





#ifndef PY_SSIZE_T_CLEAN
#define PY_SSIZE_T_CLEAN
#endif 
#if defined(CYTHON_LIMITED_API) && 0
  #ifndef Py_LIMITED_API
    #if CYTHON_LIMITED_API+0 > 0x03030000
      #define Py_LIMITED_API CYTHON_LIMITED_API
    #else
      #define Py_LIMITED_API 0x03030000
    #endif
  #endif
#endif

#include "Python.h"
#ifndef Py_PYTHON_H
    #error Python headers needed to compile C extensions, please install development version of Python.
#elif PY_VERSION_HEX < 0x02070000 || (0x03000000 <= PY_VERSION_HEX && PY_VERSION_HEX < 0x03030000)
    #error Cython requires Python 2.7+ or Python 3.3+.
#else
#if defined(CYTHON_LIMITED_API) && CYTHON_LIMITED_API
#define __PYX_EXTRA_ABI_MODULE_NAME "limited"
#else
#define __PYX_EXTRA_ABI_MODULE_NAME ""
#endif
#define CYTHON_ABI "3_0_11" __PYX_EXTRA_ABI_MODULE_NAME
#define __PYX_ABI_MODULE_NAME "_cython_" CYTHON_ABI
#define __PYX_TYPE_MODULE_PREFIX __PYX_ABI_MODULE_NAME "."
#define CYTHON_HEX_VERSION 0x03000BF0
#define CYTHON_FUTURE_DIVISION 1
#include <stddef.h>
#ifndef offsetof
  #define offsetof(type, member) ( (size_t) & ((type*)0) -> member )
#endif
#if !defined(_WIN32) && !defined(WIN32) && !defined(MS_WINDOWS)
  #ifndef __stdcall
    #define __stdcall
  #endif
  #ifndef __cdecl
    #define __cdecl
  #endif
  #ifndef __fastcall
    #define __fastcall
  #endif
#endif
#ifndef DL_IMPORT
  #define DL_IMPORT(t) t
#endif
#ifndef DL_EXPORT
  #define DL_EXPORT(t) t
#endif
#define __PYX_COMMA ,
#ifndef HAVE_LONG_LONG
  #define HAVE_LONG_LONG
#endif
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#ifndef Py_HUGE_VAL
  #define Py_HUGE_VAL HUGE_VAL
#endif
#define __PYX_LIMITED_VERSION_HEX PY_VERSION_HEX
#if defined(GRAALVM_PYTHON)
  
  #define CYTHON_COMPILING_IN_PYPY 0
  #define CYTHON_COMPILING_IN_CPYTHON 0
  #define CYTHON_COMPILING_IN_LIMITED_API 0
  #define CYTHON_COMPILING_IN_GRAAL 1
  #define CYTHON_COMPILING_IN_NOGIL 0
  #undef CYTHON_USE_TYPE_SLOTS
  #define CYTHON_USE_TYPE_SLOTS 0
  #undef CYTHON_USE_TYPE_SPECS
  #define CYTHON_USE_TYPE_SPECS 0
  #undef CYTHON_USE_PYTYPE_LOOKUP
  #define CYTHON_USE_PYTYPE_LOOKUP 0
  #if PY_VERSION_HEX < 0x03050000
    #undef CYTHON_USE_ASYNC_SLOTS
    #define CYTHON_USE_ASYNC_SLOTS 0
  #elif !defined(CYTHON_USE_ASYNC_SLOTS)
    #define CYTHON_USE_ASYNC_SLOTS 1
  #endif
  #undef CYTHON_USE_PYLIST_INTERNALS
  #define CYTHON_USE_PYLIST_INTERNALS 0
  #undef CYTHON_USE_UNICODE_INTERNALS
  #define CYTHON_USE_UNICODE_INTERNALS 0
  #undef CYTHON_USE_UNICODE_WRITER
  #define CYTHON_USE_UNICODE_WRITER 0
  #undef CYTHON_USE_PYLONG_INTERNALS
  #define CYTHON_USE_PYLONG_INTERNALS 0
  #undef CYTHON_AVOID_BORROWED_REFS
  #define CYTHON_AVOID_BORROWED_REFS 1
  #undef CYTHON_ASSUME_SAFE_MACROS
  #define CYTHON_ASSUME_SAFE_MACROS 0
  #undef CYTHON_UNPACK_METHODS
  #define CYTHON_UNPACK_METHODS 0
  #undef CYTHON_FAST_THREAD_STATE
  #define CYTHON_FAST_THREAD_STATE 0
  #undef CYTHON_FAST_GIL
  #define CYTHON_FAST_GIL 0
  #undef CYTHON_METH_FASTCALL
  #define CYTHON_METH_FASTCALL 0
  #undef CYTHON_FAST_PYCALL
  #define CYTHON_FAST_PYCALL 0
  #ifndef CYTHON_PEP487_INIT_SUBCLASS
    #define CYTHON_PEP487_INIT_SUBCLASS (PY_MAJOR_VERSION >= 3)
  #endif
  #undef CYTHON_PEP489_MULTI_PHASE_INIT
  #define CYTHON_PEP489_MULTI_PHASE_INIT 1
  #undef CYTHON_USE_MODULE_STATE
  #define CYTHON_USE_MODULE_STATE 0
  #undef CYTHON_USE_TP_FINALIZE
  #define CYTHON_USE_TP_FINALIZE 0
  #undef CYTHON_USE_DICT_VERSIONS
  #define CYTHON_USE_DICT_VERSIONS 0
  #undef CYTHON_USE_EXC_INFO_STACK
  #define CYTHON_USE_EXC_INFO_STACK 0
  #ifndef CYTHON_UPDATE_DESCRIPTOR_DOC
    #define CYTHON_UPDATE_DESCRIPTOR_DOC 0
  #endif
  #undef CYTHON_USE_FREELISTS
  #define CYTHON_USE_FREELISTS 0
#elif defined(PYPY_VERSION)
  #define CYTHON_COMPILING_IN_PYPY 1
  #define CYTHON_COMPILING_IN_CPYTHON 0
  #define CYTHON_COMPILING_IN_LIMITED_API 0
  #define CYTHON_COMPILING_IN_GRAAL 0
  #define CYTHON_COMPILING_IN_NOGIL 0
  #undef CYTHON_USE_TYPE_SLOTS
  #define CYTHON_USE_TYPE_SLOTS 0
  #ifndef CYTHON_USE_TYPE_SPECS
    #define CYTHON_USE_TYPE_SPECS 0
  #endif
  #undef CYTHON_USE_PYTYPE_LOOKUP
  #define CYTHON_USE_PYTYPE_LOOKUP 0
  #if PY_VERSION_HEX < 0x03050000
    #undef CYTHON_USE_ASYNC_SLOTS
    #define CYTHON_USE_ASYNC_SLOTS 0
  #elif !defined(CYTHON_USE_ASYNC_SLOTS)
    #define CYTHON_USE_ASYNC_SLOTS 1
  #endif
  #undef CYTHON_USE_PYLIST_INTERNALS
  #define CYTHON_USE_PYLIST_INTERNALS 0
  #undef CYTHON_USE_UNICODE_INTERNALS
  #define CYTHON_USE_UNICODE_INTERNALS 0
  #undef CYTHON_USE_UNICODE_WRITER
  #define CYTHON_USE_UNICODE_WRITER 0
  #undef CYTHON_USE_PYLONG_INTERNALS
  #define CYTHON_USE_PYLONG_INTERNALS 0
  #undef CYTHON_AVOID_BORROWED_REFS
  #define CYTHON_AVOID_BORROWED_REFS 1
  #undef CYTHON_ASSUME_SAFE_MACROS
  #define CYTHON_ASSUME_SAFE_MACROS 0
  #undef CYTHON_UNPACK_METHODS
  #define CYTHON_UNPACK_METHODS 0
  #undef CYTHON_FAST_THREAD_STATE
  #define CYTHON_FAST_THREAD_STATE 0
  #undef CYTHON_FAST_GIL
  #define CYTHON_FAST_GIL 0
  #undef CYTHON_METH_FASTCALL
  #define CYTHON_METH_FASTCALL 0
  #undef CYTHON_FAST_PYCALL
  #define CYTHON_FAST_PYCALL 0
  #ifndef CYTHON_PEP487_INIT_SUBCLASS
    #define CYTHON_PEP487_INIT_SUBCLASS (PY_MAJOR_VERSION >= 3)
  #endif
  #if PY_VERSION_HEX < 0x03090000
    #undef CYTHON_PEP489_MULTI_PHASE_INIT
    #define CYTHON_PEP489_MULTI_PHASE_INIT 0
  #elif !defined(CYTHON_PEP489_MULTI_PHASE_INIT)
    #define CYTHON_PEP489_MULTI_PHASE_INIT 1
  #endif
  #undef CYTHON_USE_MODULE_STATE
  #define CYTHON_USE_MODULE_STATE 0
  #undef CYTHON_USE_TP_FINALIZE
  #define CYTHON_USE_TP_FINALIZE (PY_VERSION_HEX >= 0x030400a1 && PYPY_VERSION_NUM >= 0x07030C00)
  #undef CYTHON_USE_DICT_VERSIONS
  #define CYTHON_USE_DICT_VERSIONS 0
  #undef CYTHON_USE_EXC_INFO_STACK
  #define CYTHON_USE_EXC_INFO_STACK 0
  #ifndef CYTHON_UPDATE_DESCRIPTOR_DOC
    #define CYTHON_UPDATE_DESCRIPTOR_DOC 0
  #endif
  #undef CYTHON_USE_FREELISTS
  #define CYTHON_USE_FREELISTS 0
#elif defined(CYTHON_LIMITED_API)
  #ifdef Py_LIMITED_API
    #undef __PYX_LIMITED_VERSION_HEX
    #define __PYX_LIMITED_VERSION_HEX Py_LIMITED_API
  #endif
  #define CYTHON_COMPILING_IN_PYPY 0
  #define CYTHON_COMPILING_IN_CPYTHON 0
  #define CYTHON_COMPILING_IN_LIMITED_API 1
  #define CYTHON_COMPILING_IN_GRAAL 0
  #define CYTHON_COMPILING_IN_NOGIL 0
  #undef CYTHON_CLINE_IN_TRACEBACK
  #define CYTHON_CLINE_IN_TRACEBACK 0
  #undef CYTHON_USE_TYPE_SLOTS
  #define CYTHON_USE_TYPE_SLOTS 0
  #undef CYTHON_USE_TYPE_SPECS
  #define CYTHON_USE_TYPE_SPECS 1
  #undef CYTHON_USE_PYTYPE_LOOKUP
  #define CYTHON_USE_PYTYPE_LOOKUP 0
  #undef CYTHON_USE_ASYNC_SLOTS
  #define CYTHON_USE_ASYNC_SLOTS 0
  #undef CYTHON_USE_PYLIST_INTERNALS
  #define CYTHON_USE_PYLIST_INTERNALS 0
  #undef CYTHON_USE_UNICODE_INTERNALS
  #define CYTHON_USE_UNICODE_INTERNALS 0
  #ifndef CYTHON_USE_UNICODE_WRITER
    #define CYTHON_USE_UNICODE_WRITER 0
  #endif
  #undef CYTHON_USE_PYLONG_INTERNALS
  #define CYTHON_USE_PYLONG_INTERNALS 0
  #ifndef CYTHON_AVOID_BORROWED_REFS
    #define CYTHON_AVOID_BORROWED_REFS 0
  #endif
  #undef CYTHON_ASSUME_SAFE_MACROS
  #define CYTHON_ASSUME_SAFE_MACROS 0
  #undef CYTHON_UNPACK_METHODS
  #define CYTHON_UNPACK_METHODS 0
  #undef CYTHON_FAST_THREAD_STATE
  #define CYTHON_FAST_THREAD_STATE 0
  #undef CYTHON_FAST_GIL
  #define CYTHON_FAST_GIL 0
  #undef CYTHON_METH_FASTCALL
  #define CYTHON_METH_FASTCALL 0
  #undef CYTHON_FAST_PYCALL
  #define CYTHON_FAST_PYCALL 0
  #ifndef CYTHON_PEP487_INIT_SUBCLASS
    #define CYTHON_PEP487_INIT_SUBCLASS 1
  #endif
  #undef CYTHON_PEP489_MULTI_PHASE_INIT
  #define CYTHON_PEP489_MULTI_PHASE_INIT 0
  #undef CYTHON_USE_MODULE_STATE
  #define CYTHON_USE_MODULE_STATE 1
  #ifndef CYTHON_USE_TP_FINALIZE
    #define CYTHON_USE_TP_FINALIZE 0
  #endif
  #undef CYTHON_USE_DICT_VERSIONS
  #define CYTHON_USE_DICT_VERSIONS 0
  #undef CYTHON_USE_EXC_INFO_STACK
  #define CYTHON_USE_EXC_INFO_STACK 0
  #ifndef CYTHON_UPDATE_DESCRIPTOR_DOC
    #define CYTHON_UPDATE_DESCRIPTOR_DOC 0
  #endif
  #undef CYTHON_USE_FREELISTS
  #define CYTHON_USE_FREELISTS 0
#elif defined(Py_GIL_DISABLED) || defined(Py_NOGIL)
  #define CYTHON_COMPILING_IN_PYPY 0
  #define CYTHON_COMPILING_IN_CPYTHON 0
  #define CYTHON_COMPILING_IN_LIMITED_API 0
  #define CYTHON_COMPILING_IN_GRAAL 0
  #define CYTHON_COMPILING_IN_NOGIL 1
  #ifndef CYTHON_USE_TYPE_SLOTS
    #define CYTHON_USE_TYPE_SLOTS 1
  #endif
  #ifndef CYTHON_USE_TYPE_SPECS
    #define CYTHON_USE_TYPE_SPECS 0
  #endif
  #undef CYTHON_USE_PYTYPE_LOOKUP
  #define CYTHON_USE_PYTYPE_LOOKUP 0
  #ifndef CYTHON_USE_ASYNC_SLOTS
    #define CYTHON_USE_ASYNC_SLOTS 1
  #endif
  #ifndef CYTHON_USE_PYLONG_INTERNALS
    #define CYTHON_USE_PYLONG_INTERNALS 0
  #endif
  #undef CYTHON_USE_PYLIST_INTERNALS
  #define CYTHON_USE_PYLIST_INTERNALS 0
  #ifndef CYTHON_USE_UNICODE_INTERNALS
    #define CYTHON_USE_UNICODE_INTERNALS 1
  #endif
  #undef CYTHON_USE_UNICODE_WRITER
  #define CYTHON_USE_UNICODE_WRITER 0
  #ifndef CYTHON_AVOID_BORROWED_REFS
    #define CYTHON_AVOID_BORROWED_REFS 0
  #endif
  #ifndef CYTHON_ASSUME_SAFE_MACROS
    #define CYTHON_ASSUME_SAFE_MACROS 1
  #endif
  #ifndef CYTHON_UNPACK_METHODS
    #define CYTHON_UNPACK_METHODS 1
  #endif
  #undef CYTHON_FAST_THREAD_STATE
  #define CYTHON_FAST_THREAD_STATE 0
  #undef CYTHON_FAST_GIL
  #define CYTHON_FAST_GIL 0
  #ifndef CYTHON_METH_FASTCALL
    #define CYTHON_METH_FASTCALL 1
  #endif
  #undef CYTHON_FAST_PYCALL
  #define CYTHON_FAST_PYCALL 0
  #ifndef CYTHON_PEP487_INIT_SUBCLASS
    #define CYTHON_PEP487_INIT_SUBCLASS 1
  #endif
  #ifndef CYTHON_PEP489_MULTI_PHASE_INIT
    #define CYTHON_PEP489_MULTI_PHASE_INIT 1
  #endif
  #ifndef CYTHON_USE_MODULE_STATE
    #define CYTHON_USE_MODULE_STATE 0
  #endif
  #ifndef CYTHON_USE_TP_FINALIZE
    #define CYTHON_USE_TP_FINALIZE 1
  #endif
  #undef CYTHON_USE_DICT_VERSIONS
  #define CYTHON_USE_DICT_VERSIONS 0
  #undef CYTHON_USE_EXC_INFO_STACK
  #define CYTHON_USE_EXC_INFO_STACK 0
  #ifndef CYTHON_UPDATE_DESCRIPTOR_DOC
    #define CYTHON_UPDATE_DESCRIPTOR_DOC 1
  #endif
  #ifndef CYTHON_USE_FREELISTS
    #define CYTHON_USE_FREELISTS 0
  #endif
#else
  #define CYTHON_COMPILING_IN_PYPY 0
  #define CYTHON_COMPILING_IN_CPYTHON 1
  #define CYTHON_COMPILING_IN_LIMITED_API 0
  #define CYTHON_COMPILING_IN_GRAAL 0
  #define CYTHON_COMPILING_IN_NOGIL 0
  #ifndef CYTHON_USE_TYPE_SLOTS
    #define CYTHON_USE_TYPE_SLOTS 1
  #endif
  #ifndef CYTHON_USE_TYPE_SPECS
    #define CYTHON_USE_TYPE_SPECS 0
  #endif
  #ifndef CYTHON_USE_PYTYPE_LOOKUP
    #define CYTHON_USE_PYTYPE_LOOKUP 1
  #endif
  #if PY_MAJOR_VERSION < 3
    #undef CYTHON_USE_ASYNC_SLOTS
    #define CYTHON_USE_ASYNC_SLOTS 0
  #elif !defined(CYTHON_USE_ASYNC_SLOTS)
    #define CYTHON_USE_ASYNC_SLOTS 1
  #endif
  #ifndef CYTHON_USE_PYLONG_INTERNALS
    #define CYTHON_USE_PYLONG_INTERNALS 1
  #endif
  #ifndef CYTHON_USE_PYLIST_INTERNALS
    #define CYTHON_USE_PYLIST_INTERNALS 1
  #endif
  #ifndef CYTHON_USE_UNICODE_INTERNALS
    #define CYTHON_USE_UNICODE_INTERNALS 1
  #endif
  #if PY_VERSION_HEX < 0x030300F0 || PY_VERSION_HEX >= 0x030B00A2
    #undef CYTHON_USE_UNICODE_WRITER
    #define CYTHON_USE_UNICODE_WRITER 0
  #elif !defined(CYTHON_USE_UNICODE_WRITER)
    #define CYTHON_USE_UNICODE_WRITER 1
  #endif
  #ifndef CYTHON_AVOID_BORROWED_REFS
    #define CYTHON_AVOID_BORROWED_REFS 0
  #endif
  #ifndef CYTHON_ASSUME_SAFE_MACROS
    #define CYTHON_ASSUME_SAFE_MACROS 1
  #endif
  #ifndef CYTHON_UNPACK_METHODS
    #define CYTHON_UNPACK_METHODS 1
  #endif
  #ifndef CYTHON_FAST_THREAD_STATE
    #define CYTHON_FAST_THREAD_STATE 1
  #endif
  #ifndef CYTHON_FAST_GIL
    #define CYTHON_FAST_GIL (PY_MAJOR_VERSION < 3 || PY_VERSION_HEX >= 0x03060000 && PY_VERSION_HEX < 0x030C00A6)
  #endif
  #ifndef CYTHON_METH_FASTCALL
    #define CYTHON_METH_FASTCALL (PY_VERSION_HEX >= 0x030700A1)
  #endif
  #ifndef CYTHON_FAST_PYCALL
    #define CYTHON_FAST_PYCALL 1
  #endif
  #ifndef CYTHON_PEP487_INIT_SUBCLASS
    #define CYTHON_PEP487_INIT_SUBCLASS 1
  #endif
  #if PY_VERSION_HEX < 0x03050000
    #undef CYTHON_PEP489_MULTI_PHASE_INIT
    #define CYTHON_PEP489_MULTI_PHASE_INIT 0
  #elif !defined(CYTHON_PEP489_MULTI_PHASE_INIT)
    #define CYTHON_PEP489_MULTI_PHASE_INIT 1
  #endif
  #ifndef CYTHON_USE_MODULE_STATE
    #define CYTHON_USE_MODULE_STATE 0
  #endif
  #if PY_VERSION_HEX < 0x030400a1
    #undef CYTHON_USE_TP_FINALIZE
    #define CYTHON_USE_TP_FINALIZE 0
  #elif !defined(CYTHON_USE_TP_FINALIZE)
    #define CYTHON_USE_TP_FINALIZE 1
  #endif
  #if PY_VERSION_HEX < 0x030600B1
    #undef CYTHON_USE_DICT_VERSIONS
    #define CYTHON_USE_DICT_VERSIONS 0
  #elif !defined(CYTHON_USE_DICT_VERSIONS)
    #define CYTHON_USE_DICT_VERSIONS  (PY_VERSION_HEX < 0x030C00A5)
  #endif
  #if PY_VERSION_HEX < 0x030700A3
    #undef CYTHON_USE_EXC_INFO_STACK
    #define CYTHON_USE_EXC_INFO_STACK 0
  #elif !defined(CYTHON_USE_EXC_INFO_STACK)
    #define CYTHON_USE_EXC_INFO_STACK 1
  #endif
  #ifndef CYTHON_UPDATE_DESCRIPTOR_DOC
    #define CYTHON_UPDATE_DESCRIPTOR_DOC 1
  #endif
  #ifndef CYTHON_USE_FREELISTS
    #define CYTHON_USE_FREELISTS 1
  #endif
#endif
#if !defined(CYTHON_FAST_PYCCALL)
#define CYTHON_FAST_PYCCALL  (CYTHON_FAST_PYCALL && PY_VERSION_HEX >= 0x030600B1)
#endif
#if !defined(CYTHON_VECTORCALL)
#define CYTHON_VECTORCALL  (CYTHON_FAST_PYCCALL && PY_VERSION_HEX >= 0x030800B1)
#endif
#define CYTHON_BACKPORT_VECTORCALL (CYTHON_METH_FASTCALL && PY_VERSION_HEX < 0x030800B1)
#if CYTHON_USE_PYLONG_INTERNALS
  #if PY_MAJOR_VERSION < 3
    #include "longintrepr.h"
  #endif
  #undef SHIFT
  #undef BASE
  #undef MASK
  #ifdef SIZEOF_VOID_P
    enum { __pyx_check_sizeof_voidp = 1 / (int)(SIZEOF_VOID_P == sizeof(void*)) };
  #endif
#endif
#ifndef __has_attribute
  #define __has_attribute(x) 0
#endif
#ifndef __has_cpp_attribute
  #define __has_cpp_attribute(x) 0
#endif
#ifndef CYTHON_RESTRICT
  #if defined(__GNUC__)
    #define CYTHON_RESTRICT __restrict__
  #elif defined(_MSC_VER) && _MSC_VER >= 1400
    #define CYTHON_RESTRICT __restrict
  #elif defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
    #define CYTHON_RESTRICT restrict
  #else
    #define CYTHON_RESTRICT
  #endif
#endif
#ifndef CYTHON_UNUSED
  #if defined(__cplusplus)
    
    #if ((defined(_MSVC_LANG) && _MSVC_LANG >= 201703L) || __cplusplus >= 201703L)
      #if __has_cpp_attribute(maybe_unused)
        #define CYTHON_UNUSED [[maybe_unused]]
      #endif
    #endif
  #endif
#endif
#ifndef CYTHON_UNUSED
# if defined(__GNUC__)
#   if !(defined(__cplusplus)) || (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4))
#     define CYTHON_UNUSED __attribute__ ((__unused__))
#   else
#     define CYTHON_UNUSED
#   endif
# elif defined(__ICC) || (defined(__INTEL_COMPILER) && !defined(_MSC_VER))
#   define CYTHON_UNUSED __attribute__ ((__unused__))
# else
#   define CYTHON_UNUSED
# endif
#endif
#ifndef CYTHON_UNUSED_VAR
#  if defined(__cplusplus)
     template<class T> void CYTHON_UNUSED_VAR( const T& ) { }
#  else
#    define CYTHON_UNUSED_VAR(x) (void)(x)
#  endif
#endif
#ifndef CYTHON_MAYBE_UNUSED_VAR
  #define CYTHON_MAYBE_UNUSED_VAR(x) CYTHON_UNUSED_VAR(x)
#endif
#ifndef CYTHON_NCP_UNUSED
# if CYTHON_COMPILING_IN_CPYTHON
#  define CYTHON_NCP_UNUSED
# else
#  define CYTHON_NCP_UNUSED CYTHON_UNUSED
# endif
#endif
#ifndef CYTHON_USE_CPP_STD_MOVE
  #if defined(__cplusplus) && (\
    __cplusplus >= 201103L || (defined(_MSC_VER) && _MSC_VER >= 1600))
    #define CYTHON_USE_CPP_STD_MOVE 1
  #else
    #define CYTHON_USE_CPP_STD_MOVE 0
  #endif
#endif
#define __Pyx_void_to_None(void_result) ((void)(void_result), Py_INCREF(Py_None), Py_None)
#ifdef _MSC_VER
    #ifndef _MSC_STDINT_H_
        #if _MSC_VER < 1300
            typedef unsigned char     uint8_t;
            typedef unsigned short    uint16_t;
            typedef unsigned int      uint32_t;
        #else
            typedef unsigned __int8   uint8_t;
            typedef unsigned __int16  uint16_t;
            typedef unsigned __int32  uint32_t;
        #endif
    #endif
    #if _MSC_VER < 1300
        #ifdef _WIN64
            typedef unsigned long long  __pyx_uintptr_t;
        #else
            typedef unsigned int        __pyx_uintptr_t;
        #endif
    #else
        #ifdef _WIN64
            typedef unsigned __int64    __pyx_uintptr_t;
        #else
            typedef unsigned __int32    __pyx_uintptr_t;
        #endif
    #endif
#else
    #include <stdint.h>
    typedef uintptr_t  __pyx_uintptr_t;
#endif
#ifndef CYTHON_FALLTHROUGH
  #if defined(__cplusplus)
    
    #if ((defined(_MSVC_LANG) && _MSVC_LANG >= 201703L) || __cplusplus >= 201703L)
      #if __has_cpp_attribute(fallthrough)
        #define CYTHON_FALLTHROUGH [[fallthrough]]
      #endif
    #endif
    #ifndef CYTHON_FALLTHROUGH
      #if __has_cpp_attribute(clang::fallthrough)
        #define CYTHON_FALLTHROUGH [[clang::fallthrough]]
      #elif __has_cpp_attribute(gnu::fallthrough)
        #define CYTHON_FALLTHROUGH [[gnu::fallthrough]]
      #endif
    #endif
  #endif
  #ifndef CYTHON_FALLTHROUGH
    #if __has_attribute(fallthrough)
      #define CYTHON_FALLTHROUGH __attribute__((fallthrough))
    #else
      #define CYTHON_FALLTHROUGH
    #endif
  #endif
  #if defined(__clang__) && defined(__apple_build_version__)
    #if __apple_build_version__ < 7000000
      #undef  CYTHON_FALLTHROUGH
      #define CYTHON_FALLTHROUGH
    #endif
  #endif
#endif
#ifdef __cplusplus
  template <typename T>
  struct __PYX_IS_UNSIGNED_IMPL {static const bool value = T(0) < T(-1);};
  #define __PYX_IS_UNSIGNED(type) (__PYX_IS_UNSIGNED_IMPL<type>::value)
#else
  #define __PYX_IS_UNSIGNED(type) (((type)-1) > 0)
#endif
#if CYTHON_COMPILING_IN_PYPY == 1
  #define __PYX_NEED_TP_PRINT_SLOT  (PY_VERSION_HEX >= 0x030800b4 && PY_VERSION_HEX < 0x030A0000)
#else
  #define __PYX_NEED_TP_PRINT_SLOT  (PY_VERSION_HEX >= 0x030800b4 && PY_VERSION_HEX < 0x03090000)
#endif
#define __PYX_REINTERPRET_FUNCION(func_pointer, other_pointer) ((func_pointer)(void(*)(void))(other_pointer))

#ifndef CYTHON_INLINE
  #if defined(__clang__)
    #define CYTHON_INLINE __inline__ __attribute__ ((__unused__))
  #elif defined(__GNUC__)
    #define CYTHON_INLINE __inline__
  #elif defined(_MSC_VER)
    #define CYTHON_INLINE __inline
  #elif defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
    #define CYTHON_INLINE inline
  #else
    #define CYTHON_INLINE
  #endif
#endif

#define __PYX_BUILD_PY_SSIZE_T "n"
#define CYTHON_FORMAT_SSIZE_T "z"
#if PY_MAJOR_VERSION < 3
  #define __Pyx_BUILTIN_MODULE_NAME "__builtin__"
  #define __Pyx_DefaultClassType PyClass_Type
  #define __Pyx_PyCode_New(a, p, k, l, s, f, code, c, n, v, fv, cell, fn, name, fline, lnos)\
          PyCode_New(a+k, l, s, f, code, c, n, v, fv, cell, fn, name, fline, lnos)
#else
  #define __Pyx_BUILTIN_MODULE_NAME "builtins"
  #define __Pyx_DefaultClassType PyType_Type
#if CYTHON_COMPILING_IN_LIMITED_API
    static CYTHON_INLINE PyObject* __Pyx_PyCode_New(int a, int p, int k, int l, int s, int f,
                                                    PyObject *code, PyObject *c, PyObject* n, PyObject *v,
                                                    PyObject *fv, PyObject *cell, PyObject* fn,
                                                    PyObject *name, int fline, PyObject *lnos) {
        PyObject *exception_table = NULL;
        PyObject *types_module=NULL, *code_type=NULL, *result=NULL;
        #if __PYX_LIMITED_VERSION_HEX < 0x030B0000
        PyObject *version_info;
        PyObject *py_minor_version = NULL;
        #endif
        long minor_version = 0;
        PyObject *type, *value, *traceback;
        PyErr_Fetch(&type, &value, &traceback);
        #if __PYX_LIMITED_VERSION_HEX >= 0x030B0000
        minor_version = 11;
        #else
        if (!(version_info = PySys_GetObject("version_info"))) goto end;
        if (!(py_minor_version = PySequence_GetItem(version_info, 1))) goto end;
        minor_version = PyLong_AsLong(py_minor_version);
        Py_DECREF(py_minor_version);
        if (minor_version == -1 && PyErr_Occurred()) goto end;
        #endif
        if (!(types_module = PyImport_ImportModule("types"))) goto end;
        if (!(code_type = PyObject_GetAttrString(types_module, "CodeType"))) goto end;
        if (minor_version <= 7) {
            (void)p;
            result = PyObject_CallFunction(code_type, "iiiiiOOOOOOiOO", a, k, l, s, f, code,
                          c, n, v, fn, name, fline, lnos, fv, cell);
        } else if (minor_version <= 10) {
            result = PyObject_CallFunction(code_type, "iiiiiiOOOOOOiOO", a,p, k, l, s, f, code,
                          c, n, v, fn, name, fline, lnos, fv, cell);
        } else {
            if (!(exception_table = PyBytes_FromStringAndSize(NULL, 0))) goto end;
            result = PyObject_CallFunction(code_type, "iiiiiiOOOOOOOiOO", a,p, k, l, s, f, code,
                          c, n, v, fn, name, name, fline, lnos, exception_table, fv, cell);
        }
    end:
        Py_XDECREF(code_type);
        Py_XDECREF(exception_table);
        Py_XDECREF(types_module);
        if (type) {
            PyErr_Restore(type, value, traceback);
        }
        return result;
    }
    #ifndef CO_OPTIMIZED
    #define CO_OPTIMIZED 0x0001
    #endif
    #ifndef CO_NEWLOCALS
    #define CO_NEWLOCALS 0x0002
    #endif
    #ifndef CO_VARARGS
    #define CO_VARARGS 0x0004
    #endif
    #ifndef CO_VARKEYWORDS
    #define CO_VARKEYWORDS 0x0008
    #endif
    #ifndef CO_ASYNC_GENERATOR
    #define CO_ASYNC_GENERATOR 0x0200
    #endif
    #ifndef CO_GENERATOR
    #define CO_GENERATOR 0x0020
    #endif
    #ifndef CO_COROUTINE
    #define CO_COROUTINE 0x0080
    #endif
#elif PY_VERSION_HEX >= 0x030B0000
  static CYTHON_INLINE PyCodeObject* __Pyx_PyCode_New(int a, int p, int k, int l, int s, int f,
                                                    PyObject *code, PyObject *c, PyObject* n, PyObject *v,
                                                    PyObject *fv, PyObject *cell, PyObject* fn,
                                                    PyObject *name, int fline, PyObject *lnos) {
    PyCodeObject *result;
    PyObject *empty_bytes = PyBytes_FromStringAndSize("", 0);
    if (!empty_bytes) return NULL;
    result =
      #if PY_VERSION_HEX >= 0x030C0000
        PyUnstable_Code_NewWithPosOnlyArgs
      #else
        PyCode_NewWithPosOnlyArgs
      #endif
        (a, p, k, l, s, f, code, c, n, v, fv, cell, fn, name, name, fline, lnos, empty_bytes);
    Py_DECREF(empty_bytes);
    return result;
  }
#elif PY_VERSION_HEX >= 0x030800B2 && !CYTHON_COMPILING_IN_PYPY
  #define __Pyx_PyCode_New(a, p, k, l, s, f, code, c, n, v, fv, cell, fn, name, fline, lnos)\
          PyCode_NewWithPosOnlyArgs(a, p, k, l, s, f, code, c, n, v, fv, cell, fn, name, fline, lnos)
#else
  #define __Pyx_PyCode_New(a, p, k, l, s, f, code, c, n, v, fv, cell, fn, name, fline, lnos)\
          PyCode_New(a, k, l, s, f, code, c, n, v, fv, cell, fn, name, fline, lnos)
#endif
#endif
#if PY_VERSION_HEX >= 0x030900A4 || defined(Py_IS_TYPE)
  #define __Pyx_IS_TYPE(ob, type) Py_IS_TYPE(ob, type)
#else
  #define __Pyx_IS_TYPE(ob, type) (((const PyObject*)ob)->ob_type == (type))
#endif
#if PY_VERSION_HEX >= 0x030A00B1 || defined(Py_Is)
  #define __Pyx_Py_Is(x, y)  Py_Is(x, y)
#else
  #define __Pyx_Py_Is(x, y) ((x) == (y))
#endif
#if PY_VERSION_HEX >= 0x030A00B1 || defined(Py_IsNone)
  #define __Pyx_Py_IsNone(ob) Py_IsNone(ob)
#else
  #define __Pyx_Py_IsNone(ob) __Pyx_Py_Is((ob), Py_None)
#endif
#if PY_VERSION_HEX >= 0x030A00B1 || defined(Py_IsTrue)
  #define __Pyx_Py_IsTrue(ob) Py_IsTrue(ob)
#else
  #define __Pyx_Py_IsTrue(ob) __Pyx_Py_Is((ob), Py_True)
#endif
#if PY_VERSION_HEX >= 0x030A00B1 || defined(Py_IsFalse)
  #define __Pyx_Py_IsFalse(ob) Py_IsFalse(ob)
#else
  #define __Pyx_Py_IsFalse(ob) __Pyx_Py_Is((ob), Py_False)
#endif
#define __Pyx_NoneAsNull(obj)  (__Pyx_Py_IsNone(obj) ? NULL : (obj))
#if PY_VERSION_HEX >= 0x030900F0 && !CYTHON_COMPILING_IN_PYPY
  #define __Pyx_PyObject_GC_IsFinalized(o) PyObject_GC_IsFinalized(o)
#else
  #define __Pyx_PyObject_GC_IsFinalized(o) _PyGC_FINALIZED(o)
#endif
#ifndef CO_COROUTINE
  #define CO_COROUTINE 0x80
#endif
#ifndef CO_ASYNC_GENERATOR
  #define CO_ASYNC_GENERATOR 0x200
#endif
#ifndef Py_TPFLAGS_CHECKTYPES
  #define Py_TPFLAGS_CHECKTYPES 0
#endif
#ifndef Py_TPFLAGS_HAVE_INDEX
  #define Py_TPFLAGS_HAVE_INDEX 0
#endif
#ifndef Py_TPFLAGS_HAVE_NEWBUFFER
  #define Py_TPFLAGS_HAVE_NEWBUFFER 0
#endif
#ifndef Py_TPFLAGS_HAVE_FINALIZE
  #define Py_TPFLAGS_HAVE_FINALIZE 0
#endif
#ifndef Py_TPFLAGS_SEQUENCE
  #define Py_TPFLAGS_SEQUENCE 0
#endif
#ifndef Py_TPFLAGS_MAPPING
  #define Py_TPFLAGS_MAPPING 0
#endif
#ifndef METH_STACKLESS
  #define METH_STACKLESS 0
#endif
#if PY_VERSION_HEX <= 0x030700A3 || !defined(METH_FASTCALL)
  #ifndef METH_FASTCALL
     #define METH_FASTCALL 0x80
  #endif
  typedef PyObject *(*__Pyx_PyCFunctionFast) (PyObject *self, PyObject *const *args, Py_ssize_t nargs);
  typedef PyObject *(*__Pyx_PyCFunctionFastWithKeywords) (PyObject *self, PyObject *const *args,
                                                          Py_ssize_t nargs, PyObject *kwnames);
#else
  #if PY_VERSION_HEX >= 0x030d00A4
  #  define __Pyx_PyCFunctionFast PyCFunctionFast
  #  define __Pyx_PyCFunctionFastWithKeywords PyCFunctionFastWithKeywords
  #else
  #  define __Pyx_PyCFunctionFast _PyCFunctionFast
  #  define __Pyx_PyCFunctionFastWithKeywords _PyCFunctionFastWithKeywords
  #endif
#endif
#if CYTHON_METH_FASTCALL
  #define __Pyx_METH_FASTCALL METH_FASTCALL
  #define __Pyx_PyCFunction_FastCall __Pyx_PyCFunctionFast
  #define __Pyx_PyCFunction_FastCallWithKeywords __Pyx_PyCFunctionFastWithKeywords
#else
  #define __Pyx_METH_FASTCALL METH_VARARGS
  #define __Pyx_PyCFunction_FastCall PyCFunction
  #define __Pyx_PyCFunction_FastCallWithKeywords PyCFunctionWithKeywords
#endif
#if CYTHON_VECTORCALL
  #define __pyx_vectorcallfunc vectorcallfunc
  #define __Pyx_PY_VECTORCALL_ARGUMENTS_OFFSET  PY_VECTORCALL_ARGUMENTS_OFFSET
  #define __Pyx_PyVectorcall_NARGS(n)  PyVectorcall_NARGS((size_t)(n))
#elif CYTHON_BACKPORT_VECTORCALL
  typedef PyObject *(*__pyx_vectorcallfunc)(PyObject *callable, PyObject *const *args,
                                            size_t nargsf, PyObject *kwnames);
  #define __Pyx_PY_VECTORCALL_ARGUMENTS_OFFSET  ((size_t)1 << (8 * sizeof(size_t) - 1))
  #define __Pyx_PyVectorcall_NARGS(n)  ((Py_ssize_t)(((size_t)(n)) & ~__Pyx_PY_VECTORCALL_ARGUMENTS_OFFSET))
#else
  #define __Pyx_PY_VECTORCALL_ARGUMENTS_OFFSET  0
  #define __Pyx_PyVectorcall_NARGS(n)  ((Py_ssize_t)(n))
#endif
#if PY_MAJOR_VERSION >= 0x030900B1
#define __Pyx_PyCFunction_CheckExact(func)  PyCFunction_CheckExact(func)
#else
#define __Pyx_PyCFunction_CheckExact(func)  PyCFunction_Check(func)
#endif
#define __Pyx_CyOrPyCFunction_Check(func)  PyCFunction_Check(func)
#if CYTHON_COMPILING_IN_CPYTHON
#define __Pyx_CyOrPyCFunction_GET_FUNCTION(func)  (((PyCFunctionObject*)(func))->m_ml->ml_meth)
#elif !CYTHON_COMPILING_IN_LIMITED_API
#define __Pyx_CyOrPyCFunction_GET_FUNCTION(func)  PyCFunction_GET_FUNCTION(func)
#endif
#if CYTHON_COMPILING_IN_CPYTHON
#define __Pyx_CyOrPyCFunction_GET_FLAGS(func)  (((PyCFunctionObject*)(func))->m_ml->ml_flags)
static CYTHON_INLINE PyObject* __Pyx_CyOrPyCFunction_GET_SELF(PyObject *func) {
    return (__Pyx_CyOrPyCFunction_GET_FLAGS(func) & METH_STATIC) ? NULL : ((PyCFunctionObject*)func)->m_self;
}
#endif
static CYTHON_INLINE int __Pyx__IsSameCFunction(PyObject *func, void *cfunc) {
#if CYTHON_COMPILING_IN_LIMITED_API
    return PyCFunction_Check(func) && PyCFunction_GetFunction(func) == (PyCFunction) cfunc;
#else
    return PyCFunction_Check(func) && PyCFunction_GET_FUNCTION(func) == (PyCFunction) cfunc;
#endif
}
#define __Pyx_IsSameCFunction(func, cfunc)   __Pyx__IsSameCFunction(func, cfunc)
#if __PYX_LIMITED_VERSION_HEX < 0x030900B1
  #define __Pyx_PyType_FromModuleAndSpec(m, s, b)  ((void)m, PyType_FromSpecWithBases(s, b))
  typedef PyObject *(*__Pyx_PyCMethod)(PyObject *, PyTypeObject *, PyObject *const *, size_t, PyObject *);
#else
  #define __Pyx_PyType_FromModuleAndSpec(m, s, b)  PyType_FromModuleAndSpec(m, s, b)
  #define __Pyx_PyCMethod  PyCMethod
#endif
#ifndef METH_METHOD
  #define METH_METHOD 0x200
#endif
#if CYTHON_COMPILING_IN_PYPY && !defined(PyObject_Malloc)
  #define PyObject_Malloc(s)   PyMem_Malloc(s)
  #define PyObject_Free(p)     PyMem_Free(p)
  #define PyObject_Realloc(p)  PyMem_Realloc(p)
#endif
#if CYTHON_COMPILING_IN_LIMITED_API
  #define __Pyx_PyCode_HasFreeVars(co)  (PyCode_GetNumFree(co) > 0)
  #define __Pyx_PyFrame_SetLineNumber(frame, lineno)
#else
  #define __Pyx_PyCode_HasFreeVars(co)  (PyCode_GetNumFree(co) > 0)
  #define __Pyx_PyFrame_SetLineNumber(frame, lineno)  (frame)->f_lineno = (lineno)
#endif
#if CYTHON_COMPILING_IN_LIMITED_API
  #define __Pyx_PyThreadState_Current PyThreadState_Get()
#elif !CYTHON_FAST_THREAD_STATE
  #define __Pyx_PyThreadState_Current PyThreadState_GET()
#elif PY_VERSION_HEX >= 0x030d00A1
  #define __Pyx_PyThreadState_Current PyThreadState_GetUnchecked()
#elif PY_VERSION_HEX >= 0x03060000
  #define __Pyx_PyThreadState_Current _PyThreadState_UncheckedGet()
#elif PY_VERSION_HEX >= 0x03000000
  #define __Pyx_PyThreadState_Current PyThreadState_GET()
#else
  #define __Pyx_PyThreadState_Current _PyThreadState_Current
#endif
#if CYTHON_COMPILING_IN_LIMITED_API
static CYTHON_INLINE void *__Pyx_PyModule_GetState(PyObject *op)
{
    void *result;
    result = PyModule_GetState(op);
    if (!result)
        Py_FatalError("Couldn't find the module state");
    return result;
}
#endif
#define __Pyx_PyObject_GetSlot(obj, name, func_ctype)  __Pyx_PyType_GetSlot(Py_TYPE(obj), name, func_ctype)
#if CYTHON_COMPILING_IN_LIMITED_API
  #define __Pyx_PyType_GetSlot(type, name, func_ctype)  ((func_ctype) PyType_GetSlot((type), Py_##name))
#else
  #define __Pyx_PyType_GetSlot(type, name, func_ctype)  ((type)->name)
#endif
#if PY_VERSION_HEX < 0x030700A2 && !defined(PyThread_tss_create) && !defined(Py_tss_NEEDS_INIT)
#include "pythread.h"
#define Py_tss_NEEDS_INIT 0
typedef int Py_tss_t;
static CYTHON_INLINE int PyThread_tss_create(Py_tss_t *key) {
  *key = PyThread_create_key();
  return 0;
}
static CYTHON_INLINE Py_tss_t * PyThread_tss_alloc(void) {
  Py_tss_t *key = (Py_tss_t *)PyObject_Malloc(sizeof(Py_tss_t));
  *key = Py_tss_NEEDS_INIT;
  return key;
}
static CYTHON_INLINE void PyThread_tss_free(Py_tss_t *key) {
  PyObject_Free(key);
}
static CYTHON_INLINE int PyThread_tss_is_created(Py_tss_t *key) {
  return *key != Py_tss_NEEDS_INIT;
}
static CYTHON_INLINE void PyThread_tss_delete(Py_tss_t *key) {
  PyThread_delete_key(*key);
  *key = Py_tss_NEEDS_INIT;
}
static CYTHON_INLINE int PyThread_tss_set(Py_tss_t *key, void *value) {
  return PyThread_set_key_value(*key, value);
}
static CYTHON_INLINE void * PyThread_tss_get(Py_tss_t *key) {
  return PyThread_get_key_value(*key);
}
#endif
#if PY_MAJOR_VERSION < 3
    #if CYTHON_COMPILING_IN_PYPY
        #if PYPY_VERSION_NUM < 0x07030600
            #if defined(__cplusplus) && __cplusplus >= 201402L
                [[deprecated("`with nogil:` inside a nogil function will not release the GIL in PyPy2 < 7.3.6")]]
            #elif defined(__GNUC__) || defined(__clang__)
                __attribute__ ((__deprecated__("`with nogil:` inside a nogil function will not release the GIL in PyPy2 < 7.3.6")))
            #elif defined(_MSC_VER)
                __declspec(deprecated("`with nogil:` inside a nogil function will not release the GIL in PyPy2 < 7.3.6"))
            #endif
            static CYTHON_INLINE int PyGILState_Check(void) {
                return 0;
            }
        #else  // PYPY_VERSION_NUM < 0x07030600
        #endif  // PYPY_VERSION_NUM < 0x07030600
    #else
        static CYTHON_INLINE int PyGILState_Check(void) {
            PyThreadState * tstate = _PyThreadState_Current;
            return tstate && (tstate == PyGILState_GetThisThreadState());
        }
    #endif
#endif
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX < 0x030d0000 || defined(_PyDict_NewPresized)
#define __Pyx_PyDict_NewPresized(n)  ((n <= 8) ? PyDict_New() : _PyDict_NewPresized(n))
#else
#define __Pyx_PyDict_NewPresized(n)  PyDict_New()
#endif
#if PY_MAJOR_VERSION >= 3 || CYTHON_FUTURE_DIVISION
  #define __Pyx_PyNumber_Divide(x,y)         PyNumber_TrueDivide(x,y)
  #define __Pyx_PyNumber_InPlaceDivide(x,y)  PyNumber_InPlaceTrueDivide(x,y)
#else
  #define __Pyx_PyNumber_Divide(x,y)         PyNumber_Divide(x,y)
  #define __Pyx_PyNumber_InPlaceDivide(x,y)  PyNumber_InPlaceDivide(x,y)
#endif
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX > 0x030600B4 && PY_VERSION_HEX < 0x030d0000 && CYTHON_USE_UNICODE_INTERNALS
#define __Pyx_PyDict_GetItemStrWithError(dict, name)  _PyDict_GetItem_KnownHash(dict, name, ((PyASCIIObject *) name)->hash)
static CYTHON_INLINE PyObject * __Pyx_PyDict_GetItemStr(PyObject *dict, PyObject *name) {
    PyObject *res = __Pyx_PyDict_GetItemStrWithError(dict, name);
    if (res == NULL) PyErr_Clear();
    return res;
}
#elif PY_MAJOR_VERSION >= 3 && (!CYTHON_COMPILING_IN_PYPY || PYPY_VERSION_NUM >= 0x07020000)
#define __Pyx_PyDict_GetItemStrWithError  PyDict_GetItemWithError
#define __Pyx_PyDict_GetItemStr           PyDict_GetItem
#else
static CYTHON_INLINE PyObject * __Pyx_PyDict_GetItemStrWithError(PyObject *dict, PyObject *name) {
#if CYTHON_COMPILING_IN_PYPY
    return PyDict_GetItem(dict, name);
#else
    PyDictEntry *ep;
    PyDictObject *mp = (PyDictObject*) dict;
    long hash = ((PyStringObject *) name)->ob_shash;
    assert(hash != -1);
    ep = (mp->ma_lookup)(mp, name, hash);
    if (ep == NULL) {
        return NULL;
    }
    return ep->me_value;
#endif
}
#define __Pyx_PyDict_GetItemStr           PyDict_GetItem
#endif
#if CYTHON_USE_TYPE_SLOTS
  #define __Pyx_PyType_GetFlags(tp)   (((PyTypeObject *)tp)->tp_flags)
  #define __Pyx_PyType_HasFeature(type, feature)  ((__Pyx_PyType_GetFlags(type) & (feature)) != 0)
  #define __Pyx_PyObject_GetIterNextFunc(obj)  (Py_TYPE(obj)->tp_iternext)
#else
  #define __Pyx_PyType_GetFlags(tp)   (PyType_GetFlags((PyTypeObject *)tp))
  #define __Pyx_PyType_HasFeature(type, feature)  PyType_HasFeature(type, feature)
  #define __Pyx_PyObject_GetIterNextFunc(obj)  PyIter_Next
#endif
#if CYTHON_COMPILING_IN_LIMITED_API
  #define __Pyx_SetItemOnTypeDict(tp, k, v) PyObject_GenericSetAttr((PyObject*)tp, k, v)
#else
  #define __Pyx_SetItemOnTypeDict(tp, k, v) PyDict_SetItem(tp->tp_dict, k, v)
#endif
#if CYTHON_USE_TYPE_SPECS && PY_VERSION_HEX >= 0x03080000
#define __Pyx_PyHeapTypeObject_GC_Del(obj)  {\
    PyTypeObject *type = Py_TYPE((PyObject*)obj);\
    assert(__Pyx_PyType_HasFeature(type, Py_TPFLAGS_HEAPTYPE));\
    PyObject_GC_Del(obj);\
    Py_DECREF(type);\
}
#else
#define __Pyx_PyHeapTypeObject_GC_Del(obj)  PyObject_GC_Del(obj)
#endif
#if CYTHON_COMPILING_IN_LIMITED_API
  #define CYTHON_PEP393_ENABLED 1
  #define __Pyx_PyUnicode_READY(op)       (0)
  #define __Pyx_PyUnicode_GET_LENGTH(u)   PyUnicode_GetLength(u)
  #define __Pyx_PyUnicode_READ_CHAR(u, i) PyUnicode_ReadChar(u, i)
  #define __Pyx_PyUnicode_MAX_CHAR_VALUE(u)   ((void)u, 1114111U)
  #define __Pyx_PyUnicode_KIND(u)         ((void)u, (0))
  #define __Pyx_PyUnicode_DATA(u)         ((void*)u)
  #define __Pyx_PyUnicode_READ(k, d, i)   ((void)k, PyUnicode_ReadChar((PyObject*)(d), i))
  #define __Pyx_PyUnicode_IS_TRUE(u)      (0 != PyUnicode_GetLength(u))
#elif PY_VERSION_HEX > 0x03030000 && defined(PyUnicode_KIND)
  #define CYTHON_PEP393_ENABLED 1
  #if PY_VERSION_HEX >= 0x030C0000
    #define __Pyx_PyUnicode_READY(op)       (0)
  #else
    #define __Pyx_PyUnicode_READY(op)       (likely(PyUnicode_IS_READY(op)) ?\
                                                0 : _PyUnicode_Ready((PyObject *)(op)))
  #endif
  #define __Pyx_PyUnicode_GET_LENGTH(u)   PyUnicode_GET_LENGTH(u)
  #define __Pyx_PyUnicode_READ_CHAR(u, i) PyUnicode_READ_CHAR(u, i)
  #define __Pyx_PyUnicode_MAX_CHAR_VALUE(u)   PyUnicode_MAX_CHAR_VALUE(u)
  #define __Pyx_PyUnicode_KIND(u)         ((int)PyUnicode_KIND(u))
  #define __Pyx_PyUnicode_DATA(u)         PyUnicode_DATA(u)
  #define __Pyx_PyUnicode_READ(k, d, i)   PyUnicode_READ(k, d, i)
  #define __Pyx_PyUnicode_WRITE(k, d, i, ch)  PyUnicode_WRITE(k, d, i, (Py_UCS4) ch)
  #if PY_VERSION_HEX >= 0x030C0000
    #define __Pyx_PyUnicode_IS_TRUE(u)      (0 != PyUnicode_GET_LENGTH(u))
  #else
    #if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX >= 0x03090000
    #define __Pyx_PyUnicode_IS_TRUE(u)      (0 != (likely(PyUnicode_IS_READY(u)) ? PyUnicode_GET_LENGTH(u) : ((PyCompactUnicodeObject *)(u))->wstr_length))
    #else
    #define __Pyx_PyUnicode_IS_TRUE(u)      (0 != (likely(PyUnicode_IS_READY(u)) ? PyUnicode_GET_LENGTH(u) : PyUnicode_GET_SIZE(u)))
    #endif
  #endif
#else
  #define CYTHON_PEP393_ENABLED 0
  #define PyUnicode_1BYTE_KIND  1
  #define PyUnicode_2BYTE_KIND  2
  #define PyUnicode_4BYTE_KIND  4
  #define __Pyx_PyUnicode_READY(op)       (0)
  #define __Pyx_PyUnicode_GET_LENGTH(u)   PyUnicode_GET_SIZE(u)
  #define __Pyx_PyUnicode_READ_CHAR(u, i) ((Py_UCS4)(PyUnicode_AS_UNICODE(u)[i]))
  #define __Pyx_PyUnicode_MAX_CHAR_VALUE(u)   ((sizeof(Py_UNICODE) == 2) ? 65535U : 1114111U)
  #define __Pyx_PyUnicode_KIND(u)         ((int)sizeof(Py_UNICODE))
  #define __Pyx_PyUnicode_DATA(u)         ((void*)PyUnicode_AS_UNICODE(u))
  #define __Pyx_PyUnicode_READ(k, d, i)   ((void)(k), (Py_UCS4)(((Py_UNICODE*)d)[i]))
  #define __Pyx_PyUnicode_WRITE(k, d, i, ch)  (((void)(k)), ((Py_UNICODE*)d)[i] = (Py_UNICODE) ch)
  #define __Pyx_PyUnicode_IS_TRUE(u)      (0 != PyUnicode_GET_SIZE(u))
#endif
#if CYTHON_COMPILING_IN_PYPY
  #define __Pyx_PyUnicode_Concat(a, b)      PyNumber_Add(a, b)
  #define __Pyx_PyUnicode_ConcatSafe(a, b)  PyNumber_Add(a, b)
#else
  #define __Pyx_PyUnicode_Concat(a, b)      PyUnicode_Concat(a, b)
  #define __Pyx_PyUnicode_ConcatSafe(a, b)  ((unlikely((a) == Py_None) || unlikely((b) == Py_None)) ?\
      PyNumber_Add(a, b) : __Pyx_PyUnicode_Concat(a, b))
#endif
#if CYTHON_COMPILING_IN_PYPY
  #if !defined(PyUnicode_DecodeUnicodeEscape)
    #define PyUnicode_DecodeUnicodeEscape(s, size, errors)  PyUnicode_Decode(s, size, "unicode_escape", errors)
  #endif
  #if !defined(PyUnicode_Contains) || (PY_MAJOR_VERSION == 2 && PYPY_VERSION_NUM < 0x07030500)
    #undef PyUnicode_Contains
    #define PyUnicode_Contains(u, s)  PySequence_Contains(u, s)
  #endif
  #if !defined(PyByteArray_Check)
    #define PyByteArray_Check(obj)  PyObject_TypeCheck(obj, &PyByteArray_Type)
  #endif
  #if !defined(PyObject_Format)
    #define PyObject_Format(obj, fmt)  PyObject_CallMethod(obj, "__format__", "O", fmt)
  #endif
#endif
#define __Pyx_PyString_FormatSafe(a, b)   ((unlikely((a) == Py_None || (PyString_Check(b) && !PyString_CheckExact(b)))) ? PyNumber_Remainder(a, b) : __Pyx_PyString_Format(a, b))
#define __Pyx_PyUnicode_FormatSafe(a, b)  ((unlikely((a) == Py_None || (PyUnicode_Check(b) && !PyUnicode_CheckExact(b)))) ? PyNumber_Remainder(a, b) : PyUnicode_Format(a, b))
#if PY_MAJOR_VERSION >= 3
  #define __Pyx_PyString_Format(a, b)  PyUnicode_Format(a, b)
#else
  #define __Pyx_PyString_Format(a, b)  PyString_Format(a, b)
#endif
#if PY_MAJOR_VERSION < 3 && !defined(PyObject_ASCII)
  #define PyObject_ASCII(o)            PyObject_Repr(o)
#endif
#if PY_MAJOR_VERSION >= 3
  #define PyBaseString_Type            PyUnicode_Type
  #define PyStringObject               PyUnicodeObject
  #define PyString_Type                PyUnicode_Type
  #define PyString_Check               PyUnicode_Check
  #define PyString_CheckExact          PyUnicode_CheckExact
#ifndef PyObject_Unicode
  #define PyObject_Unicode             PyObject_Str
#endif
#endif
#if PY_MAJOR_VERSION >= 3
  #define __Pyx_PyBaseString_Check(obj) PyUnicode_Check(obj)
  #define __Pyx_PyBaseString_CheckExact(obj) PyUnicode_CheckExact(obj)
#else
  #define __Pyx_PyBaseString_Check(obj) (PyString_Check(obj) || PyUnicode_Check(obj))
  #define __Pyx_PyBaseString_CheckExact(obj) (PyString_CheckExact(obj) || PyUnicode_CheckExact(obj))
#endif
#if CYTHON_COMPILING_IN_CPYTHON
  #define __Pyx_PySequence_ListKeepNew(obj)\
    (likely(PyList_CheckExact(obj) && Py_REFCNT(obj) == 1) ? __Pyx_NewRef(obj) : PySequence_List(obj))
#else
  #define __Pyx_PySequence_ListKeepNew(obj)  PySequence_List(obj)
#endif
#ifndef PySet_CheckExact
  #define PySet_CheckExact(obj)        __Pyx_IS_TYPE(obj, &PySet_Type)
#endif
#if PY_VERSION_HEX >= 0x030900A4
  #define __Pyx_SET_REFCNT(obj, refcnt) Py_SET_REFCNT(obj, refcnt)
  #define __Pyx_SET_SIZE(obj, size) Py_SET_SIZE(obj, size)
#else
  #define __Pyx_SET_REFCNT(obj, refcnt) Py_REFCNT(obj) = (refcnt)
  #define __Pyx_SET_SIZE(obj, size) Py_SIZE(obj) = (size)
#endif
#if CYTHON_ASSUME_SAFE_MACROS
  #define __Pyx_PySequence_ITEM(o, i) PySequence_ITEM(o, i)
  #define __Pyx_PySequence_SIZE(seq)  Py_SIZE(seq)
  #define __Pyx_PyTuple_SET_ITEM(o, i, v) (PyTuple_SET_ITEM(o, i, v), (0))
  #define __Pyx_PyList_SET_ITEM(o, i, v) (PyList_SET_ITEM(o, i, v), (0))
  #define __Pyx_PyTuple_GET_SIZE(o) PyTuple_GET_SIZE(o)
  #define __Pyx_PyList_GET_SIZE(o) PyList_GET_SIZE(o)
  #define __Pyx_PySet_GET_SIZE(o) PySet_GET_SIZE(o)
  #define __Pyx_PyBytes_GET_SIZE(o) PyBytes_GET_SIZE(o)
  #define __Pyx_PyByteArray_GET_SIZE(o) PyByteArray_GET_SIZE(o)
#else
  #define __Pyx_PySequence_ITEM(o, i) PySequence_GetItem(o, i)
  #define __Pyx_PySequence_SIZE(seq)  PySequence_Size(seq)
  #define __Pyx_PyTuple_SET_ITEM(o, i, v) PyTuple_SetItem(o, i, v)
  #define __Pyx_PyList_SET_ITEM(o, i, v) PyList_SetItem(o, i, v)
  #define __Pyx_PyTuple_GET_SIZE(o) PyTuple_Size(o)
  #define __Pyx_PyList_GET_SIZE(o) PyList_Size(o)
  #define __Pyx_PySet_GET_SIZE(o) PySet_Size(o)
  #define __Pyx_PyBytes_GET_SIZE(o) PyBytes_Size(o)
  #define __Pyx_PyByteArray_GET_SIZE(o) PyByteArray_Size(o)
#endif
#if __PYX_LIMITED_VERSION_HEX >= 0x030d00A1
  #define __Pyx_PyImport_AddModuleRef(name) PyImport_AddModuleRef(name)
#else
  static CYTHON_INLINE PyObject *__Pyx_PyImport_AddModuleRef(const char *name) {
      PyObject *module = PyImport_AddModule(name);
      Py_XINCREF(module);
      return module;
  }
#endif
#if PY_MAJOR_VERSION >= 3
  #define PyIntObject                  PyLongObject
  #define PyInt_Type                   PyLong_Type
  #define PyInt_Check(op)              PyLong_Check(op)
  #define PyInt_CheckExact(op)         PyLong_CheckExact(op)
  #define __Pyx_Py3Int_Check(op)       PyLong_Check(op)
  #define __Pyx_Py3Int_CheckExact(op)  PyLong_CheckExact(op)
  #define PyInt_FromString             PyLong_FromString
  #define PyInt_FromUnicode            PyLong_FromUnicode
  #define PyInt_FromLong               PyLong_FromLong
  #define PyInt_FromSize_t             PyLong_FromSize_t
  #define PyInt_FromSsize_t            PyLong_FromSsize_t
  #define PyInt_AsLong                 PyLong_AsLong
  #define PyInt_AS_LONG                PyLong_AS_LONG
  #define PyInt_AsSsize_t              PyLong_AsSsize_t
  #define PyInt_AsUnsignedLongMask     PyLong_AsUnsignedLongMask
  #define PyInt_AsUnsignedLongLongMask PyLong_AsUnsignedLongLongMask
  #define PyNumber_Int                 PyNumber_Long
#else
  #define __Pyx_Py3Int_Check(op)       (PyLong_Check(op) || PyInt_Check(op))
  #define __Pyx_Py3Int_CheckExact(op)  (PyLong_CheckExact(op) || PyInt_CheckExact(op))
#endif
#if PY_MAJOR_VERSION >= 3
  #define PyBoolObject                 PyLongObject
#endif
#if PY_MAJOR_VERSION >= 3 && CYTHON_COMPILING_IN_PYPY
  #ifndef PyUnicode_InternFromString
    #define PyUnicode_InternFromString(s) PyUnicode_FromString(s)
  #endif
#endif
#if PY_VERSION_HEX < 0x030200A4
  typedef long Py_hash_t;
  #define __Pyx_PyInt_FromHash_t PyInt_FromLong
  #define __Pyx_PyInt_AsHash_t   __Pyx_PyIndex_AsHash_t
#else
  #define __Pyx_PyInt_FromHash_t PyInt_FromSsize_t
  #define __Pyx_PyInt_AsHash_t   __Pyx_PyIndex_AsSsize_t
#endif
#if CYTHON_USE_ASYNC_SLOTS
  #if PY_VERSION_HEX >= 0x030500B1
    #define __Pyx_PyAsyncMethodsStruct PyAsyncMethods
    #define __Pyx_PyType_AsAsync(obj) (Py_TYPE(obj)->tp_as_async)
  #else
    #define __Pyx_PyType_AsAsync(obj) ((__Pyx_PyAsyncMethodsStruct*) (Py_TYPE(obj)->tp_reserved))
  #endif
#else
  #define __Pyx_PyType_AsAsync(obj) NULL
#endif
#ifndef __Pyx_PyAsyncMethodsStruct
    typedef struct {
        unaryfunc am_await;
        unaryfunc am_aiter;
        unaryfunc am_anext;
    } __Pyx_PyAsyncMethodsStruct;
#endif

#if defined(_WIN32) || defined(WIN32) || defined(MS_WINDOWS)
  #if !defined(_USE_MATH_DEFINES)
    #define _USE_MATH_DEFINES
  #endif
#endif
#include <math.h>
#ifdef NAN
#define __PYX_NAN() ((float) NAN)
#else
static CYTHON_INLINE float __PYX_NAN() {
  float value;
  memset(&value, 0xFF, sizeof(value));
  return value;
}
#endif
#if defined(__CYGWIN__) && defined(_LDBL_EQ_DBL)
#define __Pyx_truncl trunc
#else
#define __Pyx_truncl truncl
#endif

#define __PYX_MARK_ERR_POS(f_index, lineno) \
    { __pyx_filename = __pyx_f[f_index]; (void)__pyx_filename; __pyx_lineno = lineno; (void)__pyx_lineno; __pyx_clineno = __LINE__;  (void)__pyx_clineno; }
#define __PYX_ERR(f_index, lineno, Ln_error) \
    { __PYX_MARK_ERR_POS(f_index, lineno) goto Ln_error; }

#ifdef CYTHON_EXTERN_C
    #undef __PYX_EXTERN_C
    #define __PYX_EXTERN_C CYTHON_EXTERN_C
#elif defined(__PYX_EXTERN_C)
    #ifdef _MSC_VER
    #pragma message ("Please do not define the '__PYX_EXTERN_C' macro externally. Use 'CYTHON_EXTERN_C' instead.")
    #else
    #warning Please do not define the '__PYX_EXTERN_C' macro externally. Use 'CYTHON_EXTERN_C' instead.
    #endif
#else
  #ifdef __cplusplus
    #define __PYX_EXTERN_C extern "C"
  #else
    #define __PYX_EXTERN_C extern
  #endif
#endif

#define __PYX_HAVE__torchbox__utils__colormaps
#define __PYX_HAVE_API__torchbox__utils__colormaps

#ifdef _OPENMP
#include <omp.h>
#endif 

#if defined(PYREX_WITHOUT_ASSERTIONS) && !defined(CYTHON_WITHOUT_ASSERTIONS)
#define CYTHON_WITHOUT_ASSERTIONS
#endif

typedef struct {PyObject **p; const char *s; const Py_ssize_t n; const char* encoding;
                const char is_unicode; const char is_str; const char intern; } __Pyx_StringTabEntry;

#define __PYX_DEFAULT_STRING_ENCODING_IS_ASCII 0
#define __PYX_DEFAULT_STRING_ENCODING_IS_UTF8 0
#define __PYX_DEFAULT_STRING_ENCODING_IS_DEFAULT (PY_MAJOR_VERSION >= 3 && __PYX_DEFAULT_STRING_ENCODING_IS_UTF8)
#define __PYX_DEFAULT_STRING_ENCODING ""
#define __Pyx_PyObject_FromString __Pyx_PyBytes_FromString
#define __Pyx_PyObject_FromStringAndSize __Pyx_PyBytes_FromStringAndSize
#define __Pyx_uchar_cast(c) ((unsigned char)c)
#define __Pyx_long_cast(x) ((long)x)
#define __Pyx_fits_Py_ssize_t(v, type, is_signed)  (\
    (sizeof(type) < sizeof(Py_ssize_t))  ||\
    (sizeof(type) > sizeof(Py_ssize_t) &&\
          likely(v < (type)PY_SSIZE_T_MAX ||\
                 v == (type)PY_SSIZE_T_MAX)  &&\
          (!is_signed || likely(v > (type)PY_SSIZE_T_MIN ||\
                                v == (type)PY_SSIZE_T_MIN)))  ||\
    (sizeof(type) == sizeof(Py_ssize_t) &&\
          (is_signed || likely(v < (type)PY_SSIZE_T_MAX ||\
                               v == (type)PY_SSIZE_T_MAX)))  )
static CYTHON_INLINE int __Pyx_is_valid_index(Py_ssize_t i, Py_ssize_t limit) {
    return (size_t) i < (size_t) limit;
}
#if defined (__cplusplus) && __cplusplus >= 201103L
    #include <cstdlib>
    #define __Pyx_sst_abs(value) std::abs(value)
#elif SIZEOF_INT >= SIZEOF_SIZE_T
    #define __Pyx_sst_abs(value) abs(value)
#elif SIZEOF_LONG >= SIZEOF_SIZE_T
    #define __Pyx_sst_abs(value) labs(value)
#elif defined (_MSC_VER)
    #define __Pyx_sst_abs(value) ((Py_ssize_t)_abs64(value))
#elif defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
    #define __Pyx_sst_abs(value) llabs(value)
#elif defined (__GNUC__)
    #define __Pyx_sst_abs(value) __builtin_llabs(value)
#else
    #define __Pyx_sst_abs(value) ((value<0) ? -value : value)
#endif
static CYTHON_INLINE Py_ssize_t __Pyx_ssize_strlen(const char *s);
static CYTHON_INLINE const char* __Pyx_PyObject_AsString(PyObject*);
static CYTHON_INLINE const char* __Pyx_PyObject_AsStringAndSize(PyObject*, Py_ssize_t* length);
static CYTHON_INLINE PyObject* __Pyx_PyByteArray_FromString(const char*);
#define __Pyx_PyByteArray_FromStringAndSize(s, l) PyByteArray_FromStringAndSize((const char*)s, l)
#define __Pyx_PyBytes_FromString        PyBytes_FromString
#define __Pyx_PyBytes_FromStringAndSize PyBytes_FromStringAndSize
static CYTHON_INLINE PyObject* __Pyx_PyUnicode_FromString(const char*);
#if PY_MAJOR_VERSION < 3
    #define __Pyx_PyStr_FromString        __Pyx_PyBytes_FromString
    #define __Pyx_PyStr_FromStringAndSize __Pyx_PyBytes_FromStringAndSize
#else
    #define __Pyx_PyStr_FromString        __Pyx_PyUnicode_FromString
    #define __Pyx_PyStr_FromStringAndSize __Pyx_PyUnicode_FromStringAndSize
#endif
#define __Pyx_PyBytes_AsWritableString(s)     ((char*) PyBytes_AS_STRING(s))
#define __Pyx_PyBytes_AsWritableSString(s)    ((signed char*) PyBytes_AS_STRING(s))
#define __Pyx_PyBytes_AsWritableUString(s)    ((unsigned char*) PyBytes_AS_STRING(s))
#define __Pyx_PyBytes_AsString(s)     ((const char*) PyBytes_AS_STRING(s))
#define __Pyx_PyBytes_AsSString(s)    ((const signed char*) PyBytes_AS_STRING(s))
#define __Pyx_PyBytes_AsUString(s)    ((const unsigned char*) PyBytes_AS_STRING(s))
#define __Pyx_PyObject_AsWritableString(s)    ((char*)(__pyx_uintptr_t) __Pyx_PyObject_AsString(s))
#define __Pyx_PyObject_AsWritableSString(s)    ((signed char*)(__pyx_uintptr_t) __Pyx_PyObject_AsString(s))
#define __Pyx_PyObject_AsWritableUString(s)    ((unsigned char*)(__pyx_uintptr_t) __Pyx_PyObject_AsString(s))
#define __Pyx_PyObject_AsSString(s)    ((const signed char*) __Pyx_PyObject_AsString(s))
#define __Pyx_PyObject_AsUString(s)    ((const unsigned char*) __Pyx_PyObject_AsString(s))
#define __Pyx_PyObject_FromCString(s)  __Pyx_PyObject_FromString((const char*)s)
#define __Pyx_PyBytes_FromCString(s)   __Pyx_PyBytes_FromString((const char*)s)
#define __Pyx_PyByteArray_FromCString(s)   __Pyx_PyByteArray_FromString((const char*)s)
#define __Pyx_PyStr_FromCString(s)     __Pyx_PyStr_FromString((const char*)s)
#define __Pyx_PyUnicode_FromCString(s) __Pyx_PyUnicode_FromString((const char*)s)
#define __Pyx_PyUnicode_FromOrdinal(o)       PyUnicode_FromOrdinal((int)o)
#define __Pyx_PyUnicode_AsUnicode            PyUnicode_AsUnicode
#define __Pyx_NewRef(obj) (Py_INCREF(obj), obj)
#define __Pyx_Owned_Py_None(b) __Pyx_NewRef(Py_None)
static CYTHON_INLINE PyObject * __Pyx_PyBool_FromLong(long b);
static CYTHON_INLINE int __Pyx_PyObject_IsTrue(PyObject*);
static CYTHON_INLINE int __Pyx_PyObject_IsTrueAndDecref(PyObject*);
static CYTHON_INLINE PyObject* __Pyx_PyNumber_IntOrLong(PyObject* x);
#define __Pyx_PySequence_Tuple(obj)\
    (likely(PyTuple_CheckExact(obj)) ? __Pyx_NewRef(obj) : PySequence_Tuple(obj))
static CYTHON_INLINE Py_ssize_t __Pyx_PyIndex_AsSsize_t(PyObject*);
static CYTHON_INLINE PyObject * __Pyx_PyInt_FromSize_t(size_t);
static CYTHON_INLINE Py_hash_t __Pyx_PyIndex_AsHash_t(PyObject*);
#if CYTHON_ASSUME_SAFE_MACROS
#define __pyx_PyFloat_AsDouble(x) (PyFloat_CheckExact(x) ? PyFloat_AS_DOUBLE(x) : PyFloat_AsDouble(x))
#else
#define __pyx_PyFloat_AsDouble(x) PyFloat_AsDouble(x)
#endif
#define __pyx_PyFloat_AsFloat(x) ((float) __pyx_PyFloat_AsDouble(x))
#if PY_MAJOR_VERSION >= 3
#define __Pyx_PyNumber_Int(x) (PyLong_CheckExact(x) ? __Pyx_NewRef(x) : PyNumber_Long(x))
#else
#define __Pyx_PyNumber_Int(x) (PyInt_CheckExact(x) ? __Pyx_NewRef(x) : PyNumber_Int(x))
#endif
#if CYTHON_USE_PYLONG_INTERNALS
  #if PY_VERSION_HEX >= 0x030C00A7
  #ifndef _PyLong_SIGN_MASK
    #define _PyLong_SIGN_MASK 3
  #endif
  #ifndef _PyLong_NON_SIZE_BITS
    #define _PyLong_NON_SIZE_BITS 3
  #endif
  #define __Pyx_PyLong_Sign(x)  (((PyLongObject*)x)->long_value.lv_tag & _PyLong_SIGN_MASK)
  #define __Pyx_PyLong_IsNeg(x)  ((__Pyx_PyLong_Sign(x) & 2) != 0)
  #define __Pyx_PyLong_IsNonNeg(x)  (!__Pyx_PyLong_IsNeg(x))
  #define __Pyx_PyLong_IsZero(x)  (__Pyx_PyLong_Sign(x) & 1)
  #define __Pyx_PyLong_IsPos(x)  (__Pyx_PyLong_Sign(x) == 0)
  #define __Pyx_PyLong_CompactValueUnsigned(x)  (__Pyx_PyLong_Digits(x)[0])
  #define __Pyx_PyLong_DigitCount(x)  ((Py_ssize_t) (((PyLongObject*)x)->long_value.lv_tag >> _PyLong_NON_SIZE_BITS))
  #define __Pyx_PyLong_SignedDigitCount(x)\
        ((1 - (Py_ssize_t) __Pyx_PyLong_Sign(x)) * __Pyx_PyLong_DigitCount(x))
  #if defined(PyUnstable_Long_IsCompact) && defined(PyUnstable_Long_CompactValue)
    #define __Pyx_PyLong_IsCompact(x)     PyUnstable_Long_IsCompact((PyLongObject*) x)
    #define __Pyx_PyLong_CompactValue(x)  PyUnstable_Long_CompactValue((PyLongObject*) x)
  #else
    #define __Pyx_PyLong_IsCompact(x)     (((PyLongObject*)x)->long_value.lv_tag < (2 << _PyLong_NON_SIZE_BITS))
    #define __Pyx_PyLong_CompactValue(x)  ((1 - (Py_ssize_t) __Pyx_PyLong_Sign(x)) * (Py_ssize_t) __Pyx_PyLong_Digits(x)[0])
  #endif
  typedef Py_ssize_t  __Pyx_compact_pylong;
  typedef size_t  __Pyx_compact_upylong;
  #else
  #define __Pyx_PyLong_IsNeg(x)  (Py_SIZE(x) < 0)
  #define __Pyx_PyLong_IsNonNeg(x)  (Py_SIZE(x) >= 0)
  #define __Pyx_PyLong_IsZero(x)  (Py_SIZE(x) == 0)
  #define __Pyx_PyLong_IsPos(x)  (Py_SIZE(x) > 0)
  #define __Pyx_PyLong_CompactValueUnsigned(x)  ((Py_SIZE(x) == 0) ? 0 : __Pyx_PyLong_Digits(x)[0])
  #define __Pyx_PyLong_DigitCount(x)  __Pyx_sst_abs(Py_SIZE(x))
  #define __Pyx_PyLong_SignedDigitCount(x)  Py_SIZE(x)
  #define __Pyx_PyLong_IsCompact(x)  (Py_SIZE(x) == 0 || Py_SIZE(x) == 1 || Py_SIZE(x) == -1)
  #define __Pyx_PyLong_CompactValue(x)\
        ((Py_SIZE(x) == 0) ? (sdigit) 0 : ((Py_SIZE(x) < 0) ? -(sdigit)__Pyx_PyLong_Digits(x)[0] : (sdigit)__Pyx_PyLong_Digits(x)[0]))
  typedef sdigit  __Pyx_compact_pylong;
  typedef digit  __Pyx_compact_upylong;
  #endif
  #if PY_VERSION_HEX >= 0x030C00A5
  #define __Pyx_PyLong_Digits(x)  (((PyLongObject*)x)->long_value.ob_digit)
  #else
  #define __Pyx_PyLong_Digits(x)  (((PyLongObject*)x)->ob_digit)
  #endif
#endif
#if PY_MAJOR_VERSION < 3 && __PYX_DEFAULT_STRING_ENCODING_IS_ASCII
#include <string.h>
static int __Pyx_sys_getdefaultencoding_not_ascii;
static int __Pyx_init_sys_getdefaultencoding_params(void) {
    PyObject* sys;
    PyObject* default_encoding = NULL;
    PyObject* ascii_chars_u = NULL;
    PyObject* ascii_chars_b = NULL;
    const char* default_encoding_c;
    sys = PyImport_ImportModule("sys");
    if (!sys) goto bad;
    default_encoding = PyObject_CallMethod(sys, (char*) "getdefaultencoding", NULL);
    Py_DECREF(sys);
    if (!default_encoding) goto bad;
    default_encoding_c = PyBytes_AsString(default_encoding);
    if (!default_encoding_c) goto bad;
    if (strcmp(default_encoding_c, "ascii") == 0) {
        __Pyx_sys_getdefaultencoding_not_ascii = 0;
    } else {
        char ascii_chars[128];
        int c;
        for (c = 0; c < 128; c++) {
            ascii_chars[c] = (char) c;
        }
        __Pyx_sys_getdefaultencoding_not_ascii = 1;
        ascii_chars_u = PyUnicode_DecodeASCII(ascii_chars, 128, NULL);
        if (!ascii_chars_u) goto bad;
        ascii_chars_b = PyUnicode_AsEncodedString(ascii_chars_u, default_encoding_c, NULL);
        if (!ascii_chars_b || !PyBytes_Check(ascii_chars_b) || memcmp(ascii_chars, PyBytes_AS_STRING(ascii_chars_b), 128) != 0) {
            PyErr_Format(
                PyExc_ValueError,
                "This module compiled with c_string_encoding=ascii, but default encoding '%.200s' is not a superset of ascii.",
                default_encoding_c);
            goto bad;
        }
        Py_DECREF(ascii_chars_u);
        Py_DECREF(ascii_chars_b);
    }
    Py_DECREF(default_encoding);
    return 0;
bad:
    Py_XDECREF(default_encoding);
    Py_XDECREF(ascii_chars_u);
    Py_XDECREF(ascii_chars_b);
    return -1;
}
#endif
#if __PYX_DEFAULT_STRING_ENCODING_IS_DEFAULT && PY_MAJOR_VERSION >= 3
#define __Pyx_PyUnicode_FromStringAndSize(c_str, size) PyUnicode_DecodeUTF8(c_str, size, NULL)
#else
#define __Pyx_PyUnicode_FromStringAndSize(c_str, size) PyUnicode_Decode(c_str, size, __PYX_DEFAULT_STRING_ENCODING, NULL)
#if __PYX_DEFAULT_STRING_ENCODING_IS_DEFAULT
#include <string.h>
static char* __PYX_DEFAULT_STRING_ENCODING;
static int __Pyx_init_sys_getdefaultencoding_params(void) {
    PyObject* sys;
    PyObject* default_encoding = NULL;
    char* default_encoding_c;
    sys = PyImport_ImportModule("sys");
    if (!sys) goto bad;
    default_encoding = PyObject_CallMethod(sys, (char*) (const char*) "getdefaultencoding", NULL);
    Py_DECREF(sys);
    if (!default_encoding) goto bad;
    default_encoding_c = PyBytes_AsString(default_encoding);
    if (!default_encoding_c) goto bad;
    __PYX_DEFAULT_STRING_ENCODING = (char*) malloc(strlen(default_encoding_c) + 1);
    if (!__PYX_DEFAULT_STRING_ENCODING) goto bad;
    strcpy(__PYX_DEFAULT_STRING_ENCODING, default_encoding_c);
    Py_DECREF(default_encoding);
    return 0;
bad:
    Py_XDECREF(default_encoding);
    return -1;
}
#endif
#endif



#if defined(__GNUC__)     && (__GNUC__ > 2 || (__GNUC__ == 2 && (__GNUC_MINOR__ > 95)))
  #define likely(x)   __builtin_expect(!!(x), 1)
  #define unlikely(x) __builtin_expect(!!(x), 0)
#else 
  #define likely(x)   (x)
  #define unlikely(x) (x)
#endif 
static CYTHON_INLINE void __Pyx_pretend_to_initialize(void* ptr) { (void)ptr; }

#if !CYTHON_USE_MODULE_STATE
static PyObject *__pyx_m = NULL;
#endif
static int __pyx_lineno;
static int __pyx_clineno = 0;
static const char * __pyx_cfilenm = __FILE__;
static const char *__pyx_filename;



static const char *__pyx_f[] = {
  "torchbox/utils/colormaps.py",
};










#ifndef CYTHON_REFNANNY
  #define CYTHON_REFNANNY 0
#endif
#if CYTHON_REFNANNY
  typedef struct {
    void (*INCREF)(void*, PyObject*, Py_ssize_t);
    void (*DECREF)(void*, PyObject*, Py_ssize_t);
    void (*GOTREF)(void*, PyObject*, Py_ssize_t);
    void (*GIVEREF)(void*, PyObject*, Py_ssize_t);
    void* (*SetupContext)(const char*, Py_ssize_t, const char*);
    void (*FinishContext)(void**);
  } __Pyx_RefNannyAPIStruct;
  static __Pyx_RefNannyAPIStruct *__Pyx_RefNanny = NULL;
  static __Pyx_RefNannyAPIStruct *__Pyx_RefNannyImportAPI(const char *modname);
  #define __Pyx_RefNannyDeclarations void *__pyx_refnanny = NULL;
#ifdef WITH_THREAD
  #define __Pyx_RefNannySetupContext(name, acquire_gil)\
          if (acquire_gil) {\
              PyGILState_STATE __pyx_gilstate_save = PyGILState_Ensure();\
              __pyx_refnanny = __Pyx_RefNanny->SetupContext((name), (__LINE__), (__FILE__));\
              PyGILState_Release(__pyx_gilstate_save);\
          } else {\
              __pyx_refnanny = __Pyx_RefNanny->SetupContext((name), (__LINE__), (__FILE__));\
          }
  #define __Pyx_RefNannyFinishContextNogil() {\
              PyGILState_STATE __pyx_gilstate_save = PyGILState_Ensure();\
              __Pyx_RefNannyFinishContext();\
              PyGILState_Release(__pyx_gilstate_save);\
          }
#else
  #define __Pyx_RefNannySetupContext(name, acquire_gil)\
          __pyx_refnanny = __Pyx_RefNanny->SetupContext((name), (__LINE__), (__FILE__))
  #define __Pyx_RefNannyFinishContextNogil() __Pyx_RefNannyFinishContext()
#endif
  #define __Pyx_RefNannyFinishContextNogil() {\
              PyGILState_STATE __pyx_gilstate_save = PyGILState_Ensure();\
              __Pyx_RefNannyFinishContext();\
              PyGILState_Release(__pyx_gilstate_save);\
          }
  #define __Pyx_RefNannyFinishContext()\
          __Pyx_RefNanny->FinishContext(&__pyx_refnanny)
  #define __Pyx_INCREF(r)  __Pyx_RefNanny->INCREF(__pyx_refnanny, (PyObject *)(r), (__LINE__))
  #define __Pyx_DECREF(r)  __Pyx_RefNanny->DECREF(__pyx_refnanny, (PyObject *)(r), (__LINE__))
  #define __Pyx_GOTREF(r)  __Pyx_RefNanny->GOTREF(__pyx_refnanny, (PyObject *)(r), (__LINE__))
  #define __Pyx_GIVEREF(r) __Pyx_RefNanny->GIVEREF(__pyx_refnanny, (PyObject *)(r), (__LINE__))
  #define __Pyx_XINCREF(r)  do { if((r) == NULL); else {__Pyx_INCREF(r); }} while(0)
  #define __Pyx_XDECREF(r)  do { if((r) == NULL); else {__Pyx_DECREF(r); }} while(0)
  #define __Pyx_XGOTREF(r)  do { if((r) == NULL); else {__Pyx_GOTREF(r); }} while(0)
  #define __Pyx_XGIVEREF(r) do { if((r) == NULL); else {__Pyx_GIVEREF(r);}} while(0)
#else
  #define __Pyx_RefNannyDeclarations
  #define __Pyx_RefNannySetupContext(name, acquire_gil)
  #define __Pyx_RefNannyFinishContextNogil()
  #define __Pyx_RefNannyFinishContext()
  #define __Pyx_INCREF(r) Py_INCREF(r)
  #define __Pyx_DECREF(r) Py_DECREF(r)
  #define __Pyx_GOTREF(r)
  #define __Pyx_GIVEREF(r)
  #define __Pyx_XINCREF(r) Py_XINCREF(r)
  #define __Pyx_XDECREF(r) Py_XDECREF(r)
  #define __Pyx_XGOTREF(r)
  #define __Pyx_XGIVEREF(r)
#endif
#define __Pyx_Py_XDECREF_SET(r, v) do {\
        PyObject *tmp = (PyObject *) r;\
        r = v; Py_XDECREF(tmp);\
    } while (0)
#define __Pyx_XDECREF_SET(r, v) do {\
        PyObject *tmp = (PyObject *) r;\
        r = v; __Pyx_XDECREF(tmp);\
    } while (0)
#define __Pyx_DECREF_SET(r, v) do {\
        PyObject *tmp = (PyObject *) r;\
        r = v; __Pyx_DECREF(tmp);\
    } while (0)
#define __Pyx_CLEAR(r)    do { PyObject* tmp = ((PyObject*)(r)); r = NULL; __Pyx_DECREF(tmp);} while(0)
#define __Pyx_XCLEAR(r)   do { if((r) != NULL) {PyObject* tmp = ((PyObject*)(r)); r = NULL; __Pyx_DECREF(tmp);}} while(0)


#if CYTHON_USE_TYPE_SLOTS
static CYTHON_INLINE PyObject* __Pyx_PyObject_GetAttrStr(PyObject* obj, PyObject* attr_name);
#else
#define __Pyx_PyObject_GetAttrStr(o,n) PyObject_GetAttr(o,n)
#endif


#include <string.h>


static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list, int level);


static PyObject *__Pyx_ImportDottedModule(PyObject *name, PyObject *parts_tuple);
#if PY_MAJOR_VERSION >= 3
static PyObject *__Pyx_ImportDottedModule_WalkParts(PyObject *module, PyObject *name, PyObject *parts_tuple);
#endif


static PyObject* __Pyx_ImportFrom(PyObject* module, PyObject* name);


#if CYTHON_FAST_THREAD_STATE
#define __Pyx_PyErr_ExceptionMatches(err) __Pyx_PyErr_ExceptionMatchesInState(__pyx_tstate, err)
static CYTHON_INLINE int __Pyx_PyErr_ExceptionMatchesInState(PyThreadState* tstate, PyObject* err);
#else
#define __Pyx_PyErr_ExceptionMatches(err)  PyErr_ExceptionMatches(err)
#endif


#if CYTHON_FAST_THREAD_STATE
#define __Pyx_PyThreadState_declare  PyThreadState *__pyx_tstate;
#define __Pyx_PyThreadState_assign  __pyx_tstate = __Pyx_PyThreadState_Current;
#if PY_VERSION_HEX >= 0x030C00A6
#define __Pyx_PyErr_Occurred()  (__pyx_tstate->current_exception != NULL)
#define __Pyx_PyErr_CurrentExceptionType()  (__pyx_tstate->current_exception ? (PyObject*) Py_TYPE(__pyx_tstate->current_exception) : (PyObject*) NULL)
#else
#define __Pyx_PyErr_Occurred()  (__pyx_tstate->curexc_type != NULL)
#define __Pyx_PyErr_CurrentExceptionType()  (__pyx_tstate->curexc_type)
#endif
#else
#define __Pyx_PyThreadState_declare
#define __Pyx_PyThreadState_assign
#define __Pyx_PyErr_Occurred()  (PyErr_Occurred() != NULL)
#define __Pyx_PyErr_CurrentExceptionType()  PyErr_Occurred()
#endif


#if CYTHON_FAST_THREAD_STATE
#define __Pyx_PyErr_Clear() __Pyx_ErrRestore(NULL, NULL, NULL)
#define __Pyx_ErrRestoreWithState(type, value, tb)  __Pyx_ErrRestoreInState(PyThreadState_GET(), type, value, tb)
#define __Pyx_ErrFetchWithState(type, value, tb)    __Pyx_ErrFetchInState(PyThreadState_GET(), type, value, tb)
#define __Pyx_ErrRestore(type, value, tb)  __Pyx_ErrRestoreInState(__pyx_tstate, type, value, tb)
#define __Pyx_ErrFetch(type, value, tb)    __Pyx_ErrFetchInState(__pyx_tstate, type, value, tb)
static CYTHON_INLINE void __Pyx_ErrRestoreInState(PyThreadState *tstate, PyObject *type, PyObject *value, PyObject *tb);
static CYTHON_INLINE void __Pyx_ErrFetchInState(PyThreadState *tstate, PyObject **type, PyObject **value, PyObject **tb);
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX < 0x030C00A6
#define __Pyx_PyErr_SetNone(exc) (Py_INCREF(exc), __Pyx_ErrRestore((exc), NULL, NULL))
#else
#define __Pyx_PyErr_SetNone(exc) PyErr_SetNone(exc)
#endif
#else
#define __Pyx_PyErr_Clear() PyErr_Clear()
#define __Pyx_PyErr_SetNone(exc) PyErr_SetNone(exc)
#define __Pyx_ErrRestoreWithState(type, value, tb)  PyErr_Restore(type, value, tb)
#define __Pyx_ErrFetchWithState(type, value, tb)  PyErr_Fetch(type, value, tb)
#define __Pyx_ErrRestoreInState(tstate, type, value, tb)  PyErr_Restore(type, value, tb)
#define __Pyx_ErrFetchInState(tstate, type, value, tb)  PyErr_Fetch(type, value, tb)
#define __Pyx_ErrRestore(type, value, tb)  PyErr_Restore(type, value, tb)
#define __Pyx_ErrFetch(type, value, tb)  PyErr_Fetch(type, value, tb)
#endif


static CYTHON_INLINE PyObject* __Pyx_PyObject_GetAttrStrNoError(PyObject* obj, PyObject* attr_name);


static PyObject *__Pyx_GetBuiltinName(PyObject *name);


#if CYTHON_USE_DICT_VERSIONS && CYTHON_USE_TYPE_SLOTS
#define __PYX_DICT_VERSION_INIT  ((PY_UINT64_T) -1)
#define __PYX_GET_DICT_VERSION(dict)  (((PyDictObject*)(dict))->ma_version_tag)
#define __PYX_UPDATE_DICT_CACHE(dict, value, cache_var, version_var)\
    (version_var) = __PYX_GET_DICT_VERSION(dict);\
    (cache_var) = (value);
#define __PYX_PY_DICT_LOOKUP_IF_MODIFIED(VAR, DICT, LOOKUP) {\
    static PY_UINT64_T __pyx_dict_version = 0;\
    static PyObject *__pyx_dict_cached_value = NULL;\
    if (likely(__PYX_GET_DICT_VERSION(DICT) == __pyx_dict_version)) {\
        (VAR) = __pyx_dict_cached_value;\
    } else {\
        (VAR) = __pyx_dict_cached_value = (LOOKUP);\
        __pyx_dict_version = __PYX_GET_DICT_VERSION(DICT);\
    }\
}
static CYTHON_INLINE PY_UINT64_T __Pyx_get_tp_dict_version(PyObject *obj);
static CYTHON_INLINE PY_UINT64_T __Pyx_get_object_dict_version(PyObject *obj);
static CYTHON_INLINE int __Pyx_object_dict_version_matches(PyObject* obj, PY_UINT64_T tp_dict_version, PY_UINT64_T obj_dict_version);
#else
#define __PYX_GET_DICT_VERSION(dict)  (0)
#define __PYX_UPDATE_DICT_CACHE(dict, value, cache_var, version_var)
#define __PYX_PY_DICT_LOOKUP_IF_MODIFIED(VAR, DICT, LOOKUP)  (VAR) = (LOOKUP);
#endif


#if CYTHON_USE_DICT_VERSIONS
#define __Pyx_GetModuleGlobalName(var, name)  do {\
    static PY_UINT64_T __pyx_dict_version = 0;\
    static PyObject *__pyx_dict_cached_value = NULL;\
    (var) = (likely(__pyx_dict_version == __PYX_GET_DICT_VERSION(__pyx_d))) ?\
        (likely(__pyx_dict_cached_value) ? __Pyx_NewRef(__pyx_dict_cached_value) : __Pyx_GetBuiltinName(name)) :\
        __Pyx__GetModuleGlobalName(name, &__pyx_dict_version, &__pyx_dict_cached_value);\
} while(0)
#define __Pyx_GetModuleGlobalNameUncached(var, name)  do {\
    PY_UINT64_T __pyx_dict_version;\
    PyObject *__pyx_dict_cached_value;\
    (var) = __Pyx__GetModuleGlobalName(name, &__pyx_dict_version, &__pyx_dict_cached_value);\
} while(0)
static PyObject *__Pyx__GetModuleGlobalName(PyObject *name, PY_UINT64_T *dict_version, PyObject **dict_cached_value);
#else
#define __Pyx_GetModuleGlobalName(var, name)  (var) = __Pyx__GetModuleGlobalName(name)
#define __Pyx_GetModuleGlobalNameUncached(var, name)  (var) = __Pyx__GetModuleGlobalName(name)
static CYTHON_INLINE PyObject *__Pyx__GetModuleGlobalName(PyObject *name);
#endif


static CYTHON_INLINE void __Pyx_RaiseTooManyValuesError(Py_ssize_t expected);


static CYTHON_INLINE void __Pyx_RaiseNeedMoreValuesError(Py_ssize_t index);


static CYTHON_INLINE void __Pyx_RaiseNoneNotIterableError(void);


#if CYTHON_COMPILING_IN_CPYTHON
static CYTHON_INLINE PyObject* __Pyx_PyObject_Call(PyObject *func, PyObject *arg, PyObject *kw);
#else
#define __Pyx_PyObject_Call(func, arg, kw) PyObject_Call(func, arg, kw)
#endif


#if PY_MAJOR_VERSION >= 3 && !CYTHON_COMPILING_IN_PYPY
static PyObject *__Pyx_PyDict_GetItem(PyObject *d, PyObject* key);
#define __Pyx_PyObject_Dict_GetItem(obj, name)\
    (likely(PyDict_CheckExact(obj)) ?\
     __Pyx_PyDict_GetItem(obj, name) : PyObject_GetItem(obj, name))
#else
#define __Pyx_PyDict_GetItem(d, key) PyObject_GetItem(d, key)
#define __Pyx_PyObject_Dict_GetItem(obj, name)  PyObject_GetItem(obj, name)
#endif


#ifdef CYTHON_CLINE_IN_TRACEBACK
#define __Pyx_CLineForTraceback(tstate, c_line)  (((CYTHON_CLINE_IN_TRACEBACK)) ? c_line : 0)
#else
static int __Pyx_CLineForTraceback(PyThreadState *tstate, int c_line);
#endif


#if !CYTHON_COMPILING_IN_LIMITED_API
typedef struct {
    PyCodeObject* code_object;
    int code_line;
} __Pyx_CodeObjectCacheEntry;
struct __Pyx_CodeObjectCache {
    int count;
    int max_count;
    __Pyx_CodeObjectCacheEntry* entries;
};
static struct __Pyx_CodeObjectCache __pyx_code_cache = {0,0,NULL};
static int __pyx_bisect_code_objects(__Pyx_CodeObjectCacheEntry* entries, int count, int code_line);
static PyCodeObject *__pyx_find_code_object(int code_line);
static void __pyx_insert_code_object(int code_line, PyCodeObject* code_object);
#endif


static void __Pyx_AddTraceback(const char *funcname, int c_line,
                               int py_line, const char *filename);


#if CYTHON_COMPILING_IN_LIMITED_API
typedef PyObject *__Pyx_TypeName;
#define __Pyx_FMT_TYPENAME "%U"
static __Pyx_TypeName __Pyx_PyType_GetName(PyTypeObject* tp);
#define __Pyx_DECREF_TypeName(obj) Py_XDECREF(obj)
#else
typedef const char *__Pyx_TypeName;
#define __Pyx_FMT_TYPENAME "%.200s"
#define __Pyx_PyType_GetName(tp) ((tp)->tp_name)
#define __Pyx_DECREF_TypeName(obj)
#endif


#if !defined(__INTEL_COMPILER) && defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 6))
#define __Pyx_HAS_GCC_DIAGNOSTIC
#endif


static CYTHON_INLINE PyObject* __Pyx_PyInt_From_long(long value);


static CYTHON_INLINE long __Pyx_PyInt_As_long(PyObject *);


static CYTHON_INLINE int __Pyx_PyInt_As_int(PyObject *);


#if CYTHON_COMPILING_IN_CPYTHON
#define __Pyx_TypeCheck(obj, type) __Pyx_IsSubtype(Py_TYPE(obj), (PyTypeObject *)type)
#define __Pyx_TypeCheck2(obj, type1, type2) __Pyx_IsAnySubtype2(Py_TYPE(obj), (PyTypeObject *)type1, (PyTypeObject *)type2)
static CYTHON_INLINE int __Pyx_IsSubtype(PyTypeObject *a, PyTypeObject *b);
static CYTHON_INLINE int __Pyx_IsAnySubtype2(PyTypeObject *cls, PyTypeObject *a, PyTypeObject *b);
static CYTHON_INLINE int __Pyx_PyErr_GivenExceptionMatches(PyObject *err, PyObject *type);
static CYTHON_INLINE int __Pyx_PyErr_GivenExceptionMatches2(PyObject *err, PyObject *type1, PyObject *type2);
#else
#define __Pyx_TypeCheck(obj, type) PyObject_TypeCheck(obj, (PyTypeObject *)type)
#define __Pyx_TypeCheck2(obj, type1, type2) (PyObject_TypeCheck(obj, (PyTypeObject *)type1) || PyObject_TypeCheck(obj, (PyTypeObject *)type2))
#define __Pyx_PyErr_GivenExceptionMatches(err, type) PyErr_GivenExceptionMatches(err, type)
#define __Pyx_PyErr_GivenExceptionMatches2(err, type1, type2) (PyErr_GivenExceptionMatches(err, type1) || PyErr_GivenExceptionMatches(err, type2))
#endif
#define __Pyx_PyErr_ExceptionMatches2(err1, err2)  __Pyx_PyErr_GivenExceptionMatches2(__Pyx_PyErr_CurrentExceptionType(), err1, err2)
#define __Pyx_PyException_Check(obj) __Pyx_TypeCheck(obj, PyExc_Exception)


static unsigned long __Pyx_get_runtime_version(void);
static int __Pyx_check_binary_version(unsigned long ct_version, unsigned long rt_version, int allow_newer);


static int __Pyx_InitStrings(__Pyx_StringTabEntry *t);






#define __Pyx_MODULE_NAME "torchbox.utils.colormaps"
extern int __pyx_module_is_main_torchbox__utils__colormaps;
int __pyx_module_is_main_torchbox__utils__colormaps = 0;




static const char __pyx_k_[] = "*";
static const char __pyx_k__2[] = ".";
static const char __pyx_k__3[] = "?";
static const char __pyx_k_th[] = "th";
static const char __pyx_k_all[] = "__all__";
static const char __pyx_k_data[] = "data";
static const char __pyx_k_main[] = "__main__";
static const char __pyx_k_name[] = "__name__";
static const char __pyx_k_spec[] = "__spec__";
static const char __pyx_k_test[] = "__test__";
static const char __pyx_k_cmaps[] = "cmaps";
static const char __pyx_k_torch[] = "torch";
static const char __pyx_k_import[] = "__import__";
static const char __pyx_k_name_2[] = "name";
static const char __pyx_k_parula[] = "parula";
static const char __pyx_k_viridis[] = "viridis";
static const char __pyx_k_parula_data[] = "_parula_data";
static const char __pyx_k_initializing[] = "_initializing";
static const char __pyx_k_viridis_data[] = "_viridis_data";
static const char __pyx_k_ListedColormap[] = "ListedColormap";
static const char __pyx_k_matplotlib_colors[] = "matplotlib.colors";
static const char __pyx_k_cline_in_traceback[] = "cline_in_traceback";



typedef struct {
  PyObject *__pyx_d;
  PyObject *__pyx_b;
  PyObject *__pyx_cython_runtime;
  PyObject *__pyx_empty_tuple;
  PyObject *__pyx_empty_bytes;
  PyObject *__pyx_empty_unicode;
  #ifdef __Pyx_CyFunction_USED
  PyTypeObject *__pyx_CyFunctionType;
  #endif
  #ifdef __Pyx_FusedFunction_USED
  PyTypeObject *__pyx_FusedFunctionType;
  #endif
  #ifdef __Pyx_Generator_USED
  PyTypeObject *__pyx_GeneratorType;
  #endif
  #ifdef __Pyx_IterableCoroutine_USED
  PyTypeObject *__pyx_IterableCoroutineType;
  #endif
  #ifdef __Pyx_Coroutine_USED
  PyTypeObject *__pyx_CoroutineAwaitType;
  #endif
  #ifdef __Pyx_Coroutine_USED
  PyTypeObject *__pyx_CoroutineType;
  #endif
  #if CYTHON_USE_MODULE_STATE
  #endif
  PyObject *__pyx_n_s_;
  PyObject *__pyx_n_s_ListedColormap;
  PyObject *__pyx_kp_u__2;
  PyObject *__pyx_n_s__3;
  PyObject *__pyx_n_s_all;
  PyObject *__pyx_n_s_cline_in_traceback;
  PyObject *__pyx_n_s_cmaps;
  PyObject *__pyx_n_s_data;
  PyObject *__pyx_n_s_import;
  PyObject *__pyx_n_s_initializing;
  PyObject *__pyx_n_s_main;
  PyObject *__pyx_n_s_matplotlib_colors;
  PyObject *__pyx_n_s_name;
  PyObject *__pyx_n_s_name_2;
  PyObject *__pyx_n_s_parula;
  PyObject *__pyx_n_u_parula;
  PyObject *__pyx_n_s_parula_data;
  PyObject *__pyx_n_s_spec;
  PyObject *__pyx_n_s_test;
  PyObject *__pyx_n_s_th;
  PyObject *__pyx_n_s_torch;
  PyObject *__pyx_n_s_viridis;
  PyObject *__pyx_n_u_viridis;
  PyObject *__pyx_n_s_viridis_data;
  PyObject *__pyx_float_0_988;
  PyObject *__pyx_float_0_0265;
  PyObject *__pyx_float_0_0538;
  PyObject *__pyx_float_0_0843;
  PyObject *__pyx_float_0_1309;
  PyObject *__pyx_float_0_1663;
  PyObject *__pyx_float_0_2081;
  PyObject *__pyx_float_0_2386;
  PyObject *__pyx_float_0_3217;
  PyObject *__pyx_float_0_4188;
  PyObject *__pyx_float_0_4266;
  PyObject *__pyx_float_0_5292;
  PyObject *__pyx_float_0_6137;
  PyObject *__pyx_float_0_6473;
  PyObject *__pyx_float_0_7015;
  PyObject *__pyx_float_0_7279;
  PyObject *__pyx_float_0_7299;
  PyObject *__pyx_float_0_7384;
  PyObject *__pyx_float_0_7456;
  PyObject *__pyx_float_0_7459;
  PyObject *__pyx_float_0_8066;
  PyObject *__pyx_float_0_8135;
  PyObject *__pyx_float_0_8467;
  PyObject *__pyx_float_0_8949;
  PyObject *__pyx_float_0_9661;
  PyObject *__pyx_float_0_9697;
  PyObject *__pyx_float_0_9763;
  PyObject *__pyx_float_0_9831;
  PyObject *__pyx_float_0_004874;
  PyObject *__pyx_float_0_009605;
  PyObject *__pyx_float_0_014625;
  PyObject *__pyx_float_0_019942;
  PyObject *__pyx_float_0_025563;
  PyObject *__pyx_float_0_031497;
  PyObject *__pyx_float_0_037752;
  PyObject *__pyx_float_0_044167;
  PyObject *__pyx_float_0_050344;
  PyObject *__pyx_float_0_056324;
  PyObject *__pyx_float_0_062145;
  PyObject *__pyx_float_0_067836;
  PyObject *__pyx_float_0_073417;
  PyObject *__pyx_float_0_078907;
  PyObject *__pyx_float_0_084320;
  PyObject *__pyx_float_0_089666;
  PyObject *__pyx_float_0_094955;
  PyObject *__pyx_float_0_095250;
  PyObject *__pyx_float_0_095374;
  PyObject *__pyx_float_0_095953;
  PyObject *__pyx_float_0_096335;
  PyObject *__pyx_float_0_097452;
  PyObject *__pyx_float_0_098125;
  PyObject *__pyx_float_0_099702;
  PyObject *__pyx_float_0_100196;
  PyObject *__pyx_float_0_100717;
  PyObject *__pyx_float_0_102646;
  PyObject *__pyx_float_0_104071;
  PyObject *__pyx_float_0_105393;
  PyObject *__pyx_float_0_106217;
  PyObject *__pyx_float_0_108131;
  PyObject *__pyx_float_0_110347;
  PyObject *__pyx_float_0_110553;
  PyObject *__pyx_float_0_112838;
  PyObject *__pyx_float_0_114965;
  PyObject *__pyx_float_0_115680;
  PyObject *__pyx_float_0_118128;
  PyObject *__pyx_float_0_119423;
  PyObject *__pyx_float_0_119483;
  PyObject *__pyx_float_0_119512;
  PyObject *__pyx_float_0_119699;
  PyObject *__pyx_float_0_119738;
  PyObject *__pyx_float_0_120005;
  PyObject *__pyx_float_0_120081;
  PyObject *__pyx_float_0_120092;
  PyObject *__pyx_float_0_120565;
  PyObject *__pyx_float_0_120638;
  PyObject *__pyx_float_0_120777;
  PyObject *__pyx_float_0_121148;
  PyObject *__pyx_float_0_121380;
  PyObject *__pyx_float_0_121831;
  PyObject *__pyx_float_0_122312;
  PyObject *__pyx_float_0_122606;
  PyObject *__pyx_float_0_123444;
  PyObject *__pyx_float_0_123463;
  PyObject *__pyx_float_0_123941;
  PyObject *__pyx_float_0_124395;
  PyObject *__pyx_float_0_124780;
  PyObject *__pyx_float_0_125394;
  PyObject *__pyx_float_0_125405;
  PyObject *__pyx_float_0_125848;
  PyObject *__pyx_float_0_126326;
  PyObject *__pyx_float_0_126453;
  PyObject *__pyx_float_0_127568;
  PyObject *__pyx_float_0_128087;
  PyObject *__pyx_float_0_128729;
  PyObject *__pyx_float_0_129933;
  PyObject *__pyx_float_0_130067;
  PyObject *__pyx_float_0_130215;
  PyObject *__pyx_float_0_130895;
  PyObject *__pyx_float_0_131109;
  PyObject *__pyx_float_0_131172;
  PyObject *__pyx_float_0_132268;
  PyObject *__pyx_float_0_132444;
  PyObject *__pyx_float_0_133743;
  PyObject *__pyx_float_0_134692;
  PyObject *__pyx_float_0_135066;
  PyObject *__pyx_float_0_135920;
  PyObject *__pyx_float_0_136408;
  PyObject *__pyx_float_0_136897;
  PyObject *__pyx_float_0_137064;
  PyObject *__pyx_float_0_137339;
  PyObject *__pyx_float_0_137770;
  PyObject *__pyx_float_0_139147;
  PyObject *__pyx_float_0_140210;
  PyObject *__pyx_float_0_140536;
  PyObject *__pyx_float_0_140926;
  PyObject *__pyx_float_0_141935;
  PyObject *__pyx_float_0_143228;
  PyObject *__pyx_float_0_143303;
  PyObject *__pyx_float_0_143343;
  PyObject *__pyx_float_0_143936;
  PyObject *__pyx_float_0_144759;
  PyObject *__pyx_float_0_145912;
  PyObject *__pyx_float_0_146180;
  PyObject *__pyx_float_0_146616;
  PyObject *__pyx_float_0_147607;
  PyObject *__pyx_float_0_149039;
  PyObject *__pyx_float_0_149561;
  PyObject *__pyx_float_0_150148;
  PyObject *__pyx_float_0_150476;
  PyObject *__pyx_float_0_150881;
  PyObject *__pyx_float_0_151918;
  PyObject *__pyx_float_0_153364;
  PyObject *__pyx_float_0_153894;
  PyObject *__pyx_float_0_154815;
  PyObject *__pyx_float_0_155834;
  PyObject *__pyx_float_0_156029;
  PyObject *__pyx_float_0_156270;
  PyObject *__pyx_float_0_157729;
  PyObject *__pyx_float_0_157851;
  PyObject *__pyx_float_0_159194;
  PyObject *__pyx_float_0_160665;
  PyObject *__pyx_float_0_160771;
  PyObject *__pyx_float_0_162016;
  PyObject *__pyx_float_0_162142;
  PyObject *__pyx_float_0_162603;
  PyObject *__pyx_float_0_163625;
  PyObject *__pyx_float_0_165117;
  PyObject *__pyx_float_0_165693;
  PyObject *__pyx_float_0_166383;
  PyObject *__pyx_float_0_166617;
  PyObject *__pyx_float_0_168126;
  PyObject *__pyx_float_0_169257;
  PyObject *__pyx_float_0_169646;
  PyObject *__pyx_float_0_170599;
  PyObject *__pyx_float_0_170948;
  PyObject *__pyx_float_0_171176;
  PyObject *__pyx_float_0_172719;
  PyObject *__pyx_float_0_174274;
  PyObject *__pyx_float_0_175490;
  PyObject *__pyx_float_0_175707;
  PyObject *__pyx_float_0_175841;
  PyObject *__pyx_float_0_175971;
  PyObject *__pyx_float_0_177423;
  PyObject *__pyx_float_0_179019;
  PyObject *__pyx_float_0_180367;
  PyObject *__pyx_float_0_180629;
  PyObject *__pyx_float_0_180653;
  PyObject *__pyx_float_0_182256;
  PyObject *__pyx_float_0_182725;
  PyObject *__pyx_float_0_183898;
  PyObject *__pyx_float_0_185228;
  PyObject *__pyx_float_0_185556;
  PyObject *__pyx_float_0_185783;
  PyObject *__pyx_float_0_187231;
  PyObject *__pyx_float_0_188923;
  PyObject *__pyx_float_0_189503;
  PyObject *__pyx_float_0_190074;
  PyObject *__pyx_float_0_190631;
  PyObject *__pyx_float_0_191090;
  PyObject *__pyx_float_0_192357;
  PyObject *__pyx_float_0_194100;
  PyObject *__pyx_float_0_194905;
  PyObject *__pyx_float_0_195860;
  PyObject *__pyx_float_0_196293;
  PyObject *__pyx_float_0_196571;
  PyObject *__pyx_float_0_197636;
  PyObject *__pyx_float_0_199430;
  PyObject *__pyx_float_0_199721;
  PyObject *__pyx_float_0_201239;
  PyObject *__pyx_float_0_202219;
  PyObject *__pyx_float_0_203063;
  PyObject *__pyx_float_0_203082;
  PyObject *__pyx_float_0_204520;
  PyObject *__pyx_float_0_204903;
  PyObject *__pyx_float_0_206756;
  PyObject *__pyx_float_0_208030;
  PyObject *__pyx_float_0_208623;
  PyObject *__pyx_float_0_209303;
  PyObject *__pyx_float_0_209861;
  PyObject *__pyx_float_0_210503;
  PyObject *__pyx_float_0_212395;
  PyObject *__pyx_float_0_214000;
  PyObject *__pyx_float_0_214069;
  PyObject *__pyx_float_0_214298;
  PyObject *__pyx_float_0_216210;
  PyObject *__pyx_float_0_216620;
  PyObject *__pyx_float_0_218130;
  PyObject *__pyx_float_0_218818;
  PyObject *__pyx_float_0_220057;
  PyObject *__pyx_float_0_220124;
  PyObject *__pyx_float_0_221989;
  PyObject *__pyx_float_0_223353;
  PyObject *__pyx_float_0_223549;
  PyObject *__pyx_float_0_223925;
  PyObject *__pyx_float_0_225863;
  PyObject *__pyx_float_0_226397;
  PyObject *__pyx_float_0_227802;
  PyObject *__pyx_float_0_228262;
  PyObject *__pyx_float_0_229739;
  PyObject *__pyx_float_0_230052;
  PyObject *__pyx_float_0_231674;
  PyObject *__pyx_float_0_232815;
  PyObject *__pyx_float_0_232956;
  PyObject *__pyx_float_0_233603;
  PyObject *__pyx_float_0_235526;
  PyObject *__pyx_float_0_236712;
  PyObject *__pyx_float_0_237441;
  PyObject *__pyx_float_0_237631;
  PyObject *__pyx_float_0_239346;
  PyObject *__pyx_float_0_239374;
  PyObject *__pyx_float_0_241237;
  PyObject *__pyx_float_0_242286;
  PyObject *__pyx_float_0_243113;
  PyObject *__pyx_float_0_243329;
  PyObject *__pyx_float_0_244972;
  PyObject *__pyx_float_0_246070;
  PyObject *__pyx_float_0_246811;
  PyObject *__pyx_float_0_246922;
  PyObject *__pyx_float_0_248629;
  PyObject *__pyx_float_0_249897;
  PyObject *__pyx_float_0_250425;
  PyObject *__pyx_float_0_251537;
  PyObject *__pyx_float_0_252194;
  PyObject *__pyx_float_0_252899;
  PyObject *__pyx_float_0_253935;
  PyObject *__pyx_float_0_255645;
  PyObject *__pyx_float_0_256130;
  PyObject *__pyx_float_0_256415;
  PyObject *__pyx_float_0_257322;
  PyObject *__pyx_float_0_258965;
  PyObject *__pyx_float_0_259857;
  PyObject *__pyx_float_0_260571;
  PyObject *__pyx_float_0_260703;
  PyObject *__pyx_float_0_262138;
  PyObject *__pyx_float_0_262877;
  PyObject *__pyx_float_0_263663;
  PyObject *__pyx_float_0_265145;
  PyObject *__pyx_float_0_265254;
  PyObject *__pyx_float_0_266580;
  PyObject *__pyx_float_0_266941;
  PyObject *__pyx_float_0_267004;
  PyObject *__pyx_float_0_267968;
  PyObject *__pyx_float_0_268510;
  PyObject *__pyx_float_0_269281;
  PyObject *__pyx_float_0_269308;
  PyObject *__pyx_float_0_269783;
  PyObject *__pyx_float_0_269944;
  PyObject *__pyx_float_0_270595;
  PyObject *__pyx_float_0_271305;
  PyObject *__pyx_float_0_271828;
  PyObject *__pyx_float_0_272594;
  PyObject *__pyx_float_0_273006;
  PyObject *__pyx_float_0_273809;
  PyObject *__pyx_float_0_274128;
  PyObject *__pyx_float_0_274149;
  PyObject *__pyx_float_0_274290;
  PyObject *__pyx_float_0_274952;
  PyObject *__pyx_float_0_275191;
  PyObject *__pyx_float_0_275626;
  PyObject *__pyx_float_0_276022;
  PyObject *__pyx_float_0_276194;
  PyObject *__pyx_float_0_277018;
  PyObject *__pyx_float_0_277134;
  PyObject *__pyx_float_0_277941;
  PyObject *__pyx_float_0_278012;
  PyObject *__pyx_float_0_278775;
  PyObject *__pyx_float_0_278791;
  PyObject *__pyx_float_0_278826;
  PyObject *__pyx_float_0_279566;
  PyObject *__pyx_float_0_279574;
  PyObject *__pyx_float_0_280255;
  PyObject *__pyx_float_0_280267;
  PyObject *__pyx_float_0_280868;
  PyObject *__pyx_float_0_280894;
  PyObject *__pyx_float_0_281412;
  PyObject *__pyx_float_0_281446;
  PyObject *__pyx_float_0_281477;
  PyObject *__pyx_float_0_281887;
  PyObject *__pyx_float_0_281908;
  PyObject *__pyx_float_0_281924;
  PyObject *__pyx_float_0_282290;
  PyObject *__pyx_float_0_282327;
  PyObject *__pyx_float_0_282623;
  PyObject *__pyx_float_0_282656;
  PyObject *__pyx_float_0_282884;
  PyObject *__pyx_float_0_282910;
  PyObject *__pyx_float_0_283072;
  PyObject *__pyx_float_0_283091;
  PyObject *__pyx_float_0_283187;
  PyObject *__pyx_float_0_283197;
  PyObject *__pyx_float_0_283229;
  PyObject *__pyx_float_0_283237;
  PyObject *__pyx_float_0_287675;
  PyObject *__pyx_float_0_288127;
  PyObject *__pyx_float_0_288921;
  PyObject *__pyx_float_0_292092;
  PyObject *__pyx_float_0_294279;
  PyObject *__pyx_float_0_296479;
  PyObject *__pyx_float_0_296485;
  PyObject *__pyx_float_0_300362;
  PyObject *__pyx_float_0_300855;
  PyObject *__pyx_float_0_304148;
  PyObject *__pyx_float_0_305202;
  PyObject *__pyx_float_0_306377;
  PyObject *__pyx_float_0_309527;
  PyObject *__pyx_float_0_311925;
  PyObject *__pyx_float_0_312321;
  PyObject *__pyx_float_0_313828;
  PyObject *__pyx_float_0_318106;
  PyObject *__pyx_float_0_318195;
  PyObject *__pyx_float_0_319809;
  PyObject *__pyx_float_0_322361;
  PyObject *__pyx_float_0_323998;
  PyObject *__pyx_float_0_326594;
  PyObject *__pyx_float_0_327796;
  PyObject *__pyx_float_0_329415;
  PyObject *__pyx_float_0_329727;
  PyObject *__pyx_float_0_330805;
  PyObject *__pyx_float_0_334994;
  PyObject *__pyx_float_0_335384;
  PyObject *__pyx_float_0_335427;
  PyObject *__pyx_float_0_335885;
  PyObject *__pyx_float_0_339161;
  PyObject *__pyx_float_0_340967;
  PyObject *__pyx_float_0_341379;
  PyObject *__pyx_float_0_343307;
  PyObject *__pyx_float_0_344074;
  PyObject *__pyx_float_0_346476;
  PyObject *__pyx_float_0_347269;
  PyObject *__pyx_float_0_347432;
  PyObject *__pyx_float_0_351535;
  PyObject *__pyx_float_0_351910;
  PyObject *__pyx_float_0_352360;
  PyObject *__pyx_float_0_353093;
  PyObject *__pyx_float_0_355619;
  PyObject *__pyx_float_0_357269;
  PyObject *__pyx_float_0_358853;
  PyObject *__pyx_float_0_359683;
  PyObject *__pyx_float_0_360741;
  PyObject *__pyx_float_0_362552;
  PyObject *__pyx_float_0_363727;
  PyObject *__pyx_float_0_364543;
  PyObject *__pyx_float_0_367752;
  PyObject *__pyx_float_0_367757;
  PyObject *__pyx_float_0_369214;
  PyObject *__pyx_float_0_370164;
  PyObject *__pyx_float_0_371758;
  PyObject *__pyx_float_0_372886;
  PyObject *__pyx_float_0_375715;
  PyObject *__pyx_float_0_375746;
  PyObject *__pyx_float_0_377779;
  PyObject *__pyx_float_0_377939;
  PyObject *__pyx_float_0_379716;
  PyObject *__pyx_float_0_381191;
  PyObject *__pyx_float_0_382914;
  PyObject *__pyx_float_0_383670;
  PyObject *__pyx_float_0_386433;
  PyObject *__pyx_float_0_386592;
  PyObject *__pyx_float_0_387607;
  PyObject *__pyx_float_0_387814;
  PyObject *__pyx_float_0_391528;
  PyObject *__pyx_float_0_391917;
  PyObject *__pyx_float_0_392636;
  PyObject *__pyx_float_0_395174;
  PyObject *__pyx_float_0_395433;
  PyObject *__pyx_float_0_397163;
  PyObject *__pyx_float_0_397381;
  PyObject *__pyx_float_0_399323;
  PyObject *__pyx_float_0_402049;
  PyObject *__pyx_float_0_402329;
  PyObject *__pyx_float_0_403199;
  PyObject *__pyx_float_0_404001;
  PyObject *__pyx_float_0_406640;
  PyObject *__pyx_float_0_407061;
  PyObject *__pyx_float_0_407414;
  PyObject *__pyx_float_0_410910;
  PyObject *__pyx_float_0_411152;
  PyObject *__pyx_float_0_412415;
  PyObject *__pyx_float_0_412913;
  PyObject *__pyx_float_0_414746;
  PyObject *__pyx_float_0_415586;
  PyObject *__pyx_float_0_417331;
  PyObject *__pyx_float_0_418570;
  PyObject *__pyx_float_0_419943;
  PyObject *__pyx_float_0_421908;
  PyObject *__pyx_float_0_422160;
  PyObject *__pyx_float_0_422383;
  PyObject *__pyx_float_0_424223;
  PyObject *__pyx_float_0_426184;
  PyObject *__pyx_float_0_426902;
  PyObject *__pyx_float_0_428426;
  PyObject *__pyx_float_0_429975;
  PyObject *__pyx_float_0_430983;
  PyObject *__pyx_float_0_431554;
  PyObject *__pyx_float_0_432552;
  PyObject *__pyx_float_0_433756;
  PyObject *__pyx_float_0_436115;
  PyObject *__pyx_float_0_436601;
  PyObject *__pyx_float_0_437527;
  PyObject *__pyx_float_0_440137;
  PyObject *__pyx_float_0_440573;
  PyObject *__pyx_float_0_440584;
  PyObject *__pyx_float_0_441290;
  PyObject *__pyx_float_0_444467;
  PyObject *__pyx_float_0_444960;
  PyObject *__pyx_float_0_445044;
  PyObject *__pyx_float_0_448284;
  PyObject *__pyx_float_0_448791;
  PyObject *__pyx_float_0_449241;
  PyObject *__pyx_float_0_449368;
  PyObject *__pyx_float_0_452024;
  PyObject *__pyx_float_0_452530;
  PyObject *__pyx_float_0_453427;
  PyObject *__pyx_float_0_455688;
  PyObject *__pyx_float_0_456262;
  PyObject *__pyx_float_0_457517;
  PyObject *__pyx_float_0_458674;
  PyObject *__pyx_float_0_459277;
  PyObject *__pyx_float_0_459988;
  PyObject *__pyx_float_0_461510;
  PyObject *__pyx_float_0_462789;
  PyObject *__pyx_float_0_463708;
  PyObject *__pyx_float_0_465405;
  PyObject *__pyx_float_0_466226;
  PyObject *__pyx_float_0_467423;
  PyObject *__pyx_float_0_468053;
  PyObject *__pyx_float_0_469201;
  PyObject *__pyx_float_0_469588;
  PyObject *__pyx_float_0_471133;
  PyObject *__pyx_float_0_472873;
  PyObject *__pyx_float_0_472899;
  PyObject *__pyx_float_0_474838;
  PyObject *__pyx_float_0_476084;
  PyObject *__pyx_float_0_476498;
  PyObject *__pyx_float_0_477504;
  PyObject *__pyx_float_0_478540;
  PyObject *__pyx_float_0_479221;
  PyObject *__pyx_float_0_479997;
  PyObject *__pyx_float_0_482237;
  PyObject *__pyx_float_0_482284;
  PyObject *__pyx_float_0_483397;
  PyObject *__pyx_float_0_485273;
  PyObject *__pyx_float_0_485932;
  PyObject *__pyx_float_0_486697;
  PyObject *__pyx_float_0_487026;
  PyObject *__pyx_float_0_488189;
  PyObject *__pyx_float_0_489624;
  PyObject *__pyx_float_0_489898;
  PyObject *__pyx_float_0_491033;
  PyObject *__pyx_float_0_493001;
  PyObject *__pyx_float_0_493313;
  PyObject *__pyx_float_0_493803;
  PyObject *__pyx_float_0_496005;
  PyObject *__pyx_float_0_496502;
  PyObject *__pyx_float_0_496615;
  PyObject *__pyx_float_0_497000;
  PyObject *__pyx_float_0_498911;
  PyObject *__pyx_float_0_499129;
  PyObject *__pyx_float_0_500685;
  PyObject *__pyx_float_0_501686;
  PyObject *__pyx_float_0_501721;
  PyObject *__pyx_float_0_504172;
  PyObject *__pyx_float_0_504369;
  PyObject *__pyx_float_0_504434;
  PyObject *__pyx_float_0_506271;
  PyObject *__pyx_float_0_506589;
  PyObject *__pyx_float_0_507052;
  PyObject *__pyx_float_0_508051;
  PyObject *__pyx_float_0_508936;
  PyObject *__pyx_float_0_509577;
  PyObject *__pyx_float_0_511215;
  PyObject *__pyx_float_0_511733;
  PyObject *__pyx_float_0_512008;
  PyObject *__pyx_float_0_513427;
  PyObject *__pyx_float_0_514349;
  PyObject *__pyx_float_0_515413;
  PyObject *__pyx_float_0_515571;
  PyObject *__pyx_float_0_515992;
  PyObject *__pyx_float_0_516599;
  PyObject *__pyx_float_0_517649;
  PyObject *__pyx_float_0_518762;
  PyObject *__pyx_float_0_519093;
  PyObject *__pyx_float_0_519661;
  PyObject *__pyx_float_0_520837;
  PyObject *__pyx_float_0_521608;
  PyObject *__pyx_float_0_522773;
  PyObject *__pyx_float_0_522828;
  PyObject *__pyx_float_0_523491;
  PyObject *__pyx_float_0_524736;
  PyObject *__pyx_float_0_525311;
  PyObject *__pyx_float_0_525776;
  PyObject *__pyx_float_0_526453;
  PyObject *__pyx_float_0_526563;
  PyObject *__pyx_float_0_527068;
  PyObject *__pyx_float_0_528312;
  PyObject *__pyx_float_0_528763;
  PyObject *__pyx_float_0_529983;
  PyObject *__pyx_float_0_530132;
  PyObject *__pyx_float_0_530398;
  PyObject *__pyx_float_0_531579;
  PyObject *__pyx_float_0_531973;
  PyObject *__pyx_float_0_533103;
  PyObject *__pyx_float_0_533488;
  PyObject *__pyx_float_0_533812;
  PyObject *__pyx_float_0_534556;
  PyObject *__pyx_float_0_534946;
  PyObject *__pyx_float_0_535621;
  PyObject *__pyx_float_0_535941;
  PyObject *__pyx_float_0_536347;
  PyObject *__pyx_float_0_537260;
  PyObject *__pyx_float_0_537492;
  PyObject *__pyx_float_0_537692;
  PyObject *__pyx_float_0_538516;
  PyObject *__pyx_float_0_538982;
  PyObject *__pyx_float_0_539709;
  PyObject *__pyx_float_0_540218;
  PyObject *__pyx_float_0_540844;
  PyObject *__pyx_float_0_541173;
  PyObject *__pyx_float_0_541400;
  PyObject *__pyx_float_0_541921;
  PyObject *__pyx_float_0_542530;
  PyObject *__pyx_float_0_542944;
  PyObject *__pyx_float_0_543611;
  PyObject *__pyx_float_0_543914;
  PyObject *__pyx_float_0_544641;
  PyObject *__pyx_float_0_544834;
  PyObject *__pyx_float_0_544853;
  PyObject *__pyx_float_0_545524;
  PyObject *__pyx_float_0_545623;
  PyObject *__pyx_float_0_545706;
  PyObject *__pyx_float_0_546532;
  PyObject *__pyx_float_0_546557;
  PyObject *__pyx_float_0_547314;
  PyObject *__pyx_float_0_547445;
  PyObject *__pyx_float_0_548053;
  PyObject *__pyx_float_0_548287;
  PyObject *__pyx_float_0_548535;
  PyObject *__pyx_float_0_548752;
  PyObject *__pyx_float_0_549086;
  PyObject *__pyx_float_0_549413;
  PyObject *__pyx_float_0_549841;
  PyObject *__pyx_float_0_550038;
  PyObject *__pyx_float_0_550556;
  PyObject *__pyx_float_0_550627;
  PyObject *__pyx_float_0_551184;
  PyObject *__pyx_float_0_551229;
  PyObject *__pyx_float_0_551710;
  PyObject *__pyx_float_0_551864;
  PyObject *__pyx_float_0_552206;
  PyObject *__pyx_float_0_552216;
  PyObject *__pyx_float_0_552459;
  PyObject *__pyx_float_0_552675;
  PyObject *__pyx_float_0_553018;
  PyObject *__pyx_float_0_553117;
  PyObject *__pyx_float_0_553533;
  PyObject *__pyx_float_0_553541;
  PyObject *__pyx_float_0_553925;
  PyObject *__pyx_float_0_554029;
  PyObject *__pyx_float_0_554294;
  PyObject *__pyx_float_0_554483;
  PyObject *__pyx_float_0_554642;
  PyObject *__pyx_float_0_554906;
  PyObject *__pyx_float_0_554969;
  PyObject *__pyx_float_0_555276;
  PyObject *__pyx_float_0_555298;
  PyObject *__pyx_float_0_555484;
  PyObject *__pyx_float_0_555565;
  PyObject *__pyx_float_0_555659;
  PyObject *__pyx_float_0_555836;
  PyObject *__pyx_float_0_555899;
  PyObject *__pyx_float_0_555991;
  PyObject *__pyx_float_0_556089;
  PyObject *__pyx_float_0_556295;
  PyObject *__pyx_float_0_556326;
  PyObject *__pyx_float_0_556547;
  PyObject *__pyx_float_0_556572;
  PyObject *__pyx_float_0_556753;
  PyObject *__pyx_float_0_556823;
  PyObject *__pyx_float_0_556944;
  PyObject *__pyx_float_0_557049;
  PyObject *__pyx_float_0_557120;
  PyObject *__pyx_float_0_557250;
  PyObject *__pyx_float_0_557282;
  PyObject *__pyx_float_0_557430;
  PyObject *__pyx_float_0_557565;
  PyObject *__pyx_float_0_557587;
  PyObject *__pyx_float_0_557685;
  PyObject *__pyx_float_0_557724;
  PyObject *__pyx_float_0_557792;
  PyObject *__pyx_float_0_557840;
  PyObject *__pyx_float_0_557885;
  PyObject *__pyx_float_0_557936;
  PyObject *__pyx_float_0_557965;
  PyObject *__pyx_float_0_558013;
  PyObject *__pyx_float_0_558030;
  PyObject *__pyx_float_0_558073;
  PyObject *__pyx_float_0_558082;
  PyObject *__pyx_float_0_558115;
  PyObject *__pyx_float_0_558119;
  PyObject *__pyx_float_0_558140;
  PyObject *__pyx_float_0_558141;
  PyObject *__pyx_float_0_558148;
  PyObject *__pyx_float_0_559582;
  PyObject *__pyx_float_0_563265;
  PyObject *__pyx_float_0_565498;
  PyObject *__pyx_float_0_566949;
  PyObject *__pyx_float_0_570633;
  PyObject *__pyx_float_0_574318;
  PyObject *__pyx_float_0_575563;
  PyObject *__pyx_float_0_578002;
  PyObject *__pyx_float_0_581687;
  PyObject *__pyx_float_0_585371;
  PyObject *__pyx_float_0_585678;
  PyObject *__pyx_float_0_589055;
  PyObject *__pyx_float_0_592739;
  PyObject *__pyx_float_0_595839;
  PyObject *__pyx_float_0_596422;
  PyObject *__pyx_float_0_600104;
  PyObject *__pyx_float_0_603785;
  PyObject *__pyx_float_0_606045;
  PyObject *__pyx_float_0_607464;
  PyObject *__pyx_float_0_611141;
  PyObject *__pyx_float_0_614817;
  PyObject *__pyx_float_0_616293;
  PyObject *__pyx_float_0_618490;
  PyObject *__pyx_float_0_622161;
  PyObject *__pyx_float_0_625828;
  PyObject *__pyx_float_0_626579;
  PyObject *__pyx_float_0_629492;
  PyObject *__pyx_float_0_633153;
  PyObject *__pyx_float_0_636809;
  PyObject *__pyx_float_0_636902;
  PyObject *__pyx_float_0_640461;
  PyObject *__pyx_float_0_644107;
  PyObject *__pyx_float_0_647257;
  PyObject *__pyx_float_0_647749;
  PyObject *__pyx_float_0_651384;
  PyObject *__pyx_float_0_655014;
  PyObject *__pyx_float_0_657642;
  PyObject *__pyx_float_0_658636;
  PyObject *__pyx_float_0_662252;
  PyObject *__pyx_float_0_665859;
  PyObject *__pyx_float_0_668054;
  PyObject *__pyx_float_0_669459;
  PyObject *__pyx_float_0_673050;
  PyObject *__pyx_float_0_676631;
  PyObject *__pyx_float_0_678489;
  PyObject *__pyx_float_0_680203;
  PyObject *__pyx_float_0_683765;
  PyObject *__pyx_float_0_687316;
  PyObject *__pyx_float_0_688944;
  PyObject *__pyx_float_0_690856;
  PyObject *__pyx_float_0_694384;
  PyObject *__pyx_float_0_697900;
  PyObject *__pyx_float_0_699415;
  PyObject *__pyx_float_0_701402;
  PyObject *__pyx_float_0_704891;
  PyObject *__pyx_float_0_708366;
  PyObject *__pyx_float_0_709898;
  PyObject *__pyx_float_0_711827;
  PyObject *__pyx_float_0_715272;
  PyObject *__pyx_float_0_718701;
  PyObject *__pyx_float_0_720391;
  PyObject *__pyx_float_0_722114;
  PyObject *__pyx_float_0_725509;
  PyObject *__pyx_float_0_728888;
  PyObject *__pyx_float_0_730889;
  PyObject *__pyx_float_0_732247;
  PyObject *__pyx_float_0_735588;
  PyObject *__pyx_float_0_738910;
  PyObject *__pyx_float_0_741388;
  PyObject *__pyx_float_0_742211;
  PyObject *__pyx_float_0_745492;
  PyObject *__pyx_float_0_748751;
  PyObject *__pyx_float_0_751884;
  PyObject *__pyx_float_0_751988;
  PyObject *__pyx_float_0_755203;
  PyObject *__pyx_float_0_758394;
  PyObject *__pyx_float_0_761561;
  PyObject *__pyx_float_0_762373;
  PyObject *__pyx_float_0_764704;
  PyObject *__pyx_float_0_767822;
  PyObject *__pyx_float_0_770914;
  PyObject *__pyx_float_0_772852;
  PyObject *__pyx_float_0_773980;
  PyObject *__pyx_float_0_777018;
  PyObject *__pyx_float_0_780029;
  PyObject *__pyx_float_0_783011;
  PyObject *__pyx_float_0_783315;
  PyObject *__pyx_float_0_785964;
  PyObject *__pyx_float_0_788888;
  PyObject *__pyx_float_0_791781;
  PyObject *__pyx_float_0_793760;
  PyObject *__pyx_float_0_794644;
  PyObject *__pyx_float_0_797475;
  PyObject *__pyx_float_0_800275;
  PyObject *__pyx_float_0_803041;
  PyObject *__pyx_float_0_804182;
  PyObject *__pyx_float_0_805774;
  PyObject *__pyx_float_0_808473;
  PyObject *__pyx_float_0_811138;
  PyObject *__pyx_float_0_813768;
  PyObject *__pyx_float_0_814576;
  PyObject *__pyx_float_0_816363;
  PyObject *__pyx_float_0_818921;
  PyObject *__pyx_float_0_821444;
  PyObject *__pyx_float_0_823929;
  PyObject *__pyx_float_0_824940;
  PyObject *__pyx_float_0_826376;
  PyObject *__pyx_float_0_828786;
  PyObject *__pyx_float_0_831158;
  PyObject *__pyx_float_0_833491;
  PyObject *__pyx_float_0_835270;
  PyObject *__pyx_float_0_835785;
  PyObject *__pyx_float_0_838039;
  PyObject *__pyx_float_0_840254;
  PyObject *__pyx_float_0_842430;
  PyObject *__pyx_float_0_844566;
  PyObject *__pyx_float_0_845561;
  PyObject *__pyx_float_0_846661;
  PyObject *__pyx_float_0_848717;
  PyObject *__pyx_float_0_850733;
  PyObject *__pyx_float_0_852709;
  PyObject *__pyx_float_0_854645;
  PyObject *__pyx_float_0_855810;
  PyObject *__pyx_float_0_856542;
  PyObject *__pyx_float_0_858400;
  PyObject *__pyx_float_0_860219;
  PyObject *__pyx_float_0_861999;
  PyObject *__pyx_float_0_863742;
  PyObject *__pyx_float_0_865448;
  PyObject *__pyx_float_0_866013;
  PyObject *__pyx_float_0_867117;
  PyObject *__pyx_float_0_868751;
  PyObject *__pyx_float_0_870350;
  PyObject *__pyx_float_0_871916;
  PyObject *__pyx_float_0_873449;
  PyObject *__pyx_float_0_874951;
  PyObject *__pyx_float_0_876168;
  PyObject *__pyx_float_0_876424;
  PyObject *__pyx_float_0_877868;
  PyObject *__pyx_float_0_879285;
  PyObject *__pyx_float_0_880678;
  PyObject *__pyx_float_0_882046;
  PyObject *__pyx_float_0_883393;
  PyObject *__pyx_float_0_884720;
  PyObject *__pyx_float_0_886029;
  PyObject *__pyx_float_0_886271;
  PyObject *__pyx_float_0_887322;
  PyObject *__pyx_float_0_888601;
  PyObject *__pyx_float_0_889868;
  PyObject *__pyx_float_0_891125;
  PyObject *__pyx_float_0_892374;
  PyObject *__pyx_float_0_893616;
  PyObject *__pyx_float_0_894855;
  PyObject *__pyx_float_0_896091;
  PyObject *__pyx_float_0_896320;
  PyObject *__pyx_float_0_897330;
  PyObject *__pyx_float_0_898570;
  PyObject *__pyx_float_0_899815;
  PyObject *__pyx_float_0_901065;
  PyObject *__pyx_float_0_902323;
  PyObject *__pyx_float_0_903590;
  PyObject *__pyx_float_0_904867;
  PyObject *__pyx_float_0_906157;
  PyObject *__pyx_float_0_906311;
  PyObject *__pyx_float_0_916242;
  PyObject *__pyx_float_0_926106;
  PyObject *__pyx_float_0_935904;
  PyObject *__pyx_float_0_945636;
  PyObject *__pyx_float_0_955300;
  PyObject *__pyx_float_0_964894;
  PyObject *__pyx_float_0_974417;
  PyObject *__pyx_float_0_983868;
  PyObject *__pyx_float_0_993248;
  PyObject *__pyx_float_0_032852381;
  PyObject *__pyx_float_0_079347619;
  PyObject *__pyx_float_0_147452381;
  PyObject *__pyx_float_0_196652381;
  PyObject *__pyx_float_0_212252381;
  PyObject *__pyx_float_0_240347619;
  PyObject *__pyx_float_0_266647619;
  PyObject *__pyx_float_0_609852381;
  PyObject *__pyx_float_0_743552381;
  PyObject *__pyx_float_0_779247619;
  PyObject *__pyx_float_0_819852381;
  PyObject *__pyx_float_0_0059571429;
  PyObject *__pyx_float_0_0116952381;
  PyObject *__pyx_float_0_0165142857;
  PyObject *__pyx_float_0_0227714286;
  PyObject *__pyx_float_0_0230904762;
  PyObject *__pyx_float_0_0238904762;
  PyObject *__pyx_float_0_0266619048;
  PyObject *__pyx_float_0_0343428571;
  PyObject *__pyx_float_0_0383714286;
  PyObject *__pyx_float_0_0487714286;
  PyObject *__pyx_float_0_0498142857;
  PyObject *__pyx_float_0_0589714286;
  PyObject *__pyx_float_0_0591333333;
  PyObject *__pyx_float_0_0629333333;
  PyObject *__pyx_float_0_0640571429;
  PyObject *__pyx_float_0_0722666667;
  PyObject *__pyx_float_0_0749428571;
  PyObject *__pyx_float_0_0755333333;
  PyObject *__pyx_float_0_0779428571;
  PyObject *__pyx_float_0_0948380952;
  PyObject *__pyx_float_0_1132428571;
  PyObject *__pyx_float_0_1132952381;
  PyObject *__pyx_float_0_1252714286;
  PyObject *__pyx_float_0_1452714286;
  PyObject *__pyx_float_0_1633142857;
  PyObject *__pyx_float_0_1707285714;
  PyObject *__pyx_float_0_1793666667;
  PyObject *__pyx_float_0_1801333333;
  PyObject *__pyx_float_0_1897809524;
  PyObject *__pyx_float_0_1959047619;
  PyObject *__pyx_float_0_2116238095;
  PyObject *__pyx_float_0_2137714286;
  PyObject *__pyx_float_0_2164142857;
  PyObject *__pyx_float_0_2178285714;
  PyObject *__pyx_float_0_2586428571;
  PyObject *__pyx_float_0_2644571429;
  PyObject *__pyx_float_0_2886428571;
  PyObject *__pyx_float_0_2919380952;
  PyObject *__pyx_float_0_3021714286;
  PyObject *__pyx_float_0_3062761905;
  PyObject *__pyx_float_0_3242428571;
  PyObject *__pyx_float_0_3360285714;
  PyObject *__pyx_float_0_3481666667;
  PyObject *__pyx_float_0_3497904762;
  PyObject *__pyx_float_0_3598333333;
  PyObject *__pyx_float_0_3632714286;
  PyObject *__pyx_float_0_3768142857;
  PyObject *__pyx_float_0_3875095238;
  PyObject *__pyx_float_0_3904761905;
  PyObject *__pyx_float_0_3952571429;
  PyObject *__pyx_float_0_4044333333;
  PyObject *__pyx_float_0_4086142857;
  PyObject *__pyx_float_0_4336857143;
  PyObject *__pyx_float_0_4420095238;
  PyObject *__pyx_float_0_4430428571;
  PyObject *__pyx_float_0_4493904762;
  PyObject *__pyx_float_0_4585714286;
  PyObject *__pyx_float_0_4661142857;
  PyObject *__pyx_float_0_4736904762;
  PyObject *__pyx_float_0_4839761905;
  PyObject *__pyx_float_0_4871238095;
  PyObject *__pyx_float_0_4886666667;
  PyObject *__pyx_float_0_5033142857;
  PyObject *__pyx_float_0_5039857143;
  PyObject *__pyx_float_0_5200238095;
  PyObject *__pyx_float_0_5244428571;
  PyObject *__pyx_float_0_5300285714;
  PyObject *__pyx_float_0_5375428571;
  PyObject *__pyx_float_0_5472666667;
  PyObject *__pyx_float_0_5569857143;
  PyObject *__pyx_float_0_5708571429;
  PyObject *__pyx_float_0_5711857143;
  PyObject *__pyx_float_0_5772238095;
  PyObject *__pyx_float_0_5776761905;
  PyObject *__pyx_float_0_5954285714;
  PyObject *__pyx_float_0_5965809524;
  PyObject *__pyx_float_0_6192619048;
  PyObject *__pyx_float_0_6269714286;
  PyObject *__pyx_float_0_6286619048;
  PyObject *__pyx_float_0_6417857143;
  PyObject *__pyx_float_0_6424333333;
  PyObject *__pyx_float_0_6534857143;
  PyObject *__pyx_float_0_6641952381;
  PyObject *__pyx_float_0_6646285714;
  PyObject *__pyx_float_0_6742714286;
  PyObject *__pyx_float_0_6770857143;
  PyObject *__pyx_float_0_6834190476;
  PyObject *__pyx_float_0_6837571429;
  PyObject *__pyx_float_0_6858571429;
  PyObject *__pyx_float_0_6928333333;
  PyObject *__pyx_float_0_7061666667;
  PyObject *__pyx_float_0_7097571429;
  PyObject *__pyx_float_0_7176571429;
  PyObject *__pyx_float_0_7184095238;
  PyObject *__pyx_float_0_7250428571;
  PyObject *__pyx_float_0_7253857143;
  PyObject *__pyx_float_0_7257857143;
  PyObject *__pyx_float_0_7261142857;
  PyObject *__pyx_float_0_7274333333;
  PyObject *__pyx_float_0_7313952381;
  PyObject *__pyx_float_0_7317142857;
  PyObject *__pyx_float_0_7327333333;
  PyObject *__pyx_float_0_7355666667;
  PyObject *__pyx_float_0_7376047619;
  PyObject *__pyx_float_0_7411333333;
  PyObject *__pyx_float_0_7424333333;
  PyObject *__pyx_float_0_7434761905;
  PyObject *__pyx_float_0_7454571429;
  PyObject *__pyx_float_0_7473142857;
  PyObject *__pyx_float_0_7480809524;
  PyObject *__pyx_float_0_7485190476;
  PyObject *__pyx_float_0_7490619048;
  PyObject *__pyx_float_0_7491142857;
  PyObject *__pyx_float_0_7524857143;
  PyObject *__pyx_float_0_7607190476;
  PyObject *__pyx_float_0_7653142857;
  PyObject *__pyx_float_0_7767571429;
  PyObject *__pyx_float_0_7858428571;
  PyObject *__pyx_float_0_7860571429;
  PyObject *__pyx_float_0_7912666667;
  PyObject *__pyx_float_0_8037619048;
  PyObject *__pyx_float_0_8185047619;
  PyObject *__pyx_float_0_8228285714;
  PyObject *__pyx_float_0_8239571429;
  PyObject *__pyx_float_0_8262714286;
  PyObject *__pyx_float_0_8271428571;
  PyObject *__pyx_float_0_8302714286;
  PyObject *__pyx_float_0_8311809524;
  PyObject *__pyx_float_0_8383714286;
  PyObject *__pyx_float_0_8481380952;
  PyObject *__pyx_float_0_8506571429;
  PyObject *__pyx_float_0_8554380952;
  PyObject *__pyx_float_0_8640571429;
  PyObject *__pyx_float_0_8683333333;
  PyObject *__pyx_float_0_8705142857;
  PyObject *__pyx_float_0_8719571429;
  PyObject *__pyx_float_0_8786333333;
  PyObject *__pyx_float_0_8819571429;
  PyObject *__pyx_float_0_8824333333;
  PyObject *__pyx_float_0_8828428571;
  PyObject *__pyx_float_0_9139333333;
  PyObject *__pyx_float_0_9218333333;
  PyObject *__pyx_float_0_9449571429;
  PyObject *__pyx_float_0_9514428571;
  PyObject *__pyx_float_0_9588714286;
  PyObject *__pyx_float_0_9598238095;
  PyObject *__pyx_float_0_9625857143;
  PyObject *__pyx_float_0_9738952381;
  PyObject *__pyx_float_0_9788571429;
  PyObject *__pyx_float_0_9937714286;
  PyObject *__pyx_float_0_9955333333;
  PyObject *__pyx_float_0_9990428571;
} __pyx_mstate;

#if CYTHON_USE_MODULE_STATE
#ifdef __cplusplus
namespace {
  extern struct PyModuleDef __pyx_moduledef;
} 
#else
static struct PyModuleDef __pyx_moduledef;
#endif

#define __pyx_mstate(o) ((__pyx_mstate *)__Pyx_PyModule_GetState(o))

#define __pyx_mstate_global (__pyx_mstate(PyState_FindModule(&__pyx_moduledef)))

#define __pyx_m (PyState_FindModule(&__pyx_moduledef))
#else
static __pyx_mstate __pyx_mstate_global_static =
#ifdef __cplusplus
    {};
#else
    {0};
#endif
static __pyx_mstate *__pyx_mstate_global = &__pyx_mstate_global_static;
#endif

#if CYTHON_USE_MODULE_STATE
static int __pyx_m_clear(PyObject *m) {
  __pyx_mstate *clear_module_state = __pyx_mstate(m);
  if (!clear_module_state) return 0;
  Py_CLEAR(clear_module_state->__pyx_d);
  Py_CLEAR(clear_module_state->__pyx_b);
  Py_CLEAR(clear_module_state->__pyx_cython_runtime);
  Py_CLEAR(clear_module_state->__pyx_empty_tuple);
  Py_CLEAR(clear_module_state->__pyx_empty_bytes);
  Py_CLEAR(clear_module_state->__pyx_empty_unicode);
  #ifdef __Pyx_CyFunction_USED
  Py_CLEAR(clear_module_state->__pyx_CyFunctionType);
  #endif
  #ifdef __Pyx_FusedFunction_USED
  Py_CLEAR(clear_module_state->__pyx_FusedFunctionType);
  #endif
  Py_CLEAR(clear_module_state->__pyx_n_s_);
  Py_CLEAR(clear_module_state->__pyx_n_s_ListedColormap);
  Py_CLEAR(clear_module_state->__pyx_kp_u__2);
  Py_CLEAR(clear_module_state->__pyx_n_s__3);
  Py_CLEAR(clear_module_state->__pyx_n_s_all);
  Py_CLEAR(clear_module_state->__pyx_n_s_cline_in_traceback);
  Py_CLEAR(clear_module_state->__pyx_n_s_cmaps);
  Py_CLEAR(clear_module_state->__pyx_n_s_data);
  Py_CLEAR(clear_module_state->__pyx_n_s_import);
  Py_CLEAR(clear_module_state->__pyx_n_s_initializing);
  Py_CLEAR(clear_module_state->__pyx_n_s_main);
  Py_CLEAR(clear_module_state->__pyx_n_s_matplotlib_colors);
  Py_CLEAR(clear_module_state->__pyx_n_s_name);
  Py_CLEAR(clear_module_state->__pyx_n_s_name_2);
  Py_CLEAR(clear_module_state->__pyx_n_s_parula);
  Py_CLEAR(clear_module_state->__pyx_n_u_parula);
  Py_CLEAR(clear_module_state->__pyx_n_s_parula_data);
  Py_CLEAR(clear_module_state->__pyx_n_s_spec);
  Py_CLEAR(clear_module_state->__pyx_n_s_test);
  Py_CLEAR(clear_module_state->__pyx_n_s_th);
  Py_CLEAR(clear_module_state->__pyx_n_s_torch);
  Py_CLEAR(clear_module_state->__pyx_n_s_viridis);
  Py_CLEAR(clear_module_state->__pyx_n_u_viridis);
  Py_CLEAR(clear_module_state->__pyx_n_s_viridis_data);
  Py_CLEAR(clear_module_state->__pyx_float_0_988);
  Py_CLEAR(clear_module_state->__pyx_float_0_0265);
  Py_CLEAR(clear_module_state->__pyx_float_0_0538);
  Py_CLEAR(clear_module_state->__pyx_float_0_0843);
  Py_CLEAR(clear_module_state->__pyx_float_0_1309);
  Py_CLEAR(clear_module_state->__pyx_float_0_1663);
  Py_CLEAR(clear_module_state->__pyx_float_0_2081);
  Py_CLEAR(clear_module_state->__pyx_float_0_2386);
  Py_CLEAR(clear_module_state->__pyx_float_0_3217);
  Py_CLEAR(clear_module_state->__pyx_float_0_4188);
  Py_CLEAR(clear_module_state->__pyx_float_0_4266);
  Py_CLEAR(clear_module_state->__pyx_float_0_5292);
  Py_CLEAR(clear_module_state->__pyx_float_0_6137);
  Py_CLEAR(clear_module_state->__pyx_float_0_6473);
  Py_CLEAR(clear_module_state->__pyx_float_0_7015);
  Py_CLEAR(clear_module_state->__pyx_float_0_7279);
  Py_CLEAR(clear_module_state->__pyx_float_0_7299);
  Py_CLEAR(clear_module_state->__pyx_float_0_7384);
  Py_CLEAR(clear_module_state->__pyx_float_0_7456);
  Py_CLEAR(clear_module_state->__pyx_float_0_7459);
  Py_CLEAR(clear_module_state->__pyx_float_0_8066);
  Py_CLEAR(clear_module_state->__pyx_float_0_8135);
  Py_CLEAR(clear_module_state->__pyx_float_0_8467);
  Py_CLEAR(clear_module_state->__pyx_float_0_8949);
  Py_CLEAR(clear_module_state->__pyx_float_0_9661);
  Py_CLEAR(clear_module_state->__pyx_float_0_9697);
  Py_CLEAR(clear_module_state->__pyx_float_0_9763);
  Py_CLEAR(clear_module_state->__pyx_float_0_9831);
  Py_CLEAR(clear_module_state->__pyx_float_0_004874);
  Py_CLEAR(clear_module_state->__pyx_float_0_009605);
  Py_CLEAR(clear_module_state->__pyx_float_0_014625);
  Py_CLEAR(clear_module_state->__pyx_float_0_019942);
  Py_CLEAR(clear_module_state->__pyx_float_0_025563);
  Py_CLEAR(clear_module_state->__pyx_float_0_031497);
  Py_CLEAR(clear_module_state->__pyx_float_0_037752);
  Py_CLEAR(clear_module_state->__pyx_float_0_044167);
  Py_CLEAR(clear_module_state->__pyx_float_0_050344);
  Py_CLEAR(clear_module_state->__pyx_float_0_056324);
  Py_CLEAR(clear_module_state->__pyx_float_0_062145);
  Py_CLEAR(clear_module_state->__pyx_float_0_067836);
  Py_CLEAR(clear_module_state->__pyx_float_0_073417);
  Py_CLEAR(clear_module_state->__pyx_float_0_078907);
  Py_CLEAR(clear_module_state->__pyx_float_0_084320);
  Py_CLEAR(clear_module_state->__pyx_float_0_089666);
  Py_CLEAR(clear_module_state->__pyx_float_0_094955);
  Py_CLEAR(clear_module_state->__pyx_float_0_095250);
  Py_CLEAR(clear_module_state->__pyx_float_0_095374);
  Py_CLEAR(clear_module_state->__pyx_float_0_095953);
  Py_CLEAR(clear_module_state->__pyx_float_0_096335);
  Py_CLEAR(clear_module_state->__pyx_float_0_097452);
  Py_CLEAR(clear_module_state->__pyx_float_0_098125);
  Py_CLEAR(clear_module_state->__pyx_float_0_099702);
  Py_CLEAR(clear_module_state->__pyx_float_0_100196);
  Py_CLEAR(clear_module_state->__pyx_float_0_100717);
  Py_CLEAR(clear_module_state->__pyx_float_0_102646);
  Py_CLEAR(clear_module_state->__pyx_float_0_104071);
  Py_CLEAR(clear_module_state->__pyx_float_0_105393);
  Py_CLEAR(clear_module_state->__pyx_float_0_106217);
  Py_CLEAR(clear_module_state->__pyx_float_0_108131);
  Py_CLEAR(clear_module_state->__pyx_float_0_110347);
  Py_CLEAR(clear_module_state->__pyx_float_0_110553);
  Py_CLEAR(clear_module_state->__pyx_float_0_112838);
  Py_CLEAR(clear_module_state->__pyx_float_0_114965);
  Py_CLEAR(clear_module_state->__pyx_float_0_115680);
  Py_CLEAR(clear_module_state->__pyx_float_0_118128);
  Py_CLEAR(clear_module_state->__pyx_float_0_119423);
  Py_CLEAR(clear_module_state->__pyx_float_0_119483);
  Py_CLEAR(clear_module_state->__pyx_float_0_119512);
  Py_CLEAR(clear_module_state->__pyx_float_0_119699);
  Py_CLEAR(clear_module_state->__pyx_float_0_119738);
  Py_CLEAR(clear_module_state->__pyx_float_0_120005);
  Py_CLEAR(clear_module_state->__pyx_float_0_120081);
  Py_CLEAR(clear_module_state->__pyx_float_0_120092);
  Py_CLEAR(clear_module_state->__pyx_float_0_120565);
  Py_CLEAR(clear_module_state->__pyx_float_0_120638);
  Py_CLEAR(clear_module_state->__pyx_float_0_120777);
  Py_CLEAR(clear_module_state->__pyx_float_0_121148);
  Py_CLEAR(clear_module_state->__pyx_float_0_121380);
  Py_CLEAR(clear_module_state->__pyx_float_0_121831);
  Py_CLEAR(clear_module_state->__pyx_float_0_122312);
  Py_CLEAR(clear_module_state->__pyx_float_0_122606);
  Py_CLEAR(clear_module_state->__pyx_float_0_123444);
  Py_CLEAR(clear_module_state->__pyx_float_0_123463);
  Py_CLEAR(clear_module_state->__pyx_float_0_123941);
  Py_CLEAR(clear_module_state->__pyx_float_0_124395);
  Py_CLEAR(clear_module_state->__pyx_float_0_124780);
  Py_CLEAR(clear_module_state->__pyx_float_0_125394);
  Py_CLEAR(clear_module_state->__pyx_float_0_125405);
  Py_CLEAR(clear_module_state->__pyx_float_0_125848);
  Py_CLEAR(clear_module_state->__pyx_float_0_126326);
  Py_CLEAR(clear_module_state->__pyx_float_0_126453);
  Py_CLEAR(clear_module_state->__pyx_float_0_127568);
  Py_CLEAR(clear_module_state->__pyx_float_0_128087);
  Py_CLEAR(clear_module_state->__pyx_float_0_128729);
  Py_CLEAR(clear_module_state->__pyx_float_0_129933);
  Py_CLEAR(clear_module_state->__pyx_float_0_130067);
  Py_CLEAR(clear_module_state->__pyx_float_0_130215);
  Py_CLEAR(clear_module_state->__pyx_float_0_130895);
  Py_CLEAR(clear_module_state->__pyx_float_0_131109);
  Py_CLEAR(clear_module_state->__pyx_float_0_131172);
  Py_CLEAR(clear_module_state->__pyx_float_0_132268);
  Py_CLEAR(clear_module_state->__pyx_float_0_132444);
  Py_CLEAR(clear_module_state->__pyx_float_0_133743);
  Py_CLEAR(clear_module_state->__pyx_float_0_134692);
  Py_CLEAR(clear_module_state->__pyx_float_0_135066);
  Py_CLEAR(clear_module_state->__pyx_float_0_135920);
  Py_CLEAR(clear_module_state->__pyx_float_0_136408);
  Py_CLEAR(clear_module_state->__pyx_float_0_136897);
  Py_CLEAR(clear_module_state->__pyx_float_0_137064);
  Py_CLEAR(clear_module_state->__pyx_float_0_137339);
  Py_CLEAR(clear_module_state->__pyx_float_0_137770);
  Py_CLEAR(clear_module_state->__pyx_float_0_139147);
  Py_CLEAR(clear_module_state->__pyx_float_0_140210);
  Py_CLEAR(clear_module_state->__pyx_float_0_140536);
  Py_CLEAR(clear_module_state->__pyx_float_0_140926);
  Py_CLEAR(clear_module_state->__pyx_float_0_141935);
  Py_CLEAR(clear_module_state->__pyx_float_0_143228);
  Py_CLEAR(clear_module_state->__pyx_float_0_143303);
  Py_CLEAR(clear_module_state->__pyx_float_0_143343);
  Py_CLEAR(clear_module_state->__pyx_float_0_143936);
  Py_CLEAR(clear_module_state->__pyx_float_0_144759);
  Py_CLEAR(clear_module_state->__pyx_float_0_145912);
  Py_CLEAR(clear_module_state->__pyx_float_0_146180);
  Py_CLEAR(clear_module_state->__pyx_float_0_146616);
  Py_CLEAR(clear_module_state->__pyx_float_0_147607);
  Py_CLEAR(clear_module_state->__pyx_float_0_149039);
  Py_CLEAR(clear_module_state->__pyx_float_0_149561);
  Py_CLEAR(clear_module_state->__pyx_float_0_150148);
  Py_CLEAR(clear_module_state->__pyx_float_0_150476);
  Py_CLEAR(clear_module_state->__pyx_float_0_150881);
  Py_CLEAR(clear_module_state->__pyx_float_0_151918);
  Py_CLEAR(clear_module_state->__pyx_float_0_153364);
  Py_CLEAR(clear_module_state->__pyx_float_0_153894);
  Py_CLEAR(clear_module_state->__pyx_float_0_154815);
  Py_CLEAR(clear_module_state->__pyx_float_0_155834);
  Py_CLEAR(clear_module_state->__pyx_float_0_156029);
  Py_CLEAR(clear_module_state->__pyx_float_0_156270);
  Py_CLEAR(clear_module_state->__pyx_float_0_157729);
  Py_CLEAR(clear_module_state->__pyx_float_0_157851);
  Py_CLEAR(clear_module_state->__pyx_float_0_159194);
  Py_CLEAR(clear_module_state->__pyx_float_0_160665);
  Py_CLEAR(clear_module_state->__pyx_float_0_160771);
  Py_CLEAR(clear_module_state->__pyx_float_0_162016);
  Py_CLEAR(clear_module_state->__pyx_float_0_162142);
  Py_CLEAR(clear_module_state->__pyx_float_0_162603);
  Py_CLEAR(clear_module_state->__pyx_float_0_163625);
  Py_CLEAR(clear_module_state->__pyx_float_0_165117);
  Py_CLEAR(clear_module_state->__pyx_float_0_165693);
  Py_CLEAR(clear_module_state->__pyx_float_0_166383);
  Py_CLEAR(clear_module_state->__pyx_float_0_166617);
  Py_CLEAR(clear_module_state->__pyx_float_0_168126);
  Py_CLEAR(clear_module_state->__pyx_float_0_169257);
  Py_CLEAR(clear_module_state->__pyx_float_0_169646);
  Py_CLEAR(clear_module_state->__pyx_float_0_170599);
  Py_CLEAR(clear_module_state->__pyx_float_0_170948);
  Py_CLEAR(clear_module_state->__pyx_float_0_171176);
  Py_CLEAR(clear_module_state->__pyx_float_0_172719);
  Py_CLEAR(clear_module_state->__pyx_float_0_174274);
  Py_CLEAR(clear_module_state->__pyx_float_0_175490);
  Py_CLEAR(clear_module_state->__pyx_float_0_175707);
  Py_CLEAR(clear_module_state->__pyx_float_0_175841);
  Py_CLEAR(clear_module_state->__pyx_float_0_175971);
  Py_CLEAR(clear_module_state->__pyx_float_0_177423);
  Py_CLEAR(clear_module_state->__pyx_float_0_179019);
  Py_CLEAR(clear_module_state->__pyx_float_0_180367);
  Py_CLEAR(clear_module_state->__pyx_float_0_180629);
  Py_CLEAR(clear_module_state->__pyx_float_0_180653);
  Py_CLEAR(clear_module_state->__pyx_float_0_182256);
  Py_CLEAR(clear_module_state->__pyx_float_0_182725);
  Py_CLEAR(clear_module_state->__pyx_float_0_183898);
  Py_CLEAR(clear_module_state->__pyx_float_0_185228);
  Py_CLEAR(clear_module_state->__pyx_float_0_185556);
  Py_CLEAR(clear_module_state->__pyx_float_0_185783);
  Py_CLEAR(clear_module_state->__pyx_float_0_187231);
  Py_CLEAR(clear_module_state->__pyx_float_0_188923);
  Py_CLEAR(clear_module_state->__pyx_float_0_189503);
  Py_CLEAR(clear_module_state->__pyx_float_0_190074);
  Py_CLEAR(clear_module_state->__pyx_float_0_190631);
  Py_CLEAR(clear_module_state->__pyx_float_0_191090);
  Py_CLEAR(clear_module_state->__pyx_float_0_192357);
  Py_CLEAR(clear_module_state->__pyx_float_0_194100);
  Py_CLEAR(clear_module_state->__pyx_float_0_194905);
  Py_CLEAR(clear_module_state->__pyx_float_0_195860);
  Py_CLEAR(clear_module_state->__pyx_float_0_196293);
  Py_CLEAR(clear_module_state->__pyx_float_0_196571);
  Py_CLEAR(clear_module_state->__pyx_float_0_197636);
  Py_CLEAR(clear_module_state->__pyx_float_0_199430);
  Py_CLEAR(clear_module_state->__pyx_float_0_199721);
  Py_CLEAR(clear_module_state->__pyx_float_0_201239);
  Py_CLEAR(clear_module_state->__pyx_float_0_202219);
  Py_CLEAR(clear_module_state->__pyx_float_0_203063);
  Py_CLEAR(clear_module_state->__pyx_float_0_203082);
  Py_CLEAR(clear_module_state->__pyx_float_0_204520);
  Py_CLEAR(clear_module_state->__pyx_float_0_204903);
  Py_CLEAR(clear_module_state->__pyx_float_0_206756);
  Py_CLEAR(clear_module_state->__pyx_float_0_208030);
  Py_CLEAR(clear_module_state->__pyx_float_0_208623);
  Py_CLEAR(clear_module_state->__pyx_float_0_209303);
  Py_CLEAR(clear_module_state->__pyx_float_0_209861);
  Py_CLEAR(clear_module_state->__pyx_float_0_210503);
  Py_CLEAR(clear_module_state->__pyx_float_0_212395);
  Py_CLEAR(clear_module_state->__pyx_float_0_214000);
  Py_CLEAR(clear_module_state->__pyx_float_0_214069);
  Py_CLEAR(clear_module_state->__pyx_float_0_214298);
  Py_CLEAR(clear_module_state->__pyx_float_0_216210);
  Py_CLEAR(clear_module_state->__pyx_float_0_216620);
  Py_CLEAR(clear_module_state->__pyx_float_0_218130);
  Py_CLEAR(clear_module_state->__pyx_float_0_218818);
  Py_CLEAR(clear_module_state->__pyx_float_0_220057);
  Py_CLEAR(clear_module_state->__pyx_float_0_220124);
  Py_CLEAR(clear_module_state->__pyx_float_0_221989);
  Py_CLEAR(clear_module_state->__pyx_float_0_223353);
  Py_CLEAR(clear_module_state->__pyx_float_0_223549);
  Py_CLEAR(clear_module_state->__pyx_float_0_223925);
  Py_CLEAR(clear_module_state->__pyx_float_0_225863);
  Py_CLEAR(clear_module_state->__pyx_float_0_226397);
  Py_CLEAR(clear_module_state->__pyx_float_0_227802);
  Py_CLEAR(clear_module_state->__pyx_float_0_228262);
  Py_CLEAR(clear_module_state->__pyx_float_0_229739);
  Py_CLEAR(clear_module_state->__pyx_float_0_230052);
  Py_CLEAR(clear_module_state->__pyx_float_0_231674);
  Py_CLEAR(clear_module_state->__pyx_float_0_232815);
  Py_CLEAR(clear_module_state->__pyx_float_0_232956);
  Py_CLEAR(clear_module_state->__pyx_float_0_233603);
  Py_CLEAR(clear_module_state->__pyx_float_0_235526);
  Py_CLEAR(clear_module_state->__pyx_float_0_236712);
  Py_CLEAR(clear_module_state->__pyx_float_0_237441);
  Py_CLEAR(clear_module_state->__pyx_float_0_237631);
  Py_CLEAR(clear_module_state->__pyx_float_0_239346);
  Py_CLEAR(clear_module_state->__pyx_float_0_239374);
  Py_CLEAR(clear_module_state->__pyx_float_0_241237);
  Py_CLEAR(clear_module_state->__pyx_float_0_242286);
  Py_CLEAR(clear_module_state->__pyx_float_0_243113);
  Py_CLEAR(clear_module_state->__pyx_float_0_243329);
  Py_CLEAR(clear_module_state->__pyx_float_0_244972);
  Py_CLEAR(clear_module_state->__pyx_float_0_246070);
  Py_CLEAR(clear_module_state->__pyx_float_0_246811);
  Py_CLEAR(clear_module_state->__pyx_float_0_246922);
  Py_CLEAR(clear_module_state->__pyx_float_0_248629);
  Py_CLEAR(clear_module_state->__pyx_float_0_249897);
  Py_CLEAR(clear_module_state->__pyx_float_0_250425);
  Py_CLEAR(clear_module_state->__pyx_float_0_251537);
  Py_CLEAR(clear_module_state->__pyx_float_0_252194);
  Py_CLEAR(clear_module_state->__pyx_float_0_252899);
  Py_CLEAR(clear_module_state->__pyx_float_0_253935);
  Py_CLEAR(clear_module_state->__pyx_float_0_255645);
  Py_CLEAR(clear_module_state->__pyx_float_0_256130);
  Py_CLEAR(clear_module_state->__pyx_float_0_256415);
  Py_CLEAR(clear_module_state->__pyx_float_0_257322);
  Py_CLEAR(clear_module_state->__pyx_float_0_258965);
  Py_CLEAR(clear_module_state->__pyx_float_0_259857);
  Py_CLEAR(clear_module_state->__pyx_float_0_260571);
  Py_CLEAR(clear_module_state->__pyx_float_0_260703);
  Py_CLEAR(clear_module_state->__pyx_float_0_262138);
  Py_CLEAR(clear_module_state->__pyx_float_0_262877);
  Py_CLEAR(clear_module_state->__pyx_float_0_263663);
  Py_CLEAR(clear_module_state->__pyx_float_0_265145);
  Py_CLEAR(clear_module_state->__pyx_float_0_265254);
  Py_CLEAR(clear_module_state->__pyx_float_0_266580);
  Py_CLEAR(clear_module_state->__pyx_float_0_266941);
  Py_CLEAR(clear_module_state->__pyx_float_0_267004);
  Py_CLEAR(clear_module_state->__pyx_float_0_267968);
  Py_CLEAR(clear_module_state->__pyx_float_0_268510);
  Py_CLEAR(clear_module_state->__pyx_float_0_269281);
  Py_CLEAR(clear_module_state->__pyx_float_0_269308);
  Py_CLEAR(clear_module_state->__pyx_float_0_269783);
  Py_CLEAR(clear_module_state->__pyx_float_0_269944);
  Py_CLEAR(clear_module_state->__pyx_float_0_270595);
  Py_CLEAR(clear_module_state->__pyx_float_0_271305);
  Py_CLEAR(clear_module_state->__pyx_float_0_271828);
  Py_CLEAR(clear_module_state->__pyx_float_0_272594);
  Py_CLEAR(clear_module_state->__pyx_float_0_273006);
  Py_CLEAR(clear_module_state->__pyx_float_0_273809);
  Py_CLEAR(clear_module_state->__pyx_float_0_274128);
  Py_CLEAR(clear_module_state->__pyx_float_0_274149);
  Py_CLEAR(clear_module_state->__pyx_float_0_274290);
  Py_CLEAR(clear_module_state->__pyx_float_0_274952);
  Py_CLEAR(clear_module_state->__pyx_float_0_275191);
  Py_CLEAR(clear_module_state->__pyx_float_0_275626);
  Py_CLEAR(clear_module_state->__pyx_float_0_276022);
  Py_CLEAR(clear_module_state->__pyx_float_0_276194);
  Py_CLEAR(clear_module_state->__pyx_float_0_277018);
  Py_CLEAR(clear_module_state->__pyx_float_0_277134);
  Py_CLEAR(clear_module_state->__pyx_float_0_277941);
  Py_CLEAR(clear_module_state->__pyx_float_0_278012);
  Py_CLEAR(clear_module_state->__pyx_float_0_278775);
  Py_CLEAR(clear_module_state->__pyx_float_0_278791);
  Py_CLEAR(clear_module_state->__pyx_float_0_278826);
  Py_CLEAR(clear_module_state->__pyx_float_0_279566);
  Py_CLEAR(clear_module_state->__pyx_float_0_279574);
  Py_CLEAR(clear_module_state->__pyx_float_0_280255);
  Py_CLEAR(clear_module_state->__pyx_float_0_280267);
  Py_CLEAR(clear_module_state->__pyx_float_0_280868);
  Py_CLEAR(clear_module_state->__pyx_float_0_280894);
  Py_CLEAR(clear_module_state->__pyx_float_0_281412);
  Py_CLEAR(clear_module_state->__pyx_float_0_281446);
  Py_CLEAR(clear_module_state->__pyx_float_0_281477);
  Py_CLEAR(clear_module_state->__pyx_float_0_281887);
  Py_CLEAR(clear_module_state->__pyx_float_0_281908);
  Py_CLEAR(clear_module_state->__pyx_float_0_281924);
  Py_CLEAR(clear_module_state->__pyx_float_0_282290);
  Py_CLEAR(clear_module_state->__pyx_float_0_282327);
  Py_CLEAR(clear_module_state->__pyx_float_0_282623);
  Py_CLEAR(clear_module_state->__pyx_float_0_282656);
  Py_CLEAR(clear_module_state->__pyx_float_0_282884);
  Py_CLEAR(clear_module_state->__pyx_float_0_282910);
  Py_CLEAR(clear_module_state->__pyx_float_0_283072);
  Py_CLEAR(clear_module_state->__pyx_float_0_283091);
  Py_CLEAR(clear_module_state->__pyx_float_0_283187);
  Py_CLEAR(clear_module_state->__pyx_float_0_283197);
  Py_CLEAR(clear_module_state->__pyx_float_0_283229);
  Py_CLEAR(clear_module_state->__pyx_float_0_283237);
  Py_CLEAR(clear_module_state->__pyx_float_0_287675);
  Py_CLEAR(clear_module_state->__pyx_float_0_288127);
  Py_CLEAR(clear_module_state->__pyx_float_0_288921);
  Py_CLEAR(clear_module_state->__pyx_float_0_292092);
  Py_CLEAR(clear_module_state->__pyx_float_0_294279);
  Py_CLEAR(clear_module_state->__pyx_float_0_296479);
  Py_CLEAR(clear_module_state->__pyx_float_0_296485);
  Py_CLEAR(clear_module_state->__pyx_float_0_300362);
  Py_CLEAR(clear_module_state->__pyx_float_0_300855);
  Py_CLEAR(clear_module_state->__pyx_float_0_304148);
  Py_CLEAR(clear_module_state->__pyx_float_0_305202);
  Py_CLEAR(clear_module_state->__pyx_float_0_306377);
  Py_CLEAR(clear_module_state->__pyx_float_0_309527);
  Py_CLEAR(clear_module_state->__pyx_float_0_311925);
  Py_CLEAR(clear_module_state->__pyx_float_0_312321);
  Py_CLEAR(clear_module_state->__pyx_float_0_313828);
  Py_CLEAR(clear_module_state->__pyx_float_0_318106);
  Py_CLEAR(clear_module_state->__pyx_float_0_318195);
  Py_CLEAR(clear_module_state->__pyx_float_0_319809);
  Py_CLEAR(clear_module_state->__pyx_float_0_322361);
  Py_CLEAR(clear_module_state->__pyx_float_0_323998);
  Py_CLEAR(clear_module_state->__pyx_float_0_326594);
  Py_CLEAR(clear_module_state->__pyx_float_0_327796);
  Py_CLEAR(clear_module_state->__pyx_float_0_329415);
  Py_CLEAR(clear_module_state->__pyx_float_0_329727);
  Py_CLEAR(clear_module_state->__pyx_float_0_330805);
  Py_CLEAR(clear_module_state->__pyx_float_0_334994);
  Py_CLEAR(clear_module_state->__pyx_float_0_335384);
  Py_CLEAR(clear_module_state->__pyx_float_0_335427);
  Py_CLEAR(clear_module_state->__pyx_float_0_335885);
  Py_CLEAR(clear_module_state->__pyx_float_0_339161);
  Py_CLEAR(clear_module_state->__pyx_float_0_340967);
  Py_CLEAR(clear_module_state->__pyx_float_0_341379);
  Py_CLEAR(clear_module_state->__pyx_float_0_343307);
  Py_CLEAR(clear_module_state->__pyx_float_0_344074);
  Py_CLEAR(clear_module_state->__pyx_float_0_346476);
  Py_CLEAR(clear_module_state->__pyx_float_0_347269);
  Py_CLEAR(clear_module_state->__pyx_float_0_347432);
  Py_CLEAR(clear_module_state->__pyx_float_0_351535);
  Py_CLEAR(clear_module_state->__pyx_float_0_351910);
  Py_CLEAR(clear_module_state->__pyx_float_0_352360);
  Py_CLEAR(clear_module_state->__pyx_float_0_353093);
  Py_CLEAR(clear_module_state->__pyx_float_0_355619);
  Py_CLEAR(clear_module_state->__pyx_float_0_357269);
  Py_CLEAR(clear_module_state->__pyx_float_0_358853);
  Py_CLEAR(clear_module_state->__pyx_float_0_359683);
  Py_CLEAR(clear_module_state->__pyx_float_0_360741);
  Py_CLEAR(clear_module_state->__pyx_float_0_362552);
  Py_CLEAR(clear_module_state->__pyx_float_0_363727);
  Py_CLEAR(clear_module_state->__pyx_float_0_364543);
  Py_CLEAR(clear_module_state->__pyx_float_0_367752);
  Py_CLEAR(clear_module_state->__pyx_float_0_367757);
  Py_CLEAR(clear_module_state->__pyx_float_0_369214);
  Py_CLEAR(clear_module_state->__pyx_float_0_370164);
  Py_CLEAR(clear_module_state->__pyx_float_0_371758);
  Py_CLEAR(clear_module_state->__pyx_float_0_372886);
  Py_CLEAR(clear_module_state->__pyx_float_0_375715);
  Py_CLEAR(clear_module_state->__pyx_float_0_375746);
  Py_CLEAR(clear_module_state->__pyx_float_0_377779);
  Py_CLEAR(clear_module_state->__pyx_float_0_377939);
  Py_CLEAR(clear_module_state->__pyx_float_0_379716);
  Py_CLEAR(clear_module_state->__pyx_float_0_381191);
  Py_CLEAR(clear_module_state->__pyx_float_0_382914);
  Py_CLEAR(clear_module_state->__pyx_float_0_383670);
  Py_CLEAR(clear_module_state->__pyx_float_0_386433);
  Py_CLEAR(clear_module_state->__pyx_float_0_386592);
  Py_CLEAR(clear_module_state->__pyx_float_0_387607);
  Py_CLEAR(clear_module_state->__pyx_float_0_387814);
  Py_CLEAR(clear_module_state->__pyx_float_0_391528);
  Py_CLEAR(clear_module_state->__pyx_float_0_391917);
  Py_CLEAR(clear_module_state->__pyx_float_0_392636);
  Py_CLEAR(clear_module_state->__pyx_float_0_395174);
  Py_CLEAR(clear_module_state->__pyx_float_0_395433);
  Py_CLEAR(clear_module_state->__pyx_float_0_397163);
  Py_CLEAR(clear_module_state->__pyx_float_0_397381);
  Py_CLEAR(clear_module_state->__pyx_float_0_399323);
  Py_CLEAR(clear_module_state->__pyx_float_0_402049);
  Py_CLEAR(clear_module_state->__pyx_float_0_402329);
  Py_CLEAR(clear_module_state->__pyx_float_0_403199);
  Py_CLEAR(clear_module_state->__pyx_float_0_404001);
  Py_CLEAR(clear_module_state->__pyx_float_0_406640);
  Py_CLEAR(clear_module_state->__pyx_float_0_407061);
  Py_CLEAR(clear_module_state->__pyx_float_0_407414);
  Py_CLEAR(clear_module_state->__pyx_float_0_410910);
  Py_CLEAR(clear_module_state->__pyx_float_0_411152);
  Py_CLEAR(clear_module_state->__pyx_float_0_412415);
  Py_CLEAR(clear_module_state->__pyx_float_0_412913);
  Py_CLEAR(clear_module_state->__pyx_float_0_414746);
  Py_CLEAR(clear_module_state->__pyx_float_0_415586);
  Py_CLEAR(clear_module_state->__pyx_float_0_417331);
  Py_CLEAR(clear_module_state->__pyx_float_0_418570);
  Py_CLEAR(clear_module_state->__pyx_float_0_419943);
  Py_CLEAR(clear_module_state->__pyx_float_0_421908);
  Py_CLEAR(clear_module_state->__pyx_float_0_422160);
  Py_CLEAR(clear_module_state->__pyx_float_0_422383);
  Py_CLEAR(clear_module_state->__pyx_float_0_424223);
  Py_CLEAR(clear_module_state->__pyx_float_0_426184);
  Py_CLEAR(clear_module_state->__pyx_float_0_426902);
  Py_CLEAR(clear_module_state->__pyx_float_0_428426);
  Py_CLEAR(clear_module_state->__pyx_float_0_429975);
  Py_CLEAR(clear_module_state->__pyx_float_0_430983);
  Py_CLEAR(clear_module_state->__pyx_float_0_431554);
  Py_CLEAR(clear_module_state->__pyx_float_0_432552);
  Py_CLEAR(clear_module_state->__pyx_float_0_433756);
  Py_CLEAR(clear_module_state->__pyx_float_0_436115);
  Py_CLEAR(clear_module_state->__pyx_float_0_436601);
  Py_CLEAR(clear_module_state->__pyx_float_0_437527);
  Py_CLEAR(clear_module_state->__pyx_float_0_440137);
  Py_CLEAR(clear_module_state->__pyx_float_0_440573);
  Py_CLEAR(clear_module_state->__pyx_float_0_440584);
  Py_CLEAR(clear_module_state->__pyx_float_0_441290);
  Py_CLEAR(clear_module_state->__pyx_float_0_444467);
  Py_CLEAR(clear_module_state->__pyx_float_0_444960);
  Py_CLEAR(clear_module_state->__pyx_float_0_445044);
  Py_CLEAR(clear_module_state->__pyx_float_0_448284);
  Py_CLEAR(clear_module_state->__pyx_float_0_448791);
  Py_CLEAR(clear_module_state->__pyx_float_0_449241);
  Py_CLEAR(clear_module_state->__pyx_float_0_449368);
  Py_CLEAR(clear_module_state->__pyx_float_0_452024);
  Py_CLEAR(clear_module_state->__pyx_float_0_452530);
  Py_CLEAR(clear_module_state->__pyx_float_0_453427);
  Py_CLEAR(clear_module_state->__pyx_float_0_455688);
  Py_CLEAR(clear_module_state->__pyx_float_0_456262);
  Py_CLEAR(clear_module_state->__pyx_float_0_457517);
  Py_CLEAR(clear_module_state->__pyx_float_0_458674);
  Py_CLEAR(clear_module_state->__pyx_float_0_459277);
  Py_CLEAR(clear_module_state->__pyx_float_0_459988);
  Py_CLEAR(clear_module_state->__pyx_float_0_461510);
  Py_CLEAR(clear_module_state->__pyx_float_0_462789);
  Py_CLEAR(clear_module_state->__pyx_float_0_463708);
  Py_CLEAR(clear_module_state->__pyx_float_0_465405);
  Py_CLEAR(clear_module_state->__pyx_float_0_466226);
  Py_CLEAR(clear_module_state->__pyx_float_0_467423);
  Py_CLEAR(clear_module_state->__pyx_float_0_468053);
  Py_CLEAR(clear_module_state->__pyx_float_0_469201);
  Py_CLEAR(clear_module_state->__pyx_float_0_469588);
  Py_CLEAR(clear_module_state->__pyx_float_0_471133);
  Py_CLEAR(clear_module_state->__pyx_float_0_472873);
  Py_CLEAR(clear_module_state->__pyx_float_0_472899);
  Py_CLEAR(clear_module_state->__pyx_float_0_474838);
  Py_CLEAR(clear_module_state->__pyx_float_0_476084);
  Py_CLEAR(clear_module_state->__pyx_float_0_476498);
  Py_CLEAR(clear_module_state->__pyx_float_0_477504);
  Py_CLEAR(clear_module_state->__pyx_float_0_478540);
  Py_CLEAR(clear_module_state->__pyx_float_0_479221);
  Py_CLEAR(clear_module_state->__pyx_float_0_479997);
  Py_CLEAR(clear_module_state->__pyx_float_0_482237);
  Py_CLEAR(clear_module_state->__pyx_float_0_482284);
  Py_CLEAR(clear_module_state->__pyx_float_0_483397);
  Py_CLEAR(clear_module_state->__pyx_float_0_485273);
  Py_CLEAR(clear_module_state->__pyx_float_0_485932);
  Py_CLEAR(clear_module_state->__pyx_float_0_486697);
  Py_CLEAR(clear_module_state->__pyx_float_0_487026);
  Py_CLEAR(clear_module_state->__pyx_float_0_488189);
  Py_CLEAR(clear_module_state->__pyx_float_0_489624);
  Py_CLEAR(clear_module_state->__pyx_float_0_489898);
  Py_CLEAR(clear_module_state->__pyx_float_0_491033);
  Py_CLEAR(clear_module_state->__pyx_float_0_493001);
  Py_CLEAR(clear_module_state->__pyx_float_0_493313);
  Py_CLEAR(clear_module_state->__pyx_float_0_493803);
  Py_CLEAR(clear_module_state->__pyx_float_0_496005);
  Py_CLEAR(clear_module_state->__pyx_float_0_496502);
  Py_CLEAR(clear_module_state->__pyx_float_0_496615);
  Py_CLEAR(clear_module_state->__pyx_float_0_497000);
  Py_CLEAR(clear_module_state->__pyx_float_0_498911);
  Py_CLEAR(clear_module_state->__pyx_float_0_499129);
  Py_CLEAR(clear_module_state->__pyx_float_0_500685);
  Py_CLEAR(clear_module_state->__pyx_float_0_501686);
  Py_CLEAR(clear_module_state->__pyx_float_0_501721);
  Py_CLEAR(clear_module_state->__pyx_float_0_504172);
  Py_CLEAR(clear_module_state->__pyx_float_0_504369);
  Py_CLEAR(clear_module_state->__pyx_float_0_504434);
  Py_CLEAR(clear_module_state->__pyx_float_0_506271);
  Py_CLEAR(clear_module_state->__pyx_float_0_506589);
  Py_CLEAR(clear_module_state->__pyx_float_0_507052);
  Py_CLEAR(clear_module_state->__pyx_float_0_508051);
  Py_CLEAR(clear_module_state->__pyx_float_0_508936);
  Py_CLEAR(clear_module_state->__pyx_float_0_509577);
  Py_CLEAR(clear_module_state->__pyx_float_0_511215);
  Py_CLEAR(clear_module_state->__pyx_float_0_511733);
  Py_CLEAR(clear_module_state->__pyx_float_0_512008);
  Py_CLEAR(clear_module_state->__pyx_float_0_513427);
  Py_CLEAR(clear_module_state->__pyx_float_0_514349);
  Py_CLEAR(clear_module_state->__pyx_float_0_515413);
  Py_CLEAR(clear_module_state->__pyx_float_0_515571);
  Py_CLEAR(clear_module_state->__pyx_float_0_515992);
  Py_CLEAR(clear_module_state->__pyx_float_0_516599);
  Py_CLEAR(clear_module_state->__pyx_float_0_517649);
  Py_CLEAR(clear_module_state->__pyx_float_0_518762);
  Py_CLEAR(clear_module_state->__pyx_float_0_519093);
  Py_CLEAR(clear_module_state->__pyx_float_0_519661);
  Py_CLEAR(clear_module_state->__pyx_float_0_520837);
  Py_CLEAR(clear_module_state->__pyx_float_0_521608);
  Py_CLEAR(clear_module_state->__pyx_float_0_522773);
  Py_CLEAR(clear_module_state->__pyx_float_0_522828);
  Py_CLEAR(clear_module_state->__pyx_float_0_523491);
  Py_CLEAR(clear_module_state->__pyx_float_0_524736);
  Py_CLEAR(clear_module_state->__pyx_float_0_525311);
  Py_CLEAR(clear_module_state->__pyx_float_0_525776);
  Py_CLEAR(clear_module_state->__pyx_float_0_526453);
  Py_CLEAR(clear_module_state->__pyx_float_0_526563);
  Py_CLEAR(clear_module_state->__pyx_float_0_527068);
  Py_CLEAR(clear_module_state->__pyx_float_0_528312);
  Py_CLEAR(clear_module_state->__pyx_float_0_528763);
  Py_CLEAR(clear_module_state->__pyx_float_0_529983);
  Py_CLEAR(clear_module_state->__pyx_float_0_530132);
  Py_CLEAR(clear_module_state->__pyx_float_0_530398);
  Py_CLEAR(clear_module_state->__pyx_float_0_531579);
  Py_CLEAR(clear_module_state->__pyx_float_0_531973);
  Py_CLEAR(clear_module_state->__pyx_float_0_533103);
  Py_CLEAR(clear_module_state->__pyx_float_0_533488);
  Py_CLEAR(clear_module_state->__pyx_float_0_533812);
  Py_CLEAR(clear_module_state->__pyx_float_0_534556);
  Py_CLEAR(clear_module_state->__pyx_float_0_534946);
  Py_CLEAR(clear_module_state->__pyx_float_0_535621);
  Py_CLEAR(clear_module_state->__pyx_float_0_535941);
  Py_CLEAR(clear_module_state->__pyx_float_0_536347);
  Py_CLEAR(clear_module_state->__pyx_float_0_537260);
  Py_CLEAR(clear_module_state->__pyx_float_0_537492);
  Py_CLEAR(clear_module_state->__pyx_float_0_537692);
  Py_CLEAR(clear_module_state->__pyx_float_0_538516);
  Py_CLEAR(clear_module_state->__pyx_float_0_538982);
  Py_CLEAR(clear_module_state->__pyx_float_0_539709);
  Py_CLEAR(clear_module_state->__pyx_float_0_540218);
  Py_CLEAR(clear_module_state->__pyx_float_0_540844);
  Py_CLEAR(clear_module_state->__pyx_float_0_541173);
  Py_CLEAR(clear_module_state->__pyx_float_0_541400);
  Py_CLEAR(clear_module_state->__pyx_float_0_541921);
  Py_CLEAR(clear_module_state->__pyx_float_0_542530);
  Py_CLEAR(clear_module_state->__pyx_float_0_542944);
  Py_CLEAR(clear_module_state->__pyx_float_0_543611);
  Py_CLEAR(clear_module_state->__pyx_float_0_543914);
  Py_CLEAR(clear_module_state->__pyx_float_0_544641);
  Py_CLEAR(clear_module_state->__pyx_float_0_544834);
  Py_CLEAR(clear_module_state->__pyx_float_0_544853);
  Py_CLEAR(clear_module_state->__pyx_float_0_545524);
  Py_CLEAR(clear_module_state->__pyx_float_0_545623);
  Py_CLEAR(clear_module_state->__pyx_float_0_545706);
  Py_CLEAR(clear_module_state->__pyx_float_0_546532);
  Py_CLEAR(clear_module_state->__pyx_float_0_546557);
  Py_CLEAR(clear_module_state->__pyx_float_0_547314);
  Py_CLEAR(clear_module_state->__pyx_float_0_547445);
  Py_CLEAR(clear_module_state->__pyx_float_0_548053);
  Py_CLEAR(clear_module_state->__pyx_float_0_548287);
  Py_CLEAR(clear_module_state->__pyx_float_0_548535);
  Py_CLEAR(clear_module_state->__pyx_float_0_548752);
  Py_CLEAR(clear_module_state->__pyx_float_0_549086);
  Py_CLEAR(clear_module_state->__pyx_float_0_549413);
  Py_CLEAR(clear_module_state->__pyx_float_0_549841);
  Py_CLEAR(clear_module_state->__pyx_float_0_550038);
  Py_CLEAR(clear_module_state->__pyx_float_0_550556);
  Py_CLEAR(clear_module_state->__pyx_float_0_550627);
  Py_CLEAR(clear_module_state->__pyx_float_0_551184);
  Py_CLEAR(clear_module_state->__pyx_float_0_551229);
  Py_CLEAR(clear_module_state->__pyx_float_0_551710);
  Py_CLEAR(clear_module_state->__pyx_float_0_551864);
  Py_CLEAR(clear_module_state->__pyx_float_0_552206);
  Py_CLEAR(clear_module_state->__pyx_float_0_552216);
  Py_CLEAR(clear_module_state->__pyx_float_0_552459);
  Py_CLEAR(clear_module_state->__pyx_float_0_552675);
  Py_CLEAR(clear_module_state->__pyx_float_0_553018);
  Py_CLEAR(clear_module_state->__pyx_float_0_553117);
  Py_CLEAR(clear_module_state->__pyx_float_0_553533);
  Py_CLEAR(clear_module_state->__pyx_float_0_553541);
  Py_CLEAR(clear_module_state->__pyx_float_0_553925);
  Py_CLEAR(clear_module_state->__pyx_float_0_554029);
  Py_CLEAR(clear_module_state->__pyx_float_0_554294);
  Py_CLEAR(clear_module_state->__pyx_float_0_554483);
  Py_CLEAR(clear_module_state->__pyx_float_0_554642);
  Py_CLEAR(clear_module_state->__pyx_float_0_554906);
  Py_CLEAR(clear_module_state->__pyx_float_0_554969);
  Py_CLEAR(clear_module_state->__pyx_float_0_555276);
  Py_CLEAR(clear_module_state->__pyx_float_0_555298);
  Py_CLEAR(clear_module_state->__pyx_float_0_555484);
  Py_CLEAR(clear_module_state->__pyx_float_0_555565);
  Py_CLEAR(clear_module_state->__pyx_float_0_555659);
  Py_CLEAR(clear_module_state->__pyx_float_0_555836);
  Py_CLEAR(clear_module_state->__pyx_float_0_555899);
  Py_CLEAR(clear_module_state->__pyx_float_0_555991);
  Py_CLEAR(clear_module_state->__pyx_float_0_556089);
  Py_CLEAR(clear_module_state->__pyx_float_0_556295);
  Py_CLEAR(clear_module_state->__pyx_float_0_556326);
  Py_CLEAR(clear_module_state->__pyx_float_0_556547);
  Py_CLEAR(clear_module_state->__pyx_float_0_556572);
  Py_CLEAR(clear_module_state->__pyx_float_0_556753);
  Py_CLEAR(clear_module_state->__pyx_float_0_556823);
  Py_CLEAR(clear_module_state->__pyx_float_0_556944);
  Py_CLEAR(clear_module_state->__pyx_float_0_557049);
  Py_CLEAR(clear_module_state->__pyx_float_0_557120);
  Py_CLEAR(clear_module_state->__pyx_float_0_557250);
  Py_CLEAR(clear_module_state->__pyx_float_0_557282);
  Py_CLEAR(clear_module_state->__pyx_float_0_557430);
  Py_CLEAR(clear_module_state->__pyx_float_0_557565);
  Py_CLEAR(clear_module_state->__pyx_float_0_557587);
  Py_CLEAR(clear_module_state->__pyx_float_0_557685);
  Py_CLEAR(clear_module_state->__pyx_float_0_557724);
  Py_CLEAR(clear_module_state->__pyx_float_0_557792);
  Py_CLEAR(clear_module_state->__pyx_float_0_557840);
  Py_CLEAR(clear_module_state->__pyx_float_0_557885);
  Py_CLEAR(clear_module_state->__pyx_float_0_557936);
  Py_CLEAR(clear_module_state->__pyx_float_0_557965);
  Py_CLEAR(clear_module_state->__pyx_float_0_558013);
  Py_CLEAR(clear_module_state->__pyx_float_0_558030);
  Py_CLEAR(clear_module_state->__pyx_float_0_558073);
  Py_CLEAR(clear_module_state->__pyx_float_0_558082);
  Py_CLEAR(clear_module_state->__pyx_float_0_558115);
  Py_CLEAR(clear_module_state->__pyx_float_0_558119);
  Py_CLEAR(clear_module_state->__pyx_float_0_558140);
  Py_CLEAR(clear_module_state->__pyx_float_0_558141);
  Py_CLEAR(clear_module_state->__pyx_float_0_558148);
  Py_CLEAR(clear_module_state->__pyx_float_0_559582);
  Py_CLEAR(clear_module_state->__pyx_float_0_563265);
  Py_CLEAR(clear_module_state->__pyx_float_0_565498);
  Py_CLEAR(clear_module_state->__pyx_float_0_566949);
  Py_CLEAR(clear_module_state->__pyx_float_0_570633);
  Py_CLEAR(clear_module_state->__pyx_float_0_574318);
  Py_CLEAR(clear_module_state->__pyx_float_0_575563);
  Py_CLEAR(clear_module_state->__pyx_float_0_578002);
  Py_CLEAR(clear_module_state->__pyx_float_0_581687);
  Py_CLEAR(clear_module_state->__pyx_float_0_585371);
  Py_CLEAR(clear_module_state->__pyx_float_0_585678);
  Py_CLEAR(clear_module_state->__pyx_float_0_589055);
  Py_CLEAR(clear_module_state->__pyx_float_0_592739);
  Py_CLEAR(clear_module_state->__pyx_float_0_595839);
  Py_CLEAR(clear_module_state->__pyx_float_0_596422);
  Py_CLEAR(clear_module_state->__pyx_float_0_600104);
  Py_CLEAR(clear_module_state->__pyx_float_0_603785);
  Py_CLEAR(clear_module_state->__pyx_float_0_606045);
  Py_CLEAR(clear_module_state->__pyx_float_0_607464);
  Py_CLEAR(clear_module_state->__pyx_float_0_611141);
  Py_CLEAR(clear_module_state->__pyx_float_0_614817);
  Py_CLEAR(clear_module_state->__pyx_float_0_616293);
  Py_CLEAR(clear_module_state->__pyx_float_0_618490);
  Py_CLEAR(clear_module_state->__pyx_float_0_622161);
  Py_CLEAR(clear_module_state->__pyx_float_0_625828);
  Py_CLEAR(clear_module_state->__pyx_float_0_626579);
  Py_CLEAR(clear_module_state->__pyx_float_0_629492);
  Py_CLEAR(clear_module_state->__pyx_float_0_633153);
  Py_CLEAR(clear_module_state->__pyx_float_0_636809);
  Py_CLEAR(clear_module_state->__pyx_float_0_636902);
  Py_CLEAR(clear_module_state->__pyx_float_0_640461);
  Py_CLEAR(clear_module_state->__pyx_float_0_644107);
  Py_CLEAR(clear_module_state->__pyx_float_0_647257);
  Py_CLEAR(clear_module_state->__pyx_float_0_647749);
  Py_CLEAR(clear_module_state->__pyx_float_0_651384);
  Py_CLEAR(clear_module_state->__pyx_float_0_655014);
  Py_CLEAR(clear_module_state->__pyx_float_0_657642);
  Py_CLEAR(clear_module_state->__pyx_float_0_658636);
  Py_CLEAR(clear_module_state->__pyx_float_0_662252);
  Py_CLEAR(clear_module_state->__pyx_float_0_665859);
  Py_CLEAR(clear_module_state->__pyx_float_0_668054);
  Py_CLEAR(clear_module_state->__pyx_float_0_669459);
  Py_CLEAR(clear_module_state->__pyx_float_0_673050);
  Py_CLEAR(clear_module_state->__pyx_float_0_676631);
  Py_CLEAR(clear_module_state->__pyx_float_0_678489);
  Py_CLEAR(clear_module_state->__pyx_float_0_680203);
  Py_CLEAR(clear_module_state->__pyx_float_0_683765);
  Py_CLEAR(clear_module_state->__pyx_float_0_687316);
  Py_CLEAR(clear_module_state->__pyx_float_0_688944);
  Py_CLEAR(clear_module_state->__pyx_float_0_690856);
  Py_CLEAR(clear_module_state->__pyx_float_0_694384);
  Py_CLEAR(clear_module_state->__pyx_float_0_697900);
  Py_CLEAR(clear_module_state->__pyx_float_0_699415);
  Py_CLEAR(clear_module_state->__pyx_float_0_701402);
  Py_CLEAR(clear_module_state->__pyx_float_0_704891);
  Py_CLEAR(clear_module_state->__pyx_float_0_708366);
  Py_CLEAR(clear_module_state->__pyx_float_0_709898);
  Py_CLEAR(clear_module_state->__pyx_float_0_711827);
  Py_CLEAR(clear_module_state->__pyx_float_0_715272);
  Py_CLEAR(clear_module_state->__pyx_float_0_718701);
  Py_CLEAR(clear_module_state->__pyx_float_0_720391);
  Py_CLEAR(clear_module_state->__pyx_float_0_722114);
  Py_CLEAR(clear_module_state->__pyx_float_0_725509);
  Py_CLEAR(clear_module_state->__pyx_float_0_728888);
  Py_CLEAR(clear_module_state->__pyx_float_0_730889);
  Py_CLEAR(clear_module_state->__pyx_float_0_732247);
  Py_CLEAR(clear_module_state->__pyx_float_0_735588);
  Py_CLEAR(clear_module_state->__pyx_float_0_738910);
  Py_CLEAR(clear_module_state->__pyx_float_0_741388);
  Py_CLEAR(clear_module_state->__pyx_float_0_742211);
  Py_CLEAR(clear_module_state->__pyx_float_0_745492);
  Py_CLEAR(clear_module_state->__pyx_float_0_748751);
  Py_CLEAR(clear_module_state->__pyx_float_0_751884);
  Py_CLEAR(clear_module_state->__pyx_float_0_751988);
  Py_CLEAR(clear_module_state->__pyx_float_0_755203);
  Py_CLEAR(clear_module_state->__pyx_float_0_758394);
  Py_CLEAR(clear_module_state->__pyx_float_0_761561);
  Py_CLEAR(clear_module_state->__pyx_float_0_762373);
  Py_CLEAR(clear_module_state->__pyx_float_0_764704);
  Py_CLEAR(clear_module_state->__pyx_float_0_767822);
  Py_CLEAR(clear_module_state->__pyx_float_0_770914);
  Py_CLEAR(clear_module_state->__pyx_float_0_772852);
  Py_CLEAR(clear_module_state->__pyx_float_0_773980);
  Py_CLEAR(clear_module_state->__pyx_float_0_777018);
  Py_CLEAR(clear_module_state->__pyx_float_0_780029);
  Py_CLEAR(clear_module_state->__pyx_float_0_783011);
  Py_CLEAR(clear_module_state->__pyx_float_0_783315);
  Py_CLEAR(clear_module_state->__pyx_float_0_785964);
  Py_CLEAR(clear_module_state->__pyx_float_0_788888);
  Py_CLEAR(clear_module_state->__pyx_float_0_791781);
  Py_CLEAR(clear_module_state->__pyx_float_0_793760);
  Py_CLEAR(clear_module_state->__pyx_float_0_794644);
  Py_CLEAR(clear_module_state->__pyx_float_0_797475);
  Py_CLEAR(clear_module_state->__pyx_float_0_800275);
  Py_CLEAR(clear_module_state->__pyx_float_0_803041);
  Py_CLEAR(clear_module_state->__pyx_float_0_804182);
  Py_CLEAR(clear_module_state->__pyx_float_0_805774);
  Py_CLEAR(clear_module_state->__pyx_float_0_808473);
  Py_CLEAR(clear_module_state->__pyx_float_0_811138);
  Py_CLEAR(clear_module_state->__pyx_float_0_813768);
  Py_CLEAR(clear_module_state->__pyx_float_0_814576);
  Py_CLEAR(clear_module_state->__pyx_float_0_816363);
  Py_CLEAR(clear_module_state->__pyx_float_0_818921);
  Py_CLEAR(clear_module_state->__pyx_float_0_821444);
  Py_CLEAR(clear_module_state->__pyx_float_0_823929);
  Py_CLEAR(clear_module_state->__pyx_float_0_824940);
  Py_CLEAR(clear_module_state->__pyx_float_0_826376);
  Py_CLEAR(clear_module_state->__pyx_float_0_828786);
  Py_CLEAR(clear_module_state->__pyx_float_0_831158);
  Py_CLEAR(clear_module_state->__pyx_float_0_833491);
  Py_CLEAR(clear_module_state->__pyx_float_0_835270);
  Py_CLEAR(clear_module_state->__pyx_float_0_835785);
  Py_CLEAR(clear_module_state->__pyx_float_0_838039);
  Py_CLEAR(clear_module_state->__pyx_float_0_840254);
  Py_CLEAR(clear_module_state->__pyx_float_0_842430);
  Py_CLEAR(clear_module_state->__pyx_float_0_844566);
  Py_CLEAR(clear_module_state->__pyx_float_0_845561);
  Py_CLEAR(clear_module_state->__pyx_float_0_846661);
  Py_CLEAR(clear_module_state->__pyx_float_0_848717);
  Py_CLEAR(clear_module_state->__pyx_float_0_850733);
  Py_CLEAR(clear_module_state->__pyx_float_0_852709);
  Py_CLEAR(clear_module_state->__pyx_float_0_854645);
  Py_CLEAR(clear_module_state->__pyx_float_0_855810);
  Py_CLEAR(clear_module_state->__pyx_float_0_856542);
  Py_CLEAR(clear_module_state->__pyx_float_0_858400);
  Py_CLEAR(clear_module_state->__pyx_float_0_860219);
  Py_CLEAR(clear_module_state->__pyx_float_0_861999);
  Py_CLEAR(clear_module_state->__pyx_float_0_863742);
  Py_CLEAR(clear_module_state->__pyx_float_0_865448);
  Py_CLEAR(clear_module_state->__pyx_float_0_866013);
  Py_CLEAR(clear_module_state->__pyx_float_0_867117);
  Py_CLEAR(clear_module_state->__pyx_float_0_868751);
  Py_CLEAR(clear_module_state->__pyx_float_0_870350);
  Py_CLEAR(clear_module_state->__pyx_float_0_871916);
  Py_CLEAR(clear_module_state->__pyx_float_0_873449);
  Py_CLEAR(clear_module_state->__pyx_float_0_874951);
  Py_CLEAR(clear_module_state->__pyx_float_0_876168);
  Py_CLEAR(clear_module_state->__pyx_float_0_876424);
  Py_CLEAR(clear_module_state->__pyx_float_0_877868);
  Py_CLEAR(clear_module_state->__pyx_float_0_879285);
  Py_CLEAR(clear_module_state->__pyx_float_0_880678);
  Py_CLEAR(clear_module_state->__pyx_float_0_882046);
  Py_CLEAR(clear_module_state->__pyx_float_0_883393);
  Py_CLEAR(clear_module_state->__pyx_float_0_884720);
  Py_CLEAR(clear_module_state->__pyx_float_0_886029);
  Py_CLEAR(clear_module_state->__pyx_float_0_886271);
  Py_CLEAR(clear_module_state->__pyx_float_0_887322);
  Py_CLEAR(clear_module_state->__pyx_float_0_888601);
  Py_CLEAR(clear_module_state->__pyx_float_0_889868);
  Py_CLEAR(clear_module_state->__pyx_float_0_891125);
  Py_CLEAR(clear_module_state->__pyx_float_0_892374);
  Py_CLEAR(clear_module_state->__pyx_float_0_893616);
  Py_CLEAR(clear_module_state->__pyx_float_0_894855);
  Py_CLEAR(clear_module_state->__pyx_float_0_896091);
  Py_CLEAR(clear_module_state->__pyx_float_0_896320);
  Py_CLEAR(clear_module_state->__pyx_float_0_897330);
  Py_CLEAR(clear_module_state->__pyx_float_0_898570);
  Py_CLEAR(clear_module_state->__pyx_float_0_899815);
  Py_CLEAR(clear_module_state->__pyx_float_0_901065);
  Py_CLEAR(clear_module_state->__pyx_float_0_902323);
  Py_CLEAR(clear_module_state->__pyx_float_0_903590);
  Py_CLEAR(clear_module_state->__pyx_float_0_904867);
  Py_CLEAR(clear_module_state->__pyx_float_0_906157);
  Py_CLEAR(clear_module_state->__pyx_float_0_906311);
  Py_CLEAR(clear_module_state->__pyx_float_0_916242);
  Py_CLEAR(clear_module_state->__pyx_float_0_926106);
  Py_CLEAR(clear_module_state->__pyx_float_0_935904);
  Py_CLEAR(clear_module_state->__pyx_float_0_945636);
  Py_CLEAR(clear_module_state->__pyx_float_0_955300);
  Py_CLEAR(clear_module_state->__pyx_float_0_964894);
  Py_CLEAR(clear_module_state->__pyx_float_0_974417);
  Py_CLEAR(clear_module_state->__pyx_float_0_983868);
  Py_CLEAR(clear_module_state->__pyx_float_0_993248);
  Py_CLEAR(clear_module_state->__pyx_float_0_032852381);
  Py_CLEAR(clear_module_state->__pyx_float_0_079347619);
  Py_CLEAR(clear_module_state->__pyx_float_0_147452381);
  Py_CLEAR(clear_module_state->__pyx_float_0_196652381);
  Py_CLEAR(clear_module_state->__pyx_float_0_212252381);
  Py_CLEAR(clear_module_state->__pyx_float_0_240347619);
  Py_CLEAR(clear_module_state->__pyx_float_0_266647619);
  Py_CLEAR(clear_module_state->__pyx_float_0_609852381);
  Py_CLEAR(clear_module_state->__pyx_float_0_743552381);
  Py_CLEAR(clear_module_state->__pyx_float_0_779247619);
  Py_CLEAR(clear_module_state->__pyx_float_0_819852381);
  Py_CLEAR(clear_module_state->__pyx_float_0_0059571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_0116952381);
  Py_CLEAR(clear_module_state->__pyx_float_0_0165142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_0227714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_0230904762);
  Py_CLEAR(clear_module_state->__pyx_float_0_0238904762);
  Py_CLEAR(clear_module_state->__pyx_float_0_0266619048);
  Py_CLEAR(clear_module_state->__pyx_float_0_0343428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_0383714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_0487714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_0498142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_0589714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_0591333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_0629333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_0640571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_0722666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_0749428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_0755333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_0779428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_0948380952);
  Py_CLEAR(clear_module_state->__pyx_float_0_1132428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_1132952381);
  Py_CLEAR(clear_module_state->__pyx_float_0_1252714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_1452714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_1633142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_1707285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_1793666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_1801333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_1897809524);
  Py_CLEAR(clear_module_state->__pyx_float_0_1959047619);
  Py_CLEAR(clear_module_state->__pyx_float_0_2116238095);
  Py_CLEAR(clear_module_state->__pyx_float_0_2137714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_2164142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_2178285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_2586428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_2644571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_2886428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_2919380952);
  Py_CLEAR(clear_module_state->__pyx_float_0_3021714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_3062761905);
  Py_CLEAR(clear_module_state->__pyx_float_0_3242428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_3360285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_3481666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_3497904762);
  Py_CLEAR(clear_module_state->__pyx_float_0_3598333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_3632714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_3768142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_3875095238);
  Py_CLEAR(clear_module_state->__pyx_float_0_3904761905);
  Py_CLEAR(clear_module_state->__pyx_float_0_3952571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_4044333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_4086142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_4336857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_4420095238);
  Py_CLEAR(clear_module_state->__pyx_float_0_4430428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_4493904762);
  Py_CLEAR(clear_module_state->__pyx_float_0_4585714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_4661142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_4736904762);
  Py_CLEAR(clear_module_state->__pyx_float_0_4839761905);
  Py_CLEAR(clear_module_state->__pyx_float_0_4871238095);
  Py_CLEAR(clear_module_state->__pyx_float_0_4886666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_5033142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_5039857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_5200238095);
  Py_CLEAR(clear_module_state->__pyx_float_0_5244428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_5300285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_5375428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_5472666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_5569857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_5708571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_5711857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_5772238095);
  Py_CLEAR(clear_module_state->__pyx_float_0_5776761905);
  Py_CLEAR(clear_module_state->__pyx_float_0_5954285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_5965809524);
  Py_CLEAR(clear_module_state->__pyx_float_0_6192619048);
  Py_CLEAR(clear_module_state->__pyx_float_0_6269714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_6286619048);
  Py_CLEAR(clear_module_state->__pyx_float_0_6417857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_6424333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_6534857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_6641952381);
  Py_CLEAR(clear_module_state->__pyx_float_0_6646285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_6742714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_6770857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_6834190476);
  Py_CLEAR(clear_module_state->__pyx_float_0_6837571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_6858571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_6928333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_7061666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_7097571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_7176571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_7184095238);
  Py_CLEAR(clear_module_state->__pyx_float_0_7250428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_7253857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_7257857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_7261142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_7274333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_7313952381);
  Py_CLEAR(clear_module_state->__pyx_float_0_7317142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_7327333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_7355666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_7376047619);
  Py_CLEAR(clear_module_state->__pyx_float_0_7411333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_7424333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_7434761905);
  Py_CLEAR(clear_module_state->__pyx_float_0_7454571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_7473142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_7480809524);
  Py_CLEAR(clear_module_state->__pyx_float_0_7485190476);
  Py_CLEAR(clear_module_state->__pyx_float_0_7490619048);
  Py_CLEAR(clear_module_state->__pyx_float_0_7491142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_7524857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_7607190476);
  Py_CLEAR(clear_module_state->__pyx_float_0_7653142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_7767571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_7858428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_7860571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_7912666667);
  Py_CLEAR(clear_module_state->__pyx_float_0_8037619048);
  Py_CLEAR(clear_module_state->__pyx_float_0_8185047619);
  Py_CLEAR(clear_module_state->__pyx_float_0_8228285714);
  Py_CLEAR(clear_module_state->__pyx_float_0_8239571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_8262714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_8271428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_8302714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_8311809524);
  Py_CLEAR(clear_module_state->__pyx_float_0_8383714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_8481380952);
  Py_CLEAR(clear_module_state->__pyx_float_0_8506571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_8554380952);
  Py_CLEAR(clear_module_state->__pyx_float_0_8640571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_8683333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_8705142857);
  Py_CLEAR(clear_module_state->__pyx_float_0_8719571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_8786333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_8819571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_8824333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_8828428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_9139333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_9218333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_9449571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_9514428571);
  Py_CLEAR(clear_module_state->__pyx_float_0_9588714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_9598238095);
  Py_CLEAR(clear_module_state->__pyx_float_0_9625857143);
  Py_CLEAR(clear_module_state->__pyx_float_0_9738952381);
  Py_CLEAR(clear_module_state->__pyx_float_0_9788571429);
  Py_CLEAR(clear_module_state->__pyx_float_0_9937714286);
  Py_CLEAR(clear_module_state->__pyx_float_0_9955333333);
  Py_CLEAR(clear_module_state->__pyx_float_0_9990428571);
  return 0;
}
#endif

#if CYTHON_USE_MODULE_STATE
static int __pyx_m_traverse(PyObject *m, visitproc visit, void *arg) {
  __pyx_mstate *traverse_module_state = __pyx_mstate(m);
  if (!traverse_module_state) return 0;
  Py_VISIT(traverse_module_state->__pyx_d);
  Py_VISIT(traverse_module_state->__pyx_b);
  Py_VISIT(traverse_module_state->__pyx_cython_runtime);
  Py_VISIT(traverse_module_state->__pyx_empty_tuple);
  Py_VISIT(traverse_module_state->__pyx_empty_bytes);
  Py_VISIT(traverse_module_state->__pyx_empty_unicode);
  #ifdef __Pyx_CyFunction_USED
  Py_VISIT(traverse_module_state->__pyx_CyFunctionType);
  #endif
  #ifdef __Pyx_FusedFunction_USED
  Py_VISIT(traverse_module_state->__pyx_FusedFunctionType);
  #endif
  Py_VISIT(traverse_module_state->__pyx_n_s_);
  Py_VISIT(traverse_module_state->__pyx_n_s_ListedColormap);
  Py_VISIT(traverse_module_state->__pyx_kp_u__2);
  Py_VISIT(traverse_module_state->__pyx_n_s__3);
  Py_VISIT(traverse_module_state->__pyx_n_s_all);
  Py_VISIT(traverse_module_state->__pyx_n_s_cline_in_traceback);
  Py_VISIT(traverse_module_state->__pyx_n_s_cmaps);
  Py_VISIT(traverse_module_state->__pyx_n_s_data);
  Py_VISIT(traverse_module_state->__pyx_n_s_import);
  Py_VISIT(traverse_module_state->__pyx_n_s_initializing);
  Py_VISIT(traverse_module_state->__pyx_n_s_main);
  Py_VISIT(traverse_module_state->__pyx_n_s_matplotlib_colors);
  Py_VISIT(traverse_module_state->__pyx_n_s_name);
  Py_VISIT(traverse_module_state->__pyx_n_s_name_2);
  Py_VISIT(traverse_module_state->__pyx_n_s_parula);
  Py_VISIT(traverse_module_state->__pyx_n_u_parula);
  Py_VISIT(traverse_module_state->__pyx_n_s_parula_data);
  Py_VISIT(traverse_module_state->__pyx_n_s_spec);
  Py_VISIT(traverse_module_state->__pyx_n_s_test);
  Py_VISIT(traverse_module_state->__pyx_n_s_th);
  Py_VISIT(traverse_module_state->__pyx_n_s_torch);
  Py_VISIT(traverse_module_state->__pyx_n_s_viridis);
  Py_VISIT(traverse_module_state->__pyx_n_u_viridis);
  Py_VISIT(traverse_module_state->__pyx_n_s_viridis_data);
  Py_VISIT(traverse_module_state->__pyx_float_0_988);
  Py_VISIT(traverse_module_state->__pyx_float_0_0265);
  Py_VISIT(traverse_module_state->__pyx_float_0_0538);
  Py_VISIT(traverse_module_state->__pyx_float_0_0843);
  Py_VISIT(traverse_module_state->__pyx_float_0_1309);
  Py_VISIT(traverse_module_state->__pyx_float_0_1663);
  Py_VISIT(traverse_module_state->__pyx_float_0_2081);
  Py_VISIT(traverse_module_state->__pyx_float_0_2386);
  Py_VISIT(traverse_module_state->__pyx_float_0_3217);
  Py_VISIT(traverse_module_state->__pyx_float_0_4188);
  Py_VISIT(traverse_module_state->__pyx_float_0_4266);
  Py_VISIT(traverse_module_state->__pyx_float_0_5292);
  Py_VISIT(traverse_module_state->__pyx_float_0_6137);
  Py_VISIT(traverse_module_state->__pyx_float_0_6473);
  Py_VISIT(traverse_module_state->__pyx_float_0_7015);
  Py_VISIT(traverse_module_state->__pyx_float_0_7279);
  Py_VISIT(traverse_module_state->__pyx_float_0_7299);
  Py_VISIT(traverse_module_state->__pyx_float_0_7384);
  Py_VISIT(traverse_module_state->__pyx_float_0_7456);
  Py_VISIT(traverse_module_state->__pyx_float_0_7459);
  Py_VISIT(traverse_module_state->__pyx_float_0_8066);
  Py_VISIT(traverse_module_state->__pyx_float_0_8135);
  Py_VISIT(traverse_module_state->__pyx_float_0_8467);
  Py_VISIT(traverse_module_state->__pyx_float_0_8949);
  Py_VISIT(traverse_module_state->__pyx_float_0_9661);
  Py_VISIT(traverse_module_state->__pyx_float_0_9697);
  Py_VISIT(traverse_module_state->__pyx_float_0_9763);
  Py_VISIT(traverse_module_state->__pyx_float_0_9831);
  Py_VISIT(traverse_module_state->__pyx_float_0_004874);
  Py_VISIT(traverse_module_state->__pyx_float_0_009605);
  Py_VISIT(traverse_module_state->__pyx_float_0_014625);
  Py_VISIT(traverse_module_state->__pyx_float_0_019942);
  Py_VISIT(traverse_module_state->__pyx_float_0_025563);
  Py_VISIT(traverse_module_state->__pyx_float_0_031497);
  Py_VISIT(traverse_module_state->__pyx_float_0_037752);
  Py_VISIT(traverse_module_state->__pyx_float_0_044167);
  Py_VISIT(traverse_module_state->__pyx_float_0_050344);
  Py_VISIT(traverse_module_state->__pyx_float_0_056324);
  Py_VISIT(traverse_module_state->__pyx_float_0_062145);
  Py_VISIT(traverse_module_state->__pyx_float_0_067836);
  Py_VISIT(traverse_module_state->__pyx_float_0_073417);
  Py_VISIT(traverse_module_state->__pyx_float_0_078907);
  Py_VISIT(traverse_module_state->__pyx_float_0_084320);
  Py_VISIT(traverse_module_state->__pyx_float_0_089666);
  Py_VISIT(traverse_module_state->__pyx_float_0_094955);
  Py_VISIT(traverse_module_state->__pyx_float_0_095250);
  Py_VISIT(traverse_module_state->__pyx_float_0_095374);
  Py_VISIT(traverse_module_state->__pyx_float_0_095953);
  Py_VISIT(traverse_module_state->__pyx_float_0_096335);
  Py_VISIT(traverse_module_state->__pyx_float_0_097452);
  Py_VISIT(traverse_module_state->__pyx_float_0_098125);
  Py_VISIT(traverse_module_state->__pyx_float_0_099702);
  Py_VISIT(traverse_module_state->__pyx_float_0_100196);
  Py_VISIT(traverse_module_state->__pyx_float_0_100717);
  Py_VISIT(traverse_module_state->__pyx_float_0_102646);
  Py_VISIT(traverse_module_state->__pyx_float_0_104071);
  Py_VISIT(traverse_module_state->__pyx_float_0_105393);
  Py_VISIT(traverse_module_state->__pyx_float_0_106217);
  Py_VISIT(traverse_module_state->__pyx_float_0_108131);
  Py_VISIT(traverse_module_state->__pyx_float_0_110347);
  Py_VISIT(traverse_module_state->__pyx_float_0_110553);
  Py_VISIT(traverse_module_state->__pyx_float_0_112838);
  Py_VISIT(traverse_module_state->__pyx_float_0_114965);
  Py_VISIT(traverse_module_state->__pyx_float_0_115680);
  Py_VISIT(traverse_module_state->__pyx_float_0_118128);
  Py_VISIT(traverse_module_state->__pyx_float_0_119423);
  Py_VISIT(traverse_module_state->__pyx_float_0_119483);
  Py_VISIT(traverse_module_state->__pyx_float_0_119512);
  Py_VISIT(traverse_module_state->__pyx_float_0_119699);
  Py_VISIT(traverse_module_state->__pyx_float_0_119738);
  Py_VISIT(traverse_module_state->__pyx_float_0_120005);
  Py_VISIT(traverse_module_state->__pyx_float_0_120081);
  Py_VISIT(traverse_module_state->__pyx_float_0_120092);
  Py_VISIT(traverse_module_state->__pyx_float_0_120565);
  Py_VISIT(traverse_module_state->__pyx_float_0_120638);
  Py_VISIT(traverse_module_state->__pyx_float_0_120777);
  Py_VISIT(traverse_module_state->__pyx_float_0_121148);
  Py_VISIT(traverse_module_state->__pyx_float_0_121380);
  Py_VISIT(traverse_module_state->__pyx_float_0_121831);
  Py_VISIT(traverse_module_state->__pyx_float_0_122312);
  Py_VISIT(traverse_module_state->__pyx_float_0_122606);
  Py_VISIT(traverse_module_state->__pyx_float_0_123444);
  Py_VISIT(traverse_module_state->__pyx_float_0_123463);
  Py_VISIT(traverse_module_state->__pyx_float_0_123941);
  Py_VISIT(traverse_module_state->__pyx_float_0_124395);
  Py_VISIT(traverse_module_state->__pyx_float_0_124780);
  Py_VISIT(traverse_module_state->__pyx_float_0_125394);
  Py_VISIT(traverse_module_state->__pyx_float_0_125405);
  Py_VISIT(traverse_module_state->__pyx_float_0_125848);
  Py_VISIT(traverse_module_state->__pyx_float_0_126326);
  Py_VISIT(traverse_module_state->__pyx_float_0_126453);
  Py_VISIT(traverse_module_state->__pyx_float_0_127568);
  Py_VISIT(traverse_module_state->__pyx_float_0_128087);
  Py_VISIT(traverse_module_state->__pyx_float_0_128729);
  Py_VISIT(traverse_module_state->__pyx_float_0_129933);
  Py_VISIT(traverse_module_state->__pyx_float_0_130067);
  Py_VISIT(traverse_module_state->__pyx_float_0_130215);
  Py_VISIT(traverse_module_state->__pyx_float_0_130895);
  Py_VISIT(traverse_module_state->__pyx_float_0_131109);
  Py_VISIT(traverse_module_state->__pyx_float_0_131172);
  Py_VISIT(traverse_module_state->__pyx_float_0_132268);
  Py_VISIT(traverse_module_state->__pyx_float_0_132444);
  Py_VISIT(traverse_module_state->__pyx_float_0_133743);
  Py_VISIT(traverse_module_state->__pyx_float_0_134692);
  Py_VISIT(traverse_module_state->__pyx_float_0_135066);
  Py_VISIT(traverse_module_state->__pyx_float_0_135920);
  Py_VISIT(traverse_module_state->__pyx_float_0_136408);
  Py_VISIT(traverse_module_state->__pyx_float_0_136897);
  Py_VISIT(traverse_module_state->__pyx_float_0_137064);
  Py_VISIT(traverse_module_state->__pyx_float_0_137339);
  Py_VISIT(traverse_module_state->__pyx_float_0_137770);
  Py_VISIT(traverse_module_state->__pyx_float_0_139147);
  Py_VISIT(traverse_module_state->__pyx_float_0_140210);
  Py_VISIT(traverse_module_state->__pyx_float_0_140536);
  Py_VISIT(traverse_module_state->__pyx_float_0_140926);
  Py_VISIT(traverse_module_state->__pyx_float_0_141935);
  Py_VISIT(traverse_module_state->__pyx_float_0_143228);
  Py_VISIT(traverse_module_state->__pyx_float_0_143303);
  Py_VISIT(traverse_module_state->__pyx_float_0_143343);
  Py_VISIT(traverse_module_state->__pyx_float_0_143936);
  Py_VISIT(traverse_module_state->__pyx_float_0_144759);
  Py_VISIT(traverse_module_state->__pyx_float_0_145912);
  Py_VISIT(traverse_module_state->__pyx_float_0_146180);
  Py_VISIT(traverse_module_state->__pyx_float_0_146616);
  Py_VISIT(traverse_module_state->__pyx_float_0_147607);
  Py_VISIT(traverse_module_state->__pyx_float_0_149039);
  Py_VISIT(traverse_module_state->__pyx_float_0_149561);
  Py_VISIT(traverse_module_state->__pyx_float_0_150148);
  Py_VISIT(traverse_module_state->__pyx_float_0_150476);
  Py_VISIT(traverse_module_state->__pyx_float_0_150881);
  Py_VISIT(traverse_module_state->__pyx_float_0_151918);
  Py_VISIT(traverse_module_state->__pyx_float_0_153364);
  Py_VISIT(traverse_module_state->__pyx_float_0_153894);
  Py_VISIT(traverse_module_state->__pyx_float_0_154815);
  Py_VISIT(traverse_module_state->__pyx_float_0_155834);
  Py_VISIT(traverse_module_state->__pyx_float_0_156029);
  Py_VISIT(traverse_module_state->__pyx_float_0_156270);
  Py_VISIT(traverse_module_state->__pyx_float_0_157729);
  Py_VISIT(traverse_module_state->__pyx_float_0_157851);
  Py_VISIT(traverse_module_state->__pyx_float_0_159194);
  Py_VISIT(traverse_module_state->__pyx_float_0_160665);
  Py_VISIT(traverse_module_state->__pyx_float_0_160771);
  Py_VISIT(traverse_module_state->__pyx_float_0_162016);
  Py_VISIT(traverse_module_state->__pyx_float_0_162142);
  Py_VISIT(traverse_module_state->__pyx_float_0_162603);
  Py_VISIT(traverse_module_state->__pyx_float_0_163625);
  Py_VISIT(traverse_module_state->__pyx_float_0_165117);
  Py_VISIT(traverse_module_state->__pyx_float_0_165693);
  Py_VISIT(traverse_module_state->__pyx_float_0_166383);
  Py_VISIT(traverse_module_state->__pyx_float_0_166617);
  Py_VISIT(traverse_module_state->__pyx_float_0_168126);
  Py_VISIT(traverse_module_state->__pyx_float_0_169257);
  Py_VISIT(traverse_module_state->__pyx_float_0_169646);
  Py_VISIT(traverse_module_state->__pyx_float_0_170599);
  Py_VISIT(traverse_module_state->__pyx_float_0_170948);
  Py_VISIT(traverse_module_state->__pyx_float_0_171176);
  Py_VISIT(traverse_module_state->__pyx_float_0_172719);
  Py_VISIT(traverse_module_state->__pyx_float_0_174274);
  Py_VISIT(traverse_module_state->__pyx_float_0_175490);
  Py_VISIT(traverse_module_state->__pyx_float_0_175707);
  Py_VISIT(traverse_module_state->__pyx_float_0_175841);
  Py_VISIT(traverse_module_state->__pyx_float_0_175971);
  Py_VISIT(traverse_module_state->__pyx_float_0_177423);
  Py_VISIT(traverse_module_state->__pyx_float_0_179019);
  Py_VISIT(traverse_module_state->__pyx_float_0_180367);
  Py_VISIT(traverse_module_state->__pyx_float_0_180629);
  Py_VISIT(traverse_module_state->__pyx_float_0_180653);
  Py_VISIT(traverse_module_state->__pyx_float_0_182256);
  Py_VISIT(traverse_module_state->__pyx_float_0_182725);
  Py_VISIT(traverse_module_state->__pyx_float_0_183898);
  Py_VISIT(traverse_module_state->__pyx_float_0_185228);
  Py_VISIT(traverse_module_state->__pyx_float_0_185556);
  Py_VISIT(traverse_module_state->__pyx_float_0_185783);
  Py_VISIT(traverse_module_state->__pyx_float_0_187231);
  Py_VISIT(traverse_module_state->__pyx_float_0_188923);
  Py_VISIT(traverse_module_state->__pyx_float_0_189503);
  Py_VISIT(traverse_module_state->__pyx_float_0_190074);
  Py_VISIT(traverse_module_state->__pyx_float_0_190631);
  Py_VISIT(traverse_module_state->__pyx_float_0_191090);
  Py_VISIT(traverse_module_state->__pyx_float_0_192357);
  Py_VISIT(traverse_module_state->__pyx_float_0_194100);
  Py_VISIT(traverse_module_state->__pyx_float_0_194905);
  Py_VISIT(traverse_module_state->__pyx_float_0_195860);
  Py_VISIT(traverse_module_state->__pyx_float_0_196293);
  Py_VISIT(traverse_module_state->__pyx_float_0_196571);
  Py_VISIT(traverse_module_state->__pyx_float_0_197636);
  Py_VISIT(traverse_module_state->__pyx_float_0_199430);
  Py_VISIT(traverse_module_state->__pyx_float_0_199721);
  Py_VISIT(traverse_module_state->__pyx_float_0_201239);
  Py_VISIT(traverse_module_state->__pyx_float_0_202219);
  Py_VISIT(traverse_module_state->__pyx_float_0_203063);
  Py_VISIT(traverse_module_state->__pyx_float_0_203082);
  Py_VISIT(traverse_module_state->__pyx_float_0_204520);
  Py_VISIT(traverse_module_state->__pyx_float_0_204903);
  Py_VISIT(traverse_module_state->__pyx_float_0_206756);
  Py_VISIT(traverse_module_state->__pyx_float_0_208030);
  Py_VISIT(traverse_module_state->__pyx_float_0_208623);
  Py_VISIT(traverse_module_state->__pyx_float_0_209303);
  Py_VISIT(traverse_module_state->__pyx_float_0_209861);
  Py_VISIT(traverse_module_state->__pyx_float_0_210503);
  Py_VISIT(traverse_module_state->__pyx_float_0_212395);
  Py_VISIT(traverse_module_state->__pyx_float_0_214000);
  Py_VISIT(traverse_module_state->__pyx_float_0_214069);
  Py_VISIT(traverse_module_state->__pyx_float_0_214298);
  Py_VISIT(traverse_module_state->__pyx_float_0_216210);
  Py_VISIT(traverse_module_state->__pyx_float_0_216620);
  Py_VISIT(traverse_module_state->__pyx_float_0_218130);
  Py_VISIT(traverse_module_state->__pyx_float_0_218818);
  Py_VISIT(traverse_module_state->__pyx_float_0_220057);
  Py_VISIT(traverse_module_state->__pyx_float_0_220124);
  Py_VISIT(traverse_module_state->__pyx_float_0_221989);
  Py_VISIT(traverse_module_state->__pyx_float_0_223353);
  Py_VISIT(traverse_module_state->__pyx_float_0_223549);
  Py_VISIT(traverse_module_state->__pyx_float_0_223925);
  Py_VISIT(traverse_module_state->__pyx_float_0_225863);
  Py_VISIT(traverse_module_state->__pyx_float_0_226397);
  Py_VISIT(traverse_module_state->__pyx_float_0_227802);
  Py_VISIT(traverse_module_state->__pyx_float_0_228262);
  Py_VISIT(traverse_module_state->__pyx_float_0_229739);
  Py_VISIT(traverse_module_state->__pyx_float_0_230052);
  Py_VISIT(traverse_module_state->__pyx_float_0_231674);
  Py_VISIT(traverse_module_state->__pyx_float_0_232815);
  Py_VISIT(traverse_module_state->__pyx_float_0_232956);
  Py_VISIT(traverse_module_state->__pyx_float_0_233603);
  Py_VISIT(traverse_module_state->__pyx_float_0_235526);
  Py_VISIT(traverse_module_state->__pyx_float_0_236712);
  Py_VISIT(traverse_module_state->__pyx_float_0_237441);
  Py_VISIT(traverse_module_state->__pyx_float_0_237631);
  Py_VISIT(traverse_module_state->__pyx_float_0_239346);
  Py_VISIT(traverse_module_state->__pyx_float_0_239374);
  Py_VISIT(traverse_module_state->__pyx_float_0_241237);
  Py_VISIT(traverse_module_state->__pyx_float_0_242286);
  Py_VISIT(traverse_module_state->__pyx_float_0_243113);
  Py_VISIT(traverse_module_state->__pyx_float_0_243329);
  Py_VISIT(traverse_module_state->__pyx_float_0_244972);
  Py_VISIT(traverse_module_state->__pyx_float_0_246070);
  Py_VISIT(traverse_module_state->__pyx_float_0_246811);
  Py_VISIT(traverse_module_state->__pyx_float_0_246922);
  Py_VISIT(traverse_module_state->__pyx_float_0_248629);
  Py_VISIT(traverse_module_state->__pyx_float_0_249897);
  Py_VISIT(traverse_module_state->__pyx_float_0_250425);
  Py_VISIT(traverse_module_state->__pyx_float_0_251537);
  Py_VISIT(traverse_module_state->__pyx_float_0_252194);
  Py_VISIT(traverse_module_state->__pyx_float_0_252899);
  Py_VISIT(traverse_module_state->__pyx_float_0_253935);
  Py_VISIT(traverse_module_state->__pyx_float_0_255645);
  Py_VISIT(traverse_module_state->__pyx_float_0_256130);
  Py_VISIT(traverse_module_state->__pyx_float_0_256415);
  Py_VISIT(traverse_module_state->__pyx_float_0_257322);
  Py_VISIT(traverse_module_state->__pyx_float_0_258965);
  Py_VISIT(traverse_module_state->__pyx_float_0_259857);
  Py_VISIT(traverse_module_state->__pyx_float_0_260571);
  Py_VISIT(traverse_module_state->__pyx_float_0_260703);
  Py_VISIT(traverse_module_state->__pyx_float_0_262138);
  Py_VISIT(traverse_module_state->__pyx_float_0_262877);
  Py_VISIT(traverse_module_state->__pyx_float_0_263663);
  Py_VISIT(traverse_module_state->__pyx_float_0_265145);
  Py_VISIT(traverse_module_state->__pyx_float_0_265254);
  Py_VISIT(traverse_module_state->__pyx_float_0_266580);
  Py_VISIT(traverse_module_state->__pyx_float_0_266941);
  Py_VISIT(traverse_module_state->__pyx_float_0_267004);
  Py_VISIT(traverse_module_state->__pyx_float_0_267968);
  Py_VISIT(traverse_module_state->__pyx_float_0_268510);
  Py_VISIT(traverse_module_state->__pyx_float_0_269281);
  Py_VISIT(traverse_module_state->__pyx_float_0_269308);
  Py_VISIT(traverse_module_state->__pyx_float_0_269783);
  Py_VISIT(traverse_module_state->__pyx_float_0_269944);
  Py_VISIT(traverse_module_state->__pyx_float_0_270595);
  Py_VISIT(traverse_module_state->__pyx_float_0_271305);
  Py_VISIT(traverse_module_state->__pyx_float_0_271828);
  Py_VISIT(traverse_module_state->__pyx_float_0_272594);
  Py_VISIT(traverse_module_state->__pyx_float_0_273006);
  Py_VISIT(traverse_module_state->__pyx_float_0_273809);
  Py_VISIT(traverse_module_state->__pyx_float_0_274128);
  Py_VISIT(traverse_module_state->__pyx_float_0_274149);
  Py_VISIT(traverse_module_state->__pyx_float_0_274290);
  Py_VISIT(traverse_module_state->__pyx_float_0_274952);
  Py_VISIT(traverse_module_state->__pyx_float_0_275191);
  Py_VISIT(traverse_module_state->__pyx_float_0_275626);
  Py_VISIT(traverse_module_state->__pyx_float_0_276022);
  Py_VISIT(traverse_module_state->__pyx_float_0_276194);
  Py_VISIT(traverse_module_state->__pyx_float_0_277018);
  Py_VISIT(traverse_module_state->__pyx_float_0_277134);
  Py_VISIT(traverse_module_state->__pyx_float_0_277941);
  Py_VISIT(traverse_module_state->__pyx_float_0_278012);
  Py_VISIT(traverse_module_state->__pyx_float_0_278775);
  Py_VISIT(traverse_module_state->__pyx_float_0_278791);
  Py_VISIT(traverse_module_state->__pyx_float_0_278826);
  Py_VISIT(traverse_module_state->__pyx_float_0_279566);
  Py_VISIT(traverse_module_state->__pyx_float_0_279574);
  Py_VISIT(traverse_module_state->__pyx_float_0_280255);
  Py_VISIT(traverse_module_state->__pyx_float_0_280267);
  Py_VISIT(traverse_module_state->__pyx_float_0_280868);
  Py_VISIT(traverse_module_state->__pyx_float_0_280894);
  Py_VISIT(traverse_module_state->__pyx_float_0_281412);
  Py_VISIT(traverse_module_state->__pyx_float_0_281446);
  Py_VISIT(traverse_module_state->__pyx_float_0_281477);
  Py_VISIT(traverse_module_state->__pyx_float_0_281887);
  Py_VISIT(traverse_module_state->__pyx_float_0_281908);
  Py_VISIT(traverse_module_state->__pyx_float_0_281924);
  Py_VISIT(traverse_module_state->__pyx_float_0_282290);
  Py_VISIT(traverse_module_state->__pyx_float_0_282327);
  Py_VISIT(traverse_module_state->__pyx_float_0_282623);
  Py_VISIT(traverse_module_state->__pyx_float_0_282656);
  Py_VISIT(traverse_module_state->__pyx_float_0_282884);
  Py_VISIT(traverse_module_state->__pyx_float_0_282910);
  Py_VISIT(traverse_module_state->__pyx_float_0_283072);
  Py_VISIT(traverse_module_state->__pyx_float_0_283091);
  Py_VISIT(traverse_module_state->__pyx_float_0_283187);
  Py_VISIT(traverse_module_state->__pyx_float_0_283197);
  Py_VISIT(traverse_module_state->__pyx_float_0_283229);
  Py_VISIT(traverse_module_state->__pyx_float_0_283237);
  Py_VISIT(traverse_module_state->__pyx_float_0_287675);
  Py_VISIT(traverse_module_state->__pyx_float_0_288127);
  Py_VISIT(traverse_module_state->__pyx_float_0_288921);
  Py_VISIT(traverse_module_state->__pyx_float_0_292092);
  Py_VISIT(traverse_module_state->__pyx_float_0_294279);
  Py_VISIT(traverse_module_state->__pyx_float_0_296479);
  Py_VISIT(traverse_module_state->__pyx_float_0_296485);
  Py_VISIT(traverse_module_state->__pyx_float_0_300362);
  Py_VISIT(traverse_module_state->__pyx_float_0_300855);
  Py_VISIT(traverse_module_state->__pyx_float_0_304148);
  Py_VISIT(traverse_module_state->__pyx_float_0_305202);
  Py_VISIT(traverse_module_state->__pyx_float_0_306377);
  Py_VISIT(traverse_module_state->__pyx_float_0_309527);
  Py_VISIT(traverse_module_state->__pyx_float_0_311925);
  Py_VISIT(traverse_module_state->__pyx_float_0_312321);
  Py_VISIT(traverse_module_state->__pyx_float_0_313828);
  Py_VISIT(traverse_module_state->__pyx_float_0_318106);
  Py_VISIT(traverse_module_state->__pyx_float_0_318195);
  Py_VISIT(traverse_module_state->__pyx_float_0_319809);
  Py_VISIT(traverse_module_state->__pyx_float_0_322361);
  Py_VISIT(traverse_module_state->__pyx_float_0_323998);
  Py_VISIT(traverse_module_state->__pyx_float_0_326594);
  Py_VISIT(traverse_module_state->__pyx_float_0_327796);
  Py_VISIT(traverse_module_state->__pyx_float_0_329415);
  Py_VISIT(traverse_module_state->__pyx_float_0_329727);
  Py_VISIT(traverse_module_state->__pyx_float_0_330805);
  Py_VISIT(traverse_module_state->__pyx_float_0_334994);
  Py_VISIT(traverse_module_state->__pyx_float_0_335384);
  Py_VISIT(traverse_module_state->__pyx_float_0_335427);
  Py_VISIT(traverse_module_state->__pyx_float_0_335885);
  Py_VISIT(traverse_module_state->__pyx_float_0_339161);
  Py_VISIT(traverse_module_state->__pyx_float_0_340967);
  Py_VISIT(traverse_module_state->__pyx_float_0_341379);
  Py_VISIT(traverse_module_state->__pyx_float_0_343307);
  Py_VISIT(traverse_module_state->__pyx_float_0_344074);
  Py_VISIT(traverse_module_state->__pyx_float_0_346476);
  Py_VISIT(traverse_module_state->__pyx_float_0_347269);
  Py_VISIT(traverse_module_state->__pyx_float_0_347432);
  Py_VISIT(traverse_module_state->__pyx_float_0_351535);
  Py_VISIT(traverse_module_state->__pyx_float_0_351910);
  Py_VISIT(traverse_module_state->__pyx_float_0_352360);
  Py_VISIT(traverse_module_state->__pyx_float_0_353093);
  Py_VISIT(traverse_module_state->__pyx_float_0_355619);
  Py_VISIT(traverse_module_state->__pyx_float_0_357269);
  Py_VISIT(traverse_module_state->__pyx_float_0_358853);
  Py_VISIT(traverse_module_state->__pyx_float_0_359683);
  Py_VISIT(traverse_module_state->__pyx_float_0_360741);
  Py_VISIT(traverse_module_state->__pyx_float_0_362552);
  Py_VISIT(traverse_module_state->__pyx_float_0_363727);
  Py_VISIT(traverse_module_state->__pyx_float_0_364543);
  Py_VISIT(traverse_module_state->__pyx_float_0_367752);
  Py_VISIT(traverse_module_state->__pyx_float_0_367757);
  Py_VISIT(traverse_module_state->__pyx_float_0_369214);
  Py_VISIT(traverse_module_state->__pyx_float_0_370164);
  Py_VISIT(traverse_module_state->__pyx_float_0_371758);
  Py_VISIT(traverse_module_state->__pyx_float_0_372886);
  Py_VISIT(traverse_module_state->__pyx_float_0_375715);
  Py_VISIT(traverse_module_state->__pyx_float_0_375746);
  Py_VISIT(traverse_module_state->__pyx_float_0_377779);
  Py_VISIT(traverse_module_state->__pyx_float_0_377939);
  Py_VISIT(traverse_module_state->__pyx_float_0_379716);
  Py_VISIT(traverse_module_state->__pyx_float_0_381191);
  Py_VISIT(traverse_module_state->__pyx_float_0_382914);
  Py_VISIT(traverse_module_state->__pyx_float_0_383670);
  Py_VISIT(traverse_module_state->__pyx_float_0_386433);
  Py_VISIT(traverse_module_state->__pyx_float_0_386592);
  Py_VISIT(traverse_module_state->__pyx_float_0_387607);
  Py_VISIT(traverse_module_state->__pyx_float_0_387814);
  Py_VISIT(traverse_module_state->__pyx_float_0_391528);
  Py_VISIT(traverse_module_state->__pyx_float_0_391917);
  Py_VISIT(traverse_module_state->__pyx_float_0_392636);
  Py_VISIT(traverse_module_state->__pyx_float_0_395174);
  Py_VISIT(traverse_module_state->__pyx_float_0_395433);
  Py_VISIT(traverse_module_state->__pyx_float_0_397163);
  Py_VISIT(traverse_module_state->__pyx_float_0_397381);
  Py_VISIT(traverse_module_state->__pyx_float_0_399323);
  Py_VISIT(traverse_module_state->__pyx_float_0_402049);
  Py_VISIT(traverse_module_state->__pyx_float_0_402329);
  Py_VISIT(traverse_module_state->__pyx_float_0_403199);
  Py_VISIT(traverse_module_state->__pyx_float_0_404001);
  Py_VISIT(traverse_module_state->__pyx_float_0_406640);
  Py_VISIT(traverse_module_state->__pyx_float_0_407061);
  Py_VISIT(traverse_module_state->__pyx_float_0_407414);
  Py_VISIT(traverse_module_state->__pyx_float_0_410910);
  Py_VISIT(traverse_module_state->__pyx_float_0_411152);
  Py_VISIT(traverse_module_state->__pyx_float_0_412415);
  Py_VISIT(traverse_module_state->__pyx_float_0_412913);
  Py_VISIT(traverse_module_state->__pyx_float_0_414746);
  Py_VISIT(traverse_module_state->__pyx_float_0_415586);
  Py_VISIT(traverse_module_state->__pyx_float_0_417331);
  Py_VISIT(traverse_module_state->__pyx_float_0_418570);
  Py_VISIT(traverse_module_state->__pyx_float_0_419943);
  Py_VISIT(traverse_module_state->__pyx_float_0_421908);
  Py_VISIT(traverse_module_state->__pyx_float_0_422160);
  Py_VISIT(traverse_module_state->__pyx_float_0_422383);
  Py_VISIT(traverse_module_state->__pyx_float_0_424223);
  Py_VISIT(traverse_module_state->__pyx_float_0_426184);
  Py_VISIT(traverse_module_state->__pyx_float_0_426902);
  Py_VISIT(traverse_module_state->__pyx_float_0_428426);
  Py_VISIT(traverse_module_state->__pyx_float_0_429975);
  Py_VISIT(traverse_module_state->__pyx_float_0_430983);
  Py_VISIT(traverse_module_state->__pyx_float_0_431554);
  Py_VISIT(traverse_module_state->__pyx_float_0_432552);
  Py_VISIT(traverse_module_state->__pyx_float_0_433756);
  Py_VISIT(traverse_module_state->__pyx_float_0_436115);
  Py_VISIT(traverse_module_state->__pyx_float_0_436601);
  Py_VISIT(traverse_module_state->__pyx_float_0_437527);
  Py_VISIT(traverse_module_state->__pyx_float_0_440137);
  Py_VISIT(traverse_module_state->__pyx_float_0_440573);
  Py_VISIT(traverse_module_state->__pyx_float_0_440584);
  Py_VISIT(traverse_module_state->__pyx_float_0_441290);
  Py_VISIT(traverse_module_state->__pyx_float_0_444467);
  Py_VISIT(traverse_module_state->__pyx_float_0_444960);
  Py_VISIT(traverse_module_state->__pyx_float_0_445044);
  Py_VISIT(traverse_module_state->__pyx_float_0_448284);
  Py_VISIT(traverse_module_state->__pyx_float_0_448791);
  Py_VISIT(traverse_module_state->__pyx_float_0_449241);
  Py_VISIT(traverse_module_state->__pyx_float_0_449368);
  Py_VISIT(traverse_module_state->__pyx_float_0_452024);
  Py_VISIT(traverse_module_state->__pyx_float_0_452530);
  Py_VISIT(traverse_module_state->__pyx_float_0_453427);
  Py_VISIT(traverse_module_state->__pyx_float_0_455688);
  Py_VISIT(traverse_module_state->__pyx_float_0_456262);
  Py_VISIT(traverse_module_state->__pyx_float_0_457517);
  Py_VISIT(traverse_module_state->__pyx_float_0_458674);
  Py_VISIT(traverse_module_state->__pyx_float_0_459277);
  Py_VISIT(traverse_module_state->__pyx_float_0_459988);
  Py_VISIT(traverse_module_state->__pyx_float_0_461510);
  Py_VISIT(traverse_module_state->__pyx_float_0_462789);
  Py_VISIT(traverse_module_state->__pyx_float_0_463708);
  Py_VISIT(traverse_module_state->__pyx_float_0_465405);
  Py_VISIT(traverse_module_state->__pyx_float_0_466226);
  Py_VISIT(traverse_module_state->__pyx_float_0_467423);
  Py_VISIT(traverse_module_state->__pyx_float_0_468053);
  Py_VISIT(traverse_module_state->__pyx_float_0_469201);
  Py_VISIT(traverse_module_state->__pyx_float_0_469588);
  Py_VISIT(traverse_module_state->__pyx_float_0_471133);
  Py_VISIT(traverse_module_state->__pyx_float_0_472873);
  Py_VISIT(traverse_module_state->__pyx_float_0_472899);
  Py_VISIT(traverse_module_state->__pyx_float_0_474838);
  Py_VISIT(traverse_module_state->__pyx_float_0_476084);
  Py_VISIT(traverse_module_state->__pyx_float_0_476498);
  Py_VISIT(traverse_module_state->__pyx_float_0_477504);
  Py_VISIT(traverse_module_state->__pyx_float_0_478540);
  Py_VISIT(traverse_module_state->__pyx_float_0_479221);
  Py_VISIT(traverse_module_state->__pyx_float_0_479997);
  Py_VISIT(traverse_module_state->__pyx_float_0_482237);
  Py_VISIT(traverse_module_state->__pyx_float_0_482284);
  Py_VISIT(traverse_module_state->__pyx_float_0_483397);
  Py_VISIT(traverse_module_state->__pyx_float_0_485273);
  Py_VISIT(traverse_module_state->__pyx_float_0_485932);
  Py_VISIT(traverse_module_state->__pyx_float_0_486697);
  Py_VISIT(traverse_module_state->__pyx_float_0_487026);
  Py_VISIT(traverse_module_state->__pyx_float_0_488189);
  Py_VISIT(traverse_module_state->__pyx_float_0_489624);
  Py_VISIT(traverse_module_state->__pyx_float_0_489898);
  Py_VISIT(traverse_module_state->__pyx_float_0_491033);
  Py_VISIT(traverse_module_state->__pyx_float_0_493001);
  Py_VISIT(traverse_module_state->__pyx_float_0_493313);
  Py_VISIT(traverse_module_state->__pyx_float_0_493803);
  Py_VISIT(traverse_module_state->__pyx_float_0_496005);
  Py_VISIT(traverse_module_state->__pyx_float_0_496502);
  Py_VISIT(traverse_module_state->__pyx_float_0_496615);
  Py_VISIT(traverse_module_state->__pyx_float_0_497000);
  Py_VISIT(traverse_module_state->__pyx_float_0_498911);
  Py_VISIT(traverse_module_state->__pyx_float_0_499129);
  Py_VISIT(traverse_module_state->__pyx_float_0_500685);
  Py_VISIT(traverse_module_state->__pyx_float_0_501686);
  Py_VISIT(traverse_module_state->__pyx_float_0_501721);
  Py_VISIT(traverse_module_state->__pyx_float_0_504172);
  Py_VISIT(traverse_module_state->__pyx_float_0_504369);
  Py_VISIT(traverse_module_state->__pyx_float_0_504434);
  Py_VISIT(traverse_module_state->__pyx_float_0_506271);
  Py_VISIT(traverse_module_state->__pyx_float_0_506589);
  Py_VISIT(traverse_module_state->__pyx_float_0_507052);
  Py_VISIT(traverse_module_state->__pyx_float_0_508051);
  Py_VISIT(traverse_module_state->__pyx_float_0_508936);
  Py_VISIT(traverse_module_state->__pyx_float_0_509577);
  Py_VISIT(traverse_module_state->__pyx_float_0_511215);
  Py_VISIT(traverse_module_state->__pyx_float_0_511733);
  Py_VISIT(traverse_module_state->__pyx_float_0_512008);
  Py_VISIT(traverse_module_state->__pyx_float_0_513427);
  Py_VISIT(traverse_module_state->__pyx_float_0_514349);
  Py_VISIT(traverse_module_state->__pyx_float_0_515413);
  Py_VISIT(traverse_module_state->__pyx_float_0_515571);
  Py_VISIT(traverse_module_state->__pyx_float_0_515992);
  Py_VISIT(traverse_module_state->__pyx_float_0_516599);
  Py_VISIT(traverse_module_state->__pyx_float_0_517649);
  Py_VISIT(traverse_module_state->__pyx_float_0_518762);
  Py_VISIT(traverse_module_state->__pyx_float_0_519093);
  Py_VISIT(traverse_module_state->__pyx_float_0_519661);
  Py_VISIT(traverse_module_state->__pyx_float_0_520837);
  Py_VISIT(traverse_module_state->__pyx_float_0_521608);
  Py_VISIT(traverse_module_state->__pyx_float_0_522773);
  Py_VISIT(traverse_module_state->__pyx_float_0_522828);
  Py_VISIT(traverse_module_state->__pyx_float_0_523491);
  Py_VISIT(traverse_module_state->__pyx_float_0_524736);
  Py_VISIT(traverse_module_state->__pyx_float_0_525311);
  Py_VISIT(traverse_module_state->__pyx_float_0_525776);
  Py_VISIT(traverse_module_state->__pyx_float_0_526453);
  Py_VISIT(traverse_module_state->__pyx_float_0_526563);
  Py_VISIT(traverse_module_state->__pyx_float_0_527068);
  Py_VISIT(traverse_module_state->__pyx_float_0_528312);
  Py_VISIT(traverse_module_state->__pyx_float_0_528763);
  Py_VISIT(traverse_module_state->__pyx_float_0_529983);
  Py_VISIT(traverse_module_state->__pyx_float_0_530132);
  Py_VISIT(traverse_module_state->__pyx_float_0_530398);
  Py_VISIT(traverse_module_state->__pyx_float_0_531579);
  Py_VISIT(traverse_module_state->__pyx_float_0_531973);
  Py_VISIT(traverse_module_state->__pyx_float_0_533103);
  Py_VISIT(traverse_module_state->__pyx_float_0_533488);
  Py_VISIT(traverse_module_state->__pyx_float_0_533812);
  Py_VISIT(traverse_module_state->__pyx_float_0_534556);
  Py_VISIT(traverse_module_state->__pyx_float_0_534946);
  Py_VISIT(traverse_module_state->__pyx_float_0_535621);
  Py_VISIT(traverse_module_state->__pyx_float_0_535941);
  Py_VISIT(traverse_module_state->__pyx_float_0_536347);
  Py_VISIT(traverse_module_state->__pyx_float_0_537260);
  Py_VISIT(traverse_module_state->__pyx_float_0_537492);
  Py_VISIT(traverse_module_state->__pyx_float_0_537692);
  Py_VISIT(traverse_module_state->__pyx_float_0_538516);
  Py_VISIT(traverse_module_state->__pyx_float_0_538982);
  Py_VISIT(traverse_module_state->__pyx_float_0_539709);
  Py_VISIT(traverse_module_state->__pyx_float_0_540218);
  Py_VISIT(traverse_module_state->__pyx_float_0_540844);
  Py_VISIT(traverse_module_state->__pyx_float_0_541173);
  Py_VISIT(traverse_module_state->__pyx_float_0_541400);
  Py_VISIT(traverse_module_state->__pyx_float_0_541921);
  Py_VISIT(traverse_module_state->__pyx_float_0_542530);
  Py_VISIT(traverse_module_state->__pyx_float_0_542944);
  Py_VISIT(traverse_module_state->__pyx_float_0_543611);
  Py_VISIT(traverse_module_state->__pyx_float_0_543914);
  Py_VISIT(traverse_module_state->__pyx_float_0_544641);
  Py_VISIT(traverse_module_state->__pyx_float_0_544834);
  Py_VISIT(traverse_module_state->__pyx_float_0_544853);
  Py_VISIT(traverse_module_state->__pyx_float_0_545524);
  Py_VISIT(traverse_module_state->__pyx_float_0_545623);
  Py_VISIT(traverse_module_state->__pyx_float_0_545706);
  Py_VISIT(traverse_module_state->__pyx_float_0_546532);
  Py_VISIT(traverse_module_state->__pyx_float_0_546557);
  Py_VISIT(traverse_module_state->__pyx_float_0_547314);
  Py_VISIT(traverse_module_state->__pyx_float_0_547445);
  Py_VISIT(traverse_module_state->__pyx_float_0_548053);
  Py_VISIT(traverse_module_state->__pyx_float_0_548287);
  Py_VISIT(traverse_module_state->__pyx_float_0_548535);
  Py_VISIT(traverse_module_state->__pyx_float_0_548752);
  Py_VISIT(traverse_module_state->__pyx_float_0_549086);
  Py_VISIT(traverse_module_state->__pyx_float_0_549413);
  Py_VISIT(traverse_module_state->__pyx_float_0_549841);
  Py_VISIT(traverse_module_state->__pyx_float_0_550038);
  Py_VISIT(traverse_module_state->__pyx_float_0_550556);
  Py_VISIT(traverse_module_state->__pyx_float_0_550627);
  Py_VISIT(traverse_module_state->__pyx_float_0_551184);
  Py_VISIT(traverse_module_state->__pyx_float_0_551229);
  Py_VISIT(traverse_module_state->__pyx_float_0_551710);
  Py_VISIT(traverse_module_state->__pyx_float_0_551864);
  Py_VISIT(traverse_module_state->__pyx_float_0_552206);
  Py_VISIT(traverse_module_state->__pyx_float_0_552216);
  Py_VISIT(traverse_module_state->__pyx_float_0_552459);
  Py_VISIT(traverse_module_state->__pyx_float_0_552675);
  Py_VISIT(traverse_module_state->__pyx_float_0_553018);
  Py_VISIT(traverse_module_state->__pyx_float_0_553117);
  Py_VISIT(traverse_module_state->__pyx_float_0_553533);
  Py_VISIT(traverse_module_state->__pyx_float_0_553541);
  Py_VISIT(traverse_module_state->__pyx_float_0_553925);
  Py_VISIT(traverse_module_state->__pyx_float_0_554029);
  Py_VISIT(traverse_module_state->__pyx_float_0_554294);
  Py_VISIT(traverse_module_state->__pyx_float_0_554483);
  Py_VISIT(traverse_module_state->__pyx_float_0_554642);
  Py_VISIT(traverse_module_state->__pyx_float_0_554906);
  Py_VISIT(traverse_module_state->__pyx_float_0_554969);
  Py_VISIT(traverse_module_state->__pyx_float_0_555276);
  Py_VISIT(traverse_module_state->__pyx_float_0_555298);
  Py_VISIT(traverse_module_state->__pyx_float_0_555484);
  Py_VISIT(traverse_module_state->__pyx_float_0_555565);
  Py_VISIT(traverse_module_state->__pyx_float_0_555659);
  Py_VISIT(traverse_module_state->__pyx_float_0_555836);
  Py_VISIT(traverse_module_state->__pyx_float_0_555899);
  Py_VISIT(traverse_module_state->__pyx_float_0_555991);
  Py_VISIT(traverse_module_state->__pyx_float_0_556089);
  Py_VISIT(traverse_module_state->__pyx_float_0_556295);
  Py_VISIT(traverse_module_state->__pyx_float_0_556326);
  Py_VISIT(traverse_module_state->__pyx_float_0_556547);
  Py_VISIT(traverse_module_state->__pyx_float_0_556572);
  Py_VISIT(traverse_module_state->__pyx_float_0_556753);
  Py_VISIT(traverse_module_state->__pyx_float_0_556823);
  Py_VISIT(traverse_module_state->__pyx_float_0_556944);
  Py_VISIT(traverse_module_state->__pyx_float_0_557049);
  Py_VISIT(traverse_module_state->__pyx_float_0_557120);
  Py_VISIT(traverse_module_state->__pyx_float_0_557250);
  Py_VISIT(traverse_module_state->__pyx_float_0_557282);
  Py_VISIT(traverse_module_state->__pyx_float_0_557430);
  Py_VISIT(traverse_module_state->__pyx_float_0_557565);
  Py_VISIT(traverse_module_state->__pyx_float_0_557587);
  Py_VISIT(traverse_module_state->__pyx_float_0_557685);
  Py_VISIT(traverse_module_state->__pyx_float_0_557724);
  Py_VISIT(traverse_module_state->__pyx_float_0_557792);
  Py_VISIT(traverse_module_state->__pyx_float_0_557840);
  Py_VISIT(traverse_module_state->__pyx_float_0_557885);
  Py_VISIT(traverse_module_state->__pyx_float_0_557936);
  Py_VISIT(traverse_module_state->__pyx_float_0_557965);
  Py_VISIT(traverse_module_state->__pyx_float_0_558013);
  Py_VISIT(traverse_module_state->__pyx_float_0_558030);
  Py_VISIT(traverse_module_state->__pyx_float_0_558073);
  Py_VISIT(traverse_module_state->__pyx_float_0_558082);
  Py_VISIT(traverse_module_state->__pyx_float_0_558115);
  Py_VISIT(traverse_module_state->__pyx_float_0_558119);
  Py_VISIT(traverse_module_state->__pyx_float_0_558140);
  Py_VISIT(traverse_module_state->__pyx_float_0_558141);
  Py_VISIT(traverse_module_state->__pyx_float_0_558148);
  Py_VISIT(traverse_module_state->__pyx_float_0_559582);
  Py_VISIT(traverse_module_state->__pyx_float_0_563265);
  Py_VISIT(traverse_module_state->__pyx_float_0_565498);
  Py_VISIT(traverse_module_state->__pyx_float_0_566949);
  Py_VISIT(traverse_module_state->__pyx_float_0_570633);
  Py_VISIT(traverse_module_state->__pyx_float_0_574318);
  Py_VISIT(traverse_module_state->__pyx_float_0_575563);
  Py_VISIT(traverse_module_state->__pyx_float_0_578002);
  Py_VISIT(traverse_module_state->__pyx_float_0_581687);
  Py_VISIT(traverse_module_state->__pyx_float_0_585371);
  Py_VISIT(traverse_module_state->__pyx_float_0_585678);
  Py_VISIT(traverse_module_state->__pyx_float_0_589055);
  Py_VISIT(traverse_module_state->__pyx_float_0_592739);
  Py_VISIT(traverse_module_state->__pyx_float_0_595839);
  Py_VISIT(traverse_module_state->__pyx_float_0_596422);
  Py_VISIT(traverse_module_state->__pyx_float_0_600104);
  Py_VISIT(traverse_module_state->__pyx_float_0_603785);
  Py_VISIT(traverse_module_state->__pyx_float_0_606045);
  Py_VISIT(traverse_module_state->__pyx_float_0_607464);
  Py_VISIT(traverse_module_state->__pyx_float_0_611141);
  Py_VISIT(traverse_module_state->__pyx_float_0_614817);
  Py_VISIT(traverse_module_state->__pyx_float_0_616293);
  Py_VISIT(traverse_module_state->__pyx_float_0_618490);
  Py_VISIT(traverse_module_state->__pyx_float_0_622161);
  Py_VISIT(traverse_module_state->__pyx_float_0_625828);
  Py_VISIT(traverse_module_state->__pyx_float_0_626579);
  Py_VISIT(traverse_module_state->__pyx_float_0_629492);
  Py_VISIT(traverse_module_state->__pyx_float_0_633153);
  Py_VISIT(traverse_module_state->__pyx_float_0_636809);
  Py_VISIT(traverse_module_state->__pyx_float_0_636902);
  Py_VISIT(traverse_module_state->__pyx_float_0_640461);
  Py_VISIT(traverse_module_state->__pyx_float_0_644107);
  Py_VISIT(traverse_module_state->__pyx_float_0_647257);
  Py_VISIT(traverse_module_state->__pyx_float_0_647749);
  Py_VISIT(traverse_module_state->__pyx_float_0_651384);
  Py_VISIT(traverse_module_state->__pyx_float_0_655014);
  Py_VISIT(traverse_module_state->__pyx_float_0_657642);
  Py_VISIT(traverse_module_state->__pyx_float_0_658636);
  Py_VISIT(traverse_module_state->__pyx_float_0_662252);
  Py_VISIT(traverse_module_state->__pyx_float_0_665859);
  Py_VISIT(traverse_module_state->__pyx_float_0_668054);
  Py_VISIT(traverse_module_state->__pyx_float_0_669459);
  Py_VISIT(traverse_module_state->__pyx_float_0_673050);
  Py_VISIT(traverse_module_state->__pyx_float_0_676631);
  Py_VISIT(traverse_module_state->__pyx_float_0_678489);
  Py_VISIT(traverse_module_state->__pyx_float_0_680203);
  Py_VISIT(traverse_module_state->__pyx_float_0_683765);
  Py_VISIT(traverse_module_state->__pyx_float_0_687316);
  Py_VISIT(traverse_module_state->__pyx_float_0_688944);
  Py_VISIT(traverse_module_state->__pyx_float_0_690856);
  Py_VISIT(traverse_module_state->__pyx_float_0_694384);
  Py_VISIT(traverse_module_state->__pyx_float_0_697900);
  Py_VISIT(traverse_module_state->__pyx_float_0_699415);
  Py_VISIT(traverse_module_state->__pyx_float_0_701402);
  Py_VISIT(traverse_module_state->__pyx_float_0_704891);
  Py_VISIT(traverse_module_state->__pyx_float_0_708366);
  Py_VISIT(traverse_module_state->__pyx_float_0_709898);
  Py_VISIT(traverse_module_state->__pyx_float_0_711827);
  Py_VISIT(traverse_module_state->__pyx_float_0_715272);
  Py_VISIT(traverse_module_state->__pyx_float_0_718701);
  Py_VISIT(traverse_module_state->__pyx_float_0_720391);
  Py_VISIT(traverse_module_state->__pyx_float_0_722114);
  Py_VISIT(traverse_module_state->__pyx_float_0_725509);
  Py_VISIT(traverse_module_state->__pyx_float_0_728888);
  Py_VISIT(traverse_module_state->__pyx_float_0_730889);
  Py_VISIT(traverse_module_state->__pyx_float_0_732247);
  Py_VISIT(traverse_module_state->__pyx_float_0_735588);
  Py_VISIT(traverse_module_state->__pyx_float_0_738910);
  Py_VISIT(traverse_module_state->__pyx_float_0_741388);
  Py_VISIT(traverse_module_state->__pyx_float_0_742211);
  Py_VISIT(traverse_module_state->__pyx_float_0_745492);
  Py_VISIT(traverse_module_state->__pyx_float_0_748751);
  Py_VISIT(traverse_module_state->__pyx_float_0_751884);
  Py_VISIT(traverse_module_state->__pyx_float_0_751988);
  Py_VISIT(traverse_module_state->__pyx_float_0_755203);
  Py_VISIT(traverse_module_state->__pyx_float_0_758394);
  Py_VISIT(traverse_module_state->__pyx_float_0_761561);
  Py_VISIT(traverse_module_state->__pyx_float_0_762373);
  Py_VISIT(traverse_module_state->__pyx_float_0_764704);
  Py_VISIT(traverse_module_state->__pyx_float_0_767822);
  Py_VISIT(traverse_module_state->__pyx_float_0_770914);
  Py_VISIT(traverse_module_state->__pyx_float_0_772852);
  Py_VISIT(traverse_module_state->__pyx_float_0_773980);
  Py_VISIT(traverse_module_state->__pyx_float_0_777018);
  Py_VISIT(traverse_module_state->__pyx_float_0_780029);
  Py_VISIT(traverse_module_state->__pyx_float_0_783011);
  Py_VISIT(traverse_module_state->__pyx_float_0_783315);
  Py_VISIT(traverse_module_state->__pyx_float_0_785964);
  Py_VISIT(traverse_module_state->__pyx_float_0_788888);
  Py_VISIT(traverse_module_state->__pyx_float_0_791781);
  Py_VISIT(traverse_module_state->__pyx_float_0_793760);
  Py_VISIT(traverse_module_state->__pyx_float_0_794644);
  Py_VISIT(traverse_module_state->__pyx_float_0_797475);
  Py_VISIT(traverse_module_state->__pyx_float_0_800275);
  Py_VISIT(traverse_module_state->__pyx_float_0_803041);
  Py_VISIT(traverse_module_state->__pyx_float_0_804182);
  Py_VISIT(traverse_module_state->__pyx_float_0_805774);
  Py_VISIT(traverse_module_state->__pyx_float_0_808473);
  Py_VISIT(traverse_module_state->__pyx_float_0_811138);
  Py_VISIT(traverse_module_state->__pyx_float_0_813768);
  Py_VISIT(traverse_module_state->__pyx_float_0_814576);
  Py_VISIT(traverse_module_state->__pyx_float_0_816363);
  Py_VISIT(traverse_module_state->__pyx_float_0_818921);
  Py_VISIT(traverse_module_state->__pyx_float_0_821444);
  Py_VISIT(traverse_module_state->__pyx_float_0_823929);
  Py_VISIT(traverse_module_state->__pyx_float_0_824940);
  Py_VISIT(traverse_module_state->__pyx_float_0_826376);
  Py_VISIT(traverse_module_state->__pyx_float_0_828786);
  Py_VISIT(traverse_module_state->__pyx_float_0_831158);
  Py_VISIT(traverse_module_state->__pyx_float_0_833491);
  Py_VISIT(traverse_module_state->__pyx_float_0_835270);
  Py_VISIT(traverse_module_state->__pyx_float_0_835785);
  Py_VISIT(traverse_module_state->__pyx_float_0_838039);
  Py_VISIT(traverse_module_state->__pyx_float_0_840254);
  Py_VISIT(traverse_module_state->__pyx_float_0_842430);
  Py_VISIT(traverse_module_state->__pyx_float_0_844566);
  Py_VISIT(traverse_module_state->__pyx_float_0_845561);
  Py_VISIT(traverse_module_state->__pyx_float_0_846661);
  Py_VISIT(traverse_module_state->__pyx_float_0_848717);
  Py_VISIT(traverse_module_state->__pyx_float_0_850733);
  Py_VISIT(traverse_module_state->__pyx_float_0_852709);
  Py_VISIT(traverse_module_state->__pyx_float_0_854645);
  Py_VISIT(traverse_module_state->__pyx_float_0_855810);
  Py_VISIT(traverse_module_state->__pyx_float_0_856542);
  Py_VISIT(traverse_module_state->__pyx_float_0_858400);
  Py_VISIT(traverse_module_state->__pyx_float_0_860219);
  Py_VISIT(traverse_module_state->__pyx_float_0_861999);
  Py_VISIT(traverse_module_state->__pyx_float_0_863742);
  Py_VISIT(traverse_module_state->__pyx_float_0_865448);
  Py_VISIT(traverse_module_state->__pyx_float_0_866013);
  Py_VISIT(traverse_module_state->__pyx_float_0_867117);
  Py_VISIT(traverse_module_state->__pyx_float_0_868751);
  Py_VISIT(traverse_module_state->__pyx_float_0_870350);
  Py_VISIT(traverse_module_state->__pyx_float_0_871916);
  Py_VISIT(traverse_module_state->__pyx_float_0_873449);
  Py_VISIT(traverse_module_state->__pyx_float_0_874951);
  Py_VISIT(traverse_module_state->__pyx_float_0_876168);
  Py_VISIT(traverse_module_state->__pyx_float_0_876424);
  Py_VISIT(traverse_module_state->__pyx_float_0_877868);
  Py_VISIT(traverse_module_state->__pyx_float_0_879285);
  Py_VISIT(traverse_module_state->__pyx_float_0_880678);
  Py_VISIT(traverse_module_state->__pyx_float_0_882046);
  Py_VISIT(traverse_module_state->__pyx_float_0_883393);
  Py_VISIT(traverse_module_state->__pyx_float_0_884720);
  Py_VISIT(traverse_module_state->__pyx_float_0_886029);
  Py_VISIT(traverse_module_state->__pyx_float_0_886271);
  Py_VISIT(traverse_module_state->__pyx_float_0_887322);
  Py_VISIT(traverse_module_state->__pyx_float_0_888601);
  Py_VISIT(traverse_module_state->__pyx_float_0_889868);
  Py_VISIT(traverse_module_state->__pyx_float_0_891125);
  Py_VISIT(traverse_module_state->__pyx_float_0_892374);
  Py_VISIT(traverse_module_state->__pyx_float_0_893616);
  Py_VISIT(traverse_module_state->__pyx_float_0_894855);
  Py_VISIT(traverse_module_state->__pyx_float_0_896091);
  Py_VISIT(traverse_module_state->__pyx_float_0_896320);
  Py_VISIT(traverse_module_state->__pyx_float_0_897330);
  Py_VISIT(traverse_module_state->__pyx_float_0_898570);
  Py_VISIT(traverse_module_state->__pyx_float_0_899815);
  Py_VISIT(traverse_module_state->__pyx_float_0_901065);
  Py_VISIT(traverse_module_state->__pyx_float_0_902323);
  Py_VISIT(traverse_module_state->__pyx_float_0_903590);
  Py_VISIT(traverse_module_state->__pyx_float_0_904867);
  Py_VISIT(traverse_module_state->__pyx_float_0_906157);
  Py_VISIT(traverse_module_state->__pyx_float_0_906311);
  Py_VISIT(traverse_module_state->__pyx_float_0_916242);
  Py_VISIT(traverse_module_state->__pyx_float_0_926106);
  Py_VISIT(traverse_module_state->__pyx_float_0_935904);
  Py_VISIT(traverse_module_state->__pyx_float_0_945636);
  Py_VISIT(traverse_module_state->__pyx_float_0_955300);
  Py_VISIT(traverse_module_state->__pyx_float_0_964894);
  Py_VISIT(traverse_module_state->__pyx_float_0_974417);
  Py_VISIT(traverse_module_state->__pyx_float_0_983868);
  Py_VISIT(traverse_module_state->__pyx_float_0_993248);
  Py_VISIT(traverse_module_state->__pyx_float_0_032852381);
  Py_VISIT(traverse_module_state->__pyx_float_0_079347619);
  Py_VISIT(traverse_module_state->__pyx_float_0_147452381);
  Py_VISIT(traverse_module_state->__pyx_float_0_196652381);
  Py_VISIT(traverse_module_state->__pyx_float_0_212252381);
  Py_VISIT(traverse_module_state->__pyx_float_0_240347619);
  Py_VISIT(traverse_module_state->__pyx_float_0_266647619);
  Py_VISIT(traverse_module_state->__pyx_float_0_609852381);
  Py_VISIT(traverse_module_state->__pyx_float_0_743552381);
  Py_VISIT(traverse_module_state->__pyx_float_0_779247619);
  Py_VISIT(traverse_module_state->__pyx_float_0_819852381);
  Py_VISIT(traverse_module_state->__pyx_float_0_0059571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_0116952381);
  Py_VISIT(traverse_module_state->__pyx_float_0_0165142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_0227714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_0230904762);
  Py_VISIT(traverse_module_state->__pyx_float_0_0238904762);
  Py_VISIT(traverse_module_state->__pyx_float_0_0266619048);
  Py_VISIT(traverse_module_state->__pyx_float_0_0343428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_0383714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_0487714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_0498142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_0589714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_0591333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_0629333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_0640571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_0722666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_0749428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_0755333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_0779428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_0948380952);
  Py_VISIT(traverse_module_state->__pyx_float_0_1132428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_1132952381);
  Py_VISIT(traverse_module_state->__pyx_float_0_1252714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_1452714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_1633142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_1707285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_1793666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_1801333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_1897809524);
  Py_VISIT(traverse_module_state->__pyx_float_0_1959047619);
  Py_VISIT(traverse_module_state->__pyx_float_0_2116238095);
  Py_VISIT(traverse_module_state->__pyx_float_0_2137714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_2164142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_2178285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_2586428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_2644571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_2886428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_2919380952);
  Py_VISIT(traverse_module_state->__pyx_float_0_3021714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_3062761905);
  Py_VISIT(traverse_module_state->__pyx_float_0_3242428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_3360285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_3481666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_3497904762);
  Py_VISIT(traverse_module_state->__pyx_float_0_3598333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_3632714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_3768142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_3875095238);
  Py_VISIT(traverse_module_state->__pyx_float_0_3904761905);
  Py_VISIT(traverse_module_state->__pyx_float_0_3952571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_4044333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_4086142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_4336857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_4420095238);
  Py_VISIT(traverse_module_state->__pyx_float_0_4430428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_4493904762);
  Py_VISIT(traverse_module_state->__pyx_float_0_4585714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_4661142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_4736904762);
  Py_VISIT(traverse_module_state->__pyx_float_0_4839761905);
  Py_VISIT(traverse_module_state->__pyx_float_0_4871238095);
  Py_VISIT(traverse_module_state->__pyx_float_0_4886666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_5033142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_5039857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_5200238095);
  Py_VISIT(traverse_module_state->__pyx_float_0_5244428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_5300285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_5375428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_5472666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_5569857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_5708571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_5711857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_5772238095);
  Py_VISIT(traverse_module_state->__pyx_float_0_5776761905);
  Py_VISIT(traverse_module_state->__pyx_float_0_5954285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_5965809524);
  Py_VISIT(traverse_module_state->__pyx_float_0_6192619048);
  Py_VISIT(traverse_module_state->__pyx_float_0_6269714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_6286619048);
  Py_VISIT(traverse_module_state->__pyx_float_0_6417857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_6424333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_6534857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_6641952381);
  Py_VISIT(traverse_module_state->__pyx_float_0_6646285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_6742714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_6770857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_6834190476);
  Py_VISIT(traverse_module_state->__pyx_float_0_6837571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_6858571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_6928333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_7061666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_7097571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_7176571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_7184095238);
  Py_VISIT(traverse_module_state->__pyx_float_0_7250428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_7253857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_7257857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_7261142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_7274333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_7313952381);
  Py_VISIT(traverse_module_state->__pyx_float_0_7317142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_7327333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_7355666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_7376047619);
  Py_VISIT(traverse_module_state->__pyx_float_0_7411333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_7424333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_7434761905);
  Py_VISIT(traverse_module_state->__pyx_float_0_7454571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_7473142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_7480809524);
  Py_VISIT(traverse_module_state->__pyx_float_0_7485190476);
  Py_VISIT(traverse_module_state->__pyx_float_0_7490619048);
  Py_VISIT(traverse_module_state->__pyx_float_0_7491142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_7524857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_7607190476);
  Py_VISIT(traverse_module_state->__pyx_float_0_7653142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_7767571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_7858428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_7860571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_7912666667);
  Py_VISIT(traverse_module_state->__pyx_float_0_8037619048);
  Py_VISIT(traverse_module_state->__pyx_float_0_8185047619);
  Py_VISIT(traverse_module_state->__pyx_float_0_8228285714);
  Py_VISIT(traverse_module_state->__pyx_float_0_8239571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_8262714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_8271428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_8302714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_8311809524);
  Py_VISIT(traverse_module_state->__pyx_float_0_8383714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_8481380952);
  Py_VISIT(traverse_module_state->__pyx_float_0_8506571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_8554380952);
  Py_VISIT(traverse_module_state->__pyx_float_0_8640571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_8683333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_8705142857);
  Py_VISIT(traverse_module_state->__pyx_float_0_8719571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_8786333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_8819571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_8824333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_8828428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_9139333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_9218333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_9449571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_9514428571);
  Py_VISIT(traverse_module_state->__pyx_float_0_9588714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_9598238095);
  Py_VISIT(traverse_module_state->__pyx_float_0_9625857143);
  Py_VISIT(traverse_module_state->__pyx_float_0_9738952381);
  Py_VISIT(traverse_module_state->__pyx_float_0_9788571429);
  Py_VISIT(traverse_module_state->__pyx_float_0_9937714286);
  Py_VISIT(traverse_module_state->__pyx_float_0_9955333333);
  Py_VISIT(traverse_module_state->__pyx_float_0_9990428571);
  return 0;
}
#endif

#define __pyx_d __pyx_mstate_global->__pyx_d
#define __pyx_b __pyx_mstate_global->__pyx_b
#define __pyx_cython_runtime __pyx_mstate_global->__pyx_cython_runtime
#define __pyx_empty_tuple __pyx_mstate_global->__pyx_empty_tuple
#define __pyx_empty_bytes __pyx_mstate_global->__pyx_empty_bytes
#define __pyx_empty_unicode __pyx_mstate_global->__pyx_empty_unicode
#ifdef __Pyx_CyFunction_USED
#define __pyx_CyFunctionType __pyx_mstate_global->__pyx_CyFunctionType
#endif
#ifdef __Pyx_FusedFunction_USED
#define __pyx_FusedFunctionType __pyx_mstate_global->__pyx_FusedFunctionType
#endif
#ifdef __Pyx_Generator_USED
#define __pyx_GeneratorType __pyx_mstate_global->__pyx_GeneratorType
#endif
#ifdef __Pyx_IterableCoroutine_USED
#define __pyx_IterableCoroutineType __pyx_mstate_global->__pyx_IterableCoroutineType
#endif
#ifdef __Pyx_Coroutine_USED
#define __pyx_CoroutineAwaitType __pyx_mstate_global->__pyx_CoroutineAwaitType
#endif
#ifdef __Pyx_Coroutine_USED
#define __pyx_CoroutineType __pyx_mstate_global->__pyx_CoroutineType
#endif
#if CYTHON_USE_MODULE_STATE
#endif
#define __pyx_n_s_ __pyx_mstate_global->__pyx_n_s_
#define __pyx_n_s_ListedColormap __pyx_mstate_global->__pyx_n_s_ListedColormap
#define __pyx_kp_u__2 __pyx_mstate_global->__pyx_kp_u__2
#define __pyx_n_s__3 __pyx_mstate_global->__pyx_n_s__3
#define __pyx_n_s_all __pyx_mstate_global->__pyx_n_s_all
#define __pyx_n_s_cline_in_traceback __pyx_mstate_global->__pyx_n_s_cline_in_traceback
#define __pyx_n_s_cmaps __pyx_mstate_global->__pyx_n_s_cmaps
#define __pyx_n_s_data __pyx_mstate_global->__pyx_n_s_data
#define __pyx_n_s_import __pyx_mstate_global->__pyx_n_s_import
#define __pyx_n_s_initializing __pyx_mstate_global->__pyx_n_s_initializing
#define __pyx_n_s_main __pyx_mstate_global->__pyx_n_s_main
#define __pyx_n_s_matplotlib_colors __pyx_mstate_global->__pyx_n_s_matplotlib_colors
#define __pyx_n_s_name __pyx_mstate_global->__pyx_n_s_name
#define __pyx_n_s_name_2 __pyx_mstate_global->__pyx_n_s_name_2
#define __pyx_n_s_parula __pyx_mstate_global->__pyx_n_s_parula
#define __pyx_n_u_parula __pyx_mstate_global->__pyx_n_u_parula
#define __pyx_n_s_parula_data __pyx_mstate_global->__pyx_n_s_parula_data
#define __pyx_n_s_spec __pyx_mstate_global->__pyx_n_s_spec
#define __pyx_n_s_test __pyx_mstate_global->__pyx_n_s_test
#define __pyx_n_s_th __pyx_mstate_global->__pyx_n_s_th
#define __pyx_n_s_torch __pyx_mstate_global->__pyx_n_s_torch
#define __pyx_n_s_viridis __pyx_mstate_global->__pyx_n_s_viridis
#define __pyx_n_u_viridis __pyx_mstate_global->__pyx_n_u_viridis
#define __pyx_n_s_viridis_data __pyx_mstate_global->__pyx_n_s_viridis_data
#define __pyx_float_0_988 __pyx_mstate_global->__pyx_float_0_988
#define __pyx_float_0_0265 __pyx_mstate_global->__pyx_float_0_0265
#define __pyx_float_0_0538 __pyx_mstate_global->__pyx_float_0_0538
#define __pyx_float_0_0843 __pyx_mstate_global->__pyx_float_0_0843
#define __pyx_float_0_1309 __pyx_mstate_global->__pyx_float_0_1309
#define __pyx_float_0_1663 __pyx_mstate_global->__pyx_float_0_1663
#define __pyx_float_0_2081 __pyx_mstate_global->__pyx_float_0_2081
#define __pyx_float_0_2386 __pyx_mstate_global->__pyx_float_0_2386
#define __pyx_float_0_3217 __pyx_mstate_global->__pyx_float_0_3217
#define __pyx_float_0_4188 __pyx_mstate_global->__pyx_float_0_4188
#define __pyx_float_0_4266 __pyx_mstate_global->__pyx_float_0_4266
#define __pyx_float_0_5292 __pyx_mstate_global->__pyx_float_0_5292
#define __pyx_float_0_6137 __pyx_mstate_global->__pyx_float_0_6137
#define __pyx_float_0_6473 __pyx_mstate_global->__pyx_float_0_6473
#define __pyx_float_0_7015 __pyx_mstate_global->__pyx_float_0_7015
#define __pyx_float_0_7279 __pyx_mstate_global->__pyx_float_0_7279
#define __pyx_float_0_7299 __pyx_mstate_global->__pyx_float_0_7299
#define __pyx_float_0_7384 __pyx_mstate_global->__pyx_float_0_7384
#define __pyx_float_0_7456 __pyx_mstate_global->__pyx_float_0_7456
#define __pyx_float_0_7459 __pyx_mstate_global->__pyx_float_0_7459
#define __pyx_float_0_8066 __pyx_mstate_global->__pyx_float_0_8066
#define __pyx_float_0_8135 __pyx_mstate_global->__pyx_float_0_8135
#define __pyx_float_0_8467 __pyx_mstate_global->__pyx_float_0_8467
#define __pyx_float_0_8949 __pyx_mstate_global->__pyx_float_0_8949
#define __pyx_float_0_9661 __pyx_mstate_global->__pyx_float_0_9661
#define __pyx_float_0_9697 __pyx_mstate_global->__pyx_float_0_9697
#define __pyx_float_0_9763 __pyx_mstate_global->__pyx_float_0_9763
#define __pyx_float_0_9831 __pyx_mstate_global->__pyx_float_0_9831
#define __pyx_float_0_004874 __pyx_mstate_global->__pyx_float_0_004874
#define __pyx_float_0_009605 __pyx_mstate_global->__pyx_float_0_009605
#define __pyx_float_0_014625 __pyx_mstate_global->__pyx_float_0_014625
#define __pyx_float_0_019942 __pyx_mstate_global->__pyx_float_0_019942
#define __pyx_float_0_025563 __pyx_mstate_global->__pyx_float_0_025563
#define __pyx_float_0_031497 __pyx_mstate_global->__pyx_float_0_031497
#define __pyx_float_0_037752 __pyx_mstate_global->__pyx_float_0_037752
#define __pyx_float_0_044167 __pyx_mstate_global->__pyx_float_0_044167
#define __pyx_float_0_050344 __pyx_mstate_global->__pyx_float_0_050344
#define __pyx_float_0_056324 __pyx_mstate_global->__pyx_float_0_056324
#define __pyx_float_0_062145 __pyx_mstate_global->__pyx_float_0_062145
#define __pyx_float_0_067836 __pyx_mstate_global->__pyx_float_0_067836
#define __pyx_float_0_073417 __pyx_mstate_global->__pyx_float_0_073417
#define __pyx_float_0_078907 __pyx_mstate_global->__pyx_float_0_078907
#define __pyx_float_0_084320 __pyx_mstate_global->__pyx_float_0_084320
#define __pyx_float_0_089666 __pyx_mstate_global->__pyx_float_0_089666
#define __pyx_float_0_094955 __pyx_mstate_global->__pyx_float_0_094955
#define __pyx_float_0_095250 __pyx_mstate_global->__pyx_float_0_095250
#define __pyx_float_0_095374 __pyx_mstate_global->__pyx_float_0_095374
#define __pyx_float_0_095953 __pyx_mstate_global->__pyx_float_0_095953
#define __pyx_float_0_096335 __pyx_mstate_global->__pyx_float_0_096335
#define __pyx_float_0_097452 __pyx_mstate_global->__pyx_float_0_097452
#define __pyx_float_0_098125 __pyx_mstate_global->__pyx_float_0_098125
#define __pyx_float_0_099702 __pyx_mstate_global->__pyx_float_0_099702
#define __pyx_float_0_100196 __pyx_mstate_global->__pyx_float_0_100196
#define __pyx_float_0_100717 __pyx_mstate_global->__pyx_float_0_100717
#define __pyx_float_0_102646 __pyx_mstate_global->__pyx_float_0_102646
#define __pyx_float_0_104071 __pyx_mstate_global->__pyx_float_0_104071
#define __pyx_float_0_105393 __pyx_mstate_global->__pyx_float_0_105393
#define __pyx_float_0_106217 __pyx_mstate_global->__pyx_float_0_106217
#define __pyx_float_0_108131 __pyx_mstate_global->__pyx_float_0_108131
#define __pyx_float_0_110347 __pyx_mstate_global->__pyx_float_0_110347
#define __pyx_float_0_110553 __pyx_mstate_global->__pyx_float_0_110553
#define __pyx_float_0_112838 __pyx_mstate_global->__pyx_float_0_112838
#define __pyx_float_0_114965 __pyx_mstate_global->__pyx_float_0_114965
#define __pyx_float_0_115680 __pyx_mstate_global->__pyx_float_0_115680
#define __pyx_float_0_118128 __pyx_mstate_global->__pyx_float_0_118128
#define __pyx_float_0_119423 __pyx_mstate_global->__pyx_float_0_119423
#define __pyx_float_0_119483 __pyx_mstate_global->__pyx_float_0_119483
#define __pyx_float_0_119512 __pyx_mstate_global->__pyx_float_0_119512
#define __pyx_float_0_119699 __pyx_mstate_global->__pyx_float_0_119699
#define __pyx_float_0_119738 __pyx_mstate_global->__pyx_float_0_119738
#define __pyx_float_0_120005 __pyx_mstate_global->__pyx_float_0_120005
#define __pyx_float_0_120081 __pyx_mstate_global->__pyx_float_0_120081
#define __pyx_float_0_120092 __pyx_mstate_global->__pyx_float_0_120092
#define __pyx_float_0_120565 __pyx_mstate_global->__pyx_float_0_120565
#define __pyx_float_0_120638 __pyx_mstate_global->__pyx_float_0_120638
#define __pyx_float_0_120777 __pyx_mstate_global->__pyx_float_0_120777
#define __pyx_float_0_121148 __pyx_mstate_global->__pyx_float_0_121148
#define __pyx_float_0_121380 __pyx_mstate_global->__pyx_float_0_121380
#define __pyx_float_0_121831 __pyx_mstate_global->__pyx_float_0_121831
#define __pyx_float_0_122312 __pyx_mstate_global->__pyx_float_0_122312
#define __pyx_float_0_122606 __pyx_mstate_global->__pyx_float_0_122606
#define __pyx_float_0_123444 __pyx_mstate_global->__pyx_float_0_123444
#define __pyx_float_0_123463 __pyx_mstate_global->__pyx_float_0_123463
#define __pyx_float_0_123941 __pyx_mstate_global->__pyx_float_0_123941
#define __pyx_float_0_124395 __pyx_mstate_global->__pyx_float_0_124395
#define __pyx_float_0_124780 __pyx_mstate_global->__pyx_float_0_124780
#define __pyx_float_0_125394 __pyx_mstate_global->__pyx_float_0_125394
#define __pyx_float_0_125405 __pyx_mstate_global->__pyx_float_0_125405
#define __pyx_float_0_125848 __pyx_mstate_global->__pyx_float_0_125848
#define __pyx_float_0_126326 __pyx_mstate_global->__pyx_float_0_126326
#define __pyx_float_0_126453 __pyx_mstate_global->__pyx_float_0_126453
#define __pyx_float_0_127568 __pyx_mstate_global->__pyx_float_0_127568
#define __pyx_float_0_128087 __pyx_mstate_global->__pyx_float_0_128087
#define __pyx_float_0_128729 __pyx_mstate_global->__pyx_float_0_128729
#define __pyx_float_0_129933 __pyx_mstate_global->__pyx_float_0_129933
#define __pyx_float_0_130067 __pyx_mstate_global->__pyx_float_0_130067
#define __pyx_float_0_130215 __pyx_mstate_global->__pyx_float_0_130215
#define __pyx_float_0_130895 __pyx_mstate_global->__pyx_float_0_130895
#define __pyx_float_0_131109 __pyx_mstate_global->__pyx_float_0_131109
#define __pyx_float_0_131172 __pyx_mstate_global->__pyx_float_0_131172
#define __pyx_float_0_132268 __pyx_mstate_global->__pyx_float_0_132268
#define __pyx_float_0_132444 __pyx_mstate_global->__pyx_float_0_132444
#define __pyx_float_0_133743 __pyx_mstate_global->__pyx_float_0_133743
#define __pyx_float_0_134692 __pyx_mstate_global->__pyx_float_0_134692
#define __pyx_float_0_135066 __pyx_mstate_global->__pyx_float_0_135066
#define __pyx_float_0_135920 __pyx_mstate_global->__pyx_float_0_135920
#define __pyx_float_0_136408 __pyx_mstate_global->__pyx_float_0_136408
#define __pyx_float_0_136897 __pyx_mstate_global->__pyx_float_0_136897
#define __pyx_float_0_137064 __pyx_mstate_global->__pyx_float_0_137064
#define __pyx_float_0_137339 __pyx_mstate_global->__pyx_float_0_137339
#define __pyx_float_0_137770 __pyx_mstate_global->__pyx_float_0_137770
#define __pyx_float_0_139147 __pyx_mstate_global->__pyx_float_0_139147
#define __pyx_float_0_140210 __pyx_mstate_global->__pyx_float_0_140210
#define __pyx_float_0_140536 __pyx_mstate_global->__pyx_float_0_140536
#define __pyx_float_0_140926 __pyx_mstate_global->__pyx_float_0_140926
#define __pyx_float_0_141935 __pyx_mstate_global->__pyx_float_0_141935
#define __pyx_float_0_143228 __pyx_mstate_global->__pyx_float_0_143228
#define __pyx_float_0_143303 __pyx_mstate_global->__pyx_float_0_143303
#define __pyx_float_0_143343 __pyx_mstate_global->__pyx_float_0_143343
#define __pyx_float_0_143936 __pyx_mstate_global->__pyx_float_0_143936
#define __pyx_float_0_144759 __pyx_mstate_global->__pyx_float_0_144759
#define __pyx_float_0_145912 __pyx_mstate_global->__pyx_float_0_145912
#define __pyx_float_0_146180 __pyx_mstate_global->__pyx_float_0_146180
#define __pyx_float_0_146616 __pyx_mstate_global->__pyx_float_0_146616
#define __pyx_float_0_147607 __pyx_mstate_global->__pyx_float_0_147607
#define __pyx_float_0_149039 __pyx_mstate_global->__pyx_float_0_149039
#define __pyx_float_0_149561 __pyx_mstate_global->__pyx_float_0_149561
#define __pyx_float_0_150148 __pyx_mstate_global->__pyx_float_0_150148
#define __pyx_float_0_150476 __pyx_mstate_global->__pyx_float_0_150476
#define __pyx_float_0_150881 __pyx_mstate_global->__pyx_float_0_150881
#define __pyx_float_0_151918 __pyx_mstate_global->__pyx_float_0_151918
#define __pyx_float_0_153364 __pyx_mstate_global->__pyx_float_0_153364
#define __pyx_float_0_153894 __pyx_mstate_global->__pyx_float_0_153894
#define __pyx_float_0_154815 __pyx_mstate_global->__pyx_float_0_154815
#define __pyx_float_0_155834 __pyx_mstate_global->__pyx_float_0_155834
#define __pyx_float_0_156029 __pyx_mstate_global->__pyx_float_0_156029
#define __pyx_float_0_156270 __pyx_mstate_global->__pyx_float_0_156270
#define __pyx_float_0_157729 __pyx_mstate_global->__pyx_float_0_157729
#define __pyx_float_0_157851 __pyx_mstate_global->__pyx_float_0_157851
#define __pyx_float_0_159194 __pyx_mstate_global->__pyx_float_0_159194
#define __pyx_float_0_160665 __pyx_mstate_global->__pyx_float_0_160665
#define __pyx_float_0_160771 __pyx_mstate_global->__pyx_float_0_160771
#define __pyx_float_0_162016 __pyx_mstate_global->__pyx_float_0_162016
#define __pyx_float_0_162142 __pyx_mstate_global->__pyx_float_0_162142
#define __pyx_float_0_162603 __pyx_mstate_global->__pyx_float_0_162603
#define __pyx_float_0_163625 __pyx_mstate_global->__pyx_float_0_163625
#define __pyx_float_0_165117 __pyx_mstate_global->__pyx_float_0_165117
#define __pyx_float_0_165693 __pyx_mstate_global->__pyx_float_0_165693
#define __pyx_float_0_166383 __pyx_mstate_global->__pyx_float_0_166383
#define __pyx_float_0_166617 __pyx_mstate_global->__pyx_float_0_166617
#define __pyx_float_0_168126 __pyx_mstate_global->__pyx_float_0_168126
#define __pyx_float_0_169257 __pyx_mstate_global->__pyx_float_0_169257
#define __pyx_float_0_169646 __pyx_mstate_global->__pyx_float_0_169646
#define __pyx_float_0_170599 __pyx_mstate_global->__pyx_float_0_170599
#define __pyx_float_0_170948 __pyx_mstate_global->__pyx_float_0_170948
#define __pyx_float_0_171176 __pyx_mstate_global->__pyx_float_0_171176
#define __pyx_float_0_172719 __pyx_mstate_global->__pyx_float_0_172719
#define __pyx_float_0_174274 __pyx_mstate_global->__pyx_float_0_174274
#define __pyx_float_0_175490 __pyx_mstate_global->__pyx_float_0_175490
#define __pyx_float_0_175707 __pyx_mstate_global->__pyx_float_0_175707
#define __pyx_float_0_175841 __pyx_mstate_global->__pyx_float_0_175841
#define __pyx_float_0_175971 __pyx_mstate_global->__pyx_float_0_175971
#define __pyx_float_0_177423 __pyx_mstate_global->__pyx_float_0_177423
#define __pyx_float_0_179019 __pyx_mstate_global->__pyx_float_0_179019
#define __pyx_float_0_180367 __pyx_mstate_global->__pyx_float_0_180367
#define __pyx_float_0_180629 __pyx_mstate_global->__pyx_float_0_180629
#define __pyx_float_0_180653 __pyx_mstate_global->__pyx_float_0_180653
#define __pyx_float_0_182256 __pyx_mstate_global->__pyx_float_0_182256
#define __pyx_float_0_182725 __pyx_mstate_global->__pyx_float_0_182725
#define __pyx_float_0_183898 __pyx_mstate_global->__pyx_float_0_183898
#define __pyx_float_0_185228 __pyx_mstate_global->__pyx_float_0_185228
#define __pyx_float_0_185556 __pyx_mstate_global->__pyx_float_0_185556
#define __pyx_float_0_185783 __pyx_mstate_global->__pyx_float_0_185783
#define __pyx_float_0_187231 __pyx_mstate_global->__pyx_float_0_187231
#define __pyx_float_0_188923 __pyx_mstate_global->__pyx_float_0_188923
#define __pyx_float_0_189503 __pyx_mstate_global->__pyx_float_0_189503
#define __pyx_float_0_190074 __pyx_mstate_global->__pyx_float_0_190074
#define __pyx_float_0_190631 __pyx_mstate_global->__pyx_float_0_190631
#define __pyx_float_0_191090 __pyx_mstate_global->__pyx_float_0_191090
#define __pyx_float_0_192357 __pyx_mstate_global->__pyx_float_0_192357
#define __pyx_float_0_194100 __pyx_mstate_global->__pyx_float_0_194100
#define __pyx_float_0_194905 __pyx_mstate_global->__pyx_float_0_194905
#define __pyx_float_0_195860 __pyx_mstate_global->__pyx_float_0_195860
#define __pyx_float_0_196293 __pyx_mstate_global->__pyx_float_0_196293
#define __pyx_float_0_196571 __pyx_mstate_global->__pyx_float_0_196571
#define __pyx_float_0_197636 __pyx_mstate_global->__pyx_float_0_197636
#define __pyx_float_0_199430 __pyx_mstate_global->__pyx_float_0_199430
#define __pyx_float_0_199721 __pyx_mstate_global->__pyx_float_0_199721
#define __pyx_float_0_201239 __pyx_mstate_global->__pyx_float_0_201239
#define __pyx_float_0_202219 __pyx_mstate_global->__pyx_float_0_202219
#define __pyx_float_0_203063 __pyx_mstate_global->__pyx_float_0_203063
#define __pyx_float_0_203082 __pyx_mstate_global->__pyx_float_0_203082
#define __pyx_float_0_204520 __pyx_mstate_global->__pyx_float_0_204520
#define __pyx_float_0_204903 __pyx_mstate_global->__pyx_float_0_204903
#define __pyx_float_0_206756 __pyx_mstate_global->__pyx_float_0_206756
#define __pyx_float_0_208030 __pyx_mstate_global->__pyx_float_0_208030
#define __pyx_float_0_208623 __pyx_mstate_global->__pyx_float_0_208623
#define __pyx_float_0_209303 __pyx_mstate_global->__pyx_float_0_209303
#define __pyx_float_0_209861 __pyx_mstate_global->__pyx_float_0_209861
#define __pyx_float_0_210503 __pyx_mstate_global->__pyx_float_0_210503
#define __pyx_float_0_212395 __pyx_mstate_global->__pyx_float_0_212395
#define __pyx_float_0_214000 __pyx_mstate_global->__pyx_float_0_214000
#define __pyx_float_0_214069 __pyx_mstate_global->__pyx_float_0_214069
#define __pyx_float_0_214298 __pyx_mstate_global->__pyx_float_0_214298
#define __pyx_float_0_216210 __pyx_mstate_global->__pyx_float_0_216210
#define __pyx_float_0_216620 __pyx_mstate_global->__pyx_float_0_216620
#define __pyx_float_0_218130 __pyx_mstate_global->__pyx_float_0_218130
#define __pyx_float_0_218818 __pyx_mstate_global->__pyx_float_0_218818
#define __pyx_float_0_220057 __pyx_mstate_global->__pyx_float_0_220057
#define __pyx_float_0_220124 __pyx_mstate_global->__pyx_float_0_220124
#define __pyx_float_0_221989 __pyx_mstate_global->__pyx_float_0_221989
#define __pyx_float_0_223353 __pyx_mstate_global->__pyx_float_0_223353
#define __pyx_float_0_223549 __pyx_mstate_global->__pyx_float_0_223549
#define __pyx_float_0_223925 __pyx_mstate_global->__pyx_float_0_223925
#define __pyx_float_0_225863 __pyx_mstate_global->__pyx_float_0_225863
#define __pyx_float_0_226397 __pyx_mstate_global->__pyx_float_0_226397
#define __pyx_float_0_227802 __pyx_mstate_global->__pyx_float_0_227802
#define __pyx_float_0_228262 __pyx_mstate_global->__pyx_float_0_228262
#define __pyx_float_0_229739 __pyx_mstate_global->__pyx_float_0_229739
#define __pyx_float_0_230052 __pyx_mstate_global->__pyx_float_0_230052
#define __pyx_float_0_231674 __pyx_mstate_global->__pyx_float_0_231674
#define __pyx_float_0_232815 __pyx_mstate_global->__pyx_float_0_232815
#define __pyx_float_0_232956 __pyx_mstate_global->__pyx_float_0_232956
#define __pyx_float_0_233603 __pyx_mstate_global->__pyx_float_0_233603
#define __pyx_float_0_235526 __pyx_mstate_global->__pyx_float_0_235526
#define __pyx_float_0_236712 __pyx_mstate_global->__pyx_float_0_236712
#define __pyx_float_0_237441 __pyx_mstate_global->__pyx_float_0_237441
#define __pyx_float_0_237631 __pyx_mstate_global->__pyx_float_0_237631
#define __pyx_float_0_239346 __pyx_mstate_global->__pyx_float_0_239346
#define __pyx_float_0_239374 __pyx_mstate_global->__pyx_float_0_239374
#define __pyx_float_0_241237 __pyx_mstate_global->__pyx_float_0_241237
#define __pyx_float_0_242286 __pyx_mstate_global->__pyx_float_0_242286
#define __pyx_float_0_243113 __pyx_mstate_global->__pyx_float_0_243113
#define __pyx_float_0_243329 __pyx_mstate_global->__pyx_float_0_243329
#define __pyx_float_0_244972 __pyx_mstate_global->__pyx_float_0_244972
#define __pyx_float_0_246070 __pyx_mstate_global->__pyx_float_0_246070
#define __pyx_float_0_246811 __pyx_mstate_global->__pyx_float_0_246811
#define __pyx_float_0_246922 __pyx_mstate_global->__pyx_float_0_246922
#define __pyx_float_0_248629 __pyx_mstate_global->__pyx_float_0_248629
#define __pyx_float_0_249897 __pyx_mstate_global->__pyx_float_0_249897
#define __pyx_float_0_250425 __pyx_mstate_global->__pyx_float_0_250425
#define __pyx_float_0_251537 __pyx_mstate_global->__pyx_float_0_251537
#define __pyx_float_0_252194 __pyx_mstate_global->__pyx_float_0_252194
#define __pyx_float_0_252899 __pyx_mstate_global->__pyx_float_0_252899
#define __pyx_float_0_253935 __pyx_mstate_global->__pyx_float_0_253935
#define __pyx_float_0_255645 __pyx_mstate_global->__pyx_float_0_255645
#define __pyx_float_0_256130 __pyx_mstate_global->__pyx_float_0_256130
#define __pyx_float_0_256415 __pyx_mstate_global->__pyx_float_0_256415
#define __pyx_float_0_257322 __pyx_mstate_global->__pyx_float_0_257322
#define __pyx_float_0_258965 __pyx_mstate_global->__pyx_float_0_258965
#define __pyx_float_0_259857 __pyx_mstate_global->__pyx_float_0_259857
#define __pyx_float_0_260571 __pyx_mstate_global->__pyx_float_0_260571
#define __pyx_float_0_260703 __pyx_mstate_global->__pyx_float_0_260703
#define __pyx_float_0_262138 __pyx_mstate_global->__pyx_float_0_262138
#define __pyx_float_0_262877 __pyx_mstate_global->__pyx_float_0_262877
#define __pyx_float_0_263663 __pyx_mstate_global->__pyx_float_0_263663
#define __pyx_float_0_265145 __pyx_mstate_global->__pyx_float_0_265145
#define __pyx_float_0_265254 __pyx_mstate_global->__pyx_float_0_265254
#define __pyx_float_0_266580 __pyx_mstate_global->__pyx_float_0_266580
#define __pyx_float_0_266941 __pyx_mstate_global->__pyx_float_0_266941
#define __pyx_float_0_267004 __pyx_mstate_global->__pyx_float_0_267004
#define __pyx_float_0_267968 __pyx_mstate_global->__pyx_float_0_267968
#define __pyx_float_0_268510 __pyx_mstate_global->__pyx_float_0_268510
#define __pyx_float_0_269281 __pyx_mstate_global->__pyx_float_0_269281
#define __pyx_float_0_269308 __pyx_mstate_global->__pyx_float_0_269308
#define __pyx_float_0_269783 __pyx_mstate_global->__pyx_float_0_269783
#define __pyx_float_0_269944 __pyx_mstate_global->__pyx_float_0_269944
#define __pyx_float_0_270595 __pyx_mstate_global->__pyx_float_0_270595
#define __pyx_float_0_271305 __pyx_mstate_global->__pyx_float_0_271305
#define __pyx_float_0_271828 __pyx_mstate_global->__pyx_float_0_271828
#define __pyx_float_0_272594 __pyx_mstate_global->__pyx_float_0_272594
#define __pyx_float_0_273006 __pyx_mstate_global->__pyx_float_0_273006
#define __pyx_float_0_273809 __pyx_mstate_global->__pyx_float_0_273809
#define __pyx_float_0_274128 __pyx_mstate_global->__pyx_float_0_274128
#define __pyx_float_0_274149 __pyx_mstate_global->__pyx_float_0_274149
#define __pyx_float_0_274290 __pyx_mstate_global->__pyx_float_0_274290
#define __pyx_float_0_274952 __pyx_mstate_global->__pyx_float_0_274952
#define __pyx_float_0_275191 __pyx_mstate_global->__pyx_float_0_275191
#define __pyx_float_0_275626 __pyx_mstate_global->__pyx_float_0_275626
#define __pyx_float_0_276022 __pyx_mstate_global->__pyx_float_0_276022
#define __pyx_float_0_276194 __pyx_mstate_global->__pyx_float_0_276194
#define __pyx_float_0_277018 __pyx_mstate_global->__pyx_float_0_277018
#define __pyx_float_0_277134 __pyx_mstate_global->__pyx_float_0_277134
#define __pyx_float_0_277941 __pyx_mstate_global->__pyx_float_0_277941
#define __pyx_float_0_278012 __pyx_mstate_global->__pyx_float_0_278012
#define __pyx_float_0_278775 __pyx_mstate_global->__pyx_float_0_278775
#define __pyx_float_0_278791 __pyx_mstate_global->__pyx_float_0_278791
#define __pyx_float_0_278826 __pyx_mstate_global->__pyx_float_0_278826
#define __pyx_float_0_279566 __pyx_mstate_global->__pyx_float_0_279566
#define __pyx_float_0_279574 __pyx_mstate_global->__pyx_float_0_279574
#define __pyx_float_0_280255 __pyx_mstate_global->__pyx_float_0_280255
#define __pyx_float_0_280267 __pyx_mstate_global->__pyx_float_0_280267
#define __pyx_float_0_280868 __pyx_mstate_global->__pyx_float_0_280868
#define __pyx_float_0_280894 __pyx_mstate_global->__pyx_float_0_280894
#define __pyx_float_0_281412 __pyx_mstate_global->__pyx_float_0_281412
#define __pyx_float_0_281446 __pyx_mstate_global->__pyx_float_0_281446
#define __pyx_float_0_281477 __pyx_mstate_global->__pyx_float_0_281477
#define __pyx_float_0_281887 __pyx_mstate_global->__pyx_float_0_281887
#define __pyx_float_0_281908 __pyx_mstate_global->__pyx_float_0_281908
#define __pyx_float_0_281924 __pyx_mstate_global->__pyx_float_0_281924
#define __pyx_float_0_282290 __pyx_mstate_global->__pyx_float_0_282290
#define __pyx_float_0_282327 __pyx_mstate_global->__pyx_float_0_282327
#define __pyx_float_0_282623 __pyx_mstate_global->__pyx_float_0_282623
#define __pyx_float_0_282656 __pyx_mstate_global->__pyx_float_0_282656
#define __pyx_float_0_282884 __pyx_mstate_global->__pyx_float_0_282884
#define __pyx_float_0_282910 __pyx_mstate_global->__pyx_float_0_282910
#define __pyx_float_0_283072 __pyx_mstate_global->__pyx_float_0_283072
#define __pyx_float_0_283091 __pyx_mstate_global->__pyx_float_0_283091
#define __pyx_float_0_283187 __pyx_mstate_global->__pyx_float_0_283187
#define __pyx_float_0_283197 __pyx_mstate_global->__pyx_float_0_283197
#define __pyx_float_0_283229 __pyx_mstate_global->__pyx_float_0_283229
#define __pyx_float_0_283237 __pyx_mstate_global->__pyx_float_0_283237
#define __pyx_float_0_287675 __pyx_mstate_global->__pyx_float_0_287675
#define __pyx_float_0_288127 __pyx_mstate_global->__pyx_float_0_288127
#define __pyx_float_0_288921 __pyx_mstate_global->__pyx_float_0_288921
#define __pyx_float_0_292092 __pyx_mstate_global->__pyx_float_0_292092
#define __pyx_float_0_294279 __pyx_mstate_global->__pyx_float_0_294279
#define __pyx_float_0_296479 __pyx_mstate_global->__pyx_float_0_296479
#define __pyx_float_0_296485 __pyx_mstate_global->__pyx_float_0_296485
#define __pyx_float_0_300362 __pyx_mstate_global->__pyx_float_0_300362
#define __pyx_float_0_300855 __pyx_mstate_global->__pyx_float_0_300855
#define __pyx_float_0_304148 __pyx_mstate_global->__pyx_float_0_304148
#define __pyx_float_0_305202 __pyx_mstate_global->__pyx_float_0_305202
#define __pyx_float_0_306377 __pyx_mstate_global->__pyx_float_0_306377
#define __pyx_float_0_309527 __pyx_mstate_global->__pyx_float_0_309527
#define __pyx_float_0_311925 __pyx_mstate_global->__pyx_float_0_311925
#define __pyx_float_0_312321 __pyx_mstate_global->__pyx_float_0_312321
#define __pyx_float_0_313828 __pyx_mstate_global->__pyx_float_0_313828
#define __pyx_float_0_318106 __pyx_mstate_global->__pyx_float_0_318106
#define __pyx_float_0_318195 __pyx_mstate_global->__pyx_float_0_318195
#define __pyx_float_0_319809 __pyx_mstate_global->__pyx_float_0_319809
#define __pyx_float_0_322361 __pyx_mstate_global->__pyx_float_0_322361
#define __pyx_float_0_323998 __pyx_mstate_global->__pyx_float_0_323998
#define __pyx_float_0_326594 __pyx_mstate_global->__pyx_float_0_326594
#define __pyx_float_0_327796 __pyx_mstate_global->__pyx_float_0_327796
#define __pyx_float_0_329415 __pyx_mstate_global->__pyx_float_0_329415
#define __pyx_float_0_329727 __pyx_mstate_global->__pyx_float_0_329727
#define __pyx_float_0_330805 __pyx_mstate_global->__pyx_float_0_330805
#define __pyx_float_0_334994 __pyx_mstate_global->__pyx_float_0_334994
#define __pyx_float_0_335384 __pyx_mstate_global->__pyx_float_0_335384
#define __pyx_float_0_335427 __pyx_mstate_global->__pyx_float_0_335427
#define __pyx_float_0_335885 __pyx_mstate_global->__pyx_float_0_335885
#define __pyx_float_0_339161 __pyx_mstate_global->__pyx_float_0_339161
#define __pyx_float_0_340967 __pyx_mstate_global->__pyx_float_0_340967
#define __pyx_float_0_341379 __pyx_mstate_global->__pyx_float_0_341379
#define __pyx_float_0_343307 __pyx_mstate_global->__pyx_float_0_343307
#define __pyx_float_0_344074 __pyx_mstate_global->__pyx_float_0_344074
#define __pyx_float_0_346476 __pyx_mstate_global->__pyx_float_0_346476
#define __pyx_float_0_347269 __pyx_mstate_global->__pyx_float_0_347269
#define __pyx_float_0_347432 __pyx_mstate_global->__pyx_float_0_347432
#define __pyx_float_0_351535 __pyx_mstate_global->__pyx_float_0_351535
#define __pyx_float_0_351910 __pyx_mstate_global->__pyx_float_0_351910
#define __pyx_float_0_352360 __pyx_mstate_global->__pyx_float_0_352360
#define __pyx_float_0_353093 __pyx_mstate_global->__pyx_float_0_353093
#define __pyx_float_0_355619 __pyx_mstate_global->__pyx_float_0_355619
#define __pyx_float_0_357269 __pyx_mstate_global->__pyx_float_0_357269
#define __pyx_float_0_358853 __pyx_mstate_global->__pyx_float_0_358853
#define __pyx_float_0_359683 __pyx_mstate_global->__pyx_float_0_359683
#define __pyx_float_0_360741 __pyx_mstate_global->__pyx_float_0_360741
#define __pyx_float_0_362552 __pyx_mstate_global->__pyx_float_0_362552
#define __pyx_float_0_363727 __pyx_mstate_global->__pyx_float_0_363727
#define __pyx_float_0_364543 __pyx_mstate_global->__pyx_float_0_364543
#define __pyx_float_0_367752 __pyx_mstate_global->__pyx_float_0_367752
#define __pyx_float_0_367757 __pyx_mstate_global->__pyx_float_0_367757
#define __pyx_float_0_369214 __pyx_mstate_global->__pyx_float_0_369214
#define __pyx_float_0_370164 __pyx_mstate_global->__pyx_float_0_370164
#define __pyx_float_0_371758 __pyx_mstate_global->__pyx_float_0_371758
#define __pyx_float_0_372886 __pyx_mstate_global->__pyx_float_0_372886
#define __pyx_float_0_375715 __pyx_mstate_global->__pyx_float_0_375715
#define __pyx_float_0_375746 __pyx_mstate_global->__pyx_float_0_375746
#define __pyx_float_0_377779 __pyx_mstate_global->__pyx_float_0_377779
#define __pyx_float_0_377939 __pyx_mstate_global->__pyx_float_0_377939
#define __pyx_float_0_379716 __pyx_mstate_global->__pyx_float_0_379716
#define __pyx_float_0_381191 __pyx_mstate_global->__pyx_float_0_381191
#define __pyx_float_0_382914 __pyx_mstate_global->__pyx_float_0_382914
#define __pyx_float_0_383670 __pyx_mstate_global->__pyx_float_0_383670
#define __pyx_float_0_386433 __pyx_mstate_global->__pyx_float_0_386433
#define __pyx_float_0_386592 __pyx_mstate_global->__pyx_float_0_386592
#define __pyx_float_0_387607 __pyx_mstate_global->__pyx_float_0_387607
#define __pyx_float_0_387814 __pyx_mstate_global->__pyx_float_0_387814
#define __pyx_float_0_391528 __pyx_mstate_global->__pyx_float_0_391528
#define __pyx_float_0_391917 __pyx_mstate_global->__pyx_float_0_391917
#define __pyx_float_0_392636 __pyx_mstate_global->__pyx_float_0_392636
#define __pyx_float_0_395174 __pyx_mstate_global->__pyx_float_0_395174
#define __pyx_float_0_395433 __pyx_mstate_global->__pyx_float_0_395433
#define __pyx_float_0_397163 __pyx_mstate_global->__pyx_float_0_397163
#define __pyx_float_0_397381 __pyx_mstate_global->__pyx_float_0_397381
#define __pyx_float_0_399323 __pyx_mstate_global->__pyx_float_0_399323
#define __pyx_float_0_402049 __pyx_mstate_global->__pyx_float_0_402049
#define __pyx_float_0_402329 __pyx_mstate_global->__pyx_float_0_402329
#define __pyx_float_0_403199 __pyx_mstate_global->__pyx_float_0_403199
#define __pyx_float_0_404001 __pyx_mstate_global->__pyx_float_0_404001
#define __pyx_float_0_406640 __pyx_mstate_global->__pyx_float_0_406640
#define __pyx_float_0_407061 __pyx_mstate_global->__pyx_float_0_407061
#define __pyx_float_0_407414 __pyx_mstate_global->__pyx_float_0_407414
#define __pyx_float_0_410910 __pyx_mstate_global->__pyx_float_0_410910
#define __pyx_float_0_411152 __pyx_mstate_global->__pyx_float_0_411152
#define __pyx_float_0_412415 __pyx_mstate_global->__pyx_float_0_412415
#define __pyx_float_0_412913 __pyx_mstate_global->__pyx_float_0_412913
#define __pyx_float_0_414746 __pyx_mstate_global->__pyx_float_0_414746
#define __pyx_float_0_415586 __pyx_mstate_global->__pyx_float_0_415586
#define __pyx_float_0_417331 __pyx_mstate_global->__pyx_float_0_417331
#define __pyx_float_0_418570 __pyx_mstate_global->__pyx_float_0_418570
#define __pyx_float_0_419943 __pyx_mstate_global->__pyx_float_0_419943
#define __pyx_float_0_421908 __pyx_mstate_global->__pyx_float_0_421908
#define __pyx_float_0_422160 __pyx_mstate_global->__pyx_float_0_422160
#define __pyx_float_0_422383 __pyx_mstate_global->__pyx_float_0_422383
#define __pyx_float_0_424223 __pyx_mstate_global->__pyx_float_0_424223
#define __pyx_float_0_426184 __pyx_mstate_global->__pyx_float_0_426184
#define __pyx_float_0_426902 __pyx_mstate_global->__pyx_float_0_426902
#define __pyx_float_0_428426 __pyx_mstate_global->__pyx_float_0_428426
#define __pyx_float_0_429975 __pyx_mstate_global->__pyx_float_0_429975
#define __pyx_float_0_430983 __pyx_mstate_global->__pyx_float_0_430983
#define __pyx_float_0_431554 __pyx_mstate_global->__pyx_float_0_431554
#define __pyx_float_0_432552 __pyx_mstate_global->__pyx_float_0_432552
#define __pyx_float_0_433756 __pyx_mstate_global->__pyx_float_0_433756
#define __pyx_float_0_436115 __pyx_mstate_global->__pyx_float_0_436115
#define __pyx_float_0_436601 __pyx_mstate_global->__pyx_float_0_436601
#define __pyx_float_0_437527 __pyx_mstate_global->__pyx_float_0_437527
#define __pyx_float_0_440137 __pyx_mstate_global->__pyx_float_0_440137
#define __pyx_float_0_440573 __pyx_mstate_global->__pyx_float_0_440573
#define __pyx_float_0_440584 __pyx_mstate_global->__pyx_float_0_440584
#define __pyx_float_0_441290 __pyx_mstate_global->__pyx_float_0_441290
#define __pyx_float_0_444467 __pyx_mstate_global->__pyx_float_0_444467
#define __pyx_float_0_444960 __pyx_mstate_global->__pyx_float_0_444960
#define __pyx_float_0_445044 __pyx_mstate_global->__pyx_float_0_445044
#define __pyx_float_0_448284 __pyx_mstate_global->__pyx_float_0_448284
#define __pyx_float_0_448791 __pyx_mstate_global->__pyx_float_0_448791
#define __pyx_float_0_449241 __pyx_mstate_global->__pyx_float_0_449241
#define __pyx_float_0_449368 __pyx_mstate_global->__pyx_float_0_449368
#define __pyx_float_0_452024 __pyx_mstate_global->__pyx_float_0_452024
#define __pyx_float_0_452530 __pyx_mstate_global->__pyx_float_0_452530
#define __pyx_float_0_453427 __pyx_mstate_global->__pyx_float_0_453427
#define __pyx_float_0_455688 __pyx_mstate_global->__pyx_float_0_455688
#define __pyx_float_0_456262 __pyx_mstate_global->__pyx_float_0_456262
#define __pyx_float_0_457517 __pyx_mstate_global->__pyx_float_0_457517
#define __pyx_float_0_458674 __pyx_mstate_global->__pyx_float_0_458674
#define __pyx_float_0_459277 __pyx_mstate_global->__pyx_float_0_459277
#define __pyx_float_0_459988 __pyx_mstate_global->__pyx_float_0_459988
#define __pyx_float_0_461510 __pyx_mstate_global->__pyx_float_0_461510
#define __pyx_float_0_462789 __pyx_mstate_global->__pyx_float_0_462789
#define __pyx_float_0_463708 __pyx_mstate_global->__pyx_float_0_463708
#define __pyx_float_0_465405 __pyx_mstate_global->__pyx_float_0_465405
#define __pyx_float_0_466226 __pyx_mstate_global->__pyx_float_0_466226
#define __pyx_float_0_467423 __pyx_mstate_global->__pyx_float_0_467423
#define __pyx_float_0_468053 __pyx_mstate_global->__pyx_float_0_468053
#define __pyx_float_0_469201 __pyx_mstate_global->__pyx_float_0_469201
#define __pyx_float_0_469588 __pyx_mstate_global->__pyx_float_0_469588
#define __pyx_float_0_471133 __pyx_mstate_global->__pyx_float_0_471133
#define __pyx_float_0_472873 __pyx_mstate_global->__pyx_float_0_472873
#define __pyx_float_0_472899 __pyx_mstate_global->__pyx_float_0_472899
#define __pyx_float_0_474838 __pyx_mstate_global->__pyx_float_0_474838
#define __pyx_float_0_476084 __pyx_mstate_global->__pyx_float_0_476084
#define __pyx_float_0_476498 __pyx_mstate_global->__pyx_float_0_476498
#define __pyx_float_0_477504 __pyx_mstate_global->__pyx_float_0_477504
#define __pyx_float_0_478540 __pyx_mstate_global->__pyx_float_0_478540
#define __pyx_float_0_479221 __pyx_mstate_global->__pyx_float_0_479221
#define __pyx_float_0_479997 __pyx_mstate_global->__pyx_float_0_479997
#define __pyx_float_0_482237 __pyx_mstate_global->__pyx_float_0_482237
#define __pyx_float_0_482284 __pyx_mstate_global->__pyx_float_0_482284
#define __pyx_float_0_483397 __pyx_mstate_global->__pyx_float_0_483397
#define __pyx_float_0_485273 __pyx_mstate_global->__pyx_float_0_485273
#define __pyx_float_0_485932 __pyx_mstate_global->__pyx_float_0_485932
#define __pyx_float_0_486697 __pyx_mstate_global->__pyx_float_0_486697
#define __pyx_float_0_487026 __pyx_mstate_global->__pyx_float_0_487026
#define __pyx_float_0_488189 __pyx_mstate_global->__pyx_float_0_488189
#define __pyx_float_0_489624 __pyx_mstate_global->__pyx_float_0_489624
#define __pyx_float_0_489898 __pyx_mstate_global->__pyx_float_0_489898
#define __pyx_float_0_491033 __pyx_mstate_global->__pyx_float_0_491033
#define __pyx_float_0_493001 __pyx_mstate_global->__pyx_float_0_493001
#define __pyx_float_0_493313 __pyx_mstate_global->__pyx_float_0_493313
#define __pyx_float_0_493803 __pyx_mstate_global->__pyx_float_0_493803
#define __pyx_float_0_496005 __pyx_mstate_global->__pyx_float_0_496005
#define __pyx_float_0_496502 __pyx_mstate_global->__pyx_float_0_496502
#define __pyx_float_0_496615 __pyx_mstate_global->__pyx_float_0_496615
#define __pyx_float_0_497000 __pyx_mstate_global->__pyx_float_0_497000
#define __pyx_float_0_498911 __pyx_mstate_global->__pyx_float_0_498911
#define __pyx_float_0_499129 __pyx_mstate_global->__pyx_float_0_499129
#define __pyx_float_0_500685 __pyx_mstate_global->__pyx_float_0_500685
#define __pyx_float_0_501686 __pyx_mstate_global->__pyx_float_0_501686
#define __pyx_float_0_501721 __pyx_mstate_global->__pyx_float_0_501721
#define __pyx_float_0_504172 __pyx_mstate_global->__pyx_float_0_504172
#define __pyx_float_0_504369 __pyx_mstate_global->__pyx_float_0_504369
#define __pyx_float_0_504434 __pyx_mstate_global->__pyx_float_0_504434
#define __pyx_float_0_506271 __pyx_mstate_global->__pyx_float_0_506271
#define __pyx_float_0_506589 __pyx_mstate_global->__pyx_float_0_506589
#define __pyx_float_0_507052 __pyx_mstate_global->__pyx_float_0_507052
#define __pyx_float_0_508051 __pyx_mstate_global->__pyx_float_0_508051
#define __pyx_float_0_508936 __pyx_mstate_global->__pyx_float_0_508936
#define __pyx_float_0_509577 __pyx_mstate_global->__pyx_float_0_509577
#define __pyx_float_0_511215 __pyx_mstate_global->__pyx_float_0_511215
#define __pyx_float_0_511733 __pyx_mstate_global->__pyx_float_0_511733
#define __pyx_float_0_512008 __pyx_mstate_global->__pyx_float_0_512008
#define __pyx_float_0_513427 __pyx_mstate_global->__pyx_float_0_513427
#define __pyx_float_0_514349 __pyx_mstate_global->__pyx_float_0_514349
#define __pyx_float_0_515413 __pyx_mstate_global->__pyx_float_0_515413
#define __pyx_float_0_515571 __pyx_mstate_global->__pyx_float_0_515571
#define __pyx_float_0_515992 __pyx_mstate_global->__pyx_float_0_515992
#define __pyx_float_0_516599 __pyx_mstate_global->__pyx_float_0_516599
#define __pyx_float_0_517649 __pyx_mstate_global->__pyx_float_0_517649
#define __pyx_float_0_518762 __pyx_mstate_global->__pyx_float_0_518762
#define __pyx_float_0_519093 __pyx_mstate_global->__pyx_float_0_519093
#define __pyx_float_0_519661 __pyx_mstate_global->__pyx_float_0_519661
#define __pyx_float_0_520837 __pyx_mstate_global->__pyx_float_0_520837
#define __pyx_float_0_521608 __pyx_mstate_global->__pyx_float_0_521608
#define __pyx_float_0_522773 __pyx_mstate_global->__pyx_float_0_522773
#define __pyx_float_0_522828 __pyx_mstate_global->__pyx_float_0_522828
#define __pyx_float_0_523491 __pyx_mstate_global->__pyx_float_0_523491
#define __pyx_float_0_524736 __pyx_mstate_global->__pyx_float_0_524736
#define __pyx_float_0_525311 __pyx_mstate_global->__pyx_float_0_525311
#define __pyx_float_0_525776 __pyx_mstate_global->__pyx_float_0_525776
#define __pyx_float_0_526453 __pyx_mstate_global->__pyx_float_0_526453
#define __pyx_float_0_526563 __pyx_mstate_global->__pyx_float_0_526563
#define __pyx_float_0_527068 __pyx_mstate_global->__pyx_float_0_527068
#define __pyx_float_0_528312 __pyx_mstate_global->__pyx_float_0_528312
#define __pyx_float_0_528763 __pyx_mstate_global->__pyx_float_0_528763
#define __pyx_float_0_529983 __pyx_mstate_global->__pyx_float_0_529983
#define __pyx_float_0_530132 __pyx_mstate_global->__pyx_float_0_530132
#define __pyx_float_0_530398 __pyx_mstate_global->__pyx_float_0_530398
#define __pyx_float_0_531579 __pyx_mstate_global->__pyx_float_0_531579
#define __pyx_float_0_531973 __pyx_mstate_global->__pyx_float_0_531973
#define __pyx_float_0_533103 __pyx_mstate_global->__pyx_float_0_533103
#define __pyx_float_0_533488 __pyx_mstate_global->__pyx_float_0_533488
#define __pyx_float_0_533812 __pyx_mstate_global->__pyx_float_0_533812
#define __pyx_float_0_534556 __pyx_mstate_global->__pyx_float_0_534556
#define __pyx_float_0_534946 __pyx_mstate_global->__pyx_float_0_534946
#define __pyx_float_0_535621 __pyx_mstate_global->__pyx_float_0_535621
#define __pyx_float_0_535941 __pyx_mstate_global->__pyx_float_0_535941
#define __pyx_float_0_536347 __pyx_mstate_global->__pyx_float_0_536347
#define __pyx_float_0_537260 __pyx_mstate_global->__pyx_float_0_537260
#define __pyx_float_0_537492 __pyx_mstate_global->__pyx_float_0_537492
#define __pyx_float_0_537692 __pyx_mstate_global->__pyx_float_0_537692
#define __pyx_float_0_538516 __pyx_mstate_global->__pyx_float_0_538516
#define __pyx_float_0_538982 __pyx_mstate_global->__pyx_float_0_538982
#define __pyx_float_0_539709 __pyx_mstate_global->__pyx_float_0_539709
#define __pyx_float_0_540218 __pyx_mstate_global->__pyx_float_0_540218
#define __pyx_float_0_540844 __pyx_mstate_global->__pyx_float_0_540844
#define __pyx_float_0_541173 __pyx_mstate_global->__pyx_float_0_541173
#define __pyx_float_0_541400 __pyx_mstate_global->__pyx_float_0_541400
#define __pyx_float_0_541921 __pyx_mstate_global->__pyx_float_0_541921
#define __pyx_float_0_542530 __pyx_mstate_global->__pyx_float_0_542530
#define __pyx_float_0_542944 __pyx_mstate_global->__pyx_float_0_542944
#define __pyx_float_0_543611 __pyx_mstate_global->__pyx_float_0_543611
#define __pyx_float_0_543914 __pyx_mstate_global->__pyx_float_0_543914
#define __pyx_float_0_544641 __pyx_mstate_global->__pyx_float_0_544641
#define __pyx_float_0_544834 __pyx_mstate_global->__pyx_float_0_544834
#define __pyx_float_0_544853 __pyx_mstate_global->__pyx_float_0_544853
#define __pyx_float_0_545524 __pyx_mstate_global->__pyx_float_0_545524
#define __pyx_float_0_545623 __pyx_mstate_global->__pyx_float_0_545623
#define __pyx_float_0_545706 __pyx_mstate_global->__pyx_float_0_545706
#define __pyx_float_0_546532 __pyx_mstate_global->__pyx_float_0_546532
#define __pyx_float_0_546557 __pyx_mstate_global->__pyx_float_0_546557
#define __pyx_float_0_547314 __pyx_mstate_global->__pyx_float_0_547314
#define __pyx_float_0_547445 __pyx_mstate_global->__pyx_float_0_547445
#define __pyx_float_0_548053 __pyx_mstate_global->__pyx_float_0_548053
#define __pyx_float_0_548287 __pyx_mstate_global->__pyx_float_0_548287
#define __pyx_float_0_548535 __pyx_mstate_global->__pyx_float_0_548535
#define __pyx_float_0_548752 __pyx_mstate_global->__pyx_float_0_548752
#define __pyx_float_0_549086 __pyx_mstate_global->__pyx_float_0_549086
#define __pyx_float_0_549413 __pyx_mstate_global->__pyx_float_0_549413
#define __pyx_float_0_549841 __pyx_mstate_global->__pyx_float_0_549841
#define __pyx_float_0_550038 __pyx_mstate_global->__pyx_float_0_550038
#define __pyx_float_0_550556 __pyx_mstate_global->__pyx_float_0_550556
#define __pyx_float_0_550627 __pyx_mstate_global->__pyx_float_0_550627
#define __pyx_float_0_551184 __pyx_mstate_global->__pyx_float_0_551184
#define __pyx_float_0_551229 __pyx_mstate_global->__pyx_float_0_551229
#define __pyx_float_0_551710 __pyx_mstate_global->__pyx_float_0_551710
#define __pyx_float_0_551864 __pyx_mstate_global->__pyx_float_0_551864
#define __pyx_float_0_552206 __pyx_mstate_global->__pyx_float_0_552206
#define __pyx_float_0_552216 __pyx_mstate_global->__pyx_float_0_552216
#define __pyx_float_0_552459 __pyx_mstate_global->__pyx_float_0_552459
#define __pyx_float_0_552675 __pyx_mstate_global->__pyx_float_0_552675
#define __pyx_float_0_553018 __pyx_mstate_global->__pyx_float_0_553018
#define __pyx_float_0_553117 __pyx_mstate_global->__pyx_float_0_553117
#define __pyx_float_0_553533 __pyx_mstate_global->__pyx_float_0_553533
#define __pyx_float_0_553541 __pyx_mstate_global->__pyx_float_0_553541
#define __pyx_float_0_553925 __pyx_mstate_global->__pyx_float_0_553925
#define __pyx_float_0_554029 __pyx_mstate_global->__pyx_float_0_554029
#define __pyx_float_0_554294 __pyx_mstate_global->__pyx_float_0_554294
#define __pyx_float_0_554483 __pyx_mstate_global->__pyx_float_0_554483
#define __pyx_float_0_554642 __pyx_mstate_global->__pyx_float_0_554642
#define __pyx_float_0_554906 __pyx_mstate_global->__pyx_float_0_554906
#define __pyx_float_0_554969 __pyx_mstate_global->__pyx_float_0_554969
#define __pyx_float_0_555276 __pyx_mstate_global->__pyx_float_0_555276
#define __pyx_float_0_555298 __pyx_mstate_global->__pyx_float_0_555298
#define __pyx_float_0_555484 __pyx_mstate_global->__pyx_float_0_555484
#define __pyx_float_0_555565 __pyx_mstate_global->__pyx_float_0_555565
#define __pyx_float_0_555659 __pyx_mstate_global->__pyx_float_0_555659
#define __pyx_float_0_555836 __pyx_mstate_global->__pyx_float_0_555836
#define __pyx_float_0_555899 __pyx_mstate_global->__pyx_float_0_555899
#define __pyx_float_0_555991 __pyx_mstate_global->__pyx_float_0_555991
#define __pyx_float_0_556089 __pyx_mstate_global->__pyx_float_0_556089
#define __pyx_float_0_556295 __pyx_mstate_global->__pyx_float_0_556295
#define __pyx_float_0_556326 __pyx_mstate_global->__pyx_float_0_556326
#define __pyx_float_0_556547 __pyx_mstate_global->__pyx_float_0_556547
#define __pyx_float_0_556572 __pyx_mstate_global->__pyx_float_0_556572
#define __pyx_float_0_556753 __pyx_mstate_global->__pyx_float_0_556753
#define __pyx_float_0_556823 __pyx_mstate_global->__pyx_float_0_556823
#define __pyx_float_0_556944 __pyx_mstate_global->__pyx_float_0_556944
#define __pyx_float_0_557049 __pyx_mstate_global->__pyx_float_0_557049
#define __pyx_float_0_557120 __pyx_mstate_global->__pyx_float_0_557120
#define __pyx_float_0_557250 __pyx_mstate_global->__pyx_float_0_557250
#define __pyx_float_0_557282 __pyx_mstate_global->__pyx_float_0_557282
#define __pyx_float_0_557430 __pyx_mstate_global->__pyx_float_0_557430
#define __pyx_float_0_557565 __pyx_mstate_global->__pyx_float_0_557565
#define __pyx_float_0_557587 __pyx_mstate_global->__pyx_float_0_557587
#define __pyx_float_0_557685 __pyx_mstate_global->__pyx_float_0_557685
#define __pyx_float_0_557724 __pyx_mstate_global->__pyx_float_0_557724
#define __pyx_float_0_557792 __pyx_mstate_global->__pyx_float_0_557792
#define __pyx_float_0_557840 __pyx_mstate_global->__pyx_float_0_557840
#define __pyx_float_0_557885 __pyx_mstate_global->__pyx_float_0_557885
#define __pyx_float_0_557936 __pyx_mstate_global->__pyx_float_0_557936
#define __pyx_float_0_557965 __pyx_mstate_global->__pyx_float_0_557965
#define __pyx_float_0_558013 __pyx_mstate_global->__pyx_float_0_558013
#define __pyx_float_0_558030 __pyx_mstate_global->__pyx_float_0_558030
#define __pyx_float_0_558073 __pyx_mstate_global->__pyx_float_0_558073
#define __pyx_float_0_558082 __pyx_mstate_global->__pyx_float_0_558082
#define __pyx_float_0_558115 __pyx_mstate_global->__pyx_float_0_558115
#define __pyx_float_0_558119 __pyx_mstate_global->__pyx_float_0_558119
#define __pyx_float_0_558140 __pyx_mstate_global->__pyx_float_0_558140
#define __pyx_float_0_558141 __pyx_mstate_global->__pyx_float_0_558141
#define __pyx_float_0_558148 __pyx_mstate_global->__pyx_float_0_558148
#define __pyx_float_0_559582 __pyx_mstate_global->__pyx_float_0_559582
#define __pyx_float_0_563265 __pyx_mstate_global->__pyx_float_0_563265
#define __pyx_float_0_565498 __pyx_mstate_global->__pyx_float_0_565498
#define __pyx_float_0_566949 __pyx_mstate_global->__pyx_float_0_566949
#define __pyx_float_0_570633 __pyx_mstate_global->__pyx_float_0_570633
#define __pyx_float_0_574318 __pyx_mstate_global->__pyx_float_0_574318
#define __pyx_float_0_575563 __pyx_mstate_global->__pyx_float_0_575563
#define __pyx_float_0_578002 __pyx_mstate_global->__pyx_float_0_578002
#define __pyx_float_0_581687 __pyx_mstate_global->__pyx_float_0_581687
#define __pyx_float_0_585371 __pyx_mstate_global->__pyx_float_0_585371
#define __pyx_float_0_585678 __pyx_mstate_global->__pyx_float_0_585678
#define __pyx_float_0_589055 __pyx_mstate_global->__pyx_float_0_589055
#define __pyx_float_0_592739 __pyx_mstate_global->__pyx_float_0_592739
#define __pyx_float_0_595839 __pyx_mstate_global->__pyx_float_0_595839
#define __pyx_float_0_596422 __pyx_mstate_global->__pyx_float_0_596422
#define __pyx_float_0_600104 __pyx_mstate_global->__pyx_float_0_600104
#define __pyx_float_0_603785 __pyx_mstate_global->__pyx_float_0_603785
#define __pyx_float_0_606045 __pyx_mstate_global->__pyx_float_0_606045
#define __pyx_float_0_607464 __pyx_mstate_global->__pyx_float_0_607464
#define __pyx_float_0_611141 __pyx_mstate_global->__pyx_float_0_611141
#define __pyx_float_0_614817 __pyx_mstate_global->__pyx_float_0_614817
#define __pyx_float_0_616293 __pyx_mstate_global->__pyx_float_0_616293
#define __pyx_float_0_618490 __pyx_mstate_global->__pyx_float_0_618490
#define __pyx_float_0_622161 __pyx_mstate_global->__pyx_float_0_622161
#define __pyx_float_0_625828 __pyx_mstate_global->__pyx_float_0_625828
#define __pyx_float_0_626579 __pyx_mstate_global->__pyx_float_0_626579
#define __pyx_float_0_629492 __pyx_mstate_global->__pyx_float_0_629492
#define __pyx_float_0_633153 __pyx_mstate_global->__pyx_float_0_633153
#define __pyx_float_0_636809 __pyx_mstate_global->__pyx_float_0_636809
#define __pyx_float_0_636902 __pyx_mstate_global->__pyx_float_0_636902
#define __pyx_float_0_640461 __pyx_mstate_global->__pyx_float_0_640461
#define __pyx_float_0_644107 __pyx_mstate_global->__pyx_float_0_644107
#define __pyx_float_0_647257 __pyx_mstate_global->__pyx_float_0_647257
#define __pyx_float_0_647749 __pyx_mstate_global->__pyx_float_0_647749
#define __pyx_float_0_651384 __pyx_mstate_global->__pyx_float_0_651384
#define __pyx_float_0_655014 __pyx_mstate_global->__pyx_float_0_655014
#define __pyx_float_0_657642 __pyx_mstate_global->__pyx_float_0_657642
#define __pyx_float_0_658636 __pyx_mstate_global->__pyx_float_0_658636
#define __pyx_float_0_662252 __pyx_mstate_global->__pyx_float_0_662252
#define __pyx_float_0_665859 __pyx_mstate_global->__pyx_float_0_665859
#define __pyx_float_0_668054 __pyx_mstate_global->__pyx_float_0_668054
#define __pyx_float_0_669459 __pyx_mstate_global->__pyx_float_0_669459
#define __pyx_float_0_673050 __pyx_mstate_global->__pyx_float_0_673050
#define __pyx_float_0_676631 __pyx_mstate_global->__pyx_float_0_676631
#define __pyx_float_0_678489 __pyx_mstate_global->__pyx_float_0_678489
#define __pyx_float_0_680203 __pyx_mstate_global->__pyx_float_0_680203
#define __pyx_float_0_683765 __pyx_mstate_global->__pyx_float_0_683765
#define __pyx_float_0_687316 __pyx_mstate_global->__pyx_float_0_687316
#define __pyx_float_0_688944 __pyx_mstate_global->__pyx_float_0_688944
#define __pyx_float_0_690856 __pyx_mstate_global->__pyx_float_0_690856
#define __pyx_float_0_694384 __pyx_mstate_global->__pyx_float_0_694384
#define __pyx_float_0_697900 __pyx_mstate_global->__pyx_float_0_697900
#define __pyx_float_0_699415 __pyx_mstate_global->__pyx_float_0_699415
#define __pyx_float_0_701402 __pyx_mstate_global->__pyx_float_0_701402
#define __pyx_float_0_704891 __pyx_mstate_global->__pyx_float_0_704891
#define __pyx_float_0_708366 __pyx_mstate_global->__pyx_float_0_708366
#define __pyx_float_0_709898 __pyx_mstate_global->__pyx_float_0_709898
#define __pyx_float_0_711827 __pyx_mstate_global->__pyx_float_0_711827
#define __pyx_float_0_715272 __pyx_mstate_global->__pyx_float_0_715272
#define __pyx_float_0_718701 __pyx_mstate_global->__pyx_float_0_718701
#define __pyx_float_0_720391 __pyx_mstate_global->__pyx_float_0_720391
#define __pyx_float_0_722114 __pyx_mstate_global->__pyx_float_0_722114
#define __pyx_float_0_725509 __pyx_mstate_global->__pyx_float_0_725509
#define __pyx_float_0_728888 __pyx_mstate_global->__pyx_float_0_728888
#define __pyx_float_0_730889 __pyx_mstate_global->__pyx_float_0_730889
#define __pyx_float_0_732247 __pyx_mstate_global->__pyx_float_0_732247
#define __pyx_float_0_735588 __pyx_mstate_global->__pyx_float_0_735588
#define __pyx_float_0_738910 __pyx_mstate_global->__pyx_float_0_738910
#define __pyx_float_0_741388 __pyx_mstate_global->__pyx_float_0_741388
#define __pyx_float_0_742211 __pyx_mstate_global->__pyx_float_0_742211
#define __pyx_float_0_745492 __pyx_mstate_global->__pyx_float_0_745492
#define __pyx_float_0_748751 __pyx_mstate_global->__pyx_float_0_748751
#define __pyx_float_0_751884 __pyx_mstate_global->__pyx_float_0_751884
#define __pyx_float_0_751988 __pyx_mstate_global->__pyx_float_0_751988
#define __pyx_float_0_755203 __pyx_mstate_global->__pyx_float_0_755203
#define __pyx_float_0_758394 __pyx_mstate_global->__pyx_float_0_758394
#define __pyx_float_0_761561 __pyx_mstate_global->__pyx_float_0_761561
#define __pyx_float_0_762373 __pyx_mstate_global->__pyx_float_0_762373
#define __pyx_float_0_764704 __pyx_mstate_global->__pyx_float_0_764704
#define __pyx_float_0_767822 __pyx_mstate_global->__pyx_float_0_767822
#define __pyx_float_0_770914 __pyx_mstate_global->__pyx_float_0_770914
#define __pyx_float_0_772852 __pyx_mstate_global->__pyx_float_0_772852
#define __pyx_float_0_773980 __pyx_mstate_global->__pyx_float_0_773980
#define __pyx_float_0_777018 __pyx_mstate_global->__pyx_float_0_777018
#define __pyx_float_0_780029 __pyx_mstate_global->__pyx_float_0_780029
#define __pyx_float_0_783011 __pyx_mstate_global->__pyx_float_0_783011
#define __pyx_float_0_783315 __pyx_mstate_global->__pyx_float_0_783315
#define __pyx_float_0_785964 __pyx_mstate_global->__pyx_float_0_785964
#define __pyx_float_0_788888 __pyx_mstate_global->__pyx_float_0_788888
#define __pyx_float_0_791781 __pyx_mstate_global->__pyx_float_0_791781
#define __pyx_float_0_793760 __pyx_mstate_global->__pyx_float_0_793760
#define __pyx_float_0_794644 __pyx_mstate_global->__pyx_float_0_794644
#define __pyx_float_0_797475 __pyx_mstate_global->__pyx_float_0_797475
#define __pyx_float_0_800275 __pyx_mstate_global->__pyx_float_0_800275
#define __pyx_float_0_803041 __pyx_mstate_global->__pyx_float_0_803041
#define __pyx_float_0_804182 __pyx_mstate_global->__pyx_float_0_804182
#define __pyx_float_0_805774 __pyx_mstate_global->__pyx_float_0_805774
#define __pyx_float_0_808473 __pyx_mstate_global->__pyx_float_0_808473
#define __pyx_float_0_811138 __pyx_mstate_global->__pyx_float_0_811138
#define __pyx_float_0_813768 __pyx_mstate_global->__pyx_float_0_813768
#define __pyx_float_0_814576 __pyx_mstate_global->__pyx_float_0_814576
#define __pyx_float_0_816363 __pyx_mstate_global->__pyx_float_0_816363
#define __pyx_float_0_818921 __pyx_mstate_global->__pyx_float_0_818921
#define __pyx_float_0_821444 __pyx_mstate_global->__pyx_float_0_821444
#define __pyx_float_0_823929 __pyx_mstate_global->__pyx_float_0_823929
#define __pyx_float_0_824940 __pyx_mstate_global->__pyx_float_0_824940
#define __pyx_float_0_826376 __pyx_mstate_global->__pyx_float_0_826376
#define __pyx_float_0_828786 __pyx_mstate_global->__pyx_float_0_828786
#define __pyx_float_0_831158 __pyx_mstate_global->__pyx_float_0_831158
#define __pyx_float_0_833491 __pyx_mstate_global->__pyx_float_0_833491
#define __pyx_float_0_835270 __pyx_mstate_global->__pyx_float_0_835270
#define __pyx_float_0_835785 __pyx_mstate_global->__pyx_float_0_835785
#define __pyx_float_0_838039 __pyx_mstate_global->__pyx_float_0_838039
#define __pyx_float_0_840254 __pyx_mstate_global->__pyx_float_0_840254
#define __pyx_float_0_842430 __pyx_mstate_global->__pyx_float_0_842430
#define __pyx_float_0_844566 __pyx_mstate_global->__pyx_float_0_844566
#define __pyx_float_0_845561 __pyx_mstate_global->__pyx_float_0_845561
#define __pyx_float_0_846661 __pyx_mstate_global->__pyx_float_0_846661
#define __pyx_float_0_848717 __pyx_mstate_global->__pyx_float_0_848717
#define __pyx_float_0_850733 __pyx_mstate_global->__pyx_float_0_850733
#define __pyx_float_0_852709 __pyx_mstate_global->__pyx_float_0_852709
#define __pyx_float_0_854645 __pyx_mstate_global->__pyx_float_0_854645
#define __pyx_float_0_855810 __pyx_mstate_global->__pyx_float_0_855810
#define __pyx_float_0_856542 __pyx_mstate_global->__pyx_float_0_856542
#define __pyx_float_0_858400 __pyx_mstate_global->__pyx_float_0_858400
#define __pyx_float_0_860219 __pyx_mstate_global->__pyx_float_0_860219
#define __pyx_float_0_861999 __pyx_mstate_global->__pyx_float_0_861999
#define __pyx_float_0_863742 __pyx_mstate_global->__pyx_float_0_863742
#define __pyx_float_0_865448 __pyx_mstate_global->__pyx_float_0_865448
#define __pyx_float_0_866013 __pyx_mstate_global->__pyx_float_0_866013
#define __pyx_float_0_867117 __pyx_mstate_global->__pyx_float_0_867117
#define __pyx_float_0_868751 __pyx_mstate_global->__pyx_float_0_868751
#define __pyx_float_0_870350 __pyx_mstate_global->__pyx_float_0_870350
#define __pyx_float_0_871916 __pyx_mstate_global->__pyx_float_0_871916
#define __pyx_float_0_873449 __pyx_mstate_global->__pyx_float_0_873449
#define __pyx_float_0_874951 __pyx_mstate_global->__pyx_float_0_874951
#define __pyx_float_0_876168 __pyx_mstate_global->__pyx_float_0_876168
#define __pyx_float_0_876424 __pyx_mstate_global->__pyx_float_0_876424
#define __pyx_float_0_877868 __pyx_mstate_global->__pyx_float_0_877868
#define __pyx_float_0_879285 __pyx_mstate_global->__pyx_float_0_879285
#define __pyx_float_0_880678 __pyx_mstate_global->__pyx_float_0_880678
#define __pyx_float_0_882046 __pyx_mstate_global->__pyx_float_0_882046
#define __pyx_float_0_883393 __pyx_mstate_global->__pyx_float_0_883393
#define __pyx_float_0_884720 __pyx_mstate_global->__pyx_float_0_884720
#define __pyx_float_0_886029 __pyx_mstate_global->__pyx_float_0_886029
#define __pyx_float_0_886271 __pyx_mstate_global->__pyx_float_0_886271
#define __pyx_float_0_887322 __pyx_mstate_global->__pyx_float_0_887322
#define __pyx_float_0_888601 __pyx_mstate_global->__pyx_float_0_888601
#define __pyx_float_0_889868 __pyx_mstate_global->__pyx_float_0_889868
#define __pyx_float_0_891125 __pyx_mstate_global->__pyx_float_0_891125
#define __pyx_float_0_892374 __pyx_mstate_global->__pyx_float_0_892374
#define __pyx_float_0_893616 __pyx_mstate_global->__pyx_float_0_893616
#define __pyx_float_0_894855 __pyx_mstate_global->__pyx_float_0_894855
#define __pyx_float_0_896091 __pyx_mstate_global->__pyx_float_0_896091
#define __pyx_float_0_896320 __pyx_mstate_global->__pyx_float_0_896320
#define __pyx_float_0_897330 __pyx_mstate_global->__pyx_float_0_897330
#define __pyx_float_0_898570 __pyx_mstate_global->__pyx_float_0_898570
#define __pyx_float_0_899815 __pyx_mstate_global->__pyx_float_0_899815
#define __pyx_float_0_901065 __pyx_mstate_global->__pyx_float_0_901065
#define __pyx_float_0_902323 __pyx_mstate_global->__pyx_float_0_902323
#define __pyx_float_0_903590 __pyx_mstate_global->__pyx_float_0_903590
#define __pyx_float_0_904867 __pyx_mstate_global->__pyx_float_0_904867
#define __pyx_float_0_906157 __pyx_mstate_global->__pyx_float_0_906157
#define __pyx_float_0_906311 __pyx_mstate_global->__pyx_float_0_906311
#define __pyx_float_0_916242 __pyx_mstate_global->__pyx_float_0_916242
#define __pyx_float_0_926106 __pyx_mstate_global->__pyx_float_0_926106
#define __pyx_float_0_935904 __pyx_mstate_global->__pyx_float_0_935904
#define __pyx_float_0_945636 __pyx_mstate_global->__pyx_float_0_945636
#define __pyx_float_0_955300 __pyx_mstate_global->__pyx_float_0_955300
#define __pyx_float_0_964894 __pyx_mstate_global->__pyx_float_0_964894
#define __pyx_float_0_974417 __pyx_mstate_global->__pyx_float_0_974417
#define __pyx_float_0_983868 __pyx_mstate_global->__pyx_float_0_983868
#define __pyx_float_0_993248 __pyx_mstate_global->__pyx_float_0_993248
#define __pyx_float_0_032852381 __pyx_mstate_global->__pyx_float_0_032852381
#define __pyx_float_0_079347619 __pyx_mstate_global->__pyx_float_0_079347619
#define __pyx_float_0_147452381 __pyx_mstate_global->__pyx_float_0_147452381
#define __pyx_float_0_196652381 __pyx_mstate_global->__pyx_float_0_196652381
#define __pyx_float_0_212252381 __pyx_mstate_global->__pyx_float_0_212252381
#define __pyx_float_0_240347619 __pyx_mstate_global->__pyx_float_0_240347619
#define __pyx_float_0_266647619 __pyx_mstate_global->__pyx_float_0_266647619
#define __pyx_float_0_609852381 __pyx_mstate_global->__pyx_float_0_609852381
#define __pyx_float_0_743552381 __pyx_mstate_global->__pyx_float_0_743552381
#define __pyx_float_0_779247619 __pyx_mstate_global->__pyx_float_0_779247619
#define __pyx_float_0_819852381 __pyx_mstate_global->__pyx_float_0_819852381
#define __pyx_float_0_0059571429 __pyx_mstate_global->__pyx_float_0_0059571429
#define __pyx_float_0_0116952381 __pyx_mstate_global->__pyx_float_0_0116952381
#define __pyx_float_0_0165142857 __pyx_mstate_global->__pyx_float_0_0165142857
#define __pyx_float_0_0227714286 __pyx_mstate_global->__pyx_float_0_0227714286
#define __pyx_float_0_0230904762 __pyx_mstate_global->__pyx_float_0_0230904762
#define __pyx_float_0_0238904762 __pyx_mstate_global->__pyx_float_0_0238904762
#define __pyx_float_0_0266619048 __pyx_mstate_global->__pyx_float_0_0266619048
#define __pyx_float_0_0343428571 __pyx_mstate_global->__pyx_float_0_0343428571
#define __pyx_float_0_0383714286 __pyx_mstate_global->__pyx_float_0_0383714286
#define __pyx_float_0_0487714286 __pyx_mstate_global->__pyx_float_0_0487714286
#define __pyx_float_0_0498142857 __pyx_mstate_global->__pyx_float_0_0498142857
#define __pyx_float_0_0589714286 __pyx_mstate_global->__pyx_float_0_0589714286
#define __pyx_float_0_0591333333 __pyx_mstate_global->__pyx_float_0_0591333333
#define __pyx_float_0_0629333333 __pyx_mstate_global->__pyx_float_0_0629333333
#define __pyx_float_0_0640571429 __pyx_mstate_global->__pyx_float_0_0640571429
#define __pyx_float_0_0722666667 __pyx_mstate_global->__pyx_float_0_0722666667
#define __pyx_float_0_0749428571 __pyx_mstate_global->__pyx_float_0_0749428571
#define __pyx_float_0_0755333333 __pyx_mstate_global->__pyx_float_0_0755333333
#define __pyx_float_0_0779428571 __pyx_mstate_global->__pyx_float_0_0779428571
#define __pyx_float_0_0948380952 __pyx_mstate_global->__pyx_float_0_0948380952
#define __pyx_float_0_1132428571 __pyx_mstate_global->__pyx_float_0_1132428571
#define __pyx_float_0_1132952381 __pyx_mstate_global->__pyx_float_0_1132952381
#define __pyx_float_0_1252714286 __pyx_mstate_global->__pyx_float_0_1252714286
#define __pyx_float_0_1452714286 __pyx_mstate_global->__pyx_float_0_1452714286
#define __pyx_float_0_1633142857 __pyx_mstate_global->__pyx_float_0_1633142857
#define __pyx_float_0_1707285714 __pyx_mstate_global->__pyx_float_0_1707285714
#define __pyx_float_0_1793666667 __pyx_mstate_global->__pyx_float_0_1793666667
#define __pyx_float_0_1801333333 __pyx_mstate_global->__pyx_float_0_1801333333
#define __pyx_float_0_1897809524 __pyx_mstate_global->__pyx_float_0_1897809524
#define __pyx_float_0_1959047619 __pyx_mstate_global->__pyx_float_0_1959047619
#define __pyx_float_0_2116238095 __pyx_mstate_global->__pyx_float_0_2116238095
#define __pyx_float_0_2137714286 __pyx_mstate_global->__pyx_float_0_2137714286
#define __pyx_float_0_2164142857 __pyx_mstate_global->__pyx_float_0_2164142857
#define __pyx_float_0_2178285714 __pyx_mstate_global->__pyx_float_0_2178285714
#define __pyx_float_0_2586428571 __pyx_mstate_global->__pyx_float_0_2586428571
#define __pyx_float_0_2644571429 __pyx_mstate_global->__pyx_float_0_2644571429
#define __pyx_float_0_2886428571 __pyx_mstate_global->__pyx_float_0_2886428571
#define __pyx_float_0_2919380952 __pyx_mstate_global->__pyx_float_0_2919380952
#define __pyx_float_0_3021714286 __pyx_mstate_global->__pyx_float_0_3021714286
#define __pyx_float_0_3062761905 __pyx_mstate_global->__pyx_float_0_3062761905
#define __pyx_float_0_3242428571 __pyx_mstate_global->__pyx_float_0_3242428571
#define __pyx_float_0_3360285714 __pyx_mstate_global->__pyx_float_0_3360285714
#define __pyx_float_0_3481666667 __pyx_mstate_global->__pyx_float_0_3481666667
#define __pyx_float_0_3497904762 __pyx_mstate_global->__pyx_float_0_3497904762
#define __pyx_float_0_3598333333 __pyx_mstate_global->__pyx_float_0_3598333333
#define __pyx_float_0_3632714286 __pyx_mstate_global->__pyx_float_0_3632714286
#define __pyx_float_0_3768142857 __pyx_mstate_global->__pyx_float_0_3768142857
#define __pyx_float_0_3875095238 __pyx_mstate_global->__pyx_float_0_3875095238
#define __pyx_float_0_3904761905 __pyx_mstate_global->__pyx_float_0_3904761905
#define __pyx_float_0_3952571429 __pyx_mstate_global->__pyx_float_0_3952571429
#define __pyx_float_0_4044333333 __pyx_mstate_global->__pyx_float_0_4044333333
#define __pyx_float_0_4086142857 __pyx_mstate_global->__pyx_float_0_4086142857
#define __pyx_float_0_4336857143 __pyx_mstate_global->__pyx_float_0_4336857143
#define __pyx_float_0_4420095238 __pyx_mstate_global->__pyx_float_0_4420095238
#define __pyx_float_0_4430428571 __pyx_mstate_global->__pyx_float_0_4430428571
#define __pyx_float_0_4493904762 __pyx_mstate_global->__pyx_float_0_4493904762
#define __pyx_float_0_4585714286 __pyx_mstate_global->__pyx_float_0_4585714286
#define __pyx_float_0_4661142857 __pyx_mstate_global->__pyx_float_0_4661142857
#define __pyx_float_0_4736904762 __pyx_mstate_global->__pyx_float_0_4736904762
#define __pyx_float_0_4839761905 __pyx_mstate_global->__pyx_float_0_4839761905
#define __pyx_float_0_4871238095 __pyx_mstate_global->__pyx_float_0_4871238095
#define __pyx_float_0_4886666667 __pyx_mstate_global->__pyx_float_0_4886666667
#define __pyx_float_0_5033142857 __pyx_mstate_global->__pyx_float_0_5033142857
#define __pyx_float_0_5039857143 __pyx_mstate_global->__pyx_float_0_5039857143
#define __pyx_float_0_5200238095 __pyx_mstate_global->__pyx_float_0_5200238095
#define __pyx_float_0_5244428571 __pyx_mstate_global->__pyx_float_0_5244428571
#define __pyx_float_0_5300285714 __pyx_mstate_global->__pyx_float_0_5300285714
#define __pyx_float_0_5375428571 __pyx_mstate_global->__pyx_float_0_5375428571
#define __pyx_float_0_5472666667 __pyx_mstate_global->__pyx_float_0_5472666667
#define __pyx_float_0_5569857143 __pyx_mstate_global->__pyx_float_0_5569857143
#define __pyx_float_0_5708571429 __pyx_mstate_global->__pyx_float_0_5708571429
#define __pyx_float_0_5711857143 __pyx_mstate_global->__pyx_float_0_5711857143
#define __pyx_float_0_5772238095 __pyx_mstate_global->__pyx_float_0_5772238095
#define __pyx_float_0_5776761905 __pyx_mstate_global->__pyx_float_0_5776761905
#define __pyx_float_0_5954285714 __pyx_mstate_global->__pyx_float_0_5954285714
#define __pyx_float_0_5965809524 __pyx_mstate_global->__pyx_float_0_5965809524
#define __pyx_float_0_6192619048 __pyx_mstate_global->__pyx_float_0_6192619048
#define __pyx_float_0_6269714286 __pyx_mstate_global->__pyx_float_0_6269714286
#define __pyx_float_0_6286619048 __pyx_mstate_global->__pyx_float_0_6286619048
#define __pyx_float_0_6417857143 __pyx_mstate_global->__pyx_float_0_6417857143
#define __pyx_float_0_6424333333 __pyx_mstate_global->__pyx_float_0_6424333333
#define __pyx_float_0_6534857143 __pyx_mstate_global->__pyx_float_0_6534857143
#define __pyx_float_0_6641952381 __pyx_mstate_global->__pyx_float_0_6641952381
#define __pyx_float_0_6646285714 __pyx_mstate_global->__pyx_float_0_6646285714
#define __pyx_float_0_6742714286 __pyx_mstate_global->__pyx_float_0_6742714286
#define __pyx_float_0_6770857143 __pyx_mstate_global->__pyx_float_0_6770857143
#define __pyx_float_0_6834190476 __pyx_mstate_global->__pyx_float_0_6834190476
#define __pyx_float_0_6837571429 __pyx_mstate_global->__pyx_float_0_6837571429
#define __pyx_float_0_6858571429 __pyx_mstate_global->__pyx_float_0_6858571429
#define __pyx_float_0_6928333333 __pyx_mstate_global->__pyx_float_0_6928333333
#define __pyx_float_0_7061666667 __pyx_mstate_global->__pyx_float_0_7061666667
#define __pyx_float_0_7097571429 __pyx_mstate_global->__pyx_float_0_7097571429
#define __pyx_float_0_7176571429 __pyx_mstate_global->__pyx_float_0_7176571429
#define __pyx_float_0_7184095238 __pyx_mstate_global->__pyx_float_0_7184095238
#define __pyx_float_0_7250428571 __pyx_mstate_global->__pyx_float_0_7250428571
#define __pyx_float_0_7253857143 __pyx_mstate_global->__pyx_float_0_7253857143
#define __pyx_float_0_7257857143 __pyx_mstate_global->__pyx_float_0_7257857143
#define __pyx_float_0_7261142857 __pyx_mstate_global->__pyx_float_0_7261142857
#define __pyx_float_0_7274333333 __pyx_mstate_global->__pyx_float_0_7274333333
#define __pyx_float_0_7313952381 __pyx_mstate_global->__pyx_float_0_7313952381
#define __pyx_float_0_7317142857 __pyx_mstate_global->__pyx_float_0_7317142857
#define __pyx_float_0_7327333333 __pyx_mstate_global->__pyx_float_0_7327333333
#define __pyx_float_0_7355666667 __pyx_mstate_global->__pyx_float_0_7355666667
#define __pyx_float_0_7376047619 __pyx_mstate_global->__pyx_float_0_7376047619
#define __pyx_float_0_7411333333 __pyx_mstate_global->__pyx_float_0_7411333333
#define __pyx_float_0_7424333333 __pyx_mstate_global->__pyx_float_0_7424333333
#define __pyx_float_0_7434761905 __pyx_mstate_global->__pyx_float_0_7434761905
#define __pyx_float_0_7454571429 __pyx_mstate_global->__pyx_float_0_7454571429
#define __pyx_float_0_7473142857 __pyx_mstate_global->__pyx_float_0_7473142857
#define __pyx_float_0_7480809524 __pyx_mstate_global->__pyx_float_0_7480809524
#define __pyx_float_0_7485190476 __pyx_mstate_global->__pyx_float_0_7485190476
#define __pyx_float_0_7490619048 __pyx_mstate_global->__pyx_float_0_7490619048
#define __pyx_float_0_7491142857 __pyx_mstate_global->__pyx_float_0_7491142857
#define __pyx_float_0_7524857143 __pyx_mstate_global->__pyx_float_0_7524857143
#define __pyx_float_0_7607190476 __pyx_mstate_global->__pyx_float_0_7607190476
#define __pyx_float_0_7653142857 __pyx_mstate_global->__pyx_float_0_7653142857
#define __pyx_float_0_7767571429 __pyx_mstate_global->__pyx_float_0_7767571429
#define __pyx_float_0_7858428571 __pyx_mstate_global->__pyx_float_0_7858428571
#define __pyx_float_0_7860571429 __pyx_mstate_global->__pyx_float_0_7860571429
#define __pyx_float_0_7912666667 __pyx_mstate_global->__pyx_float_0_7912666667
#define __pyx_float_0_8037619048 __pyx_mstate_global->__pyx_float_0_8037619048
#define __pyx_float_0_8185047619 __pyx_mstate_global->__pyx_float_0_8185047619
#define __pyx_float_0_8228285714 __pyx_mstate_global->__pyx_float_0_8228285714
#define __pyx_float_0_8239571429 __pyx_mstate_global->__pyx_float_0_8239571429
#define __pyx_float_0_8262714286 __pyx_mstate_global->__pyx_float_0_8262714286
#define __pyx_float_0_8271428571 __pyx_mstate_global->__pyx_float_0_8271428571
#define __pyx_float_0_8302714286 __pyx_mstate_global->__pyx_float_0_8302714286
#define __pyx_float_0_8311809524 __pyx_mstate_global->__pyx_float_0_8311809524
#define __pyx_float_0_8383714286 __pyx_mstate_global->__pyx_float_0_8383714286
#define __pyx_float_0_8481380952 __pyx_mstate_global->__pyx_float_0_8481380952
#define __pyx_float_0_8506571429 __pyx_mstate_global->__pyx_float_0_8506571429
#define __pyx_float_0_8554380952 __pyx_mstate_global->__pyx_float_0_8554380952
#define __pyx_float_0_8640571429 __pyx_mstate_global->__pyx_float_0_8640571429
#define __pyx_float_0_8683333333 __pyx_mstate_global->__pyx_float_0_8683333333
#define __pyx_float_0_8705142857 __pyx_mstate_global->__pyx_float_0_8705142857
#define __pyx_float_0_8719571429 __pyx_mstate_global->__pyx_float_0_8719571429
#define __pyx_float_0_8786333333 __pyx_mstate_global->__pyx_float_0_8786333333
#define __pyx_float_0_8819571429 __pyx_mstate_global->__pyx_float_0_8819571429
#define __pyx_float_0_8824333333 __pyx_mstate_global->__pyx_float_0_8824333333
#define __pyx_float_0_8828428571 __pyx_mstate_global->__pyx_float_0_8828428571
#define __pyx_float_0_9139333333 __pyx_mstate_global->__pyx_float_0_9139333333
#define __pyx_float_0_9218333333 __pyx_mstate_global->__pyx_float_0_9218333333
#define __pyx_float_0_9449571429 __pyx_mstate_global->__pyx_float_0_9449571429
#define __pyx_float_0_9514428571 __pyx_mstate_global->__pyx_float_0_9514428571
#define __pyx_float_0_9588714286 __pyx_mstate_global->__pyx_float_0_9588714286
#define __pyx_float_0_9598238095 __pyx_mstate_global->__pyx_float_0_9598238095
#define __pyx_float_0_9625857143 __pyx_mstate_global->__pyx_float_0_9625857143
#define __pyx_float_0_9738952381 __pyx_mstate_global->__pyx_float_0_9738952381
#define __pyx_float_0_9788571429 __pyx_mstate_global->__pyx_float_0_9788571429
#define __pyx_float_0_9937714286 __pyx_mstate_global->__pyx_float_0_9937714286
#define __pyx_float_0_9955333333 __pyx_mstate_global->__pyx_float_0_9955333333
#define __pyx_float_0_9990428571 __pyx_mstate_global->__pyx_float_0_9990428571


static PyMethodDef __pyx_methods[] = {
  {0, 0, 0, 0}
};
#ifndef CYTHON_SMALL_CODE
#if defined(__clang__)
    #define CYTHON_SMALL_CODE
#elif defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 3))
    #define CYTHON_SMALL_CODE __attribute__((cold))
#else
    #define CYTHON_SMALL_CODE
#endif
#endif


static int __Pyx_CreateStringTabAndInitStrings(void) {
  __Pyx_StringTabEntry __pyx_string_tab[] = {
    {&__pyx_n_s_, __pyx_k_, sizeof(__pyx_k_), 0, 0, 1, 1},
    {&__pyx_n_s_ListedColormap, __pyx_k_ListedColormap, sizeof(__pyx_k_ListedColormap), 0, 0, 1, 1},
    {&__pyx_kp_u__2, __pyx_k__2, sizeof(__pyx_k__2), 0, 1, 0, 0},
    {&__pyx_n_s__3, __pyx_k__3, sizeof(__pyx_k__3), 0, 0, 1, 1},
    {&__pyx_n_s_all, __pyx_k_all, sizeof(__pyx_k_all), 0, 0, 1, 1},
    {&__pyx_n_s_cline_in_traceback, __pyx_k_cline_in_traceback, sizeof(__pyx_k_cline_in_traceback), 0, 0, 1, 1},
    {&__pyx_n_s_cmaps, __pyx_k_cmaps, sizeof(__pyx_k_cmaps), 0, 0, 1, 1},
    {&__pyx_n_s_data, __pyx_k_data, sizeof(__pyx_k_data), 0, 0, 1, 1},
    {&__pyx_n_s_import, __pyx_k_import, sizeof(__pyx_k_import), 0, 0, 1, 1},
    {&__pyx_n_s_initializing, __pyx_k_initializing, sizeof(__pyx_k_initializing), 0, 0, 1, 1},
    {&__pyx_n_s_main, __pyx_k_main, sizeof(__pyx_k_main), 0, 0, 1, 1},
    {&__pyx_n_s_matplotlib_colors, __pyx_k_matplotlib_colors, sizeof(__pyx_k_matplotlib_colors), 0, 0, 1, 1},
    {&__pyx_n_s_name, __pyx_k_name, sizeof(__pyx_k_name), 0, 0, 1, 1},
    {&__pyx_n_s_name_2, __pyx_k_name_2, sizeof(__pyx_k_name_2), 0, 0, 1, 1},
    {&__pyx_n_s_parula, __pyx_k_parula, sizeof(__pyx_k_parula), 0, 0, 1, 1},
    {&__pyx_n_u_parula, __pyx_k_parula, sizeof(__pyx_k_parula), 0, 1, 0, 1},
    {&__pyx_n_s_parula_data, __pyx_k_parula_data, sizeof(__pyx_k_parula_data), 0, 0, 1, 1},
    {&__pyx_n_s_spec, __pyx_k_spec, sizeof(__pyx_k_spec), 0, 0, 1, 1},
    {&__pyx_n_s_test, __pyx_k_test, sizeof(__pyx_k_test), 0, 0, 1, 1},
    {&__pyx_n_s_th, __pyx_k_th, sizeof(__pyx_k_th), 0, 0, 1, 1},
    {&__pyx_n_s_torch, __pyx_k_torch, sizeof(__pyx_k_torch), 0, 0, 1, 1},
    {&__pyx_n_s_viridis, __pyx_k_viridis, sizeof(__pyx_k_viridis), 0, 0, 1, 1},
    {&__pyx_n_u_viridis, __pyx_k_viridis, sizeof(__pyx_k_viridis), 0, 1, 0, 1},
    {&__pyx_n_s_viridis_data, __pyx_k_viridis_data, sizeof(__pyx_k_viridis_data), 0, 0, 1, 1},
    {0, 0, 0, 0, 0, 0, 0}
  };
  return __Pyx_InitStrings(__pyx_string_tab);
}

static CYTHON_SMALL_CODE int __Pyx_InitCachedBuiltins(void) {
  return 0;
}


static CYTHON_SMALL_CODE int __Pyx_InitCachedConstants(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_InitCachedConstants", 0);
  __Pyx_RefNannyFinishContext();
  return 0;
}


static CYTHON_SMALL_CODE int __Pyx_InitConstants(void) {
  if (__Pyx_CreateStringTabAndInitStrings() < 0) __PYX_ERR(0, 1, __pyx_L1_error);
  __pyx_float_0_988 = PyFloat_FromDouble(0.988); if (unlikely(!__pyx_float_0_988)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0265 = PyFloat_FromDouble(0.0265); if (unlikely(!__pyx_float_0_0265)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0538 = PyFloat_FromDouble(0.0538); if (unlikely(!__pyx_float_0_0538)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0843 = PyFloat_FromDouble(0.0843); if (unlikely(!__pyx_float_0_0843)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1309 = PyFloat_FromDouble(0.1309); if (unlikely(!__pyx_float_0_1309)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1663 = PyFloat_FromDouble(0.1663); if (unlikely(!__pyx_float_0_1663)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2081 = PyFloat_FromDouble(0.2081); if (unlikely(!__pyx_float_0_2081)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2386 = PyFloat_FromDouble(0.2386); if (unlikely(!__pyx_float_0_2386)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3217 = PyFloat_FromDouble(0.3217); if (unlikely(!__pyx_float_0_3217)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4188 = PyFloat_FromDouble(0.4188); if (unlikely(!__pyx_float_0_4188)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4266 = PyFloat_FromDouble(0.4266); if (unlikely(!__pyx_float_0_4266)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5292 = PyFloat_FromDouble(0.5292); if (unlikely(!__pyx_float_0_5292)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6137 = PyFloat_FromDouble(0.6137); if (unlikely(!__pyx_float_0_6137)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6473 = PyFloat_FromDouble(0.6473); if (unlikely(!__pyx_float_0_6473)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7015 = PyFloat_FromDouble(0.7015); if (unlikely(!__pyx_float_0_7015)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7279 = PyFloat_FromDouble(0.7279); if (unlikely(!__pyx_float_0_7279)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7299 = PyFloat_FromDouble(0.7299); if (unlikely(!__pyx_float_0_7299)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7384 = PyFloat_FromDouble(0.7384); if (unlikely(!__pyx_float_0_7384)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7456 = PyFloat_FromDouble(0.7456); if (unlikely(!__pyx_float_0_7456)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7459 = PyFloat_FromDouble(0.7459); if (unlikely(!__pyx_float_0_7459)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8066 = PyFloat_FromDouble(0.8066); if (unlikely(!__pyx_float_0_8066)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8135 = PyFloat_FromDouble(0.8135); if (unlikely(!__pyx_float_0_8135)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8467 = PyFloat_FromDouble(0.8467); if (unlikely(!__pyx_float_0_8467)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8949 = PyFloat_FromDouble(0.8949); if (unlikely(!__pyx_float_0_8949)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9661 = PyFloat_FromDouble(0.9661); if (unlikely(!__pyx_float_0_9661)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9697 = PyFloat_FromDouble(0.9697); if (unlikely(!__pyx_float_0_9697)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9763 = PyFloat_FromDouble(0.9763); if (unlikely(!__pyx_float_0_9763)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9831 = PyFloat_FromDouble(0.9831); if (unlikely(!__pyx_float_0_9831)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_004874 = PyFloat_FromDouble(0.004874); if (unlikely(!__pyx_float_0_004874)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_009605 = PyFloat_FromDouble(0.009605); if (unlikely(!__pyx_float_0_009605)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_014625 = PyFloat_FromDouble(0.014625); if (unlikely(!__pyx_float_0_014625)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_019942 = PyFloat_FromDouble(0.019942); if (unlikely(!__pyx_float_0_019942)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_025563 = PyFloat_FromDouble(0.025563); if (unlikely(!__pyx_float_0_025563)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_031497 = PyFloat_FromDouble(0.031497); if (unlikely(!__pyx_float_0_031497)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_037752 = PyFloat_FromDouble(0.037752); if (unlikely(!__pyx_float_0_037752)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_044167 = PyFloat_FromDouble(0.044167); if (unlikely(!__pyx_float_0_044167)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_050344 = PyFloat_FromDouble(0.050344); if (unlikely(!__pyx_float_0_050344)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_056324 = PyFloat_FromDouble(0.056324); if (unlikely(!__pyx_float_0_056324)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_062145 = PyFloat_FromDouble(0.062145); if (unlikely(!__pyx_float_0_062145)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_067836 = PyFloat_FromDouble(0.067836); if (unlikely(!__pyx_float_0_067836)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_073417 = PyFloat_FromDouble(0.073417); if (unlikely(!__pyx_float_0_073417)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_078907 = PyFloat_FromDouble(0.078907); if (unlikely(!__pyx_float_0_078907)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_084320 = PyFloat_FromDouble(0.084320); if (unlikely(!__pyx_float_0_084320)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_089666 = PyFloat_FromDouble(0.089666); if (unlikely(!__pyx_float_0_089666)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_094955 = PyFloat_FromDouble(0.094955); if (unlikely(!__pyx_float_0_094955)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_095250 = PyFloat_FromDouble(0.095250); if (unlikely(!__pyx_float_0_095250)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_095374 = PyFloat_FromDouble(0.095374); if (unlikely(!__pyx_float_0_095374)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_095953 = PyFloat_FromDouble(0.095953); if (unlikely(!__pyx_float_0_095953)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_096335 = PyFloat_FromDouble(0.096335); if (unlikely(!__pyx_float_0_096335)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_097452 = PyFloat_FromDouble(0.097452); if (unlikely(!__pyx_float_0_097452)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_098125 = PyFloat_FromDouble(0.098125); if (unlikely(!__pyx_float_0_098125)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_099702 = PyFloat_FromDouble(0.099702); if (unlikely(!__pyx_float_0_099702)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_100196 = PyFloat_FromDouble(0.100196); if (unlikely(!__pyx_float_0_100196)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_100717 = PyFloat_FromDouble(0.100717); if (unlikely(!__pyx_float_0_100717)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_102646 = PyFloat_FromDouble(0.102646); if (unlikely(!__pyx_float_0_102646)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_104071 = PyFloat_FromDouble(0.104071); if (unlikely(!__pyx_float_0_104071)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_105393 = PyFloat_FromDouble(0.105393); if (unlikely(!__pyx_float_0_105393)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_106217 = PyFloat_FromDouble(0.106217); if (unlikely(!__pyx_float_0_106217)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_108131 = PyFloat_FromDouble(0.108131); if (unlikely(!__pyx_float_0_108131)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_110347 = PyFloat_FromDouble(0.110347); if (unlikely(!__pyx_float_0_110347)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_110553 = PyFloat_FromDouble(0.110553); if (unlikely(!__pyx_float_0_110553)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_112838 = PyFloat_FromDouble(0.112838); if (unlikely(!__pyx_float_0_112838)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_114965 = PyFloat_FromDouble(0.114965); if (unlikely(!__pyx_float_0_114965)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_115680 = PyFloat_FromDouble(0.115680); if (unlikely(!__pyx_float_0_115680)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_118128 = PyFloat_FromDouble(0.118128); if (unlikely(!__pyx_float_0_118128)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_119423 = PyFloat_FromDouble(0.119423); if (unlikely(!__pyx_float_0_119423)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_119483 = PyFloat_FromDouble(0.119483); if (unlikely(!__pyx_float_0_119483)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_119512 = PyFloat_FromDouble(0.119512); if (unlikely(!__pyx_float_0_119512)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_119699 = PyFloat_FromDouble(0.119699); if (unlikely(!__pyx_float_0_119699)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_119738 = PyFloat_FromDouble(0.119738); if (unlikely(!__pyx_float_0_119738)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_120005 = PyFloat_FromDouble(0.120005); if (unlikely(!__pyx_float_0_120005)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_120081 = PyFloat_FromDouble(0.120081); if (unlikely(!__pyx_float_0_120081)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_120092 = PyFloat_FromDouble(0.120092); if (unlikely(!__pyx_float_0_120092)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_120565 = PyFloat_FromDouble(0.120565); if (unlikely(!__pyx_float_0_120565)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_120638 = PyFloat_FromDouble(0.120638); if (unlikely(!__pyx_float_0_120638)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_120777 = PyFloat_FromDouble(0.120777); if (unlikely(!__pyx_float_0_120777)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_121148 = PyFloat_FromDouble(0.121148); if (unlikely(!__pyx_float_0_121148)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_121380 = PyFloat_FromDouble(0.121380); if (unlikely(!__pyx_float_0_121380)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_121831 = PyFloat_FromDouble(0.121831); if (unlikely(!__pyx_float_0_121831)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_122312 = PyFloat_FromDouble(0.122312); if (unlikely(!__pyx_float_0_122312)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_122606 = PyFloat_FromDouble(0.122606); if (unlikely(!__pyx_float_0_122606)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_123444 = PyFloat_FromDouble(0.123444); if (unlikely(!__pyx_float_0_123444)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_123463 = PyFloat_FromDouble(0.123463); if (unlikely(!__pyx_float_0_123463)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_123941 = PyFloat_FromDouble(0.123941); if (unlikely(!__pyx_float_0_123941)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_124395 = PyFloat_FromDouble(0.124395); if (unlikely(!__pyx_float_0_124395)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_124780 = PyFloat_FromDouble(0.124780); if (unlikely(!__pyx_float_0_124780)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_125394 = PyFloat_FromDouble(0.125394); if (unlikely(!__pyx_float_0_125394)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_125405 = PyFloat_FromDouble(0.125405); if (unlikely(!__pyx_float_0_125405)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_125848 = PyFloat_FromDouble(0.125848); if (unlikely(!__pyx_float_0_125848)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_126326 = PyFloat_FromDouble(0.126326); if (unlikely(!__pyx_float_0_126326)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_126453 = PyFloat_FromDouble(0.126453); if (unlikely(!__pyx_float_0_126453)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_127568 = PyFloat_FromDouble(0.127568); if (unlikely(!__pyx_float_0_127568)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_128087 = PyFloat_FromDouble(0.128087); if (unlikely(!__pyx_float_0_128087)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_128729 = PyFloat_FromDouble(0.128729); if (unlikely(!__pyx_float_0_128729)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_129933 = PyFloat_FromDouble(0.129933); if (unlikely(!__pyx_float_0_129933)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_130067 = PyFloat_FromDouble(0.130067); if (unlikely(!__pyx_float_0_130067)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_130215 = PyFloat_FromDouble(0.130215); if (unlikely(!__pyx_float_0_130215)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_130895 = PyFloat_FromDouble(0.130895); if (unlikely(!__pyx_float_0_130895)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_131109 = PyFloat_FromDouble(0.131109); if (unlikely(!__pyx_float_0_131109)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_131172 = PyFloat_FromDouble(0.131172); if (unlikely(!__pyx_float_0_131172)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_132268 = PyFloat_FromDouble(0.132268); if (unlikely(!__pyx_float_0_132268)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_132444 = PyFloat_FromDouble(0.132444); if (unlikely(!__pyx_float_0_132444)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_133743 = PyFloat_FromDouble(0.133743); if (unlikely(!__pyx_float_0_133743)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_134692 = PyFloat_FromDouble(0.134692); if (unlikely(!__pyx_float_0_134692)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_135066 = PyFloat_FromDouble(0.135066); if (unlikely(!__pyx_float_0_135066)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_135920 = PyFloat_FromDouble(0.135920); if (unlikely(!__pyx_float_0_135920)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_136408 = PyFloat_FromDouble(0.136408); if (unlikely(!__pyx_float_0_136408)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_136897 = PyFloat_FromDouble(0.136897); if (unlikely(!__pyx_float_0_136897)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_137064 = PyFloat_FromDouble(0.137064); if (unlikely(!__pyx_float_0_137064)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_137339 = PyFloat_FromDouble(0.137339); if (unlikely(!__pyx_float_0_137339)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_137770 = PyFloat_FromDouble(0.137770); if (unlikely(!__pyx_float_0_137770)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_139147 = PyFloat_FromDouble(0.139147); if (unlikely(!__pyx_float_0_139147)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_140210 = PyFloat_FromDouble(0.140210); if (unlikely(!__pyx_float_0_140210)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_140536 = PyFloat_FromDouble(0.140536); if (unlikely(!__pyx_float_0_140536)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_140926 = PyFloat_FromDouble(0.140926); if (unlikely(!__pyx_float_0_140926)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_141935 = PyFloat_FromDouble(0.141935); if (unlikely(!__pyx_float_0_141935)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_143228 = PyFloat_FromDouble(0.143228); if (unlikely(!__pyx_float_0_143228)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_143303 = PyFloat_FromDouble(0.143303); if (unlikely(!__pyx_float_0_143303)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_143343 = PyFloat_FromDouble(0.143343); if (unlikely(!__pyx_float_0_143343)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_143936 = PyFloat_FromDouble(0.143936); if (unlikely(!__pyx_float_0_143936)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_144759 = PyFloat_FromDouble(0.144759); if (unlikely(!__pyx_float_0_144759)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_145912 = PyFloat_FromDouble(0.145912); if (unlikely(!__pyx_float_0_145912)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_146180 = PyFloat_FromDouble(0.146180); if (unlikely(!__pyx_float_0_146180)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_146616 = PyFloat_FromDouble(0.146616); if (unlikely(!__pyx_float_0_146616)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_147607 = PyFloat_FromDouble(0.147607); if (unlikely(!__pyx_float_0_147607)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_149039 = PyFloat_FromDouble(0.149039); if (unlikely(!__pyx_float_0_149039)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_149561 = PyFloat_FromDouble(0.149561); if (unlikely(!__pyx_float_0_149561)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_150148 = PyFloat_FromDouble(0.150148); if (unlikely(!__pyx_float_0_150148)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_150476 = PyFloat_FromDouble(0.150476); if (unlikely(!__pyx_float_0_150476)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_150881 = PyFloat_FromDouble(0.150881); if (unlikely(!__pyx_float_0_150881)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_151918 = PyFloat_FromDouble(0.151918); if (unlikely(!__pyx_float_0_151918)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_153364 = PyFloat_FromDouble(0.153364); if (unlikely(!__pyx_float_0_153364)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_153894 = PyFloat_FromDouble(0.153894); if (unlikely(!__pyx_float_0_153894)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_154815 = PyFloat_FromDouble(0.154815); if (unlikely(!__pyx_float_0_154815)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_155834 = PyFloat_FromDouble(0.155834); if (unlikely(!__pyx_float_0_155834)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_156029 = PyFloat_FromDouble(0.156029); if (unlikely(!__pyx_float_0_156029)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_156270 = PyFloat_FromDouble(0.156270); if (unlikely(!__pyx_float_0_156270)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_157729 = PyFloat_FromDouble(0.157729); if (unlikely(!__pyx_float_0_157729)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_157851 = PyFloat_FromDouble(0.157851); if (unlikely(!__pyx_float_0_157851)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_159194 = PyFloat_FromDouble(0.159194); if (unlikely(!__pyx_float_0_159194)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_160665 = PyFloat_FromDouble(0.160665); if (unlikely(!__pyx_float_0_160665)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_160771 = PyFloat_FromDouble(0.160771); if (unlikely(!__pyx_float_0_160771)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_162016 = PyFloat_FromDouble(0.162016); if (unlikely(!__pyx_float_0_162016)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_162142 = PyFloat_FromDouble(0.162142); if (unlikely(!__pyx_float_0_162142)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_162603 = PyFloat_FromDouble(0.162603); if (unlikely(!__pyx_float_0_162603)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_163625 = PyFloat_FromDouble(0.163625); if (unlikely(!__pyx_float_0_163625)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_165117 = PyFloat_FromDouble(0.165117); if (unlikely(!__pyx_float_0_165117)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_165693 = PyFloat_FromDouble(0.165693); if (unlikely(!__pyx_float_0_165693)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_166383 = PyFloat_FromDouble(0.166383); if (unlikely(!__pyx_float_0_166383)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_166617 = PyFloat_FromDouble(0.166617); if (unlikely(!__pyx_float_0_166617)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_168126 = PyFloat_FromDouble(0.168126); if (unlikely(!__pyx_float_0_168126)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_169257 = PyFloat_FromDouble(0.169257); if (unlikely(!__pyx_float_0_169257)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_169646 = PyFloat_FromDouble(0.169646); if (unlikely(!__pyx_float_0_169646)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_170599 = PyFloat_FromDouble(0.170599); if (unlikely(!__pyx_float_0_170599)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_170948 = PyFloat_FromDouble(0.170948); if (unlikely(!__pyx_float_0_170948)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_171176 = PyFloat_FromDouble(0.171176); if (unlikely(!__pyx_float_0_171176)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_172719 = PyFloat_FromDouble(0.172719); if (unlikely(!__pyx_float_0_172719)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_174274 = PyFloat_FromDouble(0.174274); if (unlikely(!__pyx_float_0_174274)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_175490 = PyFloat_FromDouble(0.175490); if (unlikely(!__pyx_float_0_175490)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_175707 = PyFloat_FromDouble(0.175707); if (unlikely(!__pyx_float_0_175707)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_175841 = PyFloat_FromDouble(0.175841); if (unlikely(!__pyx_float_0_175841)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_175971 = PyFloat_FromDouble(0.175971); if (unlikely(!__pyx_float_0_175971)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_177423 = PyFloat_FromDouble(0.177423); if (unlikely(!__pyx_float_0_177423)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_179019 = PyFloat_FromDouble(0.179019); if (unlikely(!__pyx_float_0_179019)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_180367 = PyFloat_FromDouble(0.180367); if (unlikely(!__pyx_float_0_180367)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_180629 = PyFloat_FromDouble(0.180629); if (unlikely(!__pyx_float_0_180629)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_180653 = PyFloat_FromDouble(0.180653); if (unlikely(!__pyx_float_0_180653)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_182256 = PyFloat_FromDouble(0.182256); if (unlikely(!__pyx_float_0_182256)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_182725 = PyFloat_FromDouble(0.182725); if (unlikely(!__pyx_float_0_182725)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_183898 = PyFloat_FromDouble(0.183898); if (unlikely(!__pyx_float_0_183898)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_185228 = PyFloat_FromDouble(0.185228); if (unlikely(!__pyx_float_0_185228)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_185556 = PyFloat_FromDouble(0.185556); if (unlikely(!__pyx_float_0_185556)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_185783 = PyFloat_FromDouble(0.185783); if (unlikely(!__pyx_float_0_185783)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_187231 = PyFloat_FromDouble(0.187231); if (unlikely(!__pyx_float_0_187231)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_188923 = PyFloat_FromDouble(0.188923); if (unlikely(!__pyx_float_0_188923)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_189503 = PyFloat_FromDouble(0.189503); if (unlikely(!__pyx_float_0_189503)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_190074 = PyFloat_FromDouble(0.190074); if (unlikely(!__pyx_float_0_190074)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_190631 = PyFloat_FromDouble(0.190631); if (unlikely(!__pyx_float_0_190631)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_191090 = PyFloat_FromDouble(0.191090); if (unlikely(!__pyx_float_0_191090)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_192357 = PyFloat_FromDouble(0.192357); if (unlikely(!__pyx_float_0_192357)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_194100 = PyFloat_FromDouble(0.194100); if (unlikely(!__pyx_float_0_194100)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_194905 = PyFloat_FromDouble(0.194905); if (unlikely(!__pyx_float_0_194905)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_195860 = PyFloat_FromDouble(0.195860); if (unlikely(!__pyx_float_0_195860)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_196293 = PyFloat_FromDouble(0.196293); if (unlikely(!__pyx_float_0_196293)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_196571 = PyFloat_FromDouble(0.196571); if (unlikely(!__pyx_float_0_196571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_197636 = PyFloat_FromDouble(0.197636); if (unlikely(!__pyx_float_0_197636)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_199430 = PyFloat_FromDouble(0.199430); if (unlikely(!__pyx_float_0_199430)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_199721 = PyFloat_FromDouble(0.199721); if (unlikely(!__pyx_float_0_199721)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_201239 = PyFloat_FromDouble(0.201239); if (unlikely(!__pyx_float_0_201239)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_202219 = PyFloat_FromDouble(0.202219); if (unlikely(!__pyx_float_0_202219)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_203063 = PyFloat_FromDouble(0.203063); if (unlikely(!__pyx_float_0_203063)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_203082 = PyFloat_FromDouble(0.203082); if (unlikely(!__pyx_float_0_203082)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_204520 = PyFloat_FromDouble(0.204520); if (unlikely(!__pyx_float_0_204520)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_204903 = PyFloat_FromDouble(0.204903); if (unlikely(!__pyx_float_0_204903)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_206756 = PyFloat_FromDouble(0.206756); if (unlikely(!__pyx_float_0_206756)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_208030 = PyFloat_FromDouble(0.208030); if (unlikely(!__pyx_float_0_208030)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_208623 = PyFloat_FromDouble(0.208623); if (unlikely(!__pyx_float_0_208623)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_209303 = PyFloat_FromDouble(0.209303); if (unlikely(!__pyx_float_0_209303)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_209861 = PyFloat_FromDouble(0.209861); if (unlikely(!__pyx_float_0_209861)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_210503 = PyFloat_FromDouble(0.210503); if (unlikely(!__pyx_float_0_210503)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_212395 = PyFloat_FromDouble(0.212395); if (unlikely(!__pyx_float_0_212395)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_214000 = PyFloat_FromDouble(0.214000); if (unlikely(!__pyx_float_0_214000)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_214069 = PyFloat_FromDouble(0.214069); if (unlikely(!__pyx_float_0_214069)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_214298 = PyFloat_FromDouble(0.214298); if (unlikely(!__pyx_float_0_214298)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_216210 = PyFloat_FromDouble(0.216210); if (unlikely(!__pyx_float_0_216210)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_216620 = PyFloat_FromDouble(0.216620); if (unlikely(!__pyx_float_0_216620)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_218130 = PyFloat_FromDouble(0.218130); if (unlikely(!__pyx_float_0_218130)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_218818 = PyFloat_FromDouble(0.218818); if (unlikely(!__pyx_float_0_218818)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_220057 = PyFloat_FromDouble(0.220057); if (unlikely(!__pyx_float_0_220057)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_220124 = PyFloat_FromDouble(0.220124); if (unlikely(!__pyx_float_0_220124)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_221989 = PyFloat_FromDouble(0.221989); if (unlikely(!__pyx_float_0_221989)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_223353 = PyFloat_FromDouble(0.223353); if (unlikely(!__pyx_float_0_223353)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_223549 = PyFloat_FromDouble(0.223549); if (unlikely(!__pyx_float_0_223549)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_223925 = PyFloat_FromDouble(0.223925); if (unlikely(!__pyx_float_0_223925)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_225863 = PyFloat_FromDouble(0.225863); if (unlikely(!__pyx_float_0_225863)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_226397 = PyFloat_FromDouble(0.226397); if (unlikely(!__pyx_float_0_226397)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_227802 = PyFloat_FromDouble(0.227802); if (unlikely(!__pyx_float_0_227802)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_228262 = PyFloat_FromDouble(0.228262); if (unlikely(!__pyx_float_0_228262)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_229739 = PyFloat_FromDouble(0.229739); if (unlikely(!__pyx_float_0_229739)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_230052 = PyFloat_FromDouble(0.230052); if (unlikely(!__pyx_float_0_230052)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_231674 = PyFloat_FromDouble(0.231674); if (unlikely(!__pyx_float_0_231674)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_232815 = PyFloat_FromDouble(0.232815); if (unlikely(!__pyx_float_0_232815)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_232956 = PyFloat_FromDouble(0.232956); if (unlikely(!__pyx_float_0_232956)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_233603 = PyFloat_FromDouble(0.233603); if (unlikely(!__pyx_float_0_233603)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_235526 = PyFloat_FromDouble(0.235526); if (unlikely(!__pyx_float_0_235526)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_236712 = PyFloat_FromDouble(0.236712); if (unlikely(!__pyx_float_0_236712)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_237441 = PyFloat_FromDouble(0.237441); if (unlikely(!__pyx_float_0_237441)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_237631 = PyFloat_FromDouble(0.237631); if (unlikely(!__pyx_float_0_237631)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_239346 = PyFloat_FromDouble(0.239346); if (unlikely(!__pyx_float_0_239346)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_239374 = PyFloat_FromDouble(0.239374); if (unlikely(!__pyx_float_0_239374)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_241237 = PyFloat_FromDouble(0.241237); if (unlikely(!__pyx_float_0_241237)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_242286 = PyFloat_FromDouble(0.242286); if (unlikely(!__pyx_float_0_242286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_243113 = PyFloat_FromDouble(0.243113); if (unlikely(!__pyx_float_0_243113)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_243329 = PyFloat_FromDouble(0.243329); if (unlikely(!__pyx_float_0_243329)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_244972 = PyFloat_FromDouble(0.244972); if (unlikely(!__pyx_float_0_244972)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_246070 = PyFloat_FromDouble(0.246070); if (unlikely(!__pyx_float_0_246070)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_246811 = PyFloat_FromDouble(0.246811); if (unlikely(!__pyx_float_0_246811)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_246922 = PyFloat_FromDouble(0.246922); if (unlikely(!__pyx_float_0_246922)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_248629 = PyFloat_FromDouble(0.248629); if (unlikely(!__pyx_float_0_248629)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_249897 = PyFloat_FromDouble(0.249897); if (unlikely(!__pyx_float_0_249897)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_250425 = PyFloat_FromDouble(0.250425); if (unlikely(!__pyx_float_0_250425)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_251537 = PyFloat_FromDouble(0.251537); if (unlikely(!__pyx_float_0_251537)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_252194 = PyFloat_FromDouble(0.252194); if (unlikely(!__pyx_float_0_252194)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_252899 = PyFloat_FromDouble(0.252899); if (unlikely(!__pyx_float_0_252899)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_253935 = PyFloat_FromDouble(0.253935); if (unlikely(!__pyx_float_0_253935)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_255645 = PyFloat_FromDouble(0.255645); if (unlikely(!__pyx_float_0_255645)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_256130 = PyFloat_FromDouble(0.256130); if (unlikely(!__pyx_float_0_256130)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_256415 = PyFloat_FromDouble(0.256415); if (unlikely(!__pyx_float_0_256415)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_257322 = PyFloat_FromDouble(0.257322); if (unlikely(!__pyx_float_0_257322)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_258965 = PyFloat_FromDouble(0.258965); if (unlikely(!__pyx_float_0_258965)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_259857 = PyFloat_FromDouble(0.259857); if (unlikely(!__pyx_float_0_259857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_260571 = PyFloat_FromDouble(0.260571); if (unlikely(!__pyx_float_0_260571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_260703 = PyFloat_FromDouble(0.260703); if (unlikely(!__pyx_float_0_260703)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_262138 = PyFloat_FromDouble(0.262138); if (unlikely(!__pyx_float_0_262138)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_262877 = PyFloat_FromDouble(0.262877); if (unlikely(!__pyx_float_0_262877)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_263663 = PyFloat_FromDouble(0.263663); if (unlikely(!__pyx_float_0_263663)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_265145 = PyFloat_FromDouble(0.265145); if (unlikely(!__pyx_float_0_265145)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_265254 = PyFloat_FromDouble(0.265254); if (unlikely(!__pyx_float_0_265254)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_266580 = PyFloat_FromDouble(0.266580); if (unlikely(!__pyx_float_0_266580)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_266941 = PyFloat_FromDouble(0.266941); if (unlikely(!__pyx_float_0_266941)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_267004 = PyFloat_FromDouble(0.267004); if (unlikely(!__pyx_float_0_267004)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_267968 = PyFloat_FromDouble(0.267968); if (unlikely(!__pyx_float_0_267968)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_268510 = PyFloat_FromDouble(0.268510); if (unlikely(!__pyx_float_0_268510)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_269281 = PyFloat_FromDouble(0.269281); if (unlikely(!__pyx_float_0_269281)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_269308 = PyFloat_FromDouble(0.269308); if (unlikely(!__pyx_float_0_269308)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_269783 = PyFloat_FromDouble(0.269783); if (unlikely(!__pyx_float_0_269783)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_269944 = PyFloat_FromDouble(0.269944); if (unlikely(!__pyx_float_0_269944)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_270595 = PyFloat_FromDouble(0.270595); if (unlikely(!__pyx_float_0_270595)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_271305 = PyFloat_FromDouble(0.271305); if (unlikely(!__pyx_float_0_271305)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_271828 = PyFloat_FromDouble(0.271828); if (unlikely(!__pyx_float_0_271828)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_272594 = PyFloat_FromDouble(0.272594); if (unlikely(!__pyx_float_0_272594)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_273006 = PyFloat_FromDouble(0.273006); if (unlikely(!__pyx_float_0_273006)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_273809 = PyFloat_FromDouble(0.273809); if (unlikely(!__pyx_float_0_273809)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_274128 = PyFloat_FromDouble(0.274128); if (unlikely(!__pyx_float_0_274128)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_274149 = PyFloat_FromDouble(0.274149); if (unlikely(!__pyx_float_0_274149)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_274290 = PyFloat_FromDouble(0.274290); if (unlikely(!__pyx_float_0_274290)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_274952 = PyFloat_FromDouble(0.274952); if (unlikely(!__pyx_float_0_274952)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_275191 = PyFloat_FromDouble(0.275191); if (unlikely(!__pyx_float_0_275191)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_275626 = PyFloat_FromDouble(0.275626); if (unlikely(!__pyx_float_0_275626)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_276022 = PyFloat_FromDouble(0.276022); if (unlikely(!__pyx_float_0_276022)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_276194 = PyFloat_FromDouble(0.276194); if (unlikely(!__pyx_float_0_276194)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_277018 = PyFloat_FromDouble(0.277018); if (unlikely(!__pyx_float_0_277018)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_277134 = PyFloat_FromDouble(0.277134); if (unlikely(!__pyx_float_0_277134)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_277941 = PyFloat_FromDouble(0.277941); if (unlikely(!__pyx_float_0_277941)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_278012 = PyFloat_FromDouble(0.278012); if (unlikely(!__pyx_float_0_278012)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_278775 = PyFloat_FromDouble(0.278775); if (unlikely(!__pyx_float_0_278775)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_278791 = PyFloat_FromDouble(0.278791); if (unlikely(!__pyx_float_0_278791)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_278826 = PyFloat_FromDouble(0.278826); if (unlikely(!__pyx_float_0_278826)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_279566 = PyFloat_FromDouble(0.279566); if (unlikely(!__pyx_float_0_279566)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_279574 = PyFloat_FromDouble(0.279574); if (unlikely(!__pyx_float_0_279574)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_280255 = PyFloat_FromDouble(0.280255); if (unlikely(!__pyx_float_0_280255)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_280267 = PyFloat_FromDouble(0.280267); if (unlikely(!__pyx_float_0_280267)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_280868 = PyFloat_FromDouble(0.280868); if (unlikely(!__pyx_float_0_280868)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_280894 = PyFloat_FromDouble(0.280894); if (unlikely(!__pyx_float_0_280894)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_281412 = PyFloat_FromDouble(0.281412); if (unlikely(!__pyx_float_0_281412)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_281446 = PyFloat_FromDouble(0.281446); if (unlikely(!__pyx_float_0_281446)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_281477 = PyFloat_FromDouble(0.281477); if (unlikely(!__pyx_float_0_281477)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_281887 = PyFloat_FromDouble(0.281887); if (unlikely(!__pyx_float_0_281887)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_281908 = PyFloat_FromDouble(0.281908); if (unlikely(!__pyx_float_0_281908)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_281924 = PyFloat_FromDouble(0.281924); if (unlikely(!__pyx_float_0_281924)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_282290 = PyFloat_FromDouble(0.282290); if (unlikely(!__pyx_float_0_282290)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_282327 = PyFloat_FromDouble(0.282327); if (unlikely(!__pyx_float_0_282327)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_282623 = PyFloat_FromDouble(0.282623); if (unlikely(!__pyx_float_0_282623)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_282656 = PyFloat_FromDouble(0.282656); if (unlikely(!__pyx_float_0_282656)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_282884 = PyFloat_FromDouble(0.282884); if (unlikely(!__pyx_float_0_282884)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_282910 = PyFloat_FromDouble(0.282910); if (unlikely(!__pyx_float_0_282910)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_283072 = PyFloat_FromDouble(0.283072); if (unlikely(!__pyx_float_0_283072)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_283091 = PyFloat_FromDouble(0.283091); if (unlikely(!__pyx_float_0_283091)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_283187 = PyFloat_FromDouble(0.283187); if (unlikely(!__pyx_float_0_283187)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_283197 = PyFloat_FromDouble(0.283197); if (unlikely(!__pyx_float_0_283197)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_283229 = PyFloat_FromDouble(0.283229); if (unlikely(!__pyx_float_0_283229)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_283237 = PyFloat_FromDouble(0.283237); if (unlikely(!__pyx_float_0_283237)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_287675 = PyFloat_FromDouble(0.287675); if (unlikely(!__pyx_float_0_287675)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_288127 = PyFloat_FromDouble(0.288127); if (unlikely(!__pyx_float_0_288127)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_288921 = PyFloat_FromDouble(0.288921); if (unlikely(!__pyx_float_0_288921)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_292092 = PyFloat_FromDouble(0.292092); if (unlikely(!__pyx_float_0_292092)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_294279 = PyFloat_FromDouble(0.294279); if (unlikely(!__pyx_float_0_294279)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_296479 = PyFloat_FromDouble(0.296479); if (unlikely(!__pyx_float_0_296479)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_296485 = PyFloat_FromDouble(0.296485); if (unlikely(!__pyx_float_0_296485)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_300362 = PyFloat_FromDouble(0.300362); if (unlikely(!__pyx_float_0_300362)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_300855 = PyFloat_FromDouble(0.300855); if (unlikely(!__pyx_float_0_300855)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_304148 = PyFloat_FromDouble(0.304148); if (unlikely(!__pyx_float_0_304148)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_305202 = PyFloat_FromDouble(0.305202); if (unlikely(!__pyx_float_0_305202)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_306377 = PyFloat_FromDouble(0.306377); if (unlikely(!__pyx_float_0_306377)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_309527 = PyFloat_FromDouble(0.309527); if (unlikely(!__pyx_float_0_309527)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_311925 = PyFloat_FromDouble(0.311925); if (unlikely(!__pyx_float_0_311925)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_312321 = PyFloat_FromDouble(0.312321); if (unlikely(!__pyx_float_0_312321)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_313828 = PyFloat_FromDouble(0.313828); if (unlikely(!__pyx_float_0_313828)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_318106 = PyFloat_FromDouble(0.318106); if (unlikely(!__pyx_float_0_318106)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_318195 = PyFloat_FromDouble(0.318195); if (unlikely(!__pyx_float_0_318195)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_319809 = PyFloat_FromDouble(0.319809); if (unlikely(!__pyx_float_0_319809)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_322361 = PyFloat_FromDouble(0.322361); if (unlikely(!__pyx_float_0_322361)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_323998 = PyFloat_FromDouble(0.323998); if (unlikely(!__pyx_float_0_323998)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_326594 = PyFloat_FromDouble(0.326594); if (unlikely(!__pyx_float_0_326594)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_327796 = PyFloat_FromDouble(0.327796); if (unlikely(!__pyx_float_0_327796)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_329415 = PyFloat_FromDouble(0.329415); if (unlikely(!__pyx_float_0_329415)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_329727 = PyFloat_FromDouble(0.329727); if (unlikely(!__pyx_float_0_329727)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_330805 = PyFloat_FromDouble(0.330805); if (unlikely(!__pyx_float_0_330805)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_334994 = PyFloat_FromDouble(0.334994); if (unlikely(!__pyx_float_0_334994)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_335384 = PyFloat_FromDouble(0.335384); if (unlikely(!__pyx_float_0_335384)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_335427 = PyFloat_FromDouble(0.335427); if (unlikely(!__pyx_float_0_335427)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_335885 = PyFloat_FromDouble(0.335885); if (unlikely(!__pyx_float_0_335885)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_339161 = PyFloat_FromDouble(0.339161); if (unlikely(!__pyx_float_0_339161)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_340967 = PyFloat_FromDouble(0.340967); if (unlikely(!__pyx_float_0_340967)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_341379 = PyFloat_FromDouble(0.341379); if (unlikely(!__pyx_float_0_341379)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_343307 = PyFloat_FromDouble(0.343307); if (unlikely(!__pyx_float_0_343307)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_344074 = PyFloat_FromDouble(0.344074); if (unlikely(!__pyx_float_0_344074)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_346476 = PyFloat_FromDouble(0.346476); if (unlikely(!__pyx_float_0_346476)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_347269 = PyFloat_FromDouble(0.347269); if (unlikely(!__pyx_float_0_347269)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_347432 = PyFloat_FromDouble(0.347432); if (unlikely(!__pyx_float_0_347432)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_351535 = PyFloat_FromDouble(0.351535); if (unlikely(!__pyx_float_0_351535)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_351910 = PyFloat_FromDouble(0.351910); if (unlikely(!__pyx_float_0_351910)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_352360 = PyFloat_FromDouble(0.352360); if (unlikely(!__pyx_float_0_352360)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_353093 = PyFloat_FromDouble(0.353093); if (unlikely(!__pyx_float_0_353093)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_355619 = PyFloat_FromDouble(0.355619); if (unlikely(!__pyx_float_0_355619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_357269 = PyFloat_FromDouble(0.357269); if (unlikely(!__pyx_float_0_357269)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_358853 = PyFloat_FromDouble(0.358853); if (unlikely(!__pyx_float_0_358853)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_359683 = PyFloat_FromDouble(0.359683); if (unlikely(!__pyx_float_0_359683)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_360741 = PyFloat_FromDouble(0.360741); if (unlikely(!__pyx_float_0_360741)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_362552 = PyFloat_FromDouble(0.362552); if (unlikely(!__pyx_float_0_362552)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_363727 = PyFloat_FromDouble(0.363727); if (unlikely(!__pyx_float_0_363727)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_364543 = PyFloat_FromDouble(0.364543); if (unlikely(!__pyx_float_0_364543)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_367752 = PyFloat_FromDouble(0.367752); if (unlikely(!__pyx_float_0_367752)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_367757 = PyFloat_FromDouble(0.367757); if (unlikely(!__pyx_float_0_367757)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_369214 = PyFloat_FromDouble(0.369214); if (unlikely(!__pyx_float_0_369214)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_370164 = PyFloat_FromDouble(0.370164); if (unlikely(!__pyx_float_0_370164)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_371758 = PyFloat_FromDouble(0.371758); if (unlikely(!__pyx_float_0_371758)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_372886 = PyFloat_FromDouble(0.372886); if (unlikely(!__pyx_float_0_372886)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_375715 = PyFloat_FromDouble(0.375715); if (unlikely(!__pyx_float_0_375715)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_375746 = PyFloat_FromDouble(0.375746); if (unlikely(!__pyx_float_0_375746)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_377779 = PyFloat_FromDouble(0.377779); if (unlikely(!__pyx_float_0_377779)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_377939 = PyFloat_FromDouble(0.377939); if (unlikely(!__pyx_float_0_377939)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_379716 = PyFloat_FromDouble(0.379716); if (unlikely(!__pyx_float_0_379716)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_381191 = PyFloat_FromDouble(0.381191); if (unlikely(!__pyx_float_0_381191)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_382914 = PyFloat_FromDouble(0.382914); if (unlikely(!__pyx_float_0_382914)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_383670 = PyFloat_FromDouble(0.383670); if (unlikely(!__pyx_float_0_383670)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_386433 = PyFloat_FromDouble(0.386433); if (unlikely(!__pyx_float_0_386433)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_386592 = PyFloat_FromDouble(0.386592); if (unlikely(!__pyx_float_0_386592)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_387607 = PyFloat_FromDouble(0.387607); if (unlikely(!__pyx_float_0_387607)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_387814 = PyFloat_FromDouble(0.387814); if (unlikely(!__pyx_float_0_387814)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_391528 = PyFloat_FromDouble(0.391528); if (unlikely(!__pyx_float_0_391528)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_391917 = PyFloat_FromDouble(0.391917); if (unlikely(!__pyx_float_0_391917)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_392636 = PyFloat_FromDouble(0.392636); if (unlikely(!__pyx_float_0_392636)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_395174 = PyFloat_FromDouble(0.395174); if (unlikely(!__pyx_float_0_395174)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_395433 = PyFloat_FromDouble(0.395433); if (unlikely(!__pyx_float_0_395433)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_397163 = PyFloat_FromDouble(0.397163); if (unlikely(!__pyx_float_0_397163)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_397381 = PyFloat_FromDouble(0.397381); if (unlikely(!__pyx_float_0_397381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_399323 = PyFloat_FromDouble(0.399323); if (unlikely(!__pyx_float_0_399323)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_402049 = PyFloat_FromDouble(0.402049); if (unlikely(!__pyx_float_0_402049)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_402329 = PyFloat_FromDouble(0.402329); if (unlikely(!__pyx_float_0_402329)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_403199 = PyFloat_FromDouble(0.403199); if (unlikely(!__pyx_float_0_403199)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_404001 = PyFloat_FromDouble(0.404001); if (unlikely(!__pyx_float_0_404001)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_406640 = PyFloat_FromDouble(0.406640); if (unlikely(!__pyx_float_0_406640)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_407061 = PyFloat_FromDouble(0.407061); if (unlikely(!__pyx_float_0_407061)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_407414 = PyFloat_FromDouble(0.407414); if (unlikely(!__pyx_float_0_407414)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_410910 = PyFloat_FromDouble(0.410910); if (unlikely(!__pyx_float_0_410910)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_411152 = PyFloat_FromDouble(0.411152); if (unlikely(!__pyx_float_0_411152)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_412415 = PyFloat_FromDouble(0.412415); if (unlikely(!__pyx_float_0_412415)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_412913 = PyFloat_FromDouble(0.412913); if (unlikely(!__pyx_float_0_412913)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_414746 = PyFloat_FromDouble(0.414746); if (unlikely(!__pyx_float_0_414746)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_415586 = PyFloat_FromDouble(0.415586); if (unlikely(!__pyx_float_0_415586)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_417331 = PyFloat_FromDouble(0.417331); if (unlikely(!__pyx_float_0_417331)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_418570 = PyFloat_FromDouble(0.418570); if (unlikely(!__pyx_float_0_418570)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_419943 = PyFloat_FromDouble(0.419943); if (unlikely(!__pyx_float_0_419943)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_421908 = PyFloat_FromDouble(0.421908); if (unlikely(!__pyx_float_0_421908)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_422160 = PyFloat_FromDouble(0.422160); if (unlikely(!__pyx_float_0_422160)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_422383 = PyFloat_FromDouble(0.422383); if (unlikely(!__pyx_float_0_422383)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_424223 = PyFloat_FromDouble(0.424223); if (unlikely(!__pyx_float_0_424223)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_426184 = PyFloat_FromDouble(0.426184); if (unlikely(!__pyx_float_0_426184)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_426902 = PyFloat_FromDouble(0.426902); if (unlikely(!__pyx_float_0_426902)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_428426 = PyFloat_FromDouble(0.428426); if (unlikely(!__pyx_float_0_428426)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_429975 = PyFloat_FromDouble(0.429975); if (unlikely(!__pyx_float_0_429975)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_430983 = PyFloat_FromDouble(0.430983); if (unlikely(!__pyx_float_0_430983)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_431554 = PyFloat_FromDouble(0.431554); if (unlikely(!__pyx_float_0_431554)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_432552 = PyFloat_FromDouble(0.432552); if (unlikely(!__pyx_float_0_432552)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_433756 = PyFloat_FromDouble(0.433756); if (unlikely(!__pyx_float_0_433756)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_436115 = PyFloat_FromDouble(0.436115); if (unlikely(!__pyx_float_0_436115)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_436601 = PyFloat_FromDouble(0.436601); if (unlikely(!__pyx_float_0_436601)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_437527 = PyFloat_FromDouble(0.437527); if (unlikely(!__pyx_float_0_437527)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_440137 = PyFloat_FromDouble(0.440137); if (unlikely(!__pyx_float_0_440137)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_440573 = PyFloat_FromDouble(0.440573); if (unlikely(!__pyx_float_0_440573)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_440584 = PyFloat_FromDouble(0.440584); if (unlikely(!__pyx_float_0_440584)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_441290 = PyFloat_FromDouble(0.441290); if (unlikely(!__pyx_float_0_441290)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_444467 = PyFloat_FromDouble(0.444467); if (unlikely(!__pyx_float_0_444467)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_444960 = PyFloat_FromDouble(0.444960); if (unlikely(!__pyx_float_0_444960)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_445044 = PyFloat_FromDouble(0.445044); if (unlikely(!__pyx_float_0_445044)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_448284 = PyFloat_FromDouble(0.448284); if (unlikely(!__pyx_float_0_448284)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_448791 = PyFloat_FromDouble(0.448791); if (unlikely(!__pyx_float_0_448791)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_449241 = PyFloat_FromDouble(0.449241); if (unlikely(!__pyx_float_0_449241)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_449368 = PyFloat_FromDouble(0.449368); if (unlikely(!__pyx_float_0_449368)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_452024 = PyFloat_FromDouble(0.452024); if (unlikely(!__pyx_float_0_452024)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_452530 = PyFloat_FromDouble(0.452530); if (unlikely(!__pyx_float_0_452530)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_453427 = PyFloat_FromDouble(0.453427); if (unlikely(!__pyx_float_0_453427)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_455688 = PyFloat_FromDouble(0.455688); if (unlikely(!__pyx_float_0_455688)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_456262 = PyFloat_FromDouble(0.456262); if (unlikely(!__pyx_float_0_456262)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_457517 = PyFloat_FromDouble(0.457517); if (unlikely(!__pyx_float_0_457517)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_458674 = PyFloat_FromDouble(0.458674); if (unlikely(!__pyx_float_0_458674)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_459277 = PyFloat_FromDouble(0.459277); if (unlikely(!__pyx_float_0_459277)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_459988 = PyFloat_FromDouble(0.459988); if (unlikely(!__pyx_float_0_459988)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_461510 = PyFloat_FromDouble(0.461510); if (unlikely(!__pyx_float_0_461510)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_462789 = PyFloat_FromDouble(0.462789); if (unlikely(!__pyx_float_0_462789)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_463708 = PyFloat_FromDouble(0.463708); if (unlikely(!__pyx_float_0_463708)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_465405 = PyFloat_FromDouble(0.465405); if (unlikely(!__pyx_float_0_465405)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_466226 = PyFloat_FromDouble(0.466226); if (unlikely(!__pyx_float_0_466226)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_467423 = PyFloat_FromDouble(0.467423); if (unlikely(!__pyx_float_0_467423)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_468053 = PyFloat_FromDouble(0.468053); if (unlikely(!__pyx_float_0_468053)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_469201 = PyFloat_FromDouble(0.469201); if (unlikely(!__pyx_float_0_469201)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_469588 = PyFloat_FromDouble(0.469588); if (unlikely(!__pyx_float_0_469588)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_471133 = PyFloat_FromDouble(0.471133); if (unlikely(!__pyx_float_0_471133)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_472873 = PyFloat_FromDouble(0.472873); if (unlikely(!__pyx_float_0_472873)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_472899 = PyFloat_FromDouble(0.472899); if (unlikely(!__pyx_float_0_472899)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_474838 = PyFloat_FromDouble(0.474838); if (unlikely(!__pyx_float_0_474838)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_476084 = PyFloat_FromDouble(0.476084); if (unlikely(!__pyx_float_0_476084)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_476498 = PyFloat_FromDouble(0.476498); if (unlikely(!__pyx_float_0_476498)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_477504 = PyFloat_FromDouble(0.477504); if (unlikely(!__pyx_float_0_477504)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_478540 = PyFloat_FromDouble(0.478540); if (unlikely(!__pyx_float_0_478540)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_479221 = PyFloat_FromDouble(0.479221); if (unlikely(!__pyx_float_0_479221)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_479997 = PyFloat_FromDouble(0.479997); if (unlikely(!__pyx_float_0_479997)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_482237 = PyFloat_FromDouble(0.482237); if (unlikely(!__pyx_float_0_482237)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_482284 = PyFloat_FromDouble(0.482284); if (unlikely(!__pyx_float_0_482284)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_483397 = PyFloat_FromDouble(0.483397); if (unlikely(!__pyx_float_0_483397)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_485273 = PyFloat_FromDouble(0.485273); if (unlikely(!__pyx_float_0_485273)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_485932 = PyFloat_FromDouble(0.485932); if (unlikely(!__pyx_float_0_485932)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_486697 = PyFloat_FromDouble(0.486697); if (unlikely(!__pyx_float_0_486697)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_487026 = PyFloat_FromDouble(0.487026); if (unlikely(!__pyx_float_0_487026)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_488189 = PyFloat_FromDouble(0.488189); if (unlikely(!__pyx_float_0_488189)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_489624 = PyFloat_FromDouble(0.489624); if (unlikely(!__pyx_float_0_489624)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_489898 = PyFloat_FromDouble(0.489898); if (unlikely(!__pyx_float_0_489898)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_491033 = PyFloat_FromDouble(0.491033); if (unlikely(!__pyx_float_0_491033)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_493001 = PyFloat_FromDouble(0.493001); if (unlikely(!__pyx_float_0_493001)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_493313 = PyFloat_FromDouble(0.493313); if (unlikely(!__pyx_float_0_493313)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_493803 = PyFloat_FromDouble(0.493803); if (unlikely(!__pyx_float_0_493803)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_496005 = PyFloat_FromDouble(0.496005); if (unlikely(!__pyx_float_0_496005)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_496502 = PyFloat_FromDouble(0.496502); if (unlikely(!__pyx_float_0_496502)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_496615 = PyFloat_FromDouble(0.496615); if (unlikely(!__pyx_float_0_496615)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_497000 = PyFloat_FromDouble(0.497000); if (unlikely(!__pyx_float_0_497000)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_498911 = PyFloat_FromDouble(0.498911); if (unlikely(!__pyx_float_0_498911)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_499129 = PyFloat_FromDouble(0.499129); if (unlikely(!__pyx_float_0_499129)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_500685 = PyFloat_FromDouble(0.500685); if (unlikely(!__pyx_float_0_500685)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_501686 = PyFloat_FromDouble(0.501686); if (unlikely(!__pyx_float_0_501686)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_501721 = PyFloat_FromDouble(0.501721); if (unlikely(!__pyx_float_0_501721)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_504172 = PyFloat_FromDouble(0.504172); if (unlikely(!__pyx_float_0_504172)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_504369 = PyFloat_FromDouble(0.504369); if (unlikely(!__pyx_float_0_504369)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_504434 = PyFloat_FromDouble(0.504434); if (unlikely(!__pyx_float_0_504434)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_506271 = PyFloat_FromDouble(0.506271); if (unlikely(!__pyx_float_0_506271)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_506589 = PyFloat_FromDouble(0.506589); if (unlikely(!__pyx_float_0_506589)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_507052 = PyFloat_FromDouble(0.507052); if (unlikely(!__pyx_float_0_507052)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_508051 = PyFloat_FromDouble(0.508051); if (unlikely(!__pyx_float_0_508051)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_508936 = PyFloat_FromDouble(0.508936); if (unlikely(!__pyx_float_0_508936)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_509577 = PyFloat_FromDouble(0.509577); if (unlikely(!__pyx_float_0_509577)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_511215 = PyFloat_FromDouble(0.511215); if (unlikely(!__pyx_float_0_511215)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_511733 = PyFloat_FromDouble(0.511733); if (unlikely(!__pyx_float_0_511733)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_512008 = PyFloat_FromDouble(0.512008); if (unlikely(!__pyx_float_0_512008)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_513427 = PyFloat_FromDouble(0.513427); if (unlikely(!__pyx_float_0_513427)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_514349 = PyFloat_FromDouble(0.514349); if (unlikely(!__pyx_float_0_514349)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_515413 = PyFloat_FromDouble(0.515413); if (unlikely(!__pyx_float_0_515413)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_515571 = PyFloat_FromDouble(0.515571); if (unlikely(!__pyx_float_0_515571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_515992 = PyFloat_FromDouble(0.515992); if (unlikely(!__pyx_float_0_515992)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_516599 = PyFloat_FromDouble(0.516599); if (unlikely(!__pyx_float_0_516599)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_517649 = PyFloat_FromDouble(0.517649); if (unlikely(!__pyx_float_0_517649)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_518762 = PyFloat_FromDouble(0.518762); if (unlikely(!__pyx_float_0_518762)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_519093 = PyFloat_FromDouble(0.519093); if (unlikely(!__pyx_float_0_519093)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_519661 = PyFloat_FromDouble(0.519661); if (unlikely(!__pyx_float_0_519661)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_520837 = PyFloat_FromDouble(0.520837); if (unlikely(!__pyx_float_0_520837)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_521608 = PyFloat_FromDouble(0.521608); if (unlikely(!__pyx_float_0_521608)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_522773 = PyFloat_FromDouble(0.522773); if (unlikely(!__pyx_float_0_522773)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_522828 = PyFloat_FromDouble(0.522828); if (unlikely(!__pyx_float_0_522828)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_523491 = PyFloat_FromDouble(0.523491); if (unlikely(!__pyx_float_0_523491)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_524736 = PyFloat_FromDouble(0.524736); if (unlikely(!__pyx_float_0_524736)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_525311 = PyFloat_FromDouble(0.525311); if (unlikely(!__pyx_float_0_525311)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_525776 = PyFloat_FromDouble(0.525776); if (unlikely(!__pyx_float_0_525776)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_526453 = PyFloat_FromDouble(0.526453); if (unlikely(!__pyx_float_0_526453)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_526563 = PyFloat_FromDouble(0.526563); if (unlikely(!__pyx_float_0_526563)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_527068 = PyFloat_FromDouble(0.527068); if (unlikely(!__pyx_float_0_527068)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_528312 = PyFloat_FromDouble(0.528312); if (unlikely(!__pyx_float_0_528312)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_528763 = PyFloat_FromDouble(0.528763); if (unlikely(!__pyx_float_0_528763)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_529983 = PyFloat_FromDouble(0.529983); if (unlikely(!__pyx_float_0_529983)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_530132 = PyFloat_FromDouble(0.530132); if (unlikely(!__pyx_float_0_530132)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_530398 = PyFloat_FromDouble(0.530398); if (unlikely(!__pyx_float_0_530398)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_531579 = PyFloat_FromDouble(0.531579); if (unlikely(!__pyx_float_0_531579)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_531973 = PyFloat_FromDouble(0.531973); if (unlikely(!__pyx_float_0_531973)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_533103 = PyFloat_FromDouble(0.533103); if (unlikely(!__pyx_float_0_533103)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_533488 = PyFloat_FromDouble(0.533488); if (unlikely(!__pyx_float_0_533488)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_533812 = PyFloat_FromDouble(0.533812); if (unlikely(!__pyx_float_0_533812)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_534556 = PyFloat_FromDouble(0.534556); if (unlikely(!__pyx_float_0_534556)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_534946 = PyFloat_FromDouble(0.534946); if (unlikely(!__pyx_float_0_534946)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_535621 = PyFloat_FromDouble(0.535621); if (unlikely(!__pyx_float_0_535621)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_535941 = PyFloat_FromDouble(0.535941); if (unlikely(!__pyx_float_0_535941)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_536347 = PyFloat_FromDouble(0.536347); if (unlikely(!__pyx_float_0_536347)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_537260 = PyFloat_FromDouble(0.537260); if (unlikely(!__pyx_float_0_537260)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_537492 = PyFloat_FromDouble(0.537492); if (unlikely(!__pyx_float_0_537492)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_537692 = PyFloat_FromDouble(0.537692); if (unlikely(!__pyx_float_0_537692)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_538516 = PyFloat_FromDouble(0.538516); if (unlikely(!__pyx_float_0_538516)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_538982 = PyFloat_FromDouble(0.538982); if (unlikely(!__pyx_float_0_538982)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_539709 = PyFloat_FromDouble(0.539709); if (unlikely(!__pyx_float_0_539709)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_540218 = PyFloat_FromDouble(0.540218); if (unlikely(!__pyx_float_0_540218)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_540844 = PyFloat_FromDouble(0.540844); if (unlikely(!__pyx_float_0_540844)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_541173 = PyFloat_FromDouble(0.541173); if (unlikely(!__pyx_float_0_541173)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_541400 = PyFloat_FromDouble(0.541400); if (unlikely(!__pyx_float_0_541400)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_541921 = PyFloat_FromDouble(0.541921); if (unlikely(!__pyx_float_0_541921)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_542530 = PyFloat_FromDouble(0.542530); if (unlikely(!__pyx_float_0_542530)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_542944 = PyFloat_FromDouble(0.542944); if (unlikely(!__pyx_float_0_542944)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_543611 = PyFloat_FromDouble(0.543611); if (unlikely(!__pyx_float_0_543611)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_543914 = PyFloat_FromDouble(0.543914); if (unlikely(!__pyx_float_0_543914)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_544641 = PyFloat_FromDouble(0.544641); if (unlikely(!__pyx_float_0_544641)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_544834 = PyFloat_FromDouble(0.544834); if (unlikely(!__pyx_float_0_544834)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_544853 = PyFloat_FromDouble(0.544853); if (unlikely(!__pyx_float_0_544853)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_545524 = PyFloat_FromDouble(0.545524); if (unlikely(!__pyx_float_0_545524)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_545623 = PyFloat_FromDouble(0.545623); if (unlikely(!__pyx_float_0_545623)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_545706 = PyFloat_FromDouble(0.545706); if (unlikely(!__pyx_float_0_545706)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_546532 = PyFloat_FromDouble(0.546532); if (unlikely(!__pyx_float_0_546532)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_546557 = PyFloat_FromDouble(0.546557); if (unlikely(!__pyx_float_0_546557)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_547314 = PyFloat_FromDouble(0.547314); if (unlikely(!__pyx_float_0_547314)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_547445 = PyFloat_FromDouble(0.547445); if (unlikely(!__pyx_float_0_547445)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_548053 = PyFloat_FromDouble(0.548053); if (unlikely(!__pyx_float_0_548053)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_548287 = PyFloat_FromDouble(0.548287); if (unlikely(!__pyx_float_0_548287)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_548535 = PyFloat_FromDouble(0.548535); if (unlikely(!__pyx_float_0_548535)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_548752 = PyFloat_FromDouble(0.548752); if (unlikely(!__pyx_float_0_548752)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_549086 = PyFloat_FromDouble(0.549086); if (unlikely(!__pyx_float_0_549086)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_549413 = PyFloat_FromDouble(0.549413); if (unlikely(!__pyx_float_0_549413)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_549841 = PyFloat_FromDouble(0.549841); if (unlikely(!__pyx_float_0_549841)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_550038 = PyFloat_FromDouble(0.550038); if (unlikely(!__pyx_float_0_550038)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_550556 = PyFloat_FromDouble(0.550556); if (unlikely(!__pyx_float_0_550556)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_550627 = PyFloat_FromDouble(0.550627); if (unlikely(!__pyx_float_0_550627)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_551184 = PyFloat_FromDouble(0.551184); if (unlikely(!__pyx_float_0_551184)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_551229 = PyFloat_FromDouble(0.551229); if (unlikely(!__pyx_float_0_551229)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_551710 = PyFloat_FromDouble(0.551710); if (unlikely(!__pyx_float_0_551710)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_551864 = PyFloat_FromDouble(0.551864); if (unlikely(!__pyx_float_0_551864)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_552206 = PyFloat_FromDouble(0.552206); if (unlikely(!__pyx_float_0_552206)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_552216 = PyFloat_FromDouble(0.552216); if (unlikely(!__pyx_float_0_552216)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_552459 = PyFloat_FromDouble(0.552459); if (unlikely(!__pyx_float_0_552459)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_552675 = PyFloat_FromDouble(0.552675); if (unlikely(!__pyx_float_0_552675)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_553018 = PyFloat_FromDouble(0.553018); if (unlikely(!__pyx_float_0_553018)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_553117 = PyFloat_FromDouble(0.553117); if (unlikely(!__pyx_float_0_553117)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_553533 = PyFloat_FromDouble(0.553533); if (unlikely(!__pyx_float_0_553533)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_553541 = PyFloat_FromDouble(0.553541); if (unlikely(!__pyx_float_0_553541)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_553925 = PyFloat_FromDouble(0.553925); if (unlikely(!__pyx_float_0_553925)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_554029 = PyFloat_FromDouble(0.554029); if (unlikely(!__pyx_float_0_554029)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_554294 = PyFloat_FromDouble(0.554294); if (unlikely(!__pyx_float_0_554294)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_554483 = PyFloat_FromDouble(0.554483); if (unlikely(!__pyx_float_0_554483)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_554642 = PyFloat_FromDouble(0.554642); if (unlikely(!__pyx_float_0_554642)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_554906 = PyFloat_FromDouble(0.554906); if (unlikely(!__pyx_float_0_554906)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_554969 = PyFloat_FromDouble(0.554969); if (unlikely(!__pyx_float_0_554969)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555276 = PyFloat_FromDouble(0.555276); if (unlikely(!__pyx_float_0_555276)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555298 = PyFloat_FromDouble(0.555298); if (unlikely(!__pyx_float_0_555298)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555484 = PyFloat_FromDouble(0.555484); if (unlikely(!__pyx_float_0_555484)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555565 = PyFloat_FromDouble(0.555565); if (unlikely(!__pyx_float_0_555565)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555659 = PyFloat_FromDouble(0.555659); if (unlikely(!__pyx_float_0_555659)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555836 = PyFloat_FromDouble(0.555836); if (unlikely(!__pyx_float_0_555836)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555899 = PyFloat_FromDouble(0.555899); if (unlikely(!__pyx_float_0_555899)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_555991 = PyFloat_FromDouble(0.555991); if (unlikely(!__pyx_float_0_555991)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556089 = PyFloat_FromDouble(0.556089); if (unlikely(!__pyx_float_0_556089)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556295 = PyFloat_FromDouble(0.556295); if (unlikely(!__pyx_float_0_556295)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556326 = PyFloat_FromDouble(0.556326); if (unlikely(!__pyx_float_0_556326)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556547 = PyFloat_FromDouble(0.556547); if (unlikely(!__pyx_float_0_556547)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556572 = PyFloat_FromDouble(0.556572); if (unlikely(!__pyx_float_0_556572)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556753 = PyFloat_FromDouble(0.556753); if (unlikely(!__pyx_float_0_556753)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556823 = PyFloat_FromDouble(0.556823); if (unlikely(!__pyx_float_0_556823)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_556944 = PyFloat_FromDouble(0.556944); if (unlikely(!__pyx_float_0_556944)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557049 = PyFloat_FromDouble(0.557049); if (unlikely(!__pyx_float_0_557049)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557120 = PyFloat_FromDouble(0.557120); if (unlikely(!__pyx_float_0_557120)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557250 = PyFloat_FromDouble(0.557250); if (unlikely(!__pyx_float_0_557250)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557282 = PyFloat_FromDouble(0.557282); if (unlikely(!__pyx_float_0_557282)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557430 = PyFloat_FromDouble(0.557430); if (unlikely(!__pyx_float_0_557430)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557565 = PyFloat_FromDouble(0.557565); if (unlikely(!__pyx_float_0_557565)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557587 = PyFloat_FromDouble(0.557587); if (unlikely(!__pyx_float_0_557587)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557685 = PyFloat_FromDouble(0.557685); if (unlikely(!__pyx_float_0_557685)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557724 = PyFloat_FromDouble(0.557724); if (unlikely(!__pyx_float_0_557724)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557792 = PyFloat_FromDouble(0.557792); if (unlikely(!__pyx_float_0_557792)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557840 = PyFloat_FromDouble(0.557840); if (unlikely(!__pyx_float_0_557840)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557885 = PyFloat_FromDouble(0.557885); if (unlikely(!__pyx_float_0_557885)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557936 = PyFloat_FromDouble(0.557936); if (unlikely(!__pyx_float_0_557936)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_557965 = PyFloat_FromDouble(0.557965); if (unlikely(!__pyx_float_0_557965)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558013 = PyFloat_FromDouble(0.558013); if (unlikely(!__pyx_float_0_558013)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558030 = PyFloat_FromDouble(0.558030); if (unlikely(!__pyx_float_0_558030)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558073 = PyFloat_FromDouble(0.558073); if (unlikely(!__pyx_float_0_558073)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558082 = PyFloat_FromDouble(0.558082); if (unlikely(!__pyx_float_0_558082)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558115 = PyFloat_FromDouble(0.558115); if (unlikely(!__pyx_float_0_558115)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558119 = PyFloat_FromDouble(0.558119); if (unlikely(!__pyx_float_0_558119)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558140 = PyFloat_FromDouble(0.558140); if (unlikely(!__pyx_float_0_558140)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558141 = PyFloat_FromDouble(0.558141); if (unlikely(!__pyx_float_0_558141)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_558148 = PyFloat_FromDouble(0.558148); if (unlikely(!__pyx_float_0_558148)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_559582 = PyFloat_FromDouble(0.559582); if (unlikely(!__pyx_float_0_559582)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_563265 = PyFloat_FromDouble(0.563265); if (unlikely(!__pyx_float_0_563265)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_565498 = PyFloat_FromDouble(0.565498); if (unlikely(!__pyx_float_0_565498)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_566949 = PyFloat_FromDouble(0.566949); if (unlikely(!__pyx_float_0_566949)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_570633 = PyFloat_FromDouble(0.570633); if (unlikely(!__pyx_float_0_570633)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_574318 = PyFloat_FromDouble(0.574318); if (unlikely(!__pyx_float_0_574318)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_575563 = PyFloat_FromDouble(0.575563); if (unlikely(!__pyx_float_0_575563)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_578002 = PyFloat_FromDouble(0.578002); if (unlikely(!__pyx_float_0_578002)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_581687 = PyFloat_FromDouble(0.581687); if (unlikely(!__pyx_float_0_581687)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_585371 = PyFloat_FromDouble(0.585371); if (unlikely(!__pyx_float_0_585371)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_585678 = PyFloat_FromDouble(0.585678); if (unlikely(!__pyx_float_0_585678)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_589055 = PyFloat_FromDouble(0.589055); if (unlikely(!__pyx_float_0_589055)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_592739 = PyFloat_FromDouble(0.592739); if (unlikely(!__pyx_float_0_592739)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_595839 = PyFloat_FromDouble(0.595839); if (unlikely(!__pyx_float_0_595839)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_596422 = PyFloat_FromDouble(0.596422); if (unlikely(!__pyx_float_0_596422)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_600104 = PyFloat_FromDouble(0.600104); if (unlikely(!__pyx_float_0_600104)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_603785 = PyFloat_FromDouble(0.603785); if (unlikely(!__pyx_float_0_603785)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_606045 = PyFloat_FromDouble(0.606045); if (unlikely(!__pyx_float_0_606045)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_607464 = PyFloat_FromDouble(0.607464); if (unlikely(!__pyx_float_0_607464)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_611141 = PyFloat_FromDouble(0.611141); if (unlikely(!__pyx_float_0_611141)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_614817 = PyFloat_FromDouble(0.614817); if (unlikely(!__pyx_float_0_614817)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_616293 = PyFloat_FromDouble(0.616293); if (unlikely(!__pyx_float_0_616293)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_618490 = PyFloat_FromDouble(0.618490); if (unlikely(!__pyx_float_0_618490)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_622161 = PyFloat_FromDouble(0.622161); if (unlikely(!__pyx_float_0_622161)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_625828 = PyFloat_FromDouble(0.625828); if (unlikely(!__pyx_float_0_625828)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_626579 = PyFloat_FromDouble(0.626579); if (unlikely(!__pyx_float_0_626579)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_629492 = PyFloat_FromDouble(0.629492); if (unlikely(!__pyx_float_0_629492)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_633153 = PyFloat_FromDouble(0.633153); if (unlikely(!__pyx_float_0_633153)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_636809 = PyFloat_FromDouble(0.636809); if (unlikely(!__pyx_float_0_636809)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_636902 = PyFloat_FromDouble(0.636902); if (unlikely(!__pyx_float_0_636902)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_640461 = PyFloat_FromDouble(0.640461); if (unlikely(!__pyx_float_0_640461)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_644107 = PyFloat_FromDouble(0.644107); if (unlikely(!__pyx_float_0_644107)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_647257 = PyFloat_FromDouble(0.647257); if (unlikely(!__pyx_float_0_647257)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_647749 = PyFloat_FromDouble(0.647749); if (unlikely(!__pyx_float_0_647749)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_651384 = PyFloat_FromDouble(0.651384); if (unlikely(!__pyx_float_0_651384)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_655014 = PyFloat_FromDouble(0.655014); if (unlikely(!__pyx_float_0_655014)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_657642 = PyFloat_FromDouble(0.657642); if (unlikely(!__pyx_float_0_657642)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_658636 = PyFloat_FromDouble(0.658636); if (unlikely(!__pyx_float_0_658636)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_662252 = PyFloat_FromDouble(0.662252); if (unlikely(!__pyx_float_0_662252)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_665859 = PyFloat_FromDouble(0.665859); if (unlikely(!__pyx_float_0_665859)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_668054 = PyFloat_FromDouble(0.668054); if (unlikely(!__pyx_float_0_668054)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_669459 = PyFloat_FromDouble(0.669459); if (unlikely(!__pyx_float_0_669459)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_673050 = PyFloat_FromDouble(0.673050); if (unlikely(!__pyx_float_0_673050)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_676631 = PyFloat_FromDouble(0.676631); if (unlikely(!__pyx_float_0_676631)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_678489 = PyFloat_FromDouble(0.678489); if (unlikely(!__pyx_float_0_678489)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_680203 = PyFloat_FromDouble(0.680203); if (unlikely(!__pyx_float_0_680203)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_683765 = PyFloat_FromDouble(0.683765); if (unlikely(!__pyx_float_0_683765)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_687316 = PyFloat_FromDouble(0.687316); if (unlikely(!__pyx_float_0_687316)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_688944 = PyFloat_FromDouble(0.688944); if (unlikely(!__pyx_float_0_688944)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_690856 = PyFloat_FromDouble(0.690856); if (unlikely(!__pyx_float_0_690856)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_694384 = PyFloat_FromDouble(0.694384); if (unlikely(!__pyx_float_0_694384)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_697900 = PyFloat_FromDouble(0.697900); if (unlikely(!__pyx_float_0_697900)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_699415 = PyFloat_FromDouble(0.699415); if (unlikely(!__pyx_float_0_699415)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_701402 = PyFloat_FromDouble(0.701402); if (unlikely(!__pyx_float_0_701402)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_704891 = PyFloat_FromDouble(0.704891); if (unlikely(!__pyx_float_0_704891)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_708366 = PyFloat_FromDouble(0.708366); if (unlikely(!__pyx_float_0_708366)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_709898 = PyFloat_FromDouble(0.709898); if (unlikely(!__pyx_float_0_709898)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_711827 = PyFloat_FromDouble(0.711827); if (unlikely(!__pyx_float_0_711827)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_715272 = PyFloat_FromDouble(0.715272); if (unlikely(!__pyx_float_0_715272)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_718701 = PyFloat_FromDouble(0.718701); if (unlikely(!__pyx_float_0_718701)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_720391 = PyFloat_FromDouble(0.720391); if (unlikely(!__pyx_float_0_720391)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_722114 = PyFloat_FromDouble(0.722114); if (unlikely(!__pyx_float_0_722114)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_725509 = PyFloat_FromDouble(0.725509); if (unlikely(!__pyx_float_0_725509)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_728888 = PyFloat_FromDouble(0.728888); if (unlikely(!__pyx_float_0_728888)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_730889 = PyFloat_FromDouble(0.730889); if (unlikely(!__pyx_float_0_730889)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_732247 = PyFloat_FromDouble(0.732247); if (unlikely(!__pyx_float_0_732247)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_735588 = PyFloat_FromDouble(0.735588); if (unlikely(!__pyx_float_0_735588)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_738910 = PyFloat_FromDouble(0.738910); if (unlikely(!__pyx_float_0_738910)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_741388 = PyFloat_FromDouble(0.741388); if (unlikely(!__pyx_float_0_741388)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_742211 = PyFloat_FromDouble(0.742211); if (unlikely(!__pyx_float_0_742211)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_745492 = PyFloat_FromDouble(0.745492); if (unlikely(!__pyx_float_0_745492)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_748751 = PyFloat_FromDouble(0.748751); if (unlikely(!__pyx_float_0_748751)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_751884 = PyFloat_FromDouble(0.751884); if (unlikely(!__pyx_float_0_751884)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_751988 = PyFloat_FromDouble(0.751988); if (unlikely(!__pyx_float_0_751988)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_755203 = PyFloat_FromDouble(0.755203); if (unlikely(!__pyx_float_0_755203)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_758394 = PyFloat_FromDouble(0.758394); if (unlikely(!__pyx_float_0_758394)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_761561 = PyFloat_FromDouble(0.761561); if (unlikely(!__pyx_float_0_761561)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_762373 = PyFloat_FromDouble(0.762373); if (unlikely(!__pyx_float_0_762373)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_764704 = PyFloat_FromDouble(0.764704); if (unlikely(!__pyx_float_0_764704)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_767822 = PyFloat_FromDouble(0.767822); if (unlikely(!__pyx_float_0_767822)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_770914 = PyFloat_FromDouble(0.770914); if (unlikely(!__pyx_float_0_770914)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_772852 = PyFloat_FromDouble(0.772852); if (unlikely(!__pyx_float_0_772852)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_773980 = PyFloat_FromDouble(0.773980); if (unlikely(!__pyx_float_0_773980)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_777018 = PyFloat_FromDouble(0.777018); if (unlikely(!__pyx_float_0_777018)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_780029 = PyFloat_FromDouble(0.780029); if (unlikely(!__pyx_float_0_780029)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_783011 = PyFloat_FromDouble(0.783011); if (unlikely(!__pyx_float_0_783011)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_783315 = PyFloat_FromDouble(0.783315); if (unlikely(!__pyx_float_0_783315)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_785964 = PyFloat_FromDouble(0.785964); if (unlikely(!__pyx_float_0_785964)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_788888 = PyFloat_FromDouble(0.788888); if (unlikely(!__pyx_float_0_788888)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_791781 = PyFloat_FromDouble(0.791781); if (unlikely(!__pyx_float_0_791781)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_793760 = PyFloat_FromDouble(0.793760); if (unlikely(!__pyx_float_0_793760)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_794644 = PyFloat_FromDouble(0.794644); if (unlikely(!__pyx_float_0_794644)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_797475 = PyFloat_FromDouble(0.797475); if (unlikely(!__pyx_float_0_797475)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_800275 = PyFloat_FromDouble(0.800275); if (unlikely(!__pyx_float_0_800275)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_803041 = PyFloat_FromDouble(0.803041); if (unlikely(!__pyx_float_0_803041)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_804182 = PyFloat_FromDouble(0.804182); if (unlikely(!__pyx_float_0_804182)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_805774 = PyFloat_FromDouble(0.805774); if (unlikely(!__pyx_float_0_805774)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_808473 = PyFloat_FromDouble(0.808473); if (unlikely(!__pyx_float_0_808473)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_811138 = PyFloat_FromDouble(0.811138); if (unlikely(!__pyx_float_0_811138)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_813768 = PyFloat_FromDouble(0.813768); if (unlikely(!__pyx_float_0_813768)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_814576 = PyFloat_FromDouble(0.814576); if (unlikely(!__pyx_float_0_814576)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_816363 = PyFloat_FromDouble(0.816363); if (unlikely(!__pyx_float_0_816363)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_818921 = PyFloat_FromDouble(0.818921); if (unlikely(!__pyx_float_0_818921)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_821444 = PyFloat_FromDouble(0.821444); if (unlikely(!__pyx_float_0_821444)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_823929 = PyFloat_FromDouble(0.823929); if (unlikely(!__pyx_float_0_823929)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_824940 = PyFloat_FromDouble(0.824940); if (unlikely(!__pyx_float_0_824940)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_826376 = PyFloat_FromDouble(0.826376); if (unlikely(!__pyx_float_0_826376)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_828786 = PyFloat_FromDouble(0.828786); if (unlikely(!__pyx_float_0_828786)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_831158 = PyFloat_FromDouble(0.831158); if (unlikely(!__pyx_float_0_831158)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_833491 = PyFloat_FromDouble(0.833491); if (unlikely(!__pyx_float_0_833491)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_835270 = PyFloat_FromDouble(0.835270); if (unlikely(!__pyx_float_0_835270)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_835785 = PyFloat_FromDouble(0.835785); if (unlikely(!__pyx_float_0_835785)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_838039 = PyFloat_FromDouble(0.838039); if (unlikely(!__pyx_float_0_838039)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_840254 = PyFloat_FromDouble(0.840254); if (unlikely(!__pyx_float_0_840254)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_842430 = PyFloat_FromDouble(0.842430); if (unlikely(!__pyx_float_0_842430)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_844566 = PyFloat_FromDouble(0.844566); if (unlikely(!__pyx_float_0_844566)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_845561 = PyFloat_FromDouble(0.845561); if (unlikely(!__pyx_float_0_845561)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_846661 = PyFloat_FromDouble(0.846661); if (unlikely(!__pyx_float_0_846661)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_848717 = PyFloat_FromDouble(0.848717); if (unlikely(!__pyx_float_0_848717)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_850733 = PyFloat_FromDouble(0.850733); if (unlikely(!__pyx_float_0_850733)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_852709 = PyFloat_FromDouble(0.852709); if (unlikely(!__pyx_float_0_852709)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_854645 = PyFloat_FromDouble(0.854645); if (unlikely(!__pyx_float_0_854645)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_855810 = PyFloat_FromDouble(0.855810); if (unlikely(!__pyx_float_0_855810)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_856542 = PyFloat_FromDouble(0.856542); if (unlikely(!__pyx_float_0_856542)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_858400 = PyFloat_FromDouble(0.858400); if (unlikely(!__pyx_float_0_858400)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_860219 = PyFloat_FromDouble(0.860219); if (unlikely(!__pyx_float_0_860219)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_861999 = PyFloat_FromDouble(0.861999); if (unlikely(!__pyx_float_0_861999)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_863742 = PyFloat_FromDouble(0.863742); if (unlikely(!__pyx_float_0_863742)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_865448 = PyFloat_FromDouble(0.865448); if (unlikely(!__pyx_float_0_865448)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_866013 = PyFloat_FromDouble(0.866013); if (unlikely(!__pyx_float_0_866013)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_867117 = PyFloat_FromDouble(0.867117); if (unlikely(!__pyx_float_0_867117)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_868751 = PyFloat_FromDouble(0.868751); if (unlikely(!__pyx_float_0_868751)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_870350 = PyFloat_FromDouble(0.870350); if (unlikely(!__pyx_float_0_870350)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_871916 = PyFloat_FromDouble(0.871916); if (unlikely(!__pyx_float_0_871916)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_873449 = PyFloat_FromDouble(0.873449); if (unlikely(!__pyx_float_0_873449)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_874951 = PyFloat_FromDouble(0.874951); if (unlikely(!__pyx_float_0_874951)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_876168 = PyFloat_FromDouble(0.876168); if (unlikely(!__pyx_float_0_876168)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_876424 = PyFloat_FromDouble(0.876424); if (unlikely(!__pyx_float_0_876424)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_877868 = PyFloat_FromDouble(0.877868); if (unlikely(!__pyx_float_0_877868)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_879285 = PyFloat_FromDouble(0.879285); if (unlikely(!__pyx_float_0_879285)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_880678 = PyFloat_FromDouble(0.880678); if (unlikely(!__pyx_float_0_880678)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_882046 = PyFloat_FromDouble(0.882046); if (unlikely(!__pyx_float_0_882046)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_883393 = PyFloat_FromDouble(0.883393); if (unlikely(!__pyx_float_0_883393)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_884720 = PyFloat_FromDouble(0.884720); if (unlikely(!__pyx_float_0_884720)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_886029 = PyFloat_FromDouble(0.886029); if (unlikely(!__pyx_float_0_886029)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_886271 = PyFloat_FromDouble(0.886271); if (unlikely(!__pyx_float_0_886271)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_887322 = PyFloat_FromDouble(0.887322); if (unlikely(!__pyx_float_0_887322)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_888601 = PyFloat_FromDouble(0.888601); if (unlikely(!__pyx_float_0_888601)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_889868 = PyFloat_FromDouble(0.889868); if (unlikely(!__pyx_float_0_889868)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_891125 = PyFloat_FromDouble(0.891125); if (unlikely(!__pyx_float_0_891125)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_892374 = PyFloat_FromDouble(0.892374); if (unlikely(!__pyx_float_0_892374)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_893616 = PyFloat_FromDouble(0.893616); if (unlikely(!__pyx_float_0_893616)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_894855 = PyFloat_FromDouble(0.894855); if (unlikely(!__pyx_float_0_894855)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_896091 = PyFloat_FromDouble(0.896091); if (unlikely(!__pyx_float_0_896091)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_896320 = PyFloat_FromDouble(0.896320); if (unlikely(!__pyx_float_0_896320)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_897330 = PyFloat_FromDouble(0.897330); if (unlikely(!__pyx_float_0_897330)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_898570 = PyFloat_FromDouble(0.898570); if (unlikely(!__pyx_float_0_898570)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_899815 = PyFloat_FromDouble(0.899815); if (unlikely(!__pyx_float_0_899815)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_901065 = PyFloat_FromDouble(0.901065); if (unlikely(!__pyx_float_0_901065)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_902323 = PyFloat_FromDouble(0.902323); if (unlikely(!__pyx_float_0_902323)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_903590 = PyFloat_FromDouble(0.903590); if (unlikely(!__pyx_float_0_903590)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_904867 = PyFloat_FromDouble(0.904867); if (unlikely(!__pyx_float_0_904867)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_906157 = PyFloat_FromDouble(0.906157); if (unlikely(!__pyx_float_0_906157)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_906311 = PyFloat_FromDouble(0.906311); if (unlikely(!__pyx_float_0_906311)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_916242 = PyFloat_FromDouble(0.916242); if (unlikely(!__pyx_float_0_916242)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_926106 = PyFloat_FromDouble(0.926106); if (unlikely(!__pyx_float_0_926106)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_935904 = PyFloat_FromDouble(0.935904); if (unlikely(!__pyx_float_0_935904)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_945636 = PyFloat_FromDouble(0.945636); if (unlikely(!__pyx_float_0_945636)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_955300 = PyFloat_FromDouble(0.955300); if (unlikely(!__pyx_float_0_955300)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_964894 = PyFloat_FromDouble(0.964894); if (unlikely(!__pyx_float_0_964894)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_974417 = PyFloat_FromDouble(0.974417); if (unlikely(!__pyx_float_0_974417)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_983868 = PyFloat_FromDouble(0.983868); if (unlikely(!__pyx_float_0_983868)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_993248 = PyFloat_FromDouble(0.993248); if (unlikely(!__pyx_float_0_993248)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_032852381 = PyFloat_FromDouble(0.032852381); if (unlikely(!__pyx_float_0_032852381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_079347619 = PyFloat_FromDouble(0.079347619); if (unlikely(!__pyx_float_0_079347619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_147452381 = PyFloat_FromDouble(0.147452381); if (unlikely(!__pyx_float_0_147452381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_196652381 = PyFloat_FromDouble(0.196652381); if (unlikely(!__pyx_float_0_196652381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_212252381 = PyFloat_FromDouble(0.212252381); if (unlikely(!__pyx_float_0_212252381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_240347619 = PyFloat_FromDouble(0.240347619); if (unlikely(!__pyx_float_0_240347619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_266647619 = PyFloat_FromDouble(0.266647619); if (unlikely(!__pyx_float_0_266647619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_609852381 = PyFloat_FromDouble(0.609852381); if (unlikely(!__pyx_float_0_609852381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_743552381 = PyFloat_FromDouble(0.743552381); if (unlikely(!__pyx_float_0_743552381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_779247619 = PyFloat_FromDouble(0.779247619); if (unlikely(!__pyx_float_0_779247619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_819852381 = PyFloat_FromDouble(0.819852381); if (unlikely(!__pyx_float_0_819852381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0059571429 = PyFloat_FromDouble(0.0059571429); if (unlikely(!__pyx_float_0_0059571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0116952381 = PyFloat_FromDouble(0.0116952381); if (unlikely(!__pyx_float_0_0116952381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0165142857 = PyFloat_FromDouble(0.0165142857); if (unlikely(!__pyx_float_0_0165142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0227714286 = PyFloat_FromDouble(0.0227714286); if (unlikely(!__pyx_float_0_0227714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0230904762 = PyFloat_FromDouble(0.0230904762); if (unlikely(!__pyx_float_0_0230904762)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0238904762 = PyFloat_FromDouble(0.0238904762); if (unlikely(!__pyx_float_0_0238904762)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0266619048 = PyFloat_FromDouble(0.0266619048); if (unlikely(!__pyx_float_0_0266619048)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0343428571 = PyFloat_FromDouble(0.0343428571); if (unlikely(!__pyx_float_0_0343428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0383714286 = PyFloat_FromDouble(0.0383714286); if (unlikely(!__pyx_float_0_0383714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0487714286 = PyFloat_FromDouble(0.0487714286); if (unlikely(!__pyx_float_0_0487714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0498142857 = PyFloat_FromDouble(0.0498142857); if (unlikely(!__pyx_float_0_0498142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0589714286 = PyFloat_FromDouble(0.0589714286); if (unlikely(!__pyx_float_0_0589714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0591333333 = PyFloat_FromDouble(0.0591333333); if (unlikely(!__pyx_float_0_0591333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0629333333 = PyFloat_FromDouble(0.0629333333); if (unlikely(!__pyx_float_0_0629333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0640571429 = PyFloat_FromDouble(0.0640571429); if (unlikely(!__pyx_float_0_0640571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0722666667 = PyFloat_FromDouble(0.0722666667); if (unlikely(!__pyx_float_0_0722666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0749428571 = PyFloat_FromDouble(0.0749428571); if (unlikely(!__pyx_float_0_0749428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0755333333 = PyFloat_FromDouble(0.0755333333); if (unlikely(!__pyx_float_0_0755333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0779428571 = PyFloat_FromDouble(0.0779428571); if (unlikely(!__pyx_float_0_0779428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_0948380952 = PyFloat_FromDouble(0.0948380952); if (unlikely(!__pyx_float_0_0948380952)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1132428571 = PyFloat_FromDouble(0.1132428571); if (unlikely(!__pyx_float_0_1132428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1132952381 = PyFloat_FromDouble(0.1132952381); if (unlikely(!__pyx_float_0_1132952381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1252714286 = PyFloat_FromDouble(0.1252714286); if (unlikely(!__pyx_float_0_1252714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1452714286 = PyFloat_FromDouble(0.1452714286); if (unlikely(!__pyx_float_0_1452714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1633142857 = PyFloat_FromDouble(0.1633142857); if (unlikely(!__pyx_float_0_1633142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1707285714 = PyFloat_FromDouble(0.1707285714); if (unlikely(!__pyx_float_0_1707285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1793666667 = PyFloat_FromDouble(0.1793666667); if (unlikely(!__pyx_float_0_1793666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1801333333 = PyFloat_FromDouble(0.1801333333); if (unlikely(!__pyx_float_0_1801333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1897809524 = PyFloat_FromDouble(0.1897809524); if (unlikely(!__pyx_float_0_1897809524)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_1959047619 = PyFloat_FromDouble(0.1959047619); if (unlikely(!__pyx_float_0_1959047619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2116238095 = PyFloat_FromDouble(0.2116238095); if (unlikely(!__pyx_float_0_2116238095)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2137714286 = PyFloat_FromDouble(0.2137714286); if (unlikely(!__pyx_float_0_2137714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2164142857 = PyFloat_FromDouble(0.2164142857); if (unlikely(!__pyx_float_0_2164142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2178285714 = PyFloat_FromDouble(0.2178285714); if (unlikely(!__pyx_float_0_2178285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2586428571 = PyFloat_FromDouble(0.2586428571); if (unlikely(!__pyx_float_0_2586428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2644571429 = PyFloat_FromDouble(0.2644571429); if (unlikely(!__pyx_float_0_2644571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2886428571 = PyFloat_FromDouble(0.2886428571); if (unlikely(!__pyx_float_0_2886428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_2919380952 = PyFloat_FromDouble(0.2919380952); if (unlikely(!__pyx_float_0_2919380952)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3021714286 = PyFloat_FromDouble(0.3021714286); if (unlikely(!__pyx_float_0_3021714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3062761905 = PyFloat_FromDouble(0.3062761905); if (unlikely(!__pyx_float_0_3062761905)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3242428571 = PyFloat_FromDouble(0.3242428571); if (unlikely(!__pyx_float_0_3242428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3360285714 = PyFloat_FromDouble(0.3360285714); if (unlikely(!__pyx_float_0_3360285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3481666667 = PyFloat_FromDouble(0.3481666667); if (unlikely(!__pyx_float_0_3481666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3497904762 = PyFloat_FromDouble(0.3497904762); if (unlikely(!__pyx_float_0_3497904762)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3598333333 = PyFloat_FromDouble(0.3598333333); if (unlikely(!__pyx_float_0_3598333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3632714286 = PyFloat_FromDouble(0.3632714286); if (unlikely(!__pyx_float_0_3632714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3768142857 = PyFloat_FromDouble(0.3768142857); if (unlikely(!__pyx_float_0_3768142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3875095238 = PyFloat_FromDouble(0.3875095238); if (unlikely(!__pyx_float_0_3875095238)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3904761905 = PyFloat_FromDouble(0.3904761905); if (unlikely(!__pyx_float_0_3904761905)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_3952571429 = PyFloat_FromDouble(0.3952571429); if (unlikely(!__pyx_float_0_3952571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4044333333 = PyFloat_FromDouble(0.4044333333); if (unlikely(!__pyx_float_0_4044333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4086142857 = PyFloat_FromDouble(0.4086142857); if (unlikely(!__pyx_float_0_4086142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4336857143 = PyFloat_FromDouble(0.4336857143); if (unlikely(!__pyx_float_0_4336857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4420095238 = PyFloat_FromDouble(0.4420095238); if (unlikely(!__pyx_float_0_4420095238)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4430428571 = PyFloat_FromDouble(0.4430428571); if (unlikely(!__pyx_float_0_4430428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4493904762 = PyFloat_FromDouble(0.4493904762); if (unlikely(!__pyx_float_0_4493904762)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4585714286 = PyFloat_FromDouble(0.4585714286); if (unlikely(!__pyx_float_0_4585714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4661142857 = PyFloat_FromDouble(0.4661142857); if (unlikely(!__pyx_float_0_4661142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4736904762 = PyFloat_FromDouble(0.4736904762); if (unlikely(!__pyx_float_0_4736904762)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4839761905 = PyFloat_FromDouble(0.4839761905); if (unlikely(!__pyx_float_0_4839761905)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4871238095 = PyFloat_FromDouble(0.4871238095); if (unlikely(!__pyx_float_0_4871238095)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_4886666667 = PyFloat_FromDouble(0.4886666667); if (unlikely(!__pyx_float_0_4886666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5033142857 = PyFloat_FromDouble(0.5033142857); if (unlikely(!__pyx_float_0_5033142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5039857143 = PyFloat_FromDouble(0.5039857143); if (unlikely(!__pyx_float_0_5039857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5200238095 = PyFloat_FromDouble(0.5200238095); if (unlikely(!__pyx_float_0_5200238095)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5244428571 = PyFloat_FromDouble(0.5244428571); if (unlikely(!__pyx_float_0_5244428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5300285714 = PyFloat_FromDouble(0.5300285714); if (unlikely(!__pyx_float_0_5300285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5375428571 = PyFloat_FromDouble(0.5375428571); if (unlikely(!__pyx_float_0_5375428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5472666667 = PyFloat_FromDouble(0.5472666667); if (unlikely(!__pyx_float_0_5472666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5569857143 = PyFloat_FromDouble(0.5569857143); if (unlikely(!__pyx_float_0_5569857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5708571429 = PyFloat_FromDouble(0.5708571429); if (unlikely(!__pyx_float_0_5708571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5711857143 = PyFloat_FromDouble(0.5711857143); if (unlikely(!__pyx_float_0_5711857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5772238095 = PyFloat_FromDouble(0.5772238095); if (unlikely(!__pyx_float_0_5772238095)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5776761905 = PyFloat_FromDouble(0.5776761905); if (unlikely(!__pyx_float_0_5776761905)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5954285714 = PyFloat_FromDouble(0.5954285714); if (unlikely(!__pyx_float_0_5954285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_5965809524 = PyFloat_FromDouble(0.5965809524); if (unlikely(!__pyx_float_0_5965809524)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6192619048 = PyFloat_FromDouble(0.6192619048); if (unlikely(!__pyx_float_0_6192619048)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6269714286 = PyFloat_FromDouble(0.6269714286); if (unlikely(!__pyx_float_0_6269714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6286619048 = PyFloat_FromDouble(0.6286619048); if (unlikely(!__pyx_float_0_6286619048)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6417857143 = PyFloat_FromDouble(0.6417857143); if (unlikely(!__pyx_float_0_6417857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6424333333 = PyFloat_FromDouble(0.6424333333); if (unlikely(!__pyx_float_0_6424333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6534857143 = PyFloat_FromDouble(0.6534857143); if (unlikely(!__pyx_float_0_6534857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6641952381 = PyFloat_FromDouble(0.6641952381); if (unlikely(!__pyx_float_0_6641952381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6646285714 = PyFloat_FromDouble(0.6646285714); if (unlikely(!__pyx_float_0_6646285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6742714286 = PyFloat_FromDouble(0.6742714286); if (unlikely(!__pyx_float_0_6742714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6770857143 = PyFloat_FromDouble(0.6770857143); if (unlikely(!__pyx_float_0_6770857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6834190476 = PyFloat_FromDouble(0.6834190476); if (unlikely(!__pyx_float_0_6834190476)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6837571429 = PyFloat_FromDouble(0.6837571429); if (unlikely(!__pyx_float_0_6837571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6858571429 = PyFloat_FromDouble(0.6858571429); if (unlikely(!__pyx_float_0_6858571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_6928333333 = PyFloat_FromDouble(0.6928333333); if (unlikely(!__pyx_float_0_6928333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7061666667 = PyFloat_FromDouble(0.7061666667); if (unlikely(!__pyx_float_0_7061666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7097571429 = PyFloat_FromDouble(0.7097571429); if (unlikely(!__pyx_float_0_7097571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7176571429 = PyFloat_FromDouble(0.7176571429); if (unlikely(!__pyx_float_0_7176571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7184095238 = PyFloat_FromDouble(0.7184095238); if (unlikely(!__pyx_float_0_7184095238)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7250428571 = PyFloat_FromDouble(0.7250428571); if (unlikely(!__pyx_float_0_7250428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7253857143 = PyFloat_FromDouble(0.7253857143); if (unlikely(!__pyx_float_0_7253857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7257857143 = PyFloat_FromDouble(0.7257857143); if (unlikely(!__pyx_float_0_7257857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7261142857 = PyFloat_FromDouble(0.7261142857); if (unlikely(!__pyx_float_0_7261142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7274333333 = PyFloat_FromDouble(0.7274333333); if (unlikely(!__pyx_float_0_7274333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7313952381 = PyFloat_FromDouble(0.7313952381); if (unlikely(!__pyx_float_0_7313952381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7317142857 = PyFloat_FromDouble(0.7317142857); if (unlikely(!__pyx_float_0_7317142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7327333333 = PyFloat_FromDouble(0.7327333333); if (unlikely(!__pyx_float_0_7327333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7355666667 = PyFloat_FromDouble(0.7355666667); if (unlikely(!__pyx_float_0_7355666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7376047619 = PyFloat_FromDouble(0.7376047619); if (unlikely(!__pyx_float_0_7376047619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7411333333 = PyFloat_FromDouble(0.7411333333); if (unlikely(!__pyx_float_0_7411333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7424333333 = PyFloat_FromDouble(0.7424333333); if (unlikely(!__pyx_float_0_7424333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7434761905 = PyFloat_FromDouble(0.7434761905); if (unlikely(!__pyx_float_0_7434761905)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7454571429 = PyFloat_FromDouble(0.7454571429); if (unlikely(!__pyx_float_0_7454571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7473142857 = PyFloat_FromDouble(0.7473142857); if (unlikely(!__pyx_float_0_7473142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7480809524 = PyFloat_FromDouble(0.7480809524); if (unlikely(!__pyx_float_0_7480809524)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7485190476 = PyFloat_FromDouble(0.7485190476); if (unlikely(!__pyx_float_0_7485190476)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7490619048 = PyFloat_FromDouble(0.7490619048); if (unlikely(!__pyx_float_0_7490619048)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7491142857 = PyFloat_FromDouble(0.7491142857); if (unlikely(!__pyx_float_0_7491142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7524857143 = PyFloat_FromDouble(0.7524857143); if (unlikely(!__pyx_float_0_7524857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7607190476 = PyFloat_FromDouble(0.7607190476); if (unlikely(!__pyx_float_0_7607190476)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7653142857 = PyFloat_FromDouble(0.7653142857); if (unlikely(!__pyx_float_0_7653142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7767571429 = PyFloat_FromDouble(0.7767571429); if (unlikely(!__pyx_float_0_7767571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7858428571 = PyFloat_FromDouble(0.7858428571); if (unlikely(!__pyx_float_0_7858428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7860571429 = PyFloat_FromDouble(0.7860571429); if (unlikely(!__pyx_float_0_7860571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_7912666667 = PyFloat_FromDouble(0.7912666667); if (unlikely(!__pyx_float_0_7912666667)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8037619048 = PyFloat_FromDouble(0.8037619048); if (unlikely(!__pyx_float_0_8037619048)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8185047619 = PyFloat_FromDouble(0.8185047619); if (unlikely(!__pyx_float_0_8185047619)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8228285714 = PyFloat_FromDouble(0.8228285714); if (unlikely(!__pyx_float_0_8228285714)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8239571429 = PyFloat_FromDouble(0.8239571429); if (unlikely(!__pyx_float_0_8239571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8262714286 = PyFloat_FromDouble(0.8262714286); if (unlikely(!__pyx_float_0_8262714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8271428571 = PyFloat_FromDouble(0.8271428571); if (unlikely(!__pyx_float_0_8271428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8302714286 = PyFloat_FromDouble(0.8302714286); if (unlikely(!__pyx_float_0_8302714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8311809524 = PyFloat_FromDouble(0.8311809524); if (unlikely(!__pyx_float_0_8311809524)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8383714286 = PyFloat_FromDouble(0.8383714286); if (unlikely(!__pyx_float_0_8383714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8481380952 = PyFloat_FromDouble(0.8481380952); if (unlikely(!__pyx_float_0_8481380952)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8506571429 = PyFloat_FromDouble(0.8506571429); if (unlikely(!__pyx_float_0_8506571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8554380952 = PyFloat_FromDouble(0.8554380952); if (unlikely(!__pyx_float_0_8554380952)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8640571429 = PyFloat_FromDouble(0.8640571429); if (unlikely(!__pyx_float_0_8640571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8683333333 = PyFloat_FromDouble(0.8683333333); if (unlikely(!__pyx_float_0_8683333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8705142857 = PyFloat_FromDouble(0.8705142857); if (unlikely(!__pyx_float_0_8705142857)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8719571429 = PyFloat_FromDouble(0.8719571429); if (unlikely(!__pyx_float_0_8719571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8786333333 = PyFloat_FromDouble(0.8786333333); if (unlikely(!__pyx_float_0_8786333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8819571429 = PyFloat_FromDouble(0.8819571429); if (unlikely(!__pyx_float_0_8819571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8824333333 = PyFloat_FromDouble(0.8824333333); if (unlikely(!__pyx_float_0_8824333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_8828428571 = PyFloat_FromDouble(0.8828428571); if (unlikely(!__pyx_float_0_8828428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9139333333 = PyFloat_FromDouble(0.9139333333); if (unlikely(!__pyx_float_0_9139333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9218333333 = PyFloat_FromDouble(0.9218333333); if (unlikely(!__pyx_float_0_9218333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9449571429 = PyFloat_FromDouble(0.9449571429); if (unlikely(!__pyx_float_0_9449571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9514428571 = PyFloat_FromDouble(0.9514428571); if (unlikely(!__pyx_float_0_9514428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9588714286 = PyFloat_FromDouble(0.9588714286); if (unlikely(!__pyx_float_0_9588714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9598238095 = PyFloat_FromDouble(0.9598238095); if (unlikely(!__pyx_float_0_9598238095)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9625857143 = PyFloat_FromDouble(0.9625857143); if (unlikely(!__pyx_float_0_9625857143)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9738952381 = PyFloat_FromDouble(0.9738952381); if (unlikely(!__pyx_float_0_9738952381)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9788571429 = PyFloat_FromDouble(0.9788571429); if (unlikely(!__pyx_float_0_9788571429)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9937714286 = PyFloat_FromDouble(0.9937714286); if (unlikely(!__pyx_float_0_9937714286)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9955333333 = PyFloat_FromDouble(0.9955333333); if (unlikely(!__pyx_float_0_9955333333)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_float_0_9990428571 = PyFloat_FromDouble(0.9990428571); if (unlikely(!__pyx_float_0_9990428571)) __PYX_ERR(0, 1, __pyx_L1_error)
  return 0;
  __pyx_L1_error:;
  return -1;
}


static CYTHON_SMALL_CODE int __Pyx_InitGlobals(void) {
  return 0;
}


static CYTHON_SMALL_CODE int __Pyx_modinit_global_init_code(void); 
static CYTHON_SMALL_CODE int __Pyx_modinit_variable_export_code(void); 
static CYTHON_SMALL_CODE int __Pyx_modinit_function_export_code(void); 
static CYTHON_SMALL_CODE int __Pyx_modinit_type_init_code(void); 
static CYTHON_SMALL_CODE int __Pyx_modinit_type_import_code(void); 
static CYTHON_SMALL_CODE int __Pyx_modinit_variable_import_code(void); 
static CYTHON_SMALL_CODE int __Pyx_modinit_function_import_code(void); 

static int __Pyx_modinit_global_init_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_global_init_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}

static int __Pyx_modinit_variable_export_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_variable_export_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}

static int __Pyx_modinit_function_export_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_function_export_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}

static int __Pyx_modinit_type_init_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_type_init_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}

static int __Pyx_modinit_type_import_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_type_import_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}

static int __Pyx_modinit_variable_import_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_variable_import_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}

static int __Pyx_modinit_function_import_code(void) {
  __Pyx_RefNannyDeclarations
  __Pyx_RefNannySetupContext("__Pyx_modinit_function_import_code", 0);
  
  __Pyx_RefNannyFinishContext();
  return 0;
}


#if PY_MAJOR_VERSION >= 3
#if CYTHON_PEP489_MULTI_PHASE_INIT
static PyObject* __pyx_pymod_create(PyObject *spec, PyModuleDef *def); 
static int __pyx_pymod_exec_colormaps(PyObject* module); 
static PyModuleDef_Slot __pyx_moduledef_slots[] = {
  {Py_mod_create, (void*)__pyx_pymod_create},
  {Py_mod_exec, (void*)__pyx_pymod_exec_colormaps},
  {0, NULL}
};
#endif

#ifdef __cplusplus
namespace {
  struct PyModuleDef __pyx_moduledef =
  #else
  static struct PyModuleDef __pyx_moduledef =
  #endif
  {
      PyModuleDef_HEAD_INIT,
      "colormaps",
      0, 
    #if CYTHON_PEP489_MULTI_PHASE_INIT
      0, 
    #elif CYTHON_USE_MODULE_STATE
      sizeof(__pyx_mstate), 
    #else
      -1, 
    #endif
      __pyx_methods ,
    #if CYTHON_PEP489_MULTI_PHASE_INIT
      __pyx_moduledef_slots, 
    #else
      NULL, 
    #endif
    #if CYTHON_USE_MODULE_STATE
      __pyx_m_traverse, 
      __pyx_m_clear, 
      NULL 
    #else
      NULL, 
      NULL, 
      NULL 
    #endif
  };
  #ifdef __cplusplus
} 
#endif
#endif

#ifndef CYTHON_NO_PYINIT_EXPORT
#define __Pyx_PyMODINIT_FUNC PyMODINIT_FUNC
#elif PY_MAJOR_VERSION < 3
#ifdef __cplusplus
#define __Pyx_PyMODINIT_FUNC extern "C" void
#else
#define __Pyx_PyMODINIT_FUNC void
#endif
#else
#ifdef __cplusplus
#define __Pyx_PyMODINIT_FUNC extern "C" PyObject *
#else
#define __Pyx_PyMODINIT_FUNC PyObject *
#endif
#endif


#if PY_MAJOR_VERSION < 3
__Pyx_PyMODINIT_FUNC initcolormaps(void) CYTHON_SMALL_CODE; 
__Pyx_PyMODINIT_FUNC initcolormaps(void)
#else
__Pyx_PyMODINIT_FUNC PyInit_colormaps(void) CYTHON_SMALL_CODE; 
__Pyx_PyMODINIT_FUNC PyInit_colormaps(void)
#if CYTHON_PEP489_MULTI_PHASE_INIT
{
  return PyModuleDef_Init(&__pyx_moduledef);
}
static CYTHON_SMALL_CODE int __Pyx_check_single_interpreter(void) {
    #if PY_VERSION_HEX >= 0x030700A1
    static PY_INT64_T main_interpreter_id = -1;
    PY_INT64_T current_id = PyInterpreterState_GetID(PyThreadState_Get()->interp);
    if (main_interpreter_id == -1) {
        main_interpreter_id = current_id;
        return (unlikely(current_id == -1)) ? -1 : 0;
    } else if (unlikely(main_interpreter_id != current_id))
    #else
    static PyInterpreterState *main_interpreter = NULL;
    PyInterpreterState *current_interpreter = PyThreadState_Get()->interp;
    if (!main_interpreter) {
        main_interpreter = current_interpreter;
    } else if (unlikely(main_interpreter != current_interpreter))
    #endif
    {
        PyErr_SetString(
            PyExc_ImportError,
            "Interpreter change detected - this module can only be loaded into one interpreter per process.");
        return -1;
    }
    return 0;
}
#if CYTHON_COMPILING_IN_LIMITED_API
static CYTHON_SMALL_CODE int __Pyx_copy_spec_to_module(PyObject *spec, PyObject *module, const char* from_name, const char* to_name, int allow_none)
#else
static CYTHON_SMALL_CODE int __Pyx_copy_spec_to_module(PyObject *spec, PyObject *moddict, const char* from_name, const char* to_name, int allow_none)
#endif
{
    PyObject *value = PyObject_GetAttrString(spec, from_name);
    int result = 0;
    if (likely(value)) {
        if (allow_none || value != Py_None) {
#if CYTHON_COMPILING_IN_LIMITED_API
            result = PyModule_AddObject(module, to_name, value);
#else
            result = PyDict_SetItemString(moddict, to_name, value);
#endif
        }
        Py_DECREF(value);
    } else if (PyErr_ExceptionMatches(PyExc_AttributeError)) {
        PyErr_Clear();
    } else {
        result = -1;
    }
    return result;
}
static CYTHON_SMALL_CODE PyObject* __pyx_pymod_create(PyObject *spec, PyModuleDef *def) {
    PyObject *module = NULL, *moddict, *modname;
    CYTHON_UNUSED_VAR(def);
    if (__Pyx_check_single_interpreter())
        return NULL;
    if (__pyx_m)
        return __Pyx_NewRef(__pyx_m);
    modname = PyObject_GetAttrString(spec, "name");
    if (unlikely(!modname)) goto bad;
    module = PyModule_NewObject(modname);
    Py_DECREF(modname);
    if (unlikely(!module)) goto bad;
#if CYTHON_COMPILING_IN_LIMITED_API
    moddict = module;
#else
    moddict = PyModule_GetDict(module);
    if (unlikely(!moddict)) goto bad;
#endif
    if (unlikely(__Pyx_copy_spec_to_module(spec, moddict, "loader", "__loader__", 1) < 0)) goto bad;
    if (unlikely(__Pyx_copy_spec_to_module(spec, moddict, "origin", "__file__", 1) < 0)) goto bad;
    if (unlikely(__Pyx_copy_spec_to_module(spec, moddict, "parent", "__package__", 1) < 0)) goto bad;
    if (unlikely(__Pyx_copy_spec_to_module(spec, moddict, "submodule_search_locations", "__path__", 0) < 0)) goto bad;
    return module;
bad:
    Py_XDECREF(module);
    return NULL;
}


static CYTHON_SMALL_CODE int __pyx_pymod_exec_colormaps(PyObject *__pyx_pyinit_module)
#endif
#endif
{
  int stringtab_initialized = 0;
  #if CYTHON_USE_MODULE_STATE
  int pystate_addmodule_run = 0;
  #endif
  PyObject *__pyx_t_1 = NULL;
  PyObject *__pyx_t_2 = NULL;
  PyObject *__pyx_t_3 = NULL;
  PyObject *__pyx_t_4 = NULL;
  PyObject *__pyx_t_5 = NULL;
  PyObject *__pyx_t_6 = NULL;
  PyObject *__pyx_t_7 = NULL;
  PyObject *__pyx_t_8 = NULL;
  PyObject *__pyx_t_9 = NULL;
  PyObject *__pyx_t_10 = NULL;
  PyObject *__pyx_t_11 = NULL;
  PyObject *__pyx_t_12 = NULL;
  PyObject *__pyx_t_13 = NULL;
  PyObject *__pyx_t_14 = NULL;
  PyObject *__pyx_t_15 = NULL;
  PyObject *__pyx_t_16 = NULL;
  PyObject *__pyx_t_17 = NULL;
  PyObject *__pyx_t_18 = NULL;
  PyObject *__pyx_t_19 = NULL;
  PyObject *__pyx_t_20 = NULL;
  PyObject *__pyx_t_21 = NULL;
  PyObject *__pyx_t_22 = NULL;
  PyObject *__pyx_t_23 = NULL;
  PyObject *__pyx_t_24 = NULL;
  PyObject *__pyx_t_25 = NULL;
  PyObject *__pyx_t_26 = NULL;
  PyObject *__pyx_t_27 = NULL;
  PyObject *__pyx_t_28 = NULL;
  PyObject *__pyx_t_29 = NULL;
  PyObject *__pyx_t_30 = NULL;
  PyObject *__pyx_t_31 = NULL;
  PyObject *__pyx_t_32 = NULL;
  PyObject *__pyx_t_33 = NULL;
  PyObject *__pyx_t_34 = NULL;
  PyObject *__pyx_t_35 = NULL;
  PyObject *__pyx_t_36 = NULL;
  PyObject *__pyx_t_37 = NULL;
  PyObject *__pyx_t_38 = NULL;
  PyObject *__pyx_t_39 = NULL;
  PyObject *__pyx_t_40 = NULL;
  PyObject *__pyx_t_41 = NULL;
  PyObject *__pyx_t_42 = NULL;
  PyObject *__pyx_t_43 = NULL;
  PyObject *__pyx_t_44 = NULL;
  PyObject *__pyx_t_45 = NULL;
  PyObject *__pyx_t_46 = NULL;
  PyObject *__pyx_t_47 = NULL;
  PyObject *__pyx_t_48 = NULL;
  PyObject *__pyx_t_49 = NULL;
  PyObject *__pyx_t_50 = NULL;
  PyObject *__pyx_t_51 = NULL;
  PyObject *__pyx_t_52 = NULL;
  PyObject *__pyx_t_53 = NULL;
  PyObject *__pyx_t_54 = NULL;
  PyObject *__pyx_t_55 = NULL;
  PyObject *__pyx_t_56 = NULL;
  PyObject *__pyx_t_57 = NULL;
  PyObject *__pyx_t_58 = NULL;
  PyObject *__pyx_t_59 = NULL;
  PyObject *__pyx_t_60 = NULL;
  PyObject *__pyx_t_61 = NULL;
  PyObject *__pyx_t_62 = NULL;
  PyObject *__pyx_t_63 = NULL;
  PyObject *__pyx_t_64 = NULL;
  PyObject *__pyx_t_65 = NULL;
  PyObject *__pyx_t_66 = NULL;
  PyObject *__pyx_t_67 = NULL;
  PyObject *__pyx_t_68 = NULL;
  PyObject *__pyx_t_69 = NULL;
  PyObject *__pyx_t_70 = NULL;
  PyObject *__pyx_t_71 = NULL;
  PyObject *__pyx_t_72 = NULL;
  PyObject *__pyx_t_73 = NULL;
  PyObject *__pyx_t_74 = NULL;
  PyObject *__pyx_t_75 = NULL;
  PyObject *__pyx_t_76 = NULL;
  PyObject *__pyx_t_77 = NULL;
  PyObject *__pyx_t_78 = NULL;
  PyObject *__pyx_t_79 = NULL;
  PyObject *__pyx_t_80 = NULL;
  PyObject *__pyx_t_81 = NULL;
  PyObject *__pyx_t_82 = NULL;
  PyObject *__pyx_t_83 = NULL;
  PyObject *__pyx_t_84 = NULL;
  PyObject *__pyx_t_85 = NULL;
  PyObject *__pyx_t_86 = NULL;
  PyObject *__pyx_t_87 = NULL;
  PyObject *__pyx_t_88 = NULL;
  PyObject *__pyx_t_89 = NULL;
  PyObject *__pyx_t_90 = NULL;
  PyObject *__pyx_t_91 = NULL;
  PyObject *__pyx_t_92 = NULL;
  PyObject *__pyx_t_93 = NULL;
  PyObject *__pyx_t_94 = NULL;
  PyObject *__pyx_t_95 = NULL;
  PyObject *__pyx_t_96 = NULL;
  PyObject *__pyx_t_97 = NULL;
  PyObject *__pyx_t_98 = NULL;
  PyObject *__pyx_t_99 = NULL;
  PyObject *__pyx_t_100 = NULL;
  PyObject *__pyx_t_101 = NULL;
  PyObject *__pyx_t_102 = NULL;
  PyObject *__pyx_t_103 = NULL;
  PyObject *__pyx_t_104 = NULL;
  PyObject *__pyx_t_105 = NULL;
  PyObject *__pyx_t_106 = NULL;
  PyObject *__pyx_t_107 = NULL;
  PyObject *__pyx_t_108 = NULL;
  PyObject *__pyx_t_109 = NULL;
  PyObject *__pyx_t_110 = NULL;
  PyObject *__pyx_t_111 = NULL;
  PyObject *__pyx_t_112 = NULL;
  PyObject *__pyx_t_113 = NULL;
  PyObject *__pyx_t_114 = NULL;
  PyObject *__pyx_t_115 = NULL;
  PyObject *__pyx_t_116 = NULL;
  PyObject *__pyx_t_117 = NULL;
  PyObject *__pyx_t_118 = NULL;
  PyObject *__pyx_t_119 = NULL;
  PyObject *__pyx_t_120 = NULL;
  PyObject *__pyx_t_121 = NULL;
  PyObject *__pyx_t_122 = NULL;
  PyObject *__pyx_t_123 = NULL;
  PyObject *__pyx_t_124 = NULL;
  PyObject *__pyx_t_125 = NULL;
  PyObject *__pyx_t_126 = NULL;
  PyObject *__pyx_t_127 = NULL;
  PyObject *__pyx_t_128 = NULL;
  PyObject *__pyx_t_129 = NULL;
  PyObject *__pyx_t_130 = NULL;
  PyObject *__pyx_t_131 = NULL;
  PyObject *__pyx_t_132 = NULL;
  PyObject *__pyx_t_133 = NULL;
  PyObject *__pyx_t_134 = NULL;
  PyObject *__pyx_t_135 = NULL;
  PyObject *__pyx_t_136 = NULL;
  PyObject *__pyx_t_137 = NULL;
  PyObject *__pyx_t_138 = NULL;
  PyObject *__pyx_t_139 = NULL;
  PyObject *__pyx_t_140 = NULL;
  PyObject *__pyx_t_141 = NULL;
  PyObject *__pyx_t_142 = NULL;
  PyObject *__pyx_t_143 = NULL;
  PyObject *__pyx_t_144 = NULL;
  PyObject *__pyx_t_145 = NULL;
  PyObject *__pyx_t_146 = NULL;
  PyObject *__pyx_t_147 = NULL;
  PyObject *__pyx_t_148 = NULL;
  PyObject *__pyx_t_149 = NULL;
  PyObject *__pyx_t_150 = NULL;
  PyObject *__pyx_t_151 = NULL;
  PyObject *__pyx_t_152 = NULL;
  PyObject *__pyx_t_153 = NULL;
  PyObject *__pyx_t_154 = NULL;
  PyObject *__pyx_t_155 = NULL;
  PyObject *__pyx_t_156 = NULL;
  PyObject *__pyx_t_157 = NULL;
  PyObject *__pyx_t_158 = NULL;
  PyObject *__pyx_t_159 = NULL;
  PyObject *__pyx_t_160 = NULL;
  PyObject *__pyx_t_161 = NULL;
  PyObject *__pyx_t_162 = NULL;
  PyObject *__pyx_t_163 = NULL;
  PyObject *__pyx_t_164 = NULL;
  PyObject *__pyx_t_165 = NULL;
  PyObject *__pyx_t_166 = NULL;
  PyObject *__pyx_t_167 = NULL;
  PyObject *__pyx_t_168 = NULL;
  PyObject *__pyx_t_169 = NULL;
  PyObject *__pyx_t_170 = NULL;
  PyObject *__pyx_t_171 = NULL;
  PyObject *__pyx_t_172 = NULL;
  PyObject *__pyx_t_173 = NULL;
  PyObject *__pyx_t_174 = NULL;
  PyObject *__pyx_t_175 = NULL;
  PyObject *__pyx_t_176 = NULL;
  PyObject *__pyx_t_177 = NULL;
  PyObject *__pyx_t_178 = NULL;
  PyObject *__pyx_t_179 = NULL;
  PyObject *__pyx_t_180 = NULL;
  PyObject *__pyx_t_181 = NULL;
  PyObject *__pyx_t_182 = NULL;
  PyObject *__pyx_t_183 = NULL;
  PyObject *__pyx_t_184 = NULL;
  PyObject *__pyx_t_185 = NULL;
  PyObject *__pyx_t_186 = NULL;
  PyObject *__pyx_t_187 = NULL;
  PyObject *__pyx_t_188 = NULL;
  PyObject *__pyx_t_189 = NULL;
  PyObject *__pyx_t_190 = NULL;
  PyObject *__pyx_t_191 = NULL;
  PyObject *__pyx_t_192 = NULL;
  PyObject *__pyx_t_193 = NULL;
  PyObject *__pyx_t_194 = NULL;
  PyObject *__pyx_t_195 = NULL;
  PyObject *__pyx_t_196 = NULL;
  PyObject *__pyx_t_197 = NULL;
  PyObject *__pyx_t_198 = NULL;
  PyObject *__pyx_t_199 = NULL;
  PyObject *__pyx_t_200 = NULL;
  PyObject *__pyx_t_201 = NULL;
  PyObject *__pyx_t_202 = NULL;
  PyObject *__pyx_t_203 = NULL;
  PyObject *__pyx_t_204 = NULL;
  PyObject *__pyx_t_205 = NULL;
  PyObject *__pyx_t_206 = NULL;
  PyObject *__pyx_t_207 = NULL;
  PyObject *__pyx_t_208 = NULL;
  PyObject *__pyx_t_209 = NULL;
  PyObject *__pyx_t_210 = NULL;
  PyObject *__pyx_t_211 = NULL;
  PyObject *__pyx_t_212 = NULL;
  PyObject *__pyx_t_213 = NULL;
  PyObject *__pyx_t_214 = NULL;
  PyObject *__pyx_t_215 = NULL;
  PyObject *__pyx_t_216 = NULL;
  PyObject *__pyx_t_217 = NULL;
  PyObject *__pyx_t_218 = NULL;
  PyObject *__pyx_t_219 = NULL;
  PyObject *__pyx_t_220 = NULL;
  PyObject *__pyx_t_221 = NULL;
  PyObject *__pyx_t_222 = NULL;
  PyObject *__pyx_t_223 = NULL;
  PyObject *__pyx_t_224 = NULL;
  PyObject *__pyx_t_225 = NULL;
  PyObject *__pyx_t_226 = NULL;
  PyObject *__pyx_t_227 = NULL;
  PyObject *__pyx_t_228 = NULL;
  PyObject *__pyx_t_229 = NULL;
  PyObject *__pyx_t_230 = NULL;
  PyObject *__pyx_t_231 = NULL;
  PyObject *__pyx_t_232 = NULL;
  PyObject *__pyx_t_233 = NULL;
  PyObject *__pyx_t_234 = NULL;
  PyObject *__pyx_t_235 = NULL;
  PyObject *__pyx_t_236 = NULL;
  PyObject *__pyx_t_237 = NULL;
  PyObject *__pyx_t_238 = NULL;
  PyObject *__pyx_t_239 = NULL;
  PyObject *__pyx_t_240 = NULL;
  PyObject *__pyx_t_241 = NULL;
  PyObject *__pyx_t_242 = NULL;
  PyObject *__pyx_t_243 = NULL;
  PyObject *__pyx_t_244 = NULL;
  PyObject *__pyx_t_245 = NULL;
  PyObject *__pyx_t_246 = NULL;
  PyObject *__pyx_t_247 = NULL;
  PyObject *__pyx_t_248 = NULL;
  PyObject *__pyx_t_249 = NULL;
  PyObject *__pyx_t_250 = NULL;
  PyObject *__pyx_t_251 = NULL;
  PyObject *__pyx_t_252 = NULL;
  PyObject *__pyx_t_253 = NULL;
  PyObject *__pyx_t_254 = NULL;
  PyObject *__pyx_t_255 = NULL;
  PyObject *__pyx_t_256 = NULL;
  PyObject *__pyx_t_257 = NULL;
  PyObject *__pyx_t_258 = NULL;
  Py_ssize_t __pyx_t_259;
  int __pyx_lineno = 0;
  const char *__pyx_filename = NULL;
  int __pyx_clineno = 0;
  __Pyx_RefNannyDeclarations
  #if CYTHON_PEP489_MULTI_PHASE_INIT
  if (__pyx_m) {
    if (__pyx_m == __pyx_pyinit_module) return 0;
    PyErr_SetString(PyExc_RuntimeError, "Module 'colormaps' has already been imported. Re-initialisation is not supported.");
    return -1;
  }
  #elif PY_MAJOR_VERSION >= 3
  if (__pyx_m) return __Pyx_NewRef(__pyx_m);
  #endif
  
  #if CYTHON_PEP489_MULTI_PHASE_INIT
  __pyx_m = __pyx_pyinit_module;
  Py_INCREF(__pyx_m);
  #else
  #if PY_MAJOR_VERSION < 3
  __pyx_m = Py_InitModule4("colormaps", __pyx_methods, 0, 0, PYTHON_API_VERSION); Py_XINCREF(__pyx_m);
  if (unlikely(!__pyx_m)) __PYX_ERR(0, 1, __pyx_L1_error)
  #elif CYTHON_USE_MODULE_STATE
  __pyx_t_1 = PyModule_Create(&__pyx_moduledef); if (unlikely(!__pyx_t_1)) __PYX_ERR(0, 1, __pyx_L1_error)
  {
    int add_module_result = PyState_AddModule(__pyx_t_1, &__pyx_moduledef);
    __pyx_t_1 = 0; 
    if (unlikely((add_module_result < 0))) __PYX_ERR(0, 1, __pyx_L1_error)
    pystate_addmodule_run = 1;
  }
  #else
  __pyx_m = PyModule_Create(&__pyx_moduledef);
  if (unlikely(!__pyx_m)) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  #endif
  CYTHON_UNUSED_VAR(__pyx_t_1);
  __pyx_d = PyModule_GetDict(__pyx_m); if (unlikely(!__pyx_d)) __PYX_ERR(0, 1, __pyx_L1_error)
  Py_INCREF(__pyx_d);
  __pyx_b = __Pyx_PyImport_AddModuleRef(__Pyx_BUILTIN_MODULE_NAME); if (unlikely(!__pyx_b)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_cython_runtime = __Pyx_PyImport_AddModuleRef((const char *) "cython_runtime"); if (unlikely(!__pyx_cython_runtime)) __PYX_ERR(0, 1, __pyx_L1_error)
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #if CYTHON_REFNANNY
__Pyx_RefNanny = __Pyx_RefNannyImportAPI("refnanny");
if (!__Pyx_RefNanny) {
  PyErr_Clear();
  __Pyx_RefNanny = __Pyx_RefNannyImportAPI("Cython.Runtime.refnanny");
  if (!__Pyx_RefNanny)
      Py_FatalError("failed to import 'refnanny' module");
}
#endif
  __Pyx_RefNannySetupContext("__Pyx_PyMODINIT_FUNC PyInit_colormaps(void)", 0);
  if (__Pyx_check_binary_version(__PYX_LIMITED_VERSION_HEX, __Pyx_get_runtime_version(), CYTHON_COMPILING_IN_LIMITED_API) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #ifdef __Pxy_PyFrame_Initialize_Offsets
  __Pxy_PyFrame_Initialize_Offsets();
  #endif
  __pyx_empty_tuple = PyTuple_New(0); if (unlikely(!__pyx_empty_tuple)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_empty_bytes = PyBytes_FromStringAndSize("", 0); if (unlikely(!__pyx_empty_bytes)) __PYX_ERR(0, 1, __pyx_L1_error)
  __pyx_empty_unicode = PyUnicode_FromStringAndSize("", 0); if (unlikely(!__pyx_empty_unicode)) __PYX_ERR(0, 1, __pyx_L1_error)
  #ifdef __Pyx_CyFunction_USED
  if (__pyx_CyFunction_init(__pyx_m) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  #ifdef __Pyx_FusedFunction_USED
  if (__pyx_FusedFunction_init(__pyx_m) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  #ifdef __Pyx_Coroutine_USED
  if (__pyx_Coroutine_init(__pyx_m) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  #ifdef __Pyx_Generator_USED
  if (__pyx_Generator_init(__pyx_m) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  #ifdef __Pyx_AsyncGen_USED
  if (__pyx_AsyncGen_init(__pyx_m) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  #ifdef __Pyx_StopAsyncIteration_USED
  if (__pyx_StopAsyncIteration_init(__pyx_m) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  
  
  #if defined(WITH_THREAD) && PY_VERSION_HEX < 0x030700F0 && defined(__PYX_FORCE_INIT_THREADS) && __PYX_FORCE_INIT_THREADS
  PyEval_InitThreads();
  #endif
  
  if (__Pyx_InitConstants() < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  stringtab_initialized = 1;
  if (__Pyx_InitGlobals() < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #if PY_MAJOR_VERSION < 3 && (__PYX_DEFAULT_STRING_ENCODING_IS_ASCII || __PYX_DEFAULT_STRING_ENCODING_IS_DEFAULT)
  if (__Pyx_init_sys_getdefaultencoding_params() < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif
  if (__pyx_module_is_main_torchbox__utils__colormaps) {
    if (PyObject_SetAttr(__pyx_m, __pyx_n_s_name, __pyx_n_s_main) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  }
  #if PY_MAJOR_VERSION >= 3
  {
    PyObject *modules = PyImport_GetModuleDict(); if (unlikely(!modules)) __PYX_ERR(0, 1, __pyx_L1_error)
    if (!PyDict_GetItemString(modules, "torchbox.utils.colormaps")) {
      if (unlikely((PyDict_SetItemString(modules, "torchbox.utils.colormaps", __pyx_m) < 0))) __PYX_ERR(0, 1, __pyx_L1_error)
    }
  }
  #endif
  
  if (__Pyx_InitCachedBuiltins() < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  
  if (__Pyx_InitCachedConstants() < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  
  (void)__Pyx_modinit_global_init_code();
  (void)__Pyx_modinit_variable_export_code();
  (void)__Pyx_modinit_function_export_code();
  (void)__Pyx_modinit_type_init_code();
  (void)__Pyx_modinit_type_import_code();
  (void)__Pyx_modinit_variable_import_code();
  (void)__Pyx_modinit_function_import_code();
  
  #if defined(__Pyx_Generator_USED) || defined(__Pyx_Coroutine_USED)
  if (__Pyx_patch_abc() < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  #endif

  
  __pyx_t_2 = __Pyx_ImportDottedModule(__pyx_n_s_torch, NULL); if (unlikely(!__pyx_t_2)) __PYX_ERR(0, 18, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_2);
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_th, __pyx_t_2) < 0) __PYX_ERR(0, 18, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_2); __pyx_t_2 = 0;

  
  __pyx_t_2 = PyList_New(2); if (unlikely(!__pyx_t_2)) __PYX_ERR(0, 20, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_2);
  __Pyx_INCREF(__pyx_n_u_viridis);
  __Pyx_GIVEREF(__pyx_n_u_viridis);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_2, 0, __pyx_n_u_viridis)) __PYX_ERR(0, 20, __pyx_L1_error);
  __Pyx_INCREF(__pyx_n_u_parula);
  __Pyx_GIVEREF(__pyx_n_u_parula);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_2, 1, __pyx_n_u_parula)) __PYX_ERR(0, 20, __pyx_L1_error);
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_all, __pyx_t_2) < 0) __PYX_ERR(0, 20, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_2); __pyx_t_2 = 0;

  
  __pyx_t_2 = PyList_New(3); if (unlikely(!__pyx_t_2)) __PYX_ERR(0, 22, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_2);
  __Pyx_INCREF(__pyx_float_0_267004);
  __Pyx_GIVEREF(__pyx_float_0_267004);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_2, 0, __pyx_float_0_267004)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_004874);
  __Pyx_GIVEREF(__pyx_float_0_004874);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_2, 1, __pyx_float_0_004874)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_329415);
  __Pyx_GIVEREF(__pyx_float_0_329415);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_2, 2, __pyx_float_0_329415)) __PYX_ERR(0, 22, __pyx_L1_error);

  
  __pyx_t_3 = PyList_New(3); if (unlikely(!__pyx_t_3)) __PYX_ERR(0, 23, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_3);
  __Pyx_INCREF(__pyx_float_0_268510);
  __Pyx_GIVEREF(__pyx_float_0_268510);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_3, 0, __pyx_float_0_268510)) __PYX_ERR(0, 23, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_009605);
  __Pyx_GIVEREF(__pyx_float_0_009605);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_3, 1, __pyx_float_0_009605)) __PYX_ERR(0, 23, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_335427);
  __Pyx_GIVEREF(__pyx_float_0_335427);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_3, 2, __pyx_float_0_335427)) __PYX_ERR(0, 23, __pyx_L1_error);

  
  __pyx_t_4 = PyList_New(3); if (unlikely(!__pyx_t_4)) __PYX_ERR(0, 24, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_4);
  __Pyx_INCREF(__pyx_float_0_269944);
  __Pyx_GIVEREF(__pyx_float_0_269944);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_4, 0, __pyx_float_0_269944)) __PYX_ERR(0, 24, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_014625);
  __Pyx_GIVEREF(__pyx_float_0_014625);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_4, 1, __pyx_float_0_014625)) __PYX_ERR(0, 24, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_341379);
  __Pyx_GIVEREF(__pyx_float_0_341379);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_4, 2, __pyx_float_0_341379)) __PYX_ERR(0, 24, __pyx_L1_error);

  
  __pyx_t_5 = PyList_New(3); if (unlikely(!__pyx_t_5)) __PYX_ERR(0, 25, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_5);
  __Pyx_INCREF(__pyx_float_0_271305);
  __Pyx_GIVEREF(__pyx_float_0_271305);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_5, 0, __pyx_float_0_271305)) __PYX_ERR(0, 25, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_019942);
  __Pyx_GIVEREF(__pyx_float_0_019942);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_5, 1, __pyx_float_0_019942)) __PYX_ERR(0, 25, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_347269);
  __Pyx_GIVEREF(__pyx_float_0_347269);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_5, 2, __pyx_float_0_347269)) __PYX_ERR(0, 25, __pyx_L1_error);

  
  __pyx_t_6 = PyList_New(3); if (unlikely(!__pyx_t_6)) __PYX_ERR(0, 26, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_6);
  __Pyx_INCREF(__pyx_float_0_272594);
  __Pyx_GIVEREF(__pyx_float_0_272594);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_6, 0, __pyx_float_0_272594)) __PYX_ERR(0, 26, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_025563);
  __Pyx_GIVEREF(__pyx_float_0_025563);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_6, 1, __pyx_float_0_025563)) __PYX_ERR(0, 26, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_353093);
  __Pyx_GIVEREF(__pyx_float_0_353093);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_6, 2, __pyx_float_0_353093)) __PYX_ERR(0, 26, __pyx_L1_error);

  
  __pyx_t_7 = PyList_New(3); if (unlikely(!__pyx_t_7)) __PYX_ERR(0, 27, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_7);
  __Pyx_INCREF(__pyx_float_0_273809);
  __Pyx_GIVEREF(__pyx_float_0_273809);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_7, 0, __pyx_float_0_273809)) __PYX_ERR(0, 27, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_031497);
  __Pyx_GIVEREF(__pyx_float_0_031497);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_7, 1, __pyx_float_0_031497)) __PYX_ERR(0, 27, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_358853);
  __Pyx_GIVEREF(__pyx_float_0_358853);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_7, 2, __pyx_float_0_358853)) __PYX_ERR(0, 27, __pyx_L1_error);

  
  __pyx_t_8 = PyList_New(3); if (unlikely(!__pyx_t_8)) __PYX_ERR(0, 28, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_8);
  __Pyx_INCREF(__pyx_float_0_274952);
  __Pyx_GIVEREF(__pyx_float_0_274952);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_8, 0, __pyx_float_0_274952)) __PYX_ERR(0, 28, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_037752);
  __Pyx_GIVEREF(__pyx_float_0_037752);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_8, 1, __pyx_float_0_037752)) __PYX_ERR(0, 28, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_364543);
  __Pyx_GIVEREF(__pyx_float_0_364543);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_8, 2, __pyx_float_0_364543)) __PYX_ERR(0, 28, __pyx_L1_error);

  
  __pyx_t_9 = PyList_New(3); if (unlikely(!__pyx_t_9)) __PYX_ERR(0, 29, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_9);
  __Pyx_INCREF(__pyx_float_0_276022);
  __Pyx_GIVEREF(__pyx_float_0_276022);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_9, 0, __pyx_float_0_276022)) __PYX_ERR(0, 29, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_044167);
  __Pyx_GIVEREF(__pyx_float_0_044167);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_9, 1, __pyx_float_0_044167)) __PYX_ERR(0, 29, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_370164);
  __Pyx_GIVEREF(__pyx_float_0_370164);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_9, 2, __pyx_float_0_370164)) __PYX_ERR(0, 29, __pyx_L1_error);

  
  __pyx_t_10 = PyList_New(3); if (unlikely(!__pyx_t_10)) __PYX_ERR(0, 30, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_10);
  __Pyx_INCREF(__pyx_float_0_277018);
  __Pyx_GIVEREF(__pyx_float_0_277018);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_10, 0, __pyx_float_0_277018)) __PYX_ERR(0, 30, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_050344);
  __Pyx_GIVEREF(__pyx_float_0_050344);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_10, 1, __pyx_float_0_050344)) __PYX_ERR(0, 30, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_375715);
  __Pyx_GIVEREF(__pyx_float_0_375715);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_10, 2, __pyx_float_0_375715)) __PYX_ERR(0, 30, __pyx_L1_error);

  
  __pyx_t_11 = PyList_New(3); if (unlikely(!__pyx_t_11)) __PYX_ERR(0, 31, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_11);
  __Pyx_INCREF(__pyx_float_0_277941);
  __Pyx_GIVEREF(__pyx_float_0_277941);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_11, 0, __pyx_float_0_277941)) __PYX_ERR(0, 31, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_056324);
  __Pyx_GIVEREF(__pyx_float_0_056324);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_11, 1, __pyx_float_0_056324)) __PYX_ERR(0, 31, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_381191);
  __Pyx_GIVEREF(__pyx_float_0_381191);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_11, 2, __pyx_float_0_381191)) __PYX_ERR(0, 31, __pyx_L1_error);

  
  __pyx_t_12 = PyList_New(3); if (unlikely(!__pyx_t_12)) __PYX_ERR(0, 32, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_12);
  __Pyx_INCREF(__pyx_float_0_278791);
  __Pyx_GIVEREF(__pyx_float_0_278791);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_12, 0, __pyx_float_0_278791)) __PYX_ERR(0, 32, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_062145);
  __Pyx_GIVEREF(__pyx_float_0_062145);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_12, 1, __pyx_float_0_062145)) __PYX_ERR(0, 32, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_386592);
  __Pyx_GIVEREF(__pyx_float_0_386592);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_12, 2, __pyx_float_0_386592)) __PYX_ERR(0, 32, __pyx_L1_error);

  
  __pyx_t_13 = PyList_New(3); if (unlikely(!__pyx_t_13)) __PYX_ERR(0, 33, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_13);
  __Pyx_INCREF(__pyx_float_0_279566);
  __Pyx_GIVEREF(__pyx_float_0_279566);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_13, 0, __pyx_float_0_279566)) __PYX_ERR(0, 33, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_067836);
  __Pyx_GIVEREF(__pyx_float_0_067836);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_13, 1, __pyx_float_0_067836)) __PYX_ERR(0, 33, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_391917);
  __Pyx_GIVEREF(__pyx_float_0_391917);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_13, 2, __pyx_float_0_391917)) __PYX_ERR(0, 33, __pyx_L1_error);

  
  __pyx_t_14 = PyList_New(3); if (unlikely(!__pyx_t_14)) __PYX_ERR(0, 34, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_14);
  __Pyx_INCREF(__pyx_float_0_280267);
  __Pyx_GIVEREF(__pyx_float_0_280267);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_14, 0, __pyx_float_0_280267)) __PYX_ERR(0, 34, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_073417);
  __Pyx_GIVEREF(__pyx_float_0_073417);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_14, 1, __pyx_float_0_073417)) __PYX_ERR(0, 34, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_397163);
  __Pyx_GIVEREF(__pyx_float_0_397163);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_14, 2, __pyx_float_0_397163)) __PYX_ERR(0, 34, __pyx_L1_error);

  
  __pyx_t_15 = PyList_New(3); if (unlikely(!__pyx_t_15)) __PYX_ERR(0, 35, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_15);
  __Pyx_INCREF(__pyx_float_0_280894);
  __Pyx_GIVEREF(__pyx_float_0_280894);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_15, 0, __pyx_float_0_280894)) __PYX_ERR(0, 35, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_078907);
  __Pyx_GIVEREF(__pyx_float_0_078907);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_15, 1, __pyx_float_0_078907)) __PYX_ERR(0, 35, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_402329);
  __Pyx_GIVEREF(__pyx_float_0_402329);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_15, 2, __pyx_float_0_402329)) __PYX_ERR(0, 35, __pyx_L1_error);

  
  __pyx_t_16 = PyList_New(3); if (unlikely(!__pyx_t_16)) __PYX_ERR(0, 36, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_16);
  __Pyx_INCREF(__pyx_float_0_281446);
  __Pyx_GIVEREF(__pyx_float_0_281446);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_16, 0, __pyx_float_0_281446)) __PYX_ERR(0, 36, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_084320);
  __Pyx_GIVEREF(__pyx_float_0_084320);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_16, 1, __pyx_float_0_084320)) __PYX_ERR(0, 36, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_407414);
  __Pyx_GIVEREF(__pyx_float_0_407414);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_16, 2, __pyx_float_0_407414)) __PYX_ERR(0, 36, __pyx_L1_error);

  
  __pyx_t_17 = PyList_New(3); if (unlikely(!__pyx_t_17)) __PYX_ERR(0, 37, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_17);
  __Pyx_INCREF(__pyx_float_0_281924);
  __Pyx_GIVEREF(__pyx_float_0_281924);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_17, 0, __pyx_float_0_281924)) __PYX_ERR(0, 37, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_089666);
  __Pyx_GIVEREF(__pyx_float_0_089666);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_17, 1, __pyx_float_0_089666)) __PYX_ERR(0, 37, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_412415);
  __Pyx_GIVEREF(__pyx_float_0_412415);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_17, 2, __pyx_float_0_412415)) __PYX_ERR(0, 37, __pyx_L1_error);

  
  __pyx_t_18 = PyList_New(3); if (unlikely(!__pyx_t_18)) __PYX_ERR(0, 38, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_18);
  __Pyx_INCREF(__pyx_float_0_282327);
  __Pyx_GIVEREF(__pyx_float_0_282327);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_18, 0, __pyx_float_0_282327)) __PYX_ERR(0, 38, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_094955);
  __Pyx_GIVEREF(__pyx_float_0_094955);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_18, 1, __pyx_float_0_094955)) __PYX_ERR(0, 38, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_417331);
  __Pyx_GIVEREF(__pyx_float_0_417331);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_18, 2, __pyx_float_0_417331)) __PYX_ERR(0, 38, __pyx_L1_error);

  
  __pyx_t_19 = PyList_New(3); if (unlikely(!__pyx_t_19)) __PYX_ERR(0, 39, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_19);
  __Pyx_INCREF(__pyx_float_0_282656);
  __Pyx_GIVEREF(__pyx_float_0_282656);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_19, 0, __pyx_float_0_282656)) __PYX_ERR(0, 39, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_100196);
  __Pyx_GIVEREF(__pyx_float_0_100196);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_19, 1, __pyx_float_0_100196)) __PYX_ERR(0, 39, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_422160);
  __Pyx_GIVEREF(__pyx_float_0_422160);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_19, 2, __pyx_float_0_422160)) __PYX_ERR(0, 39, __pyx_L1_error);

  
  __pyx_t_20 = PyList_New(3); if (unlikely(!__pyx_t_20)) __PYX_ERR(0, 40, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_20);
  __Pyx_INCREF(__pyx_float_0_282910);
  __Pyx_GIVEREF(__pyx_float_0_282910);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_20, 0, __pyx_float_0_282910)) __PYX_ERR(0, 40, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_105393);
  __Pyx_GIVEREF(__pyx_float_0_105393);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_20, 1, __pyx_float_0_105393)) __PYX_ERR(0, 40, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_426902);
  __Pyx_GIVEREF(__pyx_float_0_426902);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_20, 2, __pyx_float_0_426902)) __PYX_ERR(0, 40, __pyx_L1_error);

  
  __pyx_t_21 = PyList_New(3); if (unlikely(!__pyx_t_21)) __PYX_ERR(0, 41, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_21);
  __Pyx_INCREF(__pyx_float_0_283091);
  __Pyx_GIVEREF(__pyx_float_0_283091);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_21, 0, __pyx_float_0_283091)) __PYX_ERR(0, 41, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_110553);
  __Pyx_GIVEREF(__pyx_float_0_110553);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_21, 1, __pyx_float_0_110553)) __PYX_ERR(0, 41, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_431554);
  __Pyx_GIVEREF(__pyx_float_0_431554);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_21, 2, __pyx_float_0_431554)) __PYX_ERR(0, 41, __pyx_L1_error);

  
  __pyx_t_22 = PyList_New(3); if (unlikely(!__pyx_t_22)) __PYX_ERR(0, 42, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_22);
  __Pyx_INCREF(__pyx_float_0_283197);
  __Pyx_GIVEREF(__pyx_float_0_283197);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_22, 0, __pyx_float_0_283197)) __PYX_ERR(0, 42, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_115680);
  __Pyx_GIVEREF(__pyx_float_0_115680);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_22, 1, __pyx_float_0_115680)) __PYX_ERR(0, 42, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_436115);
  __Pyx_GIVEREF(__pyx_float_0_436115);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_22, 2, __pyx_float_0_436115)) __PYX_ERR(0, 42, __pyx_L1_error);

  
  __pyx_t_23 = PyList_New(3); if (unlikely(!__pyx_t_23)) __PYX_ERR(0, 43, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_23);
  __Pyx_INCREF(__pyx_float_0_283229);
  __Pyx_GIVEREF(__pyx_float_0_283229);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_23, 0, __pyx_float_0_283229)) __PYX_ERR(0, 43, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_120777);
  __Pyx_GIVEREF(__pyx_float_0_120777);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_23, 1, __pyx_float_0_120777)) __PYX_ERR(0, 43, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_440584);
  __Pyx_GIVEREF(__pyx_float_0_440584);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_23, 2, __pyx_float_0_440584)) __PYX_ERR(0, 43, __pyx_L1_error);

  
  __pyx_t_24 = PyList_New(3); if (unlikely(!__pyx_t_24)) __PYX_ERR(0, 44, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_24);
  __Pyx_INCREF(__pyx_float_0_283187);
  __Pyx_GIVEREF(__pyx_float_0_283187);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_24, 0, __pyx_float_0_283187)) __PYX_ERR(0, 44, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_125848);
  __Pyx_GIVEREF(__pyx_float_0_125848);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_24, 1, __pyx_float_0_125848)) __PYX_ERR(0, 44, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_444960);
  __Pyx_GIVEREF(__pyx_float_0_444960);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_24, 2, __pyx_float_0_444960)) __PYX_ERR(0, 44, __pyx_L1_error);

  
  __pyx_t_25 = PyList_New(3); if (unlikely(!__pyx_t_25)) __PYX_ERR(0, 45, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_25);
  __Pyx_INCREF(__pyx_float_0_283072);
  __Pyx_GIVEREF(__pyx_float_0_283072);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_25, 0, __pyx_float_0_283072)) __PYX_ERR(0, 45, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_130895);
  __Pyx_GIVEREF(__pyx_float_0_130895);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_25, 1, __pyx_float_0_130895)) __PYX_ERR(0, 45, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_449241);
  __Pyx_GIVEREF(__pyx_float_0_449241);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_25, 2, __pyx_float_0_449241)) __PYX_ERR(0, 45, __pyx_L1_error);

  
  __pyx_t_26 = PyList_New(3); if (unlikely(!__pyx_t_26)) __PYX_ERR(0, 46, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_26);
  __Pyx_INCREF(__pyx_float_0_282884);
  __Pyx_GIVEREF(__pyx_float_0_282884);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_26, 0, __pyx_float_0_282884)) __PYX_ERR(0, 46, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_135920);
  __Pyx_GIVEREF(__pyx_float_0_135920);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_26, 1, __pyx_float_0_135920)) __PYX_ERR(0, 46, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_453427);
  __Pyx_GIVEREF(__pyx_float_0_453427);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_26, 2, __pyx_float_0_453427)) __PYX_ERR(0, 46, __pyx_L1_error);

  
  __pyx_t_27 = PyList_New(3); if (unlikely(!__pyx_t_27)) __PYX_ERR(0, 47, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_27);
  __Pyx_INCREF(__pyx_float_0_282623);
  __Pyx_GIVEREF(__pyx_float_0_282623);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_27, 0, __pyx_float_0_282623)) __PYX_ERR(0, 47, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_140926);
  __Pyx_GIVEREF(__pyx_float_0_140926);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_27, 1, __pyx_float_0_140926)) __PYX_ERR(0, 47, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_457517);
  __Pyx_GIVEREF(__pyx_float_0_457517);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_27, 2, __pyx_float_0_457517)) __PYX_ERR(0, 47, __pyx_L1_error);

  
  __pyx_t_28 = PyList_New(3); if (unlikely(!__pyx_t_28)) __PYX_ERR(0, 48, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_28);
  __Pyx_INCREF(__pyx_float_0_282290);
  __Pyx_GIVEREF(__pyx_float_0_282290);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_28, 0, __pyx_float_0_282290)) __PYX_ERR(0, 48, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_145912);
  __Pyx_GIVEREF(__pyx_float_0_145912);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_28, 1, __pyx_float_0_145912)) __PYX_ERR(0, 48, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_461510);
  __Pyx_GIVEREF(__pyx_float_0_461510);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_28, 2, __pyx_float_0_461510)) __PYX_ERR(0, 48, __pyx_L1_error);

  
  __pyx_t_29 = PyList_New(3); if (unlikely(!__pyx_t_29)) __PYX_ERR(0, 49, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_29);
  __Pyx_INCREF(__pyx_float_0_281887);
  __Pyx_GIVEREF(__pyx_float_0_281887);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_29, 0, __pyx_float_0_281887)) __PYX_ERR(0, 49, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_150881);
  __Pyx_GIVEREF(__pyx_float_0_150881);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_29, 1, __pyx_float_0_150881)) __PYX_ERR(0, 49, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_465405);
  __Pyx_GIVEREF(__pyx_float_0_465405);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_29, 2, __pyx_float_0_465405)) __PYX_ERR(0, 49, __pyx_L1_error);

  
  __pyx_t_30 = PyList_New(3); if (unlikely(!__pyx_t_30)) __PYX_ERR(0, 50, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_30);
  __Pyx_INCREF(__pyx_float_0_281412);
  __Pyx_GIVEREF(__pyx_float_0_281412);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_30, 0, __pyx_float_0_281412)) __PYX_ERR(0, 50, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_155834);
  __Pyx_GIVEREF(__pyx_float_0_155834);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_30, 1, __pyx_float_0_155834)) __PYX_ERR(0, 50, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_469201);
  __Pyx_GIVEREF(__pyx_float_0_469201);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_30, 2, __pyx_float_0_469201)) __PYX_ERR(0, 50, __pyx_L1_error);

  
  __pyx_t_31 = PyList_New(3); if (unlikely(!__pyx_t_31)) __PYX_ERR(0, 51, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_31);
  __Pyx_INCREF(__pyx_float_0_280868);
  __Pyx_GIVEREF(__pyx_float_0_280868);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_31, 0, __pyx_float_0_280868)) __PYX_ERR(0, 51, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_160771);
  __Pyx_GIVEREF(__pyx_float_0_160771);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_31, 1, __pyx_float_0_160771)) __PYX_ERR(0, 51, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_472899);
  __Pyx_GIVEREF(__pyx_float_0_472899);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_31, 2, __pyx_float_0_472899)) __PYX_ERR(0, 51, __pyx_L1_error);

  
  __pyx_t_32 = PyList_New(3); if (unlikely(!__pyx_t_32)) __PYX_ERR(0, 52, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_32);
  __Pyx_INCREF(__pyx_float_0_280255);
  __Pyx_GIVEREF(__pyx_float_0_280255);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_32, 0, __pyx_float_0_280255)) __PYX_ERR(0, 52, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_165693);
  __Pyx_GIVEREF(__pyx_float_0_165693);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_32, 1, __pyx_float_0_165693)) __PYX_ERR(0, 52, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_476498);
  __Pyx_GIVEREF(__pyx_float_0_476498);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_32, 2, __pyx_float_0_476498)) __PYX_ERR(0, 52, __pyx_L1_error);

  
  __pyx_t_33 = PyList_New(3); if (unlikely(!__pyx_t_33)) __PYX_ERR(0, 53, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_33);
  __Pyx_INCREF(__pyx_float_0_279574);
  __Pyx_GIVEREF(__pyx_float_0_279574);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_33, 0, __pyx_float_0_279574)) __PYX_ERR(0, 53, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_170599);
  __Pyx_GIVEREF(__pyx_float_0_170599);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_33, 1, __pyx_float_0_170599)) __PYX_ERR(0, 53, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_479997);
  __Pyx_GIVEREF(__pyx_float_0_479997);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_33, 2, __pyx_float_0_479997)) __PYX_ERR(0, 53, __pyx_L1_error);

  
  __pyx_t_34 = PyList_New(3); if (unlikely(!__pyx_t_34)) __PYX_ERR(0, 54, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_34);
  __Pyx_INCREF(__pyx_float_0_278826);
  __Pyx_GIVEREF(__pyx_float_0_278826);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_34, 0, __pyx_float_0_278826)) __PYX_ERR(0, 54, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_175490);
  __Pyx_GIVEREF(__pyx_float_0_175490);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_34, 1, __pyx_float_0_175490)) __PYX_ERR(0, 54, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_483397);
  __Pyx_GIVEREF(__pyx_float_0_483397);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_34, 2, __pyx_float_0_483397)) __PYX_ERR(0, 54, __pyx_L1_error);

  
  __pyx_t_35 = PyList_New(3); if (unlikely(!__pyx_t_35)) __PYX_ERR(0, 55, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_35);
  __Pyx_INCREF(__pyx_float_0_278012);
  __Pyx_GIVEREF(__pyx_float_0_278012);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_35, 0, __pyx_float_0_278012)) __PYX_ERR(0, 55, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_180367);
  __Pyx_GIVEREF(__pyx_float_0_180367);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_35, 1, __pyx_float_0_180367)) __PYX_ERR(0, 55, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_486697);
  __Pyx_GIVEREF(__pyx_float_0_486697);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_35, 2, __pyx_float_0_486697)) __PYX_ERR(0, 55, __pyx_L1_error);

  
  __pyx_t_36 = PyList_New(3); if (unlikely(!__pyx_t_36)) __PYX_ERR(0, 56, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_36);
  __Pyx_INCREF(__pyx_float_0_277134);
  __Pyx_GIVEREF(__pyx_float_0_277134);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_36, 0, __pyx_float_0_277134)) __PYX_ERR(0, 56, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_185228);
  __Pyx_GIVEREF(__pyx_float_0_185228);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_36, 1, __pyx_float_0_185228)) __PYX_ERR(0, 56, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_489898);
  __Pyx_GIVEREF(__pyx_float_0_489898);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_36, 2, __pyx_float_0_489898)) __PYX_ERR(0, 56, __pyx_L1_error);

  
  __pyx_t_37 = PyList_New(3); if (unlikely(!__pyx_t_37)) __PYX_ERR(0, 57, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_37);
  __Pyx_INCREF(__pyx_float_0_276194);
  __Pyx_GIVEREF(__pyx_float_0_276194);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_37, 0, __pyx_float_0_276194)) __PYX_ERR(0, 57, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_190074);
  __Pyx_GIVEREF(__pyx_float_0_190074);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_37, 1, __pyx_float_0_190074)) __PYX_ERR(0, 57, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_493001);
  __Pyx_GIVEREF(__pyx_float_0_493001);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_37, 2, __pyx_float_0_493001)) __PYX_ERR(0, 57, __pyx_L1_error);

  
  __pyx_t_38 = PyList_New(3); if (unlikely(!__pyx_t_38)) __PYX_ERR(0, 58, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_38);
  __Pyx_INCREF(__pyx_float_0_275191);
  __Pyx_GIVEREF(__pyx_float_0_275191);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_38, 0, __pyx_float_0_275191)) __PYX_ERR(0, 58, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_194905);
  __Pyx_GIVEREF(__pyx_float_0_194905);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_38, 1, __pyx_float_0_194905)) __PYX_ERR(0, 58, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_496005);
  __Pyx_GIVEREF(__pyx_float_0_496005);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_38, 2, __pyx_float_0_496005)) __PYX_ERR(0, 58, __pyx_L1_error);

  
  __pyx_t_39 = PyList_New(3); if (unlikely(!__pyx_t_39)) __PYX_ERR(0, 59, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_39);
  __Pyx_INCREF(__pyx_float_0_274128);
  __Pyx_GIVEREF(__pyx_float_0_274128);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_39, 0, __pyx_float_0_274128)) __PYX_ERR(0, 59, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_199721);
  __Pyx_GIVEREF(__pyx_float_0_199721);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_39, 1, __pyx_float_0_199721)) __PYX_ERR(0, 59, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_498911);
  __Pyx_GIVEREF(__pyx_float_0_498911);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_39, 2, __pyx_float_0_498911)) __PYX_ERR(0, 59, __pyx_L1_error);

  
  __pyx_t_40 = PyList_New(3); if (unlikely(!__pyx_t_40)) __PYX_ERR(0, 60, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_40);
  __Pyx_INCREF(__pyx_float_0_273006);
  __Pyx_GIVEREF(__pyx_float_0_273006);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_40, 0, __pyx_float_0_273006)) __PYX_ERR(0, 60, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_204520);
  __Pyx_GIVEREF(__pyx_float_0_204520);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_40, 1, __pyx_float_0_204520)) __PYX_ERR(0, 60, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_501721);
  __Pyx_GIVEREF(__pyx_float_0_501721);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_40, 2, __pyx_float_0_501721)) __PYX_ERR(0, 60, __pyx_L1_error);

  
  __pyx_t_41 = PyList_New(3); if (unlikely(!__pyx_t_41)) __PYX_ERR(0, 61, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_41);
  __Pyx_INCREF(__pyx_float_0_271828);
  __Pyx_GIVEREF(__pyx_float_0_271828);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_41, 0, __pyx_float_0_271828)) __PYX_ERR(0, 61, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_209303);
  __Pyx_GIVEREF(__pyx_float_0_209303);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_41, 1, __pyx_float_0_209303)) __PYX_ERR(0, 61, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_504434);
  __Pyx_GIVEREF(__pyx_float_0_504434);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_41, 2, __pyx_float_0_504434)) __PYX_ERR(0, 61, __pyx_L1_error);

  
  __pyx_t_42 = PyList_New(3); if (unlikely(!__pyx_t_42)) __PYX_ERR(0, 62, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_42);
  __Pyx_INCREF(__pyx_float_0_270595);
  __Pyx_GIVEREF(__pyx_float_0_270595);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_42, 0, __pyx_float_0_270595)) __PYX_ERR(0, 62, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_214069);
  __Pyx_GIVEREF(__pyx_float_0_214069);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_42, 1, __pyx_float_0_214069)) __PYX_ERR(0, 62, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_507052);
  __Pyx_GIVEREF(__pyx_float_0_507052);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_42, 2, __pyx_float_0_507052)) __PYX_ERR(0, 62, __pyx_L1_error);

  
  __pyx_t_43 = PyList_New(3); if (unlikely(!__pyx_t_43)) __PYX_ERR(0, 63, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_43);
  __Pyx_INCREF(__pyx_float_0_269308);
  __Pyx_GIVEREF(__pyx_float_0_269308);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_43, 0, __pyx_float_0_269308)) __PYX_ERR(0, 63, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_218818);
  __Pyx_GIVEREF(__pyx_float_0_218818);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_43, 1, __pyx_float_0_218818)) __PYX_ERR(0, 63, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_509577);
  __Pyx_GIVEREF(__pyx_float_0_509577);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_43, 2, __pyx_float_0_509577)) __PYX_ERR(0, 63, __pyx_L1_error);

  
  __pyx_t_44 = PyList_New(3); if (unlikely(!__pyx_t_44)) __PYX_ERR(0, 64, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_44);
  __Pyx_INCREF(__pyx_float_0_267968);
  __Pyx_GIVEREF(__pyx_float_0_267968);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_44, 0, __pyx_float_0_267968)) __PYX_ERR(0, 64, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_223549);
  __Pyx_GIVEREF(__pyx_float_0_223549);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_44, 1, __pyx_float_0_223549)) __PYX_ERR(0, 64, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_512008);
  __Pyx_GIVEREF(__pyx_float_0_512008);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_44, 2, __pyx_float_0_512008)) __PYX_ERR(0, 64, __pyx_L1_error);

  
  __pyx_t_45 = PyList_New(3); if (unlikely(!__pyx_t_45)) __PYX_ERR(0, 65, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_45);
  __Pyx_INCREF(__pyx_float_0_266580);
  __Pyx_GIVEREF(__pyx_float_0_266580);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_45, 0, __pyx_float_0_266580)) __PYX_ERR(0, 65, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_228262);
  __Pyx_GIVEREF(__pyx_float_0_228262);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_45, 1, __pyx_float_0_228262)) __PYX_ERR(0, 65, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_514349);
  __Pyx_GIVEREF(__pyx_float_0_514349);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_45, 2, __pyx_float_0_514349)) __PYX_ERR(0, 65, __pyx_L1_error);

  
  __pyx_t_46 = PyList_New(3); if (unlikely(!__pyx_t_46)) __PYX_ERR(0, 66, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_46);
  __Pyx_INCREF(__pyx_float_0_265145);
  __Pyx_GIVEREF(__pyx_float_0_265145);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_46, 0, __pyx_float_0_265145)) __PYX_ERR(0, 66, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_232956);
  __Pyx_GIVEREF(__pyx_float_0_232956);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_46, 1, __pyx_float_0_232956)) __PYX_ERR(0, 66, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_516599);
  __Pyx_GIVEREF(__pyx_float_0_516599);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_46, 2, __pyx_float_0_516599)) __PYX_ERR(0, 66, __pyx_L1_error);

  
  __pyx_t_47 = PyList_New(3); if (unlikely(!__pyx_t_47)) __PYX_ERR(0, 67, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_47);
  __Pyx_INCREF(__pyx_float_0_263663);
  __Pyx_GIVEREF(__pyx_float_0_263663);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_47, 0, __pyx_float_0_263663)) __PYX_ERR(0, 67, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_237631);
  __Pyx_GIVEREF(__pyx_float_0_237631);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_47, 1, __pyx_float_0_237631)) __PYX_ERR(0, 67, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_518762);
  __Pyx_GIVEREF(__pyx_float_0_518762);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_47, 2, __pyx_float_0_518762)) __PYX_ERR(0, 67, __pyx_L1_error);

  
  __pyx_t_48 = PyList_New(3); if (unlikely(!__pyx_t_48)) __PYX_ERR(0, 68, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_48);
  __Pyx_INCREF(__pyx_float_0_262138);
  __Pyx_GIVEREF(__pyx_float_0_262138);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_48, 0, __pyx_float_0_262138)) __PYX_ERR(0, 68, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_242286);
  __Pyx_GIVEREF(__pyx_float_0_242286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_48, 1, __pyx_float_0_242286)) __PYX_ERR(0, 68, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_520837);
  __Pyx_GIVEREF(__pyx_float_0_520837);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_48, 2, __pyx_float_0_520837)) __PYX_ERR(0, 68, __pyx_L1_error);

  
  __pyx_t_49 = PyList_New(3); if (unlikely(!__pyx_t_49)) __PYX_ERR(0, 69, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_49);
  __Pyx_INCREF(__pyx_float_0_260571);
  __Pyx_GIVEREF(__pyx_float_0_260571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_49, 0, __pyx_float_0_260571)) __PYX_ERR(0, 69, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_246922);
  __Pyx_GIVEREF(__pyx_float_0_246922);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_49, 1, __pyx_float_0_246922)) __PYX_ERR(0, 69, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_522828);
  __Pyx_GIVEREF(__pyx_float_0_522828);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_49, 2, __pyx_float_0_522828)) __PYX_ERR(0, 69, __pyx_L1_error);

  
  __pyx_t_50 = PyList_New(3); if (unlikely(!__pyx_t_50)) __PYX_ERR(0, 70, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_50);
  __Pyx_INCREF(__pyx_float_0_258965);
  __Pyx_GIVEREF(__pyx_float_0_258965);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_50, 0, __pyx_float_0_258965)) __PYX_ERR(0, 70, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_251537);
  __Pyx_GIVEREF(__pyx_float_0_251537);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_50, 1, __pyx_float_0_251537)) __PYX_ERR(0, 70, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_524736);
  __Pyx_GIVEREF(__pyx_float_0_524736);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_50, 2, __pyx_float_0_524736)) __PYX_ERR(0, 70, __pyx_L1_error);

  
  __pyx_t_51 = PyList_New(3); if (unlikely(!__pyx_t_51)) __PYX_ERR(0, 71, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_51);
  __Pyx_INCREF(__pyx_float_0_257322);
  __Pyx_GIVEREF(__pyx_float_0_257322);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_51, 0, __pyx_float_0_257322)) __PYX_ERR(0, 71, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_256130);
  __Pyx_GIVEREF(__pyx_float_0_256130);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_51, 1, __pyx_float_0_256130)) __PYX_ERR(0, 71, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_526563);
  __Pyx_GIVEREF(__pyx_float_0_526563);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_51, 2, __pyx_float_0_526563)) __PYX_ERR(0, 71, __pyx_L1_error);

  
  __pyx_t_52 = PyList_New(3); if (unlikely(!__pyx_t_52)) __PYX_ERR(0, 72, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_52);
  __Pyx_INCREF(__pyx_float_0_255645);
  __Pyx_GIVEREF(__pyx_float_0_255645);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_52, 0, __pyx_float_0_255645)) __PYX_ERR(0, 72, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_260703);
  __Pyx_GIVEREF(__pyx_float_0_260703);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_52, 1, __pyx_float_0_260703)) __PYX_ERR(0, 72, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_528312);
  __Pyx_GIVEREF(__pyx_float_0_528312);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_52, 2, __pyx_float_0_528312)) __PYX_ERR(0, 72, __pyx_L1_error);

  
  __pyx_t_53 = PyList_New(3); if (unlikely(!__pyx_t_53)) __PYX_ERR(0, 73, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_53);
  __Pyx_INCREF(__pyx_float_0_253935);
  __Pyx_GIVEREF(__pyx_float_0_253935);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_53, 0, __pyx_float_0_253935)) __PYX_ERR(0, 73, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_265254);
  __Pyx_GIVEREF(__pyx_float_0_265254);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_53, 1, __pyx_float_0_265254)) __PYX_ERR(0, 73, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_529983);
  __Pyx_GIVEREF(__pyx_float_0_529983);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_53, 2, __pyx_float_0_529983)) __PYX_ERR(0, 73, __pyx_L1_error);

  
  __pyx_t_54 = PyList_New(3); if (unlikely(!__pyx_t_54)) __PYX_ERR(0, 74, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_54);
  __Pyx_INCREF(__pyx_float_0_252194);
  __Pyx_GIVEREF(__pyx_float_0_252194);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_54, 0, __pyx_float_0_252194)) __PYX_ERR(0, 74, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_269783);
  __Pyx_GIVEREF(__pyx_float_0_269783);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_54, 1, __pyx_float_0_269783)) __PYX_ERR(0, 74, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_531579);
  __Pyx_GIVEREF(__pyx_float_0_531579);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_54, 2, __pyx_float_0_531579)) __PYX_ERR(0, 74, __pyx_L1_error);

  
  __pyx_t_55 = PyList_New(3); if (unlikely(!__pyx_t_55)) __PYX_ERR(0, 75, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_55);
  __Pyx_INCREF(__pyx_float_0_250425);
  __Pyx_GIVEREF(__pyx_float_0_250425);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_55, 0, __pyx_float_0_250425)) __PYX_ERR(0, 75, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_274290);
  __Pyx_GIVEREF(__pyx_float_0_274290);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_55, 1, __pyx_float_0_274290)) __PYX_ERR(0, 75, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_533103);
  __Pyx_GIVEREF(__pyx_float_0_533103);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_55, 2, __pyx_float_0_533103)) __PYX_ERR(0, 75, __pyx_L1_error);

  
  __pyx_t_56 = PyList_New(3); if (unlikely(!__pyx_t_56)) __PYX_ERR(0, 76, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_56);
  __Pyx_INCREF(__pyx_float_0_248629);
  __Pyx_GIVEREF(__pyx_float_0_248629);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_56, 0, __pyx_float_0_248629)) __PYX_ERR(0, 76, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_278775);
  __Pyx_GIVEREF(__pyx_float_0_278775);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_56, 1, __pyx_float_0_278775)) __PYX_ERR(0, 76, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_534556);
  __Pyx_GIVEREF(__pyx_float_0_534556);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_56, 2, __pyx_float_0_534556)) __PYX_ERR(0, 76, __pyx_L1_error);

  
  __pyx_t_57 = PyList_New(3); if (unlikely(!__pyx_t_57)) __PYX_ERR(0, 77, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_57);
  __Pyx_INCREF(__pyx_float_0_246811);
  __Pyx_GIVEREF(__pyx_float_0_246811);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_57, 0, __pyx_float_0_246811)) __PYX_ERR(0, 77, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_283237);
  __Pyx_GIVEREF(__pyx_float_0_283237);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_57, 1, __pyx_float_0_283237)) __PYX_ERR(0, 77, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_535941);
  __Pyx_GIVEREF(__pyx_float_0_535941);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_57, 2, __pyx_float_0_535941)) __PYX_ERR(0, 77, __pyx_L1_error);

  
  __pyx_t_58 = PyList_New(3); if (unlikely(!__pyx_t_58)) __PYX_ERR(0, 78, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_58);
  __Pyx_INCREF(__pyx_float_0_244972);
  __Pyx_GIVEREF(__pyx_float_0_244972);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_58, 0, __pyx_float_0_244972)) __PYX_ERR(0, 78, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_287675);
  __Pyx_GIVEREF(__pyx_float_0_287675);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_58, 1, __pyx_float_0_287675)) __PYX_ERR(0, 78, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_537260);
  __Pyx_GIVEREF(__pyx_float_0_537260);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_58, 2, __pyx_float_0_537260)) __PYX_ERR(0, 78, __pyx_L1_error);

  
  __pyx_t_59 = PyList_New(3); if (unlikely(!__pyx_t_59)) __PYX_ERR(0, 79, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_59);
  __Pyx_INCREF(__pyx_float_0_243113);
  __Pyx_GIVEREF(__pyx_float_0_243113);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_59, 0, __pyx_float_0_243113)) __PYX_ERR(0, 79, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_292092);
  __Pyx_GIVEREF(__pyx_float_0_292092);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_59, 1, __pyx_float_0_292092)) __PYX_ERR(0, 79, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_538516);
  __Pyx_GIVEREF(__pyx_float_0_538516);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_59, 2, __pyx_float_0_538516)) __PYX_ERR(0, 79, __pyx_L1_error);

  
  __pyx_t_60 = PyList_New(3); if (unlikely(!__pyx_t_60)) __PYX_ERR(0, 80, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_60);
  __Pyx_INCREF(__pyx_float_0_241237);
  __Pyx_GIVEREF(__pyx_float_0_241237);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_60, 0, __pyx_float_0_241237)) __PYX_ERR(0, 80, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_296485);
  __Pyx_GIVEREF(__pyx_float_0_296485);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_60, 1, __pyx_float_0_296485)) __PYX_ERR(0, 80, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_539709);
  __Pyx_GIVEREF(__pyx_float_0_539709);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_60, 2, __pyx_float_0_539709)) __PYX_ERR(0, 80, __pyx_L1_error);

  
  __pyx_t_61 = PyList_New(3); if (unlikely(!__pyx_t_61)) __PYX_ERR(0, 81, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_61);
  __Pyx_INCREF(__pyx_float_0_239346);
  __Pyx_GIVEREF(__pyx_float_0_239346);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_61, 0, __pyx_float_0_239346)) __PYX_ERR(0, 81, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_300855);
  __Pyx_GIVEREF(__pyx_float_0_300855);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_61, 1, __pyx_float_0_300855)) __PYX_ERR(0, 81, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_540844);
  __Pyx_GIVEREF(__pyx_float_0_540844);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_61, 2, __pyx_float_0_540844)) __PYX_ERR(0, 81, __pyx_L1_error);

  
  __pyx_t_62 = PyList_New(3); if (unlikely(!__pyx_t_62)) __PYX_ERR(0, 82, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_62);
  __Pyx_INCREF(__pyx_float_0_237441);
  __Pyx_GIVEREF(__pyx_float_0_237441);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_62, 0, __pyx_float_0_237441)) __PYX_ERR(0, 82, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_305202);
  __Pyx_GIVEREF(__pyx_float_0_305202);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_62, 1, __pyx_float_0_305202)) __PYX_ERR(0, 82, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_541921);
  __Pyx_GIVEREF(__pyx_float_0_541921);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_62, 2, __pyx_float_0_541921)) __PYX_ERR(0, 82, __pyx_L1_error);

  
  __pyx_t_63 = PyList_New(3); if (unlikely(!__pyx_t_63)) __PYX_ERR(0, 83, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_63);
  __Pyx_INCREF(__pyx_float_0_235526);
  __Pyx_GIVEREF(__pyx_float_0_235526);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_63, 0, __pyx_float_0_235526)) __PYX_ERR(0, 83, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_309527);
  __Pyx_GIVEREF(__pyx_float_0_309527);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_63, 1, __pyx_float_0_309527)) __PYX_ERR(0, 83, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_542944);
  __Pyx_GIVEREF(__pyx_float_0_542944);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_63, 2, __pyx_float_0_542944)) __PYX_ERR(0, 83, __pyx_L1_error);

  
  __pyx_t_64 = PyList_New(3); if (unlikely(!__pyx_t_64)) __PYX_ERR(0, 84, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_64);
  __Pyx_INCREF(__pyx_float_0_233603);
  __Pyx_GIVEREF(__pyx_float_0_233603);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_64, 0, __pyx_float_0_233603)) __PYX_ERR(0, 84, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_313828);
  __Pyx_GIVEREF(__pyx_float_0_313828);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_64, 1, __pyx_float_0_313828)) __PYX_ERR(0, 84, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_543914);
  __Pyx_GIVEREF(__pyx_float_0_543914);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_64, 2, __pyx_float_0_543914)) __PYX_ERR(0, 84, __pyx_L1_error);

  
  __pyx_t_65 = PyList_New(3); if (unlikely(!__pyx_t_65)) __PYX_ERR(0, 85, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_65);
  __Pyx_INCREF(__pyx_float_0_231674);
  __Pyx_GIVEREF(__pyx_float_0_231674);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_65, 0, __pyx_float_0_231674)) __PYX_ERR(0, 85, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_318106);
  __Pyx_GIVEREF(__pyx_float_0_318106);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_65, 1, __pyx_float_0_318106)) __PYX_ERR(0, 85, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_544834);
  __Pyx_GIVEREF(__pyx_float_0_544834);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_65, 2, __pyx_float_0_544834)) __PYX_ERR(0, 85, __pyx_L1_error);

  
  __pyx_t_66 = PyList_New(3); if (unlikely(!__pyx_t_66)) __PYX_ERR(0, 86, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_66);
  __Pyx_INCREF(__pyx_float_0_229739);
  __Pyx_GIVEREF(__pyx_float_0_229739);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_66, 0, __pyx_float_0_229739)) __PYX_ERR(0, 86, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_322361);
  __Pyx_GIVEREF(__pyx_float_0_322361);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_66, 1, __pyx_float_0_322361)) __PYX_ERR(0, 86, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_545706);
  __Pyx_GIVEREF(__pyx_float_0_545706);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_66, 2, __pyx_float_0_545706)) __PYX_ERR(0, 86, __pyx_L1_error);

  
  __pyx_t_67 = PyList_New(3); if (unlikely(!__pyx_t_67)) __PYX_ERR(0, 87, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_67);
  __Pyx_INCREF(__pyx_float_0_227802);
  __Pyx_GIVEREF(__pyx_float_0_227802);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_67, 0, __pyx_float_0_227802)) __PYX_ERR(0, 87, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_326594);
  __Pyx_GIVEREF(__pyx_float_0_326594);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_67, 1, __pyx_float_0_326594)) __PYX_ERR(0, 87, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_546532);
  __Pyx_GIVEREF(__pyx_float_0_546532);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_67, 2, __pyx_float_0_546532)) __PYX_ERR(0, 87, __pyx_L1_error);

  
  __pyx_t_68 = PyList_New(3); if (unlikely(!__pyx_t_68)) __PYX_ERR(0, 88, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_68);
  __Pyx_INCREF(__pyx_float_0_225863);
  __Pyx_GIVEREF(__pyx_float_0_225863);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_68, 0, __pyx_float_0_225863)) __PYX_ERR(0, 88, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_330805);
  __Pyx_GIVEREF(__pyx_float_0_330805);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_68, 1, __pyx_float_0_330805)) __PYX_ERR(0, 88, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_547314);
  __Pyx_GIVEREF(__pyx_float_0_547314);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_68, 2, __pyx_float_0_547314)) __PYX_ERR(0, 88, __pyx_L1_error);

  
  __pyx_t_69 = PyList_New(3); if (unlikely(!__pyx_t_69)) __PYX_ERR(0, 89, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_69);
  __Pyx_INCREF(__pyx_float_0_223925);
  __Pyx_GIVEREF(__pyx_float_0_223925);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_69, 0, __pyx_float_0_223925)) __PYX_ERR(0, 89, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_334994);
  __Pyx_GIVEREF(__pyx_float_0_334994);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_69, 1, __pyx_float_0_334994)) __PYX_ERR(0, 89, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_548053);
  __Pyx_GIVEREF(__pyx_float_0_548053);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_69, 2, __pyx_float_0_548053)) __PYX_ERR(0, 89, __pyx_L1_error);

  
  __pyx_t_70 = PyList_New(3); if (unlikely(!__pyx_t_70)) __PYX_ERR(0, 90, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_70);
  __Pyx_INCREF(__pyx_float_0_221989);
  __Pyx_GIVEREF(__pyx_float_0_221989);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_70, 0, __pyx_float_0_221989)) __PYX_ERR(0, 90, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_339161);
  __Pyx_GIVEREF(__pyx_float_0_339161);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_70, 1, __pyx_float_0_339161)) __PYX_ERR(0, 90, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_548752);
  __Pyx_GIVEREF(__pyx_float_0_548752);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_70, 2, __pyx_float_0_548752)) __PYX_ERR(0, 90, __pyx_L1_error);

  
  __pyx_t_71 = PyList_New(3); if (unlikely(!__pyx_t_71)) __PYX_ERR(0, 91, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_71);
  __Pyx_INCREF(__pyx_float_0_220057);
  __Pyx_GIVEREF(__pyx_float_0_220057);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_71, 0, __pyx_float_0_220057)) __PYX_ERR(0, 91, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_343307);
  __Pyx_GIVEREF(__pyx_float_0_343307);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_71, 1, __pyx_float_0_343307)) __PYX_ERR(0, 91, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_549413);
  __Pyx_GIVEREF(__pyx_float_0_549413);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_71, 2, __pyx_float_0_549413)) __PYX_ERR(0, 91, __pyx_L1_error);

  
  __pyx_t_72 = PyList_New(3); if (unlikely(!__pyx_t_72)) __PYX_ERR(0, 92, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_72);
  __Pyx_INCREF(__pyx_float_0_218130);
  __Pyx_GIVEREF(__pyx_float_0_218130);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_72, 0, __pyx_float_0_218130)) __PYX_ERR(0, 92, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_347432);
  __Pyx_GIVEREF(__pyx_float_0_347432);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_72, 1, __pyx_float_0_347432)) __PYX_ERR(0, 92, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_550038);
  __Pyx_GIVEREF(__pyx_float_0_550038);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_72, 2, __pyx_float_0_550038)) __PYX_ERR(0, 92, __pyx_L1_error);

  
  __pyx_t_73 = PyList_New(3); if (unlikely(!__pyx_t_73)) __PYX_ERR(0, 93, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_73);
  __Pyx_INCREF(__pyx_float_0_216210);
  __Pyx_GIVEREF(__pyx_float_0_216210);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_73, 0, __pyx_float_0_216210)) __PYX_ERR(0, 93, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_351535);
  __Pyx_GIVEREF(__pyx_float_0_351535);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_73, 1, __pyx_float_0_351535)) __PYX_ERR(0, 93, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_550627);
  __Pyx_GIVEREF(__pyx_float_0_550627);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_73, 2, __pyx_float_0_550627)) __PYX_ERR(0, 93, __pyx_L1_error);

  
  __pyx_t_74 = PyList_New(3); if (unlikely(!__pyx_t_74)) __PYX_ERR(0, 94, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_74);
  __Pyx_INCREF(__pyx_float_0_214298);
  __Pyx_GIVEREF(__pyx_float_0_214298);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_74, 0, __pyx_float_0_214298)) __PYX_ERR(0, 94, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_355619);
  __Pyx_GIVEREF(__pyx_float_0_355619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_74, 1, __pyx_float_0_355619)) __PYX_ERR(0, 94, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_551184);
  __Pyx_GIVEREF(__pyx_float_0_551184);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_74, 2, __pyx_float_0_551184)) __PYX_ERR(0, 94, __pyx_L1_error);

  
  __pyx_t_75 = PyList_New(3); if (unlikely(!__pyx_t_75)) __PYX_ERR(0, 95, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_75);
  __Pyx_INCREF(__pyx_float_0_212395);
  __Pyx_GIVEREF(__pyx_float_0_212395);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_75, 0, __pyx_float_0_212395)) __PYX_ERR(0, 95, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_359683);
  __Pyx_GIVEREF(__pyx_float_0_359683);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_75, 1, __pyx_float_0_359683)) __PYX_ERR(0, 95, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_551710);
  __Pyx_GIVEREF(__pyx_float_0_551710);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_75, 2, __pyx_float_0_551710)) __PYX_ERR(0, 95, __pyx_L1_error);

  
  __pyx_t_76 = PyList_New(3); if (unlikely(!__pyx_t_76)) __PYX_ERR(0, 96, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_76);
  __Pyx_INCREF(__pyx_float_0_210503);
  __Pyx_GIVEREF(__pyx_float_0_210503);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_76, 0, __pyx_float_0_210503)) __PYX_ERR(0, 96, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_363727);
  __Pyx_GIVEREF(__pyx_float_0_363727);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_76, 1, __pyx_float_0_363727)) __PYX_ERR(0, 96, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_552206);
  __Pyx_GIVEREF(__pyx_float_0_552206);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_76, 2, __pyx_float_0_552206)) __PYX_ERR(0, 96, __pyx_L1_error);

  
  __pyx_t_77 = PyList_New(3); if (unlikely(!__pyx_t_77)) __PYX_ERR(0, 97, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_77);
  __Pyx_INCREF(__pyx_float_0_208623);
  __Pyx_GIVEREF(__pyx_float_0_208623);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_77, 0, __pyx_float_0_208623)) __PYX_ERR(0, 97, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_367752);
  __Pyx_GIVEREF(__pyx_float_0_367752);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_77, 1, __pyx_float_0_367752)) __PYX_ERR(0, 97, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_552675);
  __Pyx_GIVEREF(__pyx_float_0_552675);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_77, 2, __pyx_float_0_552675)) __PYX_ERR(0, 97, __pyx_L1_error);

  
  __pyx_t_78 = PyList_New(3); if (unlikely(!__pyx_t_78)) __PYX_ERR(0, 98, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_78);
  __Pyx_INCREF(__pyx_float_0_206756);
  __Pyx_GIVEREF(__pyx_float_0_206756);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_78, 0, __pyx_float_0_206756)) __PYX_ERR(0, 98, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_371758);
  __Pyx_GIVEREF(__pyx_float_0_371758);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_78, 1, __pyx_float_0_371758)) __PYX_ERR(0, 98, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_553117);
  __Pyx_GIVEREF(__pyx_float_0_553117);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_78, 2, __pyx_float_0_553117)) __PYX_ERR(0, 98, __pyx_L1_error);

  
  __pyx_t_79 = PyList_New(3); if (unlikely(!__pyx_t_79)) __PYX_ERR(0, 99, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_79);
  __Pyx_INCREF(__pyx_float_0_204903);
  __Pyx_GIVEREF(__pyx_float_0_204903);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_79, 0, __pyx_float_0_204903)) __PYX_ERR(0, 99, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_375746);
  __Pyx_GIVEREF(__pyx_float_0_375746);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_79, 1, __pyx_float_0_375746)) __PYX_ERR(0, 99, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_553533);
  __Pyx_GIVEREF(__pyx_float_0_553533);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_79, 2, __pyx_float_0_553533)) __PYX_ERR(0, 99, __pyx_L1_error);

  
  __pyx_t_80 = PyList_New(3); if (unlikely(!__pyx_t_80)) __PYX_ERR(0, 100, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_80);
  __Pyx_INCREF(__pyx_float_0_203063);
  __Pyx_GIVEREF(__pyx_float_0_203063);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_80, 0, __pyx_float_0_203063)) __PYX_ERR(0, 100, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_379716);
  __Pyx_GIVEREF(__pyx_float_0_379716);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_80, 1, __pyx_float_0_379716)) __PYX_ERR(0, 100, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_553925);
  __Pyx_GIVEREF(__pyx_float_0_553925);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_80, 2, __pyx_float_0_553925)) __PYX_ERR(0, 100, __pyx_L1_error);

  
  __pyx_t_81 = PyList_New(3); if (unlikely(!__pyx_t_81)) __PYX_ERR(0, 101, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_81);
  __Pyx_INCREF(__pyx_float_0_201239);
  __Pyx_GIVEREF(__pyx_float_0_201239);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_81, 0, __pyx_float_0_201239)) __PYX_ERR(0, 101, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_383670);
  __Pyx_GIVEREF(__pyx_float_0_383670);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_81, 1, __pyx_float_0_383670)) __PYX_ERR(0, 101, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_554294);
  __Pyx_GIVEREF(__pyx_float_0_554294);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_81, 2, __pyx_float_0_554294)) __PYX_ERR(0, 101, __pyx_L1_error);

  
  __pyx_t_82 = PyList_New(3); if (unlikely(!__pyx_t_82)) __PYX_ERR(0, 102, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_82);
  __Pyx_INCREF(__pyx_float_0_199430);
  __Pyx_GIVEREF(__pyx_float_0_199430);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_82, 0, __pyx_float_0_199430)) __PYX_ERR(0, 102, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_387607);
  __Pyx_GIVEREF(__pyx_float_0_387607);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_82, 1, __pyx_float_0_387607)) __PYX_ERR(0, 102, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_554642);
  __Pyx_GIVEREF(__pyx_float_0_554642);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_82, 2, __pyx_float_0_554642)) __PYX_ERR(0, 102, __pyx_L1_error);

  
  __pyx_t_83 = PyList_New(3); if (unlikely(!__pyx_t_83)) __PYX_ERR(0, 103, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_83);
  __Pyx_INCREF(__pyx_float_0_197636);
  __Pyx_GIVEREF(__pyx_float_0_197636);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_83, 0, __pyx_float_0_197636)) __PYX_ERR(0, 103, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_391528);
  __Pyx_GIVEREF(__pyx_float_0_391528);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_83, 1, __pyx_float_0_391528)) __PYX_ERR(0, 103, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_554969);
  __Pyx_GIVEREF(__pyx_float_0_554969);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_83, 2, __pyx_float_0_554969)) __PYX_ERR(0, 103, __pyx_L1_error);

  
  __pyx_t_84 = PyList_New(3); if (unlikely(!__pyx_t_84)) __PYX_ERR(0, 104, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_84);
  __Pyx_INCREF(__pyx_float_0_195860);
  __Pyx_GIVEREF(__pyx_float_0_195860);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_84, 0, __pyx_float_0_195860)) __PYX_ERR(0, 104, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_395433);
  __Pyx_GIVEREF(__pyx_float_0_395433);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_84, 1, __pyx_float_0_395433)) __PYX_ERR(0, 104, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555276);
  __Pyx_GIVEREF(__pyx_float_0_555276);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_84, 2, __pyx_float_0_555276)) __PYX_ERR(0, 104, __pyx_L1_error);

  
  __pyx_t_85 = PyList_New(3); if (unlikely(!__pyx_t_85)) __PYX_ERR(0, 105, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_85);
  __Pyx_INCREF(__pyx_float_0_194100);
  __Pyx_GIVEREF(__pyx_float_0_194100);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_85, 0, __pyx_float_0_194100)) __PYX_ERR(0, 105, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_399323);
  __Pyx_GIVEREF(__pyx_float_0_399323);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_85, 1, __pyx_float_0_399323)) __PYX_ERR(0, 105, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555565);
  __Pyx_GIVEREF(__pyx_float_0_555565);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_85, 2, __pyx_float_0_555565)) __PYX_ERR(0, 105, __pyx_L1_error);

  
  __pyx_t_86 = PyList_New(3); if (unlikely(!__pyx_t_86)) __PYX_ERR(0, 106, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_86);
  __Pyx_INCREF(__pyx_float_0_192357);
  __Pyx_GIVEREF(__pyx_float_0_192357);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_86, 0, __pyx_float_0_192357)) __PYX_ERR(0, 106, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_403199);
  __Pyx_GIVEREF(__pyx_float_0_403199);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_86, 1, __pyx_float_0_403199)) __PYX_ERR(0, 106, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555836);
  __Pyx_GIVEREF(__pyx_float_0_555836);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_86, 2, __pyx_float_0_555836)) __PYX_ERR(0, 106, __pyx_L1_error);

  
  __pyx_t_87 = PyList_New(3); if (unlikely(!__pyx_t_87)) __PYX_ERR(0, 107, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_87);
  __Pyx_INCREF(__pyx_float_0_190631);
  __Pyx_GIVEREF(__pyx_float_0_190631);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_87, 0, __pyx_float_0_190631)) __PYX_ERR(0, 107, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_407061);
  __Pyx_GIVEREF(__pyx_float_0_407061);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_87, 1, __pyx_float_0_407061)) __PYX_ERR(0, 107, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556089);
  __Pyx_GIVEREF(__pyx_float_0_556089);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_87, 2, __pyx_float_0_556089)) __PYX_ERR(0, 107, __pyx_L1_error);

  
  __pyx_t_88 = PyList_New(3); if (unlikely(!__pyx_t_88)) __PYX_ERR(0, 108, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_88);
  __Pyx_INCREF(__pyx_float_0_188923);
  __Pyx_GIVEREF(__pyx_float_0_188923);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_88, 0, __pyx_float_0_188923)) __PYX_ERR(0, 108, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_410910);
  __Pyx_GIVEREF(__pyx_float_0_410910);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_88, 1, __pyx_float_0_410910)) __PYX_ERR(0, 108, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556326);
  __Pyx_GIVEREF(__pyx_float_0_556326);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_88, 2, __pyx_float_0_556326)) __PYX_ERR(0, 108, __pyx_L1_error);

  
  __pyx_t_89 = PyList_New(3); if (unlikely(!__pyx_t_89)) __PYX_ERR(0, 109, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_89);
  __Pyx_INCREF(__pyx_float_0_187231);
  __Pyx_GIVEREF(__pyx_float_0_187231);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_89, 0, __pyx_float_0_187231)) __PYX_ERR(0, 109, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_414746);
  __Pyx_GIVEREF(__pyx_float_0_414746);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_89, 1, __pyx_float_0_414746)) __PYX_ERR(0, 109, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556547);
  __Pyx_GIVEREF(__pyx_float_0_556547);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_89, 2, __pyx_float_0_556547)) __PYX_ERR(0, 109, __pyx_L1_error);

  
  __pyx_t_90 = PyList_New(3); if (unlikely(!__pyx_t_90)) __PYX_ERR(0, 110, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_90);
  __Pyx_INCREF(__pyx_float_0_185556);
  __Pyx_GIVEREF(__pyx_float_0_185556);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_90, 0, __pyx_float_0_185556)) __PYX_ERR(0, 110, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_418570);
  __Pyx_GIVEREF(__pyx_float_0_418570);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_90, 1, __pyx_float_0_418570)) __PYX_ERR(0, 110, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556753);
  __Pyx_GIVEREF(__pyx_float_0_556753);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_90, 2, __pyx_float_0_556753)) __PYX_ERR(0, 110, __pyx_L1_error);

  
  __pyx_t_91 = PyList_New(3); if (unlikely(!__pyx_t_91)) __PYX_ERR(0, 111, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_91);
  __Pyx_INCREF(__pyx_float_0_183898);
  __Pyx_GIVEREF(__pyx_float_0_183898);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_91, 0, __pyx_float_0_183898)) __PYX_ERR(0, 111, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_422383);
  __Pyx_GIVEREF(__pyx_float_0_422383);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_91, 1, __pyx_float_0_422383)) __PYX_ERR(0, 111, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556944);
  __Pyx_GIVEREF(__pyx_float_0_556944);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_91, 2, __pyx_float_0_556944)) __PYX_ERR(0, 111, __pyx_L1_error);

  
  __pyx_t_92 = PyList_New(3); if (unlikely(!__pyx_t_92)) __PYX_ERR(0, 112, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_92);
  __Pyx_INCREF(__pyx_float_0_182256);
  __Pyx_GIVEREF(__pyx_float_0_182256);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_92, 0, __pyx_float_0_182256)) __PYX_ERR(0, 112, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_426184);
  __Pyx_GIVEREF(__pyx_float_0_426184);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_92, 1, __pyx_float_0_426184)) __PYX_ERR(0, 112, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557120);
  __Pyx_GIVEREF(__pyx_float_0_557120);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_92, 2, __pyx_float_0_557120)) __PYX_ERR(0, 112, __pyx_L1_error);

  
  __pyx_t_93 = PyList_New(3); if (unlikely(!__pyx_t_93)) __PYX_ERR(0, 113, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_93);
  __Pyx_INCREF(__pyx_float_0_180629);
  __Pyx_GIVEREF(__pyx_float_0_180629);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_93, 0, __pyx_float_0_180629)) __PYX_ERR(0, 113, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_429975);
  __Pyx_GIVEREF(__pyx_float_0_429975);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_93, 1, __pyx_float_0_429975)) __PYX_ERR(0, 113, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557282);
  __Pyx_GIVEREF(__pyx_float_0_557282);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_93, 2, __pyx_float_0_557282)) __PYX_ERR(0, 113, __pyx_L1_error);

  
  __pyx_t_94 = PyList_New(3); if (unlikely(!__pyx_t_94)) __PYX_ERR(0, 114, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_94);
  __Pyx_INCREF(__pyx_float_0_179019);
  __Pyx_GIVEREF(__pyx_float_0_179019);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_94, 0, __pyx_float_0_179019)) __PYX_ERR(0, 114, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_433756);
  __Pyx_GIVEREF(__pyx_float_0_433756);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_94, 1, __pyx_float_0_433756)) __PYX_ERR(0, 114, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557430);
  __Pyx_GIVEREF(__pyx_float_0_557430);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_94, 2, __pyx_float_0_557430)) __PYX_ERR(0, 114, __pyx_L1_error);

  
  __pyx_t_95 = PyList_New(3); if (unlikely(!__pyx_t_95)) __PYX_ERR(0, 115, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_95);
  __Pyx_INCREF(__pyx_float_0_177423);
  __Pyx_GIVEREF(__pyx_float_0_177423);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_95, 0, __pyx_float_0_177423)) __PYX_ERR(0, 115, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_437527);
  __Pyx_GIVEREF(__pyx_float_0_437527);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_95, 1, __pyx_float_0_437527)) __PYX_ERR(0, 115, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557565);
  __Pyx_GIVEREF(__pyx_float_0_557565);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_95, 2, __pyx_float_0_557565)) __PYX_ERR(0, 115, __pyx_L1_error);

  
  __pyx_t_96 = PyList_New(3); if (unlikely(!__pyx_t_96)) __PYX_ERR(0, 116, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_96);
  __Pyx_INCREF(__pyx_float_0_175841);
  __Pyx_GIVEREF(__pyx_float_0_175841);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_96, 0, __pyx_float_0_175841)) __PYX_ERR(0, 116, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_441290);
  __Pyx_GIVEREF(__pyx_float_0_441290);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_96, 1, __pyx_float_0_441290)) __PYX_ERR(0, 116, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557685);
  __Pyx_GIVEREF(__pyx_float_0_557685);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_96, 2, __pyx_float_0_557685)) __PYX_ERR(0, 116, __pyx_L1_error);

  
  __pyx_t_97 = PyList_New(3); if (unlikely(!__pyx_t_97)) __PYX_ERR(0, 117, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_97);
  __Pyx_INCREF(__pyx_float_0_174274);
  __Pyx_GIVEREF(__pyx_float_0_174274);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_97, 0, __pyx_float_0_174274)) __PYX_ERR(0, 117, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_445044);
  __Pyx_GIVEREF(__pyx_float_0_445044);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_97, 1, __pyx_float_0_445044)) __PYX_ERR(0, 117, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557792);
  __Pyx_GIVEREF(__pyx_float_0_557792);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_97, 2, __pyx_float_0_557792)) __PYX_ERR(0, 117, __pyx_L1_error);

  
  __pyx_t_98 = PyList_New(3); if (unlikely(!__pyx_t_98)) __PYX_ERR(0, 118, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_98);
  __Pyx_INCREF(__pyx_float_0_172719);
  __Pyx_GIVEREF(__pyx_float_0_172719);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_98, 0, __pyx_float_0_172719)) __PYX_ERR(0, 118, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_448791);
  __Pyx_GIVEREF(__pyx_float_0_448791);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_98, 1, __pyx_float_0_448791)) __PYX_ERR(0, 118, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557885);
  __Pyx_GIVEREF(__pyx_float_0_557885);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_98, 2, __pyx_float_0_557885)) __PYX_ERR(0, 118, __pyx_L1_error);

  
  __pyx_t_99 = PyList_New(3); if (unlikely(!__pyx_t_99)) __PYX_ERR(0, 119, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_99);
  __Pyx_INCREF(__pyx_float_0_171176);
  __Pyx_GIVEREF(__pyx_float_0_171176);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_99, 0, __pyx_float_0_171176)) __PYX_ERR(0, 119, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_452530);
  __Pyx_GIVEREF(__pyx_float_0_452530);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_99, 1, __pyx_float_0_452530)) __PYX_ERR(0, 119, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557965);
  __Pyx_GIVEREF(__pyx_float_0_557965);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_99, 2, __pyx_float_0_557965)) __PYX_ERR(0, 119, __pyx_L1_error);

  
  __pyx_t_100 = PyList_New(3); if (unlikely(!__pyx_t_100)) __PYX_ERR(0, 120, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_100);
  __Pyx_INCREF(__pyx_float_0_169646);
  __Pyx_GIVEREF(__pyx_float_0_169646);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_100, 0, __pyx_float_0_169646)) __PYX_ERR(0, 120, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_456262);
  __Pyx_GIVEREF(__pyx_float_0_456262);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_100, 1, __pyx_float_0_456262)) __PYX_ERR(0, 120, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558030);
  __Pyx_GIVEREF(__pyx_float_0_558030);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_100, 2, __pyx_float_0_558030)) __PYX_ERR(0, 120, __pyx_L1_error);

  
  __pyx_t_101 = PyList_New(3); if (unlikely(!__pyx_t_101)) __PYX_ERR(0, 121, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_101);
  __Pyx_INCREF(__pyx_float_0_168126);
  __Pyx_GIVEREF(__pyx_float_0_168126);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_101, 0, __pyx_float_0_168126)) __PYX_ERR(0, 121, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_459988);
  __Pyx_GIVEREF(__pyx_float_0_459988);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_101, 1, __pyx_float_0_459988)) __PYX_ERR(0, 121, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558082);
  __Pyx_GIVEREF(__pyx_float_0_558082);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_101, 2, __pyx_float_0_558082)) __PYX_ERR(0, 121, __pyx_L1_error);

  
  __pyx_t_102 = PyList_New(3); if (unlikely(!__pyx_t_102)) __PYX_ERR(0, 122, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_102);
  __Pyx_INCREF(__pyx_float_0_166617);
  __Pyx_GIVEREF(__pyx_float_0_166617);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_102, 0, __pyx_float_0_166617)) __PYX_ERR(0, 122, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_463708);
  __Pyx_GIVEREF(__pyx_float_0_463708);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_102, 1, __pyx_float_0_463708)) __PYX_ERR(0, 122, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558119);
  __Pyx_GIVEREF(__pyx_float_0_558119);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_102, 2, __pyx_float_0_558119)) __PYX_ERR(0, 122, __pyx_L1_error);

  
  __pyx_t_103 = PyList_New(3); if (unlikely(!__pyx_t_103)) __PYX_ERR(0, 123, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_103);
  __Pyx_INCREF(__pyx_float_0_165117);
  __Pyx_GIVEREF(__pyx_float_0_165117);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_103, 0, __pyx_float_0_165117)) __PYX_ERR(0, 123, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_467423);
  __Pyx_GIVEREF(__pyx_float_0_467423);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_103, 1, __pyx_float_0_467423)) __PYX_ERR(0, 123, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558141);
  __Pyx_GIVEREF(__pyx_float_0_558141);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_103, 2, __pyx_float_0_558141)) __PYX_ERR(0, 123, __pyx_L1_error);

  
  __pyx_t_104 = PyList_New(3); if (unlikely(!__pyx_t_104)) __PYX_ERR(0, 124, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_104);
  __Pyx_INCREF(__pyx_float_0_163625);
  __Pyx_GIVEREF(__pyx_float_0_163625);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_104, 0, __pyx_float_0_163625)) __PYX_ERR(0, 124, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_471133);
  __Pyx_GIVEREF(__pyx_float_0_471133);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_104, 1, __pyx_float_0_471133)) __PYX_ERR(0, 124, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558148);
  __Pyx_GIVEREF(__pyx_float_0_558148);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_104, 2, __pyx_float_0_558148)) __PYX_ERR(0, 124, __pyx_L1_error);

  
  __pyx_t_105 = PyList_New(3); if (unlikely(!__pyx_t_105)) __PYX_ERR(0, 125, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_105);
  __Pyx_INCREF(__pyx_float_0_162142);
  __Pyx_GIVEREF(__pyx_float_0_162142);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_105, 0, __pyx_float_0_162142)) __PYX_ERR(0, 125, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_474838);
  __Pyx_GIVEREF(__pyx_float_0_474838);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_105, 1, __pyx_float_0_474838)) __PYX_ERR(0, 125, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558140);
  __Pyx_GIVEREF(__pyx_float_0_558140);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_105, 2, __pyx_float_0_558140)) __PYX_ERR(0, 125, __pyx_L1_error);

  
  __pyx_t_106 = PyList_New(3); if (unlikely(!__pyx_t_106)) __PYX_ERR(0, 126, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_106);
  __Pyx_INCREF(__pyx_float_0_160665);
  __Pyx_GIVEREF(__pyx_float_0_160665);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_106, 0, __pyx_float_0_160665)) __PYX_ERR(0, 126, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_478540);
  __Pyx_GIVEREF(__pyx_float_0_478540);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_106, 1, __pyx_float_0_478540)) __PYX_ERR(0, 126, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558115);
  __Pyx_GIVEREF(__pyx_float_0_558115);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_106, 2, __pyx_float_0_558115)) __PYX_ERR(0, 126, __pyx_L1_error);

  
  __pyx_t_107 = PyList_New(3); if (unlikely(!__pyx_t_107)) __PYX_ERR(0, 127, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_107);
  __Pyx_INCREF(__pyx_float_0_159194);
  __Pyx_GIVEREF(__pyx_float_0_159194);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_107, 0, __pyx_float_0_159194)) __PYX_ERR(0, 127, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_482237);
  __Pyx_GIVEREF(__pyx_float_0_482237);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_107, 1, __pyx_float_0_482237)) __PYX_ERR(0, 127, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558073);
  __Pyx_GIVEREF(__pyx_float_0_558073);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_107, 2, __pyx_float_0_558073)) __PYX_ERR(0, 127, __pyx_L1_error);

  
  __pyx_t_108 = PyList_New(3); if (unlikely(!__pyx_t_108)) __PYX_ERR(0, 128, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_108);
  __Pyx_INCREF(__pyx_float_0_157729);
  __Pyx_GIVEREF(__pyx_float_0_157729);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_108, 0, __pyx_float_0_157729)) __PYX_ERR(0, 128, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_485932);
  __Pyx_GIVEREF(__pyx_float_0_485932);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_108, 1, __pyx_float_0_485932)) __PYX_ERR(0, 128, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_558013);
  __Pyx_GIVEREF(__pyx_float_0_558013);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_108, 2, __pyx_float_0_558013)) __PYX_ERR(0, 128, __pyx_L1_error);

  
  __pyx_t_109 = PyList_New(3); if (unlikely(!__pyx_t_109)) __PYX_ERR(0, 129, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_109);
  __Pyx_INCREF(__pyx_float_0_156270);
  __Pyx_GIVEREF(__pyx_float_0_156270);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_109, 0, __pyx_float_0_156270)) __PYX_ERR(0, 129, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_489624);
  __Pyx_GIVEREF(__pyx_float_0_489624);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_109, 1, __pyx_float_0_489624)) __PYX_ERR(0, 129, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557936);
  __Pyx_GIVEREF(__pyx_float_0_557936);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_109, 2, __pyx_float_0_557936)) __PYX_ERR(0, 129, __pyx_L1_error);

  
  __pyx_t_110 = PyList_New(3); if (unlikely(!__pyx_t_110)) __PYX_ERR(0, 130, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_110);
  __Pyx_INCREF(__pyx_float_0_154815);
  __Pyx_GIVEREF(__pyx_float_0_154815);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_110, 0, __pyx_float_0_154815)) __PYX_ERR(0, 130, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_493313);
  __Pyx_GIVEREF(__pyx_float_0_493313);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_110, 1, __pyx_float_0_493313)) __PYX_ERR(0, 130, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557840);
  __Pyx_GIVEREF(__pyx_float_0_557840);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_110, 2, __pyx_float_0_557840)) __PYX_ERR(0, 130, __pyx_L1_error);

  
  __pyx_t_111 = PyList_New(3); if (unlikely(!__pyx_t_111)) __PYX_ERR(0, 131, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_111);
  __Pyx_INCREF(__pyx_float_0_153364);
  __Pyx_GIVEREF(__pyx_float_0_153364);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_111, 0, __pyx_float_0_153364)) __PYX_ERR(0, 131, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_497000);
  __Pyx_GIVEREF(__pyx_float_0_497000);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_111, 1, __pyx_float_0_497000)) __PYX_ERR(0, 131, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557724);
  __Pyx_GIVEREF(__pyx_float_0_557724);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_111, 2, __pyx_float_0_557724)) __PYX_ERR(0, 131, __pyx_L1_error);

  
  __pyx_t_112 = PyList_New(3); if (unlikely(!__pyx_t_112)) __PYX_ERR(0, 132, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_112);
  __Pyx_INCREF(__pyx_float_0_151918);
  __Pyx_GIVEREF(__pyx_float_0_151918);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_112, 0, __pyx_float_0_151918)) __PYX_ERR(0, 132, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_500685);
  __Pyx_GIVEREF(__pyx_float_0_500685);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_112, 1, __pyx_float_0_500685)) __PYX_ERR(0, 132, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557587);
  __Pyx_GIVEREF(__pyx_float_0_557587);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_112, 2, __pyx_float_0_557587)) __PYX_ERR(0, 132, __pyx_L1_error);

  
  __pyx_t_113 = PyList_New(3); if (unlikely(!__pyx_t_113)) __PYX_ERR(0, 133, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_113);
  __Pyx_INCREF(__pyx_float_0_150476);
  __Pyx_GIVEREF(__pyx_float_0_150476);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_113, 0, __pyx_float_0_150476)) __PYX_ERR(0, 133, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_504369);
  __Pyx_GIVEREF(__pyx_float_0_504369);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_113, 1, __pyx_float_0_504369)) __PYX_ERR(0, 133, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557430);
  __Pyx_GIVEREF(__pyx_float_0_557430);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_113, 2, __pyx_float_0_557430)) __PYX_ERR(0, 133, __pyx_L1_error);

  
  __pyx_t_114 = PyList_New(3); if (unlikely(!__pyx_t_114)) __PYX_ERR(0, 134, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_114);
  __Pyx_INCREF(__pyx_float_0_149039);
  __Pyx_GIVEREF(__pyx_float_0_149039);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_114, 0, __pyx_float_0_149039)) __PYX_ERR(0, 134, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_508051);
  __Pyx_GIVEREF(__pyx_float_0_508051);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_114, 1, __pyx_float_0_508051)) __PYX_ERR(0, 134, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557250);
  __Pyx_GIVEREF(__pyx_float_0_557250);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_114, 2, __pyx_float_0_557250)) __PYX_ERR(0, 134, __pyx_L1_error);

  
  __pyx_t_115 = PyList_New(3); if (unlikely(!__pyx_t_115)) __PYX_ERR(0, 135, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_115);
  __Pyx_INCREF(__pyx_float_0_147607);
  __Pyx_GIVEREF(__pyx_float_0_147607);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_115, 0, __pyx_float_0_147607)) __PYX_ERR(0, 135, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_511733);
  __Pyx_GIVEREF(__pyx_float_0_511733);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_115, 1, __pyx_float_0_511733)) __PYX_ERR(0, 135, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_557049);
  __Pyx_GIVEREF(__pyx_float_0_557049);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_115, 2, __pyx_float_0_557049)) __PYX_ERR(0, 135, __pyx_L1_error);

  
  __pyx_t_116 = PyList_New(3); if (unlikely(!__pyx_t_116)) __PYX_ERR(0, 136, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_116);
  __Pyx_INCREF(__pyx_float_0_146180);
  __Pyx_GIVEREF(__pyx_float_0_146180);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_116, 0, __pyx_float_0_146180)) __PYX_ERR(0, 136, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_515413);
  __Pyx_GIVEREF(__pyx_float_0_515413);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_116, 1, __pyx_float_0_515413)) __PYX_ERR(0, 136, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556823);
  __Pyx_GIVEREF(__pyx_float_0_556823);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_116, 2, __pyx_float_0_556823)) __PYX_ERR(0, 136, __pyx_L1_error);

  
  __pyx_t_117 = PyList_New(3); if (unlikely(!__pyx_t_117)) __PYX_ERR(0, 137, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_117);
  __Pyx_INCREF(__pyx_float_0_144759);
  __Pyx_GIVEREF(__pyx_float_0_144759);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_117, 0, __pyx_float_0_144759)) __PYX_ERR(0, 137, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_519093);
  __Pyx_GIVEREF(__pyx_float_0_519093);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_117, 1, __pyx_float_0_519093)) __PYX_ERR(0, 137, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556572);
  __Pyx_GIVEREF(__pyx_float_0_556572);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_117, 2, __pyx_float_0_556572)) __PYX_ERR(0, 137, __pyx_L1_error);

  
  __pyx_t_118 = PyList_New(3); if (unlikely(!__pyx_t_118)) __PYX_ERR(0, 138, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_118);
  __Pyx_INCREF(__pyx_float_0_143343);
  __Pyx_GIVEREF(__pyx_float_0_143343);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_118, 0, __pyx_float_0_143343)) __PYX_ERR(0, 138, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_522773);
  __Pyx_GIVEREF(__pyx_float_0_522773);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_118, 1, __pyx_float_0_522773)) __PYX_ERR(0, 138, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_556295);
  __Pyx_GIVEREF(__pyx_float_0_556295);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_118, 2, __pyx_float_0_556295)) __PYX_ERR(0, 138, __pyx_L1_error);

  
  __pyx_t_119 = PyList_New(3); if (unlikely(!__pyx_t_119)) __PYX_ERR(0, 139, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_119);
  __Pyx_INCREF(__pyx_float_0_141935);
  __Pyx_GIVEREF(__pyx_float_0_141935);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_119, 0, __pyx_float_0_141935)) __PYX_ERR(0, 139, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_526453);
  __Pyx_GIVEREF(__pyx_float_0_526453);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_119, 1, __pyx_float_0_526453)) __PYX_ERR(0, 139, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555991);
  __Pyx_GIVEREF(__pyx_float_0_555991);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_119, 2, __pyx_float_0_555991)) __PYX_ERR(0, 139, __pyx_L1_error);

  
  __pyx_t_120 = PyList_New(3); if (unlikely(!__pyx_t_120)) __PYX_ERR(0, 140, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_120);
  __Pyx_INCREF(__pyx_float_0_140536);
  __Pyx_GIVEREF(__pyx_float_0_140536);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_120, 0, __pyx_float_0_140536)) __PYX_ERR(0, 140, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_530132);
  __Pyx_GIVEREF(__pyx_float_0_530132);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_120, 1, __pyx_float_0_530132)) __PYX_ERR(0, 140, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555659);
  __Pyx_GIVEREF(__pyx_float_0_555659);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_120, 2, __pyx_float_0_555659)) __PYX_ERR(0, 140, __pyx_L1_error);

  
  __pyx_t_121 = PyList_New(3); if (unlikely(!__pyx_t_121)) __PYX_ERR(0, 141, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_121);
  __Pyx_INCREF(__pyx_float_0_139147);
  __Pyx_GIVEREF(__pyx_float_0_139147);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_121, 0, __pyx_float_0_139147)) __PYX_ERR(0, 141, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_533812);
  __Pyx_GIVEREF(__pyx_float_0_533812);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_121, 1, __pyx_float_0_533812)) __PYX_ERR(0, 141, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555298);
  __Pyx_GIVEREF(__pyx_float_0_555298);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_121, 2, __pyx_float_0_555298)) __PYX_ERR(0, 141, __pyx_L1_error);

  
  __pyx_t_122 = PyList_New(3); if (unlikely(!__pyx_t_122)) __PYX_ERR(0, 142, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_122);
  __Pyx_INCREF(__pyx_float_0_137770);
  __Pyx_GIVEREF(__pyx_float_0_137770);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_122, 0, __pyx_float_0_137770)) __PYX_ERR(0, 142, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_537492);
  __Pyx_GIVEREF(__pyx_float_0_537492);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_122, 1, __pyx_float_0_537492)) __PYX_ERR(0, 142, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_554906);
  __Pyx_GIVEREF(__pyx_float_0_554906);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_122, 2, __pyx_float_0_554906)) __PYX_ERR(0, 142, __pyx_L1_error);

  
  __pyx_t_123 = PyList_New(3); if (unlikely(!__pyx_t_123)) __PYX_ERR(0, 143, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_123);
  __Pyx_INCREF(__pyx_float_0_136408);
  __Pyx_GIVEREF(__pyx_float_0_136408);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_123, 0, __pyx_float_0_136408)) __PYX_ERR(0, 143, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_541173);
  __Pyx_GIVEREF(__pyx_float_0_541173);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_123, 1, __pyx_float_0_541173)) __PYX_ERR(0, 143, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_554483);
  __Pyx_GIVEREF(__pyx_float_0_554483);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_123, 2, __pyx_float_0_554483)) __PYX_ERR(0, 143, __pyx_L1_error);

  
  __pyx_t_124 = PyList_New(3); if (unlikely(!__pyx_t_124)) __PYX_ERR(0, 144, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_124);
  __Pyx_INCREF(__pyx_float_0_135066);
  __Pyx_GIVEREF(__pyx_float_0_135066);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_124, 0, __pyx_float_0_135066)) __PYX_ERR(0, 144, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_544853);
  __Pyx_GIVEREF(__pyx_float_0_544853);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_124, 1, __pyx_float_0_544853)) __PYX_ERR(0, 144, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_554029);
  __Pyx_GIVEREF(__pyx_float_0_554029);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_124, 2, __pyx_float_0_554029)) __PYX_ERR(0, 144, __pyx_L1_error);

  
  __pyx_t_125 = PyList_New(3); if (unlikely(!__pyx_t_125)) __PYX_ERR(0, 145, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_125);
  __Pyx_INCREF(__pyx_float_0_133743);
  __Pyx_GIVEREF(__pyx_float_0_133743);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_125, 0, __pyx_float_0_133743)) __PYX_ERR(0, 145, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_548535);
  __Pyx_GIVEREF(__pyx_float_0_548535);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_125, 1, __pyx_float_0_548535)) __PYX_ERR(0, 145, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_553541);
  __Pyx_GIVEREF(__pyx_float_0_553541);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_125, 2, __pyx_float_0_553541)) __PYX_ERR(0, 145, __pyx_L1_error);

  
  __pyx_t_126 = PyList_New(3); if (unlikely(!__pyx_t_126)) __PYX_ERR(0, 146, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_126);
  __Pyx_INCREF(__pyx_float_0_132444);
  __Pyx_GIVEREF(__pyx_float_0_132444);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_126, 0, __pyx_float_0_132444)) __PYX_ERR(0, 146, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_552216);
  __Pyx_GIVEREF(__pyx_float_0_552216);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_126, 1, __pyx_float_0_552216)) __PYX_ERR(0, 146, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_553018);
  __Pyx_GIVEREF(__pyx_float_0_553018);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_126, 2, __pyx_float_0_553018)) __PYX_ERR(0, 146, __pyx_L1_error);

  
  __pyx_t_127 = PyList_New(3); if (unlikely(!__pyx_t_127)) __PYX_ERR(0, 147, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_127);
  __Pyx_INCREF(__pyx_float_0_131172);
  __Pyx_GIVEREF(__pyx_float_0_131172);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_127, 0, __pyx_float_0_131172)) __PYX_ERR(0, 147, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_555899);
  __Pyx_GIVEREF(__pyx_float_0_555899);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_127, 1, __pyx_float_0_555899)) __PYX_ERR(0, 147, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_552459);
  __Pyx_GIVEREF(__pyx_float_0_552459);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_127, 2, __pyx_float_0_552459)) __PYX_ERR(0, 147, __pyx_L1_error);

  
  __pyx_t_128 = PyList_New(3); if (unlikely(!__pyx_t_128)) __PYX_ERR(0, 148, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_128);
  __Pyx_INCREF(__pyx_float_0_129933);
  __Pyx_GIVEREF(__pyx_float_0_129933);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_128, 0, __pyx_float_0_129933)) __PYX_ERR(0, 148, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_559582);
  __Pyx_GIVEREF(__pyx_float_0_559582);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_128, 1, __pyx_float_0_559582)) __PYX_ERR(0, 148, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_551864);
  __Pyx_GIVEREF(__pyx_float_0_551864);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_128, 2, __pyx_float_0_551864)) __PYX_ERR(0, 148, __pyx_L1_error);

  
  __pyx_t_129 = PyList_New(3); if (unlikely(!__pyx_t_129)) __PYX_ERR(0, 149, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_129);
  __Pyx_INCREF(__pyx_float_0_128729);
  __Pyx_GIVEREF(__pyx_float_0_128729);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_129, 0, __pyx_float_0_128729)) __PYX_ERR(0, 149, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_563265);
  __Pyx_GIVEREF(__pyx_float_0_563265);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_129, 1, __pyx_float_0_563265)) __PYX_ERR(0, 149, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_551229);
  __Pyx_GIVEREF(__pyx_float_0_551229);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_129, 2, __pyx_float_0_551229)) __PYX_ERR(0, 149, __pyx_L1_error);

  
  __pyx_t_130 = PyList_New(3); if (unlikely(!__pyx_t_130)) __PYX_ERR(0, 150, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_130);
  __Pyx_INCREF(__pyx_float_0_127568);
  __Pyx_GIVEREF(__pyx_float_0_127568);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_130, 0, __pyx_float_0_127568)) __PYX_ERR(0, 150, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_566949);
  __Pyx_GIVEREF(__pyx_float_0_566949);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_130, 1, __pyx_float_0_566949)) __PYX_ERR(0, 150, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_550556);
  __Pyx_GIVEREF(__pyx_float_0_550556);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_130, 2, __pyx_float_0_550556)) __PYX_ERR(0, 150, __pyx_L1_error);

  
  __pyx_t_131 = PyList_New(3); if (unlikely(!__pyx_t_131)) __PYX_ERR(0, 151, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_131);
  __Pyx_INCREF(__pyx_float_0_126453);
  __Pyx_GIVEREF(__pyx_float_0_126453);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_131, 0, __pyx_float_0_126453)) __PYX_ERR(0, 151, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_570633);
  __Pyx_GIVEREF(__pyx_float_0_570633);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_131, 1, __pyx_float_0_570633)) __PYX_ERR(0, 151, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_549841);
  __Pyx_GIVEREF(__pyx_float_0_549841);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_131, 2, __pyx_float_0_549841)) __PYX_ERR(0, 151, __pyx_L1_error);

  
  __pyx_t_132 = PyList_New(3); if (unlikely(!__pyx_t_132)) __PYX_ERR(0, 152, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_132);
  __Pyx_INCREF(__pyx_float_0_125394);
  __Pyx_GIVEREF(__pyx_float_0_125394);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_132, 0, __pyx_float_0_125394)) __PYX_ERR(0, 152, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_574318);
  __Pyx_GIVEREF(__pyx_float_0_574318);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_132, 1, __pyx_float_0_574318)) __PYX_ERR(0, 152, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_549086);
  __Pyx_GIVEREF(__pyx_float_0_549086);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_132, 2, __pyx_float_0_549086)) __PYX_ERR(0, 152, __pyx_L1_error);

  
  __pyx_t_133 = PyList_New(3); if (unlikely(!__pyx_t_133)) __PYX_ERR(0, 153, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_133);
  __Pyx_INCREF(__pyx_float_0_124395);
  __Pyx_GIVEREF(__pyx_float_0_124395);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_133, 0, __pyx_float_0_124395)) __PYX_ERR(0, 153, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_578002);
  __Pyx_GIVEREF(__pyx_float_0_578002);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_133, 1, __pyx_float_0_578002)) __PYX_ERR(0, 153, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_548287);
  __Pyx_GIVEREF(__pyx_float_0_548287);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_133, 2, __pyx_float_0_548287)) __PYX_ERR(0, 153, __pyx_L1_error);

  
  __pyx_t_134 = PyList_New(3); if (unlikely(!__pyx_t_134)) __PYX_ERR(0, 154, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_134);
  __Pyx_INCREF(__pyx_float_0_123463);
  __Pyx_GIVEREF(__pyx_float_0_123463);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_134, 0, __pyx_float_0_123463)) __PYX_ERR(0, 154, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_581687);
  __Pyx_GIVEREF(__pyx_float_0_581687);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_134, 1, __pyx_float_0_581687)) __PYX_ERR(0, 154, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_547445);
  __Pyx_GIVEREF(__pyx_float_0_547445);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_134, 2, __pyx_float_0_547445)) __PYX_ERR(0, 154, __pyx_L1_error);

  
  __pyx_t_135 = PyList_New(3); if (unlikely(!__pyx_t_135)) __PYX_ERR(0, 155, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_135);
  __Pyx_INCREF(__pyx_float_0_122606);
  __Pyx_GIVEREF(__pyx_float_0_122606);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_135, 0, __pyx_float_0_122606)) __PYX_ERR(0, 155, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_585371);
  __Pyx_GIVEREF(__pyx_float_0_585371);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_135, 1, __pyx_float_0_585371)) __PYX_ERR(0, 155, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_546557);
  __Pyx_GIVEREF(__pyx_float_0_546557);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_135, 2, __pyx_float_0_546557)) __PYX_ERR(0, 155, __pyx_L1_error);

  
  __pyx_t_136 = PyList_New(3); if (unlikely(!__pyx_t_136)) __PYX_ERR(0, 156, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_136);
  __Pyx_INCREF(__pyx_float_0_121831);
  __Pyx_GIVEREF(__pyx_float_0_121831);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_136, 0, __pyx_float_0_121831)) __PYX_ERR(0, 156, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_589055);
  __Pyx_GIVEREF(__pyx_float_0_589055);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_136, 1, __pyx_float_0_589055)) __PYX_ERR(0, 156, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_545623);
  __Pyx_GIVEREF(__pyx_float_0_545623);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_136, 2, __pyx_float_0_545623)) __PYX_ERR(0, 156, __pyx_L1_error);

  
  __pyx_t_137 = PyList_New(3); if (unlikely(!__pyx_t_137)) __PYX_ERR(0, 157, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_137);
  __Pyx_INCREF(__pyx_float_0_121148);
  __Pyx_GIVEREF(__pyx_float_0_121148);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_137, 0, __pyx_float_0_121148)) __PYX_ERR(0, 157, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_592739);
  __Pyx_GIVEREF(__pyx_float_0_592739);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_137, 1, __pyx_float_0_592739)) __PYX_ERR(0, 157, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_544641);
  __Pyx_GIVEREF(__pyx_float_0_544641);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_137, 2, __pyx_float_0_544641)) __PYX_ERR(0, 157, __pyx_L1_error);

  
  __pyx_t_138 = PyList_New(3); if (unlikely(!__pyx_t_138)) __PYX_ERR(0, 158, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_138);
  __Pyx_INCREF(__pyx_float_0_120565);
  __Pyx_GIVEREF(__pyx_float_0_120565);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_138, 0, __pyx_float_0_120565)) __PYX_ERR(0, 158, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_596422);
  __Pyx_GIVEREF(__pyx_float_0_596422);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_138, 1, __pyx_float_0_596422)) __PYX_ERR(0, 158, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_543611);
  __Pyx_GIVEREF(__pyx_float_0_543611);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_138, 2, __pyx_float_0_543611)) __PYX_ERR(0, 158, __pyx_L1_error);

  
  __pyx_t_139 = PyList_New(3); if (unlikely(!__pyx_t_139)) __PYX_ERR(0, 159, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_139);
  __Pyx_INCREF(__pyx_float_0_120092);
  __Pyx_GIVEREF(__pyx_float_0_120092);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_139, 0, __pyx_float_0_120092)) __PYX_ERR(0, 159, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_600104);
  __Pyx_GIVEREF(__pyx_float_0_600104);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_139, 1, __pyx_float_0_600104)) __PYX_ERR(0, 159, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_542530);
  __Pyx_GIVEREF(__pyx_float_0_542530);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_139, 2, __pyx_float_0_542530)) __PYX_ERR(0, 159, __pyx_L1_error);

  
  __pyx_t_140 = PyList_New(3); if (unlikely(!__pyx_t_140)) __PYX_ERR(0, 160, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_140);
  __Pyx_INCREF(__pyx_float_0_119738);
  __Pyx_GIVEREF(__pyx_float_0_119738);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_140, 0, __pyx_float_0_119738)) __PYX_ERR(0, 160, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_603785);
  __Pyx_GIVEREF(__pyx_float_0_603785);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_140, 1, __pyx_float_0_603785)) __PYX_ERR(0, 160, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_541400);
  __Pyx_GIVEREF(__pyx_float_0_541400);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_140, 2, __pyx_float_0_541400)) __PYX_ERR(0, 160, __pyx_L1_error);

  
  __pyx_t_141 = PyList_New(3); if (unlikely(!__pyx_t_141)) __PYX_ERR(0, 161, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_141);
  __Pyx_INCREF(__pyx_float_0_119512);
  __Pyx_GIVEREF(__pyx_float_0_119512);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_141, 0, __pyx_float_0_119512)) __PYX_ERR(0, 161, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_607464);
  __Pyx_GIVEREF(__pyx_float_0_607464);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_141, 1, __pyx_float_0_607464)) __PYX_ERR(0, 161, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_540218);
  __Pyx_GIVEREF(__pyx_float_0_540218);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_141, 2, __pyx_float_0_540218)) __PYX_ERR(0, 161, __pyx_L1_error);

  
  __pyx_t_142 = PyList_New(3); if (unlikely(!__pyx_t_142)) __PYX_ERR(0, 162, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_142);
  __Pyx_INCREF(__pyx_float_0_119423);
  __Pyx_GIVEREF(__pyx_float_0_119423);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_142, 0, __pyx_float_0_119423)) __PYX_ERR(0, 162, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_611141);
  __Pyx_GIVEREF(__pyx_float_0_611141);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_142, 1, __pyx_float_0_611141)) __PYX_ERR(0, 162, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_538982);
  __Pyx_GIVEREF(__pyx_float_0_538982);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_142, 2, __pyx_float_0_538982)) __PYX_ERR(0, 162, __pyx_L1_error);

  
  __pyx_t_143 = PyList_New(3); if (unlikely(!__pyx_t_143)) __PYX_ERR(0, 163, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_143);
  __Pyx_INCREF(__pyx_float_0_119483);
  __Pyx_GIVEREF(__pyx_float_0_119483);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_143, 0, __pyx_float_0_119483)) __PYX_ERR(0, 163, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_614817);
  __Pyx_GIVEREF(__pyx_float_0_614817);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_143, 1, __pyx_float_0_614817)) __PYX_ERR(0, 163, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_537692);
  __Pyx_GIVEREF(__pyx_float_0_537692);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_143, 2, __pyx_float_0_537692)) __PYX_ERR(0, 163, __pyx_L1_error);

  
  __pyx_t_144 = PyList_New(3); if (unlikely(!__pyx_t_144)) __PYX_ERR(0, 164, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_144);
  __Pyx_INCREF(__pyx_float_0_119699);
  __Pyx_GIVEREF(__pyx_float_0_119699);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_144, 0, __pyx_float_0_119699)) __PYX_ERR(0, 164, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_618490);
  __Pyx_GIVEREF(__pyx_float_0_618490);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_144, 1, __pyx_float_0_618490)) __PYX_ERR(0, 164, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_536347);
  __Pyx_GIVEREF(__pyx_float_0_536347);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_144, 2, __pyx_float_0_536347)) __PYX_ERR(0, 164, __pyx_L1_error);

  
  __pyx_t_145 = PyList_New(3); if (unlikely(!__pyx_t_145)) __PYX_ERR(0, 165, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_145);
  __Pyx_INCREF(__pyx_float_0_120081);
  __Pyx_GIVEREF(__pyx_float_0_120081);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_145, 0, __pyx_float_0_120081)) __PYX_ERR(0, 165, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_622161);
  __Pyx_GIVEREF(__pyx_float_0_622161);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_145, 1, __pyx_float_0_622161)) __PYX_ERR(0, 165, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_534946);
  __Pyx_GIVEREF(__pyx_float_0_534946);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_145, 2, __pyx_float_0_534946)) __PYX_ERR(0, 165, __pyx_L1_error);

  
  __pyx_t_146 = PyList_New(3); if (unlikely(!__pyx_t_146)) __PYX_ERR(0, 166, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_146);
  __Pyx_INCREF(__pyx_float_0_120638);
  __Pyx_GIVEREF(__pyx_float_0_120638);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_146, 0, __pyx_float_0_120638)) __PYX_ERR(0, 166, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_625828);
  __Pyx_GIVEREF(__pyx_float_0_625828);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_146, 1, __pyx_float_0_625828)) __PYX_ERR(0, 166, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_533488);
  __Pyx_GIVEREF(__pyx_float_0_533488);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_146, 2, __pyx_float_0_533488)) __PYX_ERR(0, 166, __pyx_L1_error);

  
  __pyx_t_147 = PyList_New(3); if (unlikely(!__pyx_t_147)) __PYX_ERR(0, 167, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_147);
  __Pyx_INCREF(__pyx_float_0_121380);
  __Pyx_GIVEREF(__pyx_float_0_121380);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_147, 0, __pyx_float_0_121380)) __PYX_ERR(0, 167, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_629492);
  __Pyx_GIVEREF(__pyx_float_0_629492);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_147, 1, __pyx_float_0_629492)) __PYX_ERR(0, 167, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_531973);
  __Pyx_GIVEREF(__pyx_float_0_531973);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_147, 2, __pyx_float_0_531973)) __PYX_ERR(0, 167, __pyx_L1_error);

  
  __pyx_t_148 = PyList_New(3); if (unlikely(!__pyx_t_148)) __PYX_ERR(0, 168, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_148);
  __Pyx_INCREF(__pyx_float_0_122312);
  __Pyx_GIVEREF(__pyx_float_0_122312);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_148, 0, __pyx_float_0_122312)) __PYX_ERR(0, 168, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_633153);
  __Pyx_GIVEREF(__pyx_float_0_633153);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_148, 1, __pyx_float_0_633153)) __PYX_ERR(0, 168, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_530398);
  __Pyx_GIVEREF(__pyx_float_0_530398);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_148, 2, __pyx_float_0_530398)) __PYX_ERR(0, 168, __pyx_L1_error);

  
  __pyx_t_149 = PyList_New(3); if (unlikely(!__pyx_t_149)) __PYX_ERR(0, 169, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_149);
  __Pyx_INCREF(__pyx_float_0_123444);
  __Pyx_GIVEREF(__pyx_float_0_123444);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_149, 0, __pyx_float_0_123444)) __PYX_ERR(0, 169, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_636809);
  __Pyx_GIVEREF(__pyx_float_0_636809);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_149, 1, __pyx_float_0_636809)) __PYX_ERR(0, 169, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_528763);
  __Pyx_GIVEREF(__pyx_float_0_528763);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_149, 2, __pyx_float_0_528763)) __PYX_ERR(0, 169, __pyx_L1_error);

  
  __pyx_t_150 = PyList_New(3); if (unlikely(!__pyx_t_150)) __PYX_ERR(0, 170, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_150);
  __Pyx_INCREF(__pyx_float_0_124780);
  __Pyx_GIVEREF(__pyx_float_0_124780);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_150, 0, __pyx_float_0_124780)) __PYX_ERR(0, 170, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_640461);
  __Pyx_GIVEREF(__pyx_float_0_640461);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_150, 1, __pyx_float_0_640461)) __PYX_ERR(0, 170, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_527068);
  __Pyx_GIVEREF(__pyx_float_0_527068);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_150, 2, __pyx_float_0_527068)) __PYX_ERR(0, 170, __pyx_L1_error);

  
  __pyx_t_151 = PyList_New(3); if (unlikely(!__pyx_t_151)) __PYX_ERR(0, 171, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_151);
  __Pyx_INCREF(__pyx_float_0_126326);
  __Pyx_GIVEREF(__pyx_float_0_126326);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_151, 0, __pyx_float_0_126326)) __PYX_ERR(0, 171, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_644107);
  __Pyx_GIVEREF(__pyx_float_0_644107);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_151, 1, __pyx_float_0_644107)) __PYX_ERR(0, 171, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_525311);
  __Pyx_GIVEREF(__pyx_float_0_525311);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_151, 2, __pyx_float_0_525311)) __PYX_ERR(0, 171, __pyx_L1_error);

  
  __pyx_t_152 = PyList_New(3); if (unlikely(!__pyx_t_152)) __PYX_ERR(0, 172, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_152);
  __Pyx_INCREF(__pyx_float_0_128087);
  __Pyx_GIVEREF(__pyx_float_0_128087);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_152, 0, __pyx_float_0_128087)) __PYX_ERR(0, 172, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_647749);
  __Pyx_GIVEREF(__pyx_float_0_647749);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_152, 1, __pyx_float_0_647749)) __PYX_ERR(0, 172, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_523491);
  __Pyx_GIVEREF(__pyx_float_0_523491);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_152, 2, __pyx_float_0_523491)) __PYX_ERR(0, 172, __pyx_L1_error);

  
  __pyx_t_153 = PyList_New(3); if (unlikely(!__pyx_t_153)) __PYX_ERR(0, 173, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_153);
  __Pyx_INCREF(__pyx_float_0_130067);
  __Pyx_GIVEREF(__pyx_float_0_130067);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_153, 0, __pyx_float_0_130067)) __PYX_ERR(0, 173, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_651384);
  __Pyx_GIVEREF(__pyx_float_0_651384);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_153, 1, __pyx_float_0_651384)) __PYX_ERR(0, 173, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_521608);
  __Pyx_GIVEREF(__pyx_float_0_521608);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_153, 2, __pyx_float_0_521608)) __PYX_ERR(0, 173, __pyx_L1_error);

  
  __pyx_t_154 = PyList_New(3); if (unlikely(!__pyx_t_154)) __PYX_ERR(0, 174, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_154);
  __Pyx_INCREF(__pyx_float_0_132268);
  __Pyx_GIVEREF(__pyx_float_0_132268);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_154, 0, __pyx_float_0_132268)) __PYX_ERR(0, 174, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_655014);
  __Pyx_GIVEREF(__pyx_float_0_655014);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_154, 1, __pyx_float_0_655014)) __PYX_ERR(0, 174, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_519661);
  __Pyx_GIVEREF(__pyx_float_0_519661);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_154, 2, __pyx_float_0_519661)) __PYX_ERR(0, 174, __pyx_L1_error);

  
  __pyx_t_155 = PyList_New(3); if (unlikely(!__pyx_t_155)) __PYX_ERR(0, 175, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_155);
  __Pyx_INCREF(__pyx_float_0_134692);
  __Pyx_GIVEREF(__pyx_float_0_134692);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_155, 0, __pyx_float_0_134692)) __PYX_ERR(0, 175, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_658636);
  __Pyx_GIVEREF(__pyx_float_0_658636);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_155, 1, __pyx_float_0_658636)) __PYX_ERR(0, 175, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_517649);
  __Pyx_GIVEREF(__pyx_float_0_517649);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_155, 2, __pyx_float_0_517649)) __PYX_ERR(0, 175, __pyx_L1_error);

  
  __pyx_t_156 = PyList_New(3); if (unlikely(!__pyx_t_156)) __PYX_ERR(0, 176, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_156);
  __Pyx_INCREF(__pyx_float_0_137339);
  __Pyx_GIVEREF(__pyx_float_0_137339);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_156, 0, __pyx_float_0_137339)) __PYX_ERR(0, 176, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_662252);
  __Pyx_GIVEREF(__pyx_float_0_662252);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_156, 1, __pyx_float_0_662252)) __PYX_ERR(0, 176, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_515571);
  __Pyx_GIVEREF(__pyx_float_0_515571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_156, 2, __pyx_float_0_515571)) __PYX_ERR(0, 176, __pyx_L1_error);

  
  __pyx_t_157 = PyList_New(3); if (unlikely(!__pyx_t_157)) __PYX_ERR(0, 177, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_157);
  __Pyx_INCREF(__pyx_float_0_140210);
  __Pyx_GIVEREF(__pyx_float_0_140210);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_157, 0, __pyx_float_0_140210)) __PYX_ERR(0, 177, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_665859);
  __Pyx_GIVEREF(__pyx_float_0_665859);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_157, 1, __pyx_float_0_665859)) __PYX_ERR(0, 177, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_513427);
  __Pyx_GIVEREF(__pyx_float_0_513427);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_157, 2, __pyx_float_0_513427)) __PYX_ERR(0, 177, __pyx_L1_error);

  
  __pyx_t_158 = PyList_New(3); if (unlikely(!__pyx_t_158)) __PYX_ERR(0, 178, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_158);
  __Pyx_INCREF(__pyx_float_0_143303);
  __Pyx_GIVEREF(__pyx_float_0_143303);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_158, 0, __pyx_float_0_143303)) __PYX_ERR(0, 178, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_669459);
  __Pyx_GIVEREF(__pyx_float_0_669459);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_158, 1, __pyx_float_0_669459)) __PYX_ERR(0, 178, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_511215);
  __Pyx_GIVEREF(__pyx_float_0_511215);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_158, 2, __pyx_float_0_511215)) __PYX_ERR(0, 178, __pyx_L1_error);

  
  __pyx_t_159 = PyList_New(3); if (unlikely(!__pyx_t_159)) __PYX_ERR(0, 179, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_159);
  __Pyx_INCREF(__pyx_float_0_146616);
  __Pyx_GIVEREF(__pyx_float_0_146616);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_159, 0, __pyx_float_0_146616)) __PYX_ERR(0, 179, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_673050);
  __Pyx_GIVEREF(__pyx_float_0_673050);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_159, 1, __pyx_float_0_673050)) __PYX_ERR(0, 179, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_508936);
  __Pyx_GIVEREF(__pyx_float_0_508936);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_159, 2, __pyx_float_0_508936)) __PYX_ERR(0, 179, __pyx_L1_error);

  
  __pyx_t_160 = PyList_New(3); if (unlikely(!__pyx_t_160)) __PYX_ERR(0, 180, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_160);
  __Pyx_INCREF(__pyx_float_0_150148);
  __Pyx_GIVEREF(__pyx_float_0_150148);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_160, 0, __pyx_float_0_150148)) __PYX_ERR(0, 180, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_676631);
  __Pyx_GIVEREF(__pyx_float_0_676631);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_160, 1, __pyx_float_0_676631)) __PYX_ERR(0, 180, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_506589);
  __Pyx_GIVEREF(__pyx_float_0_506589);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_160, 2, __pyx_float_0_506589)) __PYX_ERR(0, 180, __pyx_L1_error);

  
  __pyx_t_161 = PyList_New(3); if (unlikely(!__pyx_t_161)) __PYX_ERR(0, 181, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_161);
  __Pyx_INCREF(__pyx_float_0_153894);
  __Pyx_GIVEREF(__pyx_float_0_153894);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_161, 0, __pyx_float_0_153894)) __PYX_ERR(0, 181, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_680203);
  __Pyx_GIVEREF(__pyx_float_0_680203);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_161, 1, __pyx_float_0_680203)) __PYX_ERR(0, 181, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_504172);
  __Pyx_GIVEREF(__pyx_float_0_504172);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_161, 2, __pyx_float_0_504172)) __PYX_ERR(0, 181, __pyx_L1_error);

  
  __pyx_t_162 = PyList_New(3); if (unlikely(!__pyx_t_162)) __PYX_ERR(0, 182, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_162);
  __Pyx_INCREF(__pyx_float_0_157851);
  __Pyx_GIVEREF(__pyx_float_0_157851);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_162, 0, __pyx_float_0_157851)) __PYX_ERR(0, 182, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_683765);
  __Pyx_GIVEREF(__pyx_float_0_683765);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_162, 1, __pyx_float_0_683765)) __PYX_ERR(0, 182, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_501686);
  __Pyx_GIVEREF(__pyx_float_0_501686);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_162, 2, __pyx_float_0_501686)) __PYX_ERR(0, 182, __pyx_L1_error);

  
  __pyx_t_163 = PyList_New(3); if (unlikely(!__pyx_t_163)) __PYX_ERR(0, 183, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_163);
  __Pyx_INCREF(__pyx_float_0_162016);
  __Pyx_GIVEREF(__pyx_float_0_162016);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_163, 0, __pyx_float_0_162016)) __PYX_ERR(0, 183, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_687316);
  __Pyx_GIVEREF(__pyx_float_0_687316);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_163, 1, __pyx_float_0_687316)) __PYX_ERR(0, 183, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_499129);
  __Pyx_GIVEREF(__pyx_float_0_499129);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_163, 2, __pyx_float_0_499129)) __PYX_ERR(0, 183, __pyx_L1_error);

  
  __pyx_t_164 = PyList_New(3); if (unlikely(!__pyx_t_164)) __PYX_ERR(0, 184, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_164);
  __Pyx_INCREF(__pyx_float_0_166383);
  __Pyx_GIVEREF(__pyx_float_0_166383);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_164, 0, __pyx_float_0_166383)) __PYX_ERR(0, 184, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_690856);
  __Pyx_GIVEREF(__pyx_float_0_690856);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_164, 1, __pyx_float_0_690856)) __PYX_ERR(0, 184, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_496502);
  __Pyx_GIVEREF(__pyx_float_0_496502);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_164, 2, __pyx_float_0_496502)) __PYX_ERR(0, 184, __pyx_L1_error);

  
  __pyx_t_165 = PyList_New(3); if (unlikely(!__pyx_t_165)) __PYX_ERR(0, 185, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_165);
  __Pyx_INCREF(__pyx_float_0_170948);
  __Pyx_GIVEREF(__pyx_float_0_170948);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_165, 0, __pyx_float_0_170948)) __PYX_ERR(0, 185, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_694384);
  __Pyx_GIVEREF(__pyx_float_0_694384);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_165, 1, __pyx_float_0_694384)) __PYX_ERR(0, 185, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_493803);
  __Pyx_GIVEREF(__pyx_float_0_493803);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_165, 2, __pyx_float_0_493803)) __PYX_ERR(0, 185, __pyx_L1_error);

  
  __pyx_t_166 = PyList_New(3); if (unlikely(!__pyx_t_166)) __PYX_ERR(0, 186, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_166);
  __Pyx_INCREF(__pyx_float_0_175707);
  __Pyx_GIVEREF(__pyx_float_0_175707);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_166, 0, __pyx_float_0_175707)) __PYX_ERR(0, 186, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_697900);
  __Pyx_GIVEREF(__pyx_float_0_697900);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_166, 1, __pyx_float_0_697900)) __PYX_ERR(0, 186, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_491033);
  __Pyx_GIVEREF(__pyx_float_0_491033);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_166, 2, __pyx_float_0_491033)) __PYX_ERR(0, 186, __pyx_L1_error);

  
  __pyx_t_167 = PyList_New(3); if (unlikely(!__pyx_t_167)) __PYX_ERR(0, 187, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_167);
  __Pyx_INCREF(__pyx_float_0_180653);
  __Pyx_GIVEREF(__pyx_float_0_180653);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_167, 0, __pyx_float_0_180653)) __PYX_ERR(0, 187, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_701402);
  __Pyx_GIVEREF(__pyx_float_0_701402);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_167, 1, __pyx_float_0_701402)) __PYX_ERR(0, 187, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_488189);
  __Pyx_GIVEREF(__pyx_float_0_488189);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_167, 2, __pyx_float_0_488189)) __PYX_ERR(0, 187, __pyx_L1_error);

  
  __pyx_t_168 = PyList_New(3); if (unlikely(!__pyx_t_168)) __PYX_ERR(0, 188, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_168);
  __Pyx_INCREF(__pyx_float_0_185783);
  __Pyx_GIVEREF(__pyx_float_0_185783);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_168, 0, __pyx_float_0_185783)) __PYX_ERR(0, 188, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_704891);
  __Pyx_GIVEREF(__pyx_float_0_704891);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_168, 1, __pyx_float_0_704891)) __PYX_ERR(0, 188, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_485273);
  __Pyx_GIVEREF(__pyx_float_0_485273);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_168, 2, __pyx_float_0_485273)) __PYX_ERR(0, 188, __pyx_L1_error);

  
  __pyx_t_169 = PyList_New(3); if (unlikely(!__pyx_t_169)) __PYX_ERR(0, 189, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_169);
  __Pyx_INCREF(__pyx_float_0_191090);
  __Pyx_GIVEREF(__pyx_float_0_191090);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_169, 0, __pyx_float_0_191090)) __PYX_ERR(0, 189, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_708366);
  __Pyx_GIVEREF(__pyx_float_0_708366);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_169, 1, __pyx_float_0_708366)) __PYX_ERR(0, 189, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_482284);
  __Pyx_GIVEREF(__pyx_float_0_482284);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_169, 2, __pyx_float_0_482284)) __PYX_ERR(0, 189, __pyx_L1_error);

  
  __pyx_t_170 = PyList_New(3); if (unlikely(!__pyx_t_170)) __PYX_ERR(0, 190, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_170);
  __Pyx_INCREF(__pyx_float_0_196571);
  __Pyx_GIVEREF(__pyx_float_0_196571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_170, 0, __pyx_float_0_196571)) __PYX_ERR(0, 190, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_711827);
  __Pyx_GIVEREF(__pyx_float_0_711827);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_170, 1, __pyx_float_0_711827)) __PYX_ERR(0, 190, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_479221);
  __Pyx_GIVEREF(__pyx_float_0_479221);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_170, 2, __pyx_float_0_479221)) __PYX_ERR(0, 190, __pyx_L1_error);

  
  __pyx_t_171 = PyList_New(3); if (unlikely(!__pyx_t_171)) __PYX_ERR(0, 191, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_171);
  __Pyx_INCREF(__pyx_float_0_202219);
  __Pyx_GIVEREF(__pyx_float_0_202219);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_171, 0, __pyx_float_0_202219)) __PYX_ERR(0, 191, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_715272);
  __Pyx_GIVEREF(__pyx_float_0_715272);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_171, 1, __pyx_float_0_715272)) __PYX_ERR(0, 191, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_476084);
  __Pyx_GIVEREF(__pyx_float_0_476084);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_171, 2, __pyx_float_0_476084)) __PYX_ERR(0, 191, __pyx_L1_error);

  
  __pyx_t_172 = PyList_New(3); if (unlikely(!__pyx_t_172)) __PYX_ERR(0, 192, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_172);
  __Pyx_INCREF(__pyx_float_0_208030);
  __Pyx_GIVEREF(__pyx_float_0_208030);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_172, 0, __pyx_float_0_208030)) __PYX_ERR(0, 192, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_718701);
  __Pyx_GIVEREF(__pyx_float_0_718701);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_172, 1, __pyx_float_0_718701)) __PYX_ERR(0, 192, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_472873);
  __Pyx_GIVEREF(__pyx_float_0_472873);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_172, 2, __pyx_float_0_472873)) __PYX_ERR(0, 192, __pyx_L1_error);

  
  __pyx_t_173 = PyList_New(3); if (unlikely(!__pyx_t_173)) __PYX_ERR(0, 193, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_173);
  __Pyx_INCREF(__pyx_float_0_214000);
  __Pyx_GIVEREF(__pyx_float_0_214000);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_173, 0, __pyx_float_0_214000)) __PYX_ERR(0, 193, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_722114);
  __Pyx_GIVEREF(__pyx_float_0_722114);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_173, 1, __pyx_float_0_722114)) __PYX_ERR(0, 193, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_469588);
  __Pyx_GIVEREF(__pyx_float_0_469588);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_173, 2, __pyx_float_0_469588)) __PYX_ERR(0, 193, __pyx_L1_error);

  
  __pyx_t_174 = PyList_New(3); if (unlikely(!__pyx_t_174)) __PYX_ERR(0, 194, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_174);
  __Pyx_INCREF(__pyx_float_0_220124);
  __Pyx_GIVEREF(__pyx_float_0_220124);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_174, 0, __pyx_float_0_220124)) __PYX_ERR(0, 194, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_725509);
  __Pyx_GIVEREF(__pyx_float_0_725509);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_174, 1, __pyx_float_0_725509)) __PYX_ERR(0, 194, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_466226);
  __Pyx_GIVEREF(__pyx_float_0_466226);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_174, 2, __pyx_float_0_466226)) __PYX_ERR(0, 194, __pyx_L1_error);

  
  __pyx_t_175 = PyList_New(3); if (unlikely(!__pyx_t_175)) __PYX_ERR(0, 195, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_175);
  __Pyx_INCREF(__pyx_float_0_226397);
  __Pyx_GIVEREF(__pyx_float_0_226397);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_175, 0, __pyx_float_0_226397)) __PYX_ERR(0, 195, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_728888);
  __Pyx_GIVEREF(__pyx_float_0_728888);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_175, 1, __pyx_float_0_728888)) __PYX_ERR(0, 195, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_462789);
  __Pyx_GIVEREF(__pyx_float_0_462789);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_175, 2, __pyx_float_0_462789)) __PYX_ERR(0, 195, __pyx_L1_error);

  
  __pyx_t_176 = PyList_New(3); if (unlikely(!__pyx_t_176)) __PYX_ERR(0, 196, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_176);
  __Pyx_INCREF(__pyx_float_0_232815);
  __Pyx_GIVEREF(__pyx_float_0_232815);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_176, 0, __pyx_float_0_232815)) __PYX_ERR(0, 196, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_732247);
  __Pyx_GIVEREF(__pyx_float_0_732247);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_176, 1, __pyx_float_0_732247)) __PYX_ERR(0, 196, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_459277);
  __Pyx_GIVEREF(__pyx_float_0_459277);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_176, 2, __pyx_float_0_459277)) __PYX_ERR(0, 196, __pyx_L1_error);

  
  __pyx_t_177 = PyList_New(3); if (unlikely(!__pyx_t_177)) __PYX_ERR(0, 197, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_177);
  __Pyx_INCREF(__pyx_float_0_239374);
  __Pyx_GIVEREF(__pyx_float_0_239374);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_177, 0, __pyx_float_0_239374)) __PYX_ERR(0, 197, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_735588);
  __Pyx_GIVEREF(__pyx_float_0_735588);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_177, 1, __pyx_float_0_735588)) __PYX_ERR(0, 197, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_455688);
  __Pyx_GIVEREF(__pyx_float_0_455688);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_177, 2, __pyx_float_0_455688)) __PYX_ERR(0, 197, __pyx_L1_error);

  
  __pyx_t_178 = PyList_New(3); if (unlikely(!__pyx_t_178)) __PYX_ERR(0, 198, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_178);
  __Pyx_INCREF(__pyx_float_0_246070);
  __Pyx_GIVEREF(__pyx_float_0_246070);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_178, 0, __pyx_float_0_246070)) __PYX_ERR(0, 198, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_738910);
  __Pyx_GIVEREF(__pyx_float_0_738910);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_178, 1, __pyx_float_0_738910)) __PYX_ERR(0, 198, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_452024);
  __Pyx_GIVEREF(__pyx_float_0_452024);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_178, 2, __pyx_float_0_452024)) __PYX_ERR(0, 198, __pyx_L1_error);

  
  __pyx_t_179 = PyList_New(3); if (unlikely(!__pyx_t_179)) __PYX_ERR(0, 199, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_179);
  __Pyx_INCREF(__pyx_float_0_252899);
  __Pyx_GIVEREF(__pyx_float_0_252899);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_179, 0, __pyx_float_0_252899)) __PYX_ERR(0, 199, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_742211);
  __Pyx_GIVEREF(__pyx_float_0_742211);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_179, 1, __pyx_float_0_742211)) __PYX_ERR(0, 199, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_448284);
  __Pyx_GIVEREF(__pyx_float_0_448284);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_179, 2, __pyx_float_0_448284)) __PYX_ERR(0, 199, __pyx_L1_error);

  
  __pyx_t_180 = PyList_New(3); if (unlikely(!__pyx_t_180)) __PYX_ERR(0, 200, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_180);
  __Pyx_INCREF(__pyx_float_0_259857);
  __Pyx_GIVEREF(__pyx_float_0_259857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_180, 0, __pyx_float_0_259857)) __PYX_ERR(0, 200, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_745492);
  __Pyx_GIVEREF(__pyx_float_0_745492);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_180, 1, __pyx_float_0_745492)) __PYX_ERR(0, 200, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_444467);
  __Pyx_GIVEREF(__pyx_float_0_444467);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_180, 2, __pyx_float_0_444467)) __PYX_ERR(0, 200, __pyx_L1_error);

  
  __pyx_t_181 = PyList_New(3); if (unlikely(!__pyx_t_181)) __PYX_ERR(0, 201, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_181);
  __Pyx_INCREF(__pyx_float_0_266941);
  __Pyx_GIVEREF(__pyx_float_0_266941);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_181, 0, __pyx_float_0_266941)) __PYX_ERR(0, 201, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_748751);
  __Pyx_GIVEREF(__pyx_float_0_748751);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_181, 1, __pyx_float_0_748751)) __PYX_ERR(0, 201, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_440573);
  __Pyx_GIVEREF(__pyx_float_0_440573);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_181, 2, __pyx_float_0_440573)) __PYX_ERR(0, 201, __pyx_L1_error);

  
  __pyx_t_182 = PyList_New(3); if (unlikely(!__pyx_t_182)) __PYX_ERR(0, 202, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_182);
  __Pyx_INCREF(__pyx_float_0_274149);
  __Pyx_GIVEREF(__pyx_float_0_274149);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_182, 0, __pyx_float_0_274149)) __PYX_ERR(0, 202, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_751988);
  __Pyx_GIVEREF(__pyx_float_0_751988);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_182, 1, __pyx_float_0_751988)) __PYX_ERR(0, 202, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_436601);
  __Pyx_GIVEREF(__pyx_float_0_436601);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_182, 2, __pyx_float_0_436601)) __PYX_ERR(0, 202, __pyx_L1_error);

  
  __pyx_t_183 = PyList_New(3); if (unlikely(!__pyx_t_183)) __PYX_ERR(0, 203, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_183);
  __Pyx_INCREF(__pyx_float_0_281477);
  __Pyx_GIVEREF(__pyx_float_0_281477);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_183, 0, __pyx_float_0_281477)) __PYX_ERR(0, 203, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_755203);
  __Pyx_GIVEREF(__pyx_float_0_755203);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_183, 1, __pyx_float_0_755203)) __PYX_ERR(0, 203, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_432552);
  __Pyx_GIVEREF(__pyx_float_0_432552);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_183, 2, __pyx_float_0_432552)) __PYX_ERR(0, 203, __pyx_L1_error);

  
  __pyx_t_184 = PyList_New(3); if (unlikely(!__pyx_t_184)) __PYX_ERR(0, 204, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_184);
  __Pyx_INCREF(__pyx_float_0_288921);
  __Pyx_GIVEREF(__pyx_float_0_288921);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_184, 0, __pyx_float_0_288921)) __PYX_ERR(0, 204, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_758394);
  __Pyx_GIVEREF(__pyx_float_0_758394);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_184, 1, __pyx_float_0_758394)) __PYX_ERR(0, 204, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_428426);
  __Pyx_GIVEREF(__pyx_float_0_428426);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_184, 2, __pyx_float_0_428426)) __PYX_ERR(0, 204, __pyx_L1_error);

  
  __pyx_t_185 = PyList_New(3); if (unlikely(!__pyx_t_185)) __PYX_ERR(0, 205, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_185);
  __Pyx_INCREF(__pyx_float_0_296479);
  __Pyx_GIVEREF(__pyx_float_0_296479);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_185, 0, __pyx_float_0_296479)) __PYX_ERR(0, 205, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_761561);
  __Pyx_GIVEREF(__pyx_float_0_761561);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_185, 1, __pyx_float_0_761561)) __PYX_ERR(0, 205, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_424223);
  __Pyx_GIVEREF(__pyx_float_0_424223);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_185, 2, __pyx_float_0_424223)) __PYX_ERR(0, 205, __pyx_L1_error);

  
  __pyx_t_186 = PyList_New(3); if (unlikely(!__pyx_t_186)) __PYX_ERR(0, 206, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_186);
  __Pyx_INCREF(__pyx_float_0_304148);
  __Pyx_GIVEREF(__pyx_float_0_304148);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_186, 0, __pyx_float_0_304148)) __PYX_ERR(0, 206, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_764704);
  __Pyx_GIVEREF(__pyx_float_0_764704);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_186, 1, __pyx_float_0_764704)) __PYX_ERR(0, 206, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_419943);
  __Pyx_GIVEREF(__pyx_float_0_419943);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_186, 2, __pyx_float_0_419943)) __PYX_ERR(0, 206, __pyx_L1_error);

  
  __pyx_t_187 = PyList_New(3); if (unlikely(!__pyx_t_187)) __PYX_ERR(0, 207, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_187);
  __Pyx_INCREF(__pyx_float_0_311925);
  __Pyx_GIVEREF(__pyx_float_0_311925);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_187, 0, __pyx_float_0_311925)) __PYX_ERR(0, 207, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_767822);
  __Pyx_GIVEREF(__pyx_float_0_767822);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_187, 1, __pyx_float_0_767822)) __PYX_ERR(0, 207, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_415586);
  __Pyx_GIVEREF(__pyx_float_0_415586);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_187, 2, __pyx_float_0_415586)) __PYX_ERR(0, 207, __pyx_L1_error);

  
  __pyx_t_188 = PyList_New(3); if (unlikely(!__pyx_t_188)) __PYX_ERR(0, 208, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_188);
  __Pyx_INCREF(__pyx_float_0_319809);
  __Pyx_GIVEREF(__pyx_float_0_319809);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_188, 0, __pyx_float_0_319809)) __PYX_ERR(0, 208, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_770914);
  __Pyx_GIVEREF(__pyx_float_0_770914);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_188, 1, __pyx_float_0_770914)) __PYX_ERR(0, 208, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_411152);
  __Pyx_GIVEREF(__pyx_float_0_411152);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_188, 2, __pyx_float_0_411152)) __PYX_ERR(0, 208, __pyx_L1_error);

  
  __pyx_t_189 = PyList_New(3); if (unlikely(!__pyx_t_189)) __PYX_ERR(0, 209, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_189);
  __Pyx_INCREF(__pyx_float_0_327796);
  __Pyx_GIVEREF(__pyx_float_0_327796);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_189, 0, __pyx_float_0_327796)) __PYX_ERR(0, 209, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_773980);
  __Pyx_GIVEREF(__pyx_float_0_773980);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_189, 1, __pyx_float_0_773980)) __PYX_ERR(0, 209, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_406640);
  __Pyx_GIVEREF(__pyx_float_0_406640);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_189, 2, __pyx_float_0_406640)) __PYX_ERR(0, 209, __pyx_L1_error);

  
  __pyx_t_190 = PyList_New(3); if (unlikely(!__pyx_t_190)) __PYX_ERR(0, 210, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_190);
  __Pyx_INCREF(__pyx_float_0_335885);
  __Pyx_GIVEREF(__pyx_float_0_335885);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_190, 0, __pyx_float_0_335885)) __PYX_ERR(0, 210, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_777018);
  __Pyx_GIVEREF(__pyx_float_0_777018);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_190, 1, __pyx_float_0_777018)) __PYX_ERR(0, 210, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_402049);
  __Pyx_GIVEREF(__pyx_float_0_402049);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_190, 2, __pyx_float_0_402049)) __PYX_ERR(0, 210, __pyx_L1_error);

  
  __pyx_t_191 = PyList_New(3); if (unlikely(!__pyx_t_191)) __PYX_ERR(0, 211, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_191);
  __Pyx_INCREF(__pyx_float_0_344074);
  __Pyx_GIVEREF(__pyx_float_0_344074);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_191, 0, __pyx_float_0_344074)) __PYX_ERR(0, 211, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_780029);
  __Pyx_GIVEREF(__pyx_float_0_780029);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_191, 1, __pyx_float_0_780029)) __PYX_ERR(0, 211, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_397381);
  __Pyx_GIVEREF(__pyx_float_0_397381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_191, 2, __pyx_float_0_397381)) __PYX_ERR(0, 211, __pyx_L1_error);

  
  __pyx_t_192 = PyList_New(3); if (unlikely(!__pyx_t_192)) __PYX_ERR(0, 212, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_192);
  __Pyx_INCREF(__pyx_float_0_352360);
  __Pyx_GIVEREF(__pyx_float_0_352360);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_192, 0, __pyx_float_0_352360)) __PYX_ERR(0, 212, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_783011);
  __Pyx_GIVEREF(__pyx_float_0_783011);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_192, 1, __pyx_float_0_783011)) __PYX_ERR(0, 212, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_392636);
  __Pyx_GIVEREF(__pyx_float_0_392636);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_192, 2, __pyx_float_0_392636)) __PYX_ERR(0, 212, __pyx_L1_error);

  
  __pyx_t_193 = PyList_New(3); if (unlikely(!__pyx_t_193)) __PYX_ERR(0, 213, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_193);
  __Pyx_INCREF(__pyx_float_0_360741);
  __Pyx_GIVEREF(__pyx_float_0_360741);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_193, 0, __pyx_float_0_360741)) __PYX_ERR(0, 213, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_785964);
  __Pyx_GIVEREF(__pyx_float_0_785964);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_193, 1, __pyx_float_0_785964)) __PYX_ERR(0, 213, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_387814);
  __Pyx_GIVEREF(__pyx_float_0_387814);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_193, 2, __pyx_float_0_387814)) __PYX_ERR(0, 213, __pyx_L1_error);

  
  __pyx_t_194 = PyList_New(3); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 214, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_194);
  __Pyx_INCREF(__pyx_float_0_369214);
  __Pyx_GIVEREF(__pyx_float_0_369214);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 0, __pyx_float_0_369214)) __PYX_ERR(0, 214, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_788888);
  __Pyx_GIVEREF(__pyx_float_0_788888);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 1, __pyx_float_0_788888)) __PYX_ERR(0, 214, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_382914);
  __Pyx_GIVEREF(__pyx_float_0_382914);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 2, __pyx_float_0_382914)) __PYX_ERR(0, 214, __pyx_L1_error);

  
  __pyx_t_195 = PyList_New(3); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 215, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  __Pyx_INCREF(__pyx_float_0_377779);
  __Pyx_GIVEREF(__pyx_float_0_377779);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_195, 0, __pyx_float_0_377779)) __PYX_ERR(0, 215, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_791781);
  __Pyx_GIVEREF(__pyx_float_0_791781);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_195, 1, __pyx_float_0_791781)) __PYX_ERR(0, 215, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_377939);
  __Pyx_GIVEREF(__pyx_float_0_377939);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_195, 2, __pyx_float_0_377939)) __PYX_ERR(0, 215, __pyx_L1_error);

  
  __pyx_t_196 = PyList_New(3); if (unlikely(!__pyx_t_196)) __PYX_ERR(0, 216, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_196);
  __Pyx_INCREF(__pyx_float_0_386433);
  __Pyx_GIVEREF(__pyx_float_0_386433);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_196, 0, __pyx_float_0_386433)) __PYX_ERR(0, 216, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_794644);
  __Pyx_GIVEREF(__pyx_float_0_794644);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_196, 1, __pyx_float_0_794644)) __PYX_ERR(0, 216, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_372886);
  __Pyx_GIVEREF(__pyx_float_0_372886);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_196, 2, __pyx_float_0_372886)) __PYX_ERR(0, 216, __pyx_L1_error);

  
  __pyx_t_197 = PyList_New(3); if (unlikely(!__pyx_t_197)) __PYX_ERR(0, 217, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_197);
  __Pyx_INCREF(__pyx_float_0_395174);
  __Pyx_GIVEREF(__pyx_float_0_395174);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_197, 0, __pyx_float_0_395174)) __PYX_ERR(0, 217, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_797475);
  __Pyx_GIVEREF(__pyx_float_0_797475);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_197, 1, __pyx_float_0_797475)) __PYX_ERR(0, 217, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_367757);
  __Pyx_GIVEREF(__pyx_float_0_367757);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_197, 2, __pyx_float_0_367757)) __PYX_ERR(0, 217, __pyx_L1_error);

  
  __pyx_t_198 = PyList_New(3); if (unlikely(!__pyx_t_198)) __PYX_ERR(0, 218, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_198);
  __Pyx_INCREF(__pyx_float_0_404001);
  __Pyx_GIVEREF(__pyx_float_0_404001);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_198, 0, __pyx_float_0_404001)) __PYX_ERR(0, 218, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_800275);
  __Pyx_GIVEREF(__pyx_float_0_800275);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_198, 1, __pyx_float_0_800275)) __PYX_ERR(0, 218, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_362552);
  __Pyx_GIVEREF(__pyx_float_0_362552);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_198, 2, __pyx_float_0_362552)) __PYX_ERR(0, 218, __pyx_L1_error);

  
  __pyx_t_199 = PyList_New(3); if (unlikely(!__pyx_t_199)) __PYX_ERR(0, 219, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_199);
  __Pyx_INCREF(__pyx_float_0_412913);
  __Pyx_GIVEREF(__pyx_float_0_412913);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_199, 0, __pyx_float_0_412913)) __PYX_ERR(0, 219, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_803041);
  __Pyx_GIVEREF(__pyx_float_0_803041);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_199, 1, __pyx_float_0_803041)) __PYX_ERR(0, 219, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_357269);
  __Pyx_GIVEREF(__pyx_float_0_357269);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_199, 2, __pyx_float_0_357269)) __PYX_ERR(0, 219, __pyx_L1_error);

  
  __pyx_t_200 = PyList_New(3); if (unlikely(!__pyx_t_200)) __PYX_ERR(0, 220, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_200);
  __Pyx_INCREF(__pyx_float_0_421908);
  __Pyx_GIVEREF(__pyx_float_0_421908);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_200, 0, __pyx_float_0_421908)) __PYX_ERR(0, 220, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_805774);
  __Pyx_GIVEREF(__pyx_float_0_805774);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_200, 1, __pyx_float_0_805774)) __PYX_ERR(0, 220, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_351910);
  __Pyx_GIVEREF(__pyx_float_0_351910);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_200, 2, __pyx_float_0_351910)) __PYX_ERR(0, 220, __pyx_L1_error);

  
  __pyx_t_201 = PyList_New(3); if (unlikely(!__pyx_t_201)) __PYX_ERR(0, 221, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_201);
  __Pyx_INCREF(__pyx_float_0_430983);
  __Pyx_GIVEREF(__pyx_float_0_430983);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_201, 0, __pyx_float_0_430983)) __PYX_ERR(0, 221, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_808473);
  __Pyx_GIVEREF(__pyx_float_0_808473);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_201, 1, __pyx_float_0_808473)) __PYX_ERR(0, 221, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_346476);
  __Pyx_GIVEREF(__pyx_float_0_346476);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_201, 2, __pyx_float_0_346476)) __PYX_ERR(0, 221, __pyx_L1_error);

  
  __pyx_t_202 = PyList_New(3); if (unlikely(!__pyx_t_202)) __PYX_ERR(0, 222, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_202);
  __Pyx_INCREF(__pyx_float_0_440137);
  __Pyx_GIVEREF(__pyx_float_0_440137);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_202, 0, __pyx_float_0_440137)) __PYX_ERR(0, 222, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_811138);
  __Pyx_GIVEREF(__pyx_float_0_811138);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_202, 1, __pyx_float_0_811138)) __PYX_ERR(0, 222, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_340967);
  __Pyx_GIVEREF(__pyx_float_0_340967);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_202, 2, __pyx_float_0_340967)) __PYX_ERR(0, 222, __pyx_L1_error);

  
  __pyx_t_203 = PyList_New(3); if (unlikely(!__pyx_t_203)) __PYX_ERR(0, 223, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_203);
  __Pyx_INCREF(__pyx_float_0_449368);
  __Pyx_GIVEREF(__pyx_float_0_449368);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_203, 0, __pyx_float_0_449368)) __PYX_ERR(0, 223, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_813768);
  __Pyx_GIVEREF(__pyx_float_0_813768);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_203, 1, __pyx_float_0_813768)) __PYX_ERR(0, 223, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_335384);
  __Pyx_GIVEREF(__pyx_float_0_335384);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_203, 2, __pyx_float_0_335384)) __PYX_ERR(0, 223, __pyx_L1_error);

  
  __pyx_t_204 = PyList_New(3); if (unlikely(!__pyx_t_204)) __PYX_ERR(0, 224, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_204);
  __Pyx_INCREF(__pyx_float_0_458674);
  __Pyx_GIVEREF(__pyx_float_0_458674);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_204, 0, __pyx_float_0_458674)) __PYX_ERR(0, 224, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_816363);
  __Pyx_GIVEREF(__pyx_float_0_816363);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_204, 1, __pyx_float_0_816363)) __PYX_ERR(0, 224, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_329727);
  __Pyx_GIVEREF(__pyx_float_0_329727);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_204, 2, __pyx_float_0_329727)) __PYX_ERR(0, 224, __pyx_L1_error);

  
  __pyx_t_205 = PyList_New(3); if (unlikely(!__pyx_t_205)) __PYX_ERR(0, 225, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_205);
  __Pyx_INCREF(__pyx_float_0_468053);
  __Pyx_GIVEREF(__pyx_float_0_468053);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_205, 0, __pyx_float_0_468053)) __PYX_ERR(0, 225, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_818921);
  __Pyx_GIVEREF(__pyx_float_0_818921);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_205, 1, __pyx_float_0_818921)) __PYX_ERR(0, 225, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_323998);
  __Pyx_GIVEREF(__pyx_float_0_323998);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_205, 2, __pyx_float_0_323998)) __PYX_ERR(0, 225, __pyx_L1_error);

  
  __pyx_t_206 = PyList_New(3); if (unlikely(!__pyx_t_206)) __PYX_ERR(0, 226, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_206);
  __Pyx_INCREF(__pyx_float_0_477504);
  __Pyx_GIVEREF(__pyx_float_0_477504);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_206, 0, __pyx_float_0_477504)) __PYX_ERR(0, 226, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_821444);
  __Pyx_GIVEREF(__pyx_float_0_821444);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_206, 1, __pyx_float_0_821444)) __PYX_ERR(0, 226, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_318195);
  __Pyx_GIVEREF(__pyx_float_0_318195);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_206, 2, __pyx_float_0_318195)) __PYX_ERR(0, 226, __pyx_L1_error);

  
  __pyx_t_207 = PyList_New(3); if (unlikely(!__pyx_t_207)) __PYX_ERR(0, 227, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_207);
  __Pyx_INCREF(__pyx_float_0_487026);
  __Pyx_GIVEREF(__pyx_float_0_487026);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_207, 0, __pyx_float_0_487026)) __PYX_ERR(0, 227, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_823929);
  __Pyx_GIVEREF(__pyx_float_0_823929);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_207, 1, __pyx_float_0_823929)) __PYX_ERR(0, 227, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_312321);
  __Pyx_GIVEREF(__pyx_float_0_312321);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_207, 2, __pyx_float_0_312321)) __PYX_ERR(0, 227, __pyx_L1_error);

  
  __pyx_t_208 = PyList_New(3); if (unlikely(!__pyx_t_208)) __PYX_ERR(0, 228, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_208);
  __Pyx_INCREF(__pyx_float_0_496615);
  __Pyx_GIVEREF(__pyx_float_0_496615);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_208, 0, __pyx_float_0_496615)) __PYX_ERR(0, 228, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_826376);
  __Pyx_GIVEREF(__pyx_float_0_826376);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_208, 1, __pyx_float_0_826376)) __PYX_ERR(0, 228, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_306377);
  __Pyx_GIVEREF(__pyx_float_0_306377);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_208, 2, __pyx_float_0_306377)) __PYX_ERR(0, 228, __pyx_L1_error);

  
  __pyx_t_209 = PyList_New(3); if (unlikely(!__pyx_t_209)) __PYX_ERR(0, 229, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_209);
  __Pyx_INCREF(__pyx_float_0_506271);
  __Pyx_GIVEREF(__pyx_float_0_506271);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_209, 0, __pyx_float_0_506271)) __PYX_ERR(0, 229, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_828786);
  __Pyx_GIVEREF(__pyx_float_0_828786);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_209, 1, __pyx_float_0_828786)) __PYX_ERR(0, 229, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_300362);
  __Pyx_GIVEREF(__pyx_float_0_300362);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_209, 2, __pyx_float_0_300362)) __PYX_ERR(0, 229, __pyx_L1_error);

  
  __pyx_t_210 = PyList_New(3); if (unlikely(!__pyx_t_210)) __PYX_ERR(0, 230, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_210);
  __Pyx_INCREF(__pyx_float_0_515992);
  __Pyx_GIVEREF(__pyx_float_0_515992);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_210, 0, __pyx_float_0_515992)) __PYX_ERR(0, 230, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_831158);
  __Pyx_GIVEREF(__pyx_float_0_831158);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_210, 1, __pyx_float_0_831158)) __PYX_ERR(0, 230, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_294279);
  __Pyx_GIVEREF(__pyx_float_0_294279);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_210, 2, __pyx_float_0_294279)) __PYX_ERR(0, 230, __pyx_L1_error);

  
  __pyx_t_211 = PyList_New(3); if (unlikely(!__pyx_t_211)) __PYX_ERR(0, 231, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_211);
  __Pyx_INCREF(__pyx_float_0_525776);
  __Pyx_GIVEREF(__pyx_float_0_525776);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_211, 0, __pyx_float_0_525776)) __PYX_ERR(0, 231, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_833491);
  __Pyx_GIVEREF(__pyx_float_0_833491);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_211, 1, __pyx_float_0_833491)) __PYX_ERR(0, 231, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_288127);
  __Pyx_GIVEREF(__pyx_float_0_288127);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_211, 2, __pyx_float_0_288127)) __PYX_ERR(0, 231, __pyx_L1_error);

  
  __pyx_t_212 = PyList_New(3); if (unlikely(!__pyx_t_212)) __PYX_ERR(0, 232, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_212);
  __Pyx_INCREF(__pyx_float_0_535621);
  __Pyx_GIVEREF(__pyx_float_0_535621);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_212, 0, __pyx_float_0_535621)) __PYX_ERR(0, 232, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_835785);
  __Pyx_GIVEREF(__pyx_float_0_835785);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_212, 1, __pyx_float_0_835785)) __PYX_ERR(0, 232, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_281908);
  __Pyx_GIVEREF(__pyx_float_0_281908);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_212, 2, __pyx_float_0_281908)) __PYX_ERR(0, 232, __pyx_L1_error);

  
  __pyx_t_213 = PyList_New(3); if (unlikely(!__pyx_t_213)) __PYX_ERR(0, 233, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_213);
  __Pyx_INCREF(__pyx_float_0_545524);
  __Pyx_GIVEREF(__pyx_float_0_545524);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_213, 0, __pyx_float_0_545524)) __PYX_ERR(0, 233, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_838039);
  __Pyx_GIVEREF(__pyx_float_0_838039);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_213, 1, __pyx_float_0_838039)) __PYX_ERR(0, 233, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_275626);
  __Pyx_GIVEREF(__pyx_float_0_275626);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_213, 2, __pyx_float_0_275626)) __PYX_ERR(0, 233, __pyx_L1_error);

  
  __pyx_t_214 = PyList_New(3); if (unlikely(!__pyx_t_214)) __PYX_ERR(0, 234, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_214);
  __Pyx_INCREF(__pyx_float_0_555484);
  __Pyx_GIVEREF(__pyx_float_0_555484);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_214, 0, __pyx_float_0_555484)) __PYX_ERR(0, 234, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_840254);
  __Pyx_GIVEREF(__pyx_float_0_840254);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_214, 1, __pyx_float_0_840254)) __PYX_ERR(0, 234, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_269281);
  __Pyx_GIVEREF(__pyx_float_0_269281);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_214, 2, __pyx_float_0_269281)) __PYX_ERR(0, 234, __pyx_L1_error);

  
  __pyx_t_215 = PyList_New(3); if (unlikely(!__pyx_t_215)) __PYX_ERR(0, 235, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_215);
  __Pyx_INCREF(__pyx_float_0_565498);
  __Pyx_GIVEREF(__pyx_float_0_565498);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_215, 0, __pyx_float_0_565498)) __PYX_ERR(0, 235, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_842430);
  __Pyx_GIVEREF(__pyx_float_0_842430);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_215, 1, __pyx_float_0_842430)) __PYX_ERR(0, 235, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_262877);
  __Pyx_GIVEREF(__pyx_float_0_262877);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_215, 2, __pyx_float_0_262877)) __PYX_ERR(0, 235, __pyx_L1_error);

  
  __pyx_t_216 = PyList_New(3); if (unlikely(!__pyx_t_216)) __PYX_ERR(0, 236, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_216);
  __Pyx_INCREF(__pyx_float_0_575563);
  __Pyx_GIVEREF(__pyx_float_0_575563);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_216, 0, __pyx_float_0_575563)) __PYX_ERR(0, 236, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_844566);
  __Pyx_GIVEREF(__pyx_float_0_844566);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_216, 1, __pyx_float_0_844566)) __PYX_ERR(0, 236, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_256415);
  __Pyx_GIVEREF(__pyx_float_0_256415);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_216, 2, __pyx_float_0_256415)) __PYX_ERR(0, 236, __pyx_L1_error);

  
  __pyx_t_217 = PyList_New(3); if (unlikely(!__pyx_t_217)) __PYX_ERR(0, 237, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_217);
  __Pyx_INCREF(__pyx_float_0_585678);
  __Pyx_GIVEREF(__pyx_float_0_585678);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_217, 0, __pyx_float_0_585678)) __PYX_ERR(0, 237, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_846661);
  __Pyx_GIVEREF(__pyx_float_0_846661);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_217, 1, __pyx_float_0_846661)) __PYX_ERR(0, 237, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_249897);
  __Pyx_GIVEREF(__pyx_float_0_249897);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_217, 2, __pyx_float_0_249897)) __PYX_ERR(0, 237, __pyx_L1_error);

  
  __pyx_t_218 = PyList_New(3); if (unlikely(!__pyx_t_218)) __PYX_ERR(0, 238, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_218);
  __Pyx_INCREF(__pyx_float_0_595839);
  __Pyx_GIVEREF(__pyx_float_0_595839);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_218, 0, __pyx_float_0_595839)) __PYX_ERR(0, 238, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_848717);
  __Pyx_GIVEREF(__pyx_float_0_848717);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_218, 1, __pyx_float_0_848717)) __PYX_ERR(0, 238, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_243329);
  __Pyx_GIVEREF(__pyx_float_0_243329);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_218, 2, __pyx_float_0_243329)) __PYX_ERR(0, 238, __pyx_L1_error);

  
  __pyx_t_219 = PyList_New(3); if (unlikely(!__pyx_t_219)) __PYX_ERR(0, 239, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_219);
  __Pyx_INCREF(__pyx_float_0_606045);
  __Pyx_GIVEREF(__pyx_float_0_606045);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_219, 0, __pyx_float_0_606045)) __PYX_ERR(0, 239, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_850733);
  __Pyx_GIVEREF(__pyx_float_0_850733);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_219, 1, __pyx_float_0_850733)) __PYX_ERR(0, 239, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_236712);
  __Pyx_GIVEREF(__pyx_float_0_236712);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_219, 2, __pyx_float_0_236712)) __PYX_ERR(0, 239, __pyx_L1_error);

  
  __pyx_t_220 = PyList_New(3); if (unlikely(!__pyx_t_220)) __PYX_ERR(0, 240, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_220);
  __Pyx_INCREF(__pyx_float_0_616293);
  __Pyx_GIVEREF(__pyx_float_0_616293);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_220, 0, __pyx_float_0_616293)) __PYX_ERR(0, 240, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_852709);
  __Pyx_GIVEREF(__pyx_float_0_852709);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_220, 1, __pyx_float_0_852709)) __PYX_ERR(0, 240, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_230052);
  __Pyx_GIVEREF(__pyx_float_0_230052);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_220, 2, __pyx_float_0_230052)) __PYX_ERR(0, 240, __pyx_L1_error);

  
  __pyx_t_221 = PyList_New(3); if (unlikely(!__pyx_t_221)) __PYX_ERR(0, 241, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_221);
  __Pyx_INCREF(__pyx_float_0_626579);
  __Pyx_GIVEREF(__pyx_float_0_626579);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_221, 0, __pyx_float_0_626579)) __PYX_ERR(0, 241, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_854645);
  __Pyx_GIVEREF(__pyx_float_0_854645);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_221, 1, __pyx_float_0_854645)) __PYX_ERR(0, 241, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_223353);
  __Pyx_GIVEREF(__pyx_float_0_223353);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_221, 2, __pyx_float_0_223353)) __PYX_ERR(0, 241, __pyx_L1_error);

  
  __pyx_t_222 = PyList_New(3); if (unlikely(!__pyx_t_222)) __PYX_ERR(0, 242, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_222);
  __Pyx_INCREF(__pyx_float_0_636902);
  __Pyx_GIVEREF(__pyx_float_0_636902);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_222, 0, __pyx_float_0_636902)) __PYX_ERR(0, 242, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_856542);
  __Pyx_GIVEREF(__pyx_float_0_856542);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_222, 1, __pyx_float_0_856542)) __PYX_ERR(0, 242, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_216620);
  __Pyx_GIVEREF(__pyx_float_0_216620);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_222, 2, __pyx_float_0_216620)) __PYX_ERR(0, 242, __pyx_L1_error);

  
  __pyx_t_223 = PyList_New(3); if (unlikely(!__pyx_t_223)) __PYX_ERR(0, 243, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_223);
  __Pyx_INCREF(__pyx_float_0_647257);
  __Pyx_GIVEREF(__pyx_float_0_647257);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_223, 0, __pyx_float_0_647257)) __PYX_ERR(0, 243, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_858400);
  __Pyx_GIVEREF(__pyx_float_0_858400);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_223, 1, __pyx_float_0_858400)) __PYX_ERR(0, 243, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_209861);
  __Pyx_GIVEREF(__pyx_float_0_209861);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_223, 2, __pyx_float_0_209861)) __PYX_ERR(0, 243, __pyx_L1_error);

  
  __pyx_t_224 = PyList_New(3); if (unlikely(!__pyx_t_224)) __PYX_ERR(0, 244, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_224);
  __Pyx_INCREF(__pyx_float_0_657642);
  __Pyx_GIVEREF(__pyx_float_0_657642);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_224, 0, __pyx_float_0_657642)) __PYX_ERR(0, 244, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_860219);
  __Pyx_GIVEREF(__pyx_float_0_860219);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_224, 1, __pyx_float_0_860219)) __PYX_ERR(0, 244, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_203082);
  __Pyx_GIVEREF(__pyx_float_0_203082);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_224, 2, __pyx_float_0_203082)) __PYX_ERR(0, 244, __pyx_L1_error);

  
  __pyx_t_225 = PyList_New(3); if (unlikely(!__pyx_t_225)) __PYX_ERR(0, 245, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_225);
  __Pyx_INCREF(__pyx_float_0_668054);
  __Pyx_GIVEREF(__pyx_float_0_668054);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_225, 0, __pyx_float_0_668054)) __PYX_ERR(0, 245, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_861999);
  __Pyx_GIVEREF(__pyx_float_0_861999);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_225, 1, __pyx_float_0_861999)) __PYX_ERR(0, 245, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_196293);
  __Pyx_GIVEREF(__pyx_float_0_196293);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_225, 2, __pyx_float_0_196293)) __PYX_ERR(0, 245, __pyx_L1_error);

  
  __pyx_t_226 = PyList_New(3); if (unlikely(!__pyx_t_226)) __PYX_ERR(0, 246, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_226);
  __Pyx_INCREF(__pyx_float_0_678489);
  __Pyx_GIVEREF(__pyx_float_0_678489);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_226, 0, __pyx_float_0_678489)) __PYX_ERR(0, 246, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_863742);
  __Pyx_GIVEREF(__pyx_float_0_863742);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_226, 1, __pyx_float_0_863742)) __PYX_ERR(0, 246, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_189503);
  __Pyx_GIVEREF(__pyx_float_0_189503);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_226, 2, __pyx_float_0_189503)) __PYX_ERR(0, 246, __pyx_L1_error);

  
  __pyx_t_227 = PyList_New(3); if (unlikely(!__pyx_t_227)) __PYX_ERR(0, 247, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_227);
  __Pyx_INCREF(__pyx_float_0_688944);
  __Pyx_GIVEREF(__pyx_float_0_688944);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_227, 0, __pyx_float_0_688944)) __PYX_ERR(0, 247, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_865448);
  __Pyx_GIVEREF(__pyx_float_0_865448);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_227, 1, __pyx_float_0_865448)) __PYX_ERR(0, 247, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_182725);
  __Pyx_GIVEREF(__pyx_float_0_182725);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_227, 2, __pyx_float_0_182725)) __PYX_ERR(0, 247, __pyx_L1_error);

  
  __pyx_t_228 = PyList_New(3); if (unlikely(!__pyx_t_228)) __PYX_ERR(0, 248, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_228);
  __Pyx_INCREF(__pyx_float_0_699415);
  __Pyx_GIVEREF(__pyx_float_0_699415);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_228, 0, __pyx_float_0_699415)) __PYX_ERR(0, 248, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_867117);
  __Pyx_GIVEREF(__pyx_float_0_867117);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_228, 1, __pyx_float_0_867117)) __PYX_ERR(0, 248, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_175971);
  __Pyx_GIVEREF(__pyx_float_0_175971);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_228, 2, __pyx_float_0_175971)) __PYX_ERR(0, 248, __pyx_L1_error);

  
  __pyx_t_229 = PyList_New(3); if (unlikely(!__pyx_t_229)) __PYX_ERR(0, 249, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_229);
  __Pyx_INCREF(__pyx_float_0_709898);
  __Pyx_GIVEREF(__pyx_float_0_709898);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_229, 0, __pyx_float_0_709898)) __PYX_ERR(0, 249, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_868751);
  __Pyx_GIVEREF(__pyx_float_0_868751);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_229, 1, __pyx_float_0_868751)) __PYX_ERR(0, 249, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_169257);
  __Pyx_GIVEREF(__pyx_float_0_169257);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_229, 2, __pyx_float_0_169257)) __PYX_ERR(0, 249, __pyx_L1_error);

  
  __pyx_t_230 = PyList_New(3); if (unlikely(!__pyx_t_230)) __PYX_ERR(0, 250, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_230);
  __Pyx_INCREF(__pyx_float_0_720391);
  __Pyx_GIVEREF(__pyx_float_0_720391);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_230, 0, __pyx_float_0_720391)) __PYX_ERR(0, 250, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_870350);
  __Pyx_GIVEREF(__pyx_float_0_870350);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_230, 1, __pyx_float_0_870350)) __PYX_ERR(0, 250, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_162603);
  __Pyx_GIVEREF(__pyx_float_0_162603);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_230, 2, __pyx_float_0_162603)) __PYX_ERR(0, 250, __pyx_L1_error);

  
  __pyx_t_231 = PyList_New(3); if (unlikely(!__pyx_t_231)) __PYX_ERR(0, 251, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_231);
  __Pyx_INCREF(__pyx_float_0_730889);
  __Pyx_GIVEREF(__pyx_float_0_730889);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_231, 0, __pyx_float_0_730889)) __PYX_ERR(0, 251, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_871916);
  __Pyx_GIVEREF(__pyx_float_0_871916);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_231, 1, __pyx_float_0_871916)) __PYX_ERR(0, 251, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_156029);
  __Pyx_GIVEREF(__pyx_float_0_156029);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_231, 2, __pyx_float_0_156029)) __PYX_ERR(0, 251, __pyx_L1_error);

  
  __pyx_t_232 = PyList_New(3); if (unlikely(!__pyx_t_232)) __PYX_ERR(0, 252, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_232);
  __Pyx_INCREF(__pyx_float_0_741388);
  __Pyx_GIVEREF(__pyx_float_0_741388);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_232, 0, __pyx_float_0_741388)) __PYX_ERR(0, 252, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_873449);
  __Pyx_GIVEREF(__pyx_float_0_873449);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_232, 1, __pyx_float_0_873449)) __PYX_ERR(0, 252, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_149561);
  __Pyx_GIVEREF(__pyx_float_0_149561);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_232, 2, __pyx_float_0_149561)) __PYX_ERR(0, 252, __pyx_L1_error);

  
  __pyx_t_233 = PyList_New(3); if (unlikely(!__pyx_t_233)) __PYX_ERR(0, 253, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_233);
  __Pyx_INCREF(__pyx_float_0_751884);
  __Pyx_GIVEREF(__pyx_float_0_751884);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_233, 0, __pyx_float_0_751884)) __PYX_ERR(0, 253, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_874951);
  __Pyx_GIVEREF(__pyx_float_0_874951);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_233, 1, __pyx_float_0_874951)) __PYX_ERR(0, 253, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_143228);
  __Pyx_GIVEREF(__pyx_float_0_143228);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_233, 2, __pyx_float_0_143228)) __PYX_ERR(0, 253, __pyx_L1_error);

  
  __pyx_t_234 = PyList_New(3); if (unlikely(!__pyx_t_234)) __PYX_ERR(0, 254, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_234);
  __Pyx_INCREF(__pyx_float_0_762373);
  __Pyx_GIVEREF(__pyx_float_0_762373);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_234, 0, __pyx_float_0_762373)) __PYX_ERR(0, 254, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_876424);
  __Pyx_GIVEREF(__pyx_float_0_876424);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_234, 1, __pyx_float_0_876424)) __PYX_ERR(0, 254, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_137064);
  __Pyx_GIVEREF(__pyx_float_0_137064);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_234, 2, __pyx_float_0_137064)) __PYX_ERR(0, 254, __pyx_L1_error);

  
  __pyx_t_235 = PyList_New(3); if (unlikely(!__pyx_t_235)) __PYX_ERR(0, 255, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_235);
  __Pyx_INCREF(__pyx_float_0_772852);
  __Pyx_GIVEREF(__pyx_float_0_772852);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_235, 0, __pyx_float_0_772852)) __PYX_ERR(0, 255, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_877868);
  __Pyx_GIVEREF(__pyx_float_0_877868);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_235, 1, __pyx_float_0_877868)) __PYX_ERR(0, 255, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_131109);
  __Pyx_GIVEREF(__pyx_float_0_131109);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_235, 2, __pyx_float_0_131109)) __PYX_ERR(0, 255, __pyx_L1_error);

  
  __pyx_t_236 = PyList_New(3); if (unlikely(!__pyx_t_236)) __PYX_ERR(0, 256, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_236);
  __Pyx_INCREF(__pyx_float_0_783315);
  __Pyx_GIVEREF(__pyx_float_0_783315);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_236, 0, __pyx_float_0_783315)) __PYX_ERR(0, 256, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_879285);
  __Pyx_GIVEREF(__pyx_float_0_879285);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_236, 1, __pyx_float_0_879285)) __PYX_ERR(0, 256, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_125405);
  __Pyx_GIVEREF(__pyx_float_0_125405);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_236, 2, __pyx_float_0_125405)) __PYX_ERR(0, 256, __pyx_L1_error);

  
  __pyx_t_237 = PyList_New(3); if (unlikely(!__pyx_t_237)) __PYX_ERR(0, 257, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_237);
  __Pyx_INCREF(__pyx_float_0_793760);
  __Pyx_GIVEREF(__pyx_float_0_793760);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_237, 0, __pyx_float_0_793760)) __PYX_ERR(0, 257, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_880678);
  __Pyx_GIVEREF(__pyx_float_0_880678);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_237, 1, __pyx_float_0_880678)) __PYX_ERR(0, 257, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_120005);
  __Pyx_GIVEREF(__pyx_float_0_120005);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_237, 2, __pyx_float_0_120005)) __PYX_ERR(0, 257, __pyx_L1_error);

  
  __pyx_t_238 = PyList_New(3); if (unlikely(!__pyx_t_238)) __PYX_ERR(0, 258, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_238);
  __Pyx_INCREF(__pyx_float_0_804182);
  __Pyx_GIVEREF(__pyx_float_0_804182);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_238, 0, __pyx_float_0_804182)) __PYX_ERR(0, 258, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_882046);
  __Pyx_GIVEREF(__pyx_float_0_882046);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_238, 1, __pyx_float_0_882046)) __PYX_ERR(0, 258, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_114965);
  __Pyx_GIVEREF(__pyx_float_0_114965);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_238, 2, __pyx_float_0_114965)) __PYX_ERR(0, 258, __pyx_L1_error);

  
  __pyx_t_239 = PyList_New(3); if (unlikely(!__pyx_t_239)) __PYX_ERR(0, 259, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_239);
  __Pyx_INCREF(__pyx_float_0_814576);
  __Pyx_GIVEREF(__pyx_float_0_814576);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_239, 0, __pyx_float_0_814576)) __PYX_ERR(0, 259, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_883393);
  __Pyx_GIVEREF(__pyx_float_0_883393);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_239, 1, __pyx_float_0_883393)) __PYX_ERR(0, 259, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_110347);
  __Pyx_GIVEREF(__pyx_float_0_110347);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_239, 2, __pyx_float_0_110347)) __PYX_ERR(0, 259, __pyx_L1_error);

  
  __pyx_t_240 = PyList_New(3); if (unlikely(!__pyx_t_240)) __PYX_ERR(0, 260, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_240);
  __Pyx_INCREF(__pyx_float_0_824940);
  __Pyx_GIVEREF(__pyx_float_0_824940);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_240, 0, __pyx_float_0_824940)) __PYX_ERR(0, 260, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_884720);
  __Pyx_GIVEREF(__pyx_float_0_884720);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_240, 1, __pyx_float_0_884720)) __PYX_ERR(0, 260, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_106217);
  __Pyx_GIVEREF(__pyx_float_0_106217);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_240, 2, __pyx_float_0_106217)) __PYX_ERR(0, 260, __pyx_L1_error);

  
  __pyx_t_241 = PyList_New(3); if (unlikely(!__pyx_t_241)) __PYX_ERR(0, 261, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_241);
  __Pyx_INCREF(__pyx_float_0_835270);
  __Pyx_GIVEREF(__pyx_float_0_835270);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_241, 0, __pyx_float_0_835270)) __PYX_ERR(0, 261, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_886029);
  __Pyx_GIVEREF(__pyx_float_0_886029);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_241, 1, __pyx_float_0_886029)) __PYX_ERR(0, 261, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_102646);
  __Pyx_GIVEREF(__pyx_float_0_102646);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_241, 2, __pyx_float_0_102646)) __PYX_ERR(0, 261, __pyx_L1_error);

  
  __pyx_t_242 = PyList_New(3); if (unlikely(!__pyx_t_242)) __PYX_ERR(0, 262, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_242);
  __Pyx_INCREF(__pyx_float_0_845561);
  __Pyx_GIVEREF(__pyx_float_0_845561);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_242, 0, __pyx_float_0_845561)) __PYX_ERR(0, 262, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_887322);
  __Pyx_GIVEREF(__pyx_float_0_887322);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_242, 1, __pyx_float_0_887322)) __PYX_ERR(0, 262, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_099702);
  __Pyx_GIVEREF(__pyx_float_0_099702);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_242, 2, __pyx_float_0_099702)) __PYX_ERR(0, 262, __pyx_L1_error);

  
  __pyx_t_243 = PyList_New(3); if (unlikely(!__pyx_t_243)) __PYX_ERR(0, 263, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_243);
  __Pyx_INCREF(__pyx_float_0_855810);
  __Pyx_GIVEREF(__pyx_float_0_855810);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_243, 0, __pyx_float_0_855810)) __PYX_ERR(0, 263, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_888601);
  __Pyx_GIVEREF(__pyx_float_0_888601);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_243, 1, __pyx_float_0_888601)) __PYX_ERR(0, 263, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_097452);
  __Pyx_GIVEREF(__pyx_float_0_097452);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_243, 2, __pyx_float_0_097452)) __PYX_ERR(0, 263, __pyx_L1_error);

  
  __pyx_t_244 = PyList_New(3); if (unlikely(!__pyx_t_244)) __PYX_ERR(0, 264, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_244);
  __Pyx_INCREF(__pyx_float_0_866013);
  __Pyx_GIVEREF(__pyx_float_0_866013);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_244, 0, __pyx_float_0_866013)) __PYX_ERR(0, 264, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_889868);
  __Pyx_GIVEREF(__pyx_float_0_889868);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_244, 1, __pyx_float_0_889868)) __PYX_ERR(0, 264, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_095953);
  __Pyx_GIVEREF(__pyx_float_0_095953);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_244, 2, __pyx_float_0_095953)) __PYX_ERR(0, 264, __pyx_L1_error);

  
  __pyx_t_245 = PyList_New(3); if (unlikely(!__pyx_t_245)) __PYX_ERR(0, 265, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_245);
  __Pyx_INCREF(__pyx_float_0_876168);
  __Pyx_GIVEREF(__pyx_float_0_876168);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_245, 0, __pyx_float_0_876168)) __PYX_ERR(0, 265, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_891125);
  __Pyx_GIVEREF(__pyx_float_0_891125);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_245, 1, __pyx_float_0_891125)) __PYX_ERR(0, 265, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_095250);
  __Pyx_GIVEREF(__pyx_float_0_095250);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_245, 2, __pyx_float_0_095250)) __PYX_ERR(0, 265, __pyx_L1_error);

  
  __pyx_t_246 = PyList_New(3); if (unlikely(!__pyx_t_246)) __PYX_ERR(0, 266, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_246);
  __Pyx_INCREF(__pyx_float_0_886271);
  __Pyx_GIVEREF(__pyx_float_0_886271);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_246, 0, __pyx_float_0_886271)) __PYX_ERR(0, 266, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_892374);
  __Pyx_GIVEREF(__pyx_float_0_892374);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_246, 1, __pyx_float_0_892374)) __PYX_ERR(0, 266, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_095374);
  __Pyx_GIVEREF(__pyx_float_0_095374);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_246, 2, __pyx_float_0_095374)) __PYX_ERR(0, 266, __pyx_L1_error);

  
  __pyx_t_247 = PyList_New(3); if (unlikely(!__pyx_t_247)) __PYX_ERR(0, 267, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_247);
  __Pyx_INCREF(__pyx_float_0_896320);
  __Pyx_GIVEREF(__pyx_float_0_896320);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_247, 0, __pyx_float_0_896320)) __PYX_ERR(0, 267, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_893616);
  __Pyx_GIVEREF(__pyx_float_0_893616);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_247, 1, __pyx_float_0_893616)) __PYX_ERR(0, 267, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_096335);
  __Pyx_GIVEREF(__pyx_float_0_096335);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_247, 2, __pyx_float_0_096335)) __PYX_ERR(0, 267, __pyx_L1_error);

  
  __pyx_t_248 = PyList_New(3); if (unlikely(!__pyx_t_248)) __PYX_ERR(0, 268, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_248);
  __Pyx_INCREF(__pyx_float_0_906311);
  __Pyx_GIVEREF(__pyx_float_0_906311);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_248, 0, __pyx_float_0_906311)) __PYX_ERR(0, 268, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_894855);
  __Pyx_GIVEREF(__pyx_float_0_894855);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_248, 1, __pyx_float_0_894855)) __PYX_ERR(0, 268, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_098125);
  __Pyx_GIVEREF(__pyx_float_0_098125);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_248, 2, __pyx_float_0_098125)) __PYX_ERR(0, 268, __pyx_L1_error);

  
  __pyx_t_249 = PyList_New(3); if (unlikely(!__pyx_t_249)) __PYX_ERR(0, 269, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_249);
  __Pyx_INCREF(__pyx_float_0_916242);
  __Pyx_GIVEREF(__pyx_float_0_916242);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_249, 0, __pyx_float_0_916242)) __PYX_ERR(0, 269, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_896091);
  __Pyx_GIVEREF(__pyx_float_0_896091);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_249, 1, __pyx_float_0_896091)) __PYX_ERR(0, 269, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_100717);
  __Pyx_GIVEREF(__pyx_float_0_100717);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_249, 2, __pyx_float_0_100717)) __PYX_ERR(0, 269, __pyx_L1_error);

  
  __pyx_t_250 = PyList_New(3); if (unlikely(!__pyx_t_250)) __PYX_ERR(0, 270, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_250);
  __Pyx_INCREF(__pyx_float_0_926106);
  __Pyx_GIVEREF(__pyx_float_0_926106);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_250, 0, __pyx_float_0_926106)) __PYX_ERR(0, 270, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_897330);
  __Pyx_GIVEREF(__pyx_float_0_897330);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_250, 1, __pyx_float_0_897330)) __PYX_ERR(0, 270, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_104071);
  __Pyx_GIVEREF(__pyx_float_0_104071);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_250, 2, __pyx_float_0_104071)) __PYX_ERR(0, 270, __pyx_L1_error);

  
  __pyx_t_251 = PyList_New(3); if (unlikely(!__pyx_t_251)) __PYX_ERR(0, 271, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_251);
  __Pyx_INCREF(__pyx_float_0_935904);
  __Pyx_GIVEREF(__pyx_float_0_935904);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_251, 0, __pyx_float_0_935904)) __PYX_ERR(0, 271, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_898570);
  __Pyx_GIVEREF(__pyx_float_0_898570);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_251, 1, __pyx_float_0_898570)) __PYX_ERR(0, 271, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_108131);
  __Pyx_GIVEREF(__pyx_float_0_108131);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_251, 2, __pyx_float_0_108131)) __PYX_ERR(0, 271, __pyx_L1_error);

  
  __pyx_t_252 = PyList_New(3); if (unlikely(!__pyx_t_252)) __PYX_ERR(0, 272, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_252);
  __Pyx_INCREF(__pyx_float_0_945636);
  __Pyx_GIVEREF(__pyx_float_0_945636);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_252, 0, __pyx_float_0_945636)) __PYX_ERR(0, 272, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_899815);
  __Pyx_GIVEREF(__pyx_float_0_899815);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_252, 1, __pyx_float_0_899815)) __PYX_ERR(0, 272, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_112838);
  __Pyx_GIVEREF(__pyx_float_0_112838);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_252, 2, __pyx_float_0_112838)) __PYX_ERR(0, 272, __pyx_L1_error);

  
  __pyx_t_253 = PyList_New(3); if (unlikely(!__pyx_t_253)) __PYX_ERR(0, 273, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_253);
  __Pyx_INCREF(__pyx_float_0_955300);
  __Pyx_GIVEREF(__pyx_float_0_955300);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_253, 0, __pyx_float_0_955300)) __PYX_ERR(0, 273, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_901065);
  __Pyx_GIVEREF(__pyx_float_0_901065);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_253, 1, __pyx_float_0_901065)) __PYX_ERR(0, 273, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_118128);
  __Pyx_GIVEREF(__pyx_float_0_118128);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_253, 2, __pyx_float_0_118128)) __PYX_ERR(0, 273, __pyx_L1_error);

  
  __pyx_t_254 = PyList_New(3); if (unlikely(!__pyx_t_254)) __PYX_ERR(0, 274, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_254);
  __Pyx_INCREF(__pyx_float_0_964894);
  __Pyx_GIVEREF(__pyx_float_0_964894);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_254, 0, __pyx_float_0_964894)) __PYX_ERR(0, 274, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_902323);
  __Pyx_GIVEREF(__pyx_float_0_902323);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_254, 1, __pyx_float_0_902323)) __PYX_ERR(0, 274, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_123941);
  __Pyx_GIVEREF(__pyx_float_0_123941);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_254, 2, __pyx_float_0_123941)) __PYX_ERR(0, 274, __pyx_L1_error);

  
  __pyx_t_255 = PyList_New(3); if (unlikely(!__pyx_t_255)) __PYX_ERR(0, 275, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_255);
  __Pyx_INCREF(__pyx_float_0_974417);
  __Pyx_GIVEREF(__pyx_float_0_974417);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_255, 0, __pyx_float_0_974417)) __PYX_ERR(0, 275, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_903590);
  __Pyx_GIVEREF(__pyx_float_0_903590);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_255, 1, __pyx_float_0_903590)) __PYX_ERR(0, 275, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_130215);
  __Pyx_GIVEREF(__pyx_float_0_130215);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_255, 2, __pyx_float_0_130215)) __PYX_ERR(0, 275, __pyx_L1_error);

  
  __pyx_t_256 = PyList_New(3); if (unlikely(!__pyx_t_256)) __PYX_ERR(0, 276, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_256);
  __Pyx_INCREF(__pyx_float_0_983868);
  __Pyx_GIVEREF(__pyx_float_0_983868);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_256, 0, __pyx_float_0_983868)) __PYX_ERR(0, 276, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_904867);
  __Pyx_GIVEREF(__pyx_float_0_904867);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_256, 1, __pyx_float_0_904867)) __PYX_ERR(0, 276, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_136897);
  __Pyx_GIVEREF(__pyx_float_0_136897);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_256, 2, __pyx_float_0_136897)) __PYX_ERR(0, 276, __pyx_L1_error);

  
  __pyx_t_257 = PyList_New(3); if (unlikely(!__pyx_t_257)) __PYX_ERR(0, 277, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_257);
  __Pyx_INCREF(__pyx_float_0_993248);
  __Pyx_GIVEREF(__pyx_float_0_993248);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_257, 0, __pyx_float_0_993248)) __PYX_ERR(0, 277, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_906157);
  __Pyx_GIVEREF(__pyx_float_0_906157);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_257, 1, __pyx_float_0_906157)) __PYX_ERR(0, 277, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_143936);
  __Pyx_GIVEREF(__pyx_float_0_143936);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_257, 2, __pyx_float_0_143936)) __PYX_ERR(0, 277, __pyx_L1_error);

  
  __pyx_t_258 = PyList_New(256); if (unlikely(!__pyx_t_258)) __PYX_ERR(0, 22, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_258);
  __Pyx_GIVEREF(__pyx_t_2);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 0, __pyx_t_2)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_3);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 1, __pyx_t_3)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_4);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 2, __pyx_t_4)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_5);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 3, __pyx_t_5)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_6);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 4, __pyx_t_6)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_7);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 5, __pyx_t_7)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_8);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 6, __pyx_t_8)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_9);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 7, __pyx_t_9)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_10);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 8, __pyx_t_10)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_11);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 9, __pyx_t_11)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_12);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 10, __pyx_t_12)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_13);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 11, __pyx_t_13)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_14);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 12, __pyx_t_14)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_15);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 13, __pyx_t_15)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_16);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 14, __pyx_t_16)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_17);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 15, __pyx_t_17)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_18);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 16, __pyx_t_18)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_19);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 17, __pyx_t_19)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_20);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 18, __pyx_t_20)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_21);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 19, __pyx_t_21)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_22);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 20, __pyx_t_22)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_23);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 21, __pyx_t_23)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_24);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 22, __pyx_t_24)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_25);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 23, __pyx_t_25)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_26);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 24, __pyx_t_26)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_27);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 25, __pyx_t_27)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_28);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 26, __pyx_t_28)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_29);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 27, __pyx_t_29)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_30);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 28, __pyx_t_30)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_31);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 29, __pyx_t_31)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_32);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 30, __pyx_t_32)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_33);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 31, __pyx_t_33)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_34);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 32, __pyx_t_34)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_35);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 33, __pyx_t_35)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_36);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 34, __pyx_t_36)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_37);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 35, __pyx_t_37)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_38);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 36, __pyx_t_38)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_39);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 37, __pyx_t_39)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_40);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 38, __pyx_t_40)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_41);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 39, __pyx_t_41)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_42);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 40, __pyx_t_42)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_43);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 41, __pyx_t_43)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_44);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 42, __pyx_t_44)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_45);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 43, __pyx_t_45)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_46);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 44, __pyx_t_46)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_47);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 45, __pyx_t_47)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_48);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 46, __pyx_t_48)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_49);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 47, __pyx_t_49)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_50);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 48, __pyx_t_50)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_51);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 49, __pyx_t_51)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_52);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 50, __pyx_t_52)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_53);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 51, __pyx_t_53)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_54);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 52, __pyx_t_54)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_55);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 53, __pyx_t_55)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_56);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 54, __pyx_t_56)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_57);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 55, __pyx_t_57)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_58);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 56, __pyx_t_58)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_59);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 57, __pyx_t_59)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_60);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 58, __pyx_t_60)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_61);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 59, __pyx_t_61)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_62);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 60, __pyx_t_62)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_63);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 61, __pyx_t_63)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_64);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 62, __pyx_t_64)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_65);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 63, __pyx_t_65)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_66);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 64, __pyx_t_66)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_67);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 65, __pyx_t_67)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_68);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 66, __pyx_t_68)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_69);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 67, __pyx_t_69)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_70);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 68, __pyx_t_70)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_71);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 69, __pyx_t_71)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_72);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 70, __pyx_t_72)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_73);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 71, __pyx_t_73)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_74);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 72, __pyx_t_74)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_75);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 73, __pyx_t_75)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_76);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 74, __pyx_t_76)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_77);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 75, __pyx_t_77)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_78);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 76, __pyx_t_78)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_79);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 77, __pyx_t_79)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_80);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 78, __pyx_t_80)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_81);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 79, __pyx_t_81)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_82);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 80, __pyx_t_82)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_83);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 81, __pyx_t_83)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_84);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 82, __pyx_t_84)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_85);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 83, __pyx_t_85)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_86);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 84, __pyx_t_86)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_87);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 85, __pyx_t_87)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_88);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 86, __pyx_t_88)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_89);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 87, __pyx_t_89)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_90);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 88, __pyx_t_90)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_91);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 89, __pyx_t_91)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_92);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 90, __pyx_t_92)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_93);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 91, __pyx_t_93)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_94);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 92, __pyx_t_94)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_95);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 93, __pyx_t_95)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_96);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 94, __pyx_t_96)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_97);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 95, __pyx_t_97)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_98);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 96, __pyx_t_98)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_99);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 97, __pyx_t_99)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_100);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 98, __pyx_t_100)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_101);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 99, __pyx_t_101)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_102);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 100, __pyx_t_102)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_103);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 101, __pyx_t_103)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_104);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 102, __pyx_t_104)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_105);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 103, __pyx_t_105)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_106);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 104, __pyx_t_106)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_107);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 105, __pyx_t_107)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_108);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 106, __pyx_t_108)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_109);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 107, __pyx_t_109)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_110);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 108, __pyx_t_110)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_111);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 109, __pyx_t_111)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_112);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 110, __pyx_t_112)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_113);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 111, __pyx_t_113)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_114);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 112, __pyx_t_114)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_115);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 113, __pyx_t_115)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_116);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 114, __pyx_t_116)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_117);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 115, __pyx_t_117)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_118);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 116, __pyx_t_118)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_119);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 117, __pyx_t_119)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_120);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 118, __pyx_t_120)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_121);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 119, __pyx_t_121)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_122);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 120, __pyx_t_122)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_123);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 121, __pyx_t_123)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_124);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 122, __pyx_t_124)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_125);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 123, __pyx_t_125)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_126);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 124, __pyx_t_126)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_127);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 125, __pyx_t_127)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_128);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 126, __pyx_t_128)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_129);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 127, __pyx_t_129)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_130);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 128, __pyx_t_130)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_131);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 129, __pyx_t_131)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_132);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 130, __pyx_t_132)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_133);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 131, __pyx_t_133)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_134);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 132, __pyx_t_134)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_135);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 133, __pyx_t_135)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_136);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 134, __pyx_t_136)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_137);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 135, __pyx_t_137)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_138);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 136, __pyx_t_138)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_139);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 137, __pyx_t_139)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_140);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 138, __pyx_t_140)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_141);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 139, __pyx_t_141)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_142);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 140, __pyx_t_142)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 141, __pyx_t_143)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_144);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 142, __pyx_t_144)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_145);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 143, __pyx_t_145)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_146);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 144, __pyx_t_146)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_147);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 145, __pyx_t_147)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_148);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 146, __pyx_t_148)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_149);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 147, __pyx_t_149)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_150);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 148, __pyx_t_150)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_151);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 149, __pyx_t_151)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_152);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 150, __pyx_t_152)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_153);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 151, __pyx_t_153)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_154);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 152, __pyx_t_154)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_155);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 153, __pyx_t_155)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_156);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 154, __pyx_t_156)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_157);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 155, __pyx_t_157)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_158);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 156, __pyx_t_158)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_159);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 157, __pyx_t_159)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_160);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 158, __pyx_t_160)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_161);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 159, __pyx_t_161)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_162);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 160, __pyx_t_162)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_163);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 161, __pyx_t_163)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_164);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 162, __pyx_t_164)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_165);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 163, __pyx_t_165)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_166);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 164, __pyx_t_166)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_167);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 165, __pyx_t_167)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_168);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 166, __pyx_t_168)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_169);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 167, __pyx_t_169)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_170);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 168, __pyx_t_170)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_171);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 169, __pyx_t_171)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_172);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 170, __pyx_t_172)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_173);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 171, __pyx_t_173)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_174);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 172, __pyx_t_174)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_175);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 173, __pyx_t_175)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_176);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 174, __pyx_t_176)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_177);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 175, __pyx_t_177)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_178);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 176, __pyx_t_178)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_179);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 177, __pyx_t_179)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_180);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 178, __pyx_t_180)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_181);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 179, __pyx_t_181)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_182);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 180, __pyx_t_182)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_183);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 181, __pyx_t_183)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_184);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 182, __pyx_t_184)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_185);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 183, __pyx_t_185)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_186);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 184, __pyx_t_186)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_187);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 185, __pyx_t_187)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_188);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 186, __pyx_t_188)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_189);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 187, __pyx_t_189)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_190);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 188, __pyx_t_190)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_191);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 189, __pyx_t_191)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_192);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 190, __pyx_t_192)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_193);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 191, __pyx_t_193)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_194);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 192, __pyx_t_194)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_195);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 193, __pyx_t_195)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_196);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 194, __pyx_t_196)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_197);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 195, __pyx_t_197)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_198);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 196, __pyx_t_198)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_199);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 197, __pyx_t_199)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_200);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 198, __pyx_t_200)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_201);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 199, __pyx_t_201)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_202);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 200, __pyx_t_202)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_203);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 201, __pyx_t_203)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_204);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 202, __pyx_t_204)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_205);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 203, __pyx_t_205)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_206);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 204, __pyx_t_206)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_207);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 205, __pyx_t_207)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_208);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 206, __pyx_t_208)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_209);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 207, __pyx_t_209)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_210);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 208, __pyx_t_210)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_211);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 209, __pyx_t_211)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_212);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 210, __pyx_t_212)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_213);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 211, __pyx_t_213)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_214);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 212, __pyx_t_214)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_215);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 213, __pyx_t_215)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_216);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 214, __pyx_t_216)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_217);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 215, __pyx_t_217)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_218);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 216, __pyx_t_218)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_219);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 217, __pyx_t_219)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_220);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 218, __pyx_t_220)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_221);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 219, __pyx_t_221)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_222);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 220, __pyx_t_222)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_223);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 221, __pyx_t_223)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_224);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 222, __pyx_t_224)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_225);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 223, __pyx_t_225)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_226);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 224, __pyx_t_226)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_227);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 225, __pyx_t_227)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_228);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 226, __pyx_t_228)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_229);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 227, __pyx_t_229)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_230);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 228, __pyx_t_230)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_231);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 229, __pyx_t_231)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_232);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 230, __pyx_t_232)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_233);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 231, __pyx_t_233)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_234);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 232, __pyx_t_234)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_235);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 233, __pyx_t_235)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_236);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 234, __pyx_t_236)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_237);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 235, __pyx_t_237)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_238);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 236, __pyx_t_238)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_239);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 237, __pyx_t_239)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_240);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 238, __pyx_t_240)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_241);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 239, __pyx_t_241)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_242);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 240, __pyx_t_242)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_243);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 241, __pyx_t_243)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_244);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 242, __pyx_t_244)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_245);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 243, __pyx_t_245)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_246);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 244, __pyx_t_246)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_247);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 245, __pyx_t_247)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_248);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 246, __pyx_t_248)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_249);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 247, __pyx_t_249)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_250);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 248, __pyx_t_250)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_251);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 249, __pyx_t_251)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_252);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 250, __pyx_t_252)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_253);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 251, __pyx_t_253)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_254);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 252, __pyx_t_254)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_255);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 253, __pyx_t_255)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_256);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 254, __pyx_t_256)) __PYX_ERR(0, 22, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_257);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 255, __pyx_t_257)) __PYX_ERR(0, 22, __pyx_L1_error);
  __pyx_t_2 = 0;
  __pyx_t_3 = 0;
  __pyx_t_4 = 0;
  __pyx_t_5 = 0;
  __pyx_t_6 = 0;
  __pyx_t_7 = 0;
  __pyx_t_8 = 0;
  __pyx_t_9 = 0;
  __pyx_t_10 = 0;
  __pyx_t_11 = 0;
  __pyx_t_12 = 0;
  __pyx_t_13 = 0;
  __pyx_t_14 = 0;
  __pyx_t_15 = 0;
  __pyx_t_16 = 0;
  __pyx_t_17 = 0;
  __pyx_t_18 = 0;
  __pyx_t_19 = 0;
  __pyx_t_20 = 0;
  __pyx_t_21 = 0;
  __pyx_t_22 = 0;
  __pyx_t_23 = 0;
  __pyx_t_24 = 0;
  __pyx_t_25 = 0;
  __pyx_t_26 = 0;
  __pyx_t_27 = 0;
  __pyx_t_28 = 0;
  __pyx_t_29 = 0;
  __pyx_t_30 = 0;
  __pyx_t_31 = 0;
  __pyx_t_32 = 0;
  __pyx_t_33 = 0;
  __pyx_t_34 = 0;
  __pyx_t_35 = 0;
  __pyx_t_36 = 0;
  __pyx_t_37 = 0;
  __pyx_t_38 = 0;
  __pyx_t_39 = 0;
  __pyx_t_40 = 0;
  __pyx_t_41 = 0;
  __pyx_t_42 = 0;
  __pyx_t_43 = 0;
  __pyx_t_44 = 0;
  __pyx_t_45 = 0;
  __pyx_t_46 = 0;
  __pyx_t_47 = 0;
  __pyx_t_48 = 0;
  __pyx_t_49 = 0;
  __pyx_t_50 = 0;
  __pyx_t_51 = 0;
  __pyx_t_52 = 0;
  __pyx_t_53 = 0;
  __pyx_t_54 = 0;
  __pyx_t_55 = 0;
  __pyx_t_56 = 0;
  __pyx_t_57 = 0;
  __pyx_t_58 = 0;
  __pyx_t_59 = 0;
  __pyx_t_60 = 0;
  __pyx_t_61 = 0;
  __pyx_t_62 = 0;
  __pyx_t_63 = 0;
  __pyx_t_64 = 0;
  __pyx_t_65 = 0;
  __pyx_t_66 = 0;
  __pyx_t_67 = 0;
  __pyx_t_68 = 0;
  __pyx_t_69 = 0;
  __pyx_t_70 = 0;
  __pyx_t_71 = 0;
  __pyx_t_72 = 0;
  __pyx_t_73 = 0;
  __pyx_t_74 = 0;
  __pyx_t_75 = 0;
  __pyx_t_76 = 0;
  __pyx_t_77 = 0;
  __pyx_t_78 = 0;
  __pyx_t_79 = 0;
  __pyx_t_80 = 0;
  __pyx_t_81 = 0;
  __pyx_t_82 = 0;
  __pyx_t_83 = 0;
  __pyx_t_84 = 0;
  __pyx_t_85 = 0;
  __pyx_t_86 = 0;
  __pyx_t_87 = 0;
  __pyx_t_88 = 0;
  __pyx_t_89 = 0;
  __pyx_t_90 = 0;
  __pyx_t_91 = 0;
  __pyx_t_92 = 0;
  __pyx_t_93 = 0;
  __pyx_t_94 = 0;
  __pyx_t_95 = 0;
  __pyx_t_96 = 0;
  __pyx_t_97 = 0;
  __pyx_t_98 = 0;
  __pyx_t_99 = 0;
  __pyx_t_100 = 0;
  __pyx_t_101 = 0;
  __pyx_t_102 = 0;
  __pyx_t_103 = 0;
  __pyx_t_104 = 0;
  __pyx_t_105 = 0;
  __pyx_t_106 = 0;
  __pyx_t_107 = 0;
  __pyx_t_108 = 0;
  __pyx_t_109 = 0;
  __pyx_t_110 = 0;
  __pyx_t_111 = 0;
  __pyx_t_112 = 0;
  __pyx_t_113 = 0;
  __pyx_t_114 = 0;
  __pyx_t_115 = 0;
  __pyx_t_116 = 0;
  __pyx_t_117 = 0;
  __pyx_t_118 = 0;
  __pyx_t_119 = 0;
  __pyx_t_120 = 0;
  __pyx_t_121 = 0;
  __pyx_t_122 = 0;
  __pyx_t_123 = 0;
  __pyx_t_124 = 0;
  __pyx_t_125 = 0;
  __pyx_t_126 = 0;
  __pyx_t_127 = 0;
  __pyx_t_128 = 0;
  __pyx_t_129 = 0;
  __pyx_t_130 = 0;
  __pyx_t_131 = 0;
  __pyx_t_132 = 0;
  __pyx_t_133 = 0;
  __pyx_t_134 = 0;
  __pyx_t_135 = 0;
  __pyx_t_136 = 0;
  __pyx_t_137 = 0;
  __pyx_t_138 = 0;
  __pyx_t_139 = 0;
  __pyx_t_140 = 0;
  __pyx_t_141 = 0;
  __pyx_t_142 = 0;
  __pyx_t_143 = 0;
  __pyx_t_144 = 0;
  __pyx_t_145 = 0;
  __pyx_t_146 = 0;
  __pyx_t_147 = 0;
  __pyx_t_148 = 0;
  __pyx_t_149 = 0;
  __pyx_t_150 = 0;
  __pyx_t_151 = 0;
  __pyx_t_152 = 0;
  __pyx_t_153 = 0;
  __pyx_t_154 = 0;
  __pyx_t_155 = 0;
  __pyx_t_156 = 0;
  __pyx_t_157 = 0;
  __pyx_t_158 = 0;
  __pyx_t_159 = 0;
  __pyx_t_160 = 0;
  __pyx_t_161 = 0;
  __pyx_t_162 = 0;
  __pyx_t_163 = 0;
  __pyx_t_164 = 0;
  __pyx_t_165 = 0;
  __pyx_t_166 = 0;
  __pyx_t_167 = 0;
  __pyx_t_168 = 0;
  __pyx_t_169 = 0;
  __pyx_t_170 = 0;
  __pyx_t_171 = 0;
  __pyx_t_172 = 0;
  __pyx_t_173 = 0;
  __pyx_t_174 = 0;
  __pyx_t_175 = 0;
  __pyx_t_176 = 0;
  __pyx_t_177 = 0;
  __pyx_t_178 = 0;
  __pyx_t_179 = 0;
  __pyx_t_180 = 0;
  __pyx_t_181 = 0;
  __pyx_t_182 = 0;
  __pyx_t_183 = 0;
  __pyx_t_184 = 0;
  __pyx_t_185 = 0;
  __pyx_t_186 = 0;
  __pyx_t_187 = 0;
  __pyx_t_188 = 0;
  __pyx_t_189 = 0;
  __pyx_t_190 = 0;
  __pyx_t_191 = 0;
  __pyx_t_192 = 0;
  __pyx_t_193 = 0;
  __pyx_t_194 = 0;
  __pyx_t_195 = 0;
  __pyx_t_196 = 0;
  __pyx_t_197 = 0;
  __pyx_t_198 = 0;
  __pyx_t_199 = 0;
  __pyx_t_200 = 0;
  __pyx_t_201 = 0;
  __pyx_t_202 = 0;
  __pyx_t_203 = 0;
  __pyx_t_204 = 0;
  __pyx_t_205 = 0;
  __pyx_t_206 = 0;
  __pyx_t_207 = 0;
  __pyx_t_208 = 0;
  __pyx_t_209 = 0;
  __pyx_t_210 = 0;
  __pyx_t_211 = 0;
  __pyx_t_212 = 0;
  __pyx_t_213 = 0;
  __pyx_t_214 = 0;
  __pyx_t_215 = 0;
  __pyx_t_216 = 0;
  __pyx_t_217 = 0;
  __pyx_t_218 = 0;
  __pyx_t_219 = 0;
  __pyx_t_220 = 0;
  __pyx_t_221 = 0;
  __pyx_t_222 = 0;
  __pyx_t_223 = 0;
  __pyx_t_224 = 0;
  __pyx_t_225 = 0;
  __pyx_t_226 = 0;
  __pyx_t_227 = 0;
  __pyx_t_228 = 0;
  __pyx_t_229 = 0;
  __pyx_t_230 = 0;
  __pyx_t_231 = 0;
  __pyx_t_232 = 0;
  __pyx_t_233 = 0;
  __pyx_t_234 = 0;
  __pyx_t_235 = 0;
  __pyx_t_236 = 0;
  __pyx_t_237 = 0;
  __pyx_t_238 = 0;
  __pyx_t_239 = 0;
  __pyx_t_240 = 0;
  __pyx_t_241 = 0;
  __pyx_t_242 = 0;
  __pyx_t_243 = 0;
  __pyx_t_244 = 0;
  __pyx_t_245 = 0;
  __pyx_t_246 = 0;
  __pyx_t_247 = 0;
  __pyx_t_248 = 0;
  __pyx_t_249 = 0;
  __pyx_t_250 = 0;
  __pyx_t_251 = 0;
  __pyx_t_252 = 0;
  __pyx_t_253 = 0;
  __pyx_t_254 = 0;
  __pyx_t_255 = 0;
  __pyx_t_256 = 0;
  __pyx_t_257 = 0;
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_viridis_data, __pyx_t_258) < 0) __PYX_ERR(0, 22, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_258); __pyx_t_258 = 0;

  
  __pyx_t_258 = PyList_New(3); if (unlikely(!__pyx_t_258)) __PYX_ERR(0, 279, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_258);
  __Pyx_INCREF(__pyx_float_0_2081);
  __Pyx_GIVEREF(__pyx_float_0_2081);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 0, __pyx_float_0_2081)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_1663);
  __Pyx_GIVEREF(__pyx_float_0_1663);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 1, __pyx_float_0_1663)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5292);
  __Pyx_GIVEREF(__pyx_float_0_5292);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_258, 2, __pyx_float_0_5292)) __PYX_ERR(0, 279, __pyx_L1_error);

  
  __pyx_t_257 = PyList_New(3); if (unlikely(!__pyx_t_257)) __PYX_ERR(0, 280, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_257);
  __Pyx_INCREF(__pyx_float_0_2116238095);
  __Pyx_GIVEREF(__pyx_float_0_2116238095);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_257, 0, __pyx_float_0_2116238095)) __PYX_ERR(0, 280, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_1897809524);
  __Pyx_GIVEREF(__pyx_float_0_1897809524);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_257, 1, __pyx_float_0_1897809524)) __PYX_ERR(0, 280, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5776761905);
  __Pyx_GIVEREF(__pyx_float_0_5776761905);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_257, 2, __pyx_float_0_5776761905)) __PYX_ERR(0, 280, __pyx_L1_error);

  
  __pyx_t_256 = PyList_New(3); if (unlikely(!__pyx_t_256)) __PYX_ERR(0, 281, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_256);
  __Pyx_INCREF(__pyx_float_0_212252381);
  __Pyx_GIVEREF(__pyx_float_0_212252381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_256, 0, __pyx_float_0_212252381)) __PYX_ERR(0, 281, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_2137714286);
  __Pyx_GIVEREF(__pyx_float_0_2137714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_256, 1, __pyx_float_0_2137714286)) __PYX_ERR(0, 281, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6269714286);
  __Pyx_GIVEREF(__pyx_float_0_6269714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_256, 2, __pyx_float_0_6269714286)) __PYX_ERR(0, 281, __pyx_L1_error);

  
  __pyx_t_255 = PyList_New(3); if (unlikely(!__pyx_t_255)) __PYX_ERR(0, 282, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_255);
  __Pyx_INCREF(__pyx_float_0_2081);
  __Pyx_GIVEREF(__pyx_float_0_2081);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_255, 0, __pyx_float_0_2081)) __PYX_ERR(0, 282, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_2386);
  __Pyx_GIVEREF(__pyx_float_0_2386);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_255, 1, __pyx_float_0_2386)) __PYX_ERR(0, 282, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6770857143);
  __Pyx_GIVEREF(__pyx_float_0_6770857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_255, 2, __pyx_float_0_6770857143)) __PYX_ERR(0, 282, __pyx_L1_error);

  
  __pyx_t_254 = PyList_New(3); if (unlikely(!__pyx_t_254)) __PYX_ERR(0, 283, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_254);
  __Pyx_INCREF(__pyx_float_0_1959047619);
  __Pyx_GIVEREF(__pyx_float_0_1959047619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_254, 0, __pyx_float_0_1959047619)) __PYX_ERR(0, 283, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_2644571429);
  __Pyx_GIVEREF(__pyx_float_0_2644571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_254, 1, __pyx_float_0_2644571429)) __PYX_ERR(0, 283, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7279);
  __Pyx_GIVEREF(__pyx_float_0_7279);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_254, 2, __pyx_float_0_7279)) __PYX_ERR(0, 283, __pyx_L1_error);

  
  __pyx_t_253 = PyList_New(3); if (unlikely(!__pyx_t_253)) __PYX_ERR(0, 284, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_253);
  __Pyx_INCREF(__pyx_float_0_1707285714);
  __Pyx_GIVEREF(__pyx_float_0_1707285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_253, 0, __pyx_float_0_1707285714)) __PYX_ERR(0, 284, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_2919380952);
  __Pyx_GIVEREF(__pyx_float_0_2919380952);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_253, 1, __pyx_float_0_2919380952)) __PYX_ERR(0, 284, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_779247619);
  __Pyx_GIVEREF(__pyx_float_0_779247619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_253, 2, __pyx_float_0_779247619)) __PYX_ERR(0, 284, __pyx_L1_error);

  
  __pyx_t_252 = PyList_New(3); if (unlikely(!__pyx_t_252)) __PYX_ERR(0, 285, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_252);
  __Pyx_INCREF(__pyx_float_0_1252714286);
  __Pyx_GIVEREF(__pyx_float_0_1252714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_252, 0, __pyx_float_0_1252714286)) __PYX_ERR(0, 285, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3242428571);
  __Pyx_GIVEREF(__pyx_float_0_3242428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_252, 1, __pyx_float_0_3242428571)) __PYX_ERR(0, 285, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8302714286);
  __Pyx_GIVEREF(__pyx_float_0_8302714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_252, 2, __pyx_float_0_8302714286)) __PYX_ERR(0, 285, __pyx_L1_error);

  
  __pyx_t_251 = PyList_New(3); if (unlikely(!__pyx_t_251)) __PYX_ERR(0, 286, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_251);
  __Pyx_INCREF(__pyx_float_0_0591333333);
  __Pyx_GIVEREF(__pyx_float_0_0591333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_251, 0, __pyx_float_0_0591333333)) __PYX_ERR(0, 286, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3598333333);
  __Pyx_GIVEREF(__pyx_float_0_3598333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_251, 1, __pyx_float_0_3598333333)) __PYX_ERR(0, 286, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8683333333);
  __Pyx_GIVEREF(__pyx_float_0_8683333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_251, 2, __pyx_float_0_8683333333)) __PYX_ERR(0, 286, __pyx_L1_error);

  
  __pyx_t_250 = PyList_New(3); if (unlikely(!__pyx_t_250)) __PYX_ERR(0, 287, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_250);
  __Pyx_INCREF(__pyx_float_0_0116952381);
  __Pyx_GIVEREF(__pyx_float_0_0116952381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_250, 0, __pyx_float_0_0116952381)) __PYX_ERR(0, 287, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3875095238);
  __Pyx_GIVEREF(__pyx_float_0_3875095238);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_250, 1, __pyx_float_0_3875095238)) __PYX_ERR(0, 287, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8819571429);
  __Pyx_GIVEREF(__pyx_float_0_8819571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_250, 2, __pyx_float_0_8819571429)) __PYX_ERR(0, 287, __pyx_L1_error);

  
  __pyx_t_249 = PyList_New(3); if (unlikely(!__pyx_t_249)) __PYX_ERR(0, 288, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_249);
  __Pyx_INCREF(__pyx_float_0_0059571429);
  __Pyx_GIVEREF(__pyx_float_0_0059571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_249, 0, __pyx_float_0_0059571429)) __PYX_ERR(0, 288, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4086142857);
  __Pyx_GIVEREF(__pyx_float_0_4086142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_249, 1, __pyx_float_0_4086142857)) __PYX_ERR(0, 288, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8828428571);
  __Pyx_GIVEREF(__pyx_float_0_8828428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_249, 2, __pyx_float_0_8828428571)) __PYX_ERR(0, 288, __pyx_L1_error);

  
  __pyx_t_248 = PyList_New(3); if (unlikely(!__pyx_t_248)) __PYX_ERR(0, 289, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_248);
  __Pyx_INCREF(__pyx_float_0_0165142857);
  __Pyx_GIVEREF(__pyx_float_0_0165142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_248, 0, __pyx_float_0_0165142857)) __PYX_ERR(0, 289, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4266);
  __Pyx_GIVEREF(__pyx_float_0_4266);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_248, 1, __pyx_float_0_4266)) __PYX_ERR(0, 289, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8786333333);
  __Pyx_GIVEREF(__pyx_float_0_8786333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_248, 2, __pyx_float_0_8786333333)) __PYX_ERR(0, 289, __pyx_L1_error);

  
  __pyx_t_247 = PyList_New(3); if (unlikely(!__pyx_t_247)) __PYX_ERR(0, 290, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_247);
  __Pyx_INCREF(__pyx_float_0_032852381);
  __Pyx_GIVEREF(__pyx_float_0_032852381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_247, 0, __pyx_float_0_032852381)) __PYX_ERR(0, 290, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4430428571);
  __Pyx_GIVEREF(__pyx_float_0_4430428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_247, 1, __pyx_float_0_4430428571)) __PYX_ERR(0, 290, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8719571429);
  __Pyx_GIVEREF(__pyx_float_0_8719571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_247, 2, __pyx_float_0_8719571429)) __PYX_ERR(0, 290, __pyx_L1_error);

  
  __pyx_t_246 = PyList_New(3); if (unlikely(!__pyx_t_246)) __PYX_ERR(0, 291, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_246);
  __Pyx_INCREF(__pyx_float_0_0498142857);
  __Pyx_GIVEREF(__pyx_float_0_0498142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_246, 0, __pyx_float_0_0498142857)) __PYX_ERR(0, 291, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4585714286);
  __Pyx_GIVEREF(__pyx_float_0_4585714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_246, 1, __pyx_float_0_4585714286)) __PYX_ERR(0, 291, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8640571429);
  __Pyx_GIVEREF(__pyx_float_0_8640571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_246, 2, __pyx_float_0_8640571429)) __PYX_ERR(0, 291, __pyx_L1_error);

  
  __pyx_t_245 = PyList_New(3); if (unlikely(!__pyx_t_245)) __PYX_ERR(0, 292, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_245);
  __Pyx_INCREF(__pyx_float_0_0629333333);
  __Pyx_GIVEREF(__pyx_float_0_0629333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_245, 0, __pyx_float_0_0629333333)) __PYX_ERR(0, 292, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4736904762);
  __Pyx_GIVEREF(__pyx_float_0_4736904762);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_245, 1, __pyx_float_0_4736904762)) __PYX_ERR(0, 292, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8554380952);
  __Pyx_GIVEREF(__pyx_float_0_8554380952);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_245, 2, __pyx_float_0_8554380952)) __PYX_ERR(0, 292, __pyx_L1_error);

  
  __pyx_t_244 = PyList_New(3); if (unlikely(!__pyx_t_244)) __PYX_ERR(0, 293, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_244);
  __Pyx_INCREF(__pyx_float_0_0722666667);
  __Pyx_GIVEREF(__pyx_float_0_0722666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_244, 0, __pyx_float_0_0722666667)) __PYX_ERR(0, 293, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4886666667);
  __Pyx_GIVEREF(__pyx_float_0_4886666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_244, 1, __pyx_float_0_4886666667)) __PYX_ERR(0, 293, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8467);
  __Pyx_GIVEREF(__pyx_float_0_8467);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_244, 2, __pyx_float_0_8467)) __PYX_ERR(0, 293, __pyx_L1_error);

  
  __pyx_t_243 = PyList_New(3); if (unlikely(!__pyx_t_243)) __PYX_ERR(0, 294, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_243);
  __Pyx_INCREF(__pyx_float_0_0779428571);
  __Pyx_GIVEREF(__pyx_float_0_0779428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_243, 0, __pyx_float_0_0779428571)) __PYX_ERR(0, 294, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5039857143);
  __Pyx_GIVEREF(__pyx_float_0_5039857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_243, 1, __pyx_float_0_5039857143)) __PYX_ERR(0, 294, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8383714286);
  __Pyx_GIVEREF(__pyx_float_0_8383714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_243, 2, __pyx_float_0_8383714286)) __PYX_ERR(0, 294, __pyx_L1_error);

  
  __pyx_t_242 = PyList_New(3); if (unlikely(!__pyx_t_242)) __PYX_ERR(0, 295, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_242);
  __Pyx_INCREF(__pyx_float_0_079347619);
  __Pyx_GIVEREF(__pyx_float_0_079347619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_242, 0, __pyx_float_0_079347619)) __PYX_ERR(0, 295, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5200238095);
  __Pyx_GIVEREF(__pyx_float_0_5200238095);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_242, 1, __pyx_float_0_5200238095)) __PYX_ERR(0, 295, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8311809524);
  __Pyx_GIVEREF(__pyx_float_0_8311809524);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_242, 2, __pyx_float_0_8311809524)) __PYX_ERR(0, 295, __pyx_L1_error);

  
  __pyx_t_241 = PyList_New(3); if (unlikely(!__pyx_t_241)) __PYX_ERR(0, 296, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_241);
  __Pyx_INCREF(__pyx_float_0_0749428571);
  __Pyx_GIVEREF(__pyx_float_0_0749428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_241, 0, __pyx_float_0_0749428571)) __PYX_ERR(0, 296, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5375428571);
  __Pyx_GIVEREF(__pyx_float_0_5375428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_241, 1, __pyx_float_0_5375428571)) __PYX_ERR(0, 296, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8262714286);
  __Pyx_GIVEREF(__pyx_float_0_8262714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_241, 2, __pyx_float_0_8262714286)) __PYX_ERR(0, 296, __pyx_L1_error);

  
  __pyx_t_240 = PyList_New(3); if (unlikely(!__pyx_t_240)) __PYX_ERR(0, 297, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_240);
  __Pyx_INCREF(__pyx_float_0_0640571429);
  __Pyx_GIVEREF(__pyx_float_0_0640571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_240, 0, __pyx_float_0_0640571429)) __PYX_ERR(0, 297, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5569857143);
  __Pyx_GIVEREF(__pyx_float_0_5569857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_240, 1, __pyx_float_0_5569857143)) __PYX_ERR(0, 297, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8239571429);
  __Pyx_GIVEREF(__pyx_float_0_8239571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_240, 2, __pyx_float_0_8239571429)) __PYX_ERR(0, 297, __pyx_L1_error);

  
  __pyx_t_239 = PyList_New(3); if (unlikely(!__pyx_t_239)) __PYX_ERR(0, 298, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_239);
  __Pyx_INCREF(__pyx_float_0_0487714286);
  __Pyx_GIVEREF(__pyx_float_0_0487714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_239, 0, __pyx_float_0_0487714286)) __PYX_ERR(0, 298, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5772238095);
  __Pyx_GIVEREF(__pyx_float_0_5772238095);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_239, 1, __pyx_float_0_5772238095)) __PYX_ERR(0, 298, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8228285714);
  __Pyx_GIVEREF(__pyx_float_0_8228285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_239, 2, __pyx_float_0_8228285714)) __PYX_ERR(0, 298, __pyx_L1_error);

  
  __pyx_t_238 = PyList_New(3); if (unlikely(!__pyx_t_238)) __PYX_ERR(0, 299, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_238);
  __Pyx_INCREF(__pyx_float_0_0343428571);
  __Pyx_GIVEREF(__pyx_float_0_0343428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_238, 0, __pyx_float_0_0343428571)) __PYX_ERR(0, 299, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5965809524);
  __Pyx_GIVEREF(__pyx_float_0_5965809524);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_238, 1, __pyx_float_0_5965809524)) __PYX_ERR(0, 299, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_819852381);
  __Pyx_GIVEREF(__pyx_float_0_819852381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_238, 2, __pyx_float_0_819852381)) __PYX_ERR(0, 299, __pyx_L1_error);

  
  __pyx_t_237 = PyList_New(3); if (unlikely(!__pyx_t_237)) __PYX_ERR(0, 300, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_237);
  __Pyx_INCREF(__pyx_float_0_0265);
  __Pyx_GIVEREF(__pyx_float_0_0265);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_237, 0, __pyx_float_0_0265)) __PYX_ERR(0, 300, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6137);
  __Pyx_GIVEREF(__pyx_float_0_6137);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_237, 1, __pyx_float_0_6137)) __PYX_ERR(0, 300, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8135);
  __Pyx_GIVEREF(__pyx_float_0_8135);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_237, 2, __pyx_float_0_8135)) __PYX_ERR(0, 300, __pyx_L1_error);

  
  __pyx_t_236 = PyList_New(3); if (unlikely(!__pyx_t_236)) __PYX_ERR(0, 301, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_236);
  __Pyx_INCREF(__pyx_float_0_0238904762);
  __Pyx_GIVEREF(__pyx_float_0_0238904762);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_236, 0, __pyx_float_0_0238904762)) __PYX_ERR(0, 301, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6286619048);
  __Pyx_GIVEREF(__pyx_float_0_6286619048);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_236, 1, __pyx_float_0_6286619048)) __PYX_ERR(0, 301, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8037619048);
  __Pyx_GIVEREF(__pyx_float_0_8037619048);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_236, 2, __pyx_float_0_8037619048)) __PYX_ERR(0, 301, __pyx_L1_error);

  
  __pyx_t_235 = PyList_New(3); if (unlikely(!__pyx_t_235)) __PYX_ERR(0, 302, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_235);
  __Pyx_INCREF(__pyx_float_0_0230904762);
  __Pyx_GIVEREF(__pyx_float_0_0230904762);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_235, 0, __pyx_float_0_0230904762)) __PYX_ERR(0, 302, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6417857143);
  __Pyx_GIVEREF(__pyx_float_0_6417857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_235, 1, __pyx_float_0_6417857143)) __PYX_ERR(0, 302, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7912666667);
  __Pyx_GIVEREF(__pyx_float_0_7912666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_235, 2, __pyx_float_0_7912666667)) __PYX_ERR(0, 302, __pyx_L1_error);

  
  __pyx_t_234 = PyList_New(3); if (unlikely(!__pyx_t_234)) __PYX_ERR(0, 303, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_234);
  __Pyx_INCREF(__pyx_float_0_0227714286);
  __Pyx_GIVEREF(__pyx_float_0_0227714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_234, 0, __pyx_float_0_0227714286)) __PYX_ERR(0, 303, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6534857143);
  __Pyx_GIVEREF(__pyx_float_0_6534857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_234, 1, __pyx_float_0_6534857143)) __PYX_ERR(0, 303, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7767571429);
  __Pyx_GIVEREF(__pyx_float_0_7767571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_234, 2, __pyx_float_0_7767571429)) __PYX_ERR(0, 303, __pyx_L1_error);

  
  __pyx_t_233 = PyList_New(3); if (unlikely(!__pyx_t_233)) __PYX_ERR(0, 304, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_233);
  __Pyx_INCREF(__pyx_float_0_0266619048);
  __Pyx_GIVEREF(__pyx_float_0_0266619048);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_233, 0, __pyx_float_0_0266619048)) __PYX_ERR(0, 304, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6641952381);
  __Pyx_GIVEREF(__pyx_float_0_6641952381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_233, 1, __pyx_float_0_6641952381)) __PYX_ERR(0, 304, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7607190476);
  __Pyx_GIVEREF(__pyx_float_0_7607190476);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_233, 2, __pyx_float_0_7607190476)) __PYX_ERR(0, 304, __pyx_L1_error);

  
  __pyx_t_232 = PyList_New(3); if (unlikely(!__pyx_t_232)) __PYX_ERR(0, 305, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_232);
  __Pyx_INCREF(__pyx_float_0_0383714286);
  __Pyx_GIVEREF(__pyx_float_0_0383714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_232, 0, __pyx_float_0_0383714286)) __PYX_ERR(0, 305, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6742714286);
  __Pyx_GIVEREF(__pyx_float_0_6742714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_232, 1, __pyx_float_0_6742714286)) __PYX_ERR(0, 305, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_743552381);
  __Pyx_GIVEREF(__pyx_float_0_743552381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_232, 2, __pyx_float_0_743552381)) __PYX_ERR(0, 305, __pyx_L1_error);

  
  __pyx_t_231 = PyList_New(3); if (unlikely(!__pyx_t_231)) __PYX_ERR(0, 306, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_231);
  __Pyx_INCREF(__pyx_float_0_0589714286);
  __Pyx_GIVEREF(__pyx_float_0_0589714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_231, 0, __pyx_float_0_0589714286)) __PYX_ERR(0, 306, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6837571429);
  __Pyx_GIVEREF(__pyx_float_0_6837571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_231, 1, __pyx_float_0_6837571429)) __PYX_ERR(0, 306, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7253857143);
  __Pyx_GIVEREF(__pyx_float_0_7253857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_231, 2, __pyx_float_0_7253857143)) __PYX_ERR(0, 306, __pyx_L1_error);

  
  __pyx_t_230 = PyList_New(3); if (unlikely(!__pyx_t_230)) __PYX_ERR(0, 307, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_230);
  __Pyx_INCREF(__pyx_float_0_0843);
  __Pyx_GIVEREF(__pyx_float_0_0843);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_230, 0, __pyx_float_0_0843)) __PYX_ERR(0, 307, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6928333333);
  __Pyx_GIVEREF(__pyx_float_0_6928333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_230, 1, __pyx_float_0_6928333333)) __PYX_ERR(0, 307, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7061666667);
  __Pyx_GIVEREF(__pyx_float_0_7061666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_230, 2, __pyx_float_0_7061666667)) __PYX_ERR(0, 307, __pyx_L1_error);

  
  __pyx_t_229 = PyList_New(3); if (unlikely(!__pyx_t_229)) __PYX_ERR(0, 308, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_229);
  __Pyx_INCREF(__pyx_float_0_1132952381);
  __Pyx_GIVEREF(__pyx_float_0_1132952381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_229, 0, __pyx_float_0_1132952381)) __PYX_ERR(0, 308, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7015);
  __Pyx_GIVEREF(__pyx_float_0_7015);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_229, 1, __pyx_float_0_7015)) __PYX_ERR(0, 308, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6858571429);
  __Pyx_GIVEREF(__pyx_float_0_6858571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_229, 2, __pyx_float_0_6858571429)) __PYX_ERR(0, 308, __pyx_L1_error);

  
  __pyx_t_228 = PyList_New(3); if (unlikely(!__pyx_t_228)) __PYX_ERR(0, 309, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_228);
  __Pyx_INCREF(__pyx_float_0_1452714286);
  __Pyx_GIVEREF(__pyx_float_0_1452714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_228, 0, __pyx_float_0_1452714286)) __PYX_ERR(0, 309, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7097571429);
  __Pyx_GIVEREF(__pyx_float_0_7097571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_228, 1, __pyx_float_0_7097571429)) __PYX_ERR(0, 309, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6646285714);
  __Pyx_GIVEREF(__pyx_float_0_6646285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_228, 2, __pyx_float_0_6646285714)) __PYX_ERR(0, 309, __pyx_L1_error);

  
  __pyx_t_227 = PyList_New(3); if (unlikely(!__pyx_t_227)) __PYX_ERR(0, 310, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_227);
  __Pyx_INCREF(__pyx_float_0_1801333333);
  __Pyx_GIVEREF(__pyx_float_0_1801333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_227, 0, __pyx_float_0_1801333333)) __PYX_ERR(0, 310, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7176571429);
  __Pyx_GIVEREF(__pyx_float_0_7176571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_227, 1, __pyx_float_0_7176571429)) __PYX_ERR(0, 310, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6424333333);
  __Pyx_GIVEREF(__pyx_float_0_6424333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_227, 2, __pyx_float_0_6424333333)) __PYX_ERR(0, 310, __pyx_L1_error);

  
  __pyx_t_226 = PyList_New(3); if (unlikely(!__pyx_t_226)) __PYX_ERR(0, 311, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_226);
  __Pyx_INCREF(__pyx_float_0_2178285714);
  __Pyx_GIVEREF(__pyx_float_0_2178285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_226, 0, __pyx_float_0_2178285714)) __PYX_ERR(0, 311, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7250428571);
  __Pyx_GIVEREF(__pyx_float_0_7250428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_226, 1, __pyx_float_0_7250428571)) __PYX_ERR(0, 311, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_6192619048);
  __Pyx_GIVEREF(__pyx_float_0_6192619048);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_226, 2, __pyx_float_0_6192619048)) __PYX_ERR(0, 311, __pyx_L1_error);

  
  __pyx_t_225 = PyList_New(3); if (unlikely(!__pyx_t_225)) __PYX_ERR(0, 312, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_225);
  __Pyx_INCREF(__pyx_float_0_2586428571);
  __Pyx_GIVEREF(__pyx_float_0_2586428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_225, 0, __pyx_float_0_2586428571)) __PYX_ERR(0, 312, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7317142857);
  __Pyx_GIVEREF(__pyx_float_0_7317142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_225, 1, __pyx_float_0_7317142857)) __PYX_ERR(0, 312, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5954285714);
  __Pyx_GIVEREF(__pyx_float_0_5954285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_225, 2, __pyx_float_0_5954285714)) __PYX_ERR(0, 312, __pyx_L1_error);

  
  __pyx_t_224 = PyList_New(3); if (unlikely(!__pyx_t_224)) __PYX_ERR(0, 313, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_224);
  __Pyx_INCREF(__pyx_float_0_3021714286);
  __Pyx_GIVEREF(__pyx_float_0_3021714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_224, 0, __pyx_float_0_3021714286)) __PYX_ERR(0, 313, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7376047619);
  __Pyx_GIVEREF(__pyx_float_0_7376047619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_224, 1, __pyx_float_0_7376047619)) __PYX_ERR(0, 313, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5711857143);
  __Pyx_GIVEREF(__pyx_float_0_5711857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_224, 2, __pyx_float_0_5711857143)) __PYX_ERR(0, 313, __pyx_L1_error);

  
  __pyx_t_223 = PyList_New(3); if (unlikely(!__pyx_t_223)) __PYX_ERR(0, 314, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_223);
  __Pyx_INCREF(__pyx_float_0_3481666667);
  __Pyx_GIVEREF(__pyx_float_0_3481666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_223, 0, __pyx_float_0_3481666667)) __PYX_ERR(0, 314, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7424333333);
  __Pyx_GIVEREF(__pyx_float_0_7424333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_223, 1, __pyx_float_0_7424333333)) __PYX_ERR(0, 314, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5472666667);
  __Pyx_GIVEREF(__pyx_float_0_5472666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_223, 2, __pyx_float_0_5472666667)) __PYX_ERR(0, 314, __pyx_L1_error);

  
  __pyx_t_222 = PyList_New(3); if (unlikely(!__pyx_t_222)) __PYX_ERR(0, 315, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_222);
  __Pyx_INCREF(__pyx_float_0_3952571429);
  __Pyx_GIVEREF(__pyx_float_0_3952571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_222, 0, __pyx_float_0_3952571429)) __PYX_ERR(0, 315, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7459);
  __Pyx_GIVEREF(__pyx_float_0_7459);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_222, 1, __pyx_float_0_7459)) __PYX_ERR(0, 315, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5244428571);
  __Pyx_GIVEREF(__pyx_float_0_5244428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_222, 2, __pyx_float_0_5244428571)) __PYX_ERR(0, 315, __pyx_L1_error);

  
  __pyx_t_221 = PyList_New(3); if (unlikely(!__pyx_t_221)) __PYX_ERR(0, 316, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_221);
  __Pyx_INCREF(__pyx_float_0_4420095238);
  __Pyx_GIVEREF(__pyx_float_0_4420095238);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_221, 0, __pyx_float_0_4420095238)) __PYX_ERR(0, 316, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7480809524);
  __Pyx_GIVEREF(__pyx_float_0_7480809524);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_221, 1, __pyx_float_0_7480809524)) __PYX_ERR(0, 316, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_5033142857);
  __Pyx_GIVEREF(__pyx_float_0_5033142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_221, 2, __pyx_float_0_5033142857)) __PYX_ERR(0, 316, __pyx_L1_error);

  
  __pyx_t_220 = PyList_New(3); if (unlikely(!__pyx_t_220)) __PYX_ERR(0, 317, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_220);
  __Pyx_INCREF(__pyx_float_0_4871238095);
  __Pyx_GIVEREF(__pyx_float_0_4871238095);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_220, 0, __pyx_float_0_4871238095)) __PYX_ERR(0, 317, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7490619048);
  __Pyx_GIVEREF(__pyx_float_0_7490619048);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_220, 1, __pyx_float_0_7490619048)) __PYX_ERR(0, 317, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4839761905);
  __Pyx_GIVEREF(__pyx_float_0_4839761905);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_220, 2, __pyx_float_0_4839761905)) __PYX_ERR(0, 317, __pyx_L1_error);

  
  __pyx_t_219 = PyList_New(3); if (unlikely(!__pyx_t_219)) __PYX_ERR(0, 318, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_219);
  __Pyx_INCREF(__pyx_float_0_5300285714);
  __Pyx_GIVEREF(__pyx_float_0_5300285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_219, 0, __pyx_float_0_5300285714)) __PYX_ERR(0, 318, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7491142857);
  __Pyx_GIVEREF(__pyx_float_0_7491142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_219, 1, __pyx_float_0_7491142857)) __PYX_ERR(0, 318, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4661142857);
  __Pyx_GIVEREF(__pyx_float_0_4661142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_219, 2, __pyx_float_0_4661142857)) __PYX_ERR(0, 318, __pyx_L1_error);

  
  __pyx_t_218 = PyList_New(3); if (unlikely(!__pyx_t_218)) __PYX_ERR(0, 319, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_218);
  __Pyx_INCREF(__pyx_float_0_5708571429);
  __Pyx_GIVEREF(__pyx_float_0_5708571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_218, 0, __pyx_float_0_5708571429)) __PYX_ERR(0, 319, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7485190476);
  __Pyx_GIVEREF(__pyx_float_0_7485190476);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_218, 1, __pyx_float_0_7485190476)) __PYX_ERR(0, 319, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4493904762);
  __Pyx_GIVEREF(__pyx_float_0_4493904762);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_218, 2, __pyx_float_0_4493904762)) __PYX_ERR(0, 319, __pyx_L1_error);

  
  __pyx_t_217 = PyList_New(3); if (unlikely(!__pyx_t_217)) __PYX_ERR(0, 320, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_217);
  __Pyx_INCREF(__pyx_float_0_609852381);
  __Pyx_GIVEREF(__pyx_float_0_609852381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_217, 0, __pyx_float_0_609852381)) __PYX_ERR(0, 320, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7473142857);
  __Pyx_GIVEREF(__pyx_float_0_7473142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_217, 1, __pyx_float_0_7473142857)) __PYX_ERR(0, 320, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4336857143);
  __Pyx_GIVEREF(__pyx_float_0_4336857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_217, 2, __pyx_float_0_4336857143)) __PYX_ERR(0, 320, __pyx_L1_error);

  
  __pyx_t_216 = PyList_New(3); if (unlikely(!__pyx_t_216)) __PYX_ERR(0, 321, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_216);
  __Pyx_INCREF(__pyx_float_0_6473);
  __Pyx_GIVEREF(__pyx_float_0_6473);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_216, 0, __pyx_float_0_6473)) __PYX_ERR(0, 321, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7456);
  __Pyx_GIVEREF(__pyx_float_0_7456);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_216, 1, __pyx_float_0_7456)) __PYX_ERR(0, 321, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4188);
  __Pyx_GIVEREF(__pyx_float_0_4188);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_216, 2, __pyx_float_0_4188)) __PYX_ERR(0, 321, __pyx_L1_error);

  
  __pyx_t_215 = PyList_New(3); if (unlikely(!__pyx_t_215)) __PYX_ERR(0, 322, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_215);
  __Pyx_INCREF(__pyx_float_0_6834190476);
  __Pyx_GIVEREF(__pyx_float_0_6834190476);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_215, 0, __pyx_float_0_6834190476)) __PYX_ERR(0, 322, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7434761905);
  __Pyx_GIVEREF(__pyx_float_0_7434761905);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_215, 1, __pyx_float_0_7434761905)) __PYX_ERR(0, 322, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_4044333333);
  __Pyx_GIVEREF(__pyx_float_0_4044333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_215, 2, __pyx_float_0_4044333333)) __PYX_ERR(0, 322, __pyx_L1_error);

  
  __pyx_t_214 = PyList_New(3); if (unlikely(!__pyx_t_214)) __PYX_ERR(0, 323, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_214);
  __Pyx_INCREF(__pyx_float_0_7184095238);
  __Pyx_GIVEREF(__pyx_float_0_7184095238);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_214, 0, __pyx_float_0_7184095238)) __PYX_ERR(0, 323, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7411333333);
  __Pyx_GIVEREF(__pyx_float_0_7411333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_214, 1, __pyx_float_0_7411333333)) __PYX_ERR(0, 323, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3904761905);
  __Pyx_GIVEREF(__pyx_float_0_3904761905);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_214, 2, __pyx_float_0_3904761905)) __PYX_ERR(0, 323, __pyx_L1_error);

  
  __pyx_t_213 = PyList_New(3); if (unlikely(!__pyx_t_213)) __PYX_ERR(0, 324, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_213);
  __Pyx_INCREF(__pyx_float_0_7524857143);
  __Pyx_GIVEREF(__pyx_float_0_7524857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_213, 0, __pyx_float_0_7524857143)) __PYX_ERR(0, 324, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7384);
  __Pyx_GIVEREF(__pyx_float_0_7384);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_213, 1, __pyx_float_0_7384)) __PYX_ERR(0, 324, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3768142857);
  __Pyx_GIVEREF(__pyx_float_0_3768142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_213, 2, __pyx_float_0_3768142857)) __PYX_ERR(0, 324, __pyx_L1_error);

  
  __pyx_t_212 = PyList_New(3); if (unlikely(!__pyx_t_212)) __PYX_ERR(0, 325, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_212);
  __Pyx_INCREF(__pyx_float_0_7858428571);
  __Pyx_GIVEREF(__pyx_float_0_7858428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_212, 0, __pyx_float_0_7858428571)) __PYX_ERR(0, 325, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7355666667);
  __Pyx_GIVEREF(__pyx_float_0_7355666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_212, 1, __pyx_float_0_7355666667)) __PYX_ERR(0, 325, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3632714286);
  __Pyx_GIVEREF(__pyx_float_0_3632714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_212, 2, __pyx_float_0_3632714286)) __PYX_ERR(0, 325, __pyx_L1_error);

  
  __pyx_t_211 = PyList_New(3); if (unlikely(!__pyx_t_211)) __PYX_ERR(0, 326, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_211);
  __Pyx_INCREF(__pyx_float_0_8185047619);
  __Pyx_GIVEREF(__pyx_float_0_8185047619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_211, 0, __pyx_float_0_8185047619)) __PYX_ERR(0, 326, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7327333333);
  __Pyx_GIVEREF(__pyx_float_0_7327333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_211, 1, __pyx_float_0_7327333333)) __PYX_ERR(0, 326, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3497904762);
  __Pyx_GIVEREF(__pyx_float_0_3497904762);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_211, 2, __pyx_float_0_3497904762)) __PYX_ERR(0, 326, __pyx_L1_error);

  
  __pyx_t_210 = PyList_New(3); if (unlikely(!__pyx_t_210)) __PYX_ERR(0, 327, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_210);
  __Pyx_INCREF(__pyx_float_0_8506571429);
  __Pyx_GIVEREF(__pyx_float_0_8506571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_210, 0, __pyx_float_0_8506571429)) __PYX_ERR(0, 327, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7299);
  __Pyx_GIVEREF(__pyx_float_0_7299);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_210, 1, __pyx_float_0_7299)) __PYX_ERR(0, 327, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3360285714);
  __Pyx_GIVEREF(__pyx_float_0_3360285714);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_210, 2, __pyx_float_0_3360285714)) __PYX_ERR(0, 327, __pyx_L1_error);

  
  __pyx_t_209 = PyList_New(3); if (unlikely(!__pyx_t_209)) __PYX_ERR(0, 328, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_209);
  __Pyx_INCREF(__pyx_float_0_8824333333);
  __Pyx_GIVEREF(__pyx_float_0_8824333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_209, 0, __pyx_float_0_8824333333)) __PYX_ERR(0, 328, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7274333333);
  __Pyx_GIVEREF(__pyx_float_0_7274333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_209, 1, __pyx_float_0_7274333333)) __PYX_ERR(0, 328, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3217);
  __Pyx_GIVEREF(__pyx_float_0_3217);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_209, 2, __pyx_float_0_3217)) __PYX_ERR(0, 328, __pyx_L1_error);

  
  __pyx_t_208 = PyList_New(3); if (unlikely(!__pyx_t_208)) __PYX_ERR(0, 329, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_208);
  __Pyx_INCREF(__pyx_float_0_9139333333);
  __Pyx_GIVEREF(__pyx_float_0_9139333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_208, 0, __pyx_float_0_9139333333)) __PYX_ERR(0, 329, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7257857143);
  __Pyx_GIVEREF(__pyx_float_0_7257857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_208, 1, __pyx_float_0_7257857143)) __PYX_ERR(0, 329, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_3062761905);
  __Pyx_GIVEREF(__pyx_float_0_3062761905);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_208, 2, __pyx_float_0_3062761905)) __PYX_ERR(0, 329, __pyx_L1_error);

  
  __pyx_t_207 = PyList_New(3); if (unlikely(!__pyx_t_207)) __PYX_ERR(0, 330, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_207);
  __Pyx_INCREF(__pyx_float_0_9449571429);
  __Pyx_GIVEREF(__pyx_float_0_9449571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_207, 0, __pyx_float_0_9449571429)) __PYX_ERR(0, 330, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7261142857);
  __Pyx_GIVEREF(__pyx_float_0_7261142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_207, 1, __pyx_float_0_7261142857)) __PYX_ERR(0, 330, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_2886428571);
  __Pyx_GIVEREF(__pyx_float_0_2886428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_207, 2, __pyx_float_0_2886428571)) __PYX_ERR(0, 330, __pyx_L1_error);

  
  __pyx_t_206 = PyList_New(3); if (unlikely(!__pyx_t_206)) __PYX_ERR(0, 331, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_206);
  __Pyx_INCREF(__pyx_float_0_9738952381);
  __Pyx_GIVEREF(__pyx_float_0_9738952381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_206, 0, __pyx_float_0_9738952381)) __PYX_ERR(0, 331, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7313952381);
  __Pyx_GIVEREF(__pyx_float_0_7313952381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_206, 1, __pyx_float_0_7313952381)) __PYX_ERR(0, 331, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_266647619);
  __Pyx_GIVEREF(__pyx_float_0_266647619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_206, 2, __pyx_float_0_266647619)) __PYX_ERR(0, 331, __pyx_L1_error);

  
  __pyx_t_205 = PyList_New(3); if (unlikely(!__pyx_t_205)) __PYX_ERR(0, 332, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_205);
  __Pyx_INCREF(__pyx_float_0_9937714286);
  __Pyx_GIVEREF(__pyx_float_0_9937714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_205, 0, __pyx_float_0_9937714286)) __PYX_ERR(0, 332, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7454571429);
  __Pyx_GIVEREF(__pyx_float_0_7454571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_205, 1, __pyx_float_0_7454571429)) __PYX_ERR(0, 332, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_240347619);
  __Pyx_GIVEREF(__pyx_float_0_240347619);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_205, 2, __pyx_float_0_240347619)) __PYX_ERR(0, 332, __pyx_L1_error);

  
  __pyx_t_204 = PyList_New(3); if (unlikely(!__pyx_t_204)) __PYX_ERR(0, 333, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_204);
  __Pyx_INCREF(__pyx_float_0_9990428571);
  __Pyx_GIVEREF(__pyx_float_0_9990428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_204, 0, __pyx_float_0_9990428571)) __PYX_ERR(0, 333, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7653142857);
  __Pyx_GIVEREF(__pyx_float_0_7653142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_204, 1, __pyx_float_0_7653142857)) __PYX_ERR(0, 333, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_2164142857);
  __Pyx_GIVEREF(__pyx_float_0_2164142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_204, 2, __pyx_float_0_2164142857)) __PYX_ERR(0, 333, __pyx_L1_error);

  
  __pyx_t_203 = PyList_New(3); if (unlikely(!__pyx_t_203)) __PYX_ERR(0, 334, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_203);
  __Pyx_INCREF(__pyx_float_0_9955333333);
  __Pyx_GIVEREF(__pyx_float_0_9955333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_203, 0, __pyx_float_0_9955333333)) __PYX_ERR(0, 334, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_7860571429);
  __Pyx_GIVEREF(__pyx_float_0_7860571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_203, 1, __pyx_float_0_7860571429)) __PYX_ERR(0, 334, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_196652381);
  __Pyx_GIVEREF(__pyx_float_0_196652381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_203, 2, __pyx_float_0_196652381)) __PYX_ERR(0, 334, __pyx_L1_error);

  
  __pyx_t_202 = PyList_New(3); if (unlikely(!__pyx_t_202)) __PYX_ERR(0, 335, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_202);
  __Pyx_INCREF(__pyx_float_0_988);
  __Pyx_GIVEREF(__pyx_float_0_988);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_202, 0, __pyx_float_0_988)) __PYX_ERR(0, 335, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8066);
  __Pyx_GIVEREF(__pyx_float_0_8066);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_202, 1, __pyx_float_0_8066)) __PYX_ERR(0, 335, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_1793666667);
  __Pyx_GIVEREF(__pyx_float_0_1793666667);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_202, 2, __pyx_float_0_1793666667)) __PYX_ERR(0, 335, __pyx_L1_error);

  
  __pyx_t_201 = PyList_New(3); if (unlikely(!__pyx_t_201)) __PYX_ERR(0, 336, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_201);
  __Pyx_INCREF(__pyx_float_0_9788571429);
  __Pyx_GIVEREF(__pyx_float_0_9788571429);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_201, 0, __pyx_float_0_9788571429)) __PYX_ERR(0, 336, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8271428571);
  __Pyx_GIVEREF(__pyx_float_0_8271428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_201, 1, __pyx_float_0_8271428571)) __PYX_ERR(0, 336, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_1633142857);
  __Pyx_GIVEREF(__pyx_float_0_1633142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_201, 2, __pyx_float_0_1633142857)) __PYX_ERR(0, 336, __pyx_L1_error);

  
  __pyx_t_200 = PyList_New(3); if (unlikely(!__pyx_t_200)) __PYX_ERR(0, 337, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_200);
  __Pyx_INCREF(__pyx_float_0_9697);
  __Pyx_GIVEREF(__pyx_float_0_9697);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_200, 0, __pyx_float_0_9697)) __PYX_ERR(0, 337, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8481380952);
  __Pyx_GIVEREF(__pyx_float_0_8481380952);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_200, 1, __pyx_float_0_8481380952)) __PYX_ERR(0, 337, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_147452381);
  __Pyx_GIVEREF(__pyx_float_0_147452381);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_200, 2, __pyx_float_0_147452381)) __PYX_ERR(0, 337, __pyx_L1_error);

  
  __pyx_t_199 = PyList_New(3); if (unlikely(!__pyx_t_199)) __PYX_ERR(0, 338, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_199);
  __Pyx_INCREF(__pyx_float_0_9625857143);
  __Pyx_GIVEREF(__pyx_float_0_9625857143);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_199, 0, __pyx_float_0_9625857143)) __PYX_ERR(0, 338, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8705142857);
  __Pyx_GIVEREF(__pyx_float_0_8705142857);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_199, 1, __pyx_float_0_8705142857)) __PYX_ERR(0, 338, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_1309);
  __Pyx_GIVEREF(__pyx_float_0_1309);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_199, 2, __pyx_float_0_1309)) __PYX_ERR(0, 338, __pyx_L1_error);

  
  __pyx_t_198 = PyList_New(3); if (unlikely(!__pyx_t_198)) __PYX_ERR(0, 339, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_198);
  __Pyx_INCREF(__pyx_float_0_9588714286);
  __Pyx_GIVEREF(__pyx_float_0_9588714286);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_198, 0, __pyx_float_0_9588714286)) __PYX_ERR(0, 339, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_8949);
  __Pyx_GIVEREF(__pyx_float_0_8949);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_198, 1, __pyx_float_0_8949)) __PYX_ERR(0, 339, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_1132428571);
  __Pyx_GIVEREF(__pyx_float_0_1132428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_198, 2, __pyx_float_0_1132428571)) __PYX_ERR(0, 339, __pyx_L1_error);

  
  __pyx_t_197 = PyList_New(3); if (unlikely(!__pyx_t_197)) __PYX_ERR(0, 340, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_197);
  __Pyx_INCREF(__pyx_float_0_9598238095);
  __Pyx_GIVEREF(__pyx_float_0_9598238095);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_197, 0, __pyx_float_0_9598238095)) __PYX_ERR(0, 340, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_9218333333);
  __Pyx_GIVEREF(__pyx_float_0_9218333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_197, 1, __pyx_float_0_9218333333)) __PYX_ERR(0, 340, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_0948380952);
  __Pyx_GIVEREF(__pyx_float_0_0948380952);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_197, 2, __pyx_float_0_0948380952)) __PYX_ERR(0, 340, __pyx_L1_error);

  
  __pyx_t_196 = PyList_New(3); if (unlikely(!__pyx_t_196)) __PYX_ERR(0, 341, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_196);
  __Pyx_INCREF(__pyx_float_0_9661);
  __Pyx_GIVEREF(__pyx_float_0_9661);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_196, 0, __pyx_float_0_9661)) __PYX_ERR(0, 341, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_9514428571);
  __Pyx_GIVEREF(__pyx_float_0_9514428571);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_196, 1, __pyx_float_0_9514428571)) __PYX_ERR(0, 341, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_0755333333);
  __Pyx_GIVEREF(__pyx_float_0_0755333333);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_196, 2, __pyx_float_0_0755333333)) __PYX_ERR(0, 341, __pyx_L1_error);

  
  __pyx_t_195 = PyList_New(3); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 342, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  __Pyx_INCREF(__pyx_float_0_9763);
  __Pyx_GIVEREF(__pyx_float_0_9763);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_195, 0, __pyx_float_0_9763)) __PYX_ERR(0, 342, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_9831);
  __Pyx_GIVEREF(__pyx_float_0_9831);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_195, 1, __pyx_float_0_9831)) __PYX_ERR(0, 342, __pyx_L1_error);
  __Pyx_INCREF(__pyx_float_0_0538);
  __Pyx_GIVEREF(__pyx_float_0_0538);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_195, 2, __pyx_float_0_0538)) __PYX_ERR(0, 342, __pyx_L1_error);

  
  __pyx_t_194 = PyList_New(64); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 279, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_194);
  __Pyx_GIVEREF(__pyx_t_258);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 0, __pyx_t_258)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_257);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 1, __pyx_t_257)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_256);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 2, __pyx_t_256)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_255);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 3, __pyx_t_255)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_254);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 4, __pyx_t_254)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_253);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 5, __pyx_t_253)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_252);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 6, __pyx_t_252)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_251);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 7, __pyx_t_251)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_250);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 8, __pyx_t_250)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_249);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 9, __pyx_t_249)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_248);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 10, __pyx_t_248)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_247);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 11, __pyx_t_247)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_246);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 12, __pyx_t_246)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_245);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 13, __pyx_t_245)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_244);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 14, __pyx_t_244)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_243);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 15, __pyx_t_243)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_242);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 16, __pyx_t_242)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_241);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 17, __pyx_t_241)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_240);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 18, __pyx_t_240)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_239);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 19, __pyx_t_239)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_238);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 20, __pyx_t_238)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_237);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 21, __pyx_t_237)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_236);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 22, __pyx_t_236)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_235);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 23, __pyx_t_235)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_234);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 24, __pyx_t_234)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_233);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 25, __pyx_t_233)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_232);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 26, __pyx_t_232)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_231);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 27, __pyx_t_231)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_230);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 28, __pyx_t_230)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_229);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 29, __pyx_t_229)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_228);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 30, __pyx_t_228)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_227);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 31, __pyx_t_227)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_226);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 32, __pyx_t_226)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_225);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 33, __pyx_t_225)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_224);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 34, __pyx_t_224)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_223);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 35, __pyx_t_223)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_222);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 36, __pyx_t_222)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_221);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 37, __pyx_t_221)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_220);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 38, __pyx_t_220)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_219);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 39, __pyx_t_219)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_218);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 40, __pyx_t_218)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_217);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 41, __pyx_t_217)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_216);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 42, __pyx_t_216)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_215);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 43, __pyx_t_215)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_214);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 44, __pyx_t_214)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_213);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 45, __pyx_t_213)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_212);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 46, __pyx_t_212)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_211);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 47, __pyx_t_211)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_210);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 48, __pyx_t_210)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_209);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 49, __pyx_t_209)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_208);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 50, __pyx_t_208)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_207);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 51, __pyx_t_207)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_206);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 52, __pyx_t_206)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_205);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 53, __pyx_t_205)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_204);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 54, __pyx_t_204)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_203);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 55, __pyx_t_203)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_202);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 56, __pyx_t_202)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_201);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 57, __pyx_t_201)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_200);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 58, __pyx_t_200)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_199);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 59, __pyx_t_199)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_198);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 60, __pyx_t_198)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_197);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 61, __pyx_t_197)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_196);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 62, __pyx_t_196)) __PYX_ERR(0, 279, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_195);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 63, __pyx_t_195)) __PYX_ERR(0, 279, __pyx_L1_error);
  __pyx_t_258 = 0;
  __pyx_t_257 = 0;
  __pyx_t_256 = 0;
  __pyx_t_255 = 0;
  __pyx_t_254 = 0;
  __pyx_t_253 = 0;
  __pyx_t_252 = 0;
  __pyx_t_251 = 0;
  __pyx_t_250 = 0;
  __pyx_t_249 = 0;
  __pyx_t_248 = 0;
  __pyx_t_247 = 0;
  __pyx_t_246 = 0;
  __pyx_t_245 = 0;
  __pyx_t_244 = 0;
  __pyx_t_243 = 0;
  __pyx_t_242 = 0;
  __pyx_t_241 = 0;
  __pyx_t_240 = 0;
  __pyx_t_239 = 0;
  __pyx_t_238 = 0;
  __pyx_t_237 = 0;
  __pyx_t_236 = 0;
  __pyx_t_235 = 0;
  __pyx_t_234 = 0;
  __pyx_t_233 = 0;
  __pyx_t_232 = 0;
  __pyx_t_231 = 0;
  __pyx_t_230 = 0;
  __pyx_t_229 = 0;
  __pyx_t_228 = 0;
  __pyx_t_227 = 0;
  __pyx_t_226 = 0;
  __pyx_t_225 = 0;
  __pyx_t_224 = 0;
  __pyx_t_223 = 0;
  __pyx_t_222 = 0;
  __pyx_t_221 = 0;
  __pyx_t_220 = 0;
  __pyx_t_219 = 0;
  __pyx_t_218 = 0;
  __pyx_t_217 = 0;
  __pyx_t_216 = 0;
  __pyx_t_215 = 0;
  __pyx_t_214 = 0;
  __pyx_t_213 = 0;
  __pyx_t_212 = 0;
  __pyx_t_211 = 0;
  __pyx_t_210 = 0;
  __pyx_t_209 = 0;
  __pyx_t_208 = 0;
  __pyx_t_207 = 0;
  __pyx_t_206 = 0;
  __pyx_t_205 = 0;
  __pyx_t_204 = 0;
  __pyx_t_203 = 0;
  __pyx_t_202 = 0;
  __pyx_t_201 = 0;
  __pyx_t_200 = 0;
  __pyx_t_199 = 0;
  __pyx_t_198 = 0;
  __pyx_t_197 = 0;
  __pyx_t_196 = 0;
  __pyx_t_195 = 0;
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_parula_data, __pyx_t_194) < 0) __PYX_ERR(0, 279, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_194); __pyx_t_194 = 0;

  
  __pyx_t_194 = PyList_New(1); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 344, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_194);
  __Pyx_INCREF(__pyx_n_s_ListedColormap);
  __Pyx_GIVEREF(__pyx_n_s_ListedColormap);
  if (__Pyx_PyList_SET_ITEM(__pyx_t_194, 0, __pyx_n_s_ListedColormap)) __PYX_ERR(0, 344, __pyx_L1_error);
  __pyx_t_195 = __Pyx_Import(__pyx_n_s_matplotlib_colors, __pyx_t_194, 0); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 344, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  __Pyx_DECREF(__pyx_t_194); __pyx_t_194 = 0;
  __pyx_t_194 = __Pyx_ImportFrom(__pyx_t_195, __pyx_n_s_ListedColormap); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 344, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_194);
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_ListedColormap, __pyx_t_194) < 0) __PYX_ERR(0, 344, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_194); __pyx_t_194 = 0;
  __Pyx_DECREF(__pyx_t_195); __pyx_t_195 = 0;

  
  __pyx_t_195 = __Pyx_PyDict_NewPresized(0); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 346, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_cmaps, __pyx_t_195) < 0) __PYX_ERR(0, 346, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_195); __pyx_t_195 = 0;

  
  __Pyx_GetModuleGlobalName(__pyx_t_195, __pyx_n_s_viridis_data); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 347, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  __pyx_t_194 = PyTuple_New(2); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 347, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_194);
  __Pyx_INCREF(__pyx_n_u_viridis);
  __Pyx_GIVEREF(__pyx_n_u_viridis);
  if (__Pyx_PyTuple_SET_ITEM(__pyx_t_194, 0, __pyx_n_u_viridis)) __PYX_ERR(0, 347, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_195);
  if (__Pyx_PyTuple_SET_ITEM(__pyx_t_194, 1, __pyx_t_195)) __PYX_ERR(0, 347, __pyx_L1_error);
  __pyx_t_195 = 0;

  
  __Pyx_GetModuleGlobalName(__pyx_t_195, __pyx_n_s_parula_data); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 348, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  __pyx_t_196 = PyTuple_New(2); if (unlikely(!__pyx_t_196)) __PYX_ERR(0, 348, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_196);
  __Pyx_INCREF(__pyx_n_u_parula);
  __Pyx_GIVEREF(__pyx_n_u_parula);
  if (__Pyx_PyTuple_SET_ITEM(__pyx_t_196, 0, __pyx_n_u_parula)) __PYX_ERR(0, 348, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_195);
  if (__Pyx_PyTuple_SET_ITEM(__pyx_t_196, 1, __pyx_t_195)) __PYX_ERR(0, 348, __pyx_L1_error);
  __pyx_t_195 = 0;

  
  __pyx_t_195 = PyTuple_New(2); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 347, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_195);
  __Pyx_GIVEREF(__pyx_t_194);
  if (__Pyx_PyTuple_SET_ITEM(__pyx_t_195, 0, __pyx_t_194)) __PYX_ERR(0, 347, __pyx_L1_error);
  __Pyx_GIVEREF(__pyx_t_196);
  if (__Pyx_PyTuple_SET_ITEM(__pyx_t_195, 1, __pyx_t_196)) __PYX_ERR(0, 347, __pyx_L1_error);
  __pyx_t_194 = 0;
  __pyx_t_196 = 0;
  __pyx_t_196 = __pyx_t_195; __Pyx_INCREF(__pyx_t_196);
  __pyx_t_259 = 0;
  __Pyx_DECREF(__pyx_t_195); __pyx_t_195 = 0;
  for (;;) {
    if (__pyx_t_259 >= 2) break;
    #if CYTHON_ASSUME_SAFE_MACROS && !CYTHON_AVOID_BORROWED_REFS
    __pyx_t_195 = PyTuple_GET_ITEM(__pyx_t_196, __pyx_t_259); __Pyx_INCREF(__pyx_t_195); __pyx_t_259++; if (unlikely((0 < 0))) __PYX_ERR(0, 347, __pyx_L1_error)
    #else
    __pyx_t_195 = __Pyx_PySequence_ITEM(__pyx_t_196, __pyx_t_259); __pyx_t_259++; if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 347, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_195);
    #endif
    if (likely(__pyx_t_195 != Py_None)) {
      PyObject* sequence = __pyx_t_195;
      Py_ssize_t size = __Pyx_PySequence_SIZE(sequence);
      if (unlikely(size != 2)) {
        if (size > 2) __Pyx_RaiseTooManyValuesError(2);
        else if (size >= 0) __Pyx_RaiseNeedMoreValuesError(size);
        __PYX_ERR(0, 347, __pyx_L1_error)
      }
      #if CYTHON_ASSUME_SAFE_MACROS && !CYTHON_AVOID_BORROWED_REFS
      __pyx_t_194 = PyTuple_GET_ITEM(sequence, 0); 
      __pyx_t_197 = PyTuple_GET_ITEM(sequence, 1); 
      __Pyx_INCREF(__pyx_t_194);
      __Pyx_INCREF(__pyx_t_197);
      #else
      __pyx_t_194 = PySequence_ITEM(sequence, 0); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 347, __pyx_L1_error)
      __Pyx_GOTREF(__pyx_t_194);
      __pyx_t_197 = PySequence_ITEM(sequence, 1); if (unlikely(!__pyx_t_197)) __PYX_ERR(0, 347, __pyx_L1_error)
      __Pyx_GOTREF(__pyx_t_197);
      #endif
      __Pyx_DECREF(__pyx_t_195); __pyx_t_195 = 0;
    } else {
      __Pyx_RaiseNoneNotIterableError(); __PYX_ERR(0, 347, __pyx_L1_error)
    }
    if (PyDict_SetItem(__pyx_d, __pyx_n_s_name_2, __pyx_t_194) < 0) __PYX_ERR(0, 347, __pyx_L1_error)
    __Pyx_DECREF(__pyx_t_194); __pyx_t_194 = 0;
    if (PyDict_SetItem(__pyx_d, __pyx_n_s_data, __pyx_t_197) < 0) __PYX_ERR(0, 347, __pyx_L1_error)
    __Pyx_DECREF(__pyx_t_197); __pyx_t_197 = 0;

    
    __Pyx_GetModuleGlobalName(__pyx_t_195, __pyx_n_s_ListedColormap); if (unlikely(!__pyx_t_195)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_195);
    __Pyx_GetModuleGlobalName(__pyx_t_197, __pyx_n_s_data); if (unlikely(!__pyx_t_197)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_197);
    __pyx_t_194 = PyTuple_New(1); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_194);
    __Pyx_GIVEREF(__pyx_t_197);
    if (__Pyx_PyTuple_SET_ITEM(__pyx_t_194, 0, __pyx_t_197)) __PYX_ERR(0, 350, __pyx_L1_error);
    __pyx_t_197 = 0;
    __pyx_t_197 = __Pyx_PyDict_NewPresized(1); if (unlikely(!__pyx_t_197)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_197);
    __Pyx_GetModuleGlobalName(__pyx_t_198, __pyx_n_s_name_2); if (unlikely(!__pyx_t_198)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_198);
    if (PyDict_SetItem(__pyx_t_197, __pyx_n_s_name_2, __pyx_t_198) < 0) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_DECREF(__pyx_t_198); __pyx_t_198 = 0;
    __pyx_t_198 = __Pyx_PyObject_Call(__pyx_t_195, __pyx_t_194, __pyx_t_197); if (unlikely(!__pyx_t_198)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_198);
    __Pyx_DECREF(__pyx_t_195); __pyx_t_195 = 0;
    __Pyx_DECREF(__pyx_t_194); __pyx_t_194 = 0;
    __Pyx_DECREF(__pyx_t_197); __pyx_t_197 = 0;
    __Pyx_GetModuleGlobalName(__pyx_t_197, __pyx_n_s_cmaps); if (unlikely(!__pyx_t_197)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_197);
    __Pyx_GetModuleGlobalName(__pyx_t_194, __pyx_n_s_name_2); if (unlikely(!__pyx_t_194)) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_GOTREF(__pyx_t_194);
    if (unlikely((PyObject_SetItem(__pyx_t_197, __pyx_t_194, __pyx_t_198) < 0))) __PYX_ERR(0, 350, __pyx_L1_error)
    __Pyx_DECREF(__pyx_t_197); __pyx_t_197 = 0;
    __Pyx_DECREF(__pyx_t_194); __pyx_t_194 = 0;
    __Pyx_DECREF(__pyx_t_198); __pyx_t_198 = 0;

    
  }
  __Pyx_DECREF(__pyx_t_196); __pyx_t_196 = 0;

  
  __Pyx_GetModuleGlobalName(__pyx_t_196, __pyx_n_s_cmaps); if (unlikely(!__pyx_t_196)) __PYX_ERR(0, 352, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_196);
  __pyx_t_198 = __Pyx_PyObject_Dict_GetItem(__pyx_t_196, __pyx_n_u_viridis); if (unlikely(!__pyx_t_198)) __PYX_ERR(0, 352, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_198);
  __Pyx_DECREF(__pyx_t_196); __pyx_t_196 = 0;
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_viridis, __pyx_t_198) < 0) __PYX_ERR(0, 352, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_198); __pyx_t_198 = 0;

  
  __Pyx_GetModuleGlobalName(__pyx_t_198, __pyx_n_s_cmaps); if (unlikely(!__pyx_t_198)) __PYX_ERR(0, 353, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_198);
  __pyx_t_196 = __Pyx_PyObject_Dict_GetItem(__pyx_t_198, __pyx_n_u_parula); if (unlikely(!__pyx_t_196)) __PYX_ERR(0, 353, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_196);
  __Pyx_DECREF(__pyx_t_198); __pyx_t_198 = 0;
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_parula, __pyx_t_196) < 0) __PYX_ERR(0, 353, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_196); __pyx_t_196 = 0;

  
  __pyx_t_196 = __Pyx_PyDict_NewPresized(0); if (unlikely(!__pyx_t_196)) __PYX_ERR(0, 1, __pyx_L1_error)
  __Pyx_GOTREF(__pyx_t_196);
  if (PyDict_SetItem(__pyx_d, __pyx_n_s_test, __pyx_t_196) < 0) __PYX_ERR(0, 1, __pyx_L1_error)
  __Pyx_DECREF(__pyx_t_196); __pyx_t_196 = 0;

  

  goto __pyx_L0;
  __pyx_L1_error:;
  __Pyx_XDECREF(__pyx_t_2);
  __Pyx_XDECREF(__pyx_t_3);
  __Pyx_XDECREF(__pyx_t_4);
  __Pyx_XDECREF(__pyx_t_5);
  __Pyx_XDECREF(__pyx_t_6);
  __Pyx_XDECREF(__pyx_t_7);
  __Pyx_XDECREF(__pyx_t_8);
  __Pyx_XDECREF(__pyx_t_9);
  __Pyx_XDECREF(__pyx_t_10);
  __Pyx_XDECREF(__pyx_t_11);
  __Pyx_XDECREF(__pyx_t_12);
  __Pyx_XDECREF(__pyx_t_13);
  __Pyx_XDECREF(__pyx_t_14);
  __Pyx_XDECREF(__pyx_t_15);
  __Pyx_XDECREF(__pyx_t_16);
  __Pyx_XDECREF(__pyx_t_17);
  __Pyx_XDECREF(__pyx_t_18);
  __Pyx_XDECREF(__pyx_t_19);
  __Pyx_XDECREF(__pyx_t_20);
  __Pyx_XDECREF(__pyx_t_21);
  __Pyx_XDECREF(__pyx_t_22);
  __Pyx_XDECREF(__pyx_t_23);
  __Pyx_XDECREF(__pyx_t_24);
  __Pyx_XDECREF(__pyx_t_25);
  __Pyx_XDECREF(__pyx_t_26);
  __Pyx_XDECREF(__pyx_t_27);
  __Pyx_XDECREF(__pyx_t_28);
  __Pyx_XDECREF(__pyx_t_29);
  __Pyx_XDECREF(__pyx_t_30);
  __Pyx_XDECREF(__pyx_t_31);
  __Pyx_XDECREF(__pyx_t_32);
  __Pyx_XDECREF(__pyx_t_33);
  __Pyx_XDECREF(__pyx_t_34);
  __Pyx_XDECREF(__pyx_t_35);
  __Pyx_XDECREF(__pyx_t_36);
  __Pyx_XDECREF(__pyx_t_37);
  __Pyx_XDECREF(__pyx_t_38);
  __Pyx_XDECREF(__pyx_t_39);
  __Pyx_XDECREF(__pyx_t_40);
  __Pyx_XDECREF(__pyx_t_41);
  __Pyx_XDECREF(__pyx_t_42);
  __Pyx_XDECREF(__pyx_t_43);
  __Pyx_XDECREF(__pyx_t_44);
  __Pyx_XDECREF(__pyx_t_45);
  __Pyx_XDECREF(__pyx_t_46);
  __Pyx_XDECREF(__pyx_t_47);
  __Pyx_XDECREF(__pyx_t_48);
  __Pyx_XDECREF(__pyx_t_49);
  __Pyx_XDECREF(__pyx_t_50);
  __Pyx_XDECREF(__pyx_t_51);
  __Pyx_XDECREF(__pyx_t_52);
  __Pyx_XDECREF(__pyx_t_53);
  __Pyx_XDECREF(__pyx_t_54);
  __Pyx_XDECREF(__pyx_t_55);
  __Pyx_XDECREF(__pyx_t_56);
  __Pyx_XDECREF(__pyx_t_57);
  __Pyx_XDECREF(__pyx_t_58);
  __Pyx_XDECREF(__pyx_t_59);
  __Pyx_XDECREF(__pyx_t_60);
  __Pyx_XDECREF(__pyx_t_61);
  __Pyx_XDECREF(__pyx_t_62);
  __Pyx_XDECREF(__pyx_t_63);
  __Pyx_XDECREF(__pyx_t_64);
  __Pyx_XDECREF(__pyx_t_65);
  __Pyx_XDECREF(__pyx_t_66);
  __Pyx_XDECREF(__pyx_t_67);
  __Pyx_XDECREF(__pyx_t_68);
  __Pyx_XDECREF(__pyx_t_69);
  __Pyx_XDECREF(__pyx_t_70);
  __Pyx_XDECREF(__pyx_t_71);
  __Pyx_XDECREF(__pyx_t_72);
  __Pyx_XDECREF(__pyx_t_73);
  __Pyx_XDECREF(__pyx_t_74);
  __Pyx_XDECREF(__pyx_t_75);
  __Pyx_XDECREF(__pyx_t_76);
  __Pyx_XDECREF(__pyx_t_77);
  __Pyx_XDECREF(__pyx_t_78);
  __Pyx_XDECREF(__pyx_t_79);
  __Pyx_XDECREF(__pyx_t_80);
  __Pyx_XDECREF(__pyx_t_81);
  __Pyx_XDECREF(__pyx_t_82);
  __Pyx_XDECREF(__pyx_t_83);
  __Pyx_XDECREF(__pyx_t_84);
  __Pyx_XDECREF(__pyx_t_85);
  __Pyx_XDECREF(__pyx_t_86);
  __Pyx_XDECREF(__pyx_t_87);
  __Pyx_XDECREF(__pyx_t_88);
  __Pyx_XDECREF(__pyx_t_89);
  __Pyx_XDECREF(__pyx_t_90);
  __Pyx_XDECREF(__pyx_t_91);
  __Pyx_XDECREF(__pyx_t_92);
  __Pyx_XDECREF(__pyx_t_93);
  __Pyx_XDECREF(__pyx_t_94);
  __Pyx_XDECREF(__pyx_t_95);
  __Pyx_XDECREF(__pyx_t_96);
  __Pyx_XDECREF(__pyx_t_97);
  __Pyx_XDECREF(__pyx_t_98);
  __Pyx_XDECREF(__pyx_t_99);
  __Pyx_XDECREF(__pyx_t_100);
  __Pyx_XDECREF(__pyx_t_101);
  __Pyx_XDECREF(__pyx_t_102);
  __Pyx_XDECREF(__pyx_t_103);
  __Pyx_XDECREF(__pyx_t_104);
  __Pyx_XDECREF(__pyx_t_105);
  __Pyx_XDECREF(__pyx_t_106);
  __Pyx_XDECREF(__pyx_t_107);
  __Pyx_XDECREF(__pyx_t_108);
  __Pyx_XDECREF(__pyx_t_109);
  __Pyx_XDECREF(__pyx_t_110);
  __Pyx_XDECREF(__pyx_t_111);
  __Pyx_XDECREF(__pyx_t_112);
  __Pyx_XDECREF(__pyx_t_113);
  __Pyx_XDECREF(__pyx_t_114);
  __Pyx_XDECREF(__pyx_t_115);
  __Pyx_XDECREF(__pyx_t_116);
  __Pyx_XDECREF(__pyx_t_117);
  __Pyx_XDECREF(__pyx_t_118);
  __Pyx_XDECREF(__pyx_t_119);
  __Pyx_XDECREF(__pyx_t_120);
  __Pyx_XDECREF(__pyx_t_121);
  __Pyx_XDECREF(__pyx_t_122);
  __Pyx_XDECREF(__pyx_t_123);
  __Pyx_XDECREF(__pyx_t_124);
  __Pyx_XDECREF(__pyx_t_125);
  __Pyx_XDECREF(__pyx_t_126);
  __Pyx_XDECREF(__pyx_t_127);
  __Pyx_XDECREF(__pyx_t_128);
  __Pyx_XDECREF(__pyx_t_129);
  __Pyx_XDECREF(__pyx_t_130);
  __Pyx_XDECREF(__pyx_t_131);
  __Pyx_XDECREF(__pyx_t_132);
  __Pyx_XDECREF(__pyx_t_133);
  __Pyx_XDECREF(__pyx_t_134);
  __Pyx_XDECREF(__pyx_t_135);
  __Pyx_XDECREF(__pyx_t_136);
  __Pyx_XDECREF(__pyx_t_137);
  __Pyx_XDECREF(__pyx_t_138);
  __Pyx_XDECREF(__pyx_t_139);
  __Pyx_XDECREF(__pyx_t_140);
  __Pyx_XDECREF(__pyx_t_141);
  __Pyx_XDECREF(__pyx_t_142);
  __Pyx_XDECREF(__pyx_t_143);
  __Pyx_XDECREF(__pyx_t_144);
  __Pyx_XDECREF(__pyx_t_145);
  __Pyx_XDECREF(__pyx_t_146);
  __Pyx_XDECREF(__pyx_t_147);
  __Pyx_XDECREF(__pyx_t_148);
  __Pyx_XDECREF(__pyx_t_149);
  __Pyx_XDECREF(__pyx_t_150);
  __Pyx_XDECREF(__pyx_t_151);
  __Pyx_XDECREF(__pyx_t_152);
  __Pyx_XDECREF(__pyx_t_153);
  __Pyx_XDECREF(__pyx_t_154);
  __Pyx_XDECREF(__pyx_t_155);
  __Pyx_XDECREF(__pyx_t_156);
  __Pyx_XDECREF(__pyx_t_157);
  __Pyx_XDECREF(__pyx_t_158);
  __Pyx_XDECREF(__pyx_t_159);
  __Pyx_XDECREF(__pyx_t_160);
  __Pyx_XDECREF(__pyx_t_161);
  __Pyx_XDECREF(__pyx_t_162);
  __Pyx_XDECREF(__pyx_t_163);
  __Pyx_XDECREF(__pyx_t_164);
  __Pyx_XDECREF(__pyx_t_165);
  __Pyx_XDECREF(__pyx_t_166);
  __Pyx_XDECREF(__pyx_t_167);
  __Pyx_XDECREF(__pyx_t_168);
  __Pyx_XDECREF(__pyx_t_169);
  __Pyx_XDECREF(__pyx_t_170);
  __Pyx_XDECREF(__pyx_t_171);
  __Pyx_XDECREF(__pyx_t_172);
  __Pyx_XDECREF(__pyx_t_173);
  __Pyx_XDECREF(__pyx_t_174);
  __Pyx_XDECREF(__pyx_t_175);
  __Pyx_XDECREF(__pyx_t_176);
  __Pyx_XDECREF(__pyx_t_177);
  __Pyx_XDECREF(__pyx_t_178);
  __Pyx_XDECREF(__pyx_t_179);
  __Pyx_XDECREF(__pyx_t_180);
  __Pyx_XDECREF(__pyx_t_181);
  __Pyx_XDECREF(__pyx_t_182);
  __Pyx_XDECREF(__pyx_t_183);
  __Pyx_XDECREF(__pyx_t_184);
  __Pyx_XDECREF(__pyx_t_185);
  __Pyx_XDECREF(__pyx_t_186);
  __Pyx_XDECREF(__pyx_t_187);
  __Pyx_XDECREF(__pyx_t_188);
  __Pyx_XDECREF(__pyx_t_189);
  __Pyx_XDECREF(__pyx_t_190);
  __Pyx_XDECREF(__pyx_t_191);
  __Pyx_XDECREF(__pyx_t_192);
  __Pyx_XDECREF(__pyx_t_193);
  __Pyx_XDECREF(__pyx_t_194);
  __Pyx_XDECREF(__pyx_t_195);
  __Pyx_XDECREF(__pyx_t_196);
  __Pyx_XDECREF(__pyx_t_197);
  __Pyx_XDECREF(__pyx_t_198);
  __Pyx_XDECREF(__pyx_t_199);
  __Pyx_XDECREF(__pyx_t_200);
  __Pyx_XDECREF(__pyx_t_201);
  __Pyx_XDECREF(__pyx_t_202);
  __Pyx_XDECREF(__pyx_t_203);
  __Pyx_XDECREF(__pyx_t_204);
  __Pyx_XDECREF(__pyx_t_205);
  __Pyx_XDECREF(__pyx_t_206);
  __Pyx_XDECREF(__pyx_t_207);
  __Pyx_XDECREF(__pyx_t_208);
  __Pyx_XDECREF(__pyx_t_209);
  __Pyx_XDECREF(__pyx_t_210);
  __Pyx_XDECREF(__pyx_t_211);
  __Pyx_XDECREF(__pyx_t_212);
  __Pyx_XDECREF(__pyx_t_213);
  __Pyx_XDECREF(__pyx_t_214);
  __Pyx_XDECREF(__pyx_t_215);
  __Pyx_XDECREF(__pyx_t_216);
  __Pyx_XDECREF(__pyx_t_217);
  __Pyx_XDECREF(__pyx_t_218);
  __Pyx_XDECREF(__pyx_t_219);
  __Pyx_XDECREF(__pyx_t_220);
  __Pyx_XDECREF(__pyx_t_221);
  __Pyx_XDECREF(__pyx_t_222);
  __Pyx_XDECREF(__pyx_t_223);
  __Pyx_XDECREF(__pyx_t_224);
  __Pyx_XDECREF(__pyx_t_225);
  __Pyx_XDECREF(__pyx_t_226);
  __Pyx_XDECREF(__pyx_t_227);
  __Pyx_XDECREF(__pyx_t_228);
  __Pyx_XDECREF(__pyx_t_229);
  __Pyx_XDECREF(__pyx_t_230);
  __Pyx_XDECREF(__pyx_t_231);
  __Pyx_XDECREF(__pyx_t_232);
  __Pyx_XDECREF(__pyx_t_233);
  __Pyx_XDECREF(__pyx_t_234);
  __Pyx_XDECREF(__pyx_t_235);
  __Pyx_XDECREF(__pyx_t_236);
  __Pyx_XDECREF(__pyx_t_237);
  __Pyx_XDECREF(__pyx_t_238);
  __Pyx_XDECREF(__pyx_t_239);
  __Pyx_XDECREF(__pyx_t_240);
  __Pyx_XDECREF(__pyx_t_241);
  __Pyx_XDECREF(__pyx_t_242);
  __Pyx_XDECREF(__pyx_t_243);
  __Pyx_XDECREF(__pyx_t_244);
  __Pyx_XDECREF(__pyx_t_245);
  __Pyx_XDECREF(__pyx_t_246);
  __Pyx_XDECREF(__pyx_t_247);
  __Pyx_XDECREF(__pyx_t_248);
  __Pyx_XDECREF(__pyx_t_249);
  __Pyx_XDECREF(__pyx_t_250);
  __Pyx_XDECREF(__pyx_t_251);
  __Pyx_XDECREF(__pyx_t_252);
  __Pyx_XDECREF(__pyx_t_253);
  __Pyx_XDECREF(__pyx_t_254);
  __Pyx_XDECREF(__pyx_t_255);
  __Pyx_XDECREF(__pyx_t_256);
  __Pyx_XDECREF(__pyx_t_257);
  __Pyx_XDECREF(__pyx_t_258);
  if (__pyx_m) {
    if (__pyx_d && stringtab_initialized) {
      __Pyx_AddTraceback("init torchbox.utils.colormaps", __pyx_clineno, __pyx_lineno, __pyx_filename);
    }
    #if !CYTHON_USE_MODULE_STATE
    Py_CLEAR(__pyx_m);
    #else
    Py_DECREF(__pyx_m);
    if (pystate_addmodule_run) {
      PyObject *tp, *value, *tb;
      PyErr_Fetch(&tp, &value, &tb);
      PyState_RemoveModule(&__pyx_moduledef);
      PyErr_Restore(tp, value, tb);
    }
    #endif
  } else if (!PyErr_Occurred()) {
    PyErr_SetString(PyExc_ImportError, "init torchbox.utils.colormaps");
  }
  __pyx_L0:;
  __Pyx_RefNannyFinishContext();
  #if CYTHON_PEP489_MULTI_PHASE_INIT
  return (__pyx_m != NULL) ? 0 : -1;
  #elif PY_MAJOR_VERSION >= 3
  return __pyx_m;
  #else
  return;
  #endif
}




#ifdef _MSC_VER
#pragma warning( push )

#pragma warning( disable : 4127 )
#endif







#if CYTHON_REFNANNY
static __Pyx_RefNannyAPIStruct *__Pyx_RefNannyImportAPI(const char *modname) {
    PyObject *m = NULL, *p = NULL;
    void *r = NULL;
    m = PyImport_ImportModule(modname);
    if (!m) goto end;
    p = PyObject_GetAttrString(m, "RefNannyAPI");
    if (!p) goto end;
    r = PyLong_AsVoidPtr(p);
end:
    Py_XDECREF(p);
    Py_XDECREF(m);
    return (__Pyx_RefNannyAPIStruct *)r;
}
#endif


#if CYTHON_USE_TYPE_SLOTS
static CYTHON_INLINE PyObject* __Pyx_PyObject_GetAttrStr(PyObject* obj, PyObject* attr_name) {
    PyTypeObject* tp = Py_TYPE(obj);
    if (likely(tp->tp_getattro))
        return tp->tp_getattro(obj, attr_name);
#if PY_MAJOR_VERSION < 3
    if (likely(tp->tp_getattr))
        return tp->tp_getattr(obj, PyString_AS_STRING(attr_name));
#endif
    return PyObject_GetAttr(obj, attr_name);
}
#endif


static PyObject *__Pyx_Import(PyObject *name, PyObject *from_list, int level) {
    PyObject *module = 0;
    PyObject *empty_dict = 0;
    PyObject *empty_list = 0;
    #if PY_MAJOR_VERSION < 3
    PyObject *py_import;
    py_import = __Pyx_PyObject_GetAttrStr(__pyx_b, __pyx_n_s_import);
    if (unlikely(!py_import))
        goto bad;
    if (!from_list) {
        empty_list = PyList_New(0);
        if (unlikely(!empty_list))
            goto bad;
        from_list = empty_list;
    }
    #endif
    empty_dict = PyDict_New();
    if (unlikely(!empty_dict))
        goto bad;
    {
        #if PY_MAJOR_VERSION >= 3
        if (level == -1) {
            if (strchr(__Pyx_MODULE_NAME, '.') != NULL) {
                module = PyImport_ImportModuleLevelObject(
                    name, __pyx_d, empty_dict, from_list, 1);
                if (unlikely(!module)) {
                    if (unlikely(!PyErr_ExceptionMatches(PyExc_ImportError)))
                        goto bad;
                    PyErr_Clear();
                }
            }
            level = 0;
        }
        #endif
        if (!module) {
            #if PY_MAJOR_VERSION < 3
            PyObject *py_level = PyInt_FromLong(level);
            if (unlikely(!py_level))
                goto bad;
            module = PyObject_CallFunctionObjArgs(py_import,
                name, __pyx_d, empty_dict, from_list, py_level, (PyObject *)NULL);
            Py_DECREF(py_level);
            #else
            module = PyImport_ImportModuleLevelObject(
                name, __pyx_d, empty_dict, from_list, level);
            #endif
        }
    }
bad:
    Py_XDECREF(empty_dict);
    Py_XDECREF(empty_list);
    #if PY_MAJOR_VERSION < 3
    Py_XDECREF(py_import);
    #endif
    return module;
}


#if PY_MAJOR_VERSION >= 3
static PyObject *__Pyx__ImportDottedModule_Error(PyObject *name, PyObject *parts_tuple, Py_ssize_t count) {
    PyObject *partial_name = NULL, *slice = NULL, *sep = NULL;
    if (unlikely(PyErr_Occurred())) {
        PyErr_Clear();
    }
    if (likely(PyTuple_GET_SIZE(parts_tuple) == count)) {
        partial_name = name;
    } else {
        slice = PySequence_GetSlice(parts_tuple, 0, count);
        if (unlikely(!slice))
            goto bad;
        sep = PyUnicode_FromStringAndSize(".", 1);
        if (unlikely(!sep))
            goto bad;
        partial_name = PyUnicode_Join(sep, slice);
    }
    PyErr_Format(
#if PY_MAJOR_VERSION < 3
        PyExc_ImportError,
        "No module named '%s'", PyString_AS_STRING(partial_name));
#else
#if PY_VERSION_HEX >= 0x030600B1
        PyExc_ModuleNotFoundError,
#else
        PyExc_ImportError,
#endif
        "No module named '%U'", partial_name);
#endif
bad:
    Py_XDECREF(sep);
    Py_XDECREF(slice);
    Py_XDECREF(partial_name);
    return NULL;
}
#endif
#if PY_MAJOR_VERSION >= 3
static PyObject *__Pyx__ImportDottedModule_Lookup(PyObject *name) {
    PyObject *imported_module;
#if PY_VERSION_HEX < 0x030700A1 || (CYTHON_COMPILING_IN_PYPY && PYPY_VERSION_NUM  < 0x07030400)
    PyObject *modules = PyImport_GetModuleDict();
    if (unlikely(!modules))
        return NULL;
    imported_module = __Pyx_PyDict_GetItemStr(modules, name);
    Py_XINCREF(imported_module);
#else
    imported_module = PyImport_GetModule(name);
#endif
    return imported_module;
}
#endif
#if PY_MAJOR_VERSION >= 3
static PyObject *__Pyx_ImportDottedModule_WalkParts(PyObject *module, PyObject *name, PyObject *parts_tuple) {
    Py_ssize_t i, nparts;
    nparts = PyTuple_GET_SIZE(parts_tuple);
    for (i=1; i < nparts && module; i++) {
        PyObject *part, *submodule;
#if CYTHON_ASSUME_SAFE_MACROS && !CYTHON_AVOID_BORROWED_REFS
        part = PyTuple_GET_ITEM(parts_tuple, i);
#else
        part = PySequence_ITEM(parts_tuple, i);
#endif
        submodule = __Pyx_PyObject_GetAttrStrNoError(module, part);
#if !(CYTHON_ASSUME_SAFE_MACROS && !CYTHON_AVOID_BORROWED_REFS)
        Py_DECREF(part);
#endif
        Py_DECREF(module);
        module = submodule;
    }
    if (unlikely(!module)) {
        return __Pyx__ImportDottedModule_Error(name, parts_tuple, i);
    }
    return module;
}
#endif
static PyObject *__Pyx__ImportDottedModule(PyObject *name, PyObject *parts_tuple) {
#if PY_MAJOR_VERSION < 3
    PyObject *module, *from_list, *star = __pyx_n_s_;
    CYTHON_UNUSED_VAR(parts_tuple);
    from_list = PyList_New(1);
    if (unlikely(!from_list))
        return NULL;
    Py_INCREF(star);
    PyList_SET_ITEM(from_list, 0, star);
    module = __Pyx_Import(name, from_list, 0);
    Py_DECREF(from_list);
    return module;
#else
    PyObject *imported_module;
    PyObject *module = __Pyx_Import(name, NULL, 0);
    if (!parts_tuple || unlikely(!module))
        return module;
    imported_module = __Pyx__ImportDottedModule_Lookup(name);
    if (likely(imported_module)) {
        Py_DECREF(module);
        return imported_module;
    }
    PyErr_Clear();
    return __Pyx_ImportDottedModule_WalkParts(module, name, parts_tuple);
#endif
}
static PyObject *__Pyx_ImportDottedModule(PyObject *name, PyObject *parts_tuple) {
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX >= 0x030400B1
    PyObject *module = __Pyx__ImportDottedModule_Lookup(name);
    if (likely(module)) {
        PyObject *spec = __Pyx_PyObject_GetAttrStrNoError(module, __pyx_n_s_spec);
        if (likely(spec)) {
            PyObject *unsafe = __Pyx_PyObject_GetAttrStrNoError(spec, __pyx_n_s_initializing);
            if (likely(!unsafe || !__Pyx_PyObject_IsTrue(unsafe))) {
                Py_DECREF(spec);
                spec = NULL;
            }
            Py_XDECREF(unsafe);
        }
        if (likely(!spec)) {
            PyErr_Clear();
            return module;
        }
        Py_DECREF(spec);
        Py_DECREF(module);
    } else if (PyErr_Occurred()) {
        PyErr_Clear();
    }
#endif
    return __Pyx__ImportDottedModule(name, parts_tuple);
}


static PyObject* __Pyx_ImportFrom(PyObject* module, PyObject* name) {
    PyObject* value = __Pyx_PyObject_GetAttrStr(module, name);
    if (unlikely(!value) && PyErr_ExceptionMatches(PyExc_AttributeError)) {
        const char* module_name_str = 0;
        PyObject* module_name = 0;
        PyObject* module_dot = 0;
        PyObject* full_name = 0;
        PyErr_Clear();
        module_name_str = PyModule_GetName(module);
        if (unlikely(!module_name_str)) { goto modbad; }
        module_name = PyUnicode_FromString(module_name_str);
        if (unlikely(!module_name)) { goto modbad; }
        module_dot = PyUnicode_Concat(module_name, __pyx_kp_u__2);
        if (unlikely(!module_dot)) { goto modbad; }
        full_name = PyUnicode_Concat(module_dot, name);
        if (unlikely(!full_name)) { goto modbad; }
        #if PY_VERSION_HEX < 0x030700A1 || (CYTHON_COMPILING_IN_PYPY && PYPY_VERSION_NUM  < 0x07030400)
        {
            PyObject *modules = PyImport_GetModuleDict();
            if (unlikely(!modules))
                goto modbad;
            value = PyObject_GetItem(modules, full_name);
        }
        #else
        value = PyImport_GetModule(full_name);
        #endif
      modbad:
        Py_XDECREF(full_name);
        Py_XDECREF(module_dot);
        Py_XDECREF(module_name);
    }
    if (unlikely(!value)) {
        PyErr_Format(PyExc_ImportError,
        #if PY_MAJOR_VERSION < 3
            "cannot import name %.230s", PyString_AS_STRING(name));
        #else
            "cannot import name %S", name);
        #endif
    }
    return value;
}


#if CYTHON_FAST_THREAD_STATE
static int __Pyx_PyErr_ExceptionMatchesTuple(PyObject *exc_type, PyObject *tuple) {
    Py_ssize_t i, n;
    n = PyTuple_GET_SIZE(tuple);
#if PY_MAJOR_VERSION >= 3
    for (i=0; i<n; i++) {
        if (exc_type == PyTuple_GET_ITEM(tuple, i)) return 1;
    }
#endif
    for (i=0; i<n; i++) {
        if (__Pyx_PyErr_GivenExceptionMatches(exc_type, PyTuple_GET_ITEM(tuple, i))) return 1;
    }
    return 0;
}
static CYTHON_INLINE int __Pyx_PyErr_ExceptionMatchesInState(PyThreadState* tstate, PyObject* err) {
    int result;
    PyObject *exc_type;
#if PY_VERSION_HEX >= 0x030C00A6
    PyObject *current_exception = tstate->current_exception;
    if (unlikely(!current_exception)) return 0;
    exc_type = (PyObject*) Py_TYPE(current_exception);
    if (exc_type == err) return 1;
#else
    exc_type = tstate->curexc_type;
    if (exc_type == err) return 1;
    if (unlikely(!exc_type)) return 0;
#endif
    #if CYTHON_AVOID_BORROWED_REFS
    Py_INCREF(exc_type);
    #endif
    if (unlikely(PyTuple_Check(err))) {
        result = __Pyx_PyErr_ExceptionMatchesTuple(exc_type, err);
    } else {
        result = __Pyx_PyErr_GivenExceptionMatches(exc_type, err);
    }
    #if CYTHON_AVOID_BORROWED_REFS
    Py_DECREF(exc_type);
    #endif
    return result;
}
#endif


#if CYTHON_FAST_THREAD_STATE
static CYTHON_INLINE void __Pyx_ErrRestoreInState(PyThreadState *tstate, PyObject *type, PyObject *value, PyObject *tb) {
#if PY_VERSION_HEX >= 0x030C00A6
    PyObject *tmp_value;
    assert(type == NULL || (value != NULL && type == (PyObject*) Py_TYPE(value)));
    if (value) {
        #if CYTHON_COMPILING_IN_CPYTHON
        if (unlikely(((PyBaseExceptionObject*) value)->traceback != tb))
        #endif
            PyException_SetTraceback(value, tb);
    }
    tmp_value = tstate->current_exception;
    tstate->current_exception = value;
    Py_XDECREF(tmp_value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
#else
    PyObject *tmp_type, *tmp_value, *tmp_tb;
    tmp_type = tstate->curexc_type;
    tmp_value = tstate->curexc_value;
    tmp_tb = tstate->curexc_traceback;
    tstate->curexc_type = type;
    tstate->curexc_value = value;
    tstate->curexc_traceback = tb;
    Py_XDECREF(tmp_type);
    Py_XDECREF(tmp_value);
    Py_XDECREF(tmp_tb);
#endif
}
static CYTHON_INLINE void __Pyx_ErrFetchInState(PyThreadState *tstate, PyObject **type, PyObject **value, PyObject **tb) {
#if PY_VERSION_HEX >= 0x030C00A6
    PyObject* exc_value;
    exc_value = tstate->current_exception;
    tstate->current_exception = 0;
    *value = exc_value;
    *type = NULL;
    *tb = NULL;
    if (exc_value) {
        *type = (PyObject*) Py_TYPE(exc_value);
        Py_INCREF(*type);
        #if CYTHON_COMPILING_IN_CPYTHON
        *tb = ((PyBaseExceptionObject*) exc_value)->traceback;
        Py_XINCREF(*tb);
        #else
        *tb = PyException_GetTraceback(exc_value);
        #endif
    }
#else
    *type = tstate->curexc_type;
    *value = tstate->curexc_value;
    *tb = tstate->curexc_traceback;
    tstate->curexc_type = 0;
    tstate->curexc_value = 0;
    tstate->curexc_traceback = 0;
#endif
}
#endif


#if __PYX_LIMITED_VERSION_HEX < 0x030d00A1
static void __Pyx_PyObject_GetAttrStr_ClearAttributeError(void) {
    __Pyx_PyThreadState_declare
    __Pyx_PyThreadState_assign
    if (likely(__Pyx_PyErr_ExceptionMatches(PyExc_AttributeError)))
        __Pyx_PyErr_Clear();
}
#endif
static CYTHON_INLINE PyObject* __Pyx_PyObject_GetAttrStrNoError(PyObject* obj, PyObject* attr_name) {
    PyObject *result;
#if __PYX_LIMITED_VERSION_HEX >= 0x030d00A1
    (void) PyObject_GetOptionalAttr(obj, attr_name, &result);
    return result;
#else
#if CYTHON_COMPILING_IN_CPYTHON && CYTHON_USE_TYPE_SLOTS && PY_VERSION_HEX >= 0x030700B1
    PyTypeObject* tp = Py_TYPE(obj);
    if (likely(tp->tp_getattro == PyObject_GenericGetAttr)) {
        return _PyObject_GenericGetAttrWithDict(obj, attr_name, NULL, 1);
    }
#endif
    result = __Pyx_PyObject_GetAttrStr(obj, attr_name);
    if (unlikely(!result)) {
        __Pyx_PyObject_GetAttrStr_ClearAttributeError();
    }
    return result;
#endif
}


static PyObject *__Pyx_GetBuiltinName(PyObject *name) {
    PyObject* result = __Pyx_PyObject_GetAttrStrNoError(__pyx_b, name);
    if (unlikely(!result) && !PyErr_Occurred()) {
        PyErr_Format(PyExc_NameError,
#if PY_MAJOR_VERSION >= 3
            "name '%U' is not defined", name);
#else
            "name '%.200s' is not defined", PyString_AS_STRING(name));
#endif
    }
    return result;
}


#if CYTHON_USE_DICT_VERSIONS && CYTHON_USE_TYPE_SLOTS
static CYTHON_INLINE PY_UINT64_T __Pyx_get_tp_dict_version(PyObject *obj) {
    PyObject *dict = Py_TYPE(obj)->tp_dict;
    return likely(dict) ? __PYX_GET_DICT_VERSION(dict) : 0;
}
static CYTHON_INLINE PY_UINT64_T __Pyx_get_object_dict_version(PyObject *obj) {
    PyObject **dictptr = NULL;
    Py_ssize_t offset = Py_TYPE(obj)->tp_dictoffset;
    if (offset) {
#if CYTHON_COMPILING_IN_CPYTHON
        dictptr = (likely(offset > 0)) ? (PyObject **) ((char *)obj + offset) : _PyObject_GetDictPtr(obj);
#else
        dictptr = _PyObject_GetDictPtr(obj);
#endif
    }
    return (dictptr && *dictptr) ? __PYX_GET_DICT_VERSION(*dictptr) : 0;
}
static CYTHON_INLINE int __Pyx_object_dict_version_matches(PyObject* obj, PY_UINT64_T tp_dict_version, PY_UINT64_T obj_dict_version) {
    PyObject *dict = Py_TYPE(obj)->tp_dict;
    if (unlikely(!dict) || unlikely(tp_dict_version != __PYX_GET_DICT_VERSION(dict)))
        return 0;
    return obj_dict_version == __Pyx_get_object_dict_version(obj);
}
#endif


#if CYTHON_USE_DICT_VERSIONS
static PyObject *__Pyx__GetModuleGlobalName(PyObject *name, PY_UINT64_T *dict_version, PyObject **dict_cached_value)
#else
static CYTHON_INLINE PyObject *__Pyx__GetModuleGlobalName(PyObject *name)
#endif
{
    PyObject *result;
#if !CYTHON_AVOID_BORROWED_REFS
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX >= 0x030500A1 && PY_VERSION_HEX < 0x030d0000
    result = _PyDict_GetItem_KnownHash(__pyx_d, name, ((PyASCIIObject *) name)->hash);
    __PYX_UPDATE_DICT_CACHE(__pyx_d, result, *dict_cached_value, *dict_version)
    if (likely(result)) {
        return __Pyx_NewRef(result);
    } else if (unlikely(PyErr_Occurred())) {
        return NULL;
    }
#elif CYTHON_COMPILING_IN_LIMITED_API
    if (unlikely(!__pyx_m)) {
        return NULL;
    }
    result = PyObject_GetAttr(__pyx_m, name);
    if (likely(result)) {
        return result;
    }
#else
    result = PyDict_GetItem(__pyx_d, name);
    __PYX_UPDATE_DICT_CACHE(__pyx_d, result, *dict_cached_value, *dict_version)
    if (likely(result)) {
        return __Pyx_NewRef(result);
    }
#endif
#else
    result = PyObject_GetItem(__pyx_d, name);
    __PYX_UPDATE_DICT_CACHE(__pyx_d, result, *dict_cached_value, *dict_version)
    if (likely(result)) {
        return __Pyx_NewRef(result);
    }
    PyErr_Clear();
#endif
    return __Pyx_GetBuiltinName(name);
}


static CYTHON_INLINE void __Pyx_RaiseTooManyValuesError(Py_ssize_t expected) {
    PyErr_Format(PyExc_ValueError,
                 "too many values to unpack (expected %" CYTHON_FORMAT_SSIZE_T "d)", expected);
}


static CYTHON_INLINE void __Pyx_RaiseNeedMoreValuesError(Py_ssize_t index) {
    PyErr_Format(PyExc_ValueError,
                 "need more than %" CYTHON_FORMAT_SSIZE_T "d value%.1s to unpack",
                 index, (index == 1) ? "" : "s");
}


static CYTHON_INLINE void __Pyx_RaiseNoneNotIterableError(void) {
    PyErr_SetString(PyExc_TypeError, "'NoneType' object is not iterable");
}


#if CYTHON_COMPILING_IN_CPYTHON
static CYTHON_INLINE PyObject* __Pyx_PyObject_Call(PyObject *func, PyObject *arg, PyObject *kw) {
    PyObject *result;
    ternaryfunc call = Py_TYPE(func)->tp_call;
    if (unlikely(!call))
        return PyObject_Call(func, arg, kw);
    #if PY_MAJOR_VERSION < 3
    if (unlikely(Py_EnterRecursiveCall((char*)" while calling a Python object")))
        return NULL;
    #else
    if (unlikely(Py_EnterRecursiveCall(" while calling a Python object")))
        return NULL;
    #endif
    result = (*call)(func, arg, kw);
    Py_LeaveRecursiveCall();
    if (unlikely(!result) && unlikely(!PyErr_Occurred())) {
        PyErr_SetString(
            PyExc_SystemError,
            "NULL result without error in PyObject_Call");
    }
    return result;
}
#endif


#if PY_MAJOR_VERSION >= 3 && !CYTHON_COMPILING_IN_PYPY
static PyObject *__Pyx_PyDict_GetItem(PyObject *d, PyObject* key) {
    PyObject *value;
    value = PyDict_GetItemWithError(d, key);
    if (unlikely(!value)) {
        if (!PyErr_Occurred()) {
            if (unlikely(PyTuple_Check(key))) {
                PyObject* args = PyTuple_Pack(1, key);
                if (likely(args)) {
                    PyErr_SetObject(PyExc_KeyError, args);
                    Py_DECREF(args);
                }
            } else {
                PyErr_SetObject(PyExc_KeyError, key);
            }
        }
        return NULL;
    }
    Py_INCREF(value);
    return value;
}
#endif


#ifndef CYTHON_CLINE_IN_TRACEBACK
static int __Pyx_CLineForTraceback(PyThreadState *tstate, int c_line) {
    PyObject *use_cline;
    PyObject *ptype, *pvalue, *ptraceback;
#if CYTHON_COMPILING_IN_CPYTHON
    PyObject **cython_runtime_dict;
#endif
    CYTHON_MAYBE_UNUSED_VAR(tstate);
    if (unlikely(!__pyx_cython_runtime)) {
        return c_line;
    }
    __Pyx_ErrFetchInState(tstate, &ptype, &pvalue, &ptraceback);
#if CYTHON_COMPILING_IN_CPYTHON
    cython_runtime_dict = _PyObject_GetDictPtr(__pyx_cython_runtime);
    if (likely(cython_runtime_dict)) {
        __PYX_PY_DICT_LOOKUP_IF_MODIFIED(
            use_cline, *cython_runtime_dict,
            __Pyx_PyDict_GetItemStr(*cython_runtime_dict, __pyx_n_s_cline_in_traceback))
    } else
#endif
    {
      PyObject *use_cline_obj = __Pyx_PyObject_GetAttrStrNoError(__pyx_cython_runtime, __pyx_n_s_cline_in_traceback);
      if (use_cline_obj) {
        use_cline = PyObject_Not(use_cline_obj) ? Py_False : Py_True;
        Py_DECREF(use_cline_obj);
      } else {
        PyErr_Clear();
        use_cline = NULL;
      }
    }
    if (!use_cline) {
        c_line = 0;
        (void) PyObject_SetAttr(__pyx_cython_runtime, __pyx_n_s_cline_in_traceback, Py_False);
    }
    else if (use_cline == Py_False || (use_cline != Py_True && PyObject_Not(use_cline) != 0)) {
        c_line = 0;
    }
    __Pyx_ErrRestoreInState(tstate, ptype, pvalue, ptraceback);
    return c_line;
}
#endif


#if !CYTHON_COMPILING_IN_LIMITED_API
static int __pyx_bisect_code_objects(__Pyx_CodeObjectCacheEntry* entries, int count, int code_line) {
    int start = 0, mid = 0, end = count - 1;
    if (end >= 0 && code_line > entries[end].code_line) {
        return count;
    }
    while (start < end) {
        mid = start + (end - start) / 2;
        if (code_line < entries[mid].code_line) {
            end = mid;
        } else if (code_line > entries[mid].code_line) {
             start = mid + 1;
        } else {
            return mid;
        }
    }
    if (code_line <= entries[mid].code_line) {
        return mid;
    } else {
        return mid + 1;
    }
}
static PyCodeObject *__pyx_find_code_object(int code_line) {
    PyCodeObject* code_object;
    int pos;
    if (unlikely(!code_line) || unlikely(!__pyx_code_cache.entries)) {
        return NULL;
    }
    pos = __pyx_bisect_code_objects(__pyx_code_cache.entries, __pyx_code_cache.count, code_line);
    if (unlikely(pos >= __pyx_code_cache.count) || unlikely(__pyx_code_cache.entries[pos].code_line != code_line)) {
        return NULL;
    }
    code_object = __pyx_code_cache.entries[pos].code_object;
    Py_INCREF(code_object);
    return code_object;
}
static void __pyx_insert_code_object(int code_line, PyCodeObject* code_object) {
    int pos, i;
    __Pyx_CodeObjectCacheEntry* entries = __pyx_code_cache.entries;
    if (unlikely(!code_line)) {
        return;
    }
    if (unlikely(!entries)) {
        entries = (__Pyx_CodeObjectCacheEntry*)PyMem_Malloc(64*sizeof(__Pyx_CodeObjectCacheEntry));
        if (likely(entries)) {
            __pyx_code_cache.entries = entries;
            __pyx_code_cache.max_count = 64;
            __pyx_code_cache.count = 1;
            entries[0].code_line = code_line;
            entries[0].code_object = code_object;
            Py_INCREF(code_object);
        }
        return;
    }
    pos = __pyx_bisect_code_objects(__pyx_code_cache.entries, __pyx_code_cache.count, code_line);
    if ((pos < __pyx_code_cache.count) && unlikely(__pyx_code_cache.entries[pos].code_line == code_line)) {
        PyCodeObject* tmp = entries[pos].code_object;
        entries[pos].code_object = code_object;
        Py_DECREF(tmp);
        return;
    }
    if (__pyx_code_cache.count == __pyx_code_cache.max_count) {
        int new_max = __pyx_code_cache.max_count + 64;
        entries = (__Pyx_CodeObjectCacheEntry*)PyMem_Realloc(
            __pyx_code_cache.entries, ((size_t)new_max) * sizeof(__Pyx_CodeObjectCacheEntry));
        if (unlikely(!entries)) {
            return;
        }
        __pyx_code_cache.entries = entries;
        __pyx_code_cache.max_count = new_max;
    }
    for (i=__pyx_code_cache.count; i>pos; i--) {
        entries[i] = entries[i-1];
    }
    entries[pos].code_line = code_line;
    entries[pos].code_object = code_object;
    __pyx_code_cache.count++;
    Py_INCREF(code_object);
}
#endif


#include "compile.h"
#include "frameobject.h"
#include "traceback.h"
#if PY_VERSION_HEX >= 0x030b00a6 && !CYTHON_COMPILING_IN_LIMITED_API
  #ifndef Py_BUILD_CORE
    #define Py_BUILD_CORE 1
  #endif
  #include "internal/pycore_frame.h"
#endif
#if CYTHON_COMPILING_IN_LIMITED_API
static PyObject *__Pyx_PyCode_Replace_For_AddTraceback(PyObject *code, PyObject *scratch_dict,
                                                       PyObject *firstlineno, PyObject *name) {
    PyObject *replace = NULL;
    if (unlikely(PyDict_SetItemString(scratch_dict, "co_firstlineno", firstlineno))) return NULL;
    if (unlikely(PyDict_SetItemString(scratch_dict, "co_name", name))) return NULL;
    replace = PyObject_GetAttrString(code, "replace");
    if (likely(replace)) {
        PyObject *result;
        result = PyObject_Call(replace, __pyx_empty_tuple, scratch_dict);
        Py_DECREF(replace);
        return result;
    }
    PyErr_Clear();
    #if __PYX_LIMITED_VERSION_HEX < 0x030780000
    {
        PyObject *compiled = NULL, *result = NULL;
        if (unlikely(PyDict_SetItemString(scratch_dict, "code", code))) return NULL;
        if (unlikely(PyDict_SetItemString(scratch_dict, "type", (PyObject*)(&PyType_Type)))) return NULL;
        compiled = Py_CompileString(
            "out = type(code)(\n"
            "  code.co_argcount, code.co_kwonlyargcount, code.co_nlocals, code.co_stacksize,\n"
            "  code.co_flags, code.co_code, code.co_consts, code.co_names,\n"
            "  code.co_varnames, code.co_filename, co_name, co_firstlineno,\n"
            "  code.co_lnotab)\n", "<dummy>", Py_file_input);
        if (!compiled) return NULL;
        result = PyEval_EvalCode(compiled, scratch_dict, scratch_dict);
        Py_DECREF(compiled);
        if (!result) PyErr_Print();
        Py_DECREF(result);
        result = PyDict_GetItemString(scratch_dict, "out");
        if (result) Py_INCREF(result);
        return result;
    }
    #else
    return NULL;
    #endif
}
static void __Pyx_AddTraceback(const char *funcname, int c_line,
                               int py_line, const char *filename) {
    PyObject *code_object = NULL, *py_py_line = NULL, *py_funcname = NULL, *dict = NULL;
    PyObject *replace = NULL, *getframe = NULL, *frame = NULL;
    PyObject *exc_type, *exc_value, *exc_traceback;
    int success = 0;
    if (c_line) {
        (void) __pyx_cfilenm;
        (void) __Pyx_CLineForTraceback(__Pyx_PyThreadState_Current, c_line);
    }
    PyErr_Fetch(&exc_type, &exc_value, &exc_traceback);
    code_object = Py_CompileString("_getframe()", filename, Py_eval_input);
    if (unlikely(!code_object)) goto bad;
    py_py_line = PyLong_FromLong(py_line);
    if (unlikely(!py_py_line)) goto bad;
    py_funcname = PyUnicode_FromString(funcname);
    if (unlikely(!py_funcname)) goto bad;
    dict = PyDict_New();
    if (unlikely(!dict)) goto bad;
    {
        PyObject *old_code_object = code_object;
        code_object = __Pyx_PyCode_Replace_For_AddTraceback(code_object, dict, py_py_line, py_funcname);
        Py_DECREF(old_code_object);
    }
    if (unlikely(!code_object)) goto bad;
    getframe = PySys_GetObject("_getframe");
    if (unlikely(!getframe)) goto bad;
    if (unlikely(PyDict_SetItemString(dict, "_getframe", getframe))) goto bad;
    frame = PyEval_EvalCode(code_object, dict, dict);
    if (unlikely(!frame) || frame == Py_None) goto bad;
    success = 1;
  bad:
    PyErr_Restore(exc_type, exc_value, exc_traceback);
    Py_XDECREF(code_object);
    Py_XDECREF(py_py_line);
    Py_XDECREF(py_funcname);
    Py_XDECREF(dict);
    Py_XDECREF(replace);
    if (success) {
        PyTraceBack_Here(
            (struct _frame*)frame);
    }
    Py_XDECREF(frame);
}
#else
static PyCodeObject* __Pyx_CreateCodeObjectForTraceback(
            const char *funcname, int c_line,
            int py_line, const char *filename) {
    PyCodeObject *py_code = NULL;
    PyObject *py_funcname = NULL;
    #if PY_MAJOR_VERSION < 3
    PyObject *py_srcfile = NULL;
    py_srcfile = PyString_FromString(filename);
    if (!py_srcfile) goto bad;
    #endif
    if (c_line) {
        #if PY_MAJOR_VERSION < 3
        py_funcname = PyString_FromFormat( "%s (%s:%d)", funcname, __pyx_cfilenm, c_line);
        if (!py_funcname) goto bad;
        #else
        py_funcname = PyUnicode_FromFormat( "%s (%s:%d)", funcname, __pyx_cfilenm, c_line);
        if (!py_funcname) goto bad;
        funcname = PyUnicode_AsUTF8(py_funcname);
        if (!funcname) goto bad;
        #endif
    }
    else {
        #if PY_MAJOR_VERSION < 3
        py_funcname = PyString_FromString(funcname);
        if (!py_funcname) goto bad;
        #endif
    }
    #if PY_MAJOR_VERSION < 3
    py_code = __Pyx_PyCode_New(
        0,
        0,
        0,
        0,
        0,
        0,
        __pyx_empty_bytes, 
        __pyx_empty_tuple, 
        __pyx_empty_tuple, 
        __pyx_empty_tuple, 
        __pyx_empty_tuple, 
        __pyx_empty_tuple, 
        py_srcfile,   
        py_funcname,  
        py_line,
        __pyx_empty_bytes  
    );
    Py_DECREF(py_srcfile);
    #else
    py_code = PyCode_NewEmpty(filename, funcname, py_line);
    #endif
    Py_XDECREF(py_funcname);
    return py_code;
bad:
    Py_XDECREF(py_funcname);
    #if PY_MAJOR_VERSION < 3
    Py_XDECREF(py_srcfile);
    #endif
    return NULL;
}
static void __Pyx_AddTraceback(const char *funcname, int c_line,
                               int py_line, const char *filename) {
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    PyThreadState *tstate = __Pyx_PyThreadState_Current;
    PyObject *ptype, *pvalue, *ptraceback;
    if (c_line) {
        c_line = __Pyx_CLineForTraceback(tstate, c_line);
    }
    py_code = __pyx_find_code_object(c_line ? -c_line : py_line);
    if (!py_code) {
        __Pyx_ErrFetchInState(tstate, &ptype, &pvalue, &ptraceback);
        py_code = __Pyx_CreateCodeObjectForTraceback(
            funcname, c_line, py_line, filename);
        if (!py_code) {
            
            Py_XDECREF(ptype);
            Py_XDECREF(pvalue);
            Py_XDECREF(ptraceback);
            goto bad;
        }
        __Pyx_ErrRestoreInState(tstate, ptype, pvalue, ptraceback);
        __pyx_insert_code_object(c_line ? -c_line : py_line, py_code);
    }
    py_frame = PyFrame_New(
        tstate,            
        py_code,           
        __pyx_d,    
        0                  
    );
    if (!py_frame) goto bad;
    __Pyx_PyFrame_SetLineNumber(py_frame, py_line);
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
#endif


#if CYTHON_COMPILING_IN_LIMITED_API
static __Pyx_TypeName
__Pyx_PyType_GetName(PyTypeObject* tp)
{
    PyObject *name = __Pyx_PyObject_GetAttrStr((PyObject *)tp,
                                               __pyx_n_s_name);
    if (unlikely(name == NULL) || unlikely(!PyUnicode_Check(name))) {
        PyErr_Clear();
        Py_XDECREF(name);
        name = __Pyx_NewRef(__pyx_n_s__3);
    }
    return name;
}
#endif


static CYTHON_INLINE PyObject* __Pyx_PyInt_From_long(long value) {
#ifdef __Pyx_HAS_GCC_DIAGNOSTIC
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wconversion"
#endif
    const long neg_one = (long) -1, const_zero = (long) 0;
#ifdef __Pyx_HAS_GCC_DIAGNOSTIC
#pragma GCC diagnostic pop
#endif
    const int is_unsigned = neg_one > const_zero;
    if (is_unsigned) {
        if (sizeof(long) < sizeof(long)) {
            return PyInt_FromLong((long) value);
        } else if (sizeof(long) <= sizeof(unsigned long)) {
            return PyLong_FromUnsignedLong((unsigned long) value);
#ifdef HAVE_LONG_LONG
        } else if (sizeof(long) <= sizeof(unsigned PY_LONG_LONG)) {
            return PyLong_FromUnsignedLongLong((unsigned PY_LONG_LONG) value);
#endif
        }
    } else {
        if (sizeof(long) <= sizeof(long)) {
            return PyInt_FromLong((long) value);
#ifdef HAVE_LONG_LONG
        } else if (sizeof(long) <= sizeof(PY_LONG_LONG)) {
            return PyLong_FromLongLong((PY_LONG_LONG) value);
#endif
        }
    }
    {
        unsigned char *bytes = (unsigned char *)&value;
#if !CYTHON_COMPILING_IN_LIMITED_API && PY_VERSION_HEX >= 0x030d00A4
        if (is_unsigned) {
            return PyLong_FromUnsignedNativeBytes(bytes, sizeof(value), -1);
        } else {
            return PyLong_FromNativeBytes(bytes, sizeof(value), -1);
        }
#elif !CYTHON_COMPILING_IN_LIMITED_API && PY_VERSION_HEX < 0x030d0000
        int one = 1; int little = (int)*(unsigned char *)&one;
        return _PyLong_FromByteArray(bytes, sizeof(long),
                                     little, !is_unsigned);
#else
        int one = 1; int little = (int)*(unsigned char *)&one;
        PyObject *from_bytes, *result = NULL;
        PyObject *py_bytes = NULL, *arg_tuple = NULL, *kwds = NULL, *order_str = NULL;
        from_bytes = PyObject_GetAttrString((PyObject*)&PyLong_Type, "from_bytes");
        if (!from_bytes) return NULL;
        py_bytes = PyBytes_FromStringAndSize((char*)bytes, sizeof(long));
        if (!py_bytes) goto limited_bad;
        order_str = PyUnicode_FromString(little ? "little" : "big");
        if (!order_str) goto limited_bad;
        arg_tuple = PyTuple_Pack(2, py_bytes, order_str);
        if (!arg_tuple) goto limited_bad;
        if (!is_unsigned) {
            kwds = PyDict_New();
            if (!kwds) goto limited_bad;
            if (PyDict_SetItemString(kwds, "signed", __Pyx_NewRef(Py_True))) goto limited_bad;
        }
        result = PyObject_Call(from_bytes, arg_tuple, kwds);
        limited_bad:
        Py_XDECREF(kwds);
        Py_XDECREF(arg_tuple);
        Py_XDECREF(order_str);
        Py_XDECREF(py_bytes);
        Py_XDECREF(from_bytes);
        return result;
#endif
    }
}


#define __PYX_VERIFY_RETURN_INT(target_type, func_type, func_value)\
    __PYX__VERIFY_RETURN_INT(target_type, func_type, func_value, 0)
#define __PYX_VERIFY_RETURN_INT_EXC(target_type, func_type, func_value)\
    __PYX__VERIFY_RETURN_INT(target_type, func_type, func_value, 1)
#define __PYX__VERIFY_RETURN_INT(target_type, func_type, func_value, exc)\
    {\
        func_type value = func_value;\
        if (sizeof(target_type) < sizeof(func_type)) {\
            if (unlikely(value != (func_type) (target_type) value)) {\
                func_type zero = 0;\
                if (exc && unlikely(value == (func_type)-1 && PyErr_Occurred()))\
                    return (target_type) -1;\
                if (is_unsigned && unlikely(value < zero))\
                    goto raise_neg_overflow;\
                else\
                    goto raise_overflow;\
            }\
        }\
        return (target_type) value;\
    }


static CYTHON_INLINE long __Pyx_PyInt_As_long(PyObject *x) {
#ifdef __Pyx_HAS_GCC_DIAGNOSTIC
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wconversion"
#endif
    const long neg_one = (long) -1, const_zero = (long) 0;
#ifdef __Pyx_HAS_GCC_DIAGNOSTIC
#pragma GCC diagnostic pop
#endif
    const int is_unsigned = neg_one > const_zero;
#if PY_MAJOR_VERSION < 3
    if (likely(PyInt_Check(x))) {
        if ((sizeof(long) < sizeof(long))) {
            __PYX_VERIFY_RETURN_INT(long, long, PyInt_AS_LONG(x))
        } else {
            long val = PyInt_AS_LONG(x);
            if (is_unsigned && unlikely(val < 0)) {
                goto raise_neg_overflow;
            }
            return (long) val;
        }
    }
#endif
    if (unlikely(!PyLong_Check(x))) {
        long val;
        PyObject *tmp = __Pyx_PyNumber_IntOrLong(x);
        if (!tmp) return (long) -1;
        val = __Pyx_PyInt_As_long(tmp);
        Py_DECREF(tmp);
        return val;
    }
    if (is_unsigned) {
#if CYTHON_USE_PYLONG_INTERNALS
        if (unlikely(__Pyx_PyLong_IsNeg(x))) {
            goto raise_neg_overflow;
        } else if (__Pyx_PyLong_IsCompact(x)) {
            __PYX_VERIFY_RETURN_INT(long, __Pyx_compact_upylong, __Pyx_PyLong_CompactValueUnsigned(x))
        } else {
            const digit* digits = __Pyx_PyLong_Digits(x);
            assert(__Pyx_PyLong_DigitCount(x) > 1);
            switch (__Pyx_PyLong_DigitCount(x)) {
                case 2:
                    if ((8 * sizeof(long) > 1 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 2 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, unsigned long, (((((unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) >= 2 * PyLong_SHIFT)) {
                            return (long) (((((long)digits[1]) << PyLong_SHIFT) | (long)digits[0]));
                        }
                    }
                    break;
                case 3:
                    if ((8 * sizeof(long) > 2 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 3 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, unsigned long, (((((((unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) >= 3 * PyLong_SHIFT)) {
                            return (long) (((((((long)digits[2]) << PyLong_SHIFT) | (long)digits[1]) << PyLong_SHIFT) | (long)digits[0]));
                        }
                    }
                    break;
                case 4:
                    if ((8 * sizeof(long) > 3 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 4 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, unsigned long, (((((((((unsigned long)digits[3]) << PyLong_SHIFT) | (unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) >= 4 * PyLong_SHIFT)) {
                            return (long) (((((((((long)digits[3]) << PyLong_SHIFT) | (long)digits[2]) << PyLong_SHIFT) | (long)digits[1]) << PyLong_SHIFT) | (long)digits[0]));
                        }
                    }
                    break;
            }
        }
#endif
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX < 0x030C00A7
        if (unlikely(Py_SIZE(x) < 0)) {
            goto raise_neg_overflow;
        }
#else
        {
            int result = PyObject_RichCompareBool(x, Py_False, Py_LT);
            if (unlikely(result < 0))
                return (long) -1;
            if (unlikely(result == 1))
                goto raise_neg_overflow;
        }
#endif
        if ((sizeof(long) <= sizeof(unsigned long))) {
            __PYX_VERIFY_RETURN_INT_EXC(long, unsigned long, PyLong_AsUnsignedLong(x))
#ifdef HAVE_LONG_LONG
        } else if ((sizeof(long) <= sizeof(unsigned PY_LONG_LONG))) {
            __PYX_VERIFY_RETURN_INT_EXC(long, unsigned PY_LONG_LONG, PyLong_AsUnsignedLongLong(x))
#endif
        }
    } else {
#if CYTHON_USE_PYLONG_INTERNALS
        if (__Pyx_PyLong_IsCompact(x)) {
            __PYX_VERIFY_RETURN_INT(long, __Pyx_compact_pylong, __Pyx_PyLong_CompactValue(x))
        } else {
            const digit* digits = __Pyx_PyLong_Digits(x);
            assert(__Pyx_PyLong_DigitCount(x) > 1);
            switch (__Pyx_PyLong_SignedDigitCount(x)) {
                case -2:
                    if ((8 * sizeof(long) - 1 > 1 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 2 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, long, -(long) (((((unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) - 1 > 2 * PyLong_SHIFT)) {
                            return (long) (((long)-1)*(((((long)digits[1]) << PyLong_SHIFT) | (long)digits[0])));
                        }
                    }
                    break;
                case 2:
                    if ((8 * sizeof(long) > 1 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 2 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, unsigned long, (((((unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) - 1 > 2 * PyLong_SHIFT)) {
                            return (long) ((((((long)digits[1]) << PyLong_SHIFT) | (long)digits[0])));
                        }
                    }
                    break;
                case -3:
                    if ((8 * sizeof(long) - 1 > 2 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 3 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, long, -(long) (((((((unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) - 1 > 3 * PyLong_SHIFT)) {
                            return (long) (((long)-1)*(((((((long)digits[2]) << PyLong_SHIFT) | (long)digits[1]) << PyLong_SHIFT) | (long)digits[0])));
                        }
                    }
                    break;
                case 3:
                    if ((8 * sizeof(long) > 2 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 3 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, unsigned long, (((((((unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) - 1 > 3 * PyLong_SHIFT)) {
                            return (long) ((((((((long)digits[2]) << PyLong_SHIFT) | (long)digits[1]) << PyLong_SHIFT) | (long)digits[0])));
                        }
                    }
                    break;
                case -4:
                    if ((8 * sizeof(long) - 1 > 3 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 4 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, long, -(long) (((((((((unsigned long)digits[3]) << PyLong_SHIFT) | (unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) - 1 > 4 * PyLong_SHIFT)) {
                            return (long) (((long)-1)*(((((((((long)digits[3]) << PyLong_SHIFT) | (long)digits[2]) << PyLong_SHIFT) | (long)digits[1]) << PyLong_SHIFT) | (long)digits[0])));
                        }
                    }
                    break;
                case 4:
                    if ((8 * sizeof(long) > 3 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 4 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(long, unsigned long, (((((((((unsigned long)digits[3]) << PyLong_SHIFT) | (unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(long) - 1 > 4 * PyLong_SHIFT)) {
                            return (long) ((((((((((long)digits[3]) << PyLong_SHIFT) | (long)digits[2]) << PyLong_SHIFT) | (long)digits[1]) << PyLong_SHIFT) | (long)digits[0])));
                        }
                    }
                    break;
            }
        }
#endif
        if ((sizeof(long) <= sizeof(long))) {
            __PYX_VERIFY_RETURN_INT_EXC(long, long, PyLong_AsLong(x))
#ifdef HAVE_LONG_LONG
        } else if ((sizeof(long) <= sizeof(PY_LONG_LONG))) {
            __PYX_VERIFY_RETURN_INT_EXC(long, PY_LONG_LONG, PyLong_AsLongLong(x))
#endif
        }
    }
    {
        long val;
        int ret = -1;
#if PY_VERSION_HEX >= 0x030d00A6 && !CYTHON_COMPILING_IN_LIMITED_API
        Py_ssize_t bytes_copied = PyLong_AsNativeBytes(
            x, &val, sizeof(val), Py_ASNATIVEBYTES_NATIVE_ENDIAN | (is_unsigned ? Py_ASNATIVEBYTES_UNSIGNED_BUFFER | Py_ASNATIVEBYTES_REJECT_NEGATIVE : 0));
        if (unlikely(bytes_copied == -1)) {
        } else if (unlikely(bytes_copied > (Py_ssize_t) sizeof(val))) {
            goto raise_overflow;
        } else {
            ret = 0;
        }
#elif PY_VERSION_HEX < 0x030d0000 && !(CYTHON_COMPILING_IN_PYPY || CYTHON_COMPILING_IN_LIMITED_API) || defined(_PyLong_AsByteArray)
        int one = 1; int is_little = (int)*(unsigned char *)&one;
        unsigned char *bytes = (unsigned char *)&val;
        ret = _PyLong_AsByteArray((PyLongObject *)x,
                                    bytes, sizeof(val),
                                    is_little, !is_unsigned);
#else
        PyObject *v;
        PyObject *stepval = NULL, *mask = NULL, *shift = NULL;
        int bits, remaining_bits, is_negative = 0;
        int chunk_size = (sizeof(long) < 8) ? 30 : 62;
        if (likely(PyLong_CheckExact(x))) {
            v = __Pyx_NewRef(x);
        } else {
            v = PyNumber_Long(x);
            if (unlikely(!v)) return (long) -1;
            assert(PyLong_CheckExact(v));
        }
        {
            int result = PyObject_RichCompareBool(v, Py_False, Py_LT);
            if (unlikely(result < 0)) {
                Py_DECREF(v);
                return (long) -1;
            }
            is_negative = result == 1;
        }
        if (is_unsigned && unlikely(is_negative)) {
            Py_DECREF(v);
            goto raise_neg_overflow;
        } else if (is_negative) {
            stepval = PyNumber_Invert(v);
            Py_DECREF(v);
            if (unlikely(!stepval))
                return (long) -1;
        } else {
            stepval = v;
        }
        v = NULL;
        val = (long) 0;
        mask = PyLong_FromLong((1L << chunk_size) - 1); if (unlikely(!mask)) goto done;
        shift = PyLong_FromLong(chunk_size); if (unlikely(!shift)) goto done;
        for (bits = 0; bits < (int) sizeof(long) * 8 - chunk_size; bits += chunk_size) {
            PyObject *tmp, *digit;
            long idigit;
            digit = PyNumber_And(stepval, mask);
            if (unlikely(!digit)) goto done;
            idigit = PyLong_AsLong(digit);
            Py_DECREF(digit);
            if (unlikely(idigit < 0)) goto done;
            val |= ((long) idigit) << bits;
            tmp = PyNumber_Rshift(stepval, shift);
            if (unlikely(!tmp)) goto done;
            Py_DECREF(stepval); stepval = tmp;
        }
        Py_DECREF(shift); shift = NULL;
        Py_DECREF(mask); mask = NULL;
        {
            long idigit = PyLong_AsLong(stepval);
            if (unlikely(idigit < 0)) goto done;
            remaining_bits = ((int) sizeof(long) * 8) - bits - (is_unsigned ? 0 : 1);
            if (unlikely(idigit >= (1L << remaining_bits)))
                goto raise_overflow;
            val |= ((long) idigit) << bits;
        }
        if (!is_unsigned) {
            if (unlikely(val & (((long) 1) << (sizeof(long) * 8 - 1))))
                goto raise_overflow;
            if (is_negative)
                val = ~val;
        }
        ret = 0;
    done:
        Py_XDECREF(shift);
        Py_XDECREF(mask);
        Py_XDECREF(stepval);
#endif
        if (unlikely(ret))
            return (long) -1;
        return val;
    }
raise_overflow:
    PyErr_SetString(PyExc_OverflowError,
        "value too large to convert to long");
    return (long) -1;
raise_neg_overflow:
    PyErr_SetString(PyExc_OverflowError,
        "can't convert negative value to long");
    return (long) -1;
}


static CYTHON_INLINE int __Pyx_PyInt_As_int(PyObject *x) {
#ifdef __Pyx_HAS_GCC_DIAGNOSTIC
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wconversion"
#endif
    const int neg_one = (int) -1, const_zero = (int) 0;
#ifdef __Pyx_HAS_GCC_DIAGNOSTIC
#pragma GCC diagnostic pop
#endif
    const int is_unsigned = neg_one > const_zero;
#if PY_MAJOR_VERSION < 3
    if (likely(PyInt_Check(x))) {
        if ((sizeof(int) < sizeof(long))) {
            __PYX_VERIFY_RETURN_INT(int, long, PyInt_AS_LONG(x))
        } else {
            long val = PyInt_AS_LONG(x);
            if (is_unsigned && unlikely(val < 0)) {
                goto raise_neg_overflow;
            }
            return (int) val;
        }
    }
#endif
    if (unlikely(!PyLong_Check(x))) {
        int val;
        PyObject *tmp = __Pyx_PyNumber_IntOrLong(x);
        if (!tmp) return (int) -1;
        val = __Pyx_PyInt_As_int(tmp);
        Py_DECREF(tmp);
        return val;
    }
    if (is_unsigned) {
#if CYTHON_USE_PYLONG_INTERNALS
        if (unlikely(__Pyx_PyLong_IsNeg(x))) {
            goto raise_neg_overflow;
        } else if (__Pyx_PyLong_IsCompact(x)) {
            __PYX_VERIFY_RETURN_INT(int, __Pyx_compact_upylong, __Pyx_PyLong_CompactValueUnsigned(x))
        } else {
            const digit* digits = __Pyx_PyLong_Digits(x);
            assert(__Pyx_PyLong_DigitCount(x) > 1);
            switch (__Pyx_PyLong_DigitCount(x)) {
                case 2:
                    if ((8 * sizeof(int) > 1 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 2 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, unsigned long, (((((unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) >= 2 * PyLong_SHIFT)) {
                            return (int) (((((int)digits[1]) << PyLong_SHIFT) | (int)digits[0]));
                        }
                    }
                    break;
                case 3:
                    if ((8 * sizeof(int) > 2 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 3 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, unsigned long, (((((((unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) >= 3 * PyLong_SHIFT)) {
                            return (int) (((((((int)digits[2]) << PyLong_SHIFT) | (int)digits[1]) << PyLong_SHIFT) | (int)digits[0]));
                        }
                    }
                    break;
                case 4:
                    if ((8 * sizeof(int) > 3 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 4 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, unsigned long, (((((((((unsigned long)digits[3]) << PyLong_SHIFT) | (unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) >= 4 * PyLong_SHIFT)) {
                            return (int) (((((((((int)digits[3]) << PyLong_SHIFT) | (int)digits[2]) << PyLong_SHIFT) | (int)digits[1]) << PyLong_SHIFT) | (int)digits[0]));
                        }
                    }
                    break;
            }
        }
#endif
#if CYTHON_COMPILING_IN_CPYTHON && PY_VERSION_HEX < 0x030C00A7
        if (unlikely(Py_SIZE(x) < 0)) {
            goto raise_neg_overflow;
        }
#else
        {
            int result = PyObject_RichCompareBool(x, Py_False, Py_LT);
            if (unlikely(result < 0))
                return (int) -1;
            if (unlikely(result == 1))
                goto raise_neg_overflow;
        }
#endif
        if ((sizeof(int) <= sizeof(unsigned long))) {
            __PYX_VERIFY_RETURN_INT_EXC(int, unsigned long, PyLong_AsUnsignedLong(x))
#ifdef HAVE_LONG_LONG
        } else if ((sizeof(int) <= sizeof(unsigned PY_LONG_LONG))) {
            __PYX_VERIFY_RETURN_INT_EXC(int, unsigned PY_LONG_LONG, PyLong_AsUnsignedLongLong(x))
#endif
        }
    } else {
#if CYTHON_USE_PYLONG_INTERNALS
        if (__Pyx_PyLong_IsCompact(x)) {
            __PYX_VERIFY_RETURN_INT(int, __Pyx_compact_pylong, __Pyx_PyLong_CompactValue(x))
        } else {
            const digit* digits = __Pyx_PyLong_Digits(x);
            assert(__Pyx_PyLong_DigitCount(x) > 1);
            switch (__Pyx_PyLong_SignedDigitCount(x)) {
                case -2:
                    if ((8 * sizeof(int) - 1 > 1 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 2 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, long, -(long) (((((unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) - 1 > 2 * PyLong_SHIFT)) {
                            return (int) (((int)-1)*(((((int)digits[1]) << PyLong_SHIFT) | (int)digits[0])));
                        }
                    }
                    break;
                case 2:
                    if ((8 * sizeof(int) > 1 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 2 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, unsigned long, (((((unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) - 1 > 2 * PyLong_SHIFT)) {
                            return (int) ((((((int)digits[1]) << PyLong_SHIFT) | (int)digits[0])));
                        }
                    }
                    break;
                case -3:
                    if ((8 * sizeof(int) - 1 > 2 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 3 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, long, -(long) (((((((unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) - 1 > 3 * PyLong_SHIFT)) {
                            return (int) (((int)-1)*(((((((int)digits[2]) << PyLong_SHIFT) | (int)digits[1]) << PyLong_SHIFT) | (int)digits[0])));
                        }
                    }
                    break;
                case 3:
                    if ((8 * sizeof(int) > 2 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 3 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, unsigned long, (((((((unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) - 1 > 3 * PyLong_SHIFT)) {
                            return (int) ((((((((int)digits[2]) << PyLong_SHIFT) | (int)digits[1]) << PyLong_SHIFT) | (int)digits[0])));
                        }
                    }
                    break;
                case -4:
                    if ((8 * sizeof(int) - 1 > 3 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 4 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, long, -(long) (((((((((unsigned long)digits[3]) << PyLong_SHIFT) | (unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) - 1 > 4 * PyLong_SHIFT)) {
                            return (int) (((int)-1)*(((((((((int)digits[3]) << PyLong_SHIFT) | (int)digits[2]) << PyLong_SHIFT) | (int)digits[1]) << PyLong_SHIFT) | (int)digits[0])));
                        }
                    }
                    break;
                case 4:
                    if ((8 * sizeof(int) > 3 * PyLong_SHIFT)) {
                        if ((8 * sizeof(unsigned long) > 4 * PyLong_SHIFT)) {
                            __PYX_VERIFY_RETURN_INT(int, unsigned long, (((((((((unsigned long)digits[3]) << PyLong_SHIFT) | (unsigned long)digits[2]) << PyLong_SHIFT) | (unsigned long)digits[1]) << PyLong_SHIFT) | (unsigned long)digits[0])))
                        } else if ((8 * sizeof(int) - 1 > 4 * PyLong_SHIFT)) {
                            return (int) ((((((((((int)digits[3]) << PyLong_SHIFT) | (int)digits[2]) << PyLong_SHIFT) | (int)digits[1]) << PyLong_SHIFT) | (int)digits[0])));
                        }
                    }
                    break;
            }
        }
#endif
        if ((sizeof(int) <= sizeof(long))) {
            __PYX_VERIFY_RETURN_INT_EXC(int, long, PyLong_AsLong(x))
#ifdef HAVE_LONG_LONG
        } else if ((sizeof(int) <= sizeof(PY_LONG_LONG))) {
            __PYX_VERIFY_RETURN_INT_EXC(int, PY_LONG_LONG, PyLong_AsLongLong(x))
#endif
        }
    }
    {
        int val;
        int ret = -1;
#if PY_VERSION_HEX >= 0x030d00A6 && !CYTHON_COMPILING_IN_LIMITED_API
        Py_ssize_t bytes_copied = PyLong_AsNativeBytes(
            x, &val, sizeof(val), Py_ASNATIVEBYTES_NATIVE_ENDIAN | (is_unsigned ? Py_ASNATIVEBYTES_UNSIGNED_BUFFER | Py_ASNATIVEBYTES_REJECT_NEGATIVE : 0));
        if (unlikely(bytes_copied == -1)) {
        } else if (unlikely(bytes_copied > (Py_ssize_t) sizeof(val))) {
            goto raise_overflow;
        } else {
            ret = 0;
        }
#elif PY_VERSION_HEX < 0x030d0000 && !(CYTHON_COMPILING_IN_PYPY || CYTHON_COMPILING_IN_LIMITED_API) || defined(_PyLong_AsByteArray)
        int one = 1; int is_little = (int)*(unsigned char *)&one;
        unsigned char *bytes = (unsigned char *)&val;
        ret = _PyLong_AsByteArray((PyLongObject *)x,
                                    bytes, sizeof(val),
                                    is_little, !is_unsigned);
#else
        PyObject *v;
        PyObject *stepval = NULL, *mask = NULL, *shift = NULL;
        int bits, remaining_bits, is_negative = 0;
        int chunk_size = (sizeof(long) < 8) ? 30 : 62;
        if (likely(PyLong_CheckExact(x))) {
            v = __Pyx_NewRef(x);
        } else {
            v = PyNumber_Long(x);
            if (unlikely(!v)) return (int) -1;
            assert(PyLong_CheckExact(v));
        }
        {
            int result = PyObject_RichCompareBool(v, Py_False, Py_LT);
            if (unlikely(result < 0)) {
                Py_DECREF(v);
                return (int) -1;
            }
            is_negative = result == 1;
        }
        if (is_unsigned && unlikely(is_negative)) {
            Py_DECREF(v);
            goto raise_neg_overflow;
        } else if (is_negative) {
            stepval = PyNumber_Invert(v);
            Py_DECREF(v);
            if (unlikely(!stepval))
                return (int) -1;
        } else {
            stepval = v;
        }
        v = NULL;
        val = (int) 0;
        mask = PyLong_FromLong((1L << chunk_size) - 1); if (unlikely(!mask)) goto done;
        shift = PyLong_FromLong(chunk_size); if (unlikely(!shift)) goto done;
        for (bits = 0; bits < (int) sizeof(int) * 8 - chunk_size; bits += chunk_size) {
            PyObject *tmp, *digit;
            long idigit;
            digit = PyNumber_And(stepval, mask);
            if (unlikely(!digit)) goto done;
            idigit = PyLong_AsLong(digit);
            Py_DECREF(digit);
            if (unlikely(idigit < 0)) goto done;
            val |= ((int) idigit) << bits;
            tmp = PyNumber_Rshift(stepval, shift);
            if (unlikely(!tmp)) goto done;
            Py_DECREF(stepval); stepval = tmp;
        }
        Py_DECREF(shift); shift = NULL;
        Py_DECREF(mask); mask = NULL;
        {
            long idigit = PyLong_AsLong(stepval);
            if (unlikely(idigit < 0)) goto done;
            remaining_bits = ((int) sizeof(int) * 8) - bits - (is_unsigned ? 0 : 1);
            if (unlikely(idigit >= (1L << remaining_bits)))
                goto raise_overflow;
            val |= ((int) idigit) << bits;
        }
        if (!is_unsigned) {
            if (unlikely(val & (((int) 1) << (sizeof(int) * 8 - 1))))
                goto raise_overflow;
            if (is_negative)
                val = ~val;
        }
        ret = 0;
    done:
        Py_XDECREF(shift);
        Py_XDECREF(mask);
        Py_XDECREF(stepval);
#endif
        if (unlikely(ret))
            return (int) -1;
        return val;
    }
raise_overflow:
    PyErr_SetString(PyExc_OverflowError,
        "value too large to convert to int");
    return (int) -1;
raise_neg_overflow:
    PyErr_SetString(PyExc_OverflowError,
        "can't convert negative value to int");
    return (int) -1;
}


#if CYTHON_COMPILING_IN_CPYTHON
static int __Pyx_InBases(PyTypeObject *a, PyTypeObject *b) {
    while (a) {
        a = __Pyx_PyType_GetSlot(a, tp_base, PyTypeObject*);
        if (a == b)
            return 1;
    }
    return b == &PyBaseObject_Type;
}
static CYTHON_INLINE int __Pyx_IsSubtype(PyTypeObject *a, PyTypeObject *b) {
    PyObject *mro;
    if (a == b) return 1;
    mro = a->tp_mro;
    if (likely(mro)) {
        Py_ssize_t i, n;
        n = PyTuple_GET_SIZE(mro);
        for (i = 0; i < n; i++) {
            if (PyTuple_GET_ITEM(mro, i) == (PyObject *)b)
                return 1;
        }
        return 0;
    }
    return __Pyx_InBases(a, b);
}
static CYTHON_INLINE int __Pyx_IsAnySubtype2(PyTypeObject *cls, PyTypeObject *a, PyTypeObject *b) {
    PyObject *mro;
    if (cls == a || cls == b) return 1;
    mro = cls->tp_mro;
    if (likely(mro)) {
        Py_ssize_t i, n;
        n = PyTuple_GET_SIZE(mro);
        for (i = 0; i < n; i++) {
            PyObject *base = PyTuple_GET_ITEM(mro, i);
            if (base == (PyObject *)a || base == (PyObject *)b)
                return 1;
        }
        return 0;
    }
    return __Pyx_InBases(cls, a) || __Pyx_InBases(cls, b);
}
#if PY_MAJOR_VERSION == 2
static int __Pyx_inner_PyErr_GivenExceptionMatches2(PyObject *err, PyObject* exc_type1, PyObject* exc_type2) {
    PyObject *exception, *value, *tb;
    int res;
    __Pyx_PyThreadState_declare
    __Pyx_PyThreadState_assign
    __Pyx_ErrFetch(&exception, &value, &tb);
    res = exc_type1 ? PyObject_IsSubclass(err, exc_type1) : 0;
    if (unlikely(res == -1)) {
        PyErr_WriteUnraisable(err);
        res = 0;
    }
    if (!res) {
        res = PyObject_IsSubclass(err, exc_type2);
        if (unlikely(res == -1)) {
            PyErr_WriteUnraisable(err);
            res = 0;
        }
    }
    __Pyx_ErrRestore(exception, value, tb);
    return res;
}
#else
static CYTHON_INLINE int __Pyx_inner_PyErr_GivenExceptionMatches2(PyObject *err, PyObject* exc_type1, PyObject *exc_type2) {
    if (exc_type1) {
        return __Pyx_IsAnySubtype2((PyTypeObject*)err, (PyTypeObject*)exc_type1, (PyTypeObject*)exc_type2);
    } else {
        return __Pyx_IsSubtype((PyTypeObject*)err, (PyTypeObject*)exc_type2);
    }
}
#endif
static int __Pyx_PyErr_GivenExceptionMatchesTuple(PyObject *exc_type, PyObject *tuple) {
    Py_ssize_t i, n;
    assert(PyExceptionClass_Check(exc_type));
    n = PyTuple_GET_SIZE(tuple);
#if PY_MAJOR_VERSION >= 3
    for (i=0; i<n; i++) {
        if (exc_type == PyTuple_GET_ITEM(tuple, i)) return 1;
    }
#endif
    for (i=0; i<n; i++) {
        PyObject *t = PyTuple_GET_ITEM(tuple, i);
        #if PY_MAJOR_VERSION < 3
        if (likely(exc_type == t)) return 1;
        #endif
        if (likely(PyExceptionClass_Check(t))) {
            if (__Pyx_inner_PyErr_GivenExceptionMatches2(exc_type, NULL, t)) return 1;
        } else {
        }
    }
    return 0;
}
static CYTHON_INLINE int __Pyx_PyErr_GivenExceptionMatches(PyObject *err, PyObject* exc_type) {
    if (likely(err == exc_type)) return 1;
    if (likely(PyExceptionClass_Check(err))) {
        if (likely(PyExceptionClass_Check(exc_type))) {
            return __Pyx_inner_PyErr_GivenExceptionMatches2(err, NULL, exc_type);
        } else if (likely(PyTuple_Check(exc_type))) {
            return __Pyx_PyErr_GivenExceptionMatchesTuple(err, exc_type);
        } else {
        }
    }
    return PyErr_GivenExceptionMatches(err, exc_type);
}
static CYTHON_INLINE int __Pyx_PyErr_GivenExceptionMatches2(PyObject *err, PyObject *exc_type1, PyObject *exc_type2) {
    assert(PyExceptionClass_Check(exc_type1));
    assert(PyExceptionClass_Check(exc_type2));
    if (likely(err == exc_type1 || err == exc_type2)) return 1;
    if (likely(PyExceptionClass_Check(err))) {
        return __Pyx_inner_PyErr_GivenExceptionMatches2(err, exc_type1, exc_type2);
    }
    return (PyErr_GivenExceptionMatches(err, exc_type1) || PyErr_GivenExceptionMatches(err, exc_type2));
}
#endif


static unsigned long __Pyx_get_runtime_version(void) {
#if __PYX_LIMITED_VERSION_HEX >= 0x030B00A4
    return Py_Version & ~0xFFUL;
#else
    const char* rt_version = Py_GetVersion();
    unsigned long version = 0;
    unsigned long factor = 0x01000000UL;
    unsigned int digit = 0;
    int i = 0;
    while (factor) {
        while ('0' <= rt_version[i] && rt_version[i] <= '9') {
            digit = digit * 10 + (unsigned int) (rt_version[i] - '0');
            ++i;
        }
        version += factor * digit;
        if (rt_version[i] != '.')
            break;
        digit = 0;
        factor >>= 8;
        ++i;
    }
    return version;
#endif
}
static int __Pyx_check_binary_version(unsigned long ct_version, unsigned long rt_version, int allow_newer) {
    const unsigned long MAJOR_MINOR = 0xFFFF0000UL;
    if ((rt_version & MAJOR_MINOR) == (ct_version & MAJOR_MINOR))
        return 0;
    if (likely(allow_newer && (rt_version & MAJOR_MINOR) > (ct_version & MAJOR_MINOR)))
        return 1;
    {
        char message[200];
        PyOS_snprintf(message, sizeof(message),
                      "compile time Python version %d.%d "
                      "of module '%.100s' "
                      "%s "
                      "runtime version %d.%d",
                       (int) (ct_version >> 24), (int) ((ct_version >> 16) & 0xFF),
                       __Pyx_MODULE_NAME,
                       (allow_newer) ? "was newer than" : "does not match",
                       (int) (rt_version >> 24), (int) ((rt_version >> 16) & 0xFF)
       );
        return PyErr_WarnEx(NULL, message, 1);
    }
}


#if PY_MAJOR_VERSION >= 3
static int __Pyx_InitString(__Pyx_StringTabEntry t, PyObject **str) {
    if (t.is_unicode | t.is_str) {
        if (t.intern) {
            *str = PyUnicode_InternFromString(t.s);
        } else if (t.encoding) {
            *str = PyUnicode_Decode(t.s, t.n - 1, t.encoding, NULL);
        } else {
            *str = PyUnicode_FromStringAndSize(t.s, t.n - 1);
        }
    } else {
        *str = PyBytes_FromStringAndSize(t.s, t.n - 1);
    }
    if (!*str)
        return -1;
    if (PyObject_Hash(*str) == -1)
        return -1;
    return 0;
}
#endif
static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        #if PY_MAJOR_VERSION >= 3
        __Pyx_InitString(*t, t->p);
        #else
        if (t->is_unicode) {
            *t->p = PyUnicode_DecodeUTF8(t->s, t->n - 1, NULL);
        } else if (t->intern) {
            *t->p = PyString_InternFromString(t->s);
        } else {
            *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        }
        if (!*t->p)
            return -1;
        if (PyObject_Hash(*t->p) == -1)
            return -1;
        #endif
        ++t;
    }
    return 0;
}

#include <string.h>
static CYTHON_INLINE Py_ssize_t __Pyx_ssize_strlen(const char *s) {
    size_t len = strlen(s);
    if (unlikely(len > (size_t) PY_SSIZE_T_MAX)) {
        PyErr_SetString(PyExc_OverflowError, "byte string is too long");
        return -1;
    }
    return (Py_ssize_t) len;
}
static CYTHON_INLINE PyObject* __Pyx_PyUnicode_FromString(const char* c_str) {
    Py_ssize_t len = __Pyx_ssize_strlen(c_str);
    if (unlikely(len < 0)) return NULL;
    return __Pyx_PyUnicode_FromStringAndSize(c_str, len);
}
static CYTHON_INLINE PyObject* __Pyx_PyByteArray_FromString(const char* c_str) {
    Py_ssize_t len = __Pyx_ssize_strlen(c_str);
    if (unlikely(len < 0)) return NULL;
    return PyByteArray_FromStringAndSize(c_str, len);
}
static CYTHON_INLINE const char* __Pyx_PyObject_AsString(PyObject* o) {
    Py_ssize_t ignore;
    return __Pyx_PyObject_AsStringAndSize(o, &ignore);
}
#if __PYX_DEFAULT_STRING_ENCODING_IS_ASCII || __PYX_DEFAULT_STRING_ENCODING_IS_DEFAULT
#if !CYTHON_PEP393_ENABLED
static const char* __Pyx_PyUnicode_AsStringAndSize(PyObject* o, Py_ssize_t *length) {
    char* defenc_c;
    PyObject* defenc = _PyUnicode_AsDefaultEncodedString(o, NULL);
    if (!defenc) return NULL;
    defenc_c = PyBytes_AS_STRING(defenc);
#if __PYX_DEFAULT_STRING_ENCODING_IS_ASCII
    {
        char* end = defenc_c + PyBytes_GET_SIZE(defenc);
        char* c;
        for (c = defenc_c; c < end; c++) {
            if ((unsigned char) (*c) >= 128) {
                PyUnicode_AsASCIIString(o);
                return NULL;
            }
        }
    }
#endif
    *length = PyBytes_GET_SIZE(defenc);
    return defenc_c;
}
#else
static CYTHON_INLINE const char* __Pyx_PyUnicode_AsStringAndSize(PyObject* o, Py_ssize_t *length) {
    if (unlikely(__Pyx_PyUnicode_READY(o) == -1)) return NULL;
#if __PYX_DEFAULT_STRING_ENCODING_IS_ASCII
    if (likely(PyUnicode_IS_ASCII(o))) {
        *length = PyUnicode_GET_LENGTH(o);
        return PyUnicode_AsUTF8(o);
    } else {
        PyUnicode_AsASCIIString(o);
        return NULL;
    }
#else
    return PyUnicode_AsUTF8AndSize(o, length);
#endif
}
#endif
#endif
static CYTHON_INLINE const char* __Pyx_PyObject_AsStringAndSize(PyObject* o, Py_ssize_t *length) {
#if __PYX_DEFAULT_STRING_ENCODING_IS_ASCII || __PYX_DEFAULT_STRING_ENCODING_IS_DEFAULT
    if (
#if PY_MAJOR_VERSION < 3 && __PYX_DEFAULT_STRING_ENCODING_IS_ASCII
            __Pyx_sys_getdefaultencoding_not_ascii &&
#endif
            PyUnicode_Check(o)) {
        return __Pyx_PyUnicode_AsStringAndSize(o, length);
    } else
#endif
#if (!CYTHON_COMPILING_IN_PYPY && !CYTHON_COMPILING_IN_LIMITED_API) || (defined(PyByteArray_AS_STRING) && defined(PyByteArray_GET_SIZE))
    if (PyByteArray_Check(o)) {
        *length = PyByteArray_GET_SIZE(o);
        return PyByteArray_AS_STRING(o);
    } else
#endif
    {
        char* result;
        int r = PyBytes_AsStringAndSize(o, &result, length);
        if (unlikely(r < 0)) {
            return NULL;
        } else {
            return result;
        }
    }
}
static CYTHON_INLINE int __Pyx_PyObject_IsTrue(PyObject* x) {
   int is_true = x == Py_True;
   if (is_true | (x == Py_False) | (x == Py_None)) return is_true;
   else return PyObject_IsTrue(x);
}
static CYTHON_INLINE int __Pyx_PyObject_IsTrueAndDecref(PyObject* x) {
    int retval;
    if (unlikely(!x)) return -1;
    retval = __Pyx_PyObject_IsTrue(x);
    Py_DECREF(x);
    return retval;
}
static PyObject* __Pyx_PyNumber_IntOrLongWrongResultType(PyObject* result, const char* type_name) {
    __Pyx_TypeName result_type_name = __Pyx_PyType_GetName(Py_TYPE(result));
#if PY_MAJOR_VERSION >= 3
    if (PyLong_Check(result)) {
        if (PyErr_WarnFormat(PyExc_DeprecationWarning, 1,
                "__int__ returned non-int (type " __Pyx_FMT_TYPENAME ").  "
                "The ability to return an instance of a strict subclass of int is deprecated, "
                "and may be removed in a future version of Python.",
                result_type_name)) {
            __Pyx_DECREF_TypeName(result_type_name);
            Py_DECREF(result);
            return NULL;
        }
        __Pyx_DECREF_TypeName(result_type_name);
        return result;
    }
#endif
    PyErr_Format(PyExc_TypeError,
                 "__%.4s__ returned non-%.4s (type " __Pyx_FMT_TYPENAME ")",
                 type_name, type_name, result_type_name);
    __Pyx_DECREF_TypeName(result_type_name);
    Py_DECREF(result);
    return NULL;
}
static CYTHON_INLINE PyObject* __Pyx_PyNumber_IntOrLong(PyObject* x) {
#if CYTHON_USE_TYPE_SLOTS
  PyNumberMethods *m;
#endif
  const char *name = NULL;
  PyObject *res = NULL;
#if PY_MAJOR_VERSION < 3
  if (likely(PyInt_Check(x) || PyLong_Check(x)))
#else
  if (likely(PyLong_Check(x)))
#endif
    return __Pyx_NewRef(x);
#if CYTHON_USE_TYPE_SLOTS
  m = Py_TYPE(x)->tp_as_number;
  #if PY_MAJOR_VERSION < 3
  if (m && m->nb_int) {
    name = "int";
    res = m->nb_int(x);
  }
  else if (m && m->nb_long) {
    name = "long";
    res = m->nb_long(x);
  }
  #else
  if (likely(m && m->nb_int)) {
    name = "int";
    res = m->nb_int(x);
  }
  #endif
#else
  if (!PyBytes_CheckExact(x) && !PyUnicode_CheckExact(x)) {
    res = PyNumber_Int(x);
  }
#endif
  if (likely(res)) {
#if PY_MAJOR_VERSION < 3
    if (unlikely(!PyInt_Check(res) && !PyLong_Check(res))) {
#else
    if (unlikely(!PyLong_CheckExact(res))) {
#endif
        return __Pyx_PyNumber_IntOrLongWrongResultType(res, name);
    }
  }
  else if (!PyErr_Occurred()) {
    PyErr_SetString(PyExc_TypeError,
                    "an integer is required");
  }
  return res;
}
static CYTHON_INLINE Py_ssize_t __Pyx_PyIndex_AsSsize_t(PyObject* b) {
  Py_ssize_t ival;
  PyObject *x;
#if PY_MAJOR_VERSION < 3
  if (likely(PyInt_CheckExact(b))) {
    if (sizeof(Py_ssize_t) >= sizeof(long))
        return PyInt_AS_LONG(b);
    else
        return PyInt_AsSsize_t(b);
  }
#endif
  if (likely(PyLong_CheckExact(b))) {
    #if CYTHON_USE_PYLONG_INTERNALS
    if (likely(__Pyx_PyLong_IsCompact(b))) {
        return __Pyx_PyLong_CompactValue(b);
    } else {
      const digit* digits = __Pyx_PyLong_Digits(b);
      const Py_ssize_t size = __Pyx_PyLong_SignedDigitCount(b);
      switch (size) {
         case 2:
           if (8 * sizeof(Py_ssize_t) > 2 * PyLong_SHIFT) {
             return (Py_ssize_t) (((((size_t)digits[1]) << PyLong_SHIFT) | (size_t)digits[0]));
           }
           break;
         case -2:
           if (8 * sizeof(Py_ssize_t) > 2 * PyLong_SHIFT) {
             return -(Py_ssize_t) (((((size_t)digits[1]) << PyLong_SHIFT) | (size_t)digits[0]));
           }
           break;
         case 3:
           if (8 * sizeof(Py_ssize_t) > 3 * PyLong_SHIFT) {
             return (Py_ssize_t) (((((((size_t)digits[2]) << PyLong_SHIFT) | (size_t)digits[1]) << PyLong_SHIFT) | (size_t)digits[0]));
           }
           break;
         case -3:
           if (8 * sizeof(Py_ssize_t) > 3 * PyLong_SHIFT) {
             return -(Py_ssize_t) (((((((size_t)digits[2]) << PyLong_SHIFT) | (size_t)digits[1]) << PyLong_SHIFT) | (size_t)digits[0]));
           }
           break;
         case 4:
           if (8 * sizeof(Py_ssize_t) > 4 * PyLong_SHIFT) {
             return (Py_ssize_t) (((((((((size_t)digits[3]) << PyLong_SHIFT) | (size_t)digits[2]) << PyLong_SHIFT) | (size_t)digits[1]) << PyLong_SHIFT) | (size_t)digits[0]));
           }
           break;
         case -4:
           if (8 * sizeof(Py_ssize_t) > 4 * PyLong_SHIFT) {
             return -(Py_ssize_t) (((((((((size_t)digits[3]) << PyLong_SHIFT) | (size_t)digits[2]) << PyLong_SHIFT) | (size_t)digits[1]) << PyLong_SHIFT) | (size_t)digits[0]));
           }
           break;
      }
    }
    #endif
    return PyLong_AsSsize_t(b);
  }
  x = PyNumber_Index(b);
  if (!x) return -1;
  ival = PyInt_AsSsize_t(x);
  Py_DECREF(x);
  return ival;
}
static CYTHON_INLINE Py_hash_t __Pyx_PyIndex_AsHash_t(PyObject* o) {
  if (sizeof(Py_hash_t) == sizeof(Py_ssize_t)) {
    return (Py_hash_t) __Pyx_PyIndex_AsSsize_t(o);
#if PY_MAJOR_VERSION < 3
  } else if (likely(PyInt_CheckExact(o))) {
    return PyInt_AS_LONG(o);
#endif
  } else {
    Py_ssize_t ival;
    PyObject *x;
    x = PyNumber_Index(o);
    if (!x) return -1;
    ival = PyInt_AsLong(x);
    Py_DECREF(x);
    return ival;
  }
}
static CYTHON_INLINE PyObject * __Pyx_PyBool_FromLong(long b) {
  return b ? __Pyx_NewRef(Py_True) : __Pyx_NewRef(Py_False);
}
static CYTHON_INLINE PyObject * __Pyx_PyInt_FromSize_t(size_t ival) {
    return PyInt_FromSize_t(ival);
}



#ifdef _MSC_VER
#pragma warning( pop )
#endif




#endif 
